/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/types","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/network","vs/base/common/cancellation","vs/platform/telemetry/common/telemetry","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/stream","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/request/common/request","vs/base/common/jsonFormatter","vs/base/common/extpath","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/iterator","fs","child_process","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/userDataSync/common/userDataSyncProfilesStorageService","vs/base/common/functional","vs/base/common/jsonEdit","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/userDataSync/electron-sandbox/userDataSyncProfilesStorageService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],re=function(Q){for(var e=[],D=0,r=Q.length;D<r;D++)e[D]=ne[Q[D]];return e};define(ne[51],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(T){return T?T.replace(/\$\((.*?)\)/g,(P,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=D;class r{constructor(P,E,b){this.id=P,this.definition=E,this.description=b,r._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return r._allCodicons}}e.Codicon=r,r._allCodicons=[],r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",r.add.definition),r.gistNew=new r("gist-new",r.add.definition),r.repoCreate=new r("repo-create",r.add.definition),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",r.circleFilled.definition),r.closeDirty=new r("close-dirty",r.circleFilled.definition),r.debugBreakpoint=new r("debug-breakpoint",r.circleFilled.definition),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",r.circleFilled.definition),r.debugHint=new r("debug-hint",r.circleFilled.definition),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circle=new r("circle",{fontCharacter:"\\eabc"}),r.circleOutline=new r("circle-outline",r.circle.definition),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",r.circle.definition),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eba4"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolCustomColor=new r("symbol-customcolor",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.circleSmallFilled=new r("circle-small-filled",{fontCharacter:"\\eb8a"}),r.debugStackframeDot=new r("debug-stackframe-dot",r.circleSmallFilled.definition),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLarge=new r("circle-large",{fontCharacter:"\\ebb5"}),r.circleLargeOutline=new r("circle-large-outline",r.circleLarge.definition),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.inspect=new r("inspect",{fontCharacter:"\\ebd1"}),r.layers=new r("layers",{fontCharacter:"\\ebd2"}),r.layersDot=new r("layers-dot",{fontCharacter:"\\ebd3"}),r.layersActive=new r("layers-active",{fontCharacter:"\\ebd4"}),r.compass=new r("compass",{fontCharacter:"\\ebd5"}),r.compassDot=new r("compass-dot",{fontCharacter:"\\ebd6"}),r.compassActive=new r("compass-active",{fontCharacter:"\\ebd7"}),r.azure=new r("azure",{fontCharacter:"\\ebd8"}),r.issueDraft=new r("issue-draft",{fontCharacter:"\\ebd9"}),r.gitPullRequestClosed=new r("git-pull-request-closed",{fontCharacter:"\\ebda"}),r.gitPullRequestDraft=new r("git-pull-request-draft",{fontCharacter:"\\ebdb"}),r.debugAll=new r("debug-all",{fontCharacter:"\\ebdc"}),r.debugCoverage=new r("debug-coverage",{fontCharacter:"\\ebdd"}),r.runErrors=new r("run-errors",{fontCharacter:"\\ebde"}),r.folderLibrary=new r("folder-library",{fontCharacter:"\\ebdf"}),r.debugContinueSmall=new r("debug-continue-small",{fontCharacter:"\\ebe0"}),r.beakerStop=new r("beaker-stop",{fontCharacter:"\\ebe1"}),r.graphLine=new r("graph-line",{fontCharacter:"\\ebe2"}),r.graphScatter=new r("graph-scatter",{fontCharacter:"\\ebe3"}),r.pieChart=new r("pie-chart",{fontCharacter:"\\ebe4"}),r.bracket=new r("bracket",r.json.definition),r.bracketDot=new r("bracket-dot",{fontCharacter:"\\ebe5"}),r.bracketError=new r("bracket-error",{fontCharacter:"\\ebe6"}),r.lockSmall=new r("lock-small",{fontCharacter:"\\ebe7"}),r.azureDevops=new r("azure-devops",{fontCharacter:"\\ebe8"}),r.verifiedFilled=new r("verified-filled",{fontCharacter:"\\ebe9"}),r.newLine=new r("newline",{fontCharacter:"\\ebea"}),r.layout=new r("layout",{fontCharacter:"\\ebeb"}),r.layoutActivitybarLeft=new r("layout-activitybar-left",{fontCharacter:"\\ebec"}),r.layoutActivitybarRight=new r("layout-activitybar-right",{fontCharacter:"\\ebed"}),r.layoutPanelLeft=new r("layout-panel-left",{fontCharacter:"\\ebee"}),r.layoutPanelCenter=new r("layout-panel-center",{fontCharacter:"\\ebef"}),r.layoutPanelJustify=new r("layout-panel-justify",{fontCharacter:"\\ebf0"}),r.layoutPanelRight=new r("layout-panel-right",{fontCharacter:"\\ebf1"}),r.layoutPanel=new r("layout-panel",{fontCharacter:"\\ebf2"}),r.layoutSidebarLeft=new r("layout-sidebar-left",{fontCharacter:"\\ebf3"}),r.layoutSidebarRight=new r("layout-sidebar-right",{fontCharacter:"\\ebf4"}),r.layoutStatusbar=new r("layout-statusbar",{fontCharacter:"\\ebf5"}),r.layoutMenubar=new r("layout-menubar",{fontCharacter:"\\ebf6"}),r.layoutCentered=new r("layout-centered",{fontCharacter:"\\ebf7"}),r.layoutSidebarRightOff=new r("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),r.layoutPanelOff=new r("layout-panel-off",{fontCharacter:"\\ec01"}),r.layoutSidebarLeftOff=new r("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),r.target=new r("target",{fontCharacter:"\\ebf8"}),r.indent=new r("indent",{fontCharacter:"\\ebf9"}),r.recordSmall=new r("record-small",{fontCharacter:"\\ebfa"}),r.errorSmall=new r("error-small",{fontCharacter:"\\ebfb"}),r.arrowCircleDown=new r("arrow-circle-down",{fontCharacter:"\\ebfc"}),r.arrowCircleLeft=new r("arrow-circle-left",{fontCharacter:"\\ebfd"}),r.arrowCircleRight=new r("arrow-circle-right",{fontCharacter:"\\ebfe"}),r.arrowCircleUp=new r("arrow-circle-up",{fontCharacter:"\\ebff"}),r.heartFilled=new r("heart-filled",{fontCharacter:"\\ec04"}),r.map=new r("map",{fontCharacter:"\\ec05"}),r.mapFilled=new r("map-filled",{fontCharacter:"\\ec06"}),r.circleSmall=new r("circle-small",{fontCharacter:"\\ec07"}),r.bellSlash=new r("bell-slash",{fontCharacter:"\\ec08"}),r.bellSlashDot=new r("bell-slash-dot",{fontCharacter:"\\ec09"}),r.commentUnresolved=new r("comment-unresolved",{fontCharacter:"\\ec0a"}),r.gitPullRequestGoToChanges=new r("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),r.gitPullRequestNewChanges=new r("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),r.searchFuzzy=new r("search-fuzzy",{fontCharacter:"\\ec0d"}),r.dialogError=new r("dialog-error",r.error.definition),r.dialogWarning=new r("dialog-warning",r.warning.definition),r.dialogInfo=new r("dialog-info",r.info.definition),r.dialogClose=new r("dialog-close",r.close.definition),r.treeItemExpanded=new r("tree-item-expanded",r.chevronDown.definition),r.treeFilterOnTypeOn=new r("tree-filter-on-type-on",r.listFilter.definition),r.treeFilterOnTypeOff=new r("tree-filter-on-type-off",r.listSelection.definition),r.treeFilterClear=new r("tree-filter-clear",r.close.definition),r.treeItemLoading=new r("tree-item-loading",r.loading.definition),r.menuSelection=new r("menu-selection",r.check.definition),r.menuSubmenu=new r("menu-submenu",r.chevronRight.definition),r.menuBarMore=new r("menubar-more",r.more.definition),r.scrollbarButtonLeft=new r("scrollbar-button-left",r.triangleLeft.definition),r.scrollbarButtonRight=new r("scrollbar-button-right",r.triangleRight.definition),r.scrollbarButtonUp=new r("scrollbar-button-up",r.triangleUp.definition),r.scrollbarButtonDown=new r("scrollbar-button-down",r.triangleDown.definition),r.toolBarMore=new r("toolbar-more",r.more.definition),r.quickInputBack=new r("quick-input-back",r.arrowLeft.definition);function R(T,P){const E=["codicon","codicon-"+T];return P&&E.push("codicon-modifier-"+P),E}e.getClassNamesArray=R;var L;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function E(w){if(w instanceof r)return["codicon","codicon-"+w.id];const p=P.exec(w.id);if(!p)return E(r.error);const[,v,h]=p,S=["codicon","codicon-"+v];return h&&S.push("codicon-modifier-"+h.substr(1)),S}T.asClassNameArray=E;function b(w){return E(w).join(" ")}T.asClassName=b;function I(w){return"."+E(w).join(".")}T.asCSSSelector=I})(L=e.CSSIcon||(e.CSSIcon={}))}),define(ne[62],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(T){return(P,E,b)=>{let I=null,w=null;if(typeof b.value=="function"?(I="value",w=b.value):typeof b.get=="function"&&(I="get",w=b.get),!w)throw new Error("not supported");b[I]=T(w,E)}}e.createDecorator=D;function r(T,P,E){let b=null,I=null;if(typeof E.value=="function"?(b="value",I=E.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(b="get",I=E.get),!I)throw new Error("not supported");const w=`$memoize$${P}`;E[b]=function(...p){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,p)}),this[w]}}e.memoize=r;function R(T,P,E){return D((b,I)=>{const w=`$debounce$${I}`,p=`$debounce$result$${I}`;return function(...v){this[p]||(this[p]=E?E():void 0),clearTimeout(this[w]),P&&(this[p]=P(this[p],...v),v=[this[p]]),this[w]=setTimeout(()=>{b.apply(this,v),this[p]=E?E():void 0},T)}})}e.debounce=R;function L(T,P,E){return D((b,I)=>{const w=`$throttle$timer$${I}`,p=`$throttle$result$${I}`,v=`$throttle$lastRun$${I}`,h=`$throttle$pending$${I}`;return function(...S){if(this[p]||(this[p]=E?E():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),P&&(this[p]=P(this[p],...S)),this[h])return;const C=this[v]+T;C<=Date.now()?(this[v]=Date.now(),b.apply(this,[this[p]]),this[p]=E?E():void 0):(this[h]=!0,this[w]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),b.apply(this,[this[p]]),this[p]=E?E():void 0},C-Date.now()))}})}e.throttle=L}),define(ne[9],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?a.isErrorNoTelemetry(i)?new a(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(o=>{o(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=D,e.errorHandler=new D;function r(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=r;function R(c){E(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=R;function L(c){E(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=L;function T(c){if(c instanceof Error){const{name:i,message:o}=c,t=c.stacktrace||c.stack;return{$isError:!0,name:i,message:o,stack:t,noTelemetry:a.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=T;const P="Canceled";function E(c){return c instanceof b?!0:c instanceof Error&&c.name===P&&c.message===P}e.isCancellationError=E;class b extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=b;function I(){const c=new Error(P);return c.name=c.message,c}e.canceled=I;function w(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=w;function p(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=p;function v(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function h(c){const i=new Error(`${c} has been disposed`);return i.name="DISPOSED",i}e.disposed=h;function S(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=S;class C extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=C;class m extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=m;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class a extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof a)return i;const o=new a;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=a;class d extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype);debugger}}e.BugIndicatingError=d}),define(ne[19],re([0,1,9]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function r(X,ie=0){return X[X.length-(1+ie)]}e.tail=r;function R(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}e.tail2=R;function L(X,ie,se=(ue,he)=>ue===he){if(X===ie)return!0;if(!X||!ie||X.length!==ie.length)return!1;for(let ue=0,he=X.length;ue<he;ue++)if(!se(X[ue],ie[ue]))return!1;return!0}e.equals=L;function T(X,ie){const se=X.length-1;ie<se&&(X[ie]=X[se]),X.pop()}e.removeFastWithoutKeepingOrder=T;function P(X,ie,se){return E(X.length,ue=>se(X[ue],ie))}e.binarySearch=P;function E(X,ie){let se=0,ue=X-1;for(;se<=ue;){const he=(se+ue)/2|0,ve=ie(he);if(ve<0)se=he+1;else if(ve>0)ue=he-1;else return he}return-(se+1)}e.binarySearch2=E;function b(X,ie){let se=0,ue=X.length;if(ue===0)return 0;for(;se<ue;){const he=Math.floor((se+ue)/2);ie(X[he])?ue=he:se=he+1}return se}e.findFirstInSorted=b;function I(X,ie,se){if(X=X|0,X>=ie.length)throw new TypeError("invalid index");const ue=ie[Math.floor(ie.length*Math.random())],he=[],ve=[],we=[];for(const Ee of ie){const Pe=se(Ee,ue);Pe<0?he.push(Ee):Pe>0?ve.push(Ee):we.push(Ee)}return X<he.length?I(X,he,se):X<he.length+we.length?we[0]:I(X-(he.length+we.length),ve,se)}e.quickSelect=I;function w(X,ie){const se=[];let ue;for(const he of X.slice(0).sort(ie))!ue||ie(ue[0],he)!==0?(ue=[he],se.push(ue)):ue.push(he);return se}e.groupBy=w;function p(X,ie,se){const ue=[];function he(Ee,Pe,Ue){if(Pe===0&&Ue.length===0)return;const We=ue[ue.length-1];We&&We.start+We.deleteCount===Ee?(We.deleteCount+=Pe,We.toInsert.push(...Ue)):ue.push({start:Ee,deleteCount:Pe,toInsert:Ue})}let ve=0,we=0;for(;;){if(ve===X.length){he(ve,0,ie.slice(we));break}if(we===ie.length){he(ve,X.length-ve,[]);break}const Ee=X[ve],Pe=ie[we],Ue=se(Ee,Pe);Ue===0?(ve+=1,we+=1):Ue<0?(he(ve,1,[]),ve+=1):Ue>0&&(he(ve,0,[Pe]),we+=1)}return ue}e.sortedDiff=p;function v(X,ie,se){const ue=p(X,ie,se),he=[],ve=[];for(const we of ue)he.push(...X.slice(we.start,we.start+we.deleteCount)),ve.push(...we.toInsert);return{removed:he,added:ve}}e.delta=v;function h(X,ie,se){if(se===0)return[];const ue=X.slice(0,se).sort(ie);return C(X,ie,ue,se,X.length),ue}e.top=h;function S(X,ie,se,ue,he){return se===0?Promise.resolve([]):new Promise((ve,we)=>{(async()=>{const Ee=X.length,Pe=X.slice(0,se).sort(ie);for(let Ue=se,We=Math.min(se+ue,Ee);Ue<Ee;Ue=We,We=Math.min(We+ue,Ee)){if(Ue>se&&await new Promise(Ve=>setTimeout(Ve)),he&&he.isCancellationRequested)throw new D.CancellationError;C(X,ie,Pe,Ue,We)}return Pe})().then(ve,we)})}e.topAsync=S;function C(X,ie,se,ue,he){for(const ve=se.length;ue<he;ue++){const we=X[ue];if(ie(we,se[ve-1])<0){se.pop();const Ee=b(se,Pe=>ie(we,Pe)<0);se.splice(Ee,0,we)}}}function m(X){return X.filter(ie=>!!ie)}e.coalesce=m;function g(X){let ie=0;for(let se=0;se<X.length;se++)X[se]&&(X[ie]=X[se],ie+=1);X.length=ie}e.coalesceInPlace=g;function a(X,ie,se){X.splice(se,0,X.splice(ie,1)[0])}e.move=a;function d(X){return!Array.isArray(X)||X.length===0}e.isFalsyOrEmpty=d;function c(X){return Array.isArray(X)&&X.length>0}e.isNonEmptyArray=c;function i(X,ie=se=>se){const se=new Set;return X.filter(ue=>{const he=ie(ue);return se.has(he)?!1:(se.add(he),!0)})}e.distinct=i;function o(X){const ie=new Set;return se=>{const ue=X(se);return ie.has(ue)?!1:(ie.add(ue),!0)}}e.uniqueFilter=o;function t(X,ie){const se=n(X,ie);if(se!==-1)return X[se]}e.findLast=t;function n(X,ie){for(let se=X.length-1;se>=0;se--){const ue=X[se];if(ie(ue))return se}return-1}e.lastIndex=n;function s(X,ie){return X.length>0?X[0]:ie}e.firstOrDefault=s;function u(X,ie){return X.length>0?X[X.length-1]:ie}e.lastOrDefault=u;function l(X,ie,se=(ue,he)=>ue===he){let ue=0;for(let he=0,ve=Math.min(X.length,ie.length);he<ve&&se(X[he],ie[he]);he++)ue++;return ue}e.commonPrefixLength=l;function f(X){return[].concat(...X)}e.flatten=f;function y(X,ie){let se=typeof ie=="number"?X:0;typeof ie=="number"?se=X:(se=0,ie=X);const ue=[];if(se<=ie)for(let he=se;he<ie;he++)ue.push(he);else for(let he=se;he>ie;he--)ue.push(he);return ue}e.range=y;function A(X,ie,se){return X.reduce((ue,he)=>(ue[ie(he)]=se?se(he):he,ue),Object.create(null))}e.index=A;function O(X,ie){return X.push(ie),()=>_(X,ie)}e.insert=O;function _(X,ie){const se=X.indexOf(ie);if(se>-1)return X.splice(se,1),ie}e.remove=_;function M(X,ie,se){const ue=X.slice(0,ie),he=X.slice(ie);return ue.concat(se,he)}e.arrayInsert=M;function k(X,ie){let se;if(typeof ie=="number"){let ue=ie;se=()=>{const he=Math.sin(ue++)*179426549;return he-Math.floor(he)}}else se=Math.random;for(let ue=X.length-1;ue>0;ue-=1){const he=Math.floor(se()*(ue+1)),ve=X[ue];X[ue]=X[he],X[he]=ve}}e.shuffle=k;function F(X,ie){const se=X.indexOf(ie);se>-1&&(X.splice(se,1),X.unshift(ie))}e.pushToStart=F;function $(X,ie){const se=X.indexOf(ie);se>-1&&(X.splice(se,1),X.push(ie))}e.pushToEnd=$;function x(X,ie){for(const se of ie)X.push(se)}e.pushMany=x;function J(X,ie){return Array.isArray(X)?X.map(ie):ie(X)}e.mapArrayOrNot=J;function H(X){return Array.isArray(X)?X:[X]}e.asArray=H;function G(X){return X[Math.floor(Math.random()*X.length)]}e.getRandomElement=G;function z(X,ie){for(const se of X){const ue=ie(se);if(ue!==void 0)return ue}}e.mapFind=z;function j(X,ie,se){const ue=te(X,ie),he=X.length,ve=se.length;X.length=he+ve;for(let we=he-1;we>=ue;we--)X[we+ve]=X[we];for(let we=0;we<ve;we++)X[we+ue]=se[we]}e.insertInto=j;function Y(X,ie,se,ue){const he=te(X,ie),ve=X.splice(he,se);return j(X,he,ue),ve}e.splice=Y;function te(X,ie){return ie<0?Math.max(ie+X.length,0):Math.min(ie,X.length)}var ce;(function(X){function ie(he){return he<0}X.isLessThan=ie;function se(he){return he>0}X.isGreaterThan=se;function ue(he){return he===0}X.isNeitherLessOrGreaterThan=ue,X.greaterThan=1,X.lessThan=-1,X.neitherLessOrGreaterThan=0})(ce=e.CompareResult||(e.CompareResult={}));function W(X,ie){return(se,ue)=>ie(X(se),X(ue))}e.compareBy=W;function V(...X){return(ie,se)=>{for(const ue of X){const he=ue(ie,se);if(!ce.isNeitherLessOrGreaterThan(he))return he}return ce.neitherLessOrGreaterThan}}e.tieBreakComparators=V;const U=(X,ie)=>X-ie;e.numberComparator=U;function N(X,ie){if(X.length===0)return;let se=X[0];for(let ue=1;ue<X.length;ue++){const he=X[ue];ie(he,se)>0&&(se=he)}return se}e.findMaxBy=N;function q(X,ie){if(X.length===0)return;let se=X[0];for(let ue=1;ue<X.length;ue++){const he=X[ue];ie(he,se)>=0&&(se=he)}return se}e.findLastMaxBy=q;function B(X,ie){return N(X,(se,ue)=>-ie(se,ue))}e.findMinBy=B;class Z{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let se=this.firstIdx;for(;se<this.items.length&&ie(this.items[se]);)se++;const ue=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,ue}takeFromEndWhile(ie){let se=this.lastIdx;for(;se>=0&&ie(this.items[se]);)se--;const ue=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,ue}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const se=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,se}}e.ArrayQueue=Z;class oe{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(se=>(ie(se),!0))}toArray(){const ie=[];return this.iterate(se=>(ie.push(se),!0)),ie}filter(ie){return new oe(se=>this.iterate(ue=>ie(ue)?se(ue):!0))}map(ie){return new oe(se=>this.iterate(ue=>se(ie(ue))))}some(ie){let se=!1;return this.iterate(ue=>(se=ie(ue),!se)),se}findFirst(ie){let se;return this.iterate(ue=>ie(ue)?(se=ue,!1):!0),se}findLast(ie){let se;return this.iterate(ue=>(ie(ue)&&(se=ue),!0)),se}findLastMaxBy(ie){let se,ue=!0;return this.iterate(he=>((ue||ce.isGreaterThan(ie(he,se)))&&(ue=!1,se=he),!0)),se}}e.CallbackIterable=oe,oe.empty=new oe(X=>{})}),define(ne[114],re([0,1,9]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function r(E,b){if(!E)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=r;function R(E,b="Unreachable"){throw new Error(b)}e.assertNever=R;function L(E){if(!E)throw new D.BugIndicatingError("Assertion Failed")}e.assert=L;function T(E){if(!E()){debugger;E(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function P(E,b){let I=0;for(;I<E.length-1;){const w=E[I],p=E[I+1];if(!b(w,p))return!1;I++}return!0}e.checkAdjacentItems=P}),define(ne[78],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(r){const R=this;let L=!1,T;return function(){return L||(L=!0,T=r.apply(R,arguments)),T}}e.once=D}),define(ne[52],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(r){function R(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}r.is=R;const L=Object.freeze([]);function T(){return L}r.empty=T;function*P(o){yield o}r.single=P;function E(o){return o||L}r.from=E;function b(o){return!o||o[Symbol.iterator]().next().done===!0}r.isEmpty=b;function I(o){return o[Symbol.iterator]().next().value}r.first=I;function w(o,t){for(const n of o)if(t(n))return!0;return!1}r.some=w;function p(o,t){for(const n of o)if(t(n))return n}r.find=p;function*v(o,t){for(const n of o)t(n)&&(yield n)}r.filter=v;function*h(o,t){let n=0;for(const s of o)yield t(s,n++)}r.map=h;function*S(...o){for(const t of o)for(const n of t)yield n}r.concat=S;function*C(o){for(const t of o)for(const n of t)yield n}r.concatNested=C;function m(o,t,n){let s=n;for(const u of o)s=t(s,u);return s}r.reduce=m;function g(o,t){let n=0;for(const s of o)t(s,n++)}r.forEach=g;function*a(o,t,n=o.length){for(t<0&&(t+=o.length),n<0?n+=o.length:n>o.length&&(n=o.length);t<n;t++)yield o[t]}r.slice=a;function d(o,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,o];const s=o[Symbol.iterator]();for(let u=0;u<t;u++){const l=s.next();if(l.done)return[n,r.empty()];n.push(l.value)}return[n,{[Symbol.iterator](){return s}}]}r.consume=d;function c(o){return d(o)[0]}r.collect=c;function i(o,t,n=(s,u)=>s===u){const s=o[Symbol.iterator](),u=t[Symbol.iterator]();for(;;){const l=s.next(),f=u.next();if(l.done!==f.done)return!1;if(l.done)return!0;if(!n(l.value,f.value))return!1}}r.equals=i})(D=e.Iterable||(e.Iterable={}))}),define(ne[35],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var r;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(r=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function T(i,o=!1){let t=0;const n=i.length;let s="",u=0,l=16,f=0;function y($){let x=0,J=0;for(;x<$;){const H=i.charCodeAt(t);if(H>=48&&H<=57)J=J*16+H-48;else if(H>=65&&H<=70)J=J*16+H-65+10;else if(H>=97&&H<=102)J=J*16+H-97+10;else break;t++,x++}return x<$&&(J=-1),J}function A($){t=$,s="",u=0,l=16,f=0}function O(){const $=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&b(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&b(i.charCodeAt(t)))for(t++;t<i.length&&b(i.charCodeAt(t));)t++;else return f=3,i.substring($,t);let x=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&b(i.charCodeAt(t))){for(t++;t<i.length&&b(i.charCodeAt(t));)t++;x=t}else f=3;return i.substring($,x)}function _(){let $="",x=t;for(;;){if(t>=n){$+=i.substring(x,t),f=2;break}const J=i.charCodeAt(t);if(J===34){$+=i.substring(x,t),t++;break}if(J===92){if($+=i.substring(x,t),t++,t>=n){f=2;break}switch(i.charCodeAt(t++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const G=y(4);G>=0?$+=String.fromCharCode(G):f=4;break}default:f=5}x=t;continue}if(J>=0&&J<=31)if(E(J)){$+=i.substring(x,t),f=2;break}else f=6;t++}return $}function M(){if(s="",f=0,u=t,t>=n)return u=n,l=17;let $=i.charCodeAt(t);if(P($)){do t++,s+=String.fromCharCode($),$=i.charCodeAt(t);while(P($));return l=15}if(E($))return t++,s+=String.fromCharCode($),$===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),l=14;switch($){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,s=_(),l=10;case 47:{const x=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!E(i.charCodeAt(t));)t++;return s=i.substring(x,t),l=12}if(i.charCodeAt(t+1)===42){t+=2;const J=n-1;let H=!1;for(;t<J;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,H=!0;break}t++}return H||(t++,f=1),s=i.substring(x,t),l=13}return s+=String.fromCharCode($),t++,l=16}case 45:if(s+=String.fromCharCode($),t++,t===n||!b(i.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=O(),l=11;default:for(;t<n&&k($);)t++,$=i.charCodeAt(t);if(u!==t){switch(s=i.substring(u,t),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode($),t++,l=16}}function k($){if(P($)||E($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let $;do $=M();while($>=12&&$<=15);return $}return{setPosition:A,getPosition:()=>t,scan:o?F:M,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>u,getTokenLength:()=>t-u,getTokenError:()=>f}}e.createScanner=T;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function E(i){return i===10||i===13||i===8232||i===8233}function b(i){return i>=48&&i<=57}var I;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(I||(I={}));function w(i,o){const t=[],n=new Object;let s;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function f(y,A,O,_){u.value=y,u.offset=A,u.length=O,u.type=_,u.colonOffset=void 0,s=u}try{a(i,{onObjectBegin:(y,A)=>{if(o<=y)throw n;s=void 0,l=o>y,t.push("")},onObjectProperty:(y,A,O)=>{if(o<A||(f(y,A,O,"property"),t[t.length-1]=y,o<=A+O))throw n},onObjectEnd:(y,A)=>{if(o<=y)throw n;s=void 0,t.pop()},onArrayBegin:(y,A)=>{if(o<=y)throw n;s=void 0,t.push(0)},onArrayEnd:(y,A)=>{if(o<=y)throw n;s=void 0,t.pop()},onLiteralValue:(y,A,O)=>{if(o<A||(f(y,A,O,c(y)),o<=A+O))throw n},onSeparator:(y,A,O)=>{if(o<=A)throw n;if(y===":"&&s&&s.type==="property")s.colonOffset=A,l=!1,s=void 0;else if(y===","){const _=t[t.length-1];typeof _=="number"?t[t.length-1]=_+1:(l=!0,t[t.length-1]=""),s=void 0}}})}catch(y){if(y!==n)throw y}return{path:t,previousNode:s,isAtPropertyKey:l,matches:y=>{let A=0;for(let O=0;A<y.length&&O<t.length;O++)if(y[A]===t[O]||y[A]==="*")A++;else if(y[A]!=="**")return!1;return A===y.length}}}e.getLocation=w;function p(i,o=[],t=L.DEFAULT){let n=null,s=[];const u=[];function l(y){Array.isArray(s)?s.push(y):n!==null&&(s[n]=y)}return a(i,{onObjectBegin:()=>{const y={};l(y),u.push(s),s=y,n=null},onObjectProperty:y=>{n=y},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const y=[];l(y),u.push(s),s=y,n=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:l,onError:(y,A,O)=>{o.push({error:y,offset:A,length:O})}},t),s[0]}e.parse=p;function v(i,o=[],t=L.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){n.type==="property"&&(n.length=y-n.offset,n=n.parent)}function u(y){return n.children.push(y),y}a(i,{onObjectBegin:y=>{n=u({type:"object",offset:y,length:-1,parent:n,children:[]})},onObjectProperty:(y,A,O)=>{n=u({type:"property",offset:A,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:y,offset:A,length:O,parent:n})},onObjectEnd:(y,A)=>{n.length=y+A-n.offset,n=n.parent,s(y+A)},onArrayBegin:(y,A)=>{n=u({type:"array",offset:y,length:-1,parent:n,children:[]})},onArrayEnd:(y,A)=>{n.length=y+A-n.offset,n=n.parent,s(y+A)},onLiteralValue:(y,A,O)=>{u({type:c(y),offset:A,length:O,parent:n,value:y}),s(A+O)},onSeparator:(y,A,O)=>{n.type==="property"&&(y===":"?n.colonOffset=A:y===","&&s(A))},onError:(y,A,O)=>{o.push({error:y,offset:A,length:O})}},t);const f=n.children[0];return f&&delete f.parent,f}e.parseTree=v;function h(i,o){if(!i)return;let t=i;for(const n of o)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const u of t.children)if(Array.isArray(u.children)&&u.children[0].value===n){t=u.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=h;function S(i){if(!i.parent||!i.parent.children)return[];const o=S(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;o.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&o.push(t)}return o}e.getNodePath=S;function C(i){switch(i.type){case"array":return i.children.map(C);case"object":{const o=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(o[t.children[0].value]=C(n))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=C;function m(i,o,t=!1){return o>=i.offset&&o<i.offset+i.length||t&&o===i.offset+i.length}e.contains=m;function g(i,o,t=!1){if(m(i,o,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=o;s++){const u=g(n[s],o,t);if(u)return u}return i}}e.findNodeAtOffset=g;function a(i,o,t=L.DEFAULT){const n=T(i,!1);function s(W){return W?()=>W(n.getTokenOffset(),n.getTokenLength()):()=>!0}function u(W){return W?V=>W(V,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=s(o.onObjectBegin),f=u(o.onObjectProperty),y=s(o.onObjectEnd),A=s(o.onArrayBegin),O=s(o.onArrayEnd),_=u(o.onLiteralValue),M=u(o.onSeparator),k=s(o.onComment),F=u(o.onError),$=t&&t.disallowComments,x=t&&t.allowTrailingComma;function J(){for(;;){const W=n.scan();switch(n.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:$||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(W){case 12:case 13:$?H(10):k();break;case 16:H(1);break;case 15:case 14:break;default:return W}}}function H(W,V=[],U=[]){if(F(W),V.length+U.length>0){let N=n.getToken();for(;N!==17;){if(V.indexOf(N)!==-1){J();break}else if(U.indexOf(N)!==-1)break;N=J()}}}function G(W){const V=n.getTokenValue();return W?_(V):f(V),J(),!0}function z(){switch(n.getToken()){case 11:{let W=0;try{W=JSON.parse(n.getTokenValue()),typeof W!="number"&&(H(2),W=0)}catch{H(2)}_(W);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return J(),!0}function j(){return n.getToken()!==10?(H(3,[],[2,5]),!1):(G(!1),n.getToken()===6?(M(":"),J(),ce()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function Y(){l(),J();let W=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(W||H(4,[],[]),M(","),J(),n.getToken()===2&&x)break}else W&&H(6,[],[]);j()||H(4,[],[2,5]),W=!0}return y(),n.getToken()!==2?H(7,[2],[]):J(),!0}function te(){A(),J();let W=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(W||H(4,[],[]),M(","),J(),n.getToken()===4&&x)break}else W&&H(6,[],[]);ce()||H(4,[],[4,5]),W=!0}return O(),n.getToken()!==4?H(8,[4],[]):J(),!0}function ce(){switch(n.getToken()){case 3:return te();case 1:return Y();case 10:return G(!0);default:return z()}}return J(),n.getToken()===17?t.allowEmptyContent?!0:(H(4,[],[]),!1):ce()?(n.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=a;function d(i,o){const t=T(i),n=[];let s,u=0,l;do switch(l=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:u!==l&&n.push(i.substring(u,l)),o!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,o)),u=t.getPosition();break}while(s!==17);return n.join("")}e.stripComments=d;function c(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(ne[46],re([0,1,35]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function r(b,I,w){let p,v,h,S,C;if(I){for(S=I.offset,C=S+I.length,h=S;h>0&&!E(b,h-1);)h--;let l=C;for(;l<b.length&&!E(b,l);)l++;v=b.substring(h,l),p=T(v,w)}else v=b,p=0,h=0,S=0,C=b.length;const m=P(w,b);let g=!1,a=0,d;w.insertSpaces?d=L(" ",w.tabSize||4):d="	";const c=(0,D.createScanner)(v,!1);let i=!1;function o(){return m+L(d,p+a)}function t(){let l=c.scan();for(g=!1;l===15||l===14;)g=g||l===14,l=c.scan();return i=l===16||c.getTokenError()!==0,l}const n=[];function s(l,f,y){!i&&f<C&&y>S&&b.substring(f,y)!==l&&n.push({offset:f,length:y-f,content:l})}let u=t();if(u!==17){const l=c.getTokenOffset()+h,f=L(d,p);s(f,h,l)}for(;u!==17;){let l=c.getTokenOffset()+c.getTokenLength()+h,f=t(),y="";for(;!g&&(f===12||f===13);){const O=c.getTokenOffset()+h;s(" ",l,O),l=c.getTokenOffset()+c.getTokenLength()+h,y=f===12?o():"",f=t()}if(f===2)u!==1&&(a--,y=o());else if(f===4)u!==3&&(a--,y=o());else{switch(u){case 3:case 1:a++,y=o();break;case 5:case 12:y=o();break;case 13:g?y=o():y=" ";break;case 6:y=" ";break;case 10:if(f===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?y=" ":f!==5&&f!==17&&(i=!0);break;case 16:i=!0;break}g&&(f===12||f===13)&&(y=o())}const A=c.getTokenOffset()+h;s(y,l,A),u=f}return n}e.format=r;function R(b,I){const w=JSON.stringify(b,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?w.replace(/\r\n|\r|\n/g,I.eol):w}e.toFormattedString=R;function L(b,I){let w="";for(let p=0;p<I;p++)w+=b;return w}function T(b,I){let w=0,p=0;const v=I.tabSize||4;for(;w<b.length;){const h=b.charAt(w);if(h===" ")p++;else if(h==="	")p+=v;else break;w++}return Math.floor(p/v)}function P(b,I){for(let w=0;w<I.length;w++){const p=I.charAt(w);if(p==="\r")return w+1<I.length&&I.charAt(w+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return b&&b.eol||`
`}e.getEOL=P;function E(b,I){return`\r
`.indexOf(b.charAt(I))!==-1}e.isEOL=E}),define(ne[79],re([0,1,35,46]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(b,I,w){return L(b,I,void 0,w)}e.removeProperty=R;function L(b,I,w,p,v){const h=I.slice(),S=[],C=(0,D.parseTree)(b,S);let m,g;for(;h.length>0&&(g=h.pop(),m=(0,D.findNodeAtLocation)(C,h),m===void 0&&w!==void 0);)typeof g=="string"?w={[g]:w}:w=[w];if(m)if(m.type==="object"&&typeof g=="string"&&Array.isArray(m.children)){const a=(0,D.findNodeAtLocation)(m,[g]);if(a!==void 0)if(w===void 0){if(!a.parent)throw new Error("Malformed AST");const d=m.children.indexOf(a.parent);let c,i=a.parent.offset+a.parent.length;if(d>0){const o=m.children[d-1];c=o.offset+o.length}else c=m.offset+1,m.children.length>1&&(i=m.children[1].offset);return T(b,{offset:c,length:i-c,content:""},p)}else return T(b,{offset:a.offset,length:a.length,content:JSON.stringify(w)},p);else{if(w===void 0)return[];const d=`${JSON.stringify(g)}: ${JSON.stringify(w)}`,c=v?v(m.children.map(o=>o.children[0].value)):m.children.length;let i;if(c>0){const o=m.children[c-1];i={offset:o.offset+o.length,length:0,content:","+d}}else m.children.length===0?i={offset:m.offset+1,length:0,content:d}:i={offset:m.offset+1,length:0,content:d+","};return T(b,i,p)}}else if(m.type==="array"&&typeof g=="number"&&Array.isArray(m.children))if(w!==void 0){const a=`${JSON.stringify(w)}`;let d;if(m.children.length===0||g===0)d={offset:m.offset+1,length:0,content:m.children.length===0?a:a+","};else{const c=g===-1||g>m.children.length?m.children.length:g,i=m.children[c-1];d={offset:i.offset+i.length,length:0,content:","+a}}return T(b,d,p)}else{const a=g,d=m.children[a];let c;if(m.children.length===1)c={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===a){const i=m.children[a-1],o=i.offset+i.length,t=m.offset+m.length;c={offset:o,length:t-2-o,content:""}}else c={offset:d.offset,length:m.children[a+1].offset-d.offset,content:""};return T(b,c,p)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${m.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return T(b,{offset:C?C.offset:0,length:C?C.length:0,content:JSON.stringify(w)},p)}}e.setProperty=L;function T(b,I,w){let p=P(b,I),v=I.offset,h=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;v>0&&!(0,r.isEOL)(p,v-1);)v--;for(;h<p.length&&!(0,r.isEOL)(p,h);)h++}const S=(0,r.format)(p,{offset:v,length:h-v},w);for(let m=S.length-1;m>=0;m--){const g=S[m];p=P(p,g),v=Math.min(v,g.offset),h=Math.max(h,g.offset+g.length),h+=g.content.length-g.length}const C=b.length-(p.length-h)-v;return[{offset:v,length:C,content:p.substring(v,h)}]}e.withFormatting=T;function P(b,I){return b.substring(0,I.offset)+I.content+b.substring(I.offset+I.length)}e.applyEdit=P;function E(b,I){const w=I.slice(0).sort((v,h)=>{const S=v.offset-h.offset;return S===0?v.length-h.length:S});let p=b.length;for(let v=w.length-1;v>=0;v--){const h=w[v];if(h.offset+h.length<=p)b=P(b,h);else throw new Error("Overlapping edit");p=h.offset}return b}e.applyEdits=E}),define(ne[115],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new D(()=>R(this.getValue()))}}e.Lazy=D}),define(ne[2],re([0,1,78,52]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let L=null;function T(s){L=s}if(e.setDisposableTracker=T,R){const s="__is_disposable_tracked__";T(new class{trackDisposable(u){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[s]||console.log(l)},3e3)}setParent(u,l){if(u&&u!==g.None)try{u[s]=!0}catch{}}markAsDisposed(u){if(u&&u!==g.None)try{u[s]=!0}catch{}}markAsSingleton(u){}})}function P(s){return L?.trackDisposable(s),s}function E(s){L?.markAsDisposed(s)}function b(s,u){L?.setParent(s,u)}function I(s,u){if(!!L)for(const l of s)L.setParent(l,u)}function w(s){return L?.markAsSingleton(s),s}e.markAsSingleton=w;function p(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=p;function v(s){if(r.Iterable.is(s)){const u=[];for(const l of s)if(l)try{l.dispose()}catch(f){u.push(f)}if(u.length===1)throw u[0];if(u.length>1)throw new AggregateError(u,"Encountered errors while disposing of store");return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=v;function h(s){for(const u of s)p(u)&&u.dispose();return[]}e.disposeIfDisposable=h;function S(...s){const u=C(()=>v(s));return I(s,u),u}e.combinedDisposable=S;function C(s){const u=P({dispose:(0,D.once)(()=>{E(u),s()})});return u}e.toDisposable=C;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{v(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return b(u,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new m,P(this),b(this._store,this)}dispose(){E(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){this._isDisposed||u===this._value||(this._value?.dispose(),u&&b(u,this),this._value=u)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const u=this._value;return this._value=void 0,u&&b(u,null),u}}e.MutableDisposable=a;class d{constructor(u){this._disposable=u,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=d;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(u){let l=u;return this.unset=()=>l=void 0,this.isset=()=>l!==void 0,this.dispose=()=>{l&&(l(),l=void 0,E(this))},this}}e.SafeDisposable=c;class i{constructor(){this.references=new Map}acquire(u,...l){let f=this.references.get(u);f||(f={counter:0,object:this.createReferencedObject(u,...l)},this.references.set(u,f));const{object:y}=f,A=(0,D.once)(()=>{--f.counter===0&&(this.destroyReferencedObject(u,f.object),this.references.delete(u))});return f.counter++,{object:y,dispose:A}}}e.ReferenceCollection=i;class o{constructor(u){this.referenceCollection=u}async acquire(u,...l){const f=this.referenceCollection.acquire(u,...l);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(y){throw f.dispose(),y}}}e.AsyncReferenceCollection=o;class t{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=t;function n(s){const u=new m;try{s(u)}finally{u.dispose()}}e.disposeOnReturn=n}),define(ne[116],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(L){this.element=L,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class r{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let L=this._first;for(;L!==D.Undefined;){const T=L.next;L.prev=D.Undefined,L.next=D.Undefined,L=T}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,T){const P=new D(L);if(this._first===D.Undefined)this._first=P,this._last=P;else if(T){const b=this._last;this._last=P,P.prev=b,b.next=P}else{const b=this._first;this._first=P,P.next=b,b.prev=P}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==D.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==D.Undefined&&L.next!==D.Undefined){const T=L.prev;T.next=L.next,L.next.prev=T}else L.prev===D.Undefined&&L.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):L.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):L.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==D.Undefined;)yield L.element,L=L.next}}e.LinkedList=r}),function(){function Q(R){const L=[];typeof R=="number"&&L.push("code/timeOrigin",R);function T(E){L.push(E,Date.now())}function P(){const E=[];for(let b=0;b<L.length;b+=2)E.push({name:L[b],startTime:L[b+1]});return E}return{mark:T,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const T of performance.getEntriesByType("mark"))L.push({name:T.name,startTime:Math.round(R+T.startTime)});return L}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=D(r))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var r in D)(typeof exports=="object"?exports:Q)[r]=D[r]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function D(r){if(e[r])return e[r].exports;var R=e[r]={i:r,l:!1,exports:{}};return Q[r].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=Q,D.c=e,D.d=function(r,R,L){D.o(r,R)||Object.defineProperty(r,R,{enumerable:!0,get:L})},D.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},D.t=function(r,R){if(1&R&&(r=D(r)),8&R||4&R&&typeof r=="object"&&r&&r.__esModule)return r;var L=Object.create(null);if(D.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:r}),2&R&&typeof r!="string")for(var T in r)D.d(L,T,function(P){return r[P]}.bind(null,T));return L},D.n=function(r){var R=r&&r.__esModule?function(){return r.default}:function(){return r};return D.d(R,"a",R),R},D.o=function(r,R){return Object.prototype.hasOwnProperty.call(r,R)},D.p="",D(D.s=0)}([function(Q,e,D){(function(r){var R;e=Q.exports=U,R=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],E=e.src=[],b=0,I=b++;E[I]="0|[1-9]\\d*";var w=b++;E[w]="[0-9]+";var p=b++;E[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=b++;E[v]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var h=b++;E[h]="("+E[w]+")\\.("+E[w]+")\\.("+E[w]+")";var S=b++;E[S]="(?:"+E[I]+"|"+E[p]+")";var C=b++;E[C]="(?:"+E[w]+"|"+E[p]+")";var m=b++;E[m]="(?:-("+E[S]+"(?:\\."+E[S]+")*))";var g=b++;E[g]="(?:-?("+E[C]+"(?:\\."+E[C]+")*))";var a=b++;E[a]="[0-9A-Za-z-]+";var d=b++;E[d]="(?:\\+("+E[a]+"(?:\\."+E[a]+")*))";var c=b++,i="v?"+E[v]+E[m]+"?"+E[d]+"?";E[c]="^"+i+"$";var o="[v=\\s]*"+E[h]+E[g]+"?"+E[d]+"?",t=b++;E[t]="^"+o+"$";var n=b++;E[n]="((?:<|>)?=?)";var s=b++;E[s]=E[w]+"|x|X|\\*";var u=b++;E[u]=E[I]+"|x|X|\\*";var l=b++;E[l]="[v=\\s]*("+E[u]+")(?:\\.("+E[u]+")(?:\\.("+E[u]+")(?:"+E[m]+")?"+E[d]+"?)?)?";var f=b++;E[f]="[v=\\s]*("+E[s]+")(?:\\.("+E[s]+")(?:\\.("+E[s]+")(?:"+E[g]+")?"+E[d]+"?)?)?";var y=b++;E[y]="^"+E[n]+"\\s*"+E[l]+"$";var A=b++;E[A]="^"+E[n]+"\\s*"+E[f]+"$";var O=b++;E[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=b++;E[_]="(?:~>?)";var M=b++;E[M]="(\\s*)"+E[_]+"\\s+",P[M]=new RegExp(E[M],"g");var k=b++;E[k]="^"+E[_]+E[l]+"$";var F=b++;E[F]="^"+E[_]+E[f]+"$";var $=b++;E[$]="(?:\\^)";var x=b++;E[x]="(\\s*)"+E[$]+"\\s+",P[x]=new RegExp(E[x],"g");var J=b++;E[J]="^"+E[$]+E[l]+"$";var H=b++;E[H]="^"+E[$]+E[f]+"$";var G=b++;E[G]="^"+E[n]+"\\s*("+o+")$|^$";var z=b++;E[z]="^"+E[n]+"\\s*("+i+")$|^$";var j=b++;E[j]="(\\s*)"+E[n]+"\\s*("+o+"|"+E[l]+")",P[j]=new RegExp(E[j],"g");var Y=b++;E[Y]="^\\s*("+E[l]+")\\s+-\\s+("+E[l]+")\\s*$";var te=b++;E[te]="^\\s*("+E[f]+")\\s+-\\s+("+E[f]+")\\s*$";var ce=b++;E[ce]="(<|>)?=?\\s*\\*";for(var W=0;W<35;W++)R(W,E[W]),P[W]||(P[W]=new RegExp(E[W]));function V(ae,de){if(ae instanceof U)return ae;if(typeof ae!="string"||ae.length>L||!(de?P[t]:P[c]).test(ae))return null;try{return new U(ae,de)}catch{return null}}function U(ae,de){if(ae instanceof U){if(ae.loose===de)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof U))return new U(ae,de);R("SemVer",ae,de),this.loose=de;var fe=ae.trim().match(de?P[t]:P[c]);if(!fe)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Ie=+Ce;if(Ie>=0&&Ie<T)return Ie}return Ce}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=V,e.valid=function(ae,de){var fe=V(ae,de);return fe?fe.version:null},e.clean=function(ae,de){var fe=V(ae.trim().replace(/^[=v]+/,""),de);return fe?fe.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(ae){return R("SemVer.compare",this.version,this.loose,ae),ae instanceof U||(ae=new U(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},U.prototype.compareMain=function(ae){return ae instanceof U||(ae=new U(ae,this.loose)),q(this.major,ae.major)||q(this.minor,ae.minor)||q(this.patch,ae.patch)},U.prototype.comparePre=function(ae){if(ae instanceof U||(ae=new U(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var de=0;do{var fe=this.prerelease[de],Ce=ae.prerelease[de];if(R("prerelease compare",de,fe,Ce),fe===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(fe===void 0)return-1;if(fe!==Ce)return q(fe,Ce)}while(++de)},U.prototype.inc=function(ae,de){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,de,fe,Ce){typeof fe=="string"&&(Ce=fe,fe=void 0);try{return new U(ae,fe).inc(de,Ce).version}catch{return null}},e.diff=function(ae,de){if(X(ae,de))return null;var fe=V(ae),Ce=V(de);if(fe.prerelease.length||Ce.prerelease.length){for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Ce[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Ce[Ie])return Ie},e.compareIdentifiers=q;var N=/^[0-9]+$/;function q(ae,de){var fe=N.test(ae),Ce=N.test(de);return fe&&Ce&&(ae=+ae,de=+de),fe&&!Ce?-1:Ce&&!fe?1:ae<de?-1:ae>de?1:0}function B(ae,de,fe){return new U(ae,fe).compare(new U(de,fe))}function Z(ae,de,fe){return B(ae,de,fe)>0}function oe(ae,de,fe){return B(ae,de,fe)<0}function X(ae,de,fe){return B(ae,de,fe)===0}function ie(ae,de,fe){return B(ae,de,fe)!==0}function se(ae,de,fe){return B(ae,de,fe)>=0}function ue(ae,de,fe){return B(ae,de,fe)<=0}function he(ae,de,fe,Ce){var Ie;switch(de){case"===":typeof ae=="object"&&(ae=ae.version),typeof fe=="object"&&(fe=fe.version),Ie=ae===fe;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof fe=="object"&&(fe=fe.version),Ie=ae!==fe;break;case"":case"=":case"==":Ie=X(ae,fe,Ce);break;case"!=":Ie=ie(ae,fe,Ce);break;case">":Ie=Z(ae,fe,Ce);break;case">=":Ie=se(ae,fe,Ce);break;case"<":Ie=oe(ae,fe,Ce);break;case"<=":Ie=ue(ae,fe,Ce);break;default:throw new TypeError("Invalid operator: "+de)}return Ie}function ve(ae,de){if(ae instanceof ve){if(ae.loose===de)return ae;ae=ae.value}if(!(this instanceof ve))return new ve(ae,de);R("comparator",ae,de),this.loose=de,this.parse(ae),this.semver===we?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(ae,de){return q(de,ae)},e.major=function(ae,de){return new U(ae,de).major},e.minor=function(ae,de){return new U(ae,de).minor},e.patch=function(ae,de){return new U(ae,de).patch},e.compare=B,e.compareLoose=function(ae,de){return B(ae,de,!0)},e.rcompare=function(ae,de,fe){return B(de,ae,fe)},e.sort=function(ae,de){return ae.sort(function(fe,Ce){return e.compare(fe,Ce,de)})},e.rsort=function(ae,de){return ae.sort(function(fe,Ce){return e.rcompare(fe,Ce,de)})},e.gt=Z,e.lt=oe,e.eq=X,e.neq=ie,e.gte=se,e.lte=ue,e.cmp=he,e.Comparator=ve;var we={};function Ee(ae,de){if(ae instanceof Ee)return ae.loose===de?ae:new Ee(ae.raw,de);if(ae instanceof ve)return new Ee(ae.value,de);if(!(this instanceof Ee))return new Ee(ae,de);if(this.loose=de,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Pe(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function Ue(ae,de,fe,Ce,Ie,Me,Re,$e,Ae,Fe,_e,ke,ee){return((de=Pe(fe)?"":Pe(Ce)?">="+fe+".0.0":Pe(Ie)?">="+fe+"."+Ce+".0":">="+de)+" "+($e=Pe(Ae)?"":Pe(Fe)?"<"+(+Ae+1)+".0.0":Pe(_e)?"<"+Ae+"."+(+Fe+1)+".0":ke?"<="+Ae+"."+Fe+"."+_e+"-"+ke:"<="+$e)).trim()}function We(ae,de){for(var fe=0;fe<ae.length;fe++)if(!ae[fe].test(de))return!1;if(de.prerelease.length){for(fe=0;fe<ae.length;fe++)if(R(ae[fe].semver),ae[fe].semver!==we&&ae[fe].semver.prerelease.length>0){var Ce=ae[fe].semver;if(Ce.major===de.major&&Ce.minor===de.minor&&Ce.patch===de.patch)return!0}return!1}return!0}function Ve(ae,de,fe){try{de=new Ee(de,fe)}catch{return!1}return de.test(ae)}function ze(ae,de,fe,Ce){var Ie,Me,Re,$e,Ae;switch(ae=new U(ae,Ce),de=new Ee(de,Ce),fe){case">":Ie=Z,Me=ue,Re=oe,$e=">",Ae=">=";break;case"<":Ie=oe,Me=se,Re=Z,$e="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ve(ae,de,Ce))return!1;for(var Fe=0;Fe<de.set.length;++Fe){var _e=de.set[Fe],ke=null,ee=null;if(_e.forEach(function(le){le.semver===we&&(le=new ve(">=0.0.0")),ke=ke||le,ee=ee||le,Ie(le.semver,ke.semver,Ce)?ke=le:Re(le.semver,ee.semver,Ce)&&(ee=le)}),ke.operator===$e||ke.operator===Ae||(!ee.operator||ee.operator===$e)&&Me(ae,ee.semver)||ee.operator===Ae&&Re(ae,ee.semver))return!1}return!0}ve.prototype.parse=function(ae){var de=this.loose?P[G]:P[z],fe=ae.match(de);if(!fe)throw new TypeError("Invalid comparator: "+ae);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new U(fe[2],this.loose):this.semver=we},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(ae){return R("Comparator.test",ae,this.loose),this.semver===we||(typeof ae=="string"&&(ae=new U(ae,this.loose)),he(ae,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(ae,de){if(!(ae instanceof ve))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Ee(ae.value,de),Ve(this.value,fe,de);if(ae.operator==="")return fe=new Ee(this.value,de),Ve(ae.semver,fe,de);var Ce=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Me=this.semver.version===ae.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),$e=he(this.semver,"<",ae.semver,de)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ae=he(this.semver,">",ae.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Ce||Ie||Me&&Re||$e||Ae},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ae){var de=this.loose;ae=ae.trim(),R("range",ae,de);var fe=de?P[te]:P[Y];ae=ae.replace(fe,Ue),R("hyphen replace",ae),ae=ae.replace(P[j],"$1$2$3"),R("comparator trim",ae,P[j]),ae=(ae=(ae=ae.replace(P[M],"$1~")).replace(P[x],"$1^")).split(/\s+/).join(" ");var Ce=de?P[G]:P[z],Ie=ae.split(" ").map(function(Me){return function(Re,$e){return R("comp",Re),Re=function(Ae,Fe){return Ae.trim().split(/\s+/).map(function(_e){return function(ke,ee){R("caret",ke,ee);var le=ee?P[H]:P[J];return ke.replace(le,function(me,ge,Se,be,De){var Te;return R("caret",ke,me,ge,Se,be,De),Pe(ge)?Te="":Pe(Se)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Pe(be)?Te=ge==="0"?">="+ge+"."+Se+".0 <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+".0 <"+(+ge+1)+".0.0":De?(R("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Te=ge==="0"?Se==="0"?">="+ge+"."+Se+"."+be+De+" <"+ge+"."+Se+"."+(+be+1):">="+ge+"."+Se+"."+be+De+" <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+"."+be+De+" <"+(+ge+1)+".0.0"):(R("no pr"),Te=ge==="0"?Se==="0"?">="+ge+"."+Se+"."+be+" <"+ge+"."+Se+"."+(+be+1):">="+ge+"."+Se+"."+be+" <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+"."+be+" <"+(+ge+1)+".0.0"),R("caret return",Te),Te})}(_e,Fe)}).join(" ")}(Re,$e),R("caret",Re),Re=function(Ae,Fe){return Ae.trim().split(/\s+/).map(function(_e){return function(ke,ee){var le=ee?P[F]:P[k];return ke.replace(le,function(me,ge,Se,be,De){var Te;return R("tilde",ke,me,ge,Se,be,De),Pe(ge)?Te="":Pe(Se)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Pe(be)?Te=">="+ge+"."+Se+".0 <"+ge+"."+(+Se+1)+".0":De?(R("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Te=">="+ge+"."+Se+"."+be+De+" <"+ge+"."+(+Se+1)+".0"):Te=">="+ge+"."+Se+"."+be+" <"+ge+"."+(+Se+1)+".0",R("tilde return",Te),Te})}(_e,Fe)}).join(" ")}(Re,$e),R("tildes",Re),Re=function(Ae,Fe){return R("replaceXRanges",Ae,Fe),Ae.split(/\s+/).map(function(_e){return function(ke,ee){ke=ke.trim();var le=ee?P[A]:P[y];return ke.replace(le,function(me,ge,Se,be,De,Te){R("xRange",ke,me,ge,Se,be,De,Te);var qe=Pe(Se),Le=qe||Pe(be),Ne=Le||Pe(De);return ge==="="&&Ne&&(ge=""),qe?me=ge===">"||ge==="<"?"<0.0.0":"*":ge&&Ne?(Le&&(be=0),Ne&&(De=0),ge===">"?(ge=">=",Le?(Se=+Se+1,be=0,De=0):Ne&&(be=+be+1,De=0)):ge==="<="&&(ge="<",Le?Se=+Se+1:be=+be+1),me=ge+Se+"."+be+"."+De):Le?me=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ne&&(me=">="+Se+"."+be+".0 <"+Se+"."+(+be+1)+".0"),R("xRange return",me),me})}(_e,Fe)}).join(" ")}(Re,$e),R("xrange",Re),Re=function(Ae,Fe){return R("replaceStars",Ae,Fe),Ae.trim().replace(P[ce],"")}(Re,$e),R("stars",Re),Re}(Me,de)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Me){return!!Me.match(Ce)})),Ie=Ie.map(function(Me){return new ve(Me,de)})},Ee.prototype.intersects=function(ae,de){if(!(ae instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Ce){return ae.set.some(function(Ie){return Ie.every(function(Me){return Ce.intersects(Me,de)})})})})},e.toComparators=function(ae,de){return new Ee(ae,de).set.map(function(fe){return fe.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new U(ae,this.loose));for(var de=0;de<this.set.length;de++)if(We(this.set[de],ae))return!0;return!1},e.satisfies=Ve,e.maxSatisfying=function(ae,de,fe){var Ce=null,Ie=null;try{var Me=new Ee(de,fe)}catch{return null}return ae.forEach(function(Re){Me.test(Re)&&(Ce&&Ie.compare(Re)!==-1||(Ie=new U(Ce=Re,fe)))}),Ce},e.minSatisfying=function(ae,de,fe){var Ce=null,Ie=null;try{var Me=new Ee(de,fe)}catch{return null}return ae.forEach(function(Re){Me.test(Re)&&(Ce&&Ie.compare(Re)!==1||(Ie=new U(Ce=Re,fe)))}),Ce},e.validRange=function(ae,de){try{return new Ee(ae,de).range||"*"}catch{return null}},e.ltr=function(ae,de,fe){return ze(ae,de,"<",fe)},e.gtr=function(ae,de,fe){return ze(ae,de,">",fe)},e.outside=ze,e.prerelease=function(ae,de){var fe=V(ae,de);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(ae,de,fe){return ae=new Ee(ae,fe),de=new Ee(de,fe),ae.intersects(de)},e.coerce=function(ae){if(ae instanceof U)return ae;if(typeof ae!="string")return null;var de=ae.match(P[O]);return de==null?null:V((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,D(1))},function(Q,e){var D,r,R=Q.exports={};function L(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function P(C){if(D===setTimeout)return setTimeout(C,0);if((D===L||!D)&&setTimeout)return D=setTimeout,setTimeout(C,0);try{return D(C,0)}catch{try{return D.call(null,C,0)}catch{return D.call(this,C,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:L}catch{D=L}try{r=typeof clearTimeout=="function"?clearTimeout:T}catch{r=T}})();var E,b=[],I=!1,w=-1;function p(){I&&E&&(I=!1,E.length?b=E.concat(b):w=-1,b.length&&v())}function v(){if(!I){var C=P(p);I=!0;for(var m=b.length;m;){for(E=b,b=[];++w<m;)E&&E[w].run();w=-1,m=b.length}E=null,I=!1,function(g){if(r===clearTimeout)return clearTimeout(g);if((r===T||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(g);try{r(g)}catch{try{return r.call(null,g)}catch{return r.call(this,g)}}}(C)}}function h(C,m){this.fun=C,this.array=m}function S(){}R.nextTick=function(C){var m=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)m[g-1]=arguments[g];b.push(new h(C,m)),b.length!==1||I||P(v)},h.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=S,R.addListener=S,R.once=S,R.off=S,R.removeListener=S,R.removeAllListeners=S,R.emit=S,R.prependListener=S,R.prependOnceListener=S,R.listeners=function(C){return[]},R.binding=function(C){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(C){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ne[117],re([0,1]),function(Q,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class r{constructor(P,E,b){this.level=P,this.key=E,this.value=b,this.forward=[]}}const R=void 0;class L{constructor(P,E=2**16){this.comparator=P,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(E)|0),this._header=new r(this._maxLevel,R,R)}get size(){return this._size}clear(){this._header=new r(this._maxLevel,R,R)}has(P){return Boolean(L._search(this,P,this.comparator))}get(P){return L._search(this,P,this.comparator)?.value}set(P,E){return L._insert(this,P,E,this.comparator)&&(this._size+=1),this}delete(P){const E=L._delete(this,P,this.comparator);return E&&(this._size-=1),E}forEach(P,E){let b=this._header.forward[0];for(;b;)P.call(E,b.value,b.key,this),b=b.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",E=this._header.forward[0];for(;E;)P+=`node(${E.key}, ${E.value}, lvl:${E.level})`,E=E.forward[0];return P}static _search(P,E,b){let I=P._header;for(let w=P._level-1;w>=0;w--)for(;I.forward[w]&&b(I.forward[w].key,E)<0;)I=I.forward[w];if(I=I.forward[0],I&&b(I.key,E)===0)return I}static _insert(P,E,b,I){const w=[];let p=P._header;for(let v=P._level-1;v>=0;v--){for(;p.forward[v]&&I(p.forward[v].key,E)<0;)p=p.forward[v];w[v]=p}if(p=p.forward[0],p&&I(p.key,E)===0)return p.value=b,!1;{const v=L._randomLevel(P);if(v>P._level){for(let h=P._level;h<v;h++)w[h]=P._header;P._level=v}p=new r(v,E,b);for(let h=0;h<v;h++)p.forward[h]=w[h].forward[h],w[h].forward[h]=p;return!0}}static _randomLevel(P,E=.5){let b=1;for(;Math.random()<E&&b<P._maxLevel;)b+=1;return b}static _delete(P,E,b){const I=[];let w=P._header;for(let p=P._level-1;p>=0;p--){for(;w.forward[p]&&b(w.forward[p].key,E)<0;)w=w.forward[p];I[p]=w}if(w=w.forward[0],!w||b(w.key,E)!==0)return!1;for(let p=0;p<P._level&&I[p].forward[p]===w;p++)I[p].forward[p]=w.forward[p];for(;P._level>0&&P._header.forward[P._level-1]===R;)P._level-=1;return!0}}e.SkipList=L}),define(ne[42],re([0,1,9,2]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(d){const c=d;return c?typeof c.read=="function":!1}e.isReadable=R;function L(d){const c=d;return c?[c.on,c.pause,c.resume,c.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=L;function T(d){const c=d;return c?L(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=T;function P(d,c){return new E(d,c)}e.newWriteableStream=P;class E{constructor(c,i){this.reducer=c,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c<"u"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(i=>i(c))}emitError(c){this.listeners.error.length===0?(0,D.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(i=>i(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,i){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(c,i){if(this.state.destroyed)return;let o;switch(c){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const t=o.indexOf(i);t>=0&&o.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(d,c){const i=[];let o;for(;(o=d.read())!==null;)i.push(o);return c(i)}e.consumeReadable=b;function I(d,c,i){const o=[];let t;for(;(t=d.read())!==null&&o.length<i;)o.push(t);return t===null&&o.length>0?c(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return d.read()}}}e.peekReadable=I;function w(d,c){return new Promise((i,o)=>{const t=[];p(d,{onData:n=>{c&&t.push(n)},onError:n=>{c?o(n):i(void 0)},onEnd:()=>{i(c?c(t):void 0)}})})}e.consumeStream=w;function p(d,c){let i=!1;return d.on("error",o=>{i||c.onError(o)}),d.on("end",()=>{i||c.onEnd()}),d.on("data",o=>{i||c.onData(o)}),(0,r.toDisposable)(()=>i=!0)}e.listenStream=p;function v(d,c){return new Promise((i,o)=>{const t=new r.DisposableStore,n=[],s=f=>{if(n.push(f),n.length>c)return t.dispose(),d.pause(),i({stream:d,buffer:n,ended:!1})},u=f=>o(f),l=()=>i({stream:d,buffer:n,ended:!0});t.add((0,r.toDisposable)(()=>d.removeListener("error",u))),d.on("error",u),t.add((0,r.toDisposable)(()=>d.removeListener("end",l))),d.on("end",l),t.add((0,r.toDisposable)(()=>d.removeListener("data",s))),d.on("data",s)})}e.peekStream=v;function h(d,c){const i=P(c);return i.end(d),i}e.toStream=h;function S(){const d=P(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=S;function C(d){let c=!1;return{read:()=>c?null:(c=!0,d)}}e.toReadable=C;function m(d,c,i){const o=P(i);return p(d,{onData:t=>o.write(c.data(t)),onError:t=>o.error(c.error?c.error(t):t),onEnd:()=>o.end()}),o}e.transform=m;function g(d,c,i){let o=!1;return{read:()=>{const t=c.read();return o?t:(o=!0,t!==null?i([d,t]):d)}}}e.prefixedReadable=g;function a(d,c,i){let o=!1;const t=P(i);return p(c,{onData:n=>o?t.write(n):(o=!0,t.write(i([d,n]))),onError:n=>t.error(n),onEnd:()=>{o||(o=!0,t.write(d)),t.end()}}),t}e.prefixedStream=a}),define(ne[16],re([0,1,42]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const r=typeof Buffer<"u";let R,L;class T{static alloc(f){return r?new T(Buffer.allocUnsafe(f)):new T(new Uint8Array(f))}static wrap(f){return r&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new T(f)}static fromString(f,y){return!(y?.dontUseNodeBuffer||!1)&&r?new T(Buffer.from(f)):(R||(R=new TextEncoder),new T(R.encode(f)))}static fromByteArray(f){const y=T.alloc(f.length);for(let A=0,O=f.length;A<O;A++)y.buffer[A]=f[A];return y}static concat(f,y){if(typeof y>"u"){y=0;for(let _=0,M=f.length;_<M;_++)y+=f[_].byteLength}const A=T.alloc(y);let O=0;for(let _=0,M=f.length;_<M;_++){const k=f[_];A.set(k,O),O+=k.byteLength}return A}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=T.alloc(this.byteLength);return f.set(this),f}toString(){return r?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(f,y){return new T(this.buffer.subarray(f,y))}set(f,y){if(f instanceof T)this.buffer.set(f.buffer,y);else if(f instanceof Uint8Array)this.buffer.set(f,y);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),y);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),y);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return b(this.buffer,f)}writeUInt32BE(f,y){I(this.buffer,f,y)}readUInt32LE(f){return w(this.buffer,f)}writeUInt32LE(f,y){p(this.buffer,f,y)}readUInt8(f){return v(this.buffer,f)}writeUInt8(f,y){h(this.buffer,f,y)}}e.VSBuffer=T;function P(l,f){return l[f+0]<<0>>>0|l[f+1]<<8>>>0}e.readUInt16LE=P;function E(l,f,y){l[y+0]=f&255,f=f>>>8,l[y+1]=f&255}e.writeUInt16LE=E;function b(l,f){return l[f]*2**24+l[f+1]*2**16+l[f+2]*2**8+l[f+3]}e.readUInt32BE=b;function I(l,f,y){l[y+3]=f,f=f>>>8,l[y+2]=f,f=f>>>8,l[y+1]=f,f=f>>>8,l[y]=f}e.writeUInt32BE=I;function w(l,f){return l[f+0]<<0>>>0|l[f+1]<<8>>>0|l[f+2]<<16>>>0|l[f+3]<<24>>>0}e.readUInt32LE=w;function p(l,f,y){l[y+0]=f&255,f=f>>>8,l[y+1]=f&255,f=f>>>8,l[y+2]=f&255,f=f>>>8,l[y+3]=f&255}e.writeUInt32LE=p;function v(l,f){return l[f]}e.readUInt8=v;function h(l,f,y){l[y]=f}e.writeUInt8=h;function S(l){return D.consumeReadable(l,f=>T.concat(f))}e.readableToBuffer=S;function C(l){return D.toReadable(l)}e.bufferToReadable=C;function m(l){return D.consumeStream(l,f=>T.concat(f))}e.streamToBuffer=m;async function g(l){return l.ended?T.concat(l.buffer):T.concat([...l.buffer,await m(l.stream)])}e.bufferedStreamToBuffer=g;function a(l){return D.toStream(l,f=>T.concat(f))}e.bufferToStream=a;function d(l){return D.transform(l,{data:f=>typeof f=="string"?T.fromString(f):T.wrap(f)},f=>T.concat(f))}e.streamToBufferReadableStream=d;function c(l){return D.newWriteableStream(f=>T.concat(f),l)}e.newWriteableBufferStream=c;function i(l,f){return D.prefixedReadable(l,f,y=>T.concat(y))}e.prefixedBufferReadable=i;function o(l,f){return D.prefixedStream(l,f,y=>T.concat(y))}e.prefixedBufferStream=o;function t(l){let f=0,y=0,A=0;const O=new Uint8Array(Math.floor(l.length/4*3)),_=k=>{switch(y){case 3:O[A++]=f|k,y=0;break;case 2:O[A++]=f|k>>>2,f=k<<6,y=3;break;case 1:O[A++]=f|k>>>4,f=k<<4,y=2;break;default:f=k<<2,y=1}};for(let k=0;k<l.length;k++){const F=l.charCodeAt(k);if(F>=65&&F<=90)_(F-65);else if(F>=97&&F<=122)_(F-97+26);else if(F>=48&&F<=57)_(F-48+52);else if(F===43||F===45)_(62);else if(F===47||F===95)_(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${l[k]}`)}}const M=A;for(;y>0;)_(0);return T.wrap(O).slice(0,M)}e.decodeBase64=t;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:l},f=!0,y=!1){const A=y?s:n;let O="";const _=l.byteLength%3;let M=0;for(;M<l.byteLength-_;M+=3){const k=l[M+0],F=l[M+1],$=l[M+2];O+=A[k>>>2],O+=A[(k<<4|F>>>4)&63],O+=A[(F<<2|$>>>6)&63],O+=A[$&63]}if(_===1){const k=l[M+0];O+=A[k>>>2],O+=A[k<<4&63],f&&(O+="==")}else if(_===2){const k=l[M+0],F=l[M+1];O+=A[k>>>2],O+=A[(k<<4|F>>>4)&63],O+=A[F<<2&63],f&&(O+="=")}return O}e.encodeBase64=u}),define(ne[15],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function D(o){return typeof o=="string"}e.isString=D;function r(o){return Array.isArray(o)&&o.every(t=>D(t))}e.isStringArray=r;function R(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=R;function L(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}e.isTypedArray=L;function T(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=T;function P(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=P;function E(o){return o===!0||o===!1}e.isBoolean=E;function b(o){return typeof o>"u"}e.isUndefined=b;function I(o){return!w(o)}e.isDefined=I;function w(o){return b(o)||o===null}e.isUndefinedOrNull=w;function p(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=p;function v(o){if(w(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=v;function h(...o){const t=[];for(let n=0;n<o.length;n++){const s=o[n];if(w(s))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(s)}return t}e.assertAllDefined=h;const S=Object.prototype.hasOwnProperty;function C(o){if(!R(o))return!1;for(const t in o)if(S.call(o,t))return!1;return!0}e.isEmptyObject=C;function m(o){return typeof o=="function"}e.isFunction=m;function g(...o){return o.length>0&&o.every(m)}e.areFunctions=g;function a(o,t){const n=Math.min(o.length,t.length);for(let s=0;s<n;s++)d(o[s],t[s])}e.validateConstraints=a;function d(o,t){if(D(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(m(t)){try{if(o instanceof t)return}catch{}if(!w(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function c(o){return o===null?void 0:o}e.withNullAsUndefined=c;function i(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=i}),define(ne[32],re([0,1,15]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function r(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const g=Array.isArray(m)?[]:{};return Object.keys(m).forEach(a=>{m[a]&&typeof m[a]=="object"?g[a]=r(m[a]):g[a]=m[a]}),g}e.deepClone=r;function R(m){if(!m||typeof m!="object")return m;const g=[m];for(;g.length>0;){const a=g.shift();Object.freeze(a);for(const d in a)if(L.call(a,d)){const c=a[d];typeof c=="object"&&!Object.isFrozen(c)&&!(0,D.isTypedArray)(c)&&g.push(c)}}return m}e.deepFreeze=R;const L=Object.prototype.hasOwnProperty;function T(m,g){return P(m,g,new Set)}e.cloneAndChange=T;function P(m,g,a){if((0,D.isUndefinedOrNull)(m))return m;const d=g(m);if(typeof d<"u")return d;if(Array.isArray(m)){const c=[];for(const i of m)c.push(P(i,g,a));return c}if((0,D.isObject)(m)){if(a.has(m))throw new Error("Cannot clone recursive data-structure");a.add(m);const c={};for(const i in m)L.call(m,i)&&(c[i]=P(m[i],g,a));return a.delete(m),c}return m}function E(m,g,a=!0){return(0,D.isObject)(m)?((0,D.isObject)(g)&&Object.keys(g).forEach(d=>{d in m?a&&((0,D.isObject)(m[d])&&(0,D.isObject)(g[d])?E(m[d],g[d],a):m[d]=g[d]):m[d]=g[d]}),m):g}e.mixin=E;function b(m,g){if(m===g)return!0;if(m==null||g===null||g===void 0||typeof m!=typeof g||typeof m!="object"||Array.isArray(m)!==Array.isArray(g))return!1;let a,d;if(Array.isArray(m)){if(m.length!==g.length)return!1;for(a=0;a<m.length;a++)if(!b(m[a],g[a]))return!1}else{const c=[];for(d in m)c.push(d);c.sort();const i=[];for(d in g)i.push(d);if(i.sort(),!b(c,i))return!1;for(a=0;a<c.length;a++)if(!b(m[c[a]],g[c[a]]))return!1}return!0}e.equals=b;function I(m){const g=new Set;return JSON.stringify(m,(a,d)=>{if((0,D.isObject)(d)||Array.isArray(d)){if(g.has(d))return"[Circular]";g.add(d)}return d})}e.safeStringify=I;function w(m,g){const a=Object.create(null);return!m||!g||Object.keys(g).forEach(c=>{const i=m[c],o=g[c];b(i,o)||(a[c]=o)}),a}e.distinct=w;function p(m,g){const a=g.toLowerCase(),d=Object.keys(m).find(c=>c.toLowerCase()===a);return d?m[d]:m[g]}e.getCaseInsensitive=p;function v(m,g){const a=Object.create(null);for(const[d,c]of Object.entries(m))g(d,c)&&(a[d]=c);return a}e.filter=v;function h(m){let g=[],a=Object.getPrototypeOf(m);for(;Object.prototype!==a;)g=g.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return g}e.getAllPropertyNames=h;function S(m){const g=[];for(const a of h(m))typeof m[a]=="function"&&g.push(a);return g}e.getAllMethodNames=S;function C(m,g){const a=c=>function(){const i=Array.prototype.slice.call(arguments,0);return g(c,i)},d={};for(const c of m)d[c]=a(c);return d}e.createProxyObject=C}),define(ne[30],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(R){return D.test(R)}e.isUUID=r,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(P){for(let E=0;E<P.length;E++)P[E]=Math.floor(Math.random()*256);return P};const L=new Uint8Array(16),T=[];for(let P=0;P<256;P++)T.push(P.toString(16).padStart(2,"0"));return function(){R(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,b="";return b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b+="-",b+=T[L[E++]],b+=T[L[E++]],b+="-",b+=T[L[E++]],b+=T[L[E++]],b+="-",b+=T[L[E++]],b+=T[L[E++]],b+="-",b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b}}()}),define(ne[118],re([0,1,37]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(T){const P=T.replace(/\-/g,":").toLowerCase();return!r.has(P)}function L(){const T=(0,D.networkInterfaces)();for(const P in T){const E=T[P];if(E){for(const{mac:b}of E)if(R(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(ne[119],re([0,1,80]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function r(P,E,b,I=1){let w=!1;return new Promise(p=>{const v=setTimeout(()=>{if(!w)return w=!0,p(0)},b);R(P,E,I,h=>{if(!w)return w=!0,clearTimeout(v),p(h)})})}e.findFreePort=r;function R(P,E,b,I){if(E===0)return I(0);const w=new D.Socket;w.once("connect",()=>(T(w),R(P+b,E-1,b,I))),w.once("data",()=>{}),w.once("error",p=>(T(w),p.code!=="ECONNREFUSED"?R(P+b,E-1,b,I):I(P))),w.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(P,E,b){let I=!1,w,p=1;const v=D.createServer({pauseOnConnect:!0});function h(S,C){I||(I=!0,v.removeAllListeners(),v.close(),w&&clearTimeout(w),C(S))}return new Promise(S=>{w=setTimeout(()=>{h(0,S)},b),v.on("listening",()=>{h(P,S)}),v.on("error",C=>{C&&(C.code==="EADDRINUSE"||C.code==="EACCES")&&p<E?(P++,p++,v.listen(P,"127.0.0.1")):h(0,S)}),v.on("close",()=>{h(0,S)}),v.listen(P,"127.0.0.1")})}e.findFreePortFaster=L;function T(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(E){console.error(E)}}}),define(ne[120],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function r(L){return L instanceof R?!0:L instanceof Error&&L.name===D&&L.message===D}e.isOfflineError=r;class R extends Error{constructor(){super(D),this.name=this.message}}e.OfflineError=R}),define(ne[121],re([0,1,16,9,120]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(E,b){if(!navigator.onLine)throw new R.OfflineError;E.proxyAuthorization&&(E.headers={...E.headers||{},"Proxy-Authorization":E.proxyAuthorization});const I=new XMLHttpRequest;return new Promise((w,p)=>{I.open(E.type||"GET",E.url||"",!0,E.user,E.password),T(I,E),I.responseType="arraybuffer",I.onerror=v=>p(new Error(I.statusText&&"XHR failed: "+I.statusText||"XHR failed")),I.onload=v=>{w({res:{statusCode:I.status,headers:P(I)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(I.response)))})},I.ontimeout=v=>p(new Error(`XHR timeout: ${E.timeout}ms`)),E.timeout&&(I.timeout=E.timeout),I.send(E.data),b.onCancellationRequested(()=>{I.abort(),p((0,r.canceled)())})})}e.request=L;function T(E,b){if(b.headers){e:for(const I in b.headers){switch(I){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}E.setRequestHeader(I,b.headers[I])}}}function P(E){const b=Object.create(null);for(const I of E.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(I){const w=I.indexOf(":");b[I.substr(0,w).trim().toLowerCase()]=I.substr(w+1).trim()}return b}}),define(ne[122],re([10,11]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ne[63],re([0,1,122]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const r=60,R=r*60,L=R*24,T=L*7,P=L*30,E=L*365;function b(w,p,v){typeof w!="number"&&(w=w.getTime());const h=Math.round((new Date().getTime()-w)/1e3);if(h<-30)return(0,D.localize)(0,null,b(new Date().getTime()+h*1e3,!1));if(h<30)return(0,D.localize)(1,null);let S;return h<r?(S=h,p?S===1?v?(0,D.localize)(2,null,S):(0,D.localize)(3,null,S):v?(0,D.localize)(4,null,S):(0,D.localize)(5,null,S):S===1?v?(0,D.localize)(6,null,S):(0,D.localize)(7,null,S):v?(0,D.localize)(8,null,S):(0,D.localize)(9,null,S)):h<R?(S=Math.floor(h/r),p?S===1?v?(0,D.localize)(10,null,S):(0,D.localize)(11,null,S):v?(0,D.localize)(12,null,S):(0,D.localize)(13,null,S):S===1?v?(0,D.localize)(14,null,S):(0,D.localize)(15,null,S):v?(0,D.localize)(16,null,S):(0,D.localize)(17,null,S)):h<L?(S=Math.floor(h/R),p?S===1?v?(0,D.localize)(18,null,S):(0,D.localize)(19,null,S):v?(0,D.localize)(20,null,S):(0,D.localize)(21,null,S):S===1?v?(0,D.localize)(22,null,S):(0,D.localize)(23,null,S):v?(0,D.localize)(24,null,S):(0,D.localize)(25,null,S)):h<T?(S=Math.floor(h/L),p?S===1?(0,D.localize)(26,null,S):(0,D.localize)(27,null,S):S===1?(0,D.localize)(28,null,S):(0,D.localize)(29,null,S)):h<P?(S=Math.floor(h/T),p?S===1?v?(0,D.localize)(30,null,S):(0,D.localize)(31,null,S):v?(0,D.localize)(32,null,S):(0,D.localize)(33,null,S):S===1?v?(0,D.localize)(34,null,S):(0,D.localize)(35,null,S):v?(0,D.localize)(36,null,S):(0,D.localize)(37,null,S)):h<E?(S=Math.floor(h/P),p?S===1?v?(0,D.localize)(38,null,S):(0,D.localize)(39,null,S):v?(0,D.localize)(40,null,S):(0,D.localize)(41,null,S):S===1?v?(0,D.localize)(42,null,S):(0,D.localize)(43,null,S):v?(0,D.localize)(44,null,S):(0,D.localize)(45,null,S)):(S=Math.floor(h/E),p?S===1?v?(0,D.localize)(46,null,S):(0,D.localize)(47,null,S):v?(0,D.localize)(48,null,S):(0,D.localize)(49,null,S):S===1?v?(0,D.localize)(50,null,S):(0,D.localize)(51,null,S):v?(0,D.localize)(52,null,S):(0,D.localize)(53,null,S))}e.fromNow=b;function I(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(ne[123],re([10,11]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ne[38],re([0,1,19,15,123]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(w,p){return p&&(w.stack||w.stacktrace)?R.localize(0,null,P(w),T(w.stack)||T(w.stacktrace)):P(w)}function T(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?R.localize(1,null,w.message):w.message||R.localize(2,null)}function E(w=null,p=!1){if(!w)return R.localize(3,null);if(Array.isArray(w)){const v=D.coalesce(w),h=E(v[0],p);return v.length>1?R.localize(4,null,h,v.length):h}if(r.isString(w))return w;if(w.detail){const v=w.detail;if(v.error)return L(v.error,p);if(v.exception)return L(v.exception,p)}return w.stack?L(w,p):w.message?w.message:R.localize(5,null)}e.toErrorMessage=E;function b(w){const p=w;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=b;function I(w,p){let v;return typeof w=="string"?v=new Error(w):v=w,v.actions=p,v}e.createErrorWithActions=I}),define(ne[124],re([10,11]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(ne[125],re([0,1,124]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function r(R){switch(R){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=r}),define(ne[126],re([10,11]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(ne[4],re([0,1,126]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const r="en";let R=!1,L=!1,T=!1,P=!1,E=!1,b=!1,I=!1,w=!1,p=!1,v=!1,h,S=r,C,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?g=e.globals.vscode.process:typeof process<"u"&&(g=process);const a=typeof g?.versions?.electron=="string",d=a&&g?.type==="renderer";if(typeof navigator=="object"&&!d)m=navigator.userAgent,R=m.indexOf("Windows")>=0,L=m.indexOf("Macintosh")>=0,w=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=m.indexOf("Linux")>=0,v=m?.indexOf("Mobi")>=0,b=!0,h=D.getConfiguredDefaultLocale(D.localize(0,null))||r,S=h;else if(typeof g=="object"){R=g.platform==="win32",L=g.platform==="darwin",T=g.platform==="linux",P=T&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,I=a,p=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=r,S=r;const f=g.env.VSCODE_NLS_CONFIG;if(f)try{const y=JSON.parse(f),A=y.availableLanguages["*"];h=y.locale,S=A||r,C=y._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var c;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(c=e.Platform||(e.Platform={}));function i(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=i;let o=0;L?o=1:R?o=3:T&&(o=2),e.isWindows=R,e.isMacintosh=L,e.isLinux=T,e.isLinuxSnap=P,e.isNative=E,e.isElectron=I,e.isWeb=b,e.isWebWorker=b&&typeof e.globals.importScripts=="function",e.isIOS=w,e.isMobile=v,e.isCI=p,e.platform=o,e.userAgent=m,e.language=S;var t;(function(f){function y(){return e.language}f.value=y;function A(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}f.isDefaultVariant=A;function O(){return e.language==="en"}f.isDefault=O})(t=e.Language||(e.Language={})),e.locale=h,e.translationsConfigFile=C,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const f=[];e.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let O=0,_=f.length;O<_;O++){const M=f[O];if(M.id===A.data.vscodeScheduleAsyncWork){f.splice(O,1),M.callback();return}}});let y=0;return A=>{const O=++y;f.push({id:O,callback:A}),e.globals.postMessage({vscodeScheduleAsyncWork:O},"*")}}return f=>setTimeout(f)})();var n;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||w?2:R?1:3;let s=!0,u=!1;function l(){if(!u){u=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,s=new Uint16Array(f.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[36],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let r;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const R=D.globals.vscode.process;r={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.platform=r.platform,e.arch=r.arch}),define(ne[12],re([0,1,36]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const r=65,R=97,L=90,T=122,P=46,E=47,b=92,I=58,w=63;class p extends Error{constructor(d,c,i){let o;typeof c=="string"&&c.indexOf("not ")===0?(o="must not be",c=c.replace(/^not /,"")):o="must be";const t=d.indexOf(".")!==-1?"property":"argument";let n=`The "${d}" ${t} ${o} of type ${c}`;n+=`. Received type ${typeof i}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function v(a,d){if(typeof a!="string")throw new p(d,"string",a)}function h(a){return a===E||a===b}function S(a){return a===E}function C(a){return a>=r&&a<=L||a>=R&&a<=T}function m(a,d,c,i){let o="",t=0,n=-1,s=0,u=0;for(let l=0;l<=a.length;++l){if(l<a.length)u=a.charCodeAt(l);else{if(i(u))break;u=E}if(i(u)){if(!(n===l-1||s===1))if(s===2){if(o.length<2||t!==2||o.charCodeAt(o.length-1)!==P||o.charCodeAt(o.length-2)!==P){if(o.length>2){const f=o.lastIndexOf(c);f===-1?(o="",t=0):(o=o.slice(0,f),t=o.length-1-o.lastIndexOf(c)),n=l,s=0;continue}else if(o.length!==0){o="",t=0,n=l,s=0;continue}}d&&(o+=o.length>0?`${c}..`:"..",t=2)}else o.length>0?o+=`${c}${a.slice(n+1,l)}`:o=a.slice(n+1,l),t=l-n-1;n=l,s=0}else u===P&&s!==-1?++s:s=-1}return o}function g(a,d){if(d===null||typeof d!="object")throw new p("pathObject","Object",d);const c=d.dir||d.root,i=d.base||`${d.name||""}${d.ext||""}`;return c?c===d.root?`${c}${i}`:`${c}${a}${i}`:i}e.win32={resolve(...a){let d="",c="",i=!1;for(let o=a.length-1;o>=-1;o--){let t;if(o>=0){if(t=a[o],v(t,"path"),t.length===0)continue}else d.length===0?t=D.cwd():(t=D.env[`=${d}`]||D.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==d.toLowerCase()&&t.charCodeAt(2)===b)&&(t=`${d}\\`));const n=t.length;let s=0,u="",l=!1;const f=t.charCodeAt(0);if(n===1)h(f)&&(s=1,l=!0);else if(h(f))if(l=!0,h(t.charCodeAt(1))){let y=2,A=y;for(;y<n&&!h(t.charCodeAt(y));)y++;if(y<n&&y!==A){const O=t.slice(A,y);for(A=y;y<n&&h(t.charCodeAt(y));)y++;if(y<n&&y!==A){for(A=y;y<n&&!h(t.charCodeAt(y));)y++;(y===n||y!==A)&&(u=`\\\\${O}\\${t.slice(A,y)}`,s=y)}}}else s=1;else C(f)&&t.charCodeAt(1)===I&&(u=t.slice(0,2),s=2,n>2&&h(t.charCodeAt(2))&&(l=!0,s=3));if(u.length>0)if(d.length>0){if(u.toLowerCase()!==d.toLowerCase())continue}else d=u;if(i){if(d.length>0)break}else if(c=`${t.slice(s)}\\${c}`,i=l,l&&d.length>0)break}return c=m(c,!i,"\\",h),i?`${d}\\${c}`:`${d}${c}`||"."},normalize(a){v(a,"path");const d=a.length;if(d===0)return".";let c=0,i,o=!1;const t=a.charCodeAt(0);if(d===1)return S(t)?"\\":a;if(h(t))if(o=!0,h(a.charCodeAt(1))){let s=2,u=s;for(;s<d&&!h(a.charCodeAt(s));)s++;if(s<d&&s!==u){const l=a.slice(u,s);for(u=s;s<d&&h(a.charCodeAt(s));)s++;if(s<d&&s!==u){for(u=s;s<d&&!h(a.charCodeAt(s));)s++;if(s===d)return`\\\\${l}\\${a.slice(u)}\\`;s!==u&&(i=`\\\\${l}\\${a.slice(u,s)}`,c=s)}}}else c=1;else C(t)&&a.charCodeAt(1)===I&&(i=a.slice(0,2),c=2,d>2&&h(a.charCodeAt(2))&&(o=!0,c=3));let n=c<d?m(a.slice(c),!o,"\\",h):"";return n.length===0&&!o&&(n="."),n.length>0&&h(a.charCodeAt(d-1))&&(n+="\\"),i===void 0?o?`\\${n}`:n:o?`${i}\\${n}`:`${i}${n}`},isAbsolute(a){v(a,"path");const d=a.length;if(d===0)return!1;const c=a.charCodeAt(0);return h(c)||d>2&&C(c)&&a.charCodeAt(1)===I&&h(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let d,c;for(let t=0;t<a.length;++t){const n=a[t];v(n,"path"),n.length>0&&(d===void 0?d=c=n:d+=`\\${n}`)}if(d===void 0)return".";let i=!0,o=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++o;const t=c.length;t>1&&h(c.charCodeAt(1))&&(++o,t>2&&(h(c.charCodeAt(2))?++o:i=!1))}if(i){for(;o<d.length&&h(d.charCodeAt(o));)o++;o>=2&&(d=`\\${d.slice(o)}`)}return e.win32.normalize(d)},relative(a,d){if(v(a,"from"),v(d,"to"),a===d)return"";const c=e.win32.resolve(a),i=e.win32.resolve(d);if(c===i||(a=c.toLowerCase(),d=i.toLowerCase(),a===d))return"";let o=0;for(;o<a.length&&a.charCodeAt(o)===b;)o++;let t=a.length;for(;t-1>o&&a.charCodeAt(t-1)===b;)t--;const n=t-o;let s=0;for(;s<d.length&&d.charCodeAt(s)===b;)s++;let u=d.length;for(;u-1>s&&d.charCodeAt(u-1)===b;)u--;const l=u-s,f=n<l?n:l;let y=-1,A=0;for(;A<f;A++){const _=a.charCodeAt(o+A);if(_!==d.charCodeAt(s+A))break;_===b&&(y=A)}if(A!==f){if(y===-1)return i}else{if(l>f){if(d.charCodeAt(s+A)===b)return i.slice(s+A+1);if(A===2)return i.slice(s+A)}n>f&&(a.charCodeAt(o+A)===b?y=A:A===2&&(y=3)),y===-1&&(y=0)}let O="";for(A=o+y+1;A<=t;++A)(A===t||a.charCodeAt(A)===b)&&(O+=O.length===0?"..":"\\..");return s+=y,O.length>0?`${O}${i.slice(s,u)}`:(i.charCodeAt(s)===b&&++s,i.slice(s,u))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const d=e.win32.resolve(a);if(d.length<=2)return a;if(d.charCodeAt(0)===b){if(d.charCodeAt(1)===b){const c=d.charCodeAt(2);if(c!==w&&c!==P)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(C(d.charCodeAt(0))&&d.charCodeAt(1)===I&&d.charCodeAt(2)===b)return`\\\\?\\${d}`;return a},dirname(a){v(a,"path");const d=a.length;if(d===0)return".";let c=-1,i=0;const o=a.charCodeAt(0);if(d===1)return h(o)?a:".";if(h(o)){if(c=i=1,h(a.charCodeAt(1))){let s=2,u=s;for(;s<d&&!h(a.charCodeAt(s));)s++;if(s<d&&s!==u){for(u=s;s<d&&h(a.charCodeAt(s));)s++;if(s<d&&s!==u){for(u=s;s<d&&!h(a.charCodeAt(s));)s++;if(s===d)return a;s!==u&&(c=i=s+1)}}}}else C(o)&&a.charCodeAt(1)===I&&(c=d>2&&h(a.charCodeAt(2))?3:2,i=c);let t=-1,n=!0;for(let s=d-1;s>=i;--s)if(h(a.charCodeAt(s))){if(!n){t=s;break}}else n=!1;if(t===-1){if(c===-1)return".";t=c}return a.slice(0,t)},basename(a,d){d!==void 0&&v(d,"ext"),v(a,"path");let c=0,i=-1,o=!0,t;if(a.length>=2&&C(a.charCodeAt(0))&&a.charCodeAt(1)===I&&(c=2),d!==void 0&&d.length>0&&d.length<=a.length){if(d===a)return"";let n=d.length-1,s=-1;for(t=a.length-1;t>=c;--t){const u=a.charCodeAt(t);if(h(u)){if(!o){c=t+1;break}}else s===-1&&(o=!1,s=t+1),n>=0&&(u===d.charCodeAt(n)?--n===-1&&(i=t):(n=-1,i=s))}return c===i?i=s:i===-1&&(i=a.length),a.slice(c,i)}for(t=a.length-1;t>=c;--t)if(h(a.charCodeAt(t))){if(!o){c=t+1;break}}else i===-1&&(o=!1,i=t+1);return i===-1?"":a.slice(c,i)},extname(a){v(a,"path");let d=0,c=-1,i=0,o=-1,t=!0,n=0;a.length>=2&&a.charCodeAt(1)===I&&C(a.charCodeAt(0))&&(d=i=2);for(let s=a.length-1;s>=d;--s){const u=a.charCodeAt(s);if(h(u)){if(!t){i=s+1;break}continue}o===-1&&(t=!1,o=s+1),u===P?c===-1?c=s:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||o===-1||n===0||n===1&&c===o-1&&c===i+1?"":a.slice(c,o)},format:g.bind(null,"\\"),parse(a){v(a,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return d;const c=a.length;let i=0,o=a.charCodeAt(0);if(c===1)return h(o)?(d.root=d.dir=a,d):(d.base=d.name=a,d);if(h(o)){if(i=1,h(a.charCodeAt(1))){let y=2,A=y;for(;y<c&&!h(a.charCodeAt(y));)y++;if(y<c&&y!==A){for(A=y;y<c&&h(a.charCodeAt(y));)y++;if(y<c&&y!==A){for(A=y;y<c&&!h(a.charCodeAt(y));)y++;y===c?i=y:y!==A&&(i=y+1)}}}}else if(C(o)&&a.charCodeAt(1)===I){if(c<=2)return d.root=d.dir=a,d;if(i=2,h(a.charCodeAt(2))){if(c===3)return d.root=d.dir=a,d;i=3}}i>0&&(d.root=a.slice(0,i));let t=-1,n=i,s=-1,u=!0,l=a.length-1,f=0;for(;l>=i;--l){if(o=a.charCodeAt(l),h(o)){if(!u){n=l+1;break}continue}s===-1&&(u=!1,s=l+1),o===P?t===-1?t=l:f!==1&&(f=1):t!==-1&&(f=-1)}return s!==-1&&(t===-1||f===0||f===1&&t===s-1&&t===n+1?d.base=d.name=a.slice(n,s):(d.name=a.slice(n,t),d.base=a.slice(n,s),d.ext=a.slice(t,s))),n>0&&n!==i?d.dir=a.slice(0,n-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let d="",c=!1;for(let i=a.length-1;i>=-1&&!c;i--){const o=i>=0?a[i]:D.cwd();v(o,"path"),o.length!==0&&(d=`${o}/${d}`,c=o.charCodeAt(0)===E)}return d=m(d,!c,"/",S),c?`/${d}`:d.length>0?d:"."},normalize(a){if(v(a,"path"),a.length===0)return".";const d=a.charCodeAt(0)===E,c=a.charCodeAt(a.length-1)===E;return a=m(a,!d,"/",S),a.length===0?d?"/":c?"./":".":(c&&(a+="/"),d?`/${a}`:a)},isAbsolute(a){return v(a,"path"),a.length>0&&a.charCodeAt(0)===E},join(...a){if(a.length===0)return".";let d;for(let c=0;c<a.length;++c){const i=a[c];v(i,"path"),i.length>0&&(d===void 0?d=i:d+=`/${i}`)}return d===void 0?".":e.posix.normalize(d)},relative(a,d){if(v(a,"from"),v(d,"to"),a===d||(a=e.posix.resolve(a),d=e.posix.resolve(d),a===d))return"";const c=1,i=a.length,o=i-c,t=1,n=d.length-t,s=o<n?o:n;let u=-1,l=0;for(;l<s;l++){const y=a.charCodeAt(c+l);if(y!==d.charCodeAt(t+l))break;y===E&&(u=l)}if(l===s)if(n>s){if(d.charCodeAt(t+l)===E)return d.slice(t+l+1);if(l===0)return d.slice(t+l)}else o>s&&(a.charCodeAt(c+l)===E?u=l:l===0&&(u=0));let f="";for(l=c+u+1;l<=i;++l)(l===i||a.charCodeAt(l)===E)&&(f+=f.length===0?"..":"/..");return`${f}${d.slice(t+u)}`},toNamespacedPath(a){return a},dirname(a){if(v(a,"path"),a.length===0)return".";const d=a.charCodeAt(0)===E;let c=-1,i=!0;for(let o=a.length-1;o>=1;--o)if(a.charCodeAt(o)===E){if(!i){c=o;break}}else i=!1;return c===-1?d?"/":".":d&&c===1?"//":a.slice(0,c)},basename(a,d){d!==void 0&&v(d,"ext"),v(a,"path");let c=0,i=-1,o=!0,t;if(d!==void 0&&d.length>0&&d.length<=a.length){if(d===a)return"";let n=d.length-1,s=-1;for(t=a.length-1;t>=0;--t){const u=a.charCodeAt(t);if(u===E){if(!o){c=t+1;break}}else s===-1&&(o=!1,s=t+1),n>=0&&(u===d.charCodeAt(n)?--n===-1&&(i=t):(n=-1,i=s))}return c===i?i=s:i===-1&&(i=a.length),a.slice(c,i)}for(t=a.length-1;t>=0;--t)if(a.charCodeAt(t)===E){if(!o){c=t+1;break}}else i===-1&&(o=!1,i=t+1);return i===-1?"":a.slice(c,i)},extname(a){v(a,"path");let d=-1,c=0,i=-1,o=!0,t=0;for(let n=a.length-1;n>=0;--n){const s=a.charCodeAt(n);if(s===E){if(!o){c=n+1;break}continue}i===-1&&(o=!1,i=n+1),s===P?d===-1?d=n:t!==1&&(t=1):d!==-1&&(t=-1)}return d===-1||i===-1||t===0||t===1&&d===i-1&&d===c+1?"":a.slice(d,i)},format:g.bind(null,"/"),parse(a){v(a,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return d;const c=a.charCodeAt(0)===E;let i;c?(d.root="/",i=1):i=0;let o=-1,t=0,n=-1,s=!0,u=a.length-1,l=0;for(;u>=i;--u){const f=a.charCodeAt(u);if(f===E){if(!s){t=u+1;break}continue}n===-1&&(s=!1,n=u+1),f===P?o===-1?o=u:l!==1&&(l=1):o!==-1&&(l=-1)}if(n!==-1){const f=t===0&&c?1:t;o===-1||l===0||l===1&&o===n-1&&o===t+1?d.base=d.name=a.slice(f,n):(d.name=a.slice(f,o),d.base=a.slice(f,n),d.ext=a.slice(o,n))}return t>0?d.dir=a.slice(0,t-1):c&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[127],re([0,1,12]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const r={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(I){const w=(0,D.extname)(I),p=r[w.toLowerCase()];return p!==void 0?p:T(I)}e.getMediaOrTextMime=L;function T(I){const w=(0,D.extname)(I);return R[w.toLowerCase()]}e.getMediaMime=T;function P(I){for(const w in R)if(R[w]===I)return w}e.getExtensionForMimeType=P;const E=/^(.+)\/(.+?)(;.+)?$/;function b(I,w){const p=E.exec(I);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:w?void 0:I}e.normalizeMimeType=b}),define(ne[81],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var r;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(r=e.Source||(e.Source={}));var R;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(P,...E){const b=E.reduce((p,v)=>(p[v]=!0,p),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(p=>!b[p]).forEach(p=>{for(let v=0;v<I.length;v++)if(p.search(I[v])!==-1){delete P[p];break}})}e.sanitizeProcessEnvironment=L;function T(P){!P||(delete P.DEBUG,D.isMacintosh&&delete P.DYLD_LIBRARY_PATH,D.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(ne[128],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const r=D.globals.performance&&typeof D.globals.performance.now=="function";class R{static create(T=!0){return new R(T)}constructor(T){this._highResolution=r&&T,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(ne[3],re([0,1,9,78,2,116,128]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,E=!1;var b;(function(u){u.None=()=>R.Disposable.None;function l(N){if(E){const{onListenerDidAdd:q}=N,B=h.create();let Z=0;N.onListenerDidAdd=()=>{++Z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),B.print()),q?.()}}}function f(N){return(q,B=null,Z)=>{let oe=!1,X;return X=N(ie=>{if(!oe)return X?X.dispose():oe=!0,q.call(B,ie)},null,Z),oe&&X.dispose(),X}}u.once=f;function y(N,q,B){return F((Z,oe=null,X)=>N(ie=>Z.call(oe,q(ie)),null,X),B)}u.map=y;function A(N,q,B){return F((Z,oe=null,X)=>N(ie=>{q(ie),Z.call(oe,ie)},null,X),B)}u.forEach=A;function O(N,q,B){return F((Z,oe=null,X)=>N(ie=>q(ie)&&Z.call(oe,ie),null,X),B)}u.filter=O;function _(N){return N}u.signal=_;function M(...N){return(q,B=null,Z)=>(0,R.combinedDisposable)(...N.map(oe=>oe(X=>q.call(B,X),null,Z)))}u.any=M;function k(N,q,B,Z){let oe=B;return y(N,X=>(oe=q(oe,X),oe),Z)}u.reduce=k;function F(N,q){let B;const Z={onFirstListenerAdd(){B=N(oe.fire,oe)},onLastListenerRemove(){B?.dispose()}};q||l(Z);const oe=new C(Z);return q?.add(oe),oe.event}function $(N,q,B=100,Z=!1,oe,X){let ie,se,ue,he=0;const ve={leakWarningThreshold:oe,onFirstListenerAdd(){ie=N(Ee=>{he++,se=q(se,Ee),Z&&!ue&&(we.fire(se),se=void 0),clearTimeout(ue),ue=setTimeout(()=>{const Pe=se;se=void 0,ue=void 0,(!Z||he>1)&&we.fire(Pe),he=0},B)})},onLastListenerRemove(){ie.dispose()}};X||l(ve);const we=new C(ve);return X?.add(we),we.event}u.debounce=$;function x(N,q=(Z,oe)=>Z===oe,B){let Z=!0,oe;return O(N,X=>{const ie=Z||!q(X,oe);return Z=!1,oe=X,ie},B)}u.latch=x;function J(N,q,B){return[u.filter(N,q,B),u.filter(N,Z=>!q(Z),B)]}u.split=J;function H(N,q=!1,B=[]){let Z=B.slice(),oe=N(se=>{Z?Z.push(se):ie.fire(se)});const X=()=>{Z?.forEach(se=>ie.fire(se)),Z=null},ie=new C({onFirstListenerAdd(){oe||(oe=N(se=>ie.fire(se)))},onFirstListenerDidAdd(){Z&&(q?setTimeout(X):X())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return ie.event}u.buffer=H;class G{constructor(q){this.event=q,this.disposables=new R.DisposableStore}map(q){return new G(y(this.event,q,this.disposables))}forEach(q){return new G(A(this.event,q,this.disposables))}filter(q){return new G(O(this.event,q,this.disposables))}reduce(q,B){return new G(k(this.event,q,B,this.disposables))}latch(){return new G(x(this.event,void 0,this.disposables))}debounce(q,B=100,Z=!1,oe){return new G($(this.event,q,B,Z,oe,this.disposables))}on(q,B,Z){return this.event(q,B,Z)}once(q,B,Z){return f(this.event)(q,B,Z)}dispose(){this.disposables.dispose()}}function z(N){return new G(N)}u.chain=z;function j(N,q,B=Z=>Z){const Z=(...se)=>ie.fire(B(...se)),oe=()=>N.on(q,Z),X=()=>N.removeListener(q,Z),ie=new C({onFirstListenerAdd:oe,onLastListenerRemove:X});return ie.event}u.fromNodeEventEmitter=j;function Y(N,q,B=Z=>Z){const Z=(...se)=>ie.fire(B(...se)),oe=()=>N.addEventListener(q,Z),X=()=>N.removeEventListener(q,Z),ie=new C({onFirstListenerAdd:oe,onLastListenerRemove:X});return ie.event}u.fromDOMEventEmitter=Y;function te(N){return new Promise(q=>f(N)(q))}u.toPromise=te;function ce(N,q){return q(void 0),N(B=>q(B))}u.runAndSubscribe=ce;function W(N,q){let B=null;function Z(X){B?.dispose(),B=new R.DisposableStore,q(X,B)}Z(void 0);const oe=N(X=>Z(X));return(0,R.toDisposable)(()=>{oe.dispose(),B?.dispose()})}u.runAndSubscribeWithStore=W;class V{constructor(q,B){this.obs=q,this._counter=0,this._hasChanged=!1;const Z={onFirstListenerAdd:()=>{q.addObserver(this)},onLastListenerRemove:()=>{q.removeObserver(this)}};B||l(Z),this.emitter=new C(Z),B&&B.add(this.emitter)}beginUpdate(q){this._counter++}handleChange(q,B){this._hasChanged=!0}endUpdate(q){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function U(N,q){return new V(N,q).emitter.event}u.fromObservable=U})(b=e.Event||(e.Event={}));class I{constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${I._idPool++}`,I.all.add(this)}start(l){this._stopWatch=new T.StopWatch(!0),this.listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=I,I.all=new Set,I._idPool=0;let w=-1;function p(u){const l=w;return w=u,{dispose(){w=l}}}e.setGlobalLeakWarningThreshold=p;class v{constructor(l,f=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l,f){let y=w;if(typeof this.customThreshold=="number"&&(y=this.customThreshold),y<=0||f<y)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(l.value)||0;if(this._stacks.set(l.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=y*.5;let O,_=0;for(const[M,k]of this._stacks)(!O||_<k)&&(O=M,_=k);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${_}):`),console.warn(O)}return()=>{const O=this._stacks.get(l.value)||0;this._stacks.set(l.value,O-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(l,f,y){this.callback=l,this.callbackThis=f,this.stack=y,this.subscription=new R.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class C{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=w>0?new v(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const l=Array.from(this._listeners);queueMicrotask(()=>{for(const f of l)f.subscription.isset()&&(f.subscription.unset(),f.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(l,f,y)=>{this._listeners||(this._listeners=new L.LinkedList);const A=this._listeners.isEmpty();A&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let O,_;this._leakageMon&&this._listeners.size>=30&&(_=h.create(),O=this._leakageMon.check(_,this._listeners.size+1)),P&&(_=_??h.create());const M=new S(l,f,_),k=this._listeners.push(M);A&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,f);const F=M.subscription.set(()=>{O?.(),this._disposed||(k(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return y instanceof R.DisposableStore?y.add(F):Array.isArray(y)&&y.push(F),F}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const f of this._listeners)this._deliveryQueue.push(this,f,l);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=C;class m{constructor(){this._queue=new L.LinkedList}get size(){return this._queue.size}push(l,f,y){this._queue.push(new a(l,f,y))}clear(l){const f=new L.LinkedList;for(const y of this._queue)y.emitter!==l&&f.push(y);this._queue=f}deliver(){for(;this._queue.size>0;){const l=this._queue.shift();try{l.listener.invoke(l.event)}catch(f){(0,D.onUnexpectedError)(f)}}}}e.EventDeliveryQueue=m;class g extends m{clear(l){this._queue.clear()}}class a{constructor(l,f,y){this.emitter=l,this.listener=f,this.event=y}}class d extends C{async fireAsync(l,f,y){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const A of this._listeners)this._asyncDeliveryQueue.push([A,l]);for(;this._asyncDeliveryQueue.size>0&&!f.isCancellationRequested;){const[A,O]=this._asyncDeliveryQueue.shift(),_=[],M={...O,token:f,waitUntil:k=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");y&&(k=y(k,A.callback)),_.push(k)}};try{A.invoke(M)}catch(k){(0,D.onUnexpectedError)(k);continue}Object.freeze(_),await Promise.allSettled(_).then(k=>{for(const F of k)F.status==="rejected"&&(0,D.onUnexpectedError)(F.reason)})}}}}e.AsyncEmitter=d;class c extends C{constructor(l){super(l),this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=c;class i extends c{constructor(l){super(l),this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=i;class o extends C{constructor(l){super(l),this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){!this.hasListeners()||(this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(f=>super.fire(f)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new C({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const f={event:l,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const y=()=>{this.hasListeners&&this.unhook(f);const A=this.events.indexOf(f);this.events.splice(A,1)};return(0,R.toDisposable)((0,r.once)(y))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(f=>this.emitter.fire(f))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class n{constructor(){this.buffers=[]}wrapEvent(l){return(f,y,A)=>l(O=>{const _=this.buffers[this.buffers.length-1];_?_.push(()=>f.call(y,O)):f.call(y,O)},void 0,A)}bufferEvents(l){const f=[];this.buffers.push(f);const y=l();return this.buffers.pop(),f.forEach(A=>A()),y}}e.EventBufferer=n;class s{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=R.Disposable.None,this.emitter=new C({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(ne[23],re([0,1,3]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const r=Object.freeze(function(P,E){const b=setTimeout(P.bind(E),0);return{dispose(){clearTimeout(b)}}});var R;(function(P){function E(b){return b===P.None||b===P.Cancelled||b instanceof L?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}P.isCancellationToken=E,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(R=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?r:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=R.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=T}),define(ne[129],re([0,1,23]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class r{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new D.CancellationTokenSource,E=this.task(P.token);return this.result={promise:E,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=r;class R{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const E=JSON.stringify(P);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=R;class L{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const E=this.fn(P);return this._map.set(P,E),E}}e.CachedFunction=L}),define(ne[82],re([0,1,3,2]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const R=T=>({onDidChange:D.Event.None,value:T});e.staticObservableValue=R;class L extends r.Disposable{get value(){return this._value}set value(P){P!==this._value&&(this._value=P,this.changeEmitter.fire(P))}constructor(P){super(),this._value=P,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=L}),define(ne[27],re([0,1,129,115]),function(Q,e,D,r){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(ee){return!ee||typeof ee!="string"?!0:ee.trim().length===0}e.isFalsyOrWhitespace=L;const T=/{(\d+)}/g;function P(ee,...le){return le.length===0?ee:ee.replace(T,function(me,ge){const Se=parseInt(ge,10);return isNaN(Se)||Se<0||Se>=le.length?me:le[Se]})}e.format=P;const E=/{([^}]+)}/g;function b(ee,le){return ee.replace(E,(me,ge)=>le[ge]??me)}e.format2=b;function I(ee){return ee.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=I;function w(ee){return ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function p(ee,le){let me=0;const ge=le.charCodeAt(0);for(let Se=ee.length-1;Se>=0;Se--)ee.charCodeAt(Se)===ge&&me++;return me}e.count=p;function v(ee,le,me="\u2026"){return ee.length<=le?ee:`${ee.substr(0,le)}${me}`}e.truncate=v;function h(ee,le=" "){const me=S(ee,le);return C(me,le)}e.trim=h;function S(ee,le){if(!ee||!le)return ee;const me=le.length;if(me===0||ee.length===0)return ee;let ge=0;for(;ee.indexOf(le,ge)===ge;)ge=ge+me;return ee.substring(ge)}e.ltrim=S;function C(ee,le){if(!ee||!le)return ee;const me=le.length,ge=ee.length;if(me===0||ge===0)return ee;let Se=ge,be=-1;for(;be=ee.lastIndexOf(le,Se-1),!(be===-1||be+me!==Se);){if(be===0)return"";Se=be}return ee.substring(0,Se)}e.rtrim=C;function m(ee){return ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function g(ee){return ee.replace(/\*/g,"")}e.stripWildcards=g;function a(ee,le,me={}){if(!ee)throw new Error("Cannot create regex from empty string");le||(ee=w(ee)),me.wholeWord&&(/\B/.test(ee.charAt(0))||(ee="\\b"+ee),/\B/.test(ee.charAt(ee.length-1))||(ee=ee+"\\b"));let ge="";return me.global&&(ge+="g"),me.matchCase||(ge+="i"),me.multiline&&(ge+="m"),me.unicode&&(ge+="u"),new RegExp(ee,ge)}e.createRegExp=a;function d(ee){return ee.source==="^"||ee.source==="^$"||ee.source==="$"||ee.source==="^\\s*$"?!1:!!(ee.exec("")&&ee.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function c(ee){return!!ee.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function i(ee){return(ee.global?"g":"")+(ee.ignoreCase?"i":"")+(ee.multiline?"m":"")+(ee.unicode?"u":"")}e.regExpFlags=i;function o(ee){return ee.split(/\r\n|\r|\n/)}e.splitLines=o;function t(ee){for(let le=0,me=ee.length;le<me;le++){const ge=ee.charCodeAt(le);if(ge!==32&&ge!==9)return le}return-1}e.firstNonWhitespaceIndex=t;function n(ee,le=0,me=ee.length){for(let ge=le;ge<me;ge++){const Se=ee.charCodeAt(ge);if(Se!==32&&Se!==9)return ee.substring(le,ge)}return ee.substring(le,me)}e.getLeadingWhitespace=n;function s(ee,le=ee.length-1){for(let me=le;me>=0;me--){const ge=ee.charCodeAt(me);if(ge!==32&&ge!==9)return me}return-1}e.lastNonWhitespaceIndex=s;function u(ee,le,me){const ge=[];let Se=0;for(const be of ee.matchAll(le)){if(ge.push(ee.slice(Se,be.index)),be.index===void 0)throw new Error("match.index should be defined");Se=be.index+be[0].length,ge.push(me(be[0],...be.slice(1),be.index,ee,be.groups))}return ge.push(ee.slice(Se)),Promise.all(ge).then(be=>be.join(""))}e.replaceAsync=u;function l(ee,le){return ee<le?-1:ee>le?1:0}e.compare=l;function f(ee,le,me=0,ge=ee.length,Se=0,be=le.length){for(;me<ge&&Se<be;me++,Se++){const qe=ee.charCodeAt(me),Le=le.charCodeAt(Se);if(qe<Le)return-1;if(qe>Le)return 1}const De=ge-me,Te=be-Se;return De<Te?-1:De>Te?1:0}e.compareSubstring=f;function y(ee,le){return A(ee,le,0,ee.length,0,le.length)}e.compareIgnoreCase=y;function A(ee,le,me=0,ge=ee.length,Se=0,be=le.length){for(;me<ge&&Se<be;me++,Se++){let qe=ee.charCodeAt(me),Le=le.charCodeAt(Se);if(qe===Le)continue;if(qe>=128||Le>=128)return f(ee.toLowerCase(),le.toLowerCase(),me,ge,Se,be);_(qe)&&(qe-=32),_(Le)&&(Le-=32);const Ne=qe-Le;if(Ne!==0)return Ne}const De=ge-me,Te=be-Se;return De<Te?-1:De>Te?1:0}e.compareSubstringIgnoreCase=A;function O(ee){return ee>=48&&ee<=57}e.isAsciiDigit=O;function _(ee){return ee>=97&&ee<=122}e.isLowerAsciiLetter=_;function M(ee){return ee>=65&&ee<=90}e.isUpperAsciiLetter=M;function k(ee,le){return ee.length===le.length&&A(ee,le)===0}e.equalsIgnoreCase=k;function F(ee,le){const me=le.length;return le.length>ee.length?!1:A(ee,le,0,me)===0}e.startsWithIgnoreCase=F;function $(ee,le){const me=Math.min(ee.length,le.length);let ge;for(ge=0;ge<me;ge++)if(ee.charCodeAt(ge)!==le.charCodeAt(ge))return ge;return me}e.commonPrefixLength=$;function x(ee,le){const me=Math.min(ee.length,le.length);let ge;const Se=ee.length-1,be=le.length-1;for(ge=0;ge<me;ge++)if(ee.charCodeAt(Se-ge)!==le.charCodeAt(be-ge))return ge;return me}e.commonSuffixLength=x;function J(ee){return 55296<=ee&&ee<=56319}e.isHighSurrogate=J;function H(ee){return 56320<=ee&&ee<=57343}e.isLowSurrogate=H;function G(ee,le){return(ee-55296<<10)+(le-56320)+65536}e.computeCodePoint=G;function z(ee,le,me){const ge=ee.charCodeAt(me);if(J(ge)&&me+1<le){const Se=ee.charCodeAt(me+1);if(H(Se))return G(ge,Se)}return ge}e.getNextCodePoint=z;function j(ee,le){const me=ee.charCodeAt(le-1);if(H(me)&&le>1){const ge=ee.charCodeAt(le-2);if(J(ge))return G(ge,me)}return me}class Y{get offset(){return this._offset}constructor(le,me=0){this._str=le,this._len=le.length,this._offset=me}setOffset(le){this._offset=le}prevCodePoint(){const le=j(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=z(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=Y;class te{get offset(){return this._iterator.offset}constructor(le,me=0){this._iterator=new Y(le,me)}nextGraphemeLength(){const le=Ie.getInstance(),me=this._iterator,ge=me.offset;let Se=le.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const be=me.offset,De=le.getGraphemeBreakType(me.nextCodePoint());if(fe(Se,De)){me.setOffset(be);break}Se=De}return me.offset-ge}prevGraphemeLength(){const le=Ie.getInstance(),me=this._iterator,ge=me.offset;let Se=le.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const be=me.offset,De=le.getGraphemeBreakType(me.prevCodePoint());if(fe(De,Se)){me.setOffset(be);break}Se=De}return ge-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=te;function ce(ee,le){return new te(ee,le).nextGraphemeLength()}e.nextCharLength=ce;function W(ee,le){return new te(ee,le).prevGraphemeLength()}e.prevCharLength=W;function V(ee,le){le>0&&H(ee.charCodeAt(le))&&le--;const me=le+ce(ee,le);return[me-W(ee,me),me]}e.getCharContainingOffset=V;let U;function N(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(ee){return U||(U=N()),U.test(ee)}e.containsRTL=q;const B=/^[\t\n\r\x20-\x7E]*$/;function Z(ee){return B.test(ee)}e.isBasicASCII=Z,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(ee){return e.UNUSUAL_LINE_TERMINATORS.test(ee)}e.containsUnusualLineTerminators=oe;function X(ee){return ee>=11904&&ee<=55215||ee>=63744&&ee<=64255||ee>=65281&&ee<=65374}e.isFullWidthCharacter=X;function ie(ee){return ee>=127462&&ee<=127487||ee===8986||ee===8987||ee===9200||ee===9203||ee>=9728&&ee<=10175||ee===11088||ee===11093||ee>=127744&&ee<=128591||ee>=128640&&ee<=128764||ee>=128992&&ee<=129008||ee>=129280&&ee<=129535||ee>=129648&&ee<=129782}e.isEmojiImprecise=ie;function se(ee,le){if(ee.length<le)return ee;const me=/\b/g;let ge=0;for(;me.test(ee)&&!(ee.length-me.lastIndex<le);)ge=me.lastIndex,me.lastIndex+=1;return ee.substring(ge).replace(/^\s/,"")}e.lcut=se;const ue=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,ve=/\x1b\[0?m/g;function we(ee){return ee&&(ee=ee.replace(ue,""),ee=ee.replace(he,""),ee=ee.replace(ve,"")),ee}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(ee){return!!(ee&&ee.length>0&&ee.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Pe(ee){return Ee(ee)?ee.substr(1):ee}e.stripUTF8BOM=Pe;function Ue(ee,le){if(!ee||!le||ee.length<le.length)return!1;const me=le.length,ge=ee.toLowerCase();let Se=0,be=-1;for(;Se<me;){const De=ge.indexOf(le[Se],be+1);if(De<0)return!1;be=De,Se++}return!0}e.fuzzyContains=Ue;function We(ee,le=!1){return ee?(le&&(ee=ee.replace(/\\./g,"")),ee.toLowerCase()!==ee):!1}e.containsUppercaseCharacter=We;function Ve(ee){return ee.charAt(0).toUpperCase()+ee.slice(1)}e.uppercaseFirstLetter=Ve;function ze(ee,le=1){if(le===0)return"";let me=-1;do me=ee.indexOf(`
`,me+1),le--;while(le>0&&me>=0);return me===-1?ee:(ee[me-1]==="\r"&&me--,ee.substr(0,me))}e.getNLines=ze;function ae(ee){return ee=ee%(2*26),ee<26?String.fromCharCode(97+ee):String.fromCharCode(65+ee-26)}e.singleLetterHash=ae;function de(ee){return Ie.getInstance().getGraphemeBreakType(ee)}e.getGraphemeBreakType=de;function fe(ee,le){return ee===0?le!==5&&le!==7:ee===2&&le===3?!1:ee===4||ee===2||ee===3||le===4||le===2||le===3?!0:!(ee===8&&(le===8||le===9||le===11||le===12)||(ee===11||ee===9)&&(le===9||le===10)||(ee===12||ee===10)&&le===10||le===5||le===13||le===7||ee===1||ee===13&&le===14||ee===6&&le===6)}var Ce;(function(ee){ee[ee.Other=0]="Other",ee[ee.Prepend=1]="Prepend",ee[ee.CR=2]="CR",ee[ee.LF=3]="LF",ee[ee.Control=4]="Control",ee[ee.Extend=5]="Extend",ee[ee.Regional_Indicator=6]="Regional_Indicator",ee[ee.SpacingMark=7]="SpacingMark",ee[ee.L=8]="L",ee[ee.V=9]="V",ee[ee.T=10]="T",ee[ee.LV=11]="LV",ee[ee.LVT=12]="LVT",ee[ee.ZWJ=13]="ZWJ",ee[ee.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{static getInstance(){return Ie._INSTANCE||(Ie._INSTANCE=new Ie),Ie._INSTANCE}constructor(){this._data=Me()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const me=this._data,ge=me.length/3;let Se=1;for(;Se<=ge;)if(le<me[3*Se])Se=2*Se;else if(le>me[3*Se+1])Se=2*Se+1;else return me[3*Se+2];return 0}}Ie._INSTANCE=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Re(ee,le){if(ee===0)return 0;const me=$e(ee,le);if(me!==void 0)return me;const ge=new Y(le,ee);return ge.prevCodePoint(),ge.offset}e.getLeftDeleteOffset=Re;function $e(ee,le){const me=new Y(le,ee);let ge=me.prevCodePoint();for(;Ae(ge)||ge===65039||ge===8419;){if(me.offset===0)return;ge=me.prevCodePoint()}if(!ie(ge))return;let Se=me.offset;return Se>0&&me.prevCodePoint()===8205&&(Se=me.offset),Se}function Ae(ee){return 127995<=ee&&ee<=127999}var Fe;(function(ee){ee[ee.zwj=8205]="zwj",ee[ee.emojiVariantSelector=65039]="emojiVariantSelector",ee[ee.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.noBreakWhitespace="\xA0";class _e{static getInstance(le){return _e.cache.get(Array.from(le))}static getLocales(){return _e._locales.getValue()}constructor(le){this.confusableDictionary=le}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=_e,R=_e,_e.ambiguousCharacterData=new r.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),_e.cache=new D.LRUCachedFunction(ee=>{function le(Le){const Ne=new Map;for(let xe=0;xe<Le.length;xe+=2)Ne.set(Le[xe],Le[xe+1]);return Ne}function me(Le,Ne){const xe=new Map(Le);for(const[Xe,Ze]of Ne)xe.set(Xe,Ze);return xe}function ge(Le,Ne){if(!Le)return Ne;const xe=new Map;for(const[Xe,Ze]of Le)Ne.has(Xe)&&xe.set(Xe,Ze);return xe}const Se=R.ambiguousCharacterData.getValue();let be=ee.filter(Le=>!Le.startsWith("_")&&Le in Se);be.length===0&&(be=["_default"]);let De;for(const Le of be){const Ne=le(Se[Le]);De=ge(De,Ne)}const Te=le(Se._common),qe=me(Te,De);return new _e(qe)}),_e._locales=new r.Lazy(()=>Object.keys(_e.ambiguousCharacterData.getValue()).filter(ee=>!ee.startsWith("_")));class ke{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ke.getRawData())),this._data}static isInvisibleCharacter(le){return ke.getData().has(le)}static get codePoints(){return ke.getData()}}e.InvisibleCharacters=ke,ke._data=void 0}),define(ne[47],re([0,1,12,4,27,15]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(s){return s===47||s===92}e.isPathSeparator=T;function P(s){return s.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function E(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=E;function b(s,u=D.posix.sep){if(!s)return"";const l=s.length,f=s.charCodeAt(0);if(T(f)){if(T(s.charCodeAt(1))&&!T(s.charCodeAt(2))){let A=3;const O=A;for(;A<l&&!T(s.charCodeAt(A));A++);if(O!==A&&!T(s.charCodeAt(A+1))){for(A+=1;A<l;A++)if(T(s.charCodeAt(A)))return s.slice(0,A+1).replace(/[\\/]/g,u)}}return u}else if(m(f)&&s.charCodeAt(1)===58)return T(s.charCodeAt(2))?s.slice(0,2)+u:s.slice(0,2);let y=s.indexOf("://");if(y!==-1){for(y+=3;y<l;y++)if(T(s.charCodeAt(y)))return s.slice(0,y+1)}return""}e.getRoot=b;function I(s){if(!r.isWindows||!s||s.length<5)return!1;let u=s.charCodeAt(0);if(u!==92||(u=s.charCodeAt(1),u!==92))return!1;let l=2;const f=l;for(;l<s.length&&(u=s.charCodeAt(l),u!==92);l++);return!(f===l||(u=s.charCodeAt(l+1),isNaN(u)||u===92))}e.isUNC=I;const w=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(s,u=r.isWindows){const l=u?w:p;return!(!s||s.length===0||/^\s+$/.test(s)||(l.lastIndex=0,l.test(s))||u&&v.test(s)||s==="."||s===".."||u&&s[s.length-1]==="."||u&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=h;function S(s,u,l){const f=s===u;return!l||f?f:!s||!u?!1:(0,R.equalsIgnoreCase)(s,u)}e.isEqual=S;function C(s,u,l,f=D.sep){if(s===u)return!0;if(!s||!u||u.length>s.length)return!1;if(l){if(!(0,R.startsWithIgnoreCase)(s,u))return!1;if(u.length===s.length)return!0;let A=u.length;return u.charAt(u.length-1)===f&&A--,s.charAt(A)===f}return u.charAt(u.length-1)!==f&&(u+=f),s.indexOf(u)===0}e.isEqualOrParent=C;function m(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=m;function g(s,u){return r.isWindows&&s.endsWith(":")&&(s+=D.sep),(0,D.isAbsolute)(s)||(s=(0,D.join)(u,s)),s=(0,D.normalize)(s),r.isWindows?(s=(0,R.rtrim)(s,D.sep),s.endsWith(":")&&(s+=D.sep)):(s=(0,R.rtrim)(s,D.sep),s||(s=D.sep)),s}e.sanitizeFilePath=g;function a(s){const u=(0,D.normalize)(s);return r.isWindows?s.length>3?!1:d(u)&&(s.length===2||u.charCodeAt(2)===92):u===D.posix.sep}e.isRootOrDriveLetter=a;function d(s,u=r.isWindows){return u?m(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function c(s){return d(s)?s[0]:void 0}e.getDriveLetter=c;function i(s,u,l){return u.length>s.length?-1:s===u?0:(l&&(s=s.toLowerCase(),u=u.toLowerCase()),s.indexOf(u))}e.indexOfPath=i;function o(s){const u=s.split(":");let l,f,y;for(const A of u){const O=Number(A);(0,L.isNumber)(O)?f===void 0?f=O:y===void 0&&(y=O):l=l?[l,A].join(":"):A}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:f!==void 0?f:void 0,column:y!==void 0?y:f!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(s,u,l=8){let f="";for(let A=0;A<l;A++)f+=t.charAt(Math.floor(Math.random()*t.length));let y;return u?y=`${u}-${f}`:y=f,s?(0,D.join)(s,y):y}e.randomPath=n}),define(ne[64],re([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function r(m){return R(m,0)}e.hash=r;function R(m,g){switch(typeof m){case"object":return m===null?L(349,g):Array.isArray(m)?E(m,g):b(m,g);case"string":return P(m,g);case"boolean":return T(m,g);case"number":return L(m,g);case"undefined":return L(937,g);default:return L(617,g)}}e.doHash=R;function L(m,g){return(g<<5)-g+m|0}e.numberHash=L;function T(m,g){return L(m?433:863,g)}function P(m,g){g=L(149417,g);for(let a=0,d=m.length;a<d;a++)g=L(m.charCodeAt(a),g);return g}e.stringHash=P;function E(m,g){return g=L(104579,g),m.reduce((a,d)=>R(d,a),g)}function b(m,g){return g=L(181387,g),Object.keys(m).sort().reduce((a,d)=>(a=P(d,a),R(m[d],a)),g)}class I{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=R(g,this._value),this._value}}e.Hasher=I;var w;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function p(m,g,a=32){const d=a-g,c=~((1<<d)-1);return(m<<g|(c&m)>>>d)>>>0}function v(m,g=0,a=m.byteLength,d=0){for(let c=0;c<a;c++)m[g+c]=d}function h(m,g,a="0"){for(;m.length<g;)m=a+m;return m}function S(m,g=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(a=>a.toString(16).padStart(2,"0")).join(""):h((m>>>0).toString(16),g/4)}e.toHexString=S;class C{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const a=g.length;if(a===0)return;const d=this._buff;let c=this._buffLen,i=this._leftoverHighSurrogate,o,t;for(i!==0?(o=i,t=-1,i=0):(o=g.charCodeAt(0),t=0);;){let n=o;if(D.isHighSurrogate(o))if(t+1<a){const s=g.charCodeAt(t+1);D.isLowSurrogate(s)?(t++,n=D.computeCodePoint(o,s)):n=65533}else{i=o;break}else D.isLowSurrogate(o)&&(n=65533);if(c=this._push(d,c,n),t++,t<a)o=g.charCodeAt(t);else break}this._buffLen=c,this._leftoverHighSurrogate=i}_push(g,a,d){return d<128?g[a++]=d:d<2048?(g[a++]=192|(d&1984)>>>6,g[a++]=128|(d&63)>>>0):d<65536?(g[a++]=224|(d&61440)>>>12,g[a++]=128|(d&4032)>>>6,g[a++]=128|(d&63)>>>0):(g[a++]=240|(d&1835008)>>>18,g[a++]=128|(d&258048)>>>12,g[a++]=128|(d&4032)>>>6,g[a++]=128|(d&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=C._bigBlock32,a=this._buffDV;for(let l=0;l<64;l+=4)g.setUint32(l,a.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)g.setUint32(l,p(g.getUint32(l-12,!1)^g.getUint32(l-32,!1)^g.getUint32(l-56,!1)^g.getUint32(l-64,!1),1),!1);let d=this._h0,c=this._h1,i=this._h2,o=this._h3,t=this._h4,n,s,u;for(let l=0;l<80;l++)l<20?(n=c&i|~c&o,s=1518500249):l<40?(n=c^i^o,s=1859775393):l<60?(n=c&i|c&o|i&o,s=2400959708):(n=c^i^o,s=3395469782),u=p(d,5)+n+t+s+g.getUint32(l*4,!1)&4294967295,t=o,o=i,i=p(c,30),c=d,d=u;this._h0=this._h0+d&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=C,C._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ne[34],re([0,1,19,27]),function(Q,e,D,r){"use strict";var R,L,T;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,n,s){let u=t.get(n);return u===void 0&&(u=s,t.set(n,u)),u}e.getOrSet=P;function E(t){const n=[];return t.forEach((s,u)=>{n.push(`${u} => ${s}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=E;function b(t){const n=[];return t.forEach(s=>{n.push(s)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=b;class I{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),u=this._value.charCodeAt(this._pos);return s-u}value(){return this._value[this._pos]}}e.StringIterator=I;class w{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,r.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,r.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=w;class p{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let s=n.length-1;s>=0;s--,this._valueLen--){const u=this._value.charCodeAt(s);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,r.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,r.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var v;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(v||(v={}));class h{constructor(n,s){this._ignorePathCasing=n,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,r.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,r.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,r.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,r.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(t){t[t.Left=-1]="Left",t[t.Mid=0]="Mid",t[t.Right=1]="Right"})(C||(C={}));class m{static forUris(n=()=>!1,s=()=>!1){return new m(new h(n,s))}static forPaths(n=!1){return new m(new p(void 0,!n))}static forStrings(){return new m(new I)}static forConfigKeys(){return new m(new w)}constructor(n){this._iter=n}clear(){this._root=void 0}fill(n,s){if(s){const u=s.slice(0);(0,D.shuffle)(u);for(const l of u)this.set(l,n)}else{const u=n.slice(0);(0,D.shuffle)(u);for(const l of u)this.set(l[0],l[1])}}set(n,s){const u=this._iter.reset(n);let l;this._root||(this._root=new S,this._root.segment=u.value());const f=[];for(l=this._root;;){const A=u.cmp(l.segment);if(A>0)l.left||(l.left=new S,l.left.segment=u.value()),f.push([-1,l]),l=l.left;else if(A<0)l.right||(l.right=new S,l.right.segment=u.value()),f.push([1,l]),l=l.right;else if(u.hasNext())u.next(),l.mid||(l.mid=new S,l.mid.segment=u.value()),f.push([0,l]),l=l.mid;else break}const y=l.value;l.value=s,l.key=n;for(let A=f.length-1;A>=0;A--){const O=f[A][1];O.updateHeight();const _=O.balanceFactor();if(_<-1||_>1){const M=f[A][0],k=f[A+1][0];if(M===1&&k===1)f[A][1]=O.rotateLeft();else if(M===-1&&k===-1)f[A][1]=O.rotateRight();else if(M===1&&k===-1)O.right=f[A+1][1]=f[A+1][1].rotateRight(),f[A][1]=O.rotateLeft();else if(M===-1&&k===1)O.left=f[A+1][1]=f[A+1][1].rotateLeft(),f[A][1]=O.rotateRight();else throw new Error;if(A>0)switch(f[A-1][0]){case-1:f[A-1][1].left=f[A][1];break;case 1:f[A-1][1].right=f[A][1];break;case 0:f[A-1][1].mid=f[A][1];break}else this._root=f[0][1]}}return y}get(n){return this._getNode(n)?.value}_getNode(n){const s=this._iter.reset(n);let u=this._root;for(;u;){const l=s.cmp(u.segment);if(l>0)u=u.left;else if(l<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else break}return u}has(n){const s=this._getNode(n);return!(s?.value===void 0&&s?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const u=this._iter.reset(n),l=[];let f=this._root;for(;f;){const y=u.cmp(f.segment);if(y>0)l.push([-1,f]),f=f.left;else if(y<0)l.push([1,f]),f=f.right;else if(u.hasNext())u.next(),l.push([0,f]),f=f.mid;else break}if(!!f){if(s?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const y=this._min(f.right),{key:A,value:O,segment:_}=y;this._delete(y.key,!1),f.key=A,f.value=O,f.segment=_}else{const y=f.left??f.right;if(l.length>0){const[A,O]=l[l.length-1];switch(A){case-1:O.left=y;break;case 0:O.mid=y;break;case 1:O.right=y;break}}else this._root=y}for(let y=l.length-1;y>=0;y--){const A=l[y][1];A.updateHeight();const O=A.balanceFactor();if(O>1?(A.right.balanceFactor()>=0||(A.right=A.right.rotateRight()),l[y][1]=A.rotateLeft()):O<-1&&(A.left.balanceFactor()<=0||(A.left=A.left.rotateLeft()),l[y][1]=A.rotateRight()),y>0)switch(l[y-1][0]){case-1:l[y-1][1].left=l[y][1];break;case 1:l[y-1][1].right=l[y][1];break;case 0:l[y-1][1].mid=l[y][1];break}else this._root=l[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const s=this._iter.reset(n);let u=this._root,l;for(;u;){const f=s.cmp(u.segment);if(f>0)u=u.left;else if(f<0)u=u.right;else if(s.hasNext())s.next(),l=u.value||l,u=u.mid;else break}return u&&u.value||l}findSuperstr(n){const s=this._iter.reset(n);let u=this._root;for(;u;){const l=s.cmp(u.segment);if(l>0)u=u.left;else if(l<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(n){for(const[s,u]of this)n(u,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const s=[];return this._dfsEntries(n,s),s[Symbol.iterator]()}_dfsEntries(n,s){!n||(n.left&&this._dfsEntries(n.left,s),n.value&&s.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,s),n.right&&this._dfsEntries(n.right,s))}_isBalanced(){const n=s=>{if(!s)return!0;const u=s.balanceFactor();return u<-1||u>1?!1:n(s.left)&&n(s.right)};return n(this._root)}}e.TernarySearchTree=m;class g{constructor(n,s){this.uri=n,this.value=s}}class a{constructor(n,s){this[R]="ResourceMap",n instanceof a?(this.map=new Map(n.map),this.toKey=s??a.defaultToKey):(this.map=new Map,this.toKey=n??a.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),new g(n,s)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[u,l]of this.map)n(l.value,l.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=a,a.defaultToKey=t=>t.toString();class d{constructor(n,s){this[L]="ResourceSet",!n||typeof n=="function"?this._map=new a(n):(this._map=new a(s),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,s){this._map.forEach((u,l)=>n.call(s,l,l,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=d;var c;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class i{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const u=this._map.get(n);if(!!u)return s!==0&&this.touch(u,s),u.value}set(n,s,u=0){let l=this._map.get(n);if(l)l.value=s,u!==0&&this.touch(l,u);else{switch(l={key:n,value:s,next:void 0,previous:void 0},u){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const u=this._state;let l=this._head;for(;l;){if(s?n.bind(s)(l.value,l.key,this):n(l.value,l.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,s=this._state;let u=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.key,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return l}values(){const n=this,s=this._state;let u=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.value,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return l}entries(){const n=this,s=this._state;let u=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:[u.key,u.value],done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return l}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,u=this.size;for(;s&&u>n;)this._map.delete(s.key),s=s.next,u--;this._head=s,this._size=u,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,u=n.previous;if(!s||!u)throw new Error("Invalid list");s.previous=u,u.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const u=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(u.previous=l,l.next=u),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const u=n.next,l=n.previous;n===this._head?(u.previous=void 0,this._head=u):(u.previous=l,l.next=u),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,u)=>{n.push([u,s])}),n}fromJSON(n){this.clear();for(const[s,u]of n)this.set(s,u)}}e.LinkedMap=i;class o extends i{constructor(n,s=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o}),define(ne[83],re([0,1,34]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const r=new D.LRUCache(1e4);function R(b){return E(b,"NFC",r)}e.normalizeNFC=R;const L=new D.LRUCache(1e4);function T(b){return E(b,"NFD",L)}e.normalizeNFD=T;const P=/[^\u0000-\u0080]/;function E(b,I,w){if(!b)return b;const p=w.get(b);if(p)return p;let v;return P.test(b)?v=b.normalize(I):v=b,w.set(b,v),v}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(I){return T(I).replace(b,"")}}()}),define(ne[84],re([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var r;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(r||(r={})),function(R){const L="error",T="warning",P="warn",E="info",b="ignore";function I(p){return p?D.equalsIgnoreCase(L,p)?R.Error:D.equalsIgnoreCase(T,p)||D.equalsIgnoreCase(P,p)?R.Warning:D.equalsIgnoreCase(E,p)?R.Info:R.Ignore:R.Ignore}R.fromValue=I;function w(p){switch(p){case R.Error:return L;case R.Warning:return T;case R.Info:return E;default:return b}}R.toString=w}(r||(r={})),e.default=r}),define(ne[7],re([0,1,12,4]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,L=/^\//,T=/^\/\//;function P(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!R.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!L.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(t,n){return!t&&!n?"file":t}function b(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==w&&(n=w+n):n=w;break}return n}const I="",w="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(n){return n instanceof v?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,s,u,l,f,y=!1){typeof n=="object"?(this.scheme=n.scheme||I,this.authority=n.authority||I,this.path=n.path||I,this.query=n.query||I,this.fragment=n.fragment||I):(this.scheme=E(n,y),this.authority=s||I,this.path=b(this.scheme,u||I),this.query=l||I,this.fragment=f||I,P(this,y))}get fsPath(){return a(this,!1)}with(n){if(!n)return this;let{scheme:s,authority:u,path:l,query:f,fragment:y}=n;return s===void 0?s=this.scheme:s===null&&(s=I),u===void 0?u=this.authority:u===null&&(u=I),l===void 0?l=this.path:l===null&&(l=I),f===void 0?f=this.query:f===null&&(f=I),y===void 0?y=this.fragment:y===null&&(y=I),s===this.scheme&&u===this.authority&&l===this.path&&f===this.query&&y===this.fragment?this:new S(s,u,l,f,y)}static parse(n,s=!1){const u=p.exec(n);return u?new S(u[2]||I,o(u[4]||I),o(u[5]||I),o(u[7]||I),o(u[9]||I),s):new S(I,I,I,I,I)}static file(n){let s=I;if(r.isWindows&&(n=n.replace(/\\/g,w)),n[0]===w&&n[1]===w){const u=n.indexOf(w,2);u===-1?(s=n.substring(2),n=w):(s=n.substring(2,u),n=n.substring(u)||w)}return new S("file",s,n,I,I)}static from(n){const s=new S(n.scheme,n.authority,n.path,n.query,n.fragment);return P(s,!0),s}static joinPath(n,...s){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return r.isWindows&&n.scheme==="file"?u=v.file(D.win32.join(a(n,!0),...s)).path:u=D.posix.join(n.path,...s),n.with({path:u})}toString(n=!1){return d(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof v)return n;{const s=new S(n);return s._formatted=n.external,s._fsPath=n._sep===h?n.fsPath:null,s}}else return n}}e.URI=v;const h=r.isWindows?1:void 0;class S extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(n=!1){return n?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=h),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(t,n){let s,u=-1;for(let l=0;l<t.length;l++){const f=t.charCodeAt(l);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||n&&f===47)u!==-1&&(s+=encodeURIComponent(t.substring(u,l)),u=-1),s!==void 0&&(s+=t.charAt(l));else{s===void 0&&(s=t.substr(0,l));const y=C[f];y!==void 0?(u!==-1&&(s+=encodeURIComponent(t.substring(u,l)),u=-1),s+=y):u===-1&&(u=l)}}return u!==-1&&(s+=encodeURIComponent(t.substring(u))),s!==void 0?s:t}function g(t){let n;for(let s=0;s<t.length;s++){const u=t.charCodeAt(s);u===35||u===63?(n===void 0&&(n=t.substr(0,s)),n+=C[u]):n!==void 0&&(n+=t[s])}return n!==void 0?n:t}function a(t,n){let s;return t.authority&&t.path.length>1&&t.scheme==="file"?s=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?s=t.path.substr(1):s=t.path[1].toLowerCase()+t.path.substr(2):s=t.path,r.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=a;function d(t,n){const s=n?g:m;let u="",{scheme:l,authority:f,path:y,query:A,fragment:O}=t;if(l&&(u+=l,u+=":"),(f||l==="file")&&(u+=w,u+=w),f){let _=f.indexOf("@");if(_!==-1){const M=f.substr(0,_);f=f.substr(_+1),_=M.indexOf(":"),_===-1?u+=s(M,!1):(u+=s(M.substr(0,_),!1),u+=":",u+=s(M.substr(_+1),!1)),u+="@"}f=f.toLowerCase(),_=f.indexOf(":"),_===-1?u+=s(f,!1):(u+=s(f.substr(0,_),!1),u+=f.substr(_))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const _=y.charCodeAt(1);_>=65&&_<=90&&(y=`/${String.fromCharCode(_+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const _=y.charCodeAt(0);_>=65&&_<=90&&(y=`${String.fromCharCode(_+32)}:${y.substr(2)}`)}u+=s(y,!0)}return A&&(u+="?",u+=s(A,!1)),O&&(u+="#",u+=n?O:m(O,!1)),u}function c(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+c(t.substr(3)):t}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(t){return t.match(i)?t.replace(i,n=>c(n)):t}}),define(ne[130],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function r(b){const I=b;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=r;function R(b){const I=[];let w;try{const p=JSON.parse(b.arguments),v=p[p.length-1];v&&v.__$stack&&(p.pop(),w=v.__$stack),I.push(...p)}catch{I.push("Unable to log remote console arguments",b.arguments)}return{args:I,stack:w}}e.parse=R;function L(b){if(typeof b!="string")return L(R(b).stack);const I=b;if(I){const w=T(I),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(p&&p.length===4)return{uri:D.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=L;function T(b){if(!b)return b;const I=b.indexOf(`
`);return I===-1?b:b.substring(0,I)}function P(b,I){const{args:w,stack:p}=R(b),v=typeof w[0]=="string"&&w.length===1;let h=T(p);h&&(h=`(${h.trim()})`);let S=[];if(typeof w[0]=="string"?h&&v?S=[`%c[${I}] %c${w[0]} %c${h}`,E("blue"),E(""),E("grey")]:S=[`%c[${I}] %c${w[0]}`,E("blue"),E(""),...w.slice(1)]:S=[`%c[${I}]%`,E("blue"),...w],h&&!v&&S.push(h),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,S)}e.log=P;function E(b){return`color: ${b}`}}),define(ne[65],re([0,1,16,27,7]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(b){return JSON.stringify(b,P)}e.stringify=L;function T(b){let I=JSON.parse(b);return I=E(I),I}e.parse=T;function P(b,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,r.regExpFlags)(I)}:I}function E(b,I=0){if(!b||I>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return R.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof D.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let w=0;w<b.length;++w)b[w]=E(b[w],I+1);else for(const w in b)Object.hasOwnProperty.call(b,w)&&(b[w]=E(b[w],I+1))}return b}e.revive=E}),define(ne[22],re([0,1,4,7]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b){this._remoteResourcesPath=`${b}/${R.vscodeRemoteResource}`}set(b,I,w){this._hosts[b]=I,this._ports[b]=w}setConnectionToken(b,I){this._connectionTokens[b]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const I=b.authority;let w=this._hosts[I];w&&w.indexOf(":")!==-1&&(w=`[${w}]`);const p=this._ports[I],v=this._connectionTokens[I];let h=`path=${encodeURIComponent(b.path)}`;return typeof v=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),r.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${w}:${p}`,path:this._remoteResourcesPath,query:h})}}e.RemoteAuthorities=new L;class T{asBrowserUri(b,I){const w=this.toUri(b,I);return w.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(w):w.scheme===R.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${R.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?w.with({scheme:R.vscodeFileResource,authority:w.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):w}asFileUri(b,I){const w=this.toUri(b,I);return w.scheme===R.vscodeFileResource?w.with({scheme:R.file,authority:w.authority!==T.FALLBACK_AUTHORITY?w.authority:null,query:null,fragment:null}):w}toUri(b,I){return r.URI.isUri(b)?b:r.URI.parse(I.toUrl(b))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T;var P;(function(E){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(b.get("3"));const I="vscode-coi";function w(v){let h;typeof v=="string"?h=new URL(v).searchParams:v instanceof URL?h=v.searchParams:r.URI.isUri(v)&&(h=new URL(v.toString(!0)).searchParams);const S=h?.get(I);if(!!S)return b.get(S)}E.getHeadersFromQuery=w;function p(v,h,S){if(!globalThis.crossOriginIsolated)return;const C=h&&S?"3":S?"2":"1";v instanceof URLSearchParams?v.set(I,C):v[I]=C}E.addSearchParam=p})(P=e.COI||(e.COI={}))}),define(ne[17],re([0,1,47,22,12,4,27,7]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(v){return(0,P.uriToFsPath)(v,!0)}e.originalFSPath=E;class b{constructor(h){this._ignorePathCasing=h}compare(h,S,C=!1){return h===S?0:(0,T.compare)(this.getComparisonKey(h,C),this.getComparisonKey(S,C))}isEqual(h,S,C=!1){return h===S?!0:!h||!S?!1:this.getComparisonKey(h,C)===this.getComparisonKey(S,C)}getComparisonKey(h,S=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,S,C=!1){if(h.scheme===S.scheme){if(h.scheme===r.Schemas.file)return D.isEqualOrParent(E(h),E(S),this._ignorePathCasing(h))&&h.query===S.query&&(C||h.fragment===S.fragment);if((0,e.isEqualAuthority)(h.authority,S.authority))return D.isEqualOrParent(h.path,S.path,this._ignorePathCasing(h),"/")&&h.query===S.query&&(C||h.fragment===S.fragment)}return!1}joinPath(h,...S){return P.URI.joinPath(h,...S)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return R.posix.basename(h.path)}extname(h){return R.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let S;return h.scheme===r.Schemas.file?S=P.URI.file(R.dirname(E(h))).path:(S=R.posix.dirname(h.path),h.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),S="/")),h.with({path:S})}normalizePath(h){if(!h.path.length)return h;let S;return h.scheme===r.Schemas.file?S=P.URI.file(R.normalize(E(h))).path:S=R.posix.normalize(h.path),h.with({path:S})}relativePath(h,S){if(h.scheme!==S.scheme||!(0,e.isEqualAuthority)(h.authority,S.authority))return;if(h.scheme===r.Schemas.file){const g=R.relative(E(h),E(S));return L.isWindows?D.toSlashes(g):g}let C=h.path||"/";const m=S.path||"/";if(this._ignorePathCasing(h)){let g=0;for(const a=Math.min(C.length,m.length);g<a&&!(C.charCodeAt(g)!==m.charCodeAt(g)&&C.charAt(g).toLowerCase()!==m.charAt(g).toLowerCase());g++);C=m.substr(0,g)+C.substr(g)}return R.posix.relative(C,m)}resolvePath(h,S){if(h.scheme===r.Schemas.file){const C=P.URI.file(R.resolve(E(h),S));return h.with({authority:C.authority,path:C.path})}return S=D.toPosixPath(S),h.with({path:R.posix.resolve(h.path,S)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,S){return h===S||h!==void 0&&S!==void 0&&(0,T.equalsIgnoreCase)(h,S)}hasTrailingPathSeparator(h,S=R.sep){if(h.scheme===r.Schemas.file){const C=E(h);return C.length>D.getRoot(C).length&&C[C.length-1]===S}else{const C=h.path;return C.length>1&&C.charCodeAt(C.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,S=R.sep){return(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,S=R.sep){let C=!1;if(h.scheme===r.Schemas.file){const m=E(h);C=m!==void 0&&m.length===D.getRoot(m).length&&m[m.length-1]===S}else{S="/";const m=h.path;C=m.length===1&&m.charCodeAt(m.length-1)===47}return!C&&!(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path+"/"}):h}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(v=>v.scheme===r.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new b(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(v,h){const S=[];for(let C=0;C<v.length;C++){const m=h(v[C]);v.some((g,a)=>a===C?!1:(0,e.isEqualOrParent)(m,h(g)))||S.push(v[C])}return S}e.distinctParents=I;var w;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(S){const C=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(a=>{const[d,c]=a.split(":");d&&c&&C.set(d,c)});const g=S.path.substring(0,S.path.indexOf(";"));return g&&C.set(v.META_DATA_MIME,g),C}v.parseMetaData=h})(w=e.DataUri||(e.DataUri={}));function p(v,h,S){if(h){let C=v.path;return C&&C[0]!==R.posix.sep&&(C=R.posix.sep+C),v.with({scheme:S,authority:h,path:C})}return v.with({scheme:S})}e.toLocalResource=p}),define(ne[6],re([0,1,23,9,3,2,17,4]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(V){return!!V&&typeof V.then=="function"}e.isThenable=E;function b(V){const U=new D.CancellationTokenSource,N=V(U.token),q=new Promise((B,Z)=>{const oe=U.token.onCancellationRequested(()=>{oe.dispose(),U.dispose(),Z(new r.CancellationError)});Promise.resolve(N).then(X=>{oe.dispose(),U.dispose(),B(X)},X=>{oe.dispose(),U.dispose(),Z(X)})});return new class{cancel(){U.cancel()}then(B,Z){return q.then(B,Z)}catch(B){return this.then(void 0,B)}finally(B){return q.finally(B)}}}e.createCancelablePromise=b;function I(V,U,N){return new Promise((q,B)=>{const Z=U.onCancellationRequested(()=>{Z.dispose(),q(N)});V.then(q,B).finally(()=>Z.dispose())})}e.raceCancellation=I;function w(V,U){return new Promise((N,q)=>{const B=U.onCancellationRequested(()=>{B.dispose(),q(new r.CancellationError)});V.then(N,q).finally(()=>B.dispose())})}e.raceCancellationError=w;async function p(V){let U=-1;const N=V.map((B,Z)=>B.then(oe=>(U=Z,oe))),q=await Promise.race(N);return V.forEach((B,Z)=>{Z!==U&&B.cancel()}),q}e.raceCancellablePromises=p;function v(V,U,N){let q;const B=setTimeout(()=>{q?.(void 0),N?.()},U);return Promise.race([V.finally(()=>clearTimeout(B)),new Promise(Z=>q=Z)])}e.raceTimeout=v;function h(V){return new Promise((U,N)=>{const q=V();E(q)?q.then(U,N):U(q)})}e.asPromise=h;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then(N,N).then(q)})}return new Promise((N,q)=>{this.queuedPromise.then(N,q)})}return this.activePromise=U(),new Promise((N,q)=>{this.activePromise.then(B=>{this.activePromise=null,N(B)},B=>{this.activePromise=null,q(B)})})}}e.Throttler=S;class C{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=C;class m{constructor(){this.promiseMap=new Map}queue(U,N){const B=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(U)===B&&this.promiseMap.delete(U)});return this.promiseMap.set(U,B),B}}e.SequencerByKey=m;const g=(V,U)=>{let N=!0;const q=setTimeout(()=>{N=!1,U()},V);return{isTriggered:()=>N,dispose:()=>{clearTimeout(q),N=!1}}},a=V=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,V())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class d{constructor(U){this.defaultDelay=U,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,N=this.defaultDelay){this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,Z)=>{this.doResolve=B,this.doReject=Z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}}));const q=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=N===e.MicrotaskDelay?a(q):g(N,q),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new r.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=d;class c{constructor(U){this.delayer=new d(U),this.throttler=new S}trigger(U,N){return this.delayer.trigger(()=>this.throttler.queue(U),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class i{constructor(){this._isOpen=!1,this._promise=new Promise((U,N)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class o extends i{constructor(U){super(),this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function t(V,U){return U?new Promise((N,q)=>{const B=setTimeout(()=>{Z.dispose(),N()},V),Z=U.onCancellationRequested(()=>{clearTimeout(B),Z.dispose(),q(new r.CancellationError)})}):b(N=>t(V,N))}e.timeout=t;function n(V,U=0){const N=setTimeout(V,U);return(0,L.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=n;function s(V){const U=[];let N=0;const q=V.length;function B(){return N<q?V[N++]():null}function Z(oe){oe!=null&&U.push(oe);const X=B();return X?X.then(Z):Promise.resolve(U)}return Promise.resolve(null).then(Z)}e.sequence=s;function u(V,U=q=>!!q,N=null){let q=0;const B=V.length,Z=()=>{if(q>=B)return Promise.resolve(N);const oe=V[q++];return Promise.resolve(oe()).then(ie=>U(ie)?Promise.resolve(ie):Z())};return Z()}e.first=u;function l(V,U=q=>!!q,N=null){if(V.length===0)return Promise.resolve(N);let q=V.length;const B=()=>{q=-1;for(const Z of V)Z.cancel?.()};return new Promise((Z,oe)=>{for(const X of V)X.then(ie=>{--q>=0&&U(ie)?(B(),Z(ie)):q===0&&Z(N)}).catch(ie=>{--q>=0&&(B(),oe(ie))})})}e.firstParallel=l;class f{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new R.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(U){return this._size++,new Promise((N,q)=>{this.outstandingPromises.push({factory:U,c:N,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const N=U.factory();N.then(U.c,U.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=f;class y extends f{constructor(){super(1)}}e.Queue=y;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const U=new z;return this.drainers.add(U),U.p}isDrained(){for(const[,U]of this.queues)if(U.size>0)return!1;return!0}queueFor(U,N=T.extUri){const q=N.getComparisonKey(U);let B=this.queues.get(q);return B||(B=new y,R.Event.once(B.onDrained)(()=>{B?.dispose(),this.queues.delete(q),this.onDidQueueDrain()}),this.queues.set(q,B)),B}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const U of this.drainers)U.complete();this.drainers.clear()}dispose(){for(const[,U]of this.queues)U.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class O{constructor(U,N){this._token=-1,typeof U=="function"&&typeof N=="number"&&this.setIfNotSet(U,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},N)}setIfNotSet(U,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},N))}}e.TimeoutTimer=O;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,N){this.cancel(),this._token=setInterval(()=>{U()},N)}}e.IntervalTimer=_;class M{constructor(U,N){this.timeoutToken=-1,this.runner=U,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=M;class k{constructor(U,N){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=N,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=k;class F extends M{constructor(U,N){super(U,N),this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner?.(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class $ extends L.Disposable{constructor(U,N){super(),this.options=U,this.handler=N,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.options.maxBufferedWork)return!1}else if(this.pending+U.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=V=>{(0,P.setTimeout0)(()=>{if(U)return;const N=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.runWhenIdle=(V,U)=>{const N=requestIdleCallback(V,typeof U=="number"?{timeout:U}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(N))}}}}();class x{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=x;async function J(V,U,N){let q;for(let B=0;B<N;B++)try{return await V()}catch(Z){q=Z,await t(U)}throw q}e.retry=J;class H{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(U,N,q){return this._pending={taskId:U,cancel:()=>q?.(),promise:N},N.then(()=>this.donePending(U),()=>this.donePending(U)),N}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let N,q;const B=new Promise((Z,oe)=>{N=Z,q=oe});this._next={run:U,promise:B,promiseResolve:N,promiseReject:q}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=H;class G{constructor(U,N=()=>Date.now()){this.interval=U,this.nowFn=N,this.lastIncrementTime=0,this.value=0}increment(){const U=this.nowFn();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class z{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,N)=>{this.completeCallback=U,this.errorCallback=N})}complete(U){return new Promise(N=>{this.completeCallback(U),this.resolved=!0,N()})}error(U){return new Promise(N=>{this.errorCallback(U),this.rejected=!0,N()})}cancel(){new Promise(U=>{this.errorCallback(new r.CancellationError),this.rejected=!0,U()})}}e.DeferredPromise=z;var j;(function(V){async function U(q){let B;const Z=await Promise.all(q.map(oe=>oe.then(X=>X,X=>{B||(B=X)})));if(typeof B<"u")throw B;return Z}V.settled=U;function N(q){return new Promise(async(B,Z)=>{try{await q(B,Z)}catch(oe){Z(oe)}})}V.withAsyncBody=N})(j=e.Promises||(e.Promises={}));var Y;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(Y||(Y={}));class te{static fromArray(U){return new te(N=>{N.emitMany(U)})}static fromPromise(U){return new te(async N=>{N.emitMany(await U)})}static fromPromises(U){return new te(async N=>{await Promise.all(U.map(async q=>N.emitOne(await q)))})}static merge(U){return new te(async N=>{await Promise.all(U.map(async q=>{for await(const B of q)N.emitOne(B)}))})}constructor(U){this._state=0,this._results=[],this._error=null,this._onStateChanged=new R.Emitter,queueMicrotask(async()=>{const N={emitOne:q=>this.emitOne(q),emitMany:q=>this.emitMany(q),reject:q=>this.reject(q)};try{await Promise.resolve(U(N)),this.resolve()}catch(q){this.reject(q)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(U<this._results.length)return{done:!1,value:this._results[U++]};if(this._state===1)return{done:!0,value:void 0};await R.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(U,N){return new te(async q=>{for await(const B of U)q.emitOne(N(B))})}map(U){return te.map(this,U)}static filter(U,N){return new te(async q=>{for await(const B of U)N(B)&&q.emitOne(B)})}filter(U){return te.filter(this,U)}static coalesce(U){return te.filter(U,N=>!!N)}coalesce(){return te.coalesce(this)}static async toPromise(U){const N=[];for await(const q of U)N.push(q);return N}toPromise(){return te.toPromise(this)}emitOne(U){this._state===0&&(this._results.push(U),this._onStateChanged.fire())}emitMany(U){this._state===0&&(this._results=this._results.concat(U),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(U){this._state===0&&(this._state=2,this._error=U,this._onStateChanged.fire())}}e.AsyncIterableObject=te,te.EMPTY=te.fromArray([]);class ce extends te{constructor(U,N){super(N),this._source=U}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function W(V){const U=new D.CancellationTokenSource,N=V(U.token);return new ce(U,async q=>{const B=U.token.onCancellationRequested(()=>{B.dispose(),U.dispose(),q.reject(new r.CancellationError)});try{for await(const Z of N){if(U.token.isCancellationRequested)return;q.emitOne(Z)}B.dispose(),U.dispose()}catch(Z){B.dispose(),U.dispose(),q.reject(Z)}})}e.createCancelableAsyncIterable=W}),define(ne[85],re([0,1,19,6,47,34,12,4,27]),function(Q,e,D,r,R,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",w="[^/\\\\]",p=/\//g;function v(z,j){switch(z){case 0:return"";case 1:return`${w}*?`;default:return`(?:${I}|${w}+${I}${j?`|${I}${w}+`:""})*?`}}function h(z,j){if(!z)return[];const Y=[];let te=!1,ce=!1,W="";for(const V of z){switch(V){case j:if(!te&&!ce){Y.push(W),W="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}W+=V}return W&&Y.push(W),Y}e.splitGlobAware=h;function S(z){if(!z)return"";let j="";const Y=h(z,e.GLOB_SPLIT);if(Y.every(te=>te===e.GLOBSTAR))j=".*";else{let te=!1;Y.forEach((ce,W)=>{if(ce===e.GLOBSTAR){if(te)return;j+=v(2,W===Y.length-1)}else{let V=!1,U="",N=!1,q="";for(const B of ce){if(B!=="}"&&V){U+=B;continue}if(N&&(B!=="]"||!q)){let Z;B==="-"?Z=B:(B==="^"||B==="!")&&!q?Z="^":B===e.GLOB_SPLIT?Z="":Z=(0,E.escapeRegExpCharacters)(B),q+=Z;continue}switch(B){case"{":V=!0;continue;case"[":N=!0;continue;case"}":{j+=`(?:${h(U,",").map(X=>S(X)).join("|")})`,V=!1,U="";break}case"]":{j+="["+q+"]",N=!1,q="";break}case"?":j+=w;continue;case"*":j+=v(1);continue;default:j+=(0,E.escapeRegExpCharacters)(B)}}W<Y.length-1&&(Y[W+1]!==e.GLOBSTAR||W+2<Y.length)&&(j+=I)}te=ce===e.GLOBSTAR})}return j}const C=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.LRUCache(1e4),o=function(){return!1},t=function(){return null};function n(z,j){if(!z)return t;let Y;typeof z!="string"?Y=z.pattern:Y=z,Y=Y.trim();const te=`${Y}_${!!j.trimForExclusions}`;let ce=i.get(te);if(ce)return s(ce,z);let W;return C.test(Y)?ce=l(Y.substr(4),Y):(W=m.exec(u(Y,j)))?ce=f(W[1],Y):(j.trimForExclusions?a:g).test(Y)?ce=y(Y,j):(W=d.exec(u(Y,j)))?ce=A(W[1].substr(1),Y,!0):(W=c.exec(u(Y,j)))?ce=A(W[1],Y,!1):ce=O(Y),i.set(te,ce),s(ce,z)}function s(z,j){if(typeof j=="string")return z;const Y=function(te,ce){return(0,R.isEqualOrParent)(te,j.base,!P.isLinux)?z(te.substr(j.base.length+1),ce):null};return Y.allBasenames=z.allBasenames,Y.allPaths=z.allPaths,Y.basenames=z.basenames,Y.patterns=z.patterns,Y}function u(z,j){return j.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function l(z,j){return function(Y,te){return typeof Y=="string"&&Y.endsWith(z)?j:null}}function f(z,j){const Y=`/${z}`,te=`\\${z}`,ce=function(V,U){return typeof V!="string"?null:U?U===z?j:null:V===z||V.endsWith(Y)||V.endsWith(te)?j:null},W=[z];return ce.basenames=W,ce.patterns=[j],ce.allBasenames=W,ce}function y(z,j){const Y=H(z.slice(1,-1).split(",").map(U=>n(U,j)).filter(U=>U!==t),z),te=Y.length;if(!te)return t;if(te===1)return Y[0];const ce=function(U,N){for(let q=0,B=Y.length;q<B;q++)if(Y[q](U,N))return z;return null},W=Y.find(U=>!!U.allBasenames);W&&(ce.allBasenames=W.allBasenames);const V=Y.reduce((U,N)=>N.allPaths?U.concat(N.allPaths):U,[]);return V.length&&(ce.allPaths=V),ce}function A(z,j,Y){const te=T.sep===T.posix.sep,ce=te?z:z.replace(p,T.sep),W=T.sep+ce,V=T.posix.sep+z;let U;return Y?U=function(N,q){return typeof N=="string"&&(N===ce||N.endsWith(W)||!te&&(N===z||N.endsWith(V)))?j:null}:U=function(N,q){return typeof N=="string"&&(N===ce||!te&&N===z)?j:null},U.allPaths=[(Y?"*/":"./")+z],U}function O(z){try{const j=new RegExp(`^${S(z)}$`);return function(Y){return j.lastIndex=0,typeof Y=="string"&&j.test(Y)?z:null}}catch{return t}}function _(z,j,Y){return!z||typeof j!="string"?!1:M(z)(j,void 0,Y)}e.match=_;function M(z,j={}){if(!z)return o;if(typeof z=="string"||k(z)){const Y=n(z,j);if(Y===t)return o;const te=function(ce,W){return!!Y(ce,W)};return Y.allBasenames&&(te.allBasenames=Y.allBasenames),Y.allPaths&&(te.allPaths=Y.allPaths),te}return x(z,j)}e.parse=M;function k(z){const j=z;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=k;function F(z){return z.allBasenames||[]}e.getBasenameTerms=F;function $(z){return z.allPaths||[]}e.getPathTerms=$;function x(z,j){const Y=H(Object.getOwnPropertyNames(z).map(U=>J(U,z[U],j)).filter(U=>U!==t)),te=Y.length;if(!te)return t;if(!Y.some(U=>!!U.requiresSiblings)){if(te===1)return Y[0];const U=function(B,Z){let oe;for(let X=0,ie=Y.length;X<ie;X++){const se=Y[X](B,Z);if(typeof se=="string")return se;(0,r.isThenable)(se)&&(oe||(oe=[]),oe.push(se))}return oe?(async()=>{for(const X of oe){const ie=await X;if(typeof ie=="string")return ie}return null})():null},N=Y.find(B=>!!B.allBasenames);N&&(U.allBasenames=N.allBasenames);const q=Y.reduce((B,Z)=>Z.allPaths?B.concat(Z.allPaths):B,[]);return q.length&&(U.allPaths=q),U}const ce=function(U,N,q){let B,Z;for(let oe=0,X=Y.length;oe<X;oe++){const ie=Y[oe];ie.requiresSiblings&&q&&(N||(N=(0,T.basename)(U)),B||(B=N.substr(0,N.length-(0,T.extname)(U).length)));const se=ie(U,N,B,q);if(typeof se=="string")return se;(0,r.isThenable)(se)&&(Z||(Z=[]),Z.push(se))}return Z?(async()=>{for(const oe of Z){const X=await oe;if(typeof X=="string")return X}return null})():null},W=Y.find(U=>!!U.allBasenames);W&&(ce.allBasenames=W.allBasenames);const V=Y.reduce((U,N)=>N.allPaths?U.concat(N.allPaths):U,[]);return V.length&&(ce.allPaths=V),ce}function J(z,j,Y){if(j===!1)return t;const te=n(z,Y);if(te===t)return t;if(typeof j=="boolean")return te;if(j){const ce=j.when;if(typeof ce=="string"){const W=(V,U,N,q)=>{if(!q||!te(V,U))return null;const B=ce.replace("$(basename)",N),Z=q(B);return(0,r.isThenable)(Z)?Z.then(oe=>oe?z:null):Z?z:null};return W.requiresSiblings=!0,W}}return te}function H(z,j){const Y=z.filter(U=>!!U.basenames);if(Y.length<2)return z;const te=Y.reduce((U,N)=>{const q=N.basenames;return q?U.concat(q):U},[]);let ce;if(j){ce=[];for(let U=0,N=te.length;U<N;U++)ce.push(j)}else ce=Y.reduce((U,N)=>{const q=N.patterns;return q?U.concat(q):U},[]);const W=function(U,N){if(typeof U!="string")return null;if(!N){let B;for(B=U.length;B>0;B--){const Z=U.charCodeAt(B-1);if(Z===47||Z===92)break}N=U.substr(B)}const q=te.indexOf(N);return q!==-1?ce[q]:null};W.basenames=te,W.patterns=ce,W.allBasenames=te;const V=z.filter(U=>!U.basenames);return V.push(W),V}function G(z,j){return(0,D.equals)(z,j,(Y,te)=>typeof Y=="string"&&typeof te=="string"?Y===te:typeof Y!="string"&&typeof te!="string"?Y.base===te.base&&Y.pattern===te.pattern:!1)}e.patternsEquals=G}),define(ne[131],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(I){return I.toJSON()}class R{constructor(w){this._uriTransformer=w}transformIncoming(w){const p=this._uriTransformer.transformIncoming(w);return p===w?w:r(D.URI.from(p))}transformOutgoing(w){const p=this._uriTransformer.transformOutgoing(w);return p===w?w:r(D.URI.from(p))}transformOutgoingURI(w){const p=this._uriTransformer.transformOutgoing(w);return p===w?w:D.URI.from(p)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function L(I,w,p){if(!I||p>200)return null;if(typeof I=="object"){if(I instanceof D.URI)return w.transformOutgoing(I);for(const v in I)if(Object.hasOwnProperty.call(I,v)){const h=L(I[v],w,p+1);h!==null&&(I[v]=h)}}return null}function T(I,w){const p=L(I,w,0);return p===null?I:p}e.transformOutgoingURIs=T;function P(I,w,p,v){if(!I||v>200)return null;if(typeof I=="object"){if(I.$mid===1)return p?D.URI.revive(w.transformIncoming(I)):w.transformIncoming(I);for(const h in I)if(Object.hasOwnProperty.call(I,h)){const S=P(I[h],w,p,v+1);S!==null&&(I[h]=S)}}return null}function E(I,w){const p=P(I,w,!1,0);return p===null?I:p}e.transformIncomingURIs=E;function b(I,w){const p=P(I,w,!0,0);return p===null?I:p}e.transformAndReviveIncomingURIs=b}),define(ne[132],re([0,1,37,9,34,30,118]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,w=0;const p=(0,D.networkInterfaces)();for(const v in p){const h=p[v];if(h)for(const{mac:S,internal:C}of h)C||(w+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(I+=1))}this._value=w>0?I/w:0}return this._value}};let P;async function E(){return P||(P=(async()=>await b()||L.generateUuid())()),P}e.getMachineId=E;async function b(){try{const I=await new Promise((p,v)=>{Q(["crypto"],p,v)}),w=(0,T.getMac)();return I.createHash("sha256").update(w,"utf8").digest("hex")}catch(I){r.onUnexpectedError(I);return}}}),define(ne[28],re([0,1,53,37,274,6,47,83,12,4,17,7]),function(Q,e,D,r,R,L,T,P,E,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(x){x[x.UNLINK=0]="UNLINK",x[x.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function v(x,J=p.UNLINK){if((0,T.isRootOrDriveLetter)(x))throw new Error("rimraf - will refuse to recursively delete root");return J===p.UNLINK?S(x):h(x)}async function h(x){try{const J=(0,T.randomPath)((0,r.tmpdir)());try{await D.promises.rename(x,J)}catch(H){return H.code==="ENOENT"?void 0:S(x)}S(J).catch(H=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function S(x){return(0,R.promisify)(D.rm)(x,{recursive:!0,force:!0,maxRetries:3})}function C(x){if((0,T.isRootOrDriveLetter)(x))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(x,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=C;async function m(x,J){return d(await(J?g(x):(0,R.promisify)(D.readdir)(x)))}async function g(x){try{return await(0,R.promisify)(D.readdir)(x,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const J=[],H=await m(x);for(const G of H){let z=!1,j=!1,Y=!1;try{const te=await e.Promises.lstat((0,E.join)(x,G));z=te.isFile(),j=te.isDirectory(),Y=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}J.push({name:G,isFile:()=>z,isDirectory:()=>j,isSymbolicLink:()=>Y})}return J}function a(x){return d(D.readdirSync(x))}e.readdirSync=a;function d(x){return x.map(J=>typeof J=="string"?b.isMacintosh?(0,P.normalizeNFC)(J):J:(J.name=b.isMacintosh?(0,P.normalizeNFC)(J.name):J.name,J))}async function c(x){const J=await m(x),H=[];for(const G of J)await o.existsDirectory((0,E.join)(x,G))&&H.push(G);return H}function i(x,J=1e3){return new Promise(H=>{let G=!1;const z=setInterval(()=>{G||(G=!0,D.access(x,j=>{G=!1,j&&(clearInterval(z),H(void 0))}))},J)})}e.whenDeleted=i;var o;(function(x){async function J(z){let j;try{if(j=await e.Promises.lstat(z),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(b.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw te}throw Y}}x.stat=J;async function H(z){try{const{stat:j,symbolicLink:Y}=await x.stat(z);return j.isFile()&&Y?.dangling!==!0}catch{}return!1}x.existsFile=H;async function G(z){try{const{stat:j,symbolicLink:Y}=await x.stat(z);return j.isDirectory()&&Y?.dangling!==!0}catch{}return!1}x.existsDirectory=G})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new L.ResourceQueue;function n(x,J,H){return t.queueFor(w.URI.file(x),I.extUriBiasedIgnorePathCase).queue(()=>{const G=y(H);return new Promise((z,j)=>l(x,J,G,Y=>Y?j(Y):z()))})}let s=!0;function u(x){s=x}e.configureFlushOnWrite=u;function l(x,J,H,G){if(!s)return D.writeFile(x,J,{mode:H.mode,flag:H.flag},G);D.open(x,H.flag,H.mode,(z,j)=>{if(z)return G(z);D.writeFile(j,J,Y=>{if(Y)return D.close(j,()=>G(Y));D.fdatasync(j,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),u(!1)),D.close(j,ce=>G(ce))))})})}function f(x,J,H){const G=y(H);if(!s)return D.writeFileSync(x,J,{mode:G.mode,flag:G.flag});const z=D.openSync(x,G.flag,G.mode);try{D.writeFileSync(z,J);try{D.fdatasyncSync(z)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),u(!1)}}finally{D.closeSync(z)}}e.writeFileSync=f;function y(x){return x?{mode:typeof x.mode=="number"?x.mode:438,flag:typeof x.flag=="string"?x.flag:"w"}:{mode:438,flag:"w"}}async function A(x,J){if(x!==J)try{await e.Promises.rename(x,J)}catch(H){if(x.toLowerCase()!==J.toLowerCase()&&H.code==="EXDEV"||x.endsWith("."))await O(x,J,{preserveSymlinks:!1}),await v(x,p.MOVE);else throw H}}async function O(x,J,H){return M(x,J,{root:{source:x,target:J},options:H,handledSourcePaths:new Set})}const _=511;async function M(x,J,H){if(H.handledSourcePaths.has(x))return;H.handledSourcePaths.add(x);const{stat:G,symbolicLink:z}=await o.stat(x);if(z){if(H.options.preserveSymlinks)try{return await $(x,J,H)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(z.dangling)return}return G.isDirectory()?k(x,J,G.mode&_,H):F(x,J,G.mode&_)}async function k(x,J,H,G){await e.Promises.mkdir(J,{recursive:!0,mode:H});const z=await m(x);for(const j of z)await M((0,E.join)(x,j),(0,E.join)(J,j),G)}async function F(x,J,H){await e.Promises.copyFile(x,J),await e.Promises.chmod(J,H)}async function $(x,J,H){let G=await e.Promises.readlink(x);(0,T.isEqualOrParent)(G,H.root.source,!b.isLinux)&&(G=(0,E.join)(H.root.target,G.substr(H.root.source.length+1))),await e.Promises.symlink(G,J)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(x,J,H,G,z)=>new Promise((j,Y)=>{D.read(x,J,H,G,z,(te,ce,W)=>te?Y(te):j({bytesRead:ce,buffer:W}))})}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(x,J,H,G,z)=>new Promise((j,Y)=>{D.write(x,J,H,G,z,(te,ce,W)=>te?Y(te):j({bytesWritten:ce,buffer:W}))})}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(x){try{return await e.Promises.access(x),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return c}get writeFile(){return n}get rm(){return v}get move(){return A}get copy(){return O}}}),define(ne[133],re([0,1,53,12,4,27,28]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(p){if(R.isLinux)return p;const v=(0,r.dirname)(p);if(p===v)return p;const h=((0,r.basename)(p)||p).toLowerCase();try{const C=(0,T.readdirSync)(v).filter(m=>m.toLowerCase()===h);if(C.length===1){const m=P(v);if(m)return(0,r.join)(m,C[0])}else if(C.length>1){const m=C.indexOf(h);if(m>=0){const g=P(v);if(g)return(0,r.join)(g,C[m])}}}catch{}return null}e.realcaseSync=P;async function E(p){if(R.isLinux)return p;const v=(0,r.dirname)(p);if(p===v)return p;const h=((0,r.basename)(p)||p).toLowerCase();try{const C=(await T.Promises.readdir(v)).filter(m=>m.toLowerCase()===h);if(C.length===1){const m=await E(v);if(m)return(0,r.join)(m,C[0])}else if(C.length>1){const m=C.indexOf(h);if(m>=0){const g=await E(v);if(g)return(0,r.join)(g,C[m])}}}catch{}return null}e.realcase=E;async function b(p){try{return await T.Promises.realpath(p)}catch{const h=w(p);return await T.Promises.access(h,D.constants.R_OK),h}}e.realpath=b;function I(p){try{return D.realpathSync(p)}catch{const h=w(p);return D.accessSync(h,D.constants.R_OK),h}}e.realpathSync=I;function w(p){return(0,L.rtrim)((0,r.normalize)(p),r.sep)}}),define(ne[86],re([0,1,37,12,28]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,T=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var E;(function(d){d[d.x64=0]="x64",d[d.x86=1]="x86",d[d.ARM=2]="ARM"})(E||(E={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class w{constructor(c,i,o){this.exePath=c,this.displayName=i,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:d=!1}={}){return d?b===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:d=!1,findPreview:c=!1}={}){const i=p({useAlternateBitness:d});if(!i)return null;const o=r.join(i,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(o))return null;let t=-1,n=null;for(const l of await R.Promises.readdir(o)){let f=-1;if(c){const A=l.indexOf("-");if(A<0)continue;const O=l.substring(0,A);if(!L.test(O)||l.substring(A+1)!=="preview")continue;f=parseInt(O,10)}else{if(!L.test(l))continue;f=parseInt(l,10)}if(f<=t)continue;const y=r.join(o,l,"pwsh.exe");!await R.SymlinkSupport.existsFile(y)||(n=y,t=f)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",u=c?" Preview":"";return new w(n,`PowerShell${u}${s}`,!0)}async function h({findPreview:d}={}){if(!process.env.LOCALAPPDATA)return null;const c=r.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=d?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(c))if(i.test(t)){const n=r.join(c,t,"pwsh.exe");return new w(n,o)}return null}function S(){const d=r.join(D.homedir(),".dotnet","tools","pwsh.exe");return new w(d,".NET Core PowerShell Global Tool")}function C(){const d=r.join(process.env.windir,b===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(d,"Windows PowerShell",!0)}async function*m(){let d=await v();d&&(yield d),d=await v({useAlternateBitness:!0}),d&&(yield d),d=await h(),d&&(yield d),d=S(),d&&(yield d),d=await v({findPreview:!0}),d&&(yield d),d=await h({findPreview:!0}),d&&(yield d),d=await v({useAlternateBitness:!0,findPreview:!0}),d&&(yield d),d=C(),d&&(yield d)}async function*g(){for await(const d of m())await d.exists()&&(yield d)}e.enumeratePowerShellInstallations=g;async function a(){for await(const d of g())return d;return null}e.getFirstAvailablePowerShellInstallation=a}),define(ne[87],re([0,1,12,4,36,81,15,28]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function E(w=R.env){return w.comspec||"cmd.exe"}e.getWindowsShell=E;function b(w){let p=[],v=!1;const h=function(S){if(v){p.push(S);return}(!w.send(S,m=>{if(m&&console.error(m),v=!1,p.length>0){const g=p.slice(0);p=[],g.forEach(a=>h(a))}})||r.isWindows)&&(v=!0)};return{send:h}}e.createQueuedSender=b;var I;(function(w){async function p(v,h,S){if(D.isAbsolute(v))return v;if(h===void 0&&(h=R.cwd()),D.dirname(v)!=="."||(S===void 0&&T.isString(R.env.PATH)&&(S=R.env.PATH.split(D.delimiter)),S===void 0||S.length===0))return D.join(h,v);async function m(g){if(await P.Promises.exists(g)){let a;try{a=await P.Promises.stat(g)}catch(d){d.message.startsWith("EACCES")&&(a=await P.Promises.lstat(g))}return a?!a.isDirectory():!1}return!1}for(const g of S){let a;if(D.isAbsolute(g)?a=D.join(g,v):a=D.join(h,g,v),await m(a))return a;let d=a+".com";if(await m(d)||(d=a+".exe",await m(d)))return d}return D.join(h,v)}w.findExecutable=p})(I=e.win32||(e.win32={}))}),define(ne[134],re([0,1,54,22]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(T){return new Promise((P,E)=>{let b;const I=new Map;function w(v,h,S,C,m){const g=I.get(h);if(v===T||g){const a={name:p(S),cmd:S,pid:v,ppid:h,load:C,mem:m};I.set(v,a),v===T&&(b=a),g&&(g.children||(g.children=[]),g.children.push(a),g.children.length>1&&(g.children=g.children.sort((d,c)=>d.pid-c.pid)))}}function p(v){const h=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,C=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,a=/--crashes-directory/,d=/\\pipe\\winpty-control/,c=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(a.exec(v))return"electron-crash-reporter";if(d.exec(v))return"winpty-process";if(c.exec(v))return"console-window-host (Windows internal process)";let o=i.exec(v);if(o&&o.length===2){if(o[1]==="renderer")return h.exec(v)?"shared-process":S.exec(v)?"issue-reporter":C.exec(v)?"process-explorer":"window";if(o[1]==="utility"){if(m.exec(v))return"utility-network-service";if(g.exec(v))return"extension-host"}return o[1]}const t=/[a-zA-Z-]+\.js/g;let n="";do o=t.exec(v),o&&(n+=o+" ");while(o);return n&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${n}`:v}if(process.platform==="win32"){const v=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,S)=>{Q(["windows-process-tree"],h,S)}).then(h=>{h.getProcessList(T,S=>{if(!S){E(new Error(`Root process ${T} not found`));return}h.getProcessCpuUsage(S,C=>{const m=new Map;C.forEach(g=>{const a=v(g.commandLine||"");m.set(g.pid,{name:p(a),cmd:a,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),b=m.get(T),b?(m.forEach(g=>{const a=m.get(g.ppid);a&&(a.children||(a.children=[]),a.children.push(g))}),m.forEach(g=>{g.children&&(g.children=g.children.sort((a,d)=>a.pid-d.pid))}),P(b)):E(new Error(`Root process ${T} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let v=function(){let h=[b];const S=[];for(;h.length;){const m=h.shift();m&&(S.push(m.pid),m.children&&(h=h.concat(m.children)))}let C=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);C+=" "+S.join(" "),(0,D.exec)(C,{},(m,g,a)=>{if(m||a)E(m||new Error(a.toString()));else{const d=g.toString().split(`
`);for(let c=0;c<S.length;c++){const i=I.get(S[c]);i.load=parseFloat(d[c])}if(!b){E(new Error(`Root process ${T} not found`));return}P(b)}})};(0,D.exec)("which ps",{},(h,S,C)=>{if(h||C)if(process.platform!=="linux")E(h||new Error(C.toString()));else{const m=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,D.exec)(m,{},(g,a,d)=>{g||d?E(g||new Error(d.toString())):(L(a,w),v())})}else{const m=S.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${m} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(a,d,c)=>{a||c&&!c.includes("screen size is bogus")?E(a||new Error(c.toString())):(L(d,w),process.platform==="linux"?v():b?P(b):E(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=R;function L(T,P){const E=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=T.toString().split(`
`);for(const I of b){const w=E.exec(I.trim());w&&w.length===6&&P(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(ne[135],re([0,1,37,4,86,87]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(v,h){return v===1?r.isWindows?w():L.getWindowsShell(h):b(v,h)}e.getSystemShell=T;function P(v,h){return v===1?r.isWindows?p(h):L.getWindowsShell(h):b(v,h)}e.getSystemShellSync=P;let E=null;function b(v,h){if(r.isLinux&&v===2||r.isMacintosh&&v===3)return"/bin/bash";if(!E){let S;if(r.isWindows)S="/bin/bash";else{if(S=h.SHELL,!S)try{S=(0,D.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}E=S}return E}let I=null;async function w(){return I||(I=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),I}function p(v){if(I)return I;const h=r.isWindows&&parseFloat((0,D.release)())>=10,S=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),C=`${v.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?C:L.getWindowsShell(v)}});var pe=this&&this.__decorate||function(Q,e,D,r){var R=arguments.length,L=R<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,D):r,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(Q,e,D,r);else for(var P=Q.length-1;P>=0;P--)(T=Q[P])&&(L=(R<3?T(L):R>3?T(e,D,L):T(e,D))||L);return R>3&&L&&Object.defineProperty(e,D,L),L};define(ne[39],re([0,1,19,6,16,23,62,9,3,2,65,27,15]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function h(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function C(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(m||(m={}));class g{constructor(j){this.buffer=j,this.pos=0}read(j){const Y=this.buffer.slice(this.pos,this.pos+j);return this.pos+=Y.byteLength,Y}}class a{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}var d;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(d||(d={}));function c(z){const j=R.VSBuffer.alloc(4);return j.writeUInt32BE(z,0),j}function i(z){return z.read(4).readUInt32BE(0)}function o(z){const j=R.VSBuffer.alloc(1);return j.writeUInt8(z,0),j}const t={Undefined:o(d.Undefined),String:o(d.String),Buffer:o(d.Buffer),VSBuffer:o(d.VSBuffer),Array:o(d.Array),Object:o(d.Object)},n=typeof Buffer<"u";function s(z,j){if(typeof j>"u")z.write(t.Undefined);else if(typeof j=="string"){const Y=R.VSBuffer.fromString(j);z.write(t.String),z.write(c(Y.byteLength)),z.write(Y)}else if(n&&Buffer.isBuffer(j)){const Y=R.VSBuffer.wrap(j);z.write(t.Buffer),z.write(c(Y.byteLength)),z.write(Y)}else if(j instanceof R.VSBuffer)z.write(t.VSBuffer),z.write(c(j.byteLength)),z.write(j);else if(Array.isArray(j)){z.write(t.Array),z.write(c(j.length));for(const Y of j)s(z,Y)}else{const Y=R.VSBuffer.fromString(JSON.stringify(j));z.write(t.Object),z.write(c(Y.byteLength)),z.write(Y)}}function u(z){switch(z.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return z.read(i(z)).toString();case d.Buffer:return z.read(i(z)).buffer;case d.VSBuffer:return z.read(i(z));case d.Array:{const Y=i(z),te=[];for(let ce=0;ce<Y;ce++)te.push(u(z));return te}case d.Object:return JSON.parse(z.read(i(z)).toString())}}class l{constructor(j,Y,te=null,ce=1e3){this.protocol=j,this.ctx=Y,this.logger=te,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(j,Y){this.channels.set(j,Y),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const Y=this.send([j.type]);this.logger?.logOutgoing(Y,0,1,C(j.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([j.type,j.id],j.data);this.logger?.logOutgoing(Y,j.id,1,C(j.type),j.data);return}}}send(j,Y=void 0){const te=new a;return s(te,j),s(te,Y),this.sendBuffer(te.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onRawMessage(j){const Y=new g(j),te=u(Y),ce=u(Y),W=te[0];switch(W){case 100:return this.logger?.logIncoming(j.byteLength,te[1],1,`${h(W)}: ${te[2]}.${te[3]}`,ce),this.onPromise({type:W,id:te[1],channelName:te[2],name:te[3],arg:ce});case 102:return this.logger?.logIncoming(j.byteLength,te[1],1,`${h(W)}: ${te[2]}.${te[3]}`,ce),this.onEventListen({type:W,id:te[1],channelName:te[2],name:te[3],arg:ce});case 101:return this.logger?.logIncoming(j.byteLength,te[1],1,`${h(W)}`),this.disposeActiveRequest({type:W,id:te[1]});case 103:return this.logger?.logIncoming(j.byteLength,te[1],1,`${h(W)}`),this.disposeActiveRequest({type:W,id:te[1]})}}onPromise(j){const Y=this.channels.get(j.channelName);if(!Y){this.collectPendingRequest(j);return}const te=new L.CancellationTokenSource;let ce;try{ce=Y.call(this.ctx,j.name,j.arg,te.token)}catch(U){ce=Promise.reject(U)}const W=j.id;ce.then(U=>{this.sendResponse({id:W,data:U,type:201}),this.activeRequests.delete(j.id)},U=>{U instanceof Error?this.sendResponse({id:W,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.sendResponse({id:W,data:U,type:203}),this.activeRequests.delete(j.id)});const V=(0,b.toDisposable)(()=>te.cancel());this.activeRequests.set(j.id,V)}onEventListen(j){const Y=this.channels.get(j.channelName);if(!Y){this.collectPendingRequest(j);return}const te=j.id,W=Y.listen(this.ctx,j.name,j.arg)(V=>this.sendResponse({id:te,data:V,type:204}));this.activeRequests.set(j.id,W)}disposeActiveRequest(j){const Y=this.activeRequests.get(j.id);Y&&(Y.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let Y=this.pendingRequests.get(j.channelName);Y||(Y=[],this.pendingRequests.set(j.channelName,Y));const te=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:j,timeoutTimer:te})}flushPendingRequests(j){const Y=this.pendingRequests.get(j);if(Y){for(const te of Y)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.onPromise(te.request);break;case 102:this.onEventListen(te.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var f;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class y{constructor(j,Y=null){this.protocol=j,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(te=>this.onBuffer(te)),this.logger=Y}getChannel(j){const Y=this;return{call(te,ce,W){return Y.isDisposed?Promise.reject(new P.CancellationError):Y.requestPromise(j,te,ce,W)},listen(te,ce){return Y.isDisposed?E.Event.None:Y.requestEvent(j,te,ce)}}}requestPromise(j,Y,te,ce=L.CancellationToken.None){const W=this.lastRequestId++,U={id:W,type:100,channelName:j,name:Y,arg:te};if(ce.isCancellationRequested)return Promise.reject(new P.CancellationError);let N;return new Promise((B,Z)=>{if(ce.isCancellationRequested)return Z(new P.CancellationError);const oe=()=>{const ue=he=>{switch(he.type){case 201:this.handlers.delete(W),B(he.data);break;case 202:{this.handlers.delete(W);const ve=new Error(he.data.message);ve.stack=he.data.stack,ve.name=he.data.name,Z(ve);break}case 203:this.handlers.delete(W),Z(he.data);break}};this.handlers.set(W,ue),this.sendRequest(U)};let X=null;this.state===m.Idle?oe():(X=(0,r.createCancelablePromise)(ue=>this.whenInitialized()),X.then(()=>{X=null,oe()}));const ie=()=>{X?(X.cancel(),X=null):this.sendRequest({id:W,type:101}),Z(new P.CancellationError)},se=ce.onCancellationRequested(ie);N=(0,b.combinedDisposable)((0,b.toDisposable)(ie),se),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(j,Y,te){const ce=this.lastRequestId++,V={id:ce,type:102,channelName:j,name:Y,arg:te};let U=null;const N=new E.Emitter({onFirstListenerAdd:()=>{U=(0,r.createCancelablePromise)(B=>this.whenInitialized()),U.then(()=>{U=null,this.activeRequests.add(N),this.sendRequest(V)})},onLastListenerRemove:()=>{U?(U.cancel(),U=null):(this.activeRequests.delete(N),this.sendRequest({id:ce,type:103}))}}),q=B=>N.fire(B.data);return this.handlers.set(ce,q),N.event}sendRequest(j){switch(j.type){case 100:case 102:{const Y=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger?.logOutgoing(Y,j.id,0,`${h(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const Y=this.send([j.type,j.id]);this.logger?.logOutgoing(Y,j.id,0,h(j.type));return}}}send(j,Y=void 0){const te=new a;return s(te,j),s(te,Y),this.sendBuffer(te.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onBuffer(j){const Y=new g(j),te=u(Y),ce=u(Y),W=te[0];switch(W){case 200:return this.logger?.logIncoming(j.byteLength,0,0,C(W)),this.onResponse({type:te[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(j.byteLength,te[1],0,C(W),ce),this.onResponse({type:te[0],id:te[1],data:ce})}}onResponse(j){if(j.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get(j.id)?.(j)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}pe([T.memoize],y.prototype,"onDidInitializePromise",null),e.ChannelClient=y;class A{get connections(){const j=[];return this._connections.forEach(Y=>j.push(Y)),j}constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:Y,onDidClientDisconnect:te})=>{E.Event.once(Y.onMessage)(W=>{const V=new g(W),U=u(V),N=new l(Y,U),q=new y(Y);this.channels.forEach((Z,oe)=>N.registerChannel(oe,Z));const B={channelServer:N,channelClient:q,ctx:U};this._connections.add(B),this._onDidAddConnection.fire(B),te(()=>{N.dispose(),q.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)})})})}getChannel(j,Y){const te=this;return{call(ce,W,V){let U;if((0,p.isFunction)(Y)){const q=(0,D.getRandomElement)(te.connections.filter(Y));U=q?Promise.resolve(q):E.Event.toPromise(E.Event.filter(te.onDidAddConnection,Y))}else U=Y.routeCall(te,ce,W);const N=U.then(q=>q.channelClient.getChannel(j));return _(N).call(ce,W,V)},listen(ce,W){if((0,p.isFunction)(Y))return te.getMulticastEvent(j,Y,ce,W);const V=Y.routeEvent(te,ce,W).then(U=>U.channelClient.getChannel(j));return _(V).listen(ce,W)}}}getMulticastEvent(j,Y,te,ce){const W=this;let V=new b.DisposableStore;const U=new E.Emitter({onFirstListenerAdd:()=>{V=new b.DisposableStore;const N=new E.EventMultiplexer,q=new Map,B=oe=>{const ie=oe.channelClient.getChannel(j).listen(te,ce),se=N.add(ie);q.set(oe,se)},Z=oe=>{const X=q.get(oe);!X||(X.dispose(),q.delete(oe))};W.connections.filter(Y).forEach(B),E.Event.filter(W.onDidAddConnection,Y)(B,void 0,V),W.onDidRemoveConnection(Z,void 0,V),N.event(U.fire,U,V),V.add(N)},onLastListenerRemove:()=>{V.dispose()}});return U.event}registerChannel(j,Y){this.channels.set(j,Y),this._connections.forEach(te=>{te.channelServer.registerChannel(j,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class O{constructor(j,Y,te=null){const ce=new a;s(ce,Y),j.send(ce.buffer),this.channelClient=new y(j,te),this.channelServer=new l(j,Y,te)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,Y){this.channelServer.registerChannel(j,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function _(z){return{call(j,Y,te){return z.then(ce=>ce.call(j,Y,te))},listen(j,Y){const te=new E.Relay;return z.then(ce=>te.input=ce.listen(j,Y)),te.event}}}e.getDelayedChannel=_;function M(z){let j=!1;return{call(Y,te,ce){return j?z.call(Y,te,ce):(0,r.timeout)(0).then(()=>j=!0).then(()=>z.call(Y,te,ce))},listen(Y,te){if(j)return z.listen(Y,te);const ce=new E.Relay;return(0,r.timeout)(0).then(()=>j=!0).then(()=>ce.input=z.listen(Y,te)),ce.event}}}e.getNextTickChannel=M;class k{constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const Y of j.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await E.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=k;var F;(function(z){function j(W,V){const U=W,N=V&&V.disableMarshalling,q=new Map;for(const B in U)te(B)&&q.set(B,E.Event.buffer(U[B],!0));return new class{listen(B,Z,oe){const X=q.get(Z);if(X)return X;if(ce(Z)){const ie=U[Z];if(typeof ie=="function")return ie.call(U,oe)}throw new Error(`Event not found: ${Z}`)}call(B,Z,oe){const X=U[Z];if(typeof X=="function"){if(!N&&Array.isArray(oe))for(let ie=0;ie<oe.length;ie++)oe[ie]=(0,I.revive)(oe[ie]);return X.apply(U,oe)}throw new Error(`Method not found: ${Z}`)}}}z.fromService=j;function Y(W,V){const U=V&&V.disableMarshalling;return new Proxy({},{get(N,q){if(typeof q=="string")return V?.properties?.has(q)?V.properties.get(q):ce(q)?function(B){return W.listen(q,B)}:te(q)?W.listen(q):async function(...B){let Z;V&&!(0,p.isUndefinedOrNull)(V.context)?Z=[V.context,...B]:Z=B;const oe=await W.call(q,Z);return U?oe:(0,I.revive)(oe)};throw new Error(`Property not found: ${String(q)}`)}})}z.toService=Y;function te(W){return W[0]==="o"&&W[1]==="n"&&w.isUpperAsciiLetter(W.charCodeAt(2))}function ce(W){return/^onDynamic/.test(W)&&w.isUpperAsciiLetter(W.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const j=z.toString();if(j!=="[object Object]")return j}return z}function J(z){return Array.isArray(z)?z.map(x):x(z)}function H(z,j,Y,te,ce,W,V){V=J(V);const U=$[ce],N=U[te%U.length];let q=[`%c[${z}]%c[${String(j).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(W)?(q=q.concat(V),q.push(")")):q.push(V),console.log.apply(console,q)}e.logWithColors=H;class G{constructor(j,Y){this._outgoingPrefix=j,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,Y,te,ce,W){this._totalOutgoing+=j,H(this._outgoingPrefix,this._totalOutgoing,j,Y,te,ce,W)}logIncoming(j,Y,te,ce,W){this._totalIncoming+=j,H(this._incomingPrefix,this._totalIncoming,j,Y,te,ce,W)}}e.IPCLogger=G}),define(ne[136],re([0,1,16,3,39]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(E){this.port=E,this.onMessage=r.Event.fromDOMEventEmitter(this.port,"message",b=>D.VSBuffer.wrap(b.data)),E.start()}send(E){this.port.postMessage(E.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class T extends R.IPCClient{constructor(E,b){const I=new L(E);super(I,b),this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=T}),define(ne[88],re([0,1,16,3,2,39]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(n){n.enableDiagnostics=!1,n.records=[];const s=new WeakMap;let u=0;function l(y,A){if(!s.has(y)){const O=String(++u);s.set(y,O)}return s.get(y)}function f(y,A,O,_){if(!n.enableDiagnostics)return;const M=l(y,A);if(_ instanceof D.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const k=D.VSBuffer.alloc(_.byteLength);k.set(_),n.records.push({timestamp:Date.now(),id:M,label:A,type:O,buff:k})}else n.records.push({timestamp:Date.now(),id:M,label:A,type:O,data:_})}n.traceSocketEvent=f})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function I(){return b||(b=D.VSBuffer.alloc(0)),b}class w{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,u){if(s===0)return I();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const A=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=s),A}if(this._chunks[0].byteLength>s){const A=this._chunks[0].slice(0,s);return u&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),A}const l=D.VSBuffer.alloc(s);let f=0,y=0;for(;s>0;){const A=this._chunks[y];if(A.byteLength>s){const O=A.slice(0,s);l.set(O,f),f+=s,u&&(this._chunks[y]=A.slice(s),this._totalLength-=s),s-=s}else l.set(A,f),f+=A.byteLength,u?(this._chunks.shift(),this._totalLength-=A.byteLength):y++,s-=A.byteLength}return l}}e.ChunkStream=w;var p;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(p||(p={}));function v(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(s,u,l,f){this.type=s,this.id=u,this.ack=l,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class C extends R.Disposable{constructor(s){super(),this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new w,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:v(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,f=this._state.id,y=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new S(l,f,y,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=D.VSBuffer.alloc(13);u.writeUInt8(s.type,0),u.writeUInt32BE(s.id,1),u.writeUInt32BE(s.ack,5),u.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:v(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(u,s.data)}_bufferAdd(s,u){const l=this._totalLength===0;return this._data.push(s,u),this._totalLength+=s.byteLength+u.byteLength,l}_bufferTake(){const s=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,u){this._bufferAdd(s,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class g extends R.Disposable{constructor(s){super(),this._onMessage=new r.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new C(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new S(1,0,0,s))}}e.Protocol=g;class a extends L.IPCClient{static fromSocket(s,u){return new a(new g(s),u)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,u,l=null){super(s,u,l),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=a;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new r.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class c{constructor(s){this.data=s,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let s=0,u=this._first;for(;u;)u=u.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let u=0,l=this._first;for(;l;)s[u++]=l.data,l=l.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const u=new c(s);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class o{static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let u=0;u<o._HISTORY_LENGTH;u++)this.lastRuns[u]=s-1e3*u;setInterval(()=>{for(let u=o._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),u=(1+o._HISTORY_LENGTH)*1e3;let l=0;for(let f=0;f<o._HISTORY_LENGTH;f++)s-this.lastRuns[f]<=u&&l++;return 1-l/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class t{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s,u=null,l=o.getInstance()){this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),u&&this._socketReader.acceptChunk(u),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new S(5,0,0,I());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new S(7,0,0,I());this._socketWriter.write(s)}sendResume(){const s=new S(8,0,0,I());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,u){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new S(3,0,this._incomingAckId,I());this._socketWriter.write(s);const u=this._outgoingUnackMsg.toArray();for(let l=0,f=u.length;l<f;l++)this._socketWriter.write(u[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new S(6,0,0,I())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let l=0,f=u.length;l<f;l++)this._socketWriter.write(u[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new S(1,u,this._incomingAckId,s);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(s){const u=new S(2,0,0,s);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),u=Date.now()-s.writtenTime,l=Date.now()-this._socketReader.lastReadTime,f=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&l>=2e4&&f>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:l});return}const y=Math.max(2e4-u,2e4-l,2e4-f,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},y)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new S(3,0,this._incomingAckId,I());this._socketWriter.write(s)}_sendKeepAlive(){const s=new S(9,0,0,I());this._socketWriter.write(s)}}e.PersistentProtocol=t}),define(ne[137],re([0,1,89,3,39,136]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends R.IPCServer{static getOnDidClientConnect(){const E=r.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(b,I)=>I);return r.Event.map(E,b=>{const{port1:I,port2:w}=new MessageChannel,v={protocol:new L.Protocol(I),onDidClientDisconnect:r.Event.fromDOMEventEmitter(I,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[w]),v})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(ne[66],re([0,1,54,6,16,23,130,9,3,2,32,87,81,39]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends v.ChannelServer{constructor(m){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",g=>R.VSBuffer.wrap(Buffer.from(g,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.Server=h;class S{constructor(m,g){this.modulePath=m,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const a=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new r.Delayer(a),this.child=null,this._client=null}getChannel(m){const g=this;return{call(a,d,c){return g.requestPromise(m,a,d,c)},listen(a,d){return g.requestEvent(m,a,d)}}}requestPromise(m,g,a,d=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(m),i=(0,r.createCancelablePromise)(n=>c.call(g,a,n)),o=d.onCancellationRequested(()=>i.cancel()),t=(0,b.toDisposable)(()=>i.cancel());return this.activeRequests.add(t),i.finally(()=>{o.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(m,g,a){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let d;const c=new E.Emitter({onFirstListenerAdd:()=>{d=this.getCachedChannel(m).listen(g,a)(c.fire,c),this.activeRequests.add(d)},onLastListenerRemove:()=>{this.activeRequests.delete(d),d.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,p.removeDangerousEnvVariables)(g.env),this.child=(0,D.fork)(this.modulePath,m,g);const a=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,T.isRemoteConsoleLog)(s)){(0,T.log)(s,`IPC Library: ${this.options.serverName}`);return}a.fire(R.VSBuffer.wrap(Buffer.from(s,"base64")))});const c=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,i=s=>this.child&&this.child.connected&&c.send(s.buffer.toString("base64")),o=a.event,t={send:i,onMessage:o};this._client=new v.ChannelClient(t);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,u)=>{process.removeListener("exit",n),this.activeRequests.forEach(l=>(0,b.dispose)(l)),this.activeRequests.clear(),s!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+u),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:u})})}return this._client}getCachedChannel(m){let g=this.channels.get(m);return g||(g=this.client.getChannel(m),this.channels.set(m,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(ne[138],re([0,1,16,9,3,2,12,4,30,39,88]),function(Q,e,D,r,R,L,T,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function w(){return{crypto:Q.__$__nodeRequire("crypto"),zlib:Q.__$__nodeRequire("zlib"),net:Q.__$__nodeRequire("net"),os:Q.__$__nodeRequire("os")}}class p{traceSocketEvent(l,f){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,f)}constructor(l,f=""){this.debugLabel=f,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=y=>{if(this.traceSocketEvent("error",{code:y?.code,message:y?.message}),y){if(y.code==="EPIPE")return;(0,r.onUnexpectedError)(y)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(l){const f=y=>{this.traceSocketEvent("read",y),l(D.VSBuffer.wrap(y))};return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(l){const f=y=>{this.traceSocketEvent("close",{hadError:y}),l({type:0,hadError:y,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(l){const f=()=>{this.traceSocketEvent("nodeEndReceived"),l()};return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(l){if(!this.socket.destroyed)try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,r.onUnexpectedError)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,r.onUnexpectedError)(f)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,f)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const y=()=>{this.socket.off("close",y),this.socket.off("end",y),this.socket.off("error",y),this.socket.off("timeout",y),this.socket.off("drain",y),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",y),this.socket.on("end",y),this.socket.on("error",y),this.socket.on("timeout",y),this.socket.on("drain",y)})}}e.NodeSocket=p;var v;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var h;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(h||(h={}));class S extends L.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(l,f){this.socket.traceSocketEvent(l,f)}constructor(l,f,y,A){super(),this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:f,inflateBytesLength:y?.byteLength||0,recordInflateBytes:A}),this._flowManager=this._register(new C(this,f,y,A,this._onData,(O,_)=>this._write(O,_))),this._register(this._flowManager.onError(O=>{console.error(O),(0,r.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})})),this._incomingData=new I.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){this._flowManager.writeMessage(l)}_write(l,f){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let y=2;l.byteLength<126?y+=0:l.byteLength<2**16?y+=2:y+=8;const A=D.VSBuffer.alloc(y);if(f?A.writeUInt8(194,0):A.writeUInt8(130,0),l.byteLength<126)A.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){A.writeUInt8(126,1);let O=1;A.writeUInt8(l.byteLength>>>8&255,++O),A.writeUInt8(l.byteLength>>>0&255,++O)}else{A.writeUInt8(127,1);let O=1;A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(l.byteLength>>>24&255,++O),A.writeUInt8(l.byteLength>>>16&255,++O),A.writeUInt8(l.byteLength>>>8&255,++O),A.writeUInt8(l.byteLength>>>0&255,++O)}this.socket.write(D.VSBuffer.concat([A,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const f=this._incomingData.peek(this._state.readLen),y=f.readUInt8(0),A=(y&128)>>>7,O=(y&64)>>>6,_=f.readUInt8(1),M=(_&128)>>>7,k=_&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(k===126?2:0)+(k===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const f=this._incomingData.read(this._state.readLen),y=f.readUInt8(1),A=(y&128)>>>7;let O=y&127,_=1;O===126?O=f.readUInt8(++_)*2**8+f.readUInt8(++_):O===127&&(O=f.readUInt8(++_)*0+f.readUInt8(++_)*0+f.readUInt8(++_)*0+f.readUInt8(++_)*0+f.readUInt8(++_)*2**24+f.readUInt8(++_)*2**16+f.readUInt8(++_)*2**8+f.readUInt8(++_));let M=0;A&&(M=f.readUInt8(++_)*2**24+f.readUInt8(++_)*2**16+f.readUInt8(++_)*2**8+f.readUInt8(++_)),this._state.state=3,this._state.readLen=O,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const f=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",f),a(f,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",f),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(f,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class C extends L.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}constructor(l,f,y,A,O,_){super(),this._tracer=l,this._onData=O,this._writeFn=_,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,f?(this._zlibInflateStream=this._register(new m(this._tracer,A,y,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(l){this._writeQueue.push(l),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const l=this._writeQueue.shift();if(this._zlibDeflateStream){const f=await this._deflateMessage(this._zlibDeflateStream,l);this._writeFn(f,!0)}else this._writeFn(l,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(l,f){return new Promise((y,A)=>{l.write(f),l.flush(O=>y(O))})}acceptFrame(l,f,y){this._readQueue.push({data:l,isCompressed:f,isLastFrameOfMessage:y}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const l=this._readQueue.shift();if(this._zlibInflateStream&&l.isCompressed){const f=await this._inflateFrame(this._zlibInflateStream,l.data,l.isLastFrameOfMessage);this._onData.fire(f)}else this._onData.fire(l.data)}this._isProcessingReadQueue=!1}}_inflateFrame(l,f,y){return new Promise((A,O)=>{l.write(f),y&&l.write(D.VSBuffer.fromByteArray([0,0,255,255])),l.flush(_=>A(_))})}}class m extends L.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}constructor(l,f,y,A){super(),this._tracer=l,this._recordInflateBytes=f,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=w().zlib.createInflateRaw(A),this._zlibInflate.on("error",O=>{this._tracer.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibInflate.on("data",O=>{this._tracer.traceSocketEvent("zlibInflateData",O),this._pendingInflateData.push(D.VSBuffer.wrap(O))}),y&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",y.buffer),this._zlibInflate.write(y.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(l){this._recordInflateBytes&&this._recordedInflateBytes.push(l.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",l),this._zlibInflate.write(l.buffer)}flush(l){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const f=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,l(f)})}}class g extends L.Disposable{constructor(l,f){super(),this._tracer=l,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=w().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",y=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:y?.message,code:y?.code}),this._onError.fire(y)}),this._zlibDeflate.on("data",y=>{this._tracer.traceSocketEvent("zlibDeflateData",y),this._pendingDeflateData.push(D.VSBuffer.wrap(y))})}write(l){this._tracer.traceSocketEvent("zlibDeflateWrite",l.buffer),this._zlibDeflate.write(l.buffer)}flush(l){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let f=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,f=f.slice(0,f.byteLength-4),l(f)})}}function a(u,l){if(l===0)return;const f=u.byteLength>>>2;for(let k=0;k<f;k++){const F=u.readUInt32BE(k*4);u.writeUInt32BE(F^l,k*4)}const y=f*4,A=u.byteLength-y,O=l>>>24&255,_=l>>>16&255,M=l>>>8&255;A>=1&&u.writeUInt8(u.readUInt8(y)^O,y),A>=2&&u.writeUInt8(u.readUInt8(y+1)^_,y+1),A>=3&&u.writeUInt8(u.readUInt8(y+2)^M,y+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const d={[2]:107,[1]:103};function c(){const u=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let l;return e.XDG_RUNTIME_DIR?l=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):l=(0,T.join)(w().os.tmpdir(),`vscode-ipc-${u}.sock`),o(l),l}e.createRandomIPCHandle=c;function i(u,l,f){const y=w().crypto.createHash("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${y}-${f}-${l}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${y.substr(0,8)}-${f}-${l}.sock`):A=(0,T.join)(u,`${f}-${l}.sock`),o(A),A}e.createStaticIPCHandle=i;function o(u){const l=d[P.platform];typeof l=="number"&&u.length>=l&&console.warn(`WARNING: IPC handle "${u}" is longer than ${l} chars, try a shorter --user-data-dir`)}class t extends b.IPCServer{static toClientConnectionEvent(l){const f=R.Event.fromNodeEventEmitter(l,"connection");return R.Event.map(f,y=>({protocol:new I.Protocol(new p(y,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(y,"close"))}))}constructor(l){super(t.toClientConnectionEvent(l)),this.server=l}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function n(u){return new Promise((l,f)=>{const y=w().net.createServer();y.on("error",f),y.listen(u,()=>{y.removeListener("error",f),l(new t(y))})})}e.serve=n;function s(u,l){return new Promise((f,y)=>{const A=w().net.createConnection(u,()=>{A.removeListener("error",y),f(I.Client.fromSocket(new p(A,`ipc-client${l}`),l))});A.once("error",y)})}e.connect=s}),define(ne[67],re([0,1,6,3,2,15]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function P(w){const p=w;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var E;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(E=e.StorageState||(e.StorageState={}));class b extends R.Disposable{constructor(p,v=Object.create(null)){super(),this.database=p,this.options=v,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=E.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((v,h)=>this.accept(h,v)),p.deleted?.forEach(v=>this.accept(v,void 0))}accept(p,v){if(this.state===E.Closed)return;let h=!1;(0,L.isUndefinedOrNull)(v)?h=this.cache.delete(p):this.cache.get(p)!==v&&(this.cache.set(p,v),h=!0),h&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===E.None&&(this.state=E.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,v){const h=this.cache.get(p);return(0,L.isUndefinedOrNull)(h)?v:h}getBoolean(p,v){const h=this.get(p);return(0,L.isUndefinedOrNull)(h)?v:h==="true"}getNumber(p,v){const h=this.get(p);return(0,L.isUndefinedOrNull)(h)?v:parseInt(h,10)}async set(p,v){if(this.state===E.Closed)return;if((0,L.isUndefinedOrNull)(v))return this.delete(p);const h=String(v);if(this.cache.get(p)!==h)return this.cache.set(p,h),this.pendingInserts.set(p,h),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async delete(p){if(!(this.state===E.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=E.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(p){if(!!this.hasPending)return this.doFlush(p)}async doFlush(p){return this.flushDelayer.trigger(()=>this.flushPending(),p)}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert?.forEach((v,h)=>this.items.set(h,v)),p.delete?.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=I}),define(ne[139],re([10,11]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(ne[140],re([10,11]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[141],re([10,11]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(ne[142],re([10,11]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(ne[143],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[144],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[145],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[146],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[147],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[148],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[149],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[150],re([10,11]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[151],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(ne[152],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ne[153],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(ne[154],re([10,11]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[155],re([10,11]),function(Q,e){return Q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[156],re([10,11]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(ne[157],re([10,11]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(ne[158],re([10,11]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[159],re([10,11]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[160],re([10,11]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ne[161],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[162],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[163],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[164],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[165],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[166],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[167],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[168],re([10,11]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(ne[90],re([0,1,63,62,22,12,36,17,7]),function(Q,e,D,r,R,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{get appRoot(){return(0,L.dirname)(R.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return E.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return E.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return E.URI.file(this.paths.tmpDir)}get cacheHome(){return E.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return E.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return E.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(E.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=T.env.VSCODE_PORTABLE;return S?E.URI.file((0,L.join)(S,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return E.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,L.resolve)(S):(0,L.normalize)((0,L.join)(R.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,L.resolve)(S):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,L.resolve)(S);const C=T.env.VSCODE_EXTENSIONS;if(C)return C;const m=T.env.VSCODE_PORTABLE;return m?(0,L.join)(m,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(C=>/^[^:/?#]+?:\/\//.test(C)?E.URI.parse(C):E.URI.file((0,L.normalize)(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?E.URI.parse(S):E.URI.file((0,L.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(E.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return E.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return E.URI.file((0,L.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=T.env.VSCODE_PORTABLE;return S?E.URI.file((0,L.join)(S,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}constructor(S,C,m){this._args=S,this.paths=C,this.productService=m,this.editSessionId=this.args.editSessionId}}pe([r.memoize],b.prototype,"appRoot",null),pe([r.memoize],b.prototype,"userHome",null),pe([r.memoize],b.prototype,"userDataPath",null),pe([r.memoize],b.prototype,"appSettingsHome",null),pe([r.memoize],b.prototype,"tmpDir",null),pe([r.memoize],b.prototype,"cacheHome",null),pe([r.memoize],b.prototype,"stateResource",null),pe([r.memoize],b.prototype,"userRoamingDataHome",null),pe([r.memoize],b.prototype,"userDataSyncHome",null),pe([r.memoize],b.prototype,"userDataSyncLogResource",null),pe([r.memoize],b.prototype,"editSessionsLogResource",null),pe([r.memoize],b.prototype,"sync",null),pe([r.memoize],b.prototype,"machineSettingsResource",null),pe([r.memoize],b.prototype,"workspaceStorageHome",null),pe([r.memoize],b.prototype,"localHistoryHome",null),pe([r.memoize],b.prototype,"keyboardLayoutResource",null),pe([r.memoize],b.prototype,"argvResource",null),pe([r.memoize],b.prototype,"isExtensionDevelopment",null),pe([r.memoize],b.prototype,"untitledWorkspacesHome",null),pe([r.memoize],b.prototype,"installSourcePath",null),pe([r.memoize],b.prototype,"builtinExtensionsPath",null),pe([r.memoize],b.prototype,"extensionsPath",null),pe([r.memoize],b.prototype,"extensionDevelopmentLocationURI",null),pe([r.memoize],b.prototype,"extensionDevelopmentKind",null),pe([r.memoize],b.prototype,"extensionTestsLocationURI",null),pe([r.memoize],b.prototype,"debugExtensionHost",null),pe([r.memoize],b.prototype,"serviceMachineIdResource",null),pe([r.memoize],b.prototype,"telemetryLogResource",null),pe([r.memoize],b.prototype,"disableWorkspaceTrust",null),pe([r.memoize],b.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=b;function I(h,S){return v(h["inspect-extensions"],h["inspect-brk-extensions"],5870,S,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=I;function w(h,S){return v(h["inspect-search"],h["inspect-brk-search"],5876,S,h.extensionEnvironment)}e.parseSearchPort=w;function p(h,S){return v(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,S,h.extensionEnvironment)}e.parsePtyHostPort=p;function v(h,S,C,m,g,a){const c=Number(S||h)||(m?null:C),i=c?Boolean(!!S):!1;let o;if(a)try{o=JSON.parse(a)}catch{}return{port:c,break:i,debugId:g,env:o}}}),define(ne[169],re([0,1,275,4,141]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,R.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,R.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,R.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(16,null)},category:{type:"string",cat:"e",description:(0,R.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,R.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,R.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,R.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,R.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,R.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,R.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,R.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(h,S,C=T){const m={},g=["_"],a=[];for(const o in S){const t=S[o];t.alias&&(m[o]=t.alias),t.type==="string"||t.type==="string[]"?(g.push(o),t.deprecates&&g.push(...t.deprecates)):t.type==="boolean"&&(a.push(o),t.deprecates&&a.push(...t.deprecates))}const d=D(h,{string:g,boolean:a,alias:m}),c={},i=d;c._=d._.map(o=>String(o)).filter(o=>o.length>0),delete i._;for(const o in S){const t=S[o];t.alias&&delete i[t.alias];let n=i[o];if(t.deprecates)for(const s of t.deprecates)i.hasOwnProperty(s)&&(n||(n=i[s],n&&C.onDeprecatedOption(s,t.deprecationMessage||(0,R.localize)(35,null,o))),delete i[s]);if(typeof n<"u"){if(t.type==="string[]"){if(Array.isArray(n)||(n=[n]),!t.allowEmptyValue){const s=n.filter(u=>u.length>0);s.length!==n.length&&(C.onEmptyValue(o),n=s.length>0?s:void 0)}}else t.type==="string"&&(Array.isArray(n)?(n=n.pop(),C.onMultipleValues(o,n)):!n&&!t.allowEmptyValue&&(C.onEmptyValue(o),n=void 0));c[o]=n,t.deprecationMessage&&C.onDeprecatedOption(o,t.deprecationMessage)}delete i[o]}for(const o in i)C.onUnknownOption(o);return c}e.parseArgs=P;function E(h,S){let C="";return S.args&&(Array.isArray(S.args)?C=` <${S.args.join("> <")}>`:C=` <${S.args}>`),S.alias?`-${S.alias} --${h}${C}`:`--${h}${C}`}function b(h,S){let C=0;const m=[];for(const c in h){const i=h[c],o=E(c,i);C=Math.max(C,o.length),m.push([o,i.description])}const g=C+2+1;if(S-g<25)return m.reduce((c,i)=>c.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const a=S-g-1,d=[];for(const c of m){const i=c[0],o=w(c[1],a),t=I(g-i.length-2);d.push("  "+i+t+o[0]);for(let n=1;n<o.length;n++)d.push(I(g)+o[n])}return d}e.formatOptions=b;function I(h){return" ".repeat(h)}function w(h,S){const C=[];for(;h.length;){const m=h.length<S?h.length:h.lastIndexOf(" ",S),g=h.slice(0,m).trim();h=h.slice(m),C.push(g)}return C}function p(h,S,C,m,g){const a=process.stdout.isTTY&&process.stdout.columns||80,d=g?.noInputFiles!==!0?`[${(0,R.localize)(36,null)}...]`:"",c=[`${h} ${C}`];c.push(""),c.push(`${(0,R.localize)(37,null)}: ${S} [${(0,R.localize)(38,null)}]${d}`),c.push(""),g?.noPipe!==!0&&(r.isWindows?c.push((0,R.localize)(39,null,S)):c.push((0,R.localize)(40,null,S)),c.push(""));const i={};for(const o in m){const t=m[o];if(t.description&&t.cat){let n=i[t.cat];n||(i[t.cat]=n={}),n[o]=t}}for(const o in i){const t=o,n=i[t];n&&(c.push(L[t]),c.push(...b(n,a)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=p;function v(h,S){return`${h||(0,R.localize)(41,null)}
${S||(0,R.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=v}),define(ne[170],re([0,1,276,142,169]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function T(p,v){const h={onUnknownOption:C=>{console.warn((0,r.localize)(0,null,C))},onMultipleValues:(C,m)=>{console.warn((0,r.localize)(1,null,C,m))},onEmptyValue:C=>{console.warn((0,r.localize)(2,null,C))},onDeprecatedOption:(C,m)=>{console.warn((0,r.localize)(3,null,C,m))}},S=(0,R.parseArgs)(p,R.OPTIONS,v?h:void 0);return S.goto&&S._.forEach(C=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(C),(0,r.localize)(4,null))),S["max-memory"]&&D(parseInt(S["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),S}function P(p){const v=p.findIndex(h=>!/^-/.test(h));if(v>-1)return[...p.slice(0,v),...p.slice(v+1)]}function E(p){let[,...v]=p;process.env.VSCODE_DEV&&(v=P(v)||[]);const h=!w(process.env);return T(v,h)}e.parseMainProcessArgv=E;function b(p){const[,,...v]=p;return T(v,!0)}e.parseCLIProcessArgv=b;function I(p,...v){const h=p.indexOf("--");return h===-1?p.push(...v):p.splice(h,0,...v),p}e.addArg=I;function w(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),function(){"use strict";function Q(e,D,r,R){function L(P){const E=T(P),b=[E];return e.isAbsolute(E)||b.unshift(R),e.resolve(...b)}function T(P){process.env.VSCODE_DEV&&(r="code-oss-dev");const E=process.env.VSCODE_PORTABLE;if(E)return e.join(E,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,r);const I=P["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(w,"AppData","Roaming")}break;case"darwin":b=e.join(D.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,r)}return{getUserDataPath:L}}if(typeof define=="function")define(ne[171],re([0,277,37,22,17,36]),function(e,D,r,R,L,T){const P=L.dirname(R.FileAccess.asFileUri("",e)),E=e.__$__nodeRequire(L.joinPath(P,"package.json").fsPath);return Q(D,r,E.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),r=require("os");module.exports=Q(D,r,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[172],re([0,1,37,90,171]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends r.AbstractNativeEnvironmentService{constructor(P,E){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P)},E)}}e.NativeEnvironmentService=L}),define(ne[173],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const r=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,E=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(C){const m=C.match(T);return m?m[1]:null}function I(C){if(C.indexOf("://")===-1){const m=C.match(r);return m?b(m[2]):null}try{const m=D.URI.parse(C);if(m.authority)return b(m.authority)}catch{}return null}function w(C,m){const g=new Set;let a;for(;a=P.exec(C);){const c=I(a[1]);c&&g.add(c)}const d=new Set(m);return Array.from(g).map(c=>d.has(c)?c:c.replace(E,"a"))}e.getDomainsOfRemotes=w;function p(C){const m=C.match(L);return m?m[2]:null}function v(C,m,g){return C&&m?(g&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${C}${m}`:`${C}/${m}`):null}function h(C,m){if(C.indexOf("://")===-1){const g=C.match(R);if(g)return v(g[2],g[3],m)}try{const g=D.URI.parse(C);if(g.authority)return v(p(g.authority),g.path,m)}catch{}return null}function S(C,m=!1){const g=[];let a;for(;a=P.exec(C);){const d=h(a[1],m);d&&g.push(d)}return g}e.getRemotes=S}),define(ne[174],re([0,1,15,145]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function R(T,P,E){try{L(T,P,E)}catch{}return T}e.localizeManifest=R;function L(T,P,E){const b=(I,w,p)=>{const v=I[w];if((0,D.isString)(v)){const h=v,S=h.length;if(S>1&&h[0]==="%"&&h[S-1]==="%"){const C=h.substr(1,S-2);let m=P[C];m===void 0&&E&&(m=E[C]);const g=typeof m=="string"?m:m.message;if(g!==void 0){const a=E?.[C],d=typeof a=="string"?a:a?.message;if(p&&(w==="title"||w==="category")&&d&&d!==g){const c={value:g,original:d};I[w]=c}else I[w]=g}else console.warn(`[${T.name}]: ${(0,r.localize)(0,null,C)}`)}}else if((0,D.isObject)(v))for(const h in v)v.hasOwnProperty(h)&&(h==="commands"?b(v,h,!0):b(v,h,p));else if(Array.isArray(v))for(let h=0;h<v.length;h++)b(v,h,p)};for(const I in T)T.hasOwnProperty(I)&&b(T,I)}}),define(ne[175],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,T,P,E){return this.channel.call("promptImportantExtensionsInstallNotification",[L,T,P,E])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class r{constructor(L){this.service=L}listen(L,T){throw new Error(`Event not found: ${T}`)}call(L,T,P){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=r}),define(ne[68],re([0,1,17,84,150,55]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function E(m){return m=m.trim(),m==="*"||T.test(m)}e.isValidVersionStr=E;function b(m){if(!E(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=m.match(T);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=b;function I(m){if(!m)return null;const g=m.majorBase,a=m.majorMustEqual,d=m.minorBase;let c=m.minorMustEqual;const i=m.patchBase;let o=m.patchMustEqual;m.hasCaret&&(g===0||(c=!1),o=!1);let t=0;if(m.preRelease){const n=P.exec(m.preRelease);if(n){const[,s,u,l]=n;t=Date.UTC(Number(s),Number(u)-1,Number(l))}}return{majorBase:g,majorMustEqual:a,minorBase:d,minorMustEqual:c,patchBase:i,patchMustEqual:o,isMinimum:m.hasGreaterEquals,notBefore:t}}e.normalizeVersion=I;function w(m,g,a){let d;typeof m=="string"?d=I(b(m)):d=m;let c;g instanceof Date?c=g.getTime():typeof g=="string"&&(c=new Date(g).getTime());let i;if(typeof a=="string"?i=I(b(a)):i=a,!d||!i)return!1;const o=d.majorBase,t=d.minorBase,n=d.patchBase;let s=i.majorBase,u=i.minorBase,l=i.patchBase;const f=i.notBefore;let y=i.majorMustEqual,A=i.minorMustEqual,O=i.patchMustEqual;return i.isMinimum?o>s?!0:o<s?!1:t>u?!0:t<u||c&&c<f?!1:n>=l:(o===1&&s===0&&(!y||!A||!O)&&(s=1,u=0,l=0,y=!0,A=!1,O=!1),o<s?!1:o>s?!y:t<u?!1:t>u?!A:n<l?!1:n>l?!O:!(c&&c<f))}e.isValidVersion=w;function p(m,g,a,d,c){const i=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return i.push([r.default.Error,R.localize(0,null)]),i;if(typeof d.name!="string")return i.push([r.default.Error,R.localize(1,null,"name")]),i;if(typeof d.version!="string")return i.push([r.default.Error,R.localize(2,null,"version")]),i;if(!d.engines)return i.push([r.default.Error,R.localize(3,null,"engines")]),i;if(typeof d.engines.vscode!="string")return i.push([r.default.Error,R.localize(4,null,"engines.vscode")]),i;if(typeof d.extensionDependencies<"u"&&!C(d.extensionDependencies))return i.push([r.default.Error,R.localize(5,null,"extensionDependencies")]),i;if(typeof d.activationEvents<"u"){if(!C(d.activationEvents))return i.push([r.default.Error,R.localize(6,null,"activationEvents")]),i;if(typeof d.main>"u"&&typeof d.browser>"u")return i.push([r.default.Error,R.localize(7,null,"activationEvents","main")]),i}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&i.push([r.default.Warning,R.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return i.push([r.default.Error,R.localize(9,null,"main")]),i;{const n=(0,D.joinPath)(a,d.main);(0,D.isEqualOrParent)(n,a)||i.push([r.default.Warning,R.localize(10,null,n.path,a.path)])}if(typeof d.activationEvents>"u")return i.push([r.default.Error,R.localize(11,null,"activationEvents","main")]),i}if(typeof d.browser<"u"){if(typeof d.browser!="string")return i.push([r.default.Error,R.localize(12,null,"browser")]),i;{const n=(0,D.joinPath)(a,d.browser);(0,D.isEqualOrParent)(n,a)||i.push([r.default.Warning,R.localize(13,null,n.path,a.path)])}if(typeof d.activationEvents>"u")return i.push([r.default.Error,R.localize(14,null,"activationEvents","browser")]),i}if(!L.valid(d.version))return i.push([r.default.Error,R.localize(15,null)]),i;const o=[];if(!v(m,g,d,c,o))for(const n of o)i.push([r.default.Error,n]);return i}e.validateExtensionManifest=p;function v(m,g,a,d,c){return d||typeof a.main>"u"&&typeof a.browser>"u"?!0:S(m,g,a.engines.vscode,c)}e.isValidExtensionVersion=v;function h(m,g,a){return m==="*"||S(g,a,m)}e.isEngineValid=h;function S(m,g,a,d=[]){const c=I(b(a));if(!c)return d.push(R.localize(16,null,a)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return d.push(R.localize(17,null,a)),!1}else if(!c.majorMustEqual)return d.push(R.localize(18,null,a)),!1;return w(m,g,c)?!0:(d.push(R.localize(19,null,m,a)),!1)}function C(m){if(!Array.isArray(m))return!1;for(let g=0,a=m.length;g<a;g++)if(typeof m[g]!="string")return!1;return!0}}),define(ne[48],re([0,1,16,30]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(L,T,P){let E=P&&P.get("storage.serviceMachineId",-1)||null;if(E)return E;try{const I=(await T.readFile(L.serviceMachineIdResource)).value.toString();E=(0,r.isUUID)(I)?I:null}catch{E=null}if(!E){E=(0,r.generateUuid)();try{await T.writeFile(L.serviceMachineIdResource,D.VSBuffer.fromString(E))}catch{}}return P?.store("storage.serviceMachineId",E,-1,1),E}e.getServiceMachineId=R}),define(ne[56],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,L=[],T=!1){this.ctor=R,this.staticArguments=L,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=D}),define(ne[91],re([0,1,56]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const r=[];var R;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(R=e.InstantiationType||(e.InstantiationType={}));function L(P,E,b){E instanceof D.SyncDescriptor||(E=new D.SyncDescriptor(E,[],Boolean(b))),r.push([P,E])}e.registerSingleton=L;function T(){return r}e.getSingletonServiceDescriptors=T}),define(ne[176],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(L,T){this.key=L,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=D;class r{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const T of this._nodes.values())T.outgoing.size===0&&L.push(T);return L}insertEdge(L,T){const P=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(T);P.outgoing.set(E.key,E),E.incoming.set(P.key,P)}removeNode(L){const T=this._hashFn(L);this._nodes.delete(T);for(const P of this._nodes.values())P.outgoing.delete(T),P.incoming.delete(T)}lookupOrInsertNode(L){const T=this._hashFn(L);let P=this._nodes.get(T);return P||(P=new D(T,L),this._nodes.set(T,P)),P}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[T,P]of this._nodes)L.push(`${T}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,T]of this._nodes){const P=new Set([L]),E=this._findCycle(T,P);if(E)return E}}_findCycle(L,T){for(const[P,E]of L.outgoing){if(T.has(P))return[...T,P].join(" -> ");T.add(P);const b=this._findCycle(E,T);if(b)return b;T.delete(P)}}}e.Graph=r}),define(ne[5],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function P(E){return E[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=P})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function r(T,P,E){P[D.DI_TARGET]===P?P[D.DI_DEPENDENCIES].push({id:T,index:E}):(P[D.DI_DEPENDENCIES]=[{id:T,index:E}],P[D.DI_TARGET]=P)}function R(T){if(D.serviceIds.has(T))return D.serviceIds.get(T);const P=function(E,b,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(P,E,I)};return P.toString=()=>T,D.serviceIds.set(T,P),P}e.createDecorator=R;function L(T){return T}e.refineServiceDecorator=L}),define(ne[177],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(ne[18],re([0,1,15,7,5]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function L(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof r.URI)}e.isConfigurationOverrides=L;function T(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof r.URI)}e.isConfigurationUpdateOverrides=T;var P;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function b(m,g){const a=Object.create(null);for(const d in m)I(a,d,m[d],g);return a}e.toValuesTree=b;function I(m,g,a,d){const c=g.split("."),i=c.pop();let o=m;for(let t=0;t<c.length;t++){const n=c[t];let s=o[n];switch(typeof s){case"undefined":s=o[n]=Object.create(null);break;case"object":break;default:d(`Ignoring ${g} as ${c.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[i]=a}catch{d(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(o)}`)}else d(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=I;function w(m,g){const a=g.split(".");p(m,a)}e.removeFromValueTree=w;function p(m,g){const a=g.shift();if(g.length===0){delete m[a];return}if(Object.keys(m).indexOf(a)!==-1){const d=m[a];typeof d=="object"&&!Array.isArray(d)&&(p(d,g),Object.keys(d).length===0&&delete m[a])}}function v(m,g,a){function d(o,t){let n=o;for(const s of t){if(typeof n!="object"||n===null)return;n=n[s]}return n}const c=g.split("."),i=d(m,c);return typeof i>"u"?a:i}e.getConfigurationValue=v;function h(m,g,a){Object.keys(g).forEach(d=>{d!=="__proto__"&&(d in m?D.isObject(m[d])&&D.isObject(g[d])?h(m[d],g[d],a):a&&(m[d]=g[d]):m[d]=g[d])})}e.merge=h;function S(m,g,a){const d=m.inspect(g),c=m.inspect(a);return typeof d.userValue<"u"||typeof d.workspaceValue<"u"||typeof d.workspaceFolderValue<"u"?d.value:typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:d.defaultValue}e.getMigratedSettingValue=S;function C(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=C}),define(ne[178],re([0,1,4,27,5]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",D.isMacintosh),L.set("isLinux",D.isLinux),L.set("isWindows",D.isWindows),L.set("isWeb",D.isWeb),L.set("isMacNative",D.isMacintosh&&!D.isWeb),L.set("isEdge",D.isEdge),L.set("isFirefox",D.isFirefox),L.set("isChrome",D.isChrome),L.set("isSafari",D.isSafari);const T=Object.prototype.hasOwnProperty;var P;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return w.INSTANCE}static true(){return p.INSTANCE}static has(k){return v.create(k)}static equals(k,F){return h.create(k,F)}static notEquals(k,F){return m.create(k,F)}static regex(k,F){return t.create(k,F)}static in(k,F){return S.create(k,F)}static notIn(k,F){return C.create(k,F)}static not(k){return g.create(k)}static and(...k){return u.create(k,null)}static or(...k){return l.create(k,null,!0)}static greater(k,F){return d.create(k,F)}static greaterEquals(k,F){return c.create(k,F)}static smaller(k,F){return i.create(k,F)}static smallerEquals(k,F){return o.create(k,F)}static deserialize(k,F=!1){if(!!k)return this._deserializeOrExpression(k,F)}static _deserializeOrExpression(k,F){const $=k.split("||");return l.create($.map(x=>this._deserializeAndExpression(x,F)),null,!0)}static _deserializeAndExpression(k,F){const $=k.split("&&");return u.create($.map(x=>this._deserializeOne(x,F)),null)}static _deserializeOne(k,F){if(k=k.trim(),k.indexOf("!=")>=0){const $=k.split("!=");return m.create($[0].trim(),this._deserializeValue($[1],F))}if(k.indexOf("==")>=0){const $=k.split("==");return h.create($[0].trim(),this._deserializeValue($[1],F))}if(k.indexOf("=~")>=0){const $=k.split("=~");return t.create($[0].trim(),this._deserializeRegexValue($[1],F))}if(k.indexOf(" not in ")>=0){const $=k.split(" not in ");return C.create($[0].trim(),$[1].trim())}if(k.indexOf(" in ")>=0){const $=k.split(" in ");return S.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const $=k.split(">=");return c.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const $=k.split(">");return d.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const $=k.split("<=");return o.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const $=k.split("<");return i.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(k)?g.create(k.substr(1).trim()):v.create(k)}static _deserializeValue(k,F){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;const $=/^'([^']*)'$/.exec(k);return $?$[1].trim():k}static _deserializeRegexValue(k,F){if((0,r.isFalsyOrWhitespace)(k)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=k.indexOf("/"),x=k.lastIndexOf("/");if($===x||$<0){if(F)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}const J=k.slice($+1,x),H=k[x+1]==="i"?"i":"";try{return new RegExp(J,H)}catch(G){if(F)throw new Error(`bad regexp-value '${k}', parse error: ${G}`);return console.warn(`bad regexp-value '${k}', parse error: ${G}`),null}}}e.ContextKeyExpr=E;function b(M,k){const F=M?M.substituteConstants():void 0,$=k?k.substituteConstants():void 0;return!F&&!$?!0:!F||!$?!1:F.equals($)}e.expressionsAreEqualWithConstantSubstitution=b;function I(M,k){return M.cmp(k)}class w{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class p{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class v{static create(k,F=null){const $=L.get(k);return typeof $=="boolean"?$?p.INSTANCE:w.INSTANCE:new v(k,F)}constructor(k,F){this.key=k,this.negated=F,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:y(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=L.get(this.key);return typeof k=="boolean"?k?p.INSTANCE:w.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=v;class h{static create(k,F,$=null){if(typeof F=="boolean")return F?v.create(k,$):g.create(k,$);const x=L.get(k);return typeof x=="boolean"?F===(x?"true":"false")?p.INSTANCE:w.INSTANCE:new h(k,F,$)}constructor(k,F,$){this.key=k,this.value=F,this.negated=$,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=L.get(this.key);if(typeof k=="boolean"){const F=k?"true":"false";return this.value===F?p.INSTANCE:w.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class S{static create(k,F){return new S(k,F)}constructor(k,F){this.key=k,this.valueKey=F,this.type=10,this.negated=null}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const F=k.getValue(this.valueKey),$=k.getValue(this.key);return Array.isArray(F)?F.includes($):typeof $=="string"&&typeof F=="object"&&F!==null?T.call(F,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=C.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=S;class C{static create(k,F){return new C(k,F)}constructor(k,F){this.key=k,this.valueKey=F,this.type=11,this._negated=S.create(k,F)}cmp(k){return k.type!==this.type?this.type-k.type:this._negated.cmp(k._negated)}equals(k){return k.type===this.type?this._negated.equals(k._negated):!1}substituteConstants(){return this}evaluate(k){return!this._negated.evaluate(k)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(k){return k.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=C;class m{static create(k,F,$=null){if(typeof F=="boolean")return F?g.create(k,$):v.create(k,$);const x=L.get(k);return typeof x=="boolean"?F===(x?"true":"false")?w.INSTANCE:p.INSTANCE:new m(k,F,$)}constructor(k,F,$){this.key=k,this.value=F,this.negated=$,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=L.get(this.key);if(typeof k=="boolean"){const F=k?"true":"false";return this.value===F?w.INSTANCE:p.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class g{static create(k,F=null){const $=L.get(k);return typeof $=="boolean"?$?w.INSTANCE:p.INSTANCE:new g(k,F)}constructor(k,F){this.key=k,this.negated=F,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:y(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=L.get(this.key);return typeof k=="boolean"?k?w.INSTANCE:p.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function a(M,k){if(typeof M=="string"){const F=parseFloat(M);isNaN(F)||(M=F)}return typeof M=="string"||typeof M=="number"?k(M):w.INSTANCE}class d{static create(k,F,$=null){return a(F,x=>new d(k,x,$))}constructor(k,F,$){this.key=k,this.value=F,this.negated=$,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=d;class c{static create(k,F,$=null){return a(F,x=>new c(k,x,$))}constructor(k,F,$){this.key=k,this.value=F,this.negated=$,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class i{static create(k,F,$=null){return a(F,x=>new i(k,x,$))}constructor(k,F,$){this.key=k,this.value=F,this.negated=$,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class o{static create(k,F,$=null){return a(F,x=>new o(k,x,$))}constructor(k,F,$){this.key=k,this.value=F,this.negated=$,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class t{static create(k,F){return new t(k,F)}constructor(k,F){this.key=k,this.regexp=F,this.type=7,this.negated=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const F=this.regexp?this.regexp.source:"",$=k.regexp?k.regexp.source:"";return F<$?-1:F>$?1:0}equals(k){if(k.type===this.type){const F=this.regexp?this.regexp.source:"",$=k.regexp?k.regexp.source:"";return this.key===k.key&&F===$}return!1}substituteConstants(){return this}evaluate(k){const F=k.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class n{static create(k){return new n(k)}constructor(k){this._actual=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new n(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function s(M){let k=null;for(let F=0,$=M.length;F<$;F++){const x=M[F].substituteConstants();if(M[F]!==x&&k===null){k=[];for(let J=0;J<F;J++)k[J]=M[J]}k!==null&&(k[F]=x)}return k===null?M:k}class u{static create(k,F){return u._normalizeArr(k,F)}constructor(k,F){this.expr=k,this.negated=F,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let F=0,$=this.expr.length;F<$;F++){const x=I(this.expr[F],k.expr[F]);if(x!==0)return x}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let F=0,$=this.expr.length;F<$;F++)if(!this.expr[F].equals(k.expr[F]))return!1;return!0}return!1}substituteConstants(){const k=s(this.expr);return k===this.expr?this:u.create(k,this.negated)}evaluate(k){for(let F=0,$=this.expr.length;F<$;F++)if(!this.expr[F].evaluate(k))return!1;return!0}static _normalizeArr(k,F){const $=[];let x=!1;for(const J of k)if(!!J){if(J.type===1){x=!0;continue}if(J.type===0)return w.INSTANCE;if(J.type===6){$.push(...J.expr);continue}$.push(J)}if($.length===0&&x)return p.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(I);for(let J=1;J<$.length;J++)$[J-1].equals($[J])&&($.splice(J,1),J--);if($.length===1)return $[0];for(;$.length>1;){const J=$[$.length-1];if(J.type!==9)break;$.pop();const H=$.pop(),G=$.length===0,z=l.create(J.expr.map(j=>u.create([j,H],null)),null,G);z&&($.push(z),$.sort(I))}return $.length===1?$[0]:new u($,F)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const F of this.expr)k.push(...F.keys());return k}map(k){return new u(this.expr.map(F=>F.map(k)),null)}negate(){if(!this.negated){const k=[];for(const F of this.expr)k.push(F.negate());this.negated=l.create(k,this,!0)}return this.negated}}class l{static create(k,F,$){return l._normalizeArr(k,F,$)}constructor(k,F){this.expr=k,this.negated=F,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let F=0,$=this.expr.length;F<$;F++){const x=I(this.expr[F],k.expr[F]);if(x!==0)return x}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let F=0,$=this.expr.length;F<$;F++)if(!this.expr[F].equals(k.expr[F]))return!1;return!0}return!1}substituteConstants(){const k=s(this.expr);return k===this.expr?this:l.create(k,this.negated,!1)}evaluate(k){for(let F=0,$=this.expr.length;F<$;F++)if(this.expr[F].evaluate(k))return!0;return!1}static _normalizeArr(k,F,$){let x=[],J=!1;if(k){for(let H=0,G=k.length;H<G;H++){const z=k[H];if(!!z){if(z.type===0){J=!0;continue}if(z.type===1)return p.INSTANCE;if(z.type===9){x=x.concat(z.expr);continue}x.push(z)}}if(x.length===0&&J)return w.INSTANCE;x.sort(I)}if(x.length!==0){if(x.length===1)return x[0];for(let H=1;H<x.length;H++)x[H-1].equals(x[H])&&(x.splice(H,1),H--);if(x.length===1)return x[0];if($){for(let H=0;H<x.length;H++)for(let G=H+1;G<x.length;G++)O(x[H],x[G])&&(x.splice(G,1),G--);if(x.length===1)return x[0]}return new l(x,F)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const F of this.expr)k.push(...F.keys());return k}map(k){return new l(this.expr.map(F=>F.map(k)),null)}negate(){if(!this.negated){const k=[];for(const F of this.expr)k.push(F.negate());for(;k.length>1;){const F=k.shift(),$=k.shift(),x=[];for(const H of _(F))for(const G of _($))x.push(u.create([H,G],null));const J=k.length===0;k.unshift(l.create(x,null,J))}this.negated=k[0]}return this.negated}}class f extends v{static all(){return f._info.values()}constructor(k,F,$){super(k,null),this._defaultValue=F,typeof $=="object"?f._info.push({...$,key:k}):$!==!0&&f._info.push({key:k,description:$,type:F!=null?typeof F:void 0})}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return h.create(this.key,k)}notEqualsTo(k){return m.create(this.key,k)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function y(M,k){return M<k?-1:M>k?1:0}function A(M,k,F,$){return M<F?-1:M>F?1:k<$?-1:k>$?1:0}function O(M,k){if(k.type===6&&M.type!==9&&M.type!==6){for(const x of k.expr)if(M.equals(x))return!0}const F=M.negate(),$=_(F).concat(_(k));$.sort(I);for(let x=0;x<$.length;x++){const H=$[x].negate();for(let G=x+1;G<$.length;G++){const z=$[G];if(H.equals(z))return!0}}return!1}e.implies=O;function _(M){return M.type===9?M.expr:[M]}}),define(ne[92],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function r(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=r;class R{async getPerformanceInfo(T,P){return{}}async getSystemInfo(T,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,P){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=R}),define(ne[93],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(ne[14],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[29],re([0,1,144,5]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function R(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function L(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function T(m,g){switch(m){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function P(m,g){return g==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function E(m,g,a){return P(g,a)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===a?!0:b(a).includes(m)}e.isTargetPlatformCompatible=E;function b(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function I(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=I;var w;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var p;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var v;(function(m){m.Install="install",m.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var h;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,r.createDecorator)("extensionGalleryService");var S;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class C extends Error{constructor(g,a){super(g),this.code=a,this.name=a}}e.ExtensionManagementError=C,e.IExtensionManagementService=(0,r.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,r.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,r.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ne[179],re([0,1,3,2,65,32,7,131,29]),function(Q,e,D,r,R,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(C,m){return T.URI.revive(m?m.transformIncoming(C):C)}function I(C,m){return m?m.transformOutgoingURI(C):C}function w(C,m){m=m||P.DefaultURITransformer;const g=C.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...C,manifest:void 0},m),manifest:g}}function p(C,m){return m?(0,L.cloneAndChange)(C,g=>g instanceof T.URI?m.transformOutgoingURI(g):void 0):C}class v{constructor(m,g){this.service=m,this.getUriTransformer=g,this.onInstallExtension=D.Event.buffer(m.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(m.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(m.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(m.onDidUninstallExtension,!0)}listen(m,g){const a=this.getUriTransformer(m);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,d=>d.map(c=>({...c,local:c.local?p(c.local,a):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(m,g,a){const d=this.getUriTransformer(m);switch(g){case"zip":return this.service.zip(w(a[0],d)).then(c=>I(c,d));case"unzip":return this.service.unzip(b(a[0],d));case"install":return this.service.install(b(a[0],d),(0,R.revive)(a[1]));case"getManifest":return this.service.getManifest(b(a[0],d));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(a[0]);case"installFromGallery":return this.service.installFromGallery(a[0],(0,R.revive)(a[1]));case"uninstall":return this.service.uninstall(w(a[0],d),(0,R.revive)(a[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(w(a[0],d));case"getInstalled":return this.service.getInstalled(a[0],T.URI.revive(a[1])).then(c=>c.map(i=>p(i,d)));case"getMetadata":return this.service.getMetadata(w(a[0],d));case"updateMetadata":return this.service.updateMetadata(w(a[0],d),a[1]).then(c=>p(c,d));case"updateExtensionScope":return this.service.updateExtensionScope(w(a[0],d),a[1]).then(c=>p(c,d));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=v;class h extends r.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(m){super(),this.channel=m,this._onInstallExtension=this._register(new D.Emitter),this._onDidInstallExtensions=this._register(new D.Emitter),this._onUninstallExtension=this._register(new D.Emitter),this._onDidUninstallExtension=this._register(new D.Emitter),this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?T.URI.revive(g.source):g.source,profileLocation:T.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(a=>({...a,local:a.local?w(a.local,null):a.local,source:this.isUriComponents(a.source)?T.URI.revive(a.source):a.source,profileLocation:T.URI.revive(a.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire({identifier:g.identifier,profileLocation:T.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire({...g,profileLocation:T.URI.revive(g.profileLocation)})))}isUriComponents(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(m){const g=await this.getTargetPlatform();return m.allTargetPlatforms.some(a=>(0,E.isTargetPlatformCompatible)(a,m.allTargetPlatforms,g))}zip(m){return Promise.resolve(this.channel.call("zip",[m]).then(g=>T.URI.revive(g)))}unzip(m){return Promise.resolve(this.channel.call("unzip",[m]))}install(m,g){return Promise.resolve(this.channel.call("install",[m,g])).then(a=>w(a,null))}getManifest(m){return Promise.resolve(this.channel.call("getManifest",[m]))}installFromGallery(m,g){return Promise.resolve(this.channel.call("installFromGallery",[m,g])).then(a=>w(a,null))}uninstall(m,g){return Promise.resolve(this.channel.call("uninstall",[m,g]))}reinstallFromGallery(m){return Promise.resolve(this.channel.call("reinstallFromGallery",[m]))}getInstalled(m=null,g){return Promise.resolve(this.channel.call("getInstalled",[m,g])).then(a=>a.map(d=>w(d,null)))}getMetadata(m){return Promise.resolve(this.channel.call("getMetadata",[m]))}updateMetadata(m,g){return Promise.resolve(this.channel.call("updateMetadata",[m,g])).then(a=>w(a,null))}updateExtensionScope(m,g){return Promise.resolve(this.channel.call("updateExtensionScope",[m,g])).then(a=>w(a,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class S{constructor(m){this.service=m}listen(m,g){throw new Error("Invalid listen")}call(m,g,a){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(a[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=S}),define(ne[94],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var r;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(r=e.RecommendationSource||(e.RecommendationSource={}));function R(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var L;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[13],re([0,1,34,12,27,15,7,152,5]),function(Q,e,D,r,R,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function b(H){return H.create===!0}e.isFileOpenForWriteOptions=b;var I;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var w;(function(H){H[H.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var p;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=v;function h(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=h;function S(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=S;function C(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function m(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=m;function g(H){return v(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var a;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(a=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class d extends Error{constructor(G,z){super(G),this.code=z}}e.FileSystemProviderError=d;function c(H,G){const z=new d(H.toString(),G);return o(z,G),z}e.createFileSystemProviderError=c;function i(H){return H||c((0,P.localize)(0,null),a.Unknown)}e.ensureFileSystemProviderError=i;function o(H,G){return H.name=G?`${G} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=o;function t(H){if(!H)return a.Unknown;if(H instanceof d)return H.code;const G=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!G)return a.Unknown;switch(G[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileExceedsMemoryLimit:return a.FileExceedsMemoryLimit;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.toFileSystemProviderErrorCode=t;function n(H){if(H instanceof A)return H.fileOperationResult;switch(t(H)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 10;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileExceedsMemoryLimit:return 9;case a.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var s;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class u{constructor(G,z,j){this.resource=G,this.operation=z,this.target=j}isOperation(G){return this.operation===G}}e.FileOperationEvent=u;var l;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class f{constructor(G,z){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=G;const j=new Map;for(const Y of G){const te=j.get(Y.type);switch(te?te.push([Y.resource,Y]):j.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,te]of j)switch(Y){case 1:this.added=D.TernarySearchTree.forUris(()=>z),this.added.fill(te);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>z),this.updated.fill(te);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>z),this.deleted.fill(te);break}}contains(G,...z){return this.doContains(G,{includeChildren:!1},...z)}affects(G,...z){return this.doContains(G,{includeChildren:!0},...z)}doContains(G,z,...j){if(!G)return!1;const Y=j.length>0;return!!((!Y||j.includes(1))&&(this.added?.get(G)||z.includeChildren&&this.added?.findSuperstr(G))||(!Y||j.includes(0))&&(this.updated?.get(G)||z.includeChildren&&this.updated?.findSuperstr(G))||(!Y||j.includes(2))&&(this.deleted?.findSubstr(G)||z.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=f;function y(H,G,z){return!H||!G||H===G||G.length>H.length?!1:(G.charAt(G.length-1)!==r.sep&&(G+=r.sep),z?(0,R.startsWithIgnoreCase)(H,G):H.indexOf(G)===0)}e.isParent=y;class A extends Error{constructor(G,z,j){super(G),this.fileOperationResult=z,this.options=j}}e.FileOperationError=A;class O extends A{constructor(G,z,j){super(G,2,j),this.stat=z}}e.NotModifiedSinceFileOperationError=O;var _;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var M;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(M=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function k(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=k;async function F(H,G){if(!G.hasProvider(T.URI.from({scheme:H.scheme})))return new Promise(z=>{const j=G.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===H.scheme&&Y.added&&(j.dispose(),z())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(G){return(0,L.isNumber)(G)||(G=0),G<$.KB?(0,P.localize)(1,null,G.toFixed(0)):G<$.MB?(0,P.localize)(2,null,(G/$.KB).toFixed(2)):G<$.GB?(0,P.localize)(3,null,(G/$.MB).toFixed(2)):G<$.TB?(0,P.localize)(4,null,(G/$.GB).toFixed(2)):(0,P.localize)(5,null,(G/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var x;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(x=e.Arch||(e.Arch={}));function J(H){return{maxFileSize:H===0?300*$.MB:16*$.GB,maxHeapSize:H===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=J});var K=this&&this.__param||function(Q,e){return function(D,r){e(D,r,Q)}};define(ne[180],re([0,1,95,42,13]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(P){this.fileService=P}async checksum(P){const E=(await this.fileService.readFileStream(P)).value;return new Promise((b,I)=>{const w=(0,D.createHash)("md5");(0,r.listenStream)(E,{onData:p=>w.update(p.buffer),onError:p=>I(p),onEnd:()=>b(w.digest("base64").replace(/=+$/,""))})})}};L=pe([K(0,R.IFileService)],L),e.ChecksumService=L}),define(ne[181],re([0,1,16,38,9,3,2,42,7,30,13]),function(Q,e,D,r,R,L,T,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends T.Disposable{constructor(v,h){super(),this.channel=v,this.extraCapabilities=h,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(v){return this.channel.call("stat",[v])}readdir(v){return this.channel.call("readdir",[v])}async readFile(v,h){const{buffer:S}=await this.channel.call("readFile",[v,h]);return S}readFileStream(v,h,S){const C=(0,P.newWriteableStream)(g=>D.VSBuffer.concat(g.map(a=>D.VSBuffer.wrap(a))).buffer),m=this.channel.listen("readFileStream",[v,h])(g=>{if(g instanceof D.VSBuffer)C.write(g.buffer);else{if(g==="end")C.end();else{let a=g;a instanceof Error||(a=(0,I.createFileSystemProviderError)((0,r.toErrorMessage)(a),I.FileSystemProviderErrorCode.Unknown)),C.error(a),C.end()}m.dispose()}});return S.onCancellationRequested(()=>{C.error((0,R.canceled)()),C.end(),m.dispose()}),C}writeFile(v,h,S){return this.channel.call("writeFile",[v,D.VSBuffer.wrap(h),S])}open(v,h){return this.channel.call("open",[v,h])}close(v){return this.channel.call("close",[v])}async read(v,h,S,C,m){const[g,a]=await this.channel.call("read",[v,h,m]);return S.set(g.buffer.slice(0,a),C),a}write(v,h,S,C,m){return this.channel.call("write",[v,h,D.VSBuffer.wrap(S),C,m])}mkdir(v){return this.channel.call("mkdir",[v])}delete(v,h){return this.channel.call("delete",[v,h])}rename(v,h,S){return this.channel.call("rename",[v,h,S])}copy(v,h,S){return this.channel.call("copy",[v,h,S])}cloneFile(v,h){return this.channel.call("cloneFile",[v,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(v=>{if(Array.isArray(v)){const h=v;this._onDidChange.fire(h.map(S=>({resource:E.URI.revive(S.resource),type:S.type})))}else{const h=v;this._onDidWatchError.fire(h)}}))}watch(v,h){const S=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,S,v,h]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=w}),define(ne[96],re([0,1,16,9,153,13]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(I,w,p,v,h,S){let C;try{await P(I,w,p,v,h,S)}catch(m){C=m}finally{C&&h.errorTransformer&&(C=h.errorTransformer(C)),typeof C<"u"&&p.error(C),p.end()}}e.readFileIntoStream=T;async function P(I,w,p,v,h,S){E(S);const C=await I.open(w,{create:!1});try{E(S);let m=0,g=0,a=h&&typeof h.length=="number"?h.length:void 0,d=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof a=="number"?a:h.bufferSize)),c=h&&typeof h.position=="number"?h.position:0,i=0;do g=await I.read(C,c,d.buffer,i,d.byteLength-i),c+=g,i+=g,m+=g,typeof a=="number"&&(a-=g),i===d.byteLength&&(await p.write(v(d)),d=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof a=="number"?a:h.bufferSize)),i=0);while(g>0&&(typeof a!="number"||a>0)&&E(S)&&b(m,h));if(i>0){let o=i;typeof a=="number"&&(o=Math.min(i,a)),p.write(v(d.slice(0,o)))}}catch(m){throw(0,L.ensureFileSystemProviderError)(m)}finally{await I.close(C)}}function E(I){if(I.isCancellationRequested)throw(0,r.canceled)();return!0}function b(I,w){if(w?.limits){if(typeof w.limits.memory=="number"&&I>w.limits.memory)throw(0,L.createFileSystemProviderError)((0,R.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&I>w.limits.size)throw(0,L.createFileSystemProviderError)((0,R.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[57],re([0,1,85,2,12,4,7,13]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function E(m){return m.recursive===!0}e.isRecursiveWatchRequest=E;class b extends r.Disposable{constructor(g,a,d,c){super(),this.onFileChanges=g,this.onLogMessage=a,this.verboseLogging=d,this.options=c,this.watcherDisposables=this._register(new r.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new r.DisposableStore;this.watcherDisposables.value=g,this.watcher=this.createWatcher(g),this.watcher.setVerboseLogging(this.verboseLogging),g.add(this.watcher.onDidChangeFile(a=>this.onFileChanges(a))),g.add(this.watcher.onDidLogMessage(a=>this.onLogMessage(a))),g.add(this.watcher.onDidError(a=>this.onError(a)))}onError(g){this.options.restartOnError?this.restartCounter<b.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`):this.error(g)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.watcher?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.watcher?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${g}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=b,b.MAX_RESTARTS=5;class I extends b{constructor(g,a,d){super(g,a,d,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class w extends b{constructor(g,a,d){super(g,a,d,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=w;function p(m){return m.map(g=>({type:g.type,resource:T.URI.file(g.path)}))}e.toFileChanges=p;function v(m){const g=new C;for(const a of m)g.processEvent(a);return g.coalesce()}e.coalesceEvents=v;function h(m,g){return typeof g=="string"&&!g.startsWith(D.GLOBSTAR)&&!(0,R.isAbsolute)(g)?{base:m,pattern:g}:g}e.normalizeWatcherPattern=h;function S(m,g){const a=[];for(const d of g)a.push((0,D.parse)(h(m,d)));return a}e.parseWatcherPatterns=S;class C{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return L.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const a=this.mapPathToChange.get(this.toKey(g));let d=!1;if(a){const c=a.type,i=g.type;a.path!==g.path&&(g.type===2||g.type===1)?d=!0:c===1&&i===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(a)):c===2&&i===1?a.type=0:c===1&&i===0||(a.type=i)}else d=!0;d&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],a=[];return Array.from(this.coalesced).filter(d=>d.type!==2?(g.push(d),!1):!0).sort((d,c)=>d.path.length-c.path.length).filter(d=>a.some(c=>(0,P.isParent)(d.path,c,!L.isLinux))?!1:(a.push(d.path),!0)).concat(g)}}}),define(ne[182],re([0,1,53,6,23,47,2,83,12,4,133,28,57]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class v extends T.Disposable{constructor(C,m,g,a){super(),this.request=C,this.onDidFilesChange=m,this.onLogMessage=g,this.verboseLogging=a,this.throttledFileChangesWorker=new r.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},d=>this.onDidFilesChange(d)),this.fileChangesDelayer=this._register(new r.ThrottledDelayer(v.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,p.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,p.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new R.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const C=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const m=await w.Promises.stat(C);this._register(await this.doWatch(C,m.isDirectory()))}catch(C){C.code!=="ENOENT"?this.error(C):this.trace(C)}}async normalizePath(C){let m=C.path;try{m=await w.Promises.realpath(C.path),C.path===m&&(m=await(0,I.realcase)(C.path)??C.path),C.path!==m&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${C.path}, real: ${m})`)}catch{}return m}async doWatch(C,m){if(b.isMacintosh&&(0,L.isEqualOrParent)(C,"/Volumes/",!0))return this.error(`Refusing to watch ${C} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const g=new R.CancellationTokenSource(this.cts.token),a=new T.DisposableStore;try{const d=(0,E.basename)(C),c=(0,D.watch)(C);a.add((0,T.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${C}'`);const i=new Set;if(m)try{for(const t of await w.Promises.readdir(C))i.add(t)}catch(t){this.error(t)}const o=new Map;a.add((0,T.toDisposable)(()=>{for(const[,t]of o)t.dispose();o.clear()})),c.on("error",(t,n)=>{this.error(`Failed to watch ${C} for changes using fs.watch() (${t}, ${n})`),this.dispose()}),c.on("change",(t,n)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${n}`);let s="";if(n&&(s=n.toString(),b.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(m)if(t==="rename"){o.get(s)?.dispose();const u=setTimeout(async()=>{if(o.delete(s),s===d&&!await w.Promises.exists(C)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.existsChildStrictCase((0,E.join)(C,s));if(g.token.isCancellationRequested)return;let f;l?i.has(s)?f=0:(f=1,i.add(s)):(i.delete(s),f=2),this.onFileChange({path:(0,E.join)(this.request.path,s),type:f})},v.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,T.toDisposable)(()=>clearTimeout(u)))}else{let u;i.has(s)?u=0:(u=1,i.add(s)),this.onFileChange({path:(0,E.join)(this.request.path,s),type:u})}else if(t==="rename"||s!==d){const u=setTimeout(async()=>{const l=await w.Promises.exists(C);g.token.isCancellationRequested||(l?(this.onFileChange({path:this.request.path,type:0},!0),a.add(await this.doWatch(C,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},v.FILE_DELETE_HANDLER_DELAY);a.clear(),a.add((0,T.toDisposable)(()=>clearTimeout(u)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(d){await w.Promises.exists(C)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${C} for changes using fs.watch() (${d.toString()})`)}return(0,T.toDisposable)(()=>{g.dispose(!0),a.dispose()})}async onFileChange(C,m=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),!m&&this.excludes.some(g=>g(C.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${C.path}`):!m&&this.includes&&this.includes.length>0&&!this.includes.some(g=>g(C.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${C.path}`):this.fileChangesBuffer.push(C);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const a=(0,p.coalesceEvents)(g);if(a.length>0){if(this.verboseLogging)for(const c of a)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(a)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${a[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(C){if(b.isLinux)return w.Promises.exists(C);try{const m=(0,E.basename)(C);return(await w.Promises.readdir((0,E.dirname)(C))).some(a=>a===m)}catch(m){return this.trace(m),!1}}setVerboseLogging(C){this.verboseLogging=C}error(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${C}`})}warn(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${C}`})}trace(C){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=v,v.FILE_DELETE_HANDLER_DELAY=100,v.FILE_CHANGES_HANDLER_DELAY=50;async function h(S,C,m,g,a=512){const d=await w.Promises.open(S,"r"),c=Buffer.allocUnsafe(a),i=new R.CancellationTokenSource(g);let o,t=!1;const n={path:S,excludes:[],recursive:!1},s=new v(n,u=>{(async()=>{for(const{type:l}of u)if(l===0){if(t)return;t=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:f}=await w.Promises.read(d,c,0,a,null);if(!f||i.token.isCancellationRequested)break;C(c.slice(0,f))}}catch(f){o=new Error(f),i.dispose(!0)}finally{t=!1}}})()});return await s.ready,m(),new Promise((u,l)=>{i.token.onCancellationRequested(async()=>{s.dispose();try{await w.Promises.close(d)}catch(f){o=new Error(f)}o?l(o):u()})})}e.watchFileContents=h}),define(ne[183],re([0,1,3,85,2,4,182]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends R.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(b){const I=this.normalizeRequests(b),w=I.filter(v=>{const h=this.watchers.get(v.path);return h?!(0,r.patternsEquals)(h.request.excludes,v.excludes)||!(0,r.patternsEquals)(h.request.includes,v.includes):!0}),p=Array.from(this.watchers.values()).filter(({request:v})=>!I.find(h=>h.path===v.path&&(0,r.patternsEquals)(h.excludes,v.excludes)&&(0,r.patternsEquals)(h.includes,v.includes))).map(({request:v})=>v.path);w.length&&this.trace(`Request to start watching: ${w.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),p.length&&this.trace(`Request to stop watching: ${p.join(",")}`);for(const v of p)this.stopWatching(v);for(const v of w)this.startWatching(v)}startWatching(b){const I=new T.NodeJSFileWatcherLibrary(b,p=>this._onDidChangeFile.fire(p),p=>this._onDidLogMessage.fire(p),this.verboseLogging),w={request:b,instance:I};this.watchers.set(b.path,w)}async stop(){for(const[b]of this.watchers)this.stopWatching(b);this.watchers.clear()}stopWatching(b){const I=this.watchers.get(b);I&&(this.watchers.delete(b),I.instance.dispose())}normalizeRequests(b){const I=new Map;for(const w of b){const p=L.isLinux?w.path:w.path.toLowerCase();I.set(p,w)}return Array.from(I.values())}async setVerboseLogging(b){this.verboseLogging=b;for(const[,I]of this.watchers)I.instance.setVerboseLogging(b)}trace(b){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(b)})}toMessage(b,I){return I?`[File Watcher (node.js)] ${b} (path: ${I.request.path})`:`[File Watcher (node.js)] ${b}`}}e.NodeJSWatcher=P}),define(ne[184],re([0,1,57,183]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends D.AbstractNonRecursiveWatcherClient{constructor(T,P,E){super(T,P,E),this.init()}createWatcher(){return new r.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(ne[185],re([0,1,22,39,66,57]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends L.AbstractUniversalWatcherClient{constructor(E,b,I){super(E,b,I),this.init()}createWatcher(E){const b=E.add(new R.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(b.onDidProcessExit(({code:I,signal:w})=>this.onError(`terminated by itself with code ${I}, signal: ${w}`))),r.ProxyChannel.toService((0,r.getNextTickChannel)(b.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(ne[97],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(const[L,T]of R)this.set(L,T)}set(R,L){const T=this._entries.get(R);return this._entries.set(R,L),T}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(ne[186],re([0,1,6,9,56,176,5,97]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class b extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class I{constructor(h=new P.ServiceCollection,S=!1,C,m=E){this._services=h,this._strict=S,this._parent=C,this._enableTracing=m,this._activeInstantiations=new Set,this._services.set(T.IInstantiationService,this),this._globalGraph=m?C?._globalGraph??new L.Graph(g=>g):void 0}createChild(h){return new I(h,this._strict,this,this._enableTracing)}invokeFunction(h,...S){const C=p.traceInvocation(this._enableTracing,h);let m=!1;try{return h({get:a=>{if(m)throw(0,r.illegalState)("service accessor is only valid during the invocation of its target method");const d=this._getOrCreateServiceInstance(a,C);if(!d)throw new Error(`[invokeFunction] unknown service '${a}'`);return d}},...S)}finally{m=!0,C.stop()}}createInstance(h,...S){let C,m;return h instanceof R.SyncDescriptor?(C=p.traceCreation(this._enableTracing,h.ctor),m=this._createInstance(h.ctor,h.staticArguments.concat(S),C)):(C=p.traceCreation(this._enableTracing,h),m=this._createInstance(h,S,C)),C.stop(),m}_createInstance(h,S=[],C){const m=T._util.getServiceDependencies(h).sort((d,c)=>d.index-c.index),g=[];for(const d of m){const c=this._getOrCreateServiceInstance(d.id,C);c||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${d.id}.`,!1),g.push(c)}const a=m.length>0?m[0].index:S.length;if(S.length!==a){console.trace(`[createInstance] First service dependency of ${h.name} at position ${a+1} conflicts with ${S.length} static arguments`);const d=a-S.length;d>0?S=S.concat(new Array(d)):S=S.slice(0,a)}return new h(...S,...g)}_setServiceInstance(h,S){if(this._services.get(h)instanceof R.SyncDescriptor)this._services.set(h,S);else if(this._parent)this._parent._setServiceInstance(h,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){const S=this._services.get(h);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):S}_getOrCreateServiceInstance(h,S){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(h));const C=this._getServiceInstanceOrDescriptor(h);return C instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,C,S.branch(h,!0)):(S.branch(h,!1),C)}_safeCreateAndCacheServiceInstance(h,S,C){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,S,C)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,S,C){const m=new L.Graph(d=>d.id.toString());let g=0;const a=[{id:h,desc:S,_trace:C}];for(;a.length;){const d=a.pop();if(m.lookupOrInsertNode(d),g++>1e3)throw new b(m);for(const c of T._util.getServiceDependencies(d.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(c.id);if(i||this._throwIfStrict(`[createInstance] ${h} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(d.id),String(c.id)),i instanceof R.SyncDescriptor){const o={id:c.id,desc:i,_trace:d._trace.branch(c.id,!0)};m.insertEdge(d,o),a.push(o)}}}for(;;){const d=m.roots();if(d.length===0){if(!m.isEmpty())throw new b(m);break}for(const{data:c}of d){if(this._getServiceInstanceOrDescriptor(c.id)instanceof R.SyncDescriptor){const o=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,o)}m.removeNode(c)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,S,C=[],m,g){if(this._services.get(h)instanceof R.SyncDescriptor)return this._createServiceInstance(h,S,C,m,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,S,C,m,g);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(h,S,C=[],m,g){if(m){const a=new I(void 0,this._strict,this,this._enableTracing);a._globalGraphImplicitDependency=String(h);const d=new D.IdleValue(()=>a._createInstance(S,C,g));return new Proxy(Object.create(null),{get(c,i){if(i in c)return c[i];const o=d.value;let t=o[i];return typeof t!="function"||(t=t.bind(o),c[i]=t),t},set(c,i,o){return d.value[i]=o,!0}})}else return this._createInstance(S,C,g)}_throwIfStrict(h,S){if(S&&console.warn(h),this._strict)throw new Error(h)}}e.InstantiationService=I;var w;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(w||(w={}));class p{static traceInvocation(h,S){return h?new p(1,S.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(h,S){return h?new p(0,S.name):p._None}constructor(h,S){this.type=h,this.name=S,this._start=Date.now(),this._dep=[]}branch(h,S){const C=new p(2,h.toString());return this._dep.push([h,S,C]),C}stop(){const h=Date.now()-this._start;p._totals+=h;let S=!1;function C(g,a){const d=[],c=new Array(g+1).join("	");for(const[i,o,t]of a._dep)if(o&&t){S=!0,d.push(`${c}CREATES -> ${i}`);const n=C(g+1,t);n&&d.push(n)}else d.push(`${c}uses -> ${i}`);return d.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${C(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(h>2||S)&&p.all.add(m.join(`
`))}}e.Trace=p,p.all=new Set,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(ne[187],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,L){this.server=R,this.router=L}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,L){this.server.registerChannel(R,L)}}e.MessagePortMainProcessService=D}),define(ne[58],re([0,1,39,56,91,5]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(v,h,S,C){const m=S.getChannel(v);return P(h)?C.createInstance(new r.SyncDescriptor(h.channelClientCtor,[m])):D.ProxyChannel.toService(m,h?.proxyOptions)}}function P(p){return!!p?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let E=class extends T{constructor(v,h,S,C){super(v,h,S,C)}};E=pe([K(2,e.IMainProcessService),K(3,L.IInstantiationService)],E);function b(p,v,h){(0,R.registerSingleton)(p,new r.SyncDescriptor(E,[v,h],!0))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let I=class extends T{constructor(v,h,S,C){super(v,h,S,C)}};I=pe([K(2,e.ISharedProcessService),K(3,L.IInstantiationService)],I);function w(p,v,h){(0,R.registerSingleton)(p,new r.SyncDescriptor(I,[v,h],!0))}e.registerSharedProcessRemoteService=w}),define(ne[69],re([0,1,23,2,4,155,29,5]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let E=class extends r.Disposable{constructor(I){super(),this.extensionGalleryService=I}async getAvailableLanguages(){const I=new D.CancellationTokenSource;setTimeout(()=>I.cancel(),1e3);let w;try{w=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const v=w.firstPage.filter(h=>h.properties.localizedLanguages?.length&&h.tags.some(S=>S.startsWith("lp-"))).map(h=>{const S=h.properties.localizedLanguages?.[0],C=this.getLocale(h);return{...this.createQuickPickItem(C,S,h),extensionId:h.identifier.id,galleryExtension:h}});return v.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),v}getLocale(I){return I.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(I,w,p){const v=w??I;let h;if(v!==I&&(h=`(${I})`),I.toLowerCase()===R.language.toLowerCase()&&(h??="",h+=(0,L.localize)(0,null)),p?.installCount){h??="";const S=p.installCount;let C;S>1e6?C=`${Math.floor(S/1e5)/10}M`:S>1e3?C=`${Math.floor(S/1e3)}K`:C=String(S),h+=` $(cloud-download) ${C}`}return{id:I,label:v,description:h}}};E=pe([K(0,T.IExtensionGalleryService)],E),e.LanguagePackBaseService=E}),define(ne[188],re([0,1,2,69]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(T){super(),this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=pe([K(0,r.ILanguagePackService)],R),e.LocalizationsUpdater=R}),define(ne[8],re([0,1,38,3,2,4,5]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function P(){return new Date().toISOString()}var E;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function b(o,t,n){switch(t){case E.Trace:o.trace(n);break;case E.Debug:o.debug(n);break;case E.Info:o.info(n);break;case E.Warning:o.warn(n);break;case E.Error:o.error(n);break;case E.Critical:o.critical(n);break;default:throw new Error("Invalid log level")}}e.log=b;function I(o){let t="";for(let n=0;n<o.length;n++){let s=o[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}t+=(n>0?" ":"")+s}return t}e.format=I;class w extends R.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new r.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class p extends w{constructor(t){super(),this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(E.Trace)&&this.log(E.Trace,I([t,...n]))}debug(t,...n){this.checkLogLevel(E.Debug)&&this.log(E.Debug,I([t,...n]))}info(t,...n){this.checkLogLevel(E.Info)&&this.log(E.Info,I([t,...n]))}warn(t,...n){this.checkLogLevel(E.Warning)&&this.log(E.Warning,I([t,...n]))}error(t,...n){if(this.checkLogLevel(E.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(E.Error,I(s))}else this.log(E.Error,I([t,...n]))}critical(t,...n){this.checkLogLevel(E.Critical)&&this.log(E.Critical,I([t,...n]))}flush(){}}e.AbstractMessageLogger=p;class v extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.useColors=!L.isWindows}trace(t,...n){this.getLevel()<=E.Trace&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}debug(t,...n){this.getLevel()<=E.Debug&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}info(t,...n){this.getLevel()<=E.Info&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}warn(t,...n){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${P()}]\x1B[0m`,t,...n):console.warn(`[main ${P()}]`,t,...n))}error(t,...n){this.getLevel()<=E.Error&&(this.useColors?console.error(`\x1B[91m[main ${P()}]\x1B[0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}critical(t,...n){this.getLevel()<=E.Critical&&(this.useColors?console.error(`\x1B[90m[main ${P()}]\x1B[0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class h extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...n){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=h;class S extends w{constructor(t,n=e.DEFAULT_LOG_LEVEL){super(),this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class C extends w{constructor(t){super(),this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=C;class m extends R.Disposable{constructor(t){super(),this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=m;class g extends R.Disposable{constructor(t,n){super(),this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(s))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,n?.always?E.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),n?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class a{constructor(){this.onDidChangeLogLevel=new r.Emitter().event}setLevel(t){}getLevel(){return E.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=a;function d(o){if(o.verbose)return E.Trace;if(typeof o.logLevel=="string"){const t=c(o.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=d;function c(o){switch(o){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=c;function i(o){switch(o){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=i}),define(ne[189],re([0,1,6,9,2,12,28,14,8]),function(Q,e,D,r,R,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends R.Disposable{constructor(w,p){super(),this.environmentService=w,this.logService=p,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,L.basename)(this.environmentService.logsPath),p=(0,L.dirname)(this.environmentService.logsPath),S=(await T.Promises.readdir(p)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==w),C=S.slice(0,Math.max(0,S.length-9));C.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${C.join(", ")}'`),await Promise.all(C.map(m=>T.Promises.rm((0,L.join)(p,m)))))}catch(w){(0,r.onUnexpectedError)(w)}}};b=pe([K(0,P.IEnvironmentService),K(1,E.ILogService)],b),e.LogsDataCleaner=b}),define(ne[190],re([0,1,19,6,9,3,2,12,57,8]),function(Q,e,D,r,R,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends T.Disposable{constructor(p,v){super(),this.logService=p,this.options=v,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new r.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new r.ThrottledDelayer(0))}watch(p,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(p,v):this.watchNonRecursive(p,v)}watchUniversal(p,v){const h={path:this.toFilePath(p),excludes:v.excludes,includes:v.includes,recursive:v.recursive},S=(0,D.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{S(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(p=>(0,R.onUnexpectedError)(p))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,E.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})));const p=this.options?.watcher?.recursive?.usePolling;if(p===!0)for(const v of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const v of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(v)&&p.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(p,v){const h={path:this.toFilePath(p),excludes:v.excludes,includes:v.includes,recursive:!1},S=(0,D.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{S(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(p=>(0,R.onUnexpectedError)(p))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(p=>this._onDidChangeFile.fire((0,E.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,P.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(ne[191],re([0,1,19,6,16,23,3,64,52,2,34,22,192,17,42,151,13,96,8]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let a=class extends b.Disposable{constructor(c){super(),this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new r.ResourceQueue)}registerProvider(c,i){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${c}`);const o=new b.DisposableStore;return this.provider.set(c,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:i}),o.add(i.onDidChangeFile(t=>this._onDidFilesChange.fire(new C.FileChangesEvent(t,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&o.add(i.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),o.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:c}))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:i}),this.provider.delete(c),(0,b.dispose)(o)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(o){i.push(o)}}),!this.provider.has(c)&&await r.Promises.settled(i)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,i){const o=this.provider.get(c.scheme);return!!(o&&o.capabilities&i)}listCapabilities(){return E.Iterable.map(this.provider,([c,i])=>({scheme:c,capabilities:i.capabilities}))}async withProvider(c){if(!(0,v.isAbsolutePath)(c))throw new C.FileOperationError((0,S.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const i=this.provider.get(c.scheme);if(!i){const o=new Error;throw o.name="ENOPRO",o.message=(0,S.localize)(1,null,c.toString()),o}return i}async withReadProvider(c){const i=await this.withProvider(c);if((0,C.hasOpenReadWriteCloseCapability)(i)||(0,C.hasReadWriteCapability)(i)||(0,C.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const i=await this.withProvider(c);if((0,C.hasOpenReadWriteCloseCapability)(i)||(0,C.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,i){try{return await this.doResolveFile(c,i)}catch(o){throw(0,C.toFileSystemProviderErrorCode)(o)===C.FileSystemProviderErrorCode.FileNotFound?new C.FileOperationError((0,S.localize)(2,null,this.resourceForError(c)),1):(0,C.ensureFileSystemProviderError)(o)}}async doResolveFile(c,i){const o=await this.withProvider(c),t=this.isPathCaseSensitive(o),n=i?.resolveTo,s=i?.resolveSingleChildDescendants,u=i?.resolveMetadata,l=await o.stat(c);let f;return this.toFileStat(o,c,l,void 0,!!u,(y,A)=>(f||(f=I.TernarySearchTree.forUris(()=>!t),f.set(c,!0),n&&f.fill(!0,n)),f.get(y.resource)||f.findSuperstr(y.resource.with({query:null,fragment:null}))?!0:y.isDirectory&&s?A===1:!1))}async toFileStat(c,i,o,t,n,s){const{providerExtUri:u}=this.getExtUri(c),l={resource:i,name:u.basename(i),isFile:(o.type&C.FileType.File)!==0,isDirectory:(o.type&C.FileType.Directory)!==0,isSymbolicLink:(o.type&C.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&C.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,C.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(l.isDirectory&&s(l,t)){try{const f=await c.readdir(i),y=await r.Promises.settled(f.map(async([A,O])=>{try{const _=u.joinPath(i,A),M=n?await c.stat(_):{type:O};return await this.toFileStat(c,_,M,f.length,n,s)}catch(_){return this.logService.trace(_),null}}));l.children=(0,D.coalesce)(y)}catch(f){this.logService.trace(f),l.children=[]}return l}return l}async resolveAll(c){return r.Promises.settled(c.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(c){const i=await this.withProvider(c),o=await i.stat(c);return this.toFileStat(i,c,o,void 0,!0,()=>!1)}async exists(c){const i=await this.withProvider(c);try{return!!await i.stat(c)}catch{return!1}}async canCreateFile(c,i){try{await this.doValidateCreateFile(c,i)}catch(o){return o}return!0}async doValidateCreateFile(c,i){if(!i?.overwrite&&await this.exists(c))throw new C.FileOperationError((0,S.localize)(3,null,this.resourceForError(c)),3,i)}async createFile(c,i=R.VSBuffer.fromString(""),o){await this.doValidateCreateFile(c,o);const t=await this.writeFile(c,i);return this._onDidRunOperation.fire(new C.FileOperationEvent(c,0,t)),t}async writeFile(c,i,o){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(t);try{await this.validateWriteFile(t,c,o)||await this.mkdirp(t,n.dirname(c));let u;if((0,C.hasReadWriteCapability)(t)&&!(i instanceof R.VSBuffer))if((0,h.isReadableStream)(i)){const l=await(0,h.peekStream)(i,3);l.ended?u=R.VSBuffer.concat(l.buffer):u=l}else u=(0,h.peekReadable)(i,l=>R.VSBuffer.concat(l),3);else u=i;!(0,C.hasOpenReadWriteCloseCapability)(t)||(0,C.hasReadWriteCapability)(t)&&u instanceof R.VSBuffer?await this.doWriteUnbuffered(t,c,o,u):await this.doWriteBuffered(t,c,o,u instanceof R.VSBuffer?(0,R.bufferToReadable)(u):u),this._onDidRunOperation.fire(new C.FileOperationEvent(c,4))}catch(s){throw new C.FileOperationError((0,S.localize)(4,null,this.resourceForError(c),(0,C.ensureFileSystemProviderError)(s).toString()),(0,C.toFileOperationResult)(s),o)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,i,o){if(!!o?.unlock&&!(c.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(i)));let n;try{n=await c.stat(i)}catch{return}if((n.type&C.FileType.Directory)!==0)throw new C.FileOperationError((0,S.localize)(6,null,this.resourceForError(i)),0,o);if(this.throwIfFileIsReadonly(i,n),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==C.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&o.mtime<n.mtime&&o.etag!==(0,C.etag)({mtime:o.mtime,size:n.size}))throw new C.FileOperationError((0,S.localize)(7,null),3,o);return n}async readFile(c,i,o){const t=await this.withReadProvider(c);return i?.atomic?this.doReadFileAtomic(t,c,i,o):this.doReadFile(t,c,i,o)}async doReadFileAtomic(c,i,o,t){return new Promise((n,s)=>{this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(async()=>{try{const u=await this.doReadFile(c,i,o,t);n(u)}catch(u){s(u)}})})}async doReadFile(c,i,o,t){const n=await this.doReadFileStream(c,i,{...o,preferUnbuffered:!0},t);return{...n,value:await(0,R.streamToBuffer)(n.value)}}async readFileStream(c,i,o){const t=await this.withReadProvider(c);return this.doReadFileStream(t,c,i,o)}async doReadFileStream(c,i,o,t){const n=new L.CancellationTokenSource(t),s=this.validateReadFile(i,o).then(l=>l,l=>{throw n.cancel(),l});let u;try{return typeof o?.etag=="string"&&o.etag!==C.ETAG_DISABLED&&await s,o?.atomic&&(0,C.hasFileAtomicReadCapability)(c)||!((0,C.hasOpenReadWriteCloseCapability)(c)||(0,C.hasFileReadStreamCapability)(c))||(0,C.hasReadWriteCapability)(c)&&o?.preferUnbuffered?u=this.readFileUnbuffered(c,i,o):(0,C.hasFileReadStreamCapability)(c)?u=this.readFileStreamed(c,i,n.token,o):u=this.readFileBuffered(c,i,n.token,o),{...await s,value:u}}catch(l){u&&await(0,h.consumeStream)(u);const f=(0,S.localize)(8,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(l).toString());throw l instanceof C.NotModifiedSinceFileOperationError?new C.NotModifiedSinceFileOperationError(f,l.stat,o):new C.FileOperationError(f,(0,C.toFileOperationResult)(l),o)}}readFileStreamed(c,i,o,t=Object.create(null)){const n=c.readFileStream(i,t,o);return(0,h.transform)(n,{data:s=>s instanceof R.VSBuffer?s:R.VSBuffer.wrap(s),error:s=>new C.FileOperationError((0,S.localize)(9,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(s).toString()),(0,C.toFileOperationResult)(s),t)},s=>R.VSBuffer.concat(s))}readFileBuffered(c,i,o,t=Object.create(null)){const n=(0,R.newWriteableBufferStream)();return(0,m.readFileIntoStream)(c,i,n,s=>s,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new C.FileOperationError((0,S.localize)(10,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(s).toString()),(0,C.toFileOperationResult)(s),t)},o),n}readFileUnbuffered(c,i,o){const t=(0,h.newWriteableStream)(n=>R.VSBuffer.concat(n));return(async()=>{try{let n;o?.atomic&&(0,C.hasFileAtomicReadCapability)(c)?n=await c.readFile(i,{atomic:!0}):n=await c.readFile(i),typeof o?.position=="number"&&(n=n.slice(o.position)),typeof o?.length=="number"&&(n=n.slice(0,o.length)),this.validateReadFileLimits(i,n.byteLength,o),t.end(R.VSBuffer.wrap(n))}catch(n){t.error(n),t.end()}})(),t}async validateReadFile(c,i){const o=await this.resolve(c,{resolveMetadata:!0});if(o.isDirectory)throw new C.FileOperationError((0,S.localize)(11,null,this.resourceForError(c)),0,i);if(typeof i?.etag=="string"&&i.etag!==C.ETAG_DISABLED&&i.etag===o.etag)throw new C.NotModifiedSinceFileOperationError((0,S.localize)(12,null),o,i);return this.validateReadFileLimits(c,o.size,i),o}validateReadFileLimits(c,i,o){if(o?.limits){let t;if(typeof o.limits.memory=="number"&&i>o.limits.memory&&(t=9),typeof o.limits.size=="number"&&i>o.limits.size&&(t=7),typeof t=="number")throw new C.FileOperationError((0,S.localize)(13,null,this.resourceForError(c)),t)}}async canMove(c,i,o){return this.doCanMoveCopy(c,i,"move",o)}async canCopy(c,i,o){return this.doCanMoveCopy(c,i,"copy",o)}async doCanMoveCopy(c,i,o,t){if(c.toString()!==i.toString())try{const n=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(n,c,s,i,o,t)}catch(n){return n}return!0}async move(c,i,o){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(t,c,n,i,"move",!!o),u=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(c,s==="move"?2:3,u)),u}async copy(c,i,o){const t=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(t,c,n,i,"copy",!!o),u=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(c,s==="copy"?3:2,u)),u}async doMoveCopy(c,i,o,t,n,s){if(i.toString()===t.toString())return n;const{exists:u,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,i,o,t,n,s);if(u&&!l&&s&&await this.del(t,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(t)),n==="copy"){if(c===o&&(0,C.hasFileFolderCopyCapability)(c))await c.copy(i,t,{overwrite:s});else{const f=await this.resolve(i);f.isDirectory?await this.doCopyFolder(c,f,o,t):await this.doCopyFile(c,i,o,t)}return n}else return c===o?(await c.rename(i,t,{overwrite:s}),n):(await this.doMoveCopy(c,i,o,t,"copy",s),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(c,i,o,t){if((0,C.hasOpenReadWriteCloseCapability)(c)&&(0,C.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(c,i,o,t);if((0,C.hasOpenReadWriteCloseCapability)(c)&&(0,C.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(c,i,o,t);if((0,C.hasReadWriteCapability)(c)&&(0,C.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(c,i,o,t);if((0,C.hasReadWriteCapability)(c)&&(0,C.hasReadWriteCapability)(o))return this.doPipeUnbuffered(c,i,o,t)}async doCopyFolder(c,i,o,t){await o.mkdir(t),Array.isArray(i.children)&&await r.Promises.settled(i.children.map(async n=>{const s=this.getExtUri(o).providerExtUri.joinPath(t,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),o,s):this.doCopyFile(c,n.resource,o,s)}))}async doValidateMoveCopy(c,i,o,t,n,s){let u=!1;if(c===o){const{providerExtUri:f,isPathCaseSensitive:y}=this.getExtUri(c);if(y||(u=f.isEqual(i,t)),u&&n==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(i),this.resourceForError(t)));if(!u&&f.isEqualOrParent(t,i))throw new Error((0,S.localize)(15,null,this.resourceForError(i),this.resourceForError(t)))}const l=await this.exists(t);if(l&&!u){if(!s)throw new C.FileOperationError((0,S.localize)(16,null,this.resourceForError(i),this.resourceForError(t)),4);if(c===o){const{providerExtUri:f}=this.getExtUri(c);if(f.isEqualOrParent(i,t))throw new Error((0,S.localize)(17,null,this.resourceForError(i),this.resourceForError(t)))}}return{exists:l,isSameResourceWithDifferentPathCase:u}}getExtUri(c){const i=this.isPathCaseSensitive(c);return{providerExtUri:i?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(i,c);const o=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(c,0,o)),o}async mkdirp(c,i){const o=[],{providerExtUri:t}=this.getExtUri(c);for(;!t.isEqual(i,t.dirname(i));)try{if(((await c.stat(i)).type&C.FileType.Directory)===0)throw new Error((0,S.localize)(18,null,this.resourceForError(i)));break}catch(n){if((0,C.toFileSystemProviderErrorCode)(n)!==C.FileSystemProviderErrorCode.FileNotFound)throw n;o.push(t.basename(i)),i=t.dirname(i)}for(let n=o.length-1;n>=0;n--){i=t.joinPath(i,o[n]);try{await c.mkdir(i)}catch(s){if((0,C.toFileSystemProviderErrorCode)(s)!==C.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(c,i){try{await this.doValidateDelete(c,i)}catch(o){return o}return!0}async doValidateDelete(c,i){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!i?.useTrash&&!(o.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(c)));let n;try{n=await o.stat(c)}catch{}if(n)this.throwIfFileIsReadonly(c,n);else throw new C.FileOperationError((0,S.localize)(20,null,this.resourceForError(c)),1);if(!!!i?.recursive){const u=await this.resolve(c);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(c)))}return o}async del(c,i){const o=await this.doValidateDelete(c,i),t=!!i?.useTrash,n=!!i?.recursive;await o.delete(c,{recursive:n,useTrash:t}),this._onDidRunOperation.fire(new C.FileOperationEvent(c,1))}async cloneFile(c,i){const o=await this.withProvider(c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(o===t&&this.getExtUri(o).providerExtUri.isEqual(c,i))return;if(o===t&&(0,C.hasFileCloneCapability)(o))return o.cloneFile(c,i);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i));const n=this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri);return o===t&&(0,C.hasFileFolderCopyCapability)(o)?n.queue(()=>o.copy(c,i,{overwrite:!0})):n.queue(()=>this.doCopyFile(o,c,t,i))}watch(c,i={recursive:!1,excludes:[]}){const o=new b.DisposableStore;let t=!1,n=()=>{t=!0};return o.add((0,b.toDisposable)(()=>n())),(async()=>{try{const s=await this.doWatch(c,i);t?(0,b.dispose)(s):n=()=>(0,b.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(c,i){const o=await this.withProvider(c),t=(0,P.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(c),i]);let n=this.activeWatchers.get(t);return n||(n={count:0,disposable:o.watch(c,i)},this.activeWatchers.set(t,n)),n.count+=1,(0,b.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,b.dispose)(n.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,b.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,i,o,t){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(async()=>{const n=await c.open(i,{create:!0,unlock:o?.unlock??!1});try{(0,h.isReadableStream)(t)||(0,h.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(c,n,t):await this.doWriteReadableBufferedQueued(c,n,t)}catch(s){throw(0,C.ensureFileSystemProviderError)(s)}finally{await c.close(n)}})}async doWriteStreamBufferedQueued(c,i,o){let t=0,n;if((0,h.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=R.VSBuffer.concat(o.buffer);await this.doWriteBuffer(c,i,s,s.byteLength,t,0),t+=s.byteLength}if(o.ended)return;n=o.stream}else n=o;return new Promise((s,u)=>{(0,h.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(c,i,l,l.byteLength,t,0)}catch(f){return u(f)}t+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>u(l),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(c,i,o){let t=0,n;for(;(n=o.read())!==null;)await this.doWriteBuffer(c,i,n,n.byteLength,t,0),t+=n.byteLength}async doWriteBuffer(c,i,o,t,n,s){let u=0;for(;u<t;)u+=await c.write(i,n+u,o.buffer,s+u,t-u)}async doWriteUnbuffered(c,i,o,t){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,i,o,t))}async doWriteUnbufferedQueued(c,i,o,t){let n;t instanceof R.VSBuffer?n=t:(0,h.isReadableStream)(t)?n=await(0,R.streamToBuffer)(t):(0,h.isReadableBufferedStream)(t)?n=await(0,R.bufferedStreamToBuffer)(t):n=(0,R.readableToBuffer)(t),await c.writeFile(i,n.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(c,i,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,i,o,t))}async doPipeBufferedQueued(c,i,o,t){let n,s;try{n=await c.open(i,{create:!1}),s=await o.open(t,{create:!0,unlock:!1});const u=R.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,f=0,y=0;do y=await c.read(n,l,u.buffer,f,u.byteLength-f),await this.doWriteBuffer(o,s,u,y,l,f),l+=y,f+=y,f===u.byteLength&&(f=0);while(y>0)}catch(u){throw(0,C.ensureFileSystemProviderError)(u)}finally{await r.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(c,i,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,i,o,t))}async doPipeUnbufferedQueued(c,i,o,t){return o.writeFile(t,await c.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,i,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,i,o,t))}async doPipeUnbufferedToBufferedQueued(c,i,o,t){const n=await o.open(t,{create:!0,unlock:!1});try{const s=await c.readFile(i);await this.doWriteBuffer(o,n,R.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,C.ensureFileSystemProviderError)(s)}finally{await o.close(n)}}async doPipeBufferedToUnbuffered(c,i,o,t){const n=await(0,R.streamToBuffer)(this.readFileBuffered(c,i,L.CancellationToken.None));await this.doWriteUnbuffered(o,t,void 0,n)}throwIfFileSystemIsReadonly(c,i){if(c.capabilities&2048)throw new C.FileOperationError((0,S.localize)(22,null,this.resourceForError(i)),6);return c}throwIfFileIsReadonly(c,i){if((i.permissions??0)&C.FilePermission.Readonly)throw new C.FileOperationError((0,S.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===w.Schemas.file?c.fsPath:c.toString(!0)}};a=pe([K(0,g.ILogService)],a),e.FileService=a}),define(ne[193],re([0,1,53,278,6,34,16,3,47,2,12,4,17,42,28,154,13,96,190,38,185,184]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m,g,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,r.gracefulify)(D)}catch(o){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(o)}`)}})();class i extends g.AbstractDiskFileSystemProvider{constructor(t,n){super(t,n),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new L.ResourceMap(s=>p.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:n,symbolicLink:s}=await h.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(t){try{const n=await h.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async u=>{try{let l;u.isSymbolicLink()?l=(await this.stat((0,p.joinPath)(t,u.name))).type:l=this.toType(u),s.push([u.name,l])}catch(l){this.logService.trace(l)}})),s}catch(n){throw this.toFileSystemProviderError(n)}}toType(t,n){let s;return n?.dangling?s=C.FileType.Unknown:t.isFile()?s=C.FileType.File:t.isDirectory()?s=C.FileType.Directory:s=C.FileType.Unknown,n&&(s|=C.FileType.SymbolicLink),s}async createResourceLock(t){const n=this.toFilePath(t);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.resourceLocks.get(t);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const u=new R.Barrier;return this.resourceLocks.set(t,u),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,b.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(t)===u&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),u.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),s=await this.createResourceLock(t));const u=this.toFilePath(t);return await h.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{s?.dispose()}}readFileStream(t,n,s){const u=(0,v.newWriteableStream)(l=>T.VSBuffer.concat(l.map(f=>T.VSBuffer.wrap(f))).buffer);return(0,m.readFileIntoStream)(this,t,u,l=>l.buffer,{...n,bufferSize:256*1024},s),u}async writeFile(t,n,s){let u;try{const l=this.toFilePath(t);if(!s.create||!s.overwrite){if(await h.Promises.exists(l)){if(!s.overwrite)throw(0,C.createFileSystemProviderError)((0,S.localize)(0,null),C.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,C.createFileSystemProviderError)((0,S.localize)(1,null),C.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(u,0,n,0,n.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(t,l)}finally{typeof u=="number"&&await this.close(u)}}static configureFlushOnWrite(t){i.canFlush=t}async open(t,n){const s=this.toFilePath(t);let u;(0,C.isFileOpenForWriteOptions)(n)&&(u=await this.createResourceLock(t));let l;try{if((0,C.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:y}=await h.SymlinkSupport.stat(s);y.mode&128||await h.Promises.chmod(s,y.mode|128)}catch(y){this.logService.trace(y)}let f;if((0,C.isFileOpenForWriteOptions)(n)){if(w.isWindows)try{await h.Promises.truncate(s,0),f="r+"}catch(y){y.code!=="ENOENT"&&this.logService.trace(y)}f||(f="w")}else f="r";l=await h.Promises.open(s,f)}catch(f){throw u?.dispose(),(0,C.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(t,f):this.toFileSystemProviderError(f)}if(this.mapHandleToPos.set(l,0),(0,C.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(l,t),u){const f=this.mapHandleToLock.get(l);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${s})`),this.mapHandleToLock.set(l,u),f&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${s})`),f.dispose())}return l}async close(t){const n=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&i.canFlush)try{await h.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.logService.error(s)}return await h.Promises.close(t)}catch(s){throw this.toFileSystemProviderError(s)}finally{n&&(this.mapHandleToLock.get(t)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,u,l){const f=this.normalizePos(t,n);let y=null;try{y=(await h.Promises.read(t,s,u,l,f)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(t,f,y)}return y}normalizePos(t,n){return n===this.mapHandleToPos.get(t)?null:n}updatePos(t,n,s){const u=this.mapHandleToPos.get(t);typeof u=="number"&&(typeof n=="number"||(typeof s=="number"?this.mapHandleToPos.set(t,u+s):this.mapHandleToPos.delete(t)))}async write(t,n,s,u,l){return(0,R.retry)(()=>this.doWrite(t,n,s,u,l),100,3)}async doWrite(t,n,s,u,l){const f=this.normalizePos(t,n);let y=null;try{y=(await h.Promises.write(t,s,u,l,f)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),A)}finally{this.updatePos(t,f,y)}return y}async mkdir(t){try{await h.Promises.mkdir(this.toFilePath(t))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(t,n){try{const s=this.toFilePath(t);n.recursive?await h.Promises.rm(s,h.RimRafMode.MOVE):await h.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(t,n,s){const u=this.toFilePath(t),l=this.toFilePath(n);if(u!==l)try{await this.validateTargetDeleted(t,n,"move",s.overwrite),await h.Promises.move(u,l)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,S.localize)(2,null,(0,I.basename)(u),(0,I.basename)((0,I.dirname)(l)),f.toString()))),this.toFileSystemProviderError(f)}}async copy(t,n,s){const u=this.toFilePath(t),l=this.toFilePath(n);if(u!==l)try{await this.validateTargetDeleted(t,n,"copy",s.overwrite),await h.Promises.copy(u,l,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,S.localize)(3,null,(0,I.basename)(u),(0,I.basename)((0,I.dirname)(l)),f.toString()))),this.toFileSystemProviderError(f)}}async validateTargetDeleted(t,n,s,u){const l=this.toFilePath(t),f=this.toFilePath(n);let y=!1;if(!!(this.capabilities&1024)||(y=(0,E.isEqual)(l,f,!0)),y&&s==="copy")throw(0,C.createFileSystemProviderError)((0,S.localize)(4,null),C.FileSystemProviderErrorCode.FileExists);if(!y&&await h.Promises.exists(f)){if(!u)throw(0,C.createFileSystemProviderError)((0,S.localize)(5,null),C.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(t,n){return this.doCloneFile(t,n,!1)}async doCloneFile(t,n,s){const u=this.toFilePath(t),l=this.toFilePath(n),f=!!(this.capabilities&1024);if((0,E.isEqual)(u,l,!f))return;const y=new b.DisposableStore;try{const[A,O]=await Promise.all([this.createResourceLock(t),this.createResourceLock(n)]);y.add(A),y.add(O),s&&await h.Promises.mkdir((0,I.dirname)(l),{recursive:!0}),await h.Promises.copyFile(u,l)}catch(A){if(A.code==="ENOENT"&&!s)return this.doCloneFile(t,n,!0);throw this.toFileSystemProviderError(A)}finally{y.dispose()}}createUniversalWatcher(t,n,s){return new d.UniversalWatcherClient(u=>t(u),u=>n(u),s)}createNonRecursiveWatcher(t,n,s){return new c.NodeJSWatcherClient(u=>t(u),u=>n(u),s)}toFileSystemProviderError(t){if(t instanceof C.FileSystemProviderError)return t;let n;switch(t.code){case"ENOENT":n=C.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=C.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=C.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=C.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=C.FileSystemProviderErrorCode.NoPermissions;break;default:n=C.FileSystemProviderErrorCode.Unknown}return(0,C.createFileSystemProviderError)(t,n)}async toFileSystemProviderWriteError(t,n){let s=this.toFileSystemProviderError(n);if(t&&s.code===C.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await h.SymlinkSupport.stat(this.toFilePath(t));u.mode&128||(s=(0,C.createFileSystemProviderError)(n,C.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return s}}e.DiskFileSystemProvider=i,i.canFlush=!0}),define(ne[98],re([0,1,3,7,8]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(p){this.service=p,this.onDidChangeLogLevel=D.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(p,v,h){switch(v){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=L;class T{constructor(p){this.channel=p}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(p){T.setLevel(this.channel,p)}static setLevel(p,v){return p.call("setLevel",v)}}e.LogLevelChannelClient=T;class P{constructor(p){this.loggerService=p,this.loggers=new Map}listen(p,v){throw new Error(`Event not found: ${v}`)}async call(p,v,h){switch(v){case"createLogger":this.createLogger(r.URI.revive(h[0]),h[1]);return;case"log":return this.log(r.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${v}`)}createLogger(p,v){this.loggers.set(p.toString(),this.loggerService.createLogger(p,v))}consoleLog(p,v){let h=console.log;switch(p){case R.LogLevel.Error:h=console.error;break;case R.LogLevel.Warning:h=console.warn;break;case R.LogLevel.Info:h=console.info;break}h.call(console,...v)}log(p,v){const h=this.loggers.get(p.toString());if(!h)throw new Error("Create the logger before logging");for(const[S,C]of v)(0,R.log)(h,S,C)}}e.LoggerChannel=P;class E extends R.AbstractLoggerService{constructor(p,v,h){super(p,v),this.channel=h}createConsoleMainLogger(){return new R.AdapterLogger({log:(p,v)=>{this.channel.call("consoleLog",[p,v])}})}doCreateLogger(p,v,h){return new b(this.channel,p,v,h)}}e.LoggerChannelClient=E;class b extends R.AbstractMessageLogger{constructor(p,v,h,S){super(S?.always),this.channel=p,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[v,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,v){const h=[[p,v]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(p){this.channel.call("log",[this.file,p])}}class I extends R.LogService{constructor(p,v){super(v),this.parent=p,this._register(p.onDidChangeLogLevel(h=>v.setLevel(h)))}setLevel(p){super.setLevel(p),this.parent.setLevel(p)}}e.FollowerLogService=I}),define(ne[59],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(ne[60],re([0,1,3,52,2,5]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class T extends R.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(b){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...b,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(b),r.Iterable.reduce(this.policies.entries(),(w,[p,v])=>({...w,[p]:v}),{})}getPolicyValue(b){return this.policies.get(b)}serialize(){return r.Iterable.reduce(Object.entries(this.policyDefinitions),(b,[I,w])=>({...b,[I]:{definition:w,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=T;class P{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ne[194],re([0,1,3,2,60]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(E){this.service=E,this.disposables=new r.DisposableStore}listen(E,b){switch(b){case"onDidChange":return D.Event.map(this.service.onDidChange,I=>I.reduce((w,p)=>({...w,[p]:this.service.getPolicyValue(p)??null}),{}),this.disposables)}throw new Error(`Event not found: ${b}`)}call(E,b,I){switch(b){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(I)}throw new Error(`Call not found: ${b}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class T extends R.AbstractPolicyService{constructor(E,b){super(),this.channel=b;for(const I in E){const{definition:w,value:p}=E[I];this.policyDefinitions[I]=w,p!==void 0&&this.policies.set(I,p)}this.channel.listen("onDidChange")(I=>{for(const w in I){const p=I[w];p===null?this.policies.delete(w):this.policies.set(w,p)}this._onDidChange.fire(Object.keys(I))})}async initializePolicies(E){const b=await this.channel.call("registerPolicyDefinitions",E);for(const I in b)this.policies.set(I,b[I])}}e.PolicyChannelClient=T}),define(ne[99],re([0,1,22,4,36,17]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof r.globals.vscode<"u"&&typeof r.globals.vscode.context<"u"){const P=r.globals.vscode.context.configuration();if(P)T=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const P=(0,L.dirname)(D.FileAccess.asFileUri("",Q));T=Q.__$__nodeRequire((0,L.joinPath)(P,"product.json").fsPath);const E=Q.__$__nodeRequire((0,L.joinPath)(P,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),Object.assign(T,{version:E.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ne[25],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[195],re([0,1,6,9,2,12,28,8,25]),function(Q,e,D,r,R,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends R.Disposable{constructor(w,p,v){super(),this.productService=p,this.logService=v,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(w)},3e4)).schedule()}async cleanUpCodeCaches(w){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const p=Date.now(),v=(0,L.dirname)(w),h=(0,L.basename)(w),S=await T.Promises.readdir(v);await Promise.all(S.map(async C=>{if(C===h)return;const m=(0,L.join)(v,C),g=await T.Promises.stat(m);if(g.isDirectory()&&p-g.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${C}.`),T.Promises.rm(m)}))}catch(p){(0,r.onUnexpectedError)(p)}}};b=pe([K(1,E.IProductService),K(2,P.ILogService)],b),e.CodeCacheCleaner=b}),define(ne[196],re([0,1,6,9,2,12,28,14,8,25]),function(Q,e,D,r,R,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends R.Disposable{constructor(p,v,h){super(),this.environmentService=p,this.logService=v,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const p=Object.create(null),v=JSON.parse(await T.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const g of Object.keys(v)){const a=v[g];p[`${a.hash}.${g}`]=!0}const h=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(h))return;const C=await T.Promises.readdir(h);for(const g of C){if(p[g]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await T.Promises.rm((0,L.join)(h,g))}const m=Date.now();for(const g of Object.keys(p)){const a=(0,L.join)(h,g),d=await T.Promises.readdir(a);for(const c of d){if(c==="tcf.json")continue;const i=(0,L.join)(a,c),o=await T.Promises.stat(i);o.isDirectory()&&m-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(g,c)}`),await T.Promises.rm(i))}}}catch(p){(0,r.onUnexpectedError)(p)}}};I=pe([K(0,P.INativeEnvironmentService),K(1,E.ILogService),K(2,b.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(ne[197],re([0,1,12,5]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,r.createDecorator)("IV8InspectProfilingService");var R;(function(L){function T(P,E="noAbsolutePaths"){for(const b of P.nodes)b.callFrame&&b.callFrame.url&&((0,D.isAbsolute)(b.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(b.callFrame.url))&&(b.callFrame.url=(0,D.join)(E,(0,D.basename)(b.callFrame.url)));return P}L.rewriteAbsolutePaths=T})(R=e.Utils||(e.Utils={}))}),define(ne[198],re([0,1,30]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class r{constructor(){this._sessions=new Map}async startProfiling(L){const P=await(await new Promise((b,I)=>{Q(["v8-inspect-profiler"],b,I)})).startProfiling({port:L.port,checkForPaused:!0}),E=(0,D.generateUuid)();return this._sessions.set(E,P),E}async stopProfiling(L){const T=this._sessions.get(L);if(!T)throw new Error(`UNKNOWN session '${L}'`);const P=await T.stop();return this._sessions.delete(L),P.profile}}e.InspectProfilingService=r}),define(ne[40],re([0,1,114,15]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(T,P){D.ok(r.isString(T)),D.ok(r.isObject(P)),D.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,P)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new R}),define(ne[100],re([0,1,3,40]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,b){this.schemasById[R(E)]=b,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new L;r.Registry.add(e.Extensions.JSONContribution,T)}),define(ne[43],re([0,1,19,3,15,140,18,100,40]),function(Q,e,D,r,R,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=E.Registry.as(P.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new r.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new r.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const t=this.doRegisterConfigurations(i,o);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(i){const o=this.doDeregisterConfigurations(i);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:i,remove:o}){const t=[];t.push(...this.doDeregisterConfigurations(o)),t.push(...this.doRegisterConfigurations(i,!1)),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(t)})}registerDefaultConfigurations(i){const o=[],t=[];for(const{overrides:n,source:s}of i)for(const u in n)if(o.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const l=this.configurationDefaultsOverrides.get(u),f=l?.valuesSources??new Map;if(s)for(const _ of Object.keys(n[u]))f.set(_,s);const y={...l?.value||{},...n[u]};this.configurationDefaultsOverrides.set(u,{source:s,value:y,valuesSources:f});const A=(0,T.getLanguageTagSettingPlainKey)(u),O={type:"object",default:y,description:L.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:y,source:R.isString(s)?void 0:s,defaultValueSource:s};t.push(...S(u)),this.configurationProperties[u]=O,this.defaultLanguageConfigurationOverridesNode.properties[u]=O}else{this.configurationDefaultsOverrides.set(u,{value:n[u],source:s});const l=this.configurationProperties[u];l&&(this.updatePropertyDefaultValue(u,l),this.updateSchema(u,l))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const o=[];for(const{overrides:t,source:n}of i)for(const s in t){const u=this.configurationDefaultsOverrides.get(s),l=R.isString(n)?n:n?.id,f=R.isString(u?.source)?u?.source:u?.source?.id;if(l===f)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const y=this.configurationProperties[s];y&&(this.updatePropertyDefaultValue(s,y),this.updateSchema(s,y))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const o of i)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,o){const t=[];return i.forEach(n=>{t.push(...this.validateAndRegisterProperties(n,o,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),t}doDeregisterConfigurations(i){const o=[],t=n=>{if(n.properties)for(const s in n.properties){o.push(s);const u=this.configurationProperties[s];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.configurationContributors.indexOf(n);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(i,o=!0,t,n,s=3){s=R.isUndefinedOrNull(i.scope)?s:i.scope;const u=[],l=i.properties;if(l)for(const y in l){const A=l[y];if(o&&a(y,A)){delete l[y];continue}if(A.source=t,A.defaultDefaultValue=l[y].default,this.updatePropertyDefaultValue(y,A),e.OVERRIDE_PROPERTY_REGEX.test(y)?A.scope=void 0:(A.scope=R.isUndefinedOrNull(A.scope)?s:A.scope,A.restricted=R.isUndefinedOrNull(A.restricted)?!!n?.includes(y):A.restricted),l[y].hasOwnProperty("included")&&!l[y].included){this.excludedConfigurationProperties[y]=l[y],delete l[y];continue}else this.configurationProperties[y]=l[y],l[y].policy?.name&&this.policyConfigurations.set(l[y].policy.name,y);!l[y].deprecationMessage&&l[y].markdownDeprecationMessage&&(l[y].deprecationMessage=l[y].markdownDeprecationMessage),u.push(y)}const f=i.allOf;if(f)for(const y of f)u.push(...this.validateAndRegisterProperties(y,o,t,n,s));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const o=t=>{const n=t.properties;if(n)for(const u in n)this.updateSchema(u,n[u]);t.allOf?.forEach(o)};o(i)}updateSchema(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.resourceLanguageSettingsSchema.properties[i]=o;break}}removeFromSchema(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const o=`[${i}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,t),e.allSettings.properties[o]=t,e.applicationSettings.properties[o]=t,e.machineSettings.properties[o]=t,e.machineOverridableSettings.properties[o]=t,e.windowSettings.properties[o]=t,e.resourceSettings.properties[o]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,o){const t=this.configurationDefaultsOverrides.get(i);let n=t?.value,s=t?.source;R.isUndefined(n)&&(n=o.defaultDefaultValue,s=void 0),R.isUndefined(n)&&(n=m(o.type)),o.default=n,o.defaultValueSource=s}}const v="\\[([^\\]]+)\\]",h=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(c){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let o=h.exec(c);for(;o?.length;){const t=o[1].trim();t&&i.push(t),o=h.exec(c)}}return(0,D.distinct)(i)}e.overrideIdentifiersFromKey=S;function C(c){return c.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=C;function m(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const g=new p;E.Registry.add(e.Extensions.Configuration,g);function a(c,i){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?L.localize(7,null,c):g.getConfigurationProperties()[c]!==void 0?L.localize(8,null,c):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,c,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.validateProperty=a;function d(){const c=[],i=g.getConfigurationProperties();for(const o of Object.keys(i))c.push([o,i[o].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=d}),define(ne[70],re([0,1,19,3,35,2,34,32,15,7,18,43,40]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class v{constructor(i={},o=[],t=[]){this._contents=i,this._keys=o,this._overrides=t,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(i){return i?(0,I.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,o){const t=this.getContentsForOverrideIdentifer(o);return t?i?(0,I.getConfigurationValue)(t,i):t:void 0}getKeysForOverrideIdentifier(i){const o=[];for(const t of this.overrides)t.identifiers.includes(i)&&o.push(...t.keys);return D.distinct(o)}getAllOverrideIdentifiers(){const i=[];for(const o of this.overrides)i.push(...o.identifiers);return D.distinct(i)}override(i){let o=this.overrideConfigurations.get(i);return o||(o=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,o)),o}merge(...i){const o=P.deepClone(this.contents),t=P.deepClone(this.overrides),n=[...this.keys];for(const s of i)if(!s.isEmpty()){this.mergeContents(o,s.contents);for(const u of s.overrides){const[l]=t.filter(f=>D.equals(f.identifiers,u.identifiers));l?(this.mergeContents(l.contents,u.contents),l.keys.push(...u.keys),l.keys=D.distinct(l.keys)):t.push(P.deepClone(u))}for(const u of s.keys)n.indexOf(u)===-1&&n.push(u)}return new v(o,n,t)}freeze(){return this.frozen=!0,this}clone(){return new v(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(i){const o=this.getContentsForOverrideIdentifer(i);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const t={};for(const n of D.distinct([...Object.keys(this.contents),...Object.keys(o)])){let s=this.contents[n];const u=o[n];u&&(typeof s=="object"&&typeof u=="object"?(s=P.deepClone(s),this.mergeContents(s,u)):s=u),t[n]=s}return new v(t,this.keys,this.overrides)}mergeContents(i,o){for(const t of Object.keys(o)){if(t in i&&E.isObject(i[t])&&E.isObject(o[t])){this.mergeContents(i[t],o[t]);continue}i[t]=P.deepClone(o[t])}}checkAndFreeze(i){return this.frozen&&!Object.isFrozen(i)?P.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let o=null,t=null;const n=s=>{s&&(t?this.mergeContents(t,s):t=P.deepClone(s))};for(const s of this.overrides)D.equals(s.identifiers,[i])?o=s.contents:s.identifiers.includes(i)&&n(s.contents);return n(o),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,o){this.addKey(i),(0,I.addToValueTree)(this.contents,i,o,t=>{throw new Error(t)})}removeValue(i){this.removeKey(i)&&(0,I.removeFromValueTree)(this.contents,i)}addKey(i){let o=this.keys.length;for(let t=0;t<o;t++)i.indexOf(this.keys[t])===0&&(o=t);this.keys.splice(o,1,i)}removeKey(i){const o=this.keys.indexOf(i);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=v;class h{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,o){if(!E.isUndefinedOrNull(i)){const t=this.doParseContent(i);this.parseRaw(t,o)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,o){this._raw=i;const{contents:t,keys:n,overrides:s,restricted:u}=this.doParseRaw(i,o);this._configurationModel=new v(t,n,s),this._restrictedConfigurations=u||[]}doParseContent(i){let o={},t=null,n=[];const s=[],u=[];function l(y){Array.isArray(n)?n.push(y):t!==null&&(n[t]=y)}const f={onObjectBegin:()=>{const y={};l(y),s.push(n),n=y,t=null},onObjectProperty:y=>{t=y},onObjectEnd:()=>{n=s.pop()},onArrayBegin:()=>{const y=[];l(y),s.push(n),n=y,t=null},onArrayEnd:()=>{n=s.pop()},onLiteralValue:l,onError:(y,A,O)=>{u.push({error:y,offset:A,length:O})}};if(i)try{R.visit(i,f),o=n[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return o}doParseRaw(i,o){const t=p.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),n=this.filter(i,t,!0,o);i=n.raw;const s=(0,I.toValuesTree)(i,f=>console.error(`Conflict in settings file ${this._name}: ${f}`)),u=Object.keys(i),l=this.toOverrides(i,f=>console.error(`Conflict in settings file ${this._name}: ${f}`));return{contents:s,keys:u,overrides:l,restricted:n.restricted}}filter(i,o,t,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:i,restricted:[]};const s={},u=[];for(const l in i)if(w.OVERRIDE_PROPERTY_REGEX.test(l)&&t){const f=this.filter(i[l],o,!1,n);s[l]=f.raw,u.push(...f.restricted)}else{const f=o[l],y=f?typeof f.scope<"u"?f.scope:3:void 0;f?.restricted&&u.push(l),(y===void 0||n.scopes===void 0||n.scopes.includes(y))&&(n.skipRestricted&&f?.restricted||(s[l]=i[l]))}return{raw:s,restricted:u}}toOverrides(i,o){const t=[];for(const n of Object.keys(i))if(w.OVERRIDE_PROPERTY_REGEX.test(n)){const s={};for(const u in i[n])s[u]=i[n][u];t.push({identifiers:(0,w.overrideIdentifiersFromKey)(n),keys:Object.keys(s),contents:(0,I.toValuesTree)(s,o)})}return t}}e.ConfigurationModelParser=h;class S extends L.Disposable{constructor(i,o,t,n){super(),this.userSettingsResource=i,this.scopes=o,this.fileService=n,this._onDidChange=this._register(new r.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(r.Event.any(r.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),r.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&t.isEqual(s.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class C{constructor(i,o,t,n,s=new v,u=new v,l=new T.ResourceMap,f=new v,y=new T.ResourceMap,A=!0){this._defaultConfiguration=i,this._policyConfiguration=o,this._applicationConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=u,this._folderConfigurations=l,this._memoryConfiguration=f,this._memoryConfigurationByResource=y,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(i,o,t){return this.getConsolidatedConfigurationModel(i,o,t).getValue(i)}updateValue(i,o,t={}){let n;t.resource?(n=this._memoryConfigurationByResource.get(t.resource),n||(n=new v,this._memoryConfigurationByResource.set(t.resource,n))):n=this._memoryConfiguration,o===void 0?n.removeValue(i):n.setValue(i,o),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,o,t){const n=this.getConsolidatedConfigurationModel(i,o,t),s=this.getFolderConfigurationModelForResource(o.resource,t),u=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,l=o.overrideIdentifier?this._defaultConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),f=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(i),y=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(i),A=o.overrideIdentifier?this.userConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),O=o.overrideIdentifier?this.localUserConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),_=o.overrideIdentifier?this.remoteUserConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),M=t?o.overrideIdentifier?this._workspaceConfiguration.freeze().override(o.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,k=s?o.overrideIdentifier?s.freeze().override(o.overrideIdentifier).getValue(i):s.freeze().getValue(i):void 0,F=o.overrideIdentifier?u.override(o.overrideIdentifier).getValue(i):u.getValue(i),$=n.getValue(i),x=D.distinct(n.overrides.map(J=>J.identifiers).flat()).filter(J=>n.getOverrideValue(i,J)!==void 0);return{defaultValue:l,policyValue:f,applicationValue:y,userValue:A,userLocalValue:O,userRemoteValue:_,workspaceValue:M,workspaceFolderValue:k,memoryValue:F,value:$,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,policy:f!==void 0?{value:f}:void 0,application:y!==void 0?{value:y,override:o.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,workspace:M!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:o.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,workspaceFolder:k!==void 0?{value:s?.freeze().getValue(i),override:o.overrideIdentifier?s?.freeze().getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:u.getValue(i),override:o.overrideIdentifier?u.getOverrideValue(i,o.overrideIdentifier):void 0}:void 0,overrideIdentifiers:x.length?x:void 0}}keys(i){const o=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,o){this._folderConfigurations.set(i,o),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,o){const t=[];if(!o){const{added:n,updated:s,removed:u}=a(this._defaultConfiguration,i);o=[...n,...s,...u]}for(const n of o)for(const s of(0,w.overrideIdentifiersFromKey)(n)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(s),l=i.getKeysForOverrideIdentifier(s),f=[...l.filter(y=>u.indexOf(y)===-1),...u.filter(y=>l.indexOf(y)===-1),...u.filter(y=>!P.equals(this._defaultConfiguration.override(s).getValue(y),i.override(s).getValue(y)))];t.push([s,f])}return this.updateDefaultConfiguration(i),{keys:o,overrides:t}}compareAndUpdatePolicyConfiguration(i){const{added:o,updated:t,removed:n}=a(this._policyConfiguration,i),s=[...o,...t,...n];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:o,updated:t,removed:n,overrides:s}=a(this.applicationConfiguration,i),u=[...o,...t,...n];return u.length&&this.updateApplicationConfiguration(i),{keys:u,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:o,updated:t,removed:n,overrides:s}=a(this.localUserConfiguration,i),u=[...o,...t,...n];return u.length&&this.updateLocalUserConfiguration(i),{keys:u,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:o,updated:t,removed:n,overrides:s}=a(this.remoteUserConfiguration,i),u=[...o,...t,...n];return u.length&&this.updateRemoteUserConfiguration(i),{keys:u,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:o,updated:t,removed:n,overrides:s}=a(this.workspaceConfiguration,i),u=[...o,...t,...n];return u.length&&this.updateWorkspaceConfiguration(i),{keys:u,overrides:s}}compareAndUpdateFolderConfiguration(i,o){const t=this.folderConfigurations.get(i),{added:n,updated:s,removed:u,overrides:l}=a(t,o),f=[...n,...s,...u];return(f.length||!t)&&this.updateFolderConfiguration(i,o),{keys:f,overrides:l}}compareAndDeleteFolderConfiguration(i){const o=this.folderConfigurations.get(i);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:t,updated:n,removed:s,overrides:u}=a(o,void 0);return{keys:[...t,...n,...s],overrides:u}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,o,t){let n=this.getConsolidatedConfigurationModelForResource(o,t);return o.overrideIdentifier&&(n=n.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:i},o){let t=this.getWorkspaceConsolidatedConfiguration();if(o&&i){const n=o.getFolder(i);n&&(t=this.getFolderConsolidatedConfiguration(n.uri)||t);const s=this._memoryConfigurationByResource.get(i);s&&(t=t.merge(s))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let o=this._foldersConsolidatedConfigurations.get(i);if(!o){const t=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(i);n?(o=t.merge(n),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(i,o)):o=t}return o}getFolderConfigurationModelForResource(i,o){if(o&&i){const t=o.getFolder(i);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,o)=>{const{contents:t,overrides:n,keys:s}=this._folderConfigurations.get(o);return i.push([o,{contents:t,overrides:n,keys:s}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>i.add(o)),this.userConfiguration.freeze().keys.forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(t=>i.add(t))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>o.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>o.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>o.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(i).forEach(n=>o.add(n))),[...o.values()]}static parse(i){const o=this.parseConfigurationModel(i.defaults),t=this.parseConfigurationModel(i.policy),n=this.parseConfigurationModel(i.application),s=this.parseConfigurationModel(i.user),u=this.parseConfigurationModel(i.workspace),l=i.folders.reduce((f,y)=>(f.set(b.URI.revive(y[0]),this.parseConfigurationModel(y[1])),f),new T.ResourceMap);return new C(o,t,n,s,new v,u,l,new v,new T.ResourceMap,!1)}static parseConfigurationModel(i){return new v(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=C;function m(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,o=new Map;for(const n of c)n.keys.forEach(s=>i.add(s)),n.overrides.forEach(([s,u])=>{const l=(0,T.getOrSet)(o,s,new Set);u.forEach(f=>l.add(f))});const t=[];return o.forEach((n,s)=>t.push([s,[...n.values()]])),{keys:[...i.values()],overrides:t}}e.mergeChanges=m;class g{constructor(i,o,t,n){this.change=i,this.previous=o,this.currentConfiguraiton=t,this.currentWorkspace=n,this._previousConfiguration=void 0;const s=new Set;i.keys.forEach(l=>s.add(l)),i.overrides.forEach(([,l])=>l.forEach(f=>s.add(f))),this.affectedKeys=[...s.values()];const u=new v;this.affectedKeys.forEach(l=>u.setValue(l,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(o){const t=this.previousConfiguration?this.previousConfiguration.getValue(i,o,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(i,o,this.currentWorkspace);return!P.equals(t,n)}return!0}return!1}doesAffectedKeysTreeContains(i,o){let t=(0,I.toValuesTree)({[o]:!0},()=>{}),n;for(;typeof t=="object"&&(n=Object.keys(t)[0]);){if(i=i[n],!i)return!1;t=t[n]}return!0}}e.ConfigurationChangeEvent=g;function a(c,i){const{added:o,removed:t,updated:n}=d(i,c),s=[],u=c?.getAllOverrideIdentifiers()||[],l=i?.getAllOverrideIdentifiers()||[];if(i){const f=l.filter(y=>!u.includes(y));for(const y of f)s.push([y,i.getKeysForOverrideIdentifier(y)])}if(c){const f=u.filter(y=>!l.includes(y));for(const y of f)s.push([y,c.getKeysForOverrideIdentifier(y)])}if(i&&c){for(const f of u)if(l.includes(f)){const y=d({contents:c.getOverrideValue(void 0,f)||{},keys:c.getKeysForOverrideIdentifier(f)},{contents:i.getOverrideValue(void 0,f)||{},keys:i.getKeysForOverrideIdentifier(f)});s.push([f,[...y.added,...y.removed,...y.updated]])}}return{added:o,removed:t,updated:n,overrides:s}}function d(c,i){const o=c?i?c.keys.filter(s=>i.keys.indexOf(s)===-1):[...c.keys]:[],t=i?c?i.keys.filter(s=>c.keys.indexOf(s)===-1):[...i.keys]:[],n=[];if(c&&i){for(const s of i.keys)if(c.keys.indexOf(s)!==-1){const u=(0,I.getConfigurationValue)(i.contents,s),l=(0,I.getConfigurationValue)(c.contents,s);P.equals(u,l)||n.push(s)}}return{added:o,removed:t,updated:n}}}),define(ne[199],re([0,1,19,3,2,32,15,18,70,43,8,60,40]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class v extends R.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new h(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(p.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:a})=>this.onDidUpdateConfiguration(g,a))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(g,a){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=v;class h extends E.ConfigurationModel{constructor(g={}){const a=p.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),d=Object.keys(a),c=Object.create(null),i=[];for(const o in a){const t=g[o],n=t!==void 0?t:a[o].default;(0,P.addToValueTree)(c,o,n,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(c))b.OVERRIDE_PROPERTY_REGEX.test(o)&&i.push({identifiers:(0,b.overrideIdentifiersFromKey)(o),keys:Object.keys(c[o]),contents:(0,P.toValuesTree)(c[o],t=>console.error(`Conflict in default settings file: ${t}`))});super(c,d,i)}}e.DefaultConfigurationModel=h;class S{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=new E.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let C=class extends R.Disposable{get configurationModel(){return this._configurationModel}constructor(g,a,d){super(),this.defaultConfiguration=g,this.policyService=a,this.logService=d,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new E.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.registerPolicyDefinitions(g),!0))),this._configurationModel}async registerPolicyDefinitions(g){const a={},d=[],c=p.Registry.as(b.Extensions.Configuration).getConfigurationProperties();for(const i of g){const o=c[i];if(!o){d.push(i);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}d.push(i),a[o.policy.name]={type:o.type}}}return(0,T.isEmptyObject)(a)||await this.policyService.registerPolicyDefinitions(a),d}onDidChangePolicies(g){const a=p.Registry.as(b.Extensions.Configuration).getPolicyConfigurations(),d=(0,D.coalesce)(g.map(c=>a.get(c)));this.update(d,!0)}update(g,a){const d=p.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),c=[],i=this._configurationModel.isEmpty();for(const o of g){const t=d[o]?.policy?.name;if(t){const n=this.policyService.getPolicyValue(t);(i?n!==void 0:!(0,L.equals)(this._configurationModel.getValue(o),n))&&c.push([o,n])}else this._configurationModel.getValue(o)!==void 0&&c.push([o,void 0])}if(c.length){const o=this._configurationModel;this._configurationModel=new E.ConfigurationModel;for(const t of o.keys)this._configurationModel.setValue(t,o.getValue(t));for(const[t,n]of c)n===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,n);a&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};C=pe([K(1,w.IPolicyService),K(2,I.ILogService)],C),e.PolicyConfiguration=C}),define(ne[200],re([0,1,6,3,2,17,18,70,199,60]),function(Q,e,D,r,R,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends R.Disposable{constructor(p,v,h,S){super(),this.settingsResource=p,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new E.DefaultConfiguration),this.policyConfiguration=h instanceof b.NullPolicyService?new E.NullPolicyConfiguration:this._register(new E.PolicyConfiguration(this.defaultConfiguration,h,S)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,v)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:C,properties:m})=>this.onDidDefaultConfigurationChange(C,m))),this._register(this.policyConfiguration.onDidChangeConfiguration(C=>this.onDidPolicyConfigurationChange(C))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[p,v,h]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(p,v,new P.ConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(p,v){const h=typeof p=="string"?p:void 0,S=(0,T.isConfigurationOverrides)(p)?p:(0,T.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(h,S,void 0)}updateValue(p,v,h,S){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const v=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(h,v,2)}onDidDefaultConfigurationChange(p,v){const h=this.configuration.toData(),S=this.configuration.compareAndUpdateDefaultConfiguration(p,v);this.trigger(S,h,7)}onDidPolicyConfigurationChange(p){const v=this.configuration.toData(),h=this.configuration.compareAndUpdatePolicyConfiguration(p);this.trigger(h,v,7)}trigger(p,v,h){const S=new P.ConfigurationChangeEvent(p,{data:v},this.configuration);S.source=h,S.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(p){switch(p){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(ne[201],re([0,1,9,5]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,r.createDecorator)("remoteAuthorityResolverService");var R;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends D.ErrorNoTelemetry{static isTemporarilyNotAvailable(P){return P instanceof L&&P._code===R.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof L&&P._code===R.NoResolverFound}static isHandled(P){return P instanceof L&&P.isHandled}constructor(P,E=R.Unknown,b){super(P),this._message=P,this._code=E,this._detail=b,this.isHandled=E===R.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L}),define(ne[101],re([0,1,22]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function r(b){return b.scheme===D.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=r;function R(b){if(!b)return;const I=b.indexOf("+");return I<0?b:b.substr(0,I)}e.getRemoteName=R;function L(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.getRemoteServerRootPath=L;function T(b){const{host:I,port:w}=E(b);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:w}}e.parseAuthorityWithPort=T;function P(b,I){let{host:w,port:p}=E(b);return typeof p>"u"&&(p=I),{host:w,port:p}}e.parseAuthorityWithOptionalPort=P;function E(b){const I=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const w=b.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const p=b.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:b,port:void 0}}}),define(ne[44],re([0,1,27,5,101]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=L;function T(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var E;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class b{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,C){if(typeof S>"u"||S===null)return typeof C>"u"||C===null;if(typeof C>"u"||C===null)return!1;if(typeof S=="string"||typeof C=="string"){const m=typeof S=="string"?S:S.value,g=typeof C=="string"?C:C.value;return D.equalsIgnoreCase(m,g)}return S._lower===C._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=b;function I(h){return w(h)}e.isApplicationScopedExtension=I;function w(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function p(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function v(h,S){if(S){const C=`onResolveRemoteAuthority:${(0,R.getRemoteName)(S)}`;return h.activationEvents?.indexOf(C)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,r.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[33],re([0,1,27,29,44,4,7,9,36]),function(Q,e,D,r,R,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(o,t){return o.uuid&&t.uuid?o.uuid===t.uuid:o.id===t.id?!0:(0,D.compareIgnoreCase)(o.id,t.id)===0}e.areSameExtensions=b;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(t){const n=t.manifest?t.manifest.version:t.version,s=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new w(t.identifier,n,s)}static parse(t){const n=I.exec(t);return n&&n[1]&&n[2]?new w({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,s="undefined"){this.version=n,this.targetPlatform=s,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof w?b(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=w;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(o){const t=p.exec(o);return t&&t[1]?[S(t[1]),t[2]]:[S(o),void 0]}e.getIdAndVersion=v;function h(o,t){return`${o}.${t}`}e.getExtensionId=h;function S(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function C(o,t){return S(h(o,t))}e.getGalleryExtensionId=C;function m(o,t){const n=[],s=u=>{for(const l of n)if(l.some(f=>b(t(f),t(u))))return l;return null};for(const u of o){const l=s(u);l?l.push(u):n.push([u])}return n}e.groupByExtension=m;function g(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function a(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=a,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function d(o,t){const n=[],s=t.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const u=s.shift();if(u&&n.every(l=>!b(l.identifier,{id:u}))){const l=o.filter(f=>b(f.identifier,{id:u}));l.length===1&&(n.push(l[0]),s.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=d;async function c(o,t){if(!L.isLinux)return!1;let n;try{n=(await o.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await o.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){t.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(u))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=c;async function i(o,t){const n=await c(o,t),s=(0,r.getTargetPlatform)(n?"alpine":L.platform,E.arch);return t.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=i}),define(ne[49],re([0,1,6,16,2,34,7,33,13,5,8]),function(Q,e,D,r,R,L,T,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let w=class extends R.Disposable{constructor(v,h){super(),this.fileService=v,this.logService=h,this.resourcesAccessQueueMap=new L.ResourceMap}scanProfileExtensions(v){return this.withProfileExtensions(v)}addExtensionsToProfile(v,h){return this.withProfileExtensions(h,S=>(S=S.filter(C=>v.some(([m])=>!(0,P.areSameExtensions)(C.identifier,m.identifier))),S.push(...v.map(([C,m])=>({identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:m}))),S))}removeExtensionFromProfile(v,h){return this.withProfileExtensions(h,S=>S.filter(C=>!(0,P.areSameExtensions)(C.identifier,v)))}async withProfileExtensions(v,h){return this.getResourceAccessQueue(v).queue(async()=>{let S=[];try{const C=await this.fileService.readFile(v),m=JSON.parse(C.value.toString());for(const g of m){if(!g.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",g);continue}if(!g.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",g);continue}if(!g.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",g);continue}S.push({identifier:g.identifier,location:T.URI.revive(g.location),version:g.version,metadata:g.metadata})}}catch(C){C.fileOperationResult!==1&&this.logService.error(C)}if(h){S=h(S);const C=S.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),metadata:m.metadata}));await this.fileService.writeFile(v,r.VSBuffer.fromString(JSON.stringify(C)))}return S})}getResourceAccessQueue(v){let h=this.resourcesAccessQueueMap.get(v);return h||(h=new D.Queue,this.resourcesAccessQueueMap.set(v,h)),h}};w=pe([K(0,E.IFileService),K(1,I.ILogService)],w),e.ExtensionsProfileScannerService=w}),define(ne[202],re([0,1,23,33]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function R(L,T,P,E,b){try{const I=await L.getExtensionsControlManifest();if(!I.deprecated)return;const w=await L.getInstalled(1);for(const[p,v]of Object.entries(I.deprecated)){if(!v?.extension)continue;const{id:h,autoMigrate:S,preRelease:C}=v.extension;if(!S)continue;const m=w.find(a=>(0,r.areSameExtensions)(a.identifier,{id:p}));if(!m)continue;const g=(await T.getExtensions([{id:h,preRelease:C}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!g){b.info(`Skipping migrating '${m.identifier.id}' extension because, the comaptible target '${h}' extension is not found`);continue}try{b.info(`Migrating '${m.identifier.id}' extension to '${h}' extension...`);const a=!E.getDisabledExtensions().some(c=>(0,r.areSameExtensions)(c,m.identifier));await L.uninstall(m),b.info(`Uninstalled the unsupported extension '${m.identifier.id}'`);let d=w.find(c=>(0,r.areSameExtensions)(c.identifier,{id:h}));(!d||!d.isPreReleaseVersion&&a)&&(d=await L.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:m.isMachineScoped,operation:4}),b.info(`Installed the pre-release extension '${d.identifier.id}'`),a||(await E.disableExtension(d.identifier),b.info(`Disabled the pre-release extension '${d.identifier.id}' because the unsupported extension '${m.identifier.id}' is disabled`)),S.storage&&(P.addToMigrationList((0,r.getExtensionId)(m.manifest.publisher,m.manifest.name),(0,r.getExtensionId)(d.manifest.publisher,d.manifest.name)),b.info("Added pre-release extension to the storage migration list"))),b.info(`Migrated '${m.identifier.id}' extension to '${h}' extension.`)}catch(a){b.error(a)}}}catch(I){b.error(I)}}e.migrateUnsupportedExtensions=R}),define(ne[203],re([0,1,6,9,2,4,17,55,7,30,28,14,29,33,13,8]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let C=class extends R.Disposable{constructor(g,a,d,c){super(),this.fileService=a,this.extensionGalleryService=d,this.logService=c,this.extensionsDownloadDir=E.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,a){await this.cleanUpPromise;const d=this.getName(g),c=(0,T.joinPath)(this.extensionsDownloadDir,d);if(!await this.fileService.exists(c)){const i=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(g,i,a);try{await this.rename(i,c,Date.now()+2*60*1e3)}catch(o){try{await this.fileService.del(i)}catch{}if(o.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,r.getErrorMessage)(o)}. Deleted the vsix from downloaded location`,i.path),o}}return c}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,a,d){try{await I.Promises.rename(g.fsPath,a.fsPath)}catch(c){if(L.isWindows&&c&&c.code==="EPERM"&&Date.now()<d)return this.logService.info(`Failed renaming ${g} to ${a} with 'EPERM' error. Trying again...`),this.rename(g,a,d);throw c}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const a=[],d=[];for(const o of g.children){const t=v.ExtensionKey.parse(o.name);t&&d.push([t,o])}const c=(0,v.groupByExtension)(d,([o])=>o),i=[];for(const o of c)o.sort((t,n)=>P.rcompare(t[0].version,n[0].version)),a.push(...o.slice(1).map(t=>t[1].resource)),i.push(o[0][1]);i.sort((o,t)=>o.mtime-t.mtime),a.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(o=>o.resource)),await D.Promises.settled(a.map(o=>(this.logService.trace("Deleting vsix from cache",o.path),this.fileService.del(o))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?v.ExtensionKey.create(g).toString().toLowerCase():(0,b.generateUuid)()}};C=pe([K(0,w.INativeEnvironmentService),K(1,h.IFileService),K(2,p.IExtensionGalleryService),K(3,S.ILogService)],C),e.ExtensionsDownloader=C}),define(ne[204],re([0,1,2,12,28,44]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends D.Disposable{constructor(E,b){super(),this.environmentService=E,this.extensionsManifestCache=(0,r.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(b.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(E){E.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(E){E.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(ne[205],re([0,1,95,19,6,2,22,12,28,14,29,33,8,69]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let h=class extends v.LanguagePackBaseService{constructor(g,a,d,c){super(d),this.extensionManagementService=g,this.logService=c,this.cache=this._register(new S(a,c)),this.extensionManagementService.registerParticipant({postInstall:async i=>this.postInstallExtension(i),postUninstall:async i=>this.postUninstallExtension(i)})}async getInstalledLanguages(){const g=await this.cache.getLanguagePacks(),a=Object.keys(g).map(d=>{const c=g[d];return{...this.createQuickPickItem(d,c.label),extensionId:c.extensions[0].extensionIdentifier.id}});return a.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),a.sort((d,c)=>d.label.localeCompare(c.label)),a}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const a=await this.cache.getLanguagePacks();Object.keys(a).some(d=>a[d]&&a[d].extensions.some(c=>(0,w.areSameExtensions)(c.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,a]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),d=await this.cache.update(a);return!(0,r.equals)(Object.keys(g),Object.keys(d))}};h=pe([K(0,I.IExtensionManagementService),K(1,b.INativeEnvironmentService),K(2,I.IExtensionGalleryService),K(3,p.ILogService)],h),e.NativeLanguagePackService=h;let S=class extends L.Disposable{constructor(g,a){super(),this.logService=a,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(a=>{Object.keys(a).forEach(d=>delete a[d]),this.createLanguagePacksFromExtensions(a,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...a){for(const d of a)d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,d);Object.keys(g).forEach(d=>this.updateHash(g[d]))}createLanguagePacksFromExtension(g,a){const d=a.identifier,c=a.manifest.contributes&&a.manifest.contributes.localizations?a.manifest.contributes.localizations:[];for(const i of c)if(a.location.scheme===T.Schemas.file&&C(i)){let o=g[i.languageId];o||(o={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},g[i.languageId]=o);const t=o.extensions.filter(n=>(0,w.areSameExtensions)(n.extensionIdentifier,d))[0];t?t.version=a.manifest.version:o.extensions.push({extensionIdentifier:d,version:a.manifest.version});for(const n of i.translations)o.translations[n.id]=(0,P.join)(a.location.fsPath,n.path)}}updateHash(g){if(g){const a=(0,D.createHash)("md5");for(const d of g.extensions)a.update(d.extensionIdentifier.uuid||d.extensionIdentifier.id).update(d.version);g.hash=a.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let a=null;return E.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,d=>d.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(d)).then(d=>{try{return JSON.parse(d)}catch{return{}}}).then(d=>(a=g(d),d)).then(d=>{for(const i of Object.keys(d))d[i]||delete d[i];this.languagePacks=d,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),E.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>a,d=>this.logService.error(d))})}};S=pe([K(0,b.INativeEnvironmentService),K(1,p.ILogService)],S);function C(m){if(typeof m.languageId!="string"||!Array.isArray(m.translations)||m.translations.length===0)return!1;for(const g of m.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(m.languageName&&typeof m.languageName!="string"||m.localizedLanguageName&&typeof m.localizedLanguageName!="string")}}),define(ne[206],re([0,1,6,16,23,9,3,2,30,88,201,101]),function(Q,e,D,r,R,L,T,P,E,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var v;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function h(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function S(W){const V=new R.CancellationTokenSource;return setTimeout(()=>V.cancel(),W),V.token}function C(W,V){if(W.isCancellationRequested||V.isCancellationRequested)return R.CancellationToken.Cancelled;const U=new R.CancellationTokenSource;return W.onCancellationRequested(()=>U.cancel()),V.onCancellationRequested(()=>U.cancel()),U.token}class m{get didTimeout(){return this._state==="timedout"}constructor(V){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((U,N)=>{this._resolvePromise=U,this._rejectPromise=N}),V.isCancellationRequested?this._timeout():this._disposables.add(V.onCancellationRequested(()=>this._timeout()))}registerDisposable(V){this._state==="pending"?this._disposables.add(V):V.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const V=new Error("Time limit reached");return V.code="ETIMEDOUT",V.syscall="connect",V}resolve(V){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(V))}reject(V){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(V))}}function g(W,V){const U=new m(V);return U.registerDisposable(W.onControlMessage(N=>{const q=JSON.parse(N.toString()),B=z(q);B?U.reject(B):U.resolve(q)})),U.promise}function a(W,V,U,N,q,B,Z,oe){const X=new m(oe);return V.connect(U,N,q,B,Z,(ie,se)=>{X.didTimeout?(ie&&W.error(ie),se?.dispose()):ie||!se?X.reject(ie):X.resolve(se)}),X.promise}function d(W,V){const U=new m(V);return W.then(N=>{U.didTimeout||U.resolve(N)},N=>{U.didTimeout||U.reject(N)}),U.promise}async function c(W,V,U,N){const q=te(W,V);W.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let B;try{B=await a(W.logService,W.socketFactory,W.host,W.port,(0,w.getRemoteServerRootPath)(W),`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,`renderer-${h(V)}-${W.reconnectionToken}`,N)}catch(se){throw W.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),W.logService.error(se),se}W.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let Z,oe;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(B,null),Z=W.reconnectionProtocol,oe=!1):(Z=new b.PersistentProtocol(B,null),oe=!0),W.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const X=await d(W.signService.createNewMessage((0,E.generateUuid)()),N),ie={type:"auth",auth:W.connectionToken||"00000000000000000000",data:X.data};Z.sendControl(r.VSBuffer.fromString(JSON.stringify(ie)));try{const se=await g(Z,C(N,S(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(W.logService.trace(`${q} 4/6. received SignRequest control message.`),!await d(W.signService.validate(X,se.signedData),N)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const he=await d(W.signService.sign(se.data),N),ve={type:"connectionType",commit:W.commit,signedData:he,desiredConnectionType:V};return U&&(ve.args=U),W.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(r.VSBuffer.fromString(JSON.stringify(ve))),{protocol:Z,ownsProtocol:oe}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(W.logService.error(`${q} the handshake timed out. Error:`),W.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${q} received error control message when negotiating connection. Error:`),W.logService.error(se)),oe&&G(Z),se}}async function i(W,V,U,N){const q=Date.now(),B=te(W,V),{protocol:Z,ownsProtocol:oe}=await c(W,V,U,N),X=new m(N);return X.registerDisposable(Z.onControlMessage(ie=>{const se=JSON.parse(ie.toString()),ue=z(se);ue?(W.logService.error(`${B} received error control message when negotiating connection. Error:`),W.logService.error(ue),oe&&G(Z),X.reject(ue)):(W.reconnectionProtocol?.endAcceptReconnection(),W.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${ce(q)}!`),X.resolve({protocol:Z,firstMessage:se}))})),X.promise}async function o(W,V){const{protocol:U}=await i(W,1,void 0,V);return{protocol:U}}async function t(W,V,U){const{protocol:N,firstMessage:q}=await i(W,2,V,U),B=q&&q.debugPort;return{protocol:N,debugPort:B}}async function n(W,V,U){const N=Date.now(),q=te(W,3),{protocol:B}=await c(W,3,V,U);return W.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${ce(N)}!`),B}async function s(W,V,U){const{host:N,port:q,connectionToken:B}=await W.addressProvider.getAddress();return{commit:W.commit,quality:W.quality,host:N,port:q,connectionToken:B,reconnectionToken:V,reconnectionProtocol:U,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function u(W,V,U){return f(W,async N=>{const{protocol:q}=await o(N,R.CancellationToken.None);return new J(W,V,U,N.reconnectionToken,q)})}e.connectRemoteAgentManagement=u;async function l(W,V){return f(W,async U=>{const{protocol:N,debugPort:q}=await t(U,V,R.CancellationToken.None);return new H(W,V,U.reconnectionToken,N,q)})}e.connectRemoteAgentExtensionHost=l;async function f(W,V){for(let N=1;;N++)try{const q=(0,E.generateUuid)(),B=await s(W,q,null);return await V(B)}catch(q){if(N<5)W.logService.error(`[remote-connection][attempt ${N}] An error occurred in initial connection! Will retry... Error:`),W.logService.error(q);else throw W.logService.error(`[remote-connection][attempt ${N}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),W.logService.error(q),x.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(q)),q}}async function y(W,V,U){const N=await s(W,(0,E.generateUuid)(),null);return await n(N,{host:V,port:U},R.CancellationToken.None)}e.connectRemoteAgentTunnel=y;function A(W){return(0,D.createCancelablePromise)(V=>new Promise((U,N)=>{const q=setTimeout(U,W*1e3);V.onCancellationRequested(()=>{clearTimeout(q),U()})}))}var O;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain"})(O=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class _{constructor(V,U){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.type=0}}e.ConnectionLostEvent=_;class M{constructor(V,U,N,q){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.durationSeconds=N,this.cancellableTimer=q,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=M;class k{constructor(V,U,N){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.attempt=N,this.type=2}}e.ReconnectionRunningEvent=k;class F{constructor(V,U,N){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.attempt=N,this.type=4}}e.ConnectionGainEvent=F;class ${constructor(V,U,N,q){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.attempt=N,this.handled=q,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class x extends P.Disposable{static triggerPermanentFailure(V,U,N){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=V,this._permanentFailureAttempt=U,this._permanentFailureHandled=N,this._instances.forEach(q=>q._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(V=>V._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(V=>V._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||x._permanentFailure}constructor(V,U,N,q,B){super(),this._connectionType=V,this._options=U,this.reconnectionToken=N,this.protocol=q,this._reconnectionFailureIsFatal=B,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new F(this.reconnectionToken,0,0)),this._register(q.onSocketClose(Z=>{const oe=Y(this._connectionType,this.reconnectionToken,!0);Z?Z.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this._options.logService.error(Z.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this._options.logService.error(Z.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(q.onSocketTimeout(Z=>{const oe=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),x._instances.push(this),this._register((0,P.toDisposable)(()=>{const Z=x._instances.indexOf(this);Z>=0&&x._instances.splice(Z,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(x._permanentFailureMillisSinceLastIncomingData,x._permanentFailureAttempt,x._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const V=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${V} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const q=N<U.length?U[N]:U[U.length-1];try{if(q>0){const Z=A(q);this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,Z)),this._options.logService.info(`${V} waiting for ${q} seconds before reconnecting...`);try{await Z}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${V} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new k(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this._options.logService.info(`${V} resolving connection...`);const B=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${V} connecting to ${B.host}:${B.port}...`),await this._reconnect(B,S(p)),this._options.logService.info(`${V} reconnected!`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${V} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this._options.logService.error(`${V} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(B)){this._options.logService.info(`${V} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this._options.logService.info(`${V} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((0,L.isCancellationError)(B)){this._options.logService.info(`${V} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if(B instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${V} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,I.RemoteAuthorityResolverError.isHandled(B));break}this._options.logService.error(`${V} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(B),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(V,U,N){this._reconnectionFailureIsFatal?x.triggerPermanentFailure(V,U,N):this._gotoPermanentFailure(V,U,N)}_gotoPermanentFailure(V,U,N){this._onDidStateChange.fire(new $(this.reconnectionToken,V,U,N)),G(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=x,x._permanentFailure=!1,x._permanentFailureMillisSinceLastIncomingData=0,x._permanentFailureAttempt=0,x._permanentFailureHandled=!1,x._instances=[];class J extends x{constructor(V,U,N,q,B){super(1,V,q,B,!0),this.client=this._register(new b.Client(B,{remoteAuthority:U,clientId:N},V.ipcLogger))}async _reconnect(V,U){await o(V,U)}}e.ManagementPersistentConnection=J;class H extends x{constructor(V,U,N,q,B){super(2,V,N,q,!1),this._startArguments=U,this.debugPort=B}async _reconnect(V,U){await t(V,this._startArguments,U)}}e.ExtensionHostPersistentConnection=H;function G(W){try{W.acceptDisconnect();const V=W.getSocket();W.dispose(),V.dispose()}catch(V){(0,L.onUnexpectedError)(V)}}function z(W){if(W&&W.type==="error"){const V=new Error(`Connection error: ${W.reason}`);return V.code="VSCODE_CONNECTION_ERROR",V}return null}function j(W,V){for(;W.length<V;)W+=" ";return W}function Y(W,V,U){return`[remote-connection][${j(h(W),13)}][${V.substr(0,5)}\u2026][${U?"reconnect":"initial"}]`}function te(W,V){return`${Y(V,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function ce(W){return`${Date.now()-W} ms`}}),define(ne[207],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[208],re([0,1,80,138]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,L,T,P,E,b){const I=p=>b(p,void 0),w=D.createConnection({host:R,port:L},()=>{w.removeListener("error",I);const p=Buffer.alloc(16);for(let C=0;C<16;C++)p[C]=Math.round(Math.random()*256);const v=p.toString("base64"),h=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${L}${T}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`];w.write(h.join(`\r
`)+`\r
\r
`);const S=C=>{C.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",S),b(void 0,new r.NodeSocket(w,E)))};w.on("data",S)});w.setNoDelay(!0),w.once("error",I)}}}),define(ne[209],re([0,1,121,18,8]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(P,E){this.configurationService=P,this.logService=E}async request(P,E){this.logService.trace("RequestService#request (browser) - begin",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const b=await(0,D.request)(P,E);return this.logService.trace("RequestService#request (browser) - success",P.url),b}catch(b){throw this.logService.error("RequestService#request (browser) - error",P.url,b),b}}async resolveProxy(P){}};L=pe([K(0,r.IConfigurationService),K(1,R.ILogService)],L),e.RequestService=L}),define(ne[45],re([0,1,16,156,43,5,40]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function P(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=P;function E(S){return S.res.statusCode===204}async function b(S){return E(S)?null:(await(0,D.streamToBuffer)(S.stream)).toString()}e.asText=b;async function I(S){if(!P(S))throw new Error("Server returned "+S.res.statusCode);return b(S)}e.asTextOrError=I;async function w(S){if(!P(S))throw new Error("Server returned "+S.res.statusCode);if(E(S))return null;const m=(await(0,D.streamToBuffer)(S.stream)).toString();try{return JSON.parse(m)}catch(g){throw g.message+=`:
`+m,g}}e.asJson=w;function p(S){h(S)}e.updateProxyConfigurationsScope=p;let v;function h(S){const C=T.Registry.as(R.Extensions.Configuration),m=v;v={id:"http",order:15,title:(0,r.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,r.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,r.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,r.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,r.localize)(4,null),(0,r.localize)(5,null),(0,r.localize)(6,null),(0,r.localize)(7,null)],default:"override",description:(0,r.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,r.localize)(9,null),restricted:!0}}},C.updateConfigurations({add:[v],remove:m?[m]:[]})}h(2)}),define(ne[210],re([0,1,23,22,13,45]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(E,b){this.requestService=E,this.fileService=b}async download(E,b,I=D.CancellationToken.None){if(E.scheme===r.Schemas.file||E.scheme===r.Schemas.vscodeRemote){await this.fileService.copy(E,b);return}const w={type:"GET",url:E.toString(!0)},p=await this.requestService.request(w,I);if(p.res.statusCode===200)await this.fileService.writeFile(b,p.stream);else{const v=await(0,L.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${v}`)}}};T=pe([K(0,L.IRequestService),K(1,R.IFileService)],T),e.DownloadService=T}),define(ne[211],re([0,1,19,23,2,17,173,13,8,25,45]),function(Q,e,D,r,R,L,T,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let w=class extends R.Disposable{constructor(v,h,S,C){super(),this.fileService=v,this.productService=h,this.requestService=S,this.logService=C,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,m])=>this.allConfigBasedTips.set(m.configPath,m))}getConfigBasedTips(v){return this.getValidConfigBasedTips(v)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(v){const h=[];for(const[S,C]of this.allConfigBasedTips)if(!(C.configScheme&&C.configScheme!==v.scheme))try{const m=await this.fileService.readFile((0,L.joinPath)(v,S)),g=new Map;Object.entries(C.recommendations).forEach(([d,c])=>{if((0,D.isNonEmptyArray)(c.remotes))for(const i of c.remotes)g.set(i,{extensionId:d,extensionName:c.name,configName:C.configName,important:!!c.important,isExtensionPack:!!c.isExtensionPack,whenNotInstalled:c.whenNotInstalled});else h.push({extensionId:d,extensionName:c.name,configName:C.configName,important:!!c.important,isExtensionPack:!!c.isExtensionPack,whenNotInstalled:c.whenNotInstalled})});const a=(0,T.getDomainsOfRemotes)(m.value.toString(),[...g.keys()]);for(const d of a){const c=g.get(d);c&&h.push(c)}}catch{}return h}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const v=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},r.CancellationToken.None);if(v.res.statusCode!==200)return[];const h=await(0,I.asJson)(v);return h?h.workspaceRecommendations||[]:[]}catch(v){return this.logService.error(v),[]}}};w=pe([K(0,P.IFileService),K(1,b.IProductService),K(2,I.IRequestService),K(3,E.ILogService)],w),e.ExtensionTipsService=w}),define(ne[212],re([0,1,16,23]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class R{constructor(P){this.service=P}listen(P,E){throw new Error("Invalid listen")}call(P,E,b,I=r.CancellationToken.None){switch(E){case"request":return this.service.request(b[0],I).then(async({res:w,stream:p})=>{const v=await(0,D.streamToBuffer)(p);return[{statusCode:w.statusCode,headers:w.headers},v]});case"resolveProxy":return this.service.resolveProxy(b[0])}throw new Error("Invalid call")}}e.RequestChannel=R;class L{constructor(P){this.channel=P}async request(P,E){const[b,I]=await this.channel.call("request",[P],E);return{res:b,stream:(0,D.bufferToStream)(I)}}async resolveProxy(P){return this.channel.call("resolveProxy",[P])}}e.RequestChannelClient=L}),define(ne[213],re([0,1,209,212]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class R{constructor(T,P,E){this.configurationService=P,this.logService=E,this.browserRequestService=new D.RequestService(P,E),this.mainRequestService=new r.RequestChannelClient(T.getChannel("request"))}request(T,P){return this.getRequestService().request(T,P)}async resolveProxy(T){return this.getRequestService().resolveProxy(T)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=R}),define(ne[102],re([0,1,64,5]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function R(L){return(0,D.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=R,e.ISharedProcessWorkerService=(0,r.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[214],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(r){r.Spawn="vscode:shared-process->shared-process-worker=spawn",r.Terminate="vscode:shared-process->shared-process-worker=terminate",r.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",r.Ready="vscode:shared-process-worker->shared-process=ready",r.Ack="vscode:shared-process-worker->shared-process=ack",r.Trace="vscode:shared-process-worker->shared-process=trace",r.Info="vscode:shared-process-worker->shared-process=info",r.Warn="vscode:shared-process-worker->shared-process=warn",r.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[215],re([0,1,89,6,23,3,2,22,30,8,102,214]),function(Q,e,D,r,R,L,T,P,E,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(S){this.logService=S,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(S){const C=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${C})`);const m=(0,I.hash)(S);this.processeDisposables.has(m)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${C})`),this.doDisposeWorker(S));const g=new R.CancellationTokenSource;let a,d,c;this.processeDisposables.set(m,n=>{g.dispose(!0),a?.terminate(S,R.CancellationToken.None),d?.close(),c?.close(),this.processeDisposables.delete(m);const s=this.processResolvers.get(m);s&&(this.processResolvers.delete(m),s({reason:n}))}),a=await this.getOrCreateWebWorker(S);const i=new Promise(n=>{this.processResolvers.set(m,n)});if(g.token.isCancellationRequested)return i;const{port1:o,port2:t}=new MessageChannel;return d=o,c=t,await a.spawn(S,c,g.token),g.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${C})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",S,[d])),i}getOrCreateWebWorker(S){let C=this.workers.get(S.process.moduleId);if(!C){this.logService.trace(`SharedProcess: creating new web worker (${S.process.moduleId})`);const m=new v(S.process.type,this.logService);C=m.init(),m.onDidProcessSelfTerminate(({configuration:g,reason:a})=>{this.doDisposeWorker(g,a)}),this.workers.set(S.process.moduleId,C)}return C}async disposeWorker(S){return this.doDisposeWorker(S)}doDisposeWorker(S,C){const m=this.processeDisposables.get((0,I.hash)(S));m&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),m(C))}};p=pe([K(0,b.ILogService)],p),e.SharedProcessWorkerService=p;class v extends T.Disposable{constructor(S,C){super(),this.type=S,this.logService=C,this._onDidProcessSelfTerminate=this._register(new L.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const S=new r.DeferredPromise,C=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return C.onerror=m=>{this.logService.error(`SharedProcess: worker error (${this.type})`,m.message)},C.onmessageerror=m=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,m)},C.onmessage=m=>{const{id:g,message:a,configuration:d,nonce:c}=m.data;switch(g){case w.SharedProcessWorkerMessages.Ready:S.complete(C);break;case w.SharedProcessWorkerMessages.Ack:if(c){const i=this.mapMessageNonceToPendingMessageResolve.get(c);i&&(this.mapMessageNonceToPendingMessageResolve.delete(c),i())}break;case w.SharedProcessWorkerMessages.SelfTerminated:d&&a&&this._onDidProcessSelfTerminate.fire({configuration:d,reason:JSON.parse(a)});break;case w.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,a);break;case w.SharedProcessWorkerMessages.Info:a&&this.logService.info(a);break;case w.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,a);break;case w.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,a);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,m)}},C.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S.p}async send(S,C,m){const g=await this.workerReady;if(!C.isCancellationRequested)return new Promise(a=>{const d=(0,E.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(d,a);const c={...S,nonce:d};m?g.postMessage(c,[m]):g.postMessage(c),C.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(d)&&a()})})}spawn(S,C,m){const g={id:w.SharedProcessWorkerMessages.Spawn,configuration:S,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork",Q).fsPath}};return this.send(g,m,C)}terminate(S,C){const m={id:w.SharedProcessWorkerMessages.Terminate,configuration:S};return this.send(m,C)}}}),define(ne[216],re([0,1,62,22,172]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class L extends R.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}}pe([D.memoize],L.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=L}),define(ne[217],re([0,1,54,12,157,23,38,9,4,30,135,170,6]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const v=1e4;let h;async function S(m,g,a){return g["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):E.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(a)&&!g["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(a)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=p.Promises.withAsyncBody(async(d,c)=>{const i=new L.CancellationTokenSource,o=setTimeout(()=>{i.dispose(!0),c(new Error((0,R.localize)(0,null)))},v);try{d(await C(m,i.token))}catch(t){!(0,P.isCancellationError)(t)&&!i.token.isCancellationRequested?c(new Error((0,R.localize)(1,null,(0,T.toErrorMessage)(t)))):d({})}finally{clearTimeout(o),i.dispose()}})),h)}e.getResolvedShellEnv=S;async function C(m,g){const a=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",a);const d=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",d);const c=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(c+"(.*)"+c),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",o);const t=await(0,I.getSystemShell)(E.OS,o);return m.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(g.isCancellationRequested)return s((0,P.canceled)());const u=(0,r.basename)(t);let l,f;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(l=`& '${process.execPath}' ${y} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,f=["-Login","-Command"]):(l=`'${process.execPath}' ${y} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,u==="tcsh"?f=["-ic"]:f=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),l);const A=(0,D.spawn)(t,[...f,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});g.onCancellationRequested(()=>(A.kill(),s((0,P.canceled)()))),A.on("error",M=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(M)),s(M)});const O=[];A.stdout.on("data",M=>O.push(M));const _=[];A.stderr.on("data",M=>_.push(M)),A.on("close",(M,k)=>{const F=Buffer.concat(O).toString("utf8");m.trace("getUnixShellEnvironment#raw",F);const $=Buffer.concat(_).toString("utf8");if($.trim()&&m.trace("getUnixShellEnvironment#stderr",$),M||k)return s(new Error((0,R.localize)(2,null,M,k)));const x=i.exec(F),J=x?x[1]:"{}";try{const H=JSON.parse(J);a?H.ELECTRON_RUN_AS_NODE=a:delete H.ELECTRON_RUN_AS_NODE,d?H.ELECTRON_NO_ATTACH_CONSOLE=d:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",H),n(H)}catch(H){m.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(H)),s(H)}})})}}),define(ne[103],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[218],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((R,L)=>Q(["vsda"],R,L))}async createNewMessage(R){try{const L=await this.vsda(),T=new L.validator;if(T){const P=String(D._nextId++);return this.validators.set(P,T),{id:P,data:T.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,L){if(!R.id)return!0;const T=this.validators.get(R.id);if(!T)return!1;this.validators.delete(R.id);try{return T.validate(L)==="ok"}catch{return!1}}async sign(R){try{const L=await this.vsda(),T=new L.signer;if(T)return T.sign(R)}catch{}return R}}e.SignService=D,D._nextId=1}),define(ne[71],re([0,1,3,2]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class R extends r.Disposable{constructor(w,p,v){super(),this.channel=w,this.profile=p,this.workspace=v}async getItems(){const w={profile:this.profile,workspace:this.workspace},p=await this.channel.call("getItems",w);return new Map(p)}updateItems(w){const p={profile:this.profile,workspace:this.workspace};return w.insert&&(p.insert=Array.from(w.insert.entries())),w.delete&&(p.delete=Array.from(w.delete.values())),this.channel.call("updateItems",p)}}class L extends R{constructor(w,p){super(w,p,void 0),this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(w=>this.onDidChangeStorage(w)))}onDidChangeStorage(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this._onDidChangeItemsExternal.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}}class T extends L{constructor(w){super(w,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=T;class P extends L{constructor(w,p){super(w,p)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=P;class E extends R{constructor(w,p){super(w,void 0,p),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=E;class b{constructor(w){this.channel=w}isUsed(w){const p={payload:w,profile:void 0,workspace:void 0};return this.channel.call("isUsed",p)}}e.StorageClient=b}),define(ne[104],re([0,1,4,36,7,30]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(b){if(D.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function P(b,I,w,p,v,h,S,C,m,g){const a=Object.create(null);a["common.machineId"]=S,a.sessionID=(0,L.generateUuid)()+Date.now(),a.commitHash=v,a.version=h,a["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,D.PlatformToString)(D.platform),a["common.nodePlatform"]=r.platform,a["common.nodeArch"]=p,a["common.product"]=g||"desktop",C&&(a["common.msftInternal"]=C);let d=0;const c=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),D.isLinuxSnap&&(a["common.snap"]="true");const i=T(w);i&&(a["common.platformDetail"]=i);try{const o=await b.readFile(R.URI.file(m));a["common.source"]=o.value.toString().slice(0,30)}catch{}return a}e.resolveCommonProperties=P;function E(b){const I=r.env.USERDNSDOMAIN;if(!I)return!1;const w=I.toLowerCase();return b.some(p=>w===p)}e.verifyMicrosoftInternalDomain=E}),define(ne[24],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var r;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(r=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[219],re([0,1,37,52,6,35,22,12,4,7,132,28,134,92,13,25,24]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const m=new Map;async function g(o,t){const n=`${o}::${t.join(":")}`,s=m.get(n);if(s)return s;const u=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,f=new Map,y=2e4;function A(_,M,k,F){const $=M.substring(_.length+1);return R.Promises.withAsyncBody(async x=>{let J;try{J=await w.Promises.readdir(M,{withFileTypes:!0})}catch{x();return}if(F.count>=y){F.count+=J.length,F.maxReached=!0,x();return}let H=J.length;if(H===0){x();return}let G=J;F.count+J.length>y&&(F.maxReached=!0,H=y-F.count,G=J.slice(0,H)),F.count+=J.length;for(const z of G)if(z.isDirectory()){if(k.includes(z.name)||await A(_,(0,P.join)(M,z.name),k,F),--H===0){x();return}}else{const j=z.name.lastIndexOf(".");if(j>=0){const Y=z.name.substring(j+1);Y&&l.set(Y,(l.get(Y)??0)+1)}for(const Y of u)Y.relativePathPattern?.test($)!==!1&&Y.filePattern.test(z.name)&&f.set(Y.tag,(f.get(Y.tag)??0)+1);if(--H===0){x();return}}})}const O=R.Promises.withAsyncBody(async _=>{const M={count:0,maxReached:!1};await A(o,o,t,M);const k=await c(o);_({configFiles:a(f),fileTypes:a(l),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:k})});return m.set(n,O),O}e.collectWorkspaceStats=g;function a(o){return[...r.Iterable.map(o.entries(),([t,n])=>({name:t,count:n}))].sort((t,n)=>n.count-t.count)}function d(){const o={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},t=D.cpus();return t&&t.length>0&&(o.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),o}e.getMachineInfo=d;async function c(o){try{const t=new Map,n=(0,P.join)(o,".vscode","launch.json"),s=await w.Promises.readFile(n),u=[],l=(0,L.parse)(s.toString(),u);if(u.length)return console.log(`Unable to parse ${n}`),[];if((0,L.getNodeType)(l)==="object"&&l.configurations)for(const f of l.configurations){const y=f.type;y&&(t.has(y)?t.set(y,t.get(y)+1):t.set(y,1))}return a(t)}catch{return[]}}e.collectLaunchConfigs=c;let i=class{constructor(t,n){this.telemetryService=t,this.productService=n}formatMachineInfo(t){const n=[];return n.push(`OS Version:       ${t.os}`),n.push(`CPUs:             ${t.cpus}`),n.push(`Memory (System):  ${t.memory}`),n.push(`VM:               ${t.vmHint}`),n.join(`
`)}formatEnvironment(t){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const s=D.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),E.isWindows||n.push(`Load (avg):       ${D.loadavg().map(u=>Math.round(u)).join(", ")}`),n.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${t.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(t,n){return Promise.all([(0,p.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async s=>{let[u,l]=s,f=this.formatProcessList(t,u);return n.forEach(y=>{if((0,v.isRemoteDiagnosticError)(y))f+=`
${y.errorMessage}`,l+=`
${y.errorMessage}`;else if(f+=`

Remote: ${y.hostName}`,y.processes&&(f+=`
${this.formatProcessList(t,y.processes)}`),y.workspaceMetadata){l+=`
|  Remote: ${y.hostName}`;for(const A of Object.keys(y.workspaceMetadata)){const O=y.workspaceMetadata[A];let _=`${O.fileCount} files`;O.maxFilesReached&&(_=`more than ${_}`),l+=`|    Folder (${A}): ${_}`,l+=this.formatWorkspaceStats(O)}}}),{processInfo:f,workspaceInfo:l}})}async getSystemInfo(t,n){const{memory:s,vmHint:u,os:l,cpus:f}=d(),y={os:l,memory:s,cpus:f,vmHint:u,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:n};return E.isWindows||(y.load=`${D.loadavg().map(A=>Math.round(A)).join(", ")}`),E.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(t,n){const s=[];return(0,p.listProcesses)(t.mainPID).then(async u=>(s.push(""),s.push(this.formatEnvironment(t)),s.push(""),s.push(this.formatProcessList(t,u)),t.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(t))),n.forEach(l=>{if((0,v.isRemoteDiagnosticError)(l))s.push(`
${l.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${l.hostName}`),s.push(this.formatMachineInfo(l.machineInfo)),l.processes&&s.push(this.formatProcessList(t,l.processes)),l.workspaceMetadata)for(const f of Object.keys(l.workspaceMetadata)){const y=l.workspaceMetadata[f];let A=`${y.fileCount} files`;y.maxFilesReached&&(A=`more than ${A}`),s.push(`Folder (${f}): ${A}`),s.push(this.formatWorkspaceStats(y))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(t){const n=[];let u=0;const l=(O,_)=>{const M=` ${O}(${_})`;u+M.length>60?(n.push(f),f="|                 ",u=f.length):u+=M.length,f+=M};let f="|      File types:";const y=10,A=t.fileTypes.length>y?y:t.fileTypes.length;for(let O=0;O<A;O++){const _=t.fileTypes[O];l(_.name,_.count)}if(n.push(f),t.configFiles.length>=0&&(f="|      Conf files:",u=0,t.configFiles.forEach(O=>{l(O.name,O.count)}),n.push(f)),t.launchConfigFiles.length>0){let O="|      Launch Configs:";t.launchConfigFiles.forEach(_=>{O+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),n.push(O)}return n.join(`
`)}expandGPUFeatures(t){const n=Math.max(...Object.keys(t).map(s=>s.length));return Object.keys(t).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${t[s]}`).join(`
                  `)}formatWorkspaceMetadata(t){const n=[],s=[];return t.windows.forEach(u=>{u.folderURIs.length===0||!!u.remoteAuthority||(n.push(`|  Window (${u.title})`),u.folderURIs.forEach(l=>{const f=b.URI.revive(l);if(f.scheme===T.Schemas.file){const y=f.fsPath;s.push(g(y,["node_modules",".git"]).then(A=>{let O=`${A.fileCount} files`;A.maxFilesReached&&(O=`more than ${O}`),n.push(`|    Folder (${(0,P.basename)(y)}): ${O}`),n.push(this.formatWorkspaceStats(A))}).catch(A=>{n.push(`|      Error: Unable to collect workspace stats for folder ${y} (${A.toString()})`)}))}else n.push(`|    Folder (${f.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(u=>n.join(`
`)).catch(u=>`Unable to collect workspace stats: ${u}`)}formatProcessList(t,n){const s=new Map;t.windows.forEach(l=>s.set(l.pid,l.title));const u=[];return u.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(t.mainPID,s,u,n,0),u.join(`
`)}formatProcessItem(t,n,s,u,l){const f=l===0;let y;f?y=u.pid===t?`${this.productService.applicationName} main`:"remote agent":(y=`${"  ".repeat(l)} ${u.name}`,u.name==="window"&&(y=`${y} (${n.get(u.pid)})`));const A=process.platform==="win32"?u.mem:D.totalmem()*(u.mem/100);s.push(`${u.load.toFixed(0).padStart(5," ")}	${(A/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${u.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(u.children)&&u.children.forEach(O=>this.formatProcessItem(t,n,s,O,l+1))}async getWorkspaceFileExtensions(t){const n=new Set;for(const{uri:s}of t.folders){const u=b.URI.revive(s);if(u.scheme!==T.Schemas.file)continue;const l=u.fsPath;try{(await g(l,["node_modules",".git"])).fileTypes.forEach(y=>n.add(y.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(t){for(const{uri:n}of t.folders){const s=b.URI.revive(n);if(s.scheme!==T.Schemas.file)continue;const u=s.fsPath;try{const l=await g(u,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),l.fileTypes.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:f.name,count:f.count})}),l.launchConfigFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:f.name,count:f.count})}),l.configFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:f.name,count:f.count})})}catch{}}}};i=pe([K(0,C.ITelemetryService),K(1,S.IProductService)],i),e.DiagnosticsService=i}),define(ne[105],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(L){this.appenders=L}listen(L,T){throw new Error(`Event not found: ${T}`)}call(L,T,{eventName:P,data:E}){return this.appenders.forEach(b=>b.log(P,E)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class r{constructor(L){this.channel=L}log(L,T){return this.channel.call("log",{eventName:L,data:T}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=r}),define(ne[50],re([0,1,32,82,15,18,104,24]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class E{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,r.staticObservableValue)(0)}publicLog(i,o){return Promise.resolve(void 0)}publicLog2(i,o){return this.publicLog(i,o)}publicLogError(i,o){return Promise.resolve(void 0)}publicLogError2(i,o){return this.publicLogError(i,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=E,e.NullTelemetryService=new E;class b{async publicLog(i,o,t){}async publicLogError(i,o,t){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(c,i){return i.onDidChangeConfiguration(o=>{o.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(o.source),configurationKeys:m(o.sourceConfig)})})}e.configurationTelemetry=I;function w(c,i){return!(i.disableTelemetry||!c.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=w;function p(c){const i=c.getValue(P.TELEMETRY_SETTING_ID),o=c.getValue("telemetry.enableCrashReporter");if(c.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function v(c){const i={},o={},t={};C(c,t);for(let n in t){n=n.length>150?n.substr(n.length-149):n;const s=t[n];typeof s=="number"?o[n]=s:typeof s=="boolean"?o[n]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${s.length}`),i[n]=s.substring(0,8191)):typeof s<"u"&&s!==null&&(i[n]=s)}return{properties:i,measurements:o}}e.validateTelemetryData=v;const h=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function S(c){if(!c)return"none";for(const i of h)if(c.startsWith(`${i}+`))return i;return"other"}e.cleanRemoteAuthority=S;function C(c,i,o=0,t){if(!!c)for(const n of Object.getOwnPropertyNames(c)){const s=c[n],u=t?t+n:n;Array.isArray(s)?i[u]=(0,D.safeStringify)(s):s instanceof Date?i[u]=s.toISOString():(0,R.isObject)(s)?o<2?C(s,i,o+1,u+"."):i[u]=(0,D.safeStringify)(s):i[u]=s}}function m(c){if(!c)return[];const i=[];return g(i,"",c),i}function g(c,i,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(t=>g(c,i?`${i}.${t}`:t,o[t])):c.push(i)}function a(c,i){const o=c.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(o)||t}e.isInternalTelemetry=a;function d(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=d}),define(ne[220],re([0,1,48,50]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(L,T,P,E,b,I,w){const p={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${T.nameShort})`};if((0,r.supportsTelemetry)(T,P)&&(0,r.getTelemetryLevel)(E)===3){const v=await(0,D.getServiceMachineId)(P,b,I),{sessionId:h}=await w.getTelemetryInfo();p["X-Market-User-Id"]=v,p["VSCode-SessionId"]=h}return p}e.resolveMarketplaceHeaders=R}),define(ne[221],re([0,1,9,32,50]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function T(E,b,I){const w=await new Promise((C,m)=>{Q(["@microsoft/1ds-core-js"],C,m)}),p=await new Promise((C,m)=>{Q(["@microsoft/1ds-post-js"],C,m)}),v=new w.AppInsightsCore,h=new p.PostChannel,S={instrumentationKey:E,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[h]]};if(I){S.extensionConfig={};const C={alwaysUseXhrOverride:!0,httpXHROverride:I};S.extensionConfig[h.identifier]=C}return v.initialize(S,[]),v.addTelemetryInitializer(C=>{b&&(C.ext=C.ext??{},C.ext.utc=C.ext.utc??{},C.ext.utc.flags=8462029)}),v}class P{constructor(b,I,w,p,v){this._isInternalTelemetry=b,this._eventPrefix=I,this._defaultData=w,this._xhrOverride=v,this.endPointUrl=L,this._defaultData||(this._defaultData={}),typeof p=="function"?this._aiCoreOrKey=p():this._aiCoreOrKey=p,this._asyncAiCore=null}_withAIClient(b){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){b(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=T(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(I=>{b(I)},I=>{(0,D.onUnexpectedError)(I),console.error(I)})}}log(b,I){if(!this._aiCoreOrKey)return;I=(0,r.mixin)(I,this._defaultData),I=(0,R.validateTelemetryData)(I);const w=this._eventPrefix+"/"+b;try{this._withAIClient(p=>{p.pluginVersionString=I?.properties.version??"Unknown",p.track({name:w,baseData:{name:w,properties:I?.properties,measurements:I?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(b=>{this._withAIClient(I=>{I.unload(!0,()=>{this._aiCoreOrKey=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(ne[106],re([0,1,2,14,8,50]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends D.Disposable{constructor(E,b,I=""){super(),this.prefix=I;const w=E.getLogger(b.telemetryLogResource);w?this.logger=this._register(w):(this.logger=this._register(E.createLogger(b.telemetryLogResource)),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(E,b){this.logger.trace(`${this.prefix}telemetry/${E}`,(0,L.validateTelemetryData)(b))}};T=pe([K(0,R.ILoggerService),K(1,r.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(ne[107],re([0,1,2,32,82,4,27,158,18,43,99,25,40,24,50]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(g,a,d){this._configurationService=a,this._productService=d,this._experimentProperties={},this.telemetryLevel=new R.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,a){this._experimentProperties[g]=a}_updateTelemetryLevel(){let g=(0,h.getTelemetryLevel)(this._configurationService);const a=this._productService.enabledTelemetryLevels;if(a){this._sendErrorTelemetry=this.sendErrorTelemetry?a.error:!1;const d=a.usage?3:a.error?2:0;g=Math.min(g,d)}this.telemetryLevel.value=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const g=await this._commonProperties,a=g.sessionID,d=g["common.machineId"],c=g["common.firstSessionDate"],i=g["common.msftInternal"];return{sessionId:a,machineId:d,firstSessionDate:c,msftInternal:i}}dispose(){this._disposables.dispose()}_log(g,a,d,c){return this.telemetryLevel.value<a?Promise.resolve(void 0):this._commonProperties.then(i=>{d=(0,r.mixin)(d,i),d=(0,r.mixin)(d,this._experimentProperties),d=(0,r.cloneAndChange)(d,o=>{if(typeof o=="string")return this._cleanupInfo(o,c)}),this._appenders.forEach(o=>o.log(g,d))},i=>{console.error(i)})}publicLog(g,a,d){return this._log(g,3,a,d)}publicLog2(g,a,d){return this.publicLog(g,a,d)}publicLogError(g,a){return this._sendErrorTelemetry?this._log(g,2,a,!0):Promise.resolve(void 0)}publicLogError2(g,a){return this.publicLogError(g,a)}_anonymizeFilePaths(g){let a=g;const d=[];for(const t of this._cleanupPatterns)for(;;){const n=t.exec(g);if(!n)break;d.push([n.index,t.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(a="";;){const t=i.exec(g);if(!t)break;!c.test(t[0])&&d.every(([n,s])=>t.index<n||t.index>=s)&&(a+=g.substring(o,t.index)+"<REDACTED: user-file-path>",o=i.lastIndex)}return o<g.length&&(a+=g.substr(o)),a}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const a=g.toLowerCase(),d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const c of d)if(c.regex.test(a))return`<REDACTED: ${c.label}>`;return g}_cleanupInfo(g,a){let d=g;a&&(d=this._anonymizeFilePaths(d));for(const c of this._cleanupPatterns)d=d.replace(c,"");return d=this._removePropertiesWithPossibleUserInfo(d),d}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=pe([K(1,E.IConfigurationService),K(2,w.IProductService)],S),e.TelemetryService=S;function C(){const m=(0,P.localize)(0,null,I.default.nameLong),g=I.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),a=L.isWeb?"":(0,P.localize)(3,null),d=(0,P.localize)(4,null),c=(0,P.localize)(5,null),i=(0,P.localize)(6,null),o=(0,P.localize)(7,null),t=`
|       | ${d} | ${c} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,P.localize)(8,null);return`
${m} ${g} ${a}

&nbsp;

${o}
${t}

&nbsp;

${n}
`}p.Registry.as(b.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:C(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(b.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,P.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,P.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[222],re([0,1,279,221]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class R extends r.AbstractOneDataSystemAppender{constructor(T,P,E,b){const I={sendPOST:(w,p)=>{const v={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const h=D.request(w.urlString,v,S=>{S.on("data",function(C){p(S.statusCode??200,S.headers,C.toString())}),S.on("error",function(C){p(0,{})})});h.write(w.data),h.end()}catch{p(0,{})}}};super(T,P,E,b,I)}}e.OneDataSystemAppender=R}),define(ne[223],re([0,1,22,66,18,14,8,25,24,105,106,107]),function(Q,e,D,r,R,L,T,P,E,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(h,S,C,m,g){this.configurationService=h,this.telemetryService=S,this.loggerService=C,this.environmentService=m,this.productService=g,this.customTelemetryServices=new Map}async getCustomTelemetryService(h){if(!this.customTelemetryServices.has(h.id)){const{machineId:S,sessionId:C}=await this.telemetryService.getTelemetryInfo(),m=Object.create(null);m["common.vscodemachineid"]=S,m["common.vscodesessionid"]=C;const g=[h.id,JSON.stringify(m),h.aiKey],d=new r.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new b.TelemetryAppenderClient(d),new I.TelemetryLogAppender(this.loggerService,this.environmentService,`[${h.id}] `)];this.customTelemetryServices.set(h.id,new w.TelemetryService({appenders:c,sendErrorTelemetry:h.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(h.id)}async publicLog(h,S,C){await(await this.getCustomTelemetryService(h)).publicLog(S,C)}async publicLogError(h,S,C){await(await this.getCustomTelemetryService(h)).publicLogError(S,C)}};p=pe([K(0,R.IConfigurationService),K(1,E.ITelemetryService),K(2,T.ILoggerService),K(3,L.IEnvironmentService),K(4,P.IProductService)],p),e.CustomEndpointTelemetryService=p}),define(ne[224],re([0,1,6,23,3,2,8]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends L.Disposable{constructor(b,I){super(),this._logService=I,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((I,w)=>{const p=++this._lastRequestId;this._pendingRequests.set(p,I),this._onCreateRequest.fire({requestId:p,...b});const v=new r.CancellationTokenSource;(0,D.timeout)(this._timeout,v.token).then(()=>w(`Request ${p} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(p,[(0,L.toDisposable)(()=>v.cancel())])})}acceptReply(b,I){const w=this._pendingRequests.get(b);w?(this._pendingRequests.delete(b),(0,L.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),w(I)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};P=pe([K(1,T.ILogService)],P),e.RequestStore=P}),define(ne[108],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var r;(function(a){a.Shell="terminal.integrated.shell.",a.ShellArgs="terminal.integrated.shellArgs.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(r=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(a){a.ShellLinux="terminal.integrated.shell.linux",a.ShellMacOs="terminal.integrated.shell.osx",a.ShellWindows="terminal.integrated.shell.windows",a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationShellLinux="terminal.integrated.automationShell.linux",a.AutomationShellMacOs="terminal.integrated.automationShell.osx",a.AutomationShellWindows="terminal.integrated.automationShell.windows",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ShellArgsLinux="terminal.integrated.shellArgs.linux",a.ShellArgsMacOs="terminal.integrated.shellArgs.osx",a.ShellArgsWindows="terminal.integrated.shellArgs.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.CustomGlyphs="terminal.integrated.customGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.SmoothScrolling="terminal.integrated.smoothScrolling"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(a){a.FileName="ptyhost"})(L=e.TerminalLogConstants||(e.TerminalLogConstants={}));var T;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var P;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var E;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(E=e.TitleEventSource||(e.TitleEventSource={}));var b;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.Log="log",a.Heartbeat="heartbeat"})(b=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var I;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(I=e.ProcessPropertyType||(e.ProcessPropertyType={}));var w;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w=e.HeartbeatConstants||(e.HeartbeatConstants={}));var p;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(p=e.TerminalLocation||(e.TerminalLocation={}));var v;(function(a){a.TerminalView="view",a.Editor="editor"})(v=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var S;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(S=e.FlowControlConstants||(e.FlowControlConstants={}));var C;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(C=e.ProfileSource||(e.ProfileSource={}));var m;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(m=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var g;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(g=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ne[225],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(ne[226],re([0,1,37,22,32,12,4,36,27,15,28]),function(Q,e,D,r,R,L,T,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function w(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let c=0;return d&&d.length===4&&(c=parseInt(d[3])),c}e.getWindowsBuildNumber=w;async function p(d,c,i,o=P.env,t=I.Promises.exists){if(L.isAbsolute(d))return await t(d)?d:void 0;if(c===void 0&&(c=P.cwd()),L.dirname(d)!=="."){const l=L.join(c,d);return await t(l)?l:void 0}const s=(0,R.getCaseInsensitive)(o,"PATH");if(i===void 0&&(0,b.isString)(s)&&(i=s.split(L.delimiter)),i===void 0||i.length===0){const l=L.join(c,d);return await t(l)?l:void 0}for(const l of i){let f;if(L.isAbsolute(l)?f=L.join(l,d):f=L.join(c,l,d),await t(f))return f;if(T.isWindows){let y=f+".com";if(await t(y)||(y=f+".exe",await t(y)))return y}}const u=L.join(c,d);return await t(u)?u:void 0}e.findExecutable=p;function v(d,c,i,o){if(!c.enabled||!d.executable||d.isFeatureTerminal||d.hideFromUser||d.ignoreShellIntegration)return;const t=d.args,n=P.platform==="win32"?L.basename(d.executable).toLowerCase():L.basename(d.executable),s=L.dirname(r.FileAccess.asFileUri("",Q).fsPath);let u;const l={VSCODE_INJECTION:"1"};if(T.isWindows){if(n==="pwsh.exe")return!t||g(t)?u=e.shellIntegrationArgs.get(h.WindowsPwsh):m(t)&&(u=e.shellIntegrationArgs.get(h.WindowsPwshLogin)),u?(u=[...u],u[u.length-1]=(0,E.format)(u[u.length-1],s,""),{newArgs:u,envMixin:l}):void 0;o.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args);return}switch(n){case"bash":return!t||t.length===0?u=e.shellIntegrationArgs.get(h.Bash):a(t)&&(l.VSCODE_SHELL_LOGIN="1",u=e.shellIntegrationArgs.get(h.Bash)),u?(u=[...u],u[u.length-1]=(0,E.format)(u[u.length-1],s),{newArgs:u,envMixin:l}):void 0;case"pwsh":return!t||g(t)?u=e.shellIntegrationArgs.get(h.Pwsh):m(t)&&(u=e.shellIntegrationArgs.get(h.PwshLogin)),u?(u=[...u],u[u.length-1]=(0,E.format)(u[u.length-1],s,""),{newArgs:u,envMixin:l}):void 0;case"zsh":{if(!t||t.length===0?u=e.shellIntegrationArgs.get(h.Zsh):a(t)?u=e.shellIntegrationArgs.get(h.ZshLogin):(t===e.shellIntegrationArgs.get(h.Zsh)||t===e.shellIntegrationArgs.get(h.ZshLogin))&&(u=t),!u)return;u=[...u],u[u.length-1]=(0,E.format)(u[u.length-1],s);const f=L.join(D.tmpdir(),`${D.userInfo().username}-vscode-zsh`);l.ZDOTDIR=f;const y=i?.ZDOTDIR??D.homedir()??"~";l.USER_ZDOTDIR=y;const A=[];return A.push({source:L.join(s,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:L.join(f,".zshrc")}),A.push({source:L.join(s,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:L.join(f,".zprofile")}),A.push({source:L.join(s,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:L.join(f,".zshenv")}),A.push({source:L.join(s,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:L.join(f,".zlogin")}),{newArgs:u,envMixin:l,filesToCopy:A}}}o.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args)}e.getShellIntegrationInjection=v;var h;(function(d){d.WindowsPwsh="windows-pwsh",d.WindowsPwshLogin="windows-pwsh-login",d.Pwsh="pwsh",d.PwshLogin="pwsh-login",d.Zsh="zsh",d.ZshLogin="zsh-login",d.Bash="bash"})(h=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(h.Zsh,["-i"]),e.shellIntegrationArgs.set(h.ZshLogin,["-il"]),e.shellIntegrationArgs.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],C=["-nol","-nologo"];function m(d){return typeof d=="string"?S.includes(d.toLowerCase()):d.length===1&&S.includes(d[0].toLowerCase())||d.length===2&&(S.includes(d[0].toLowerCase())||S.includes(d[1].toLowerCase()))&&(C.includes(d[0].toLowerCase())||C.includes(d[1].toLowerCase()))}function g(d){return typeof d=="string"?C.includes(d.toLowerCase()):d.length===0||d?.length===1&&C.includes(d[0].toLowerCase())}function a(d){return d==="string"&&S.includes(d.toLowerCase())||typeof d!="string"&&d.length===1&&S.includes(d[0].toLowerCase())}}),define(ne[227],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var D;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(D=e.ColorScheme||(e.ColorScheme={}));function r(L){return L===D.HIGH_CONTRAST_DARK||L===D.HIGH_CONTRAST_LIGHT}e.isHighContrast=r;function R(L){return L===D.DARK||L===D.HIGH_CONTRAST_DARK}e.isDark=R}),define(ne[109],re([0,1,51,3,2,5,40,227]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var E;(function(C){function m(g){return g&&typeof g=="object"&&typeof g.id=="string"}C.isThemeColor=m})(E=e.ThemeColor||(e.ThemeColor={}));function b(C){return{id:C}}e.themeColorFromId=b;var I;(function(C){function m(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||E.isThemeColor(n.color))}C.isThemeIcon=m;const g=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function a(n){const s=g.exec(n);if(!s)return;const[,u]=s;return{id:u}}C.fromString=a;function d(n){return{id:n}}C.fromId=d;function c(n,s){let u=n.id;const l=u.lastIndexOf("~");return l!==-1&&(u=u.substring(0,l)),s&&(u=`${u}~${s}`),{id:u}}C.modify=c;function i(n){const s=n.id.lastIndexOf("~");if(s!==-1)return n.id.substring(s+1)}C.getModifier=i;function o(n,s){return n.id===s.id&&n.color?.id===s.color?.id}C.isEqual=o;function t(n,s){return{id:n.id,color:s?b(s):void 0}}C.asThemeIcon=t,C.asClassNameArray=D.CSSIcon.asClassNameArray,C.asClassName=D.CSSIcon.asClassName,C.asCSSSelector=D.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function w(C){switch(C){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new r.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,R.toDisposable)(()=>{const g=this.themingParticipants.indexOf(m);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const v=new p;T.Registry.add(e.Extensions.ThemingContribution,v);function h(C){return v.onColorThemeChange(C)}e.registerThemingParticipant=h;class S extends R.Disposable{constructor(m){super(),this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,g){let a=this.theme.getColor(m);return a&&g&&(a=g(a,this.theme)),a?a.toString():null}}e.Themable=S}),define(ne[228],re([0,1,51,7,160,109]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(p,v){const h=[{name:null,description:(0,R.localize)(0,null)}];return h.push(...p.map(S=>({name:S.profileName,description:P(S)}))),v&&h.push(...v.map(S=>({name:S.title,description:E(S)}))),{values:h.map(S=>S.name),markdownDescriptions:h.map(S=>S.description)}}e.createProfileSchemaEnums=T;function P(p){let v=`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:D.Codicon.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?v+=`
- args: "${p.args}"`:v+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(v+=`
- overrideName: ${p.overrideName}`),p.color&&(v+=`
- color: ${p.color}`),p.env&&(v+=`
- env: ${JSON.stringify(p.env)}`),v}function E(p){return`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:D.Codicon.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function b(p,v){if(!p&&!v)return!0;if(typeof p=="string"&&typeof v=="string")return p===v;if(Array.isArray(p)&&Array.isArray(v)){if(p.length!==v.length)return!1;for(let h=0;h<p.length;h++)if(p[h]!==v[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function I(p,v){if(!p&&!v)return!0;if(!p||!v)return!1;if(L.ThemeIcon.isThemeIcon(p)&&L.ThemeIcon.isThemeIcon(v))return p.id===v.id&&p.color===v.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof v=="object"&&"light"in v&&"dark"in v){const h=p,S=v;if((r.URI.isUri(h.light)||w(h.light))&&(r.URI.isUri(h.dark)||w(h.dark))&&(r.URI.isUri(S.light)||w(S.light))&&(r.URI.isUri(S.dark)||w(S.dark)))return h.light.path===S.light.path&&h.dark.path===S.dark.path}if(r.URI.isUri(p)&&r.URI.isUri(v)||w(p)||w(v)){const h=p,S=v;return h.path===S.path&&h.scheme===S.scheme}return!1}e.terminalIconsEqual=I;function w(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.isUriComponents=w}),define(ne[229],re([0,1,51,159,43,40,228]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(D.Codicon.getAll(),d=>d.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),d=>`$(${d.id})`)};const P={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.terminalIconSchema},color:{description:(0,r.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},E={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},b={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...P}},I=(0,r.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),w=(0,r.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),p=(0,r.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),v=(0,r.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,r.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,r.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),C={id:"terminal",order:100,title:(0,r.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,r.localize)(26,null)}},{type:"string",markdownDescription:(0,r.localize)(27,null)}],default:[],markdownDeprecationMessage:p},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(30,null),type:"string"},id:{description:(0,r.localize)(31,null),type:"string"},title:{description:(0,r.localize)(32,null),type:"string"},...P}},{type:"null"},E]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(34,null),type:"string"},id:{description:(0,r.localize)(35,null),type:"string"},title:{description:(0,r.localize)(36,null),type:"string"},...P}},{type:"null"},E]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(38,null),type:"string"},id:{description:(0,r.localize)(39,null),type:"string"},title:{description:(0,r.localize)(40,null),type:"string"},...P}},{type:"null"},E]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,r.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){L.Registry.as(R.Extensions.Configuration).registerConfiguration(C),a()}e.registerTerminalPlatformConfiguration=m;let g;function a(d,c){const i=L.Registry.as(R.Extensions.Configuration);let o;d&&(o=(0,T.createProfileSchemaEnums)(d?.profiles,c));const t=g;g={id:"terminal",order:100,title:(0,r.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:d?.os===3?o?.values:void 0,markdownEnumDescriptions:d?.os===3?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:d?.os===2?o?.values:void 0,markdownEnumDescriptions:d?.os===2?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:d?.os===1?o?.values:void 0,markdownEnumDescriptions:d?.os===1?o?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[g],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=a}),define(ne[230],re([0,1,54,51,12,4,28,86,226,109]),function(Q,e,D,r,R,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,w=!0;function p(o,t,n,s,u=process.env,l,f,y,A){return l=l||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},L.isWindows?v(n,l,u,f,s.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:s.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:s.getValue("terminal.integrated.defaultProfile.windows"),A,y):d(l,f,n,o&&typeof o=="object"?{...o}:s.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:s.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),A,y,u)}e.detectAvailableProfiles=p;async function v(o,t,n,s,u,l,f,y,A){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let M=!1;(0,E.getWindowsBuildNumber)()>=16299&&(M=!0),await C(y);const k=new Map;o&&(k.set("PowerShell",{source:"PowerShell",icon:r.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:r.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),k.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:r.Codicon.terminalCmd,isAutoDetected:!0})),c(l,k);const F=await h(k.entries(),f,t,n,s,A);if(o||u)try{const $=await g(`${_}\\${M?"wsl":"bash"}.exe`,f);for(const x of $)(!l||!(x.profileName in l))&&F.push(x)}catch{w&&(s?.info("WSL is not installed, so could not detect WSL profiles"),w=!1)}return F}async function h(o,t,n,s=process.env,u,l){const f=[];for(const[y,A]of o){if(A===null)continue;let O,_,M;if("source"in A){const $=I?.get(A.source);if(!$)continue;O=$.paths,_=A.args||$.args,A.icon?M=S(A.icon):$.icon&&(M=$.icon)}else O=Array.isArray(A.path)?A.path:[A.path],_=L.isWindows||Array.isArray(A.args)?A.args:void 0,M=S(A.icon);const k=await l?.(O)||O.slice(),F=await i(y,t,k,n,s,_,A.env,A.overrideName,A.isAutoDetected,u);F?(F.isAutoDetected=A.isAutoDetected,F.icon=M,F.color=A.color,f.push(F)):u?.debug("Terminal profile not validated",y,O)}return u?.debug("Validated terminal profiles",f),f}function S(o){return typeof o=="string"?{id:o}:o}async function C(o){I&&!o||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),I.set("PowerShell",{profileName:"PowerShell",paths:o||await m(),icon:b.ThemeIcon.asThemeIcon(r.Codicon.terminalPowershell)}))}async function m(){const o=[];for await(const t of(0,P.enumeratePowerShellInstallations)())o.push(t.exePath);return o}async function g(o,t){const n=[],s=await new Promise((f,y)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(A,O)=>{if(A)return y("Problem occurred when getting wsl distros");f(O)})});if(!s)return[];const u=new RegExp(/[\r?\n]/),l=s.split(u).filter(f=>f.trim().length>0&&f!=="");for(const f of l){if(f===""||f.startsWith("docker-desktop"))continue;const y=`${f} (WSL)`,A={profileName:y,path:o,args:["-d",`${f}`],isDefault:y===t,icon:a(f),isAutoDetected:!1};n.push(A)}return n}function a(o){return o.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(r.Codicon.terminalUbuntu):o.includes("Debian")?b.ThemeIcon.asThemeIcon(r.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(r.Codicon.terminalLinux)}async function d(o,t,n,s,u,l,f,y){const A=new Map;if(n){const O=(await o.readFile("/etc/shells")).toString(),_=l||O.split(`
`).filter(k=>k.trim().indexOf("#")!==0&&k.trim().length>0),M=new Map;for(const k of _){let F=(0,R.basename)(k),$=M.get(F)||0;$++,$>1&&(F=`${F} (${$})`),M.set(F,$),A.set(F,{path:k,isAutoDetected:!0})}}return c(s,A),await h(A.entries(),u,o,y,t,f)}function c(o,t){if(!!o)for(const[n,s]of Object.entries(o))s===null||!("path"in s)&&!("source"in s)?t.delete(n):(s.icon=s.icon||t.get(n)?.icon,t.set(n,s))}async function i(o,t,n,s,u,l,f,y,A,O){if(n.length===0)return Promise.resolve(void 0);const _=n.shift();if(_==="")return i(o,t,n,s,u,l,f,y,A);const M={profileName:o,path:_,args:l,env:f,overrideName:y,isAutoDetected:A,isDefault:o===t};if((0,R.basename)(_)===_){const F=u.PATH?u.PATH.split(R.delimiter):void 0,$=await(0,E.findExecutable)(_,void 0,F,void 0,s.existsFile);return $?(M.path=$,M.isFromPath=!0,M):i(o,t,n,s,u,l)}return await s.existsFile((0,R.normalize)(_))?M:i(o,t,n,s,u,l,f,y,A)}}),define(ne[231],re([0,1,3,2,22,4,39,66,18,14,90,217,8,98,224,108,229,230]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(c){c[c.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let a=0,d=class extends r.Disposable{constructor(i,o,t,n){super(),this._reconnectConstants=i,this._configurationService=o,this._environmentService=t,this._logService=n,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,C.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,r.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,w.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(i){return this._logService.error("ptyHost was unable to resolve shell environment",i),{}}}_startPtyHost(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:a,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},o=(0,I.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);o&&(o.break&&o.port?i.debugBrk=o.port:!o.break&&o.port&&(i.debug=o.port));const t=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,i);this._onPtyHostStart.fire(),T.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(l=>{this._onPtyHostExit.fire(l.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${l.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${l.code}, giving up`))}));const s=t.getChannel(S.TerminalIpcChannels.Log);v.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const u=T.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(l=>this._onProcessData.fire(l))),this._register(u.onProcessReady(l=>this._onProcessReady.fire(l))),this._register(u.onProcessExit(l=>this._onProcessExit.fire(l))),this._register(u.onDidChangeProperty(l=>this._onDidChangeProperty.fire(l))),this._register(u.onProcessReplay(l=>this._onProcessReplay.fire(l))),this._register(u.onProcessOrphanQuestion(l=>this._onProcessOrphanQuestion.fire(l))),this._register(u.onDidRequestDetach(l=>this._onDidRequestDetach.fire(l))),[t,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(i,o,t,n,s,u,l,f,y,A,O){const _=setTimeout(()=>this._handleUnresponsiveCreateProcess(),S.HeartbeatConstants.CreateProcessTimeout),M=await this._proxy.createProcess(i,o,t,n,s,u,l,f,y,A,O);return clearTimeout(_),a=Math.max(a,M),M}updateTitle(i,o,t){return this._proxy.updateTitle(i,o,t)}updateIcon(i,o,t,n){return this._proxy.updateIcon(i,o,t,n)}attachToProcess(i){return this._proxy.attachToProcess(i)}detachFromProcess(i,o){return this._proxy.detachFromProcess(i,o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(i){return this._proxy.start(i)}shutdown(i,o){return this._proxy.shutdown(i,o)}input(i,o){return this._proxy.input(i,o)}processBinary(i,o){return this._proxy.processBinary(i,o)}resize(i,o,t){return this._proxy.resize(i,o,t)}acknowledgeDataEvent(i,o){return this._proxy.acknowledgeDataEvent(i,o)}setUnicodeVersion(i,o){return this._proxy.setUnicodeVersion(i,o)}getInitialCwd(i){return this._proxy.getInitialCwd(i)}getCwd(i){return this._proxy.getCwd(i)}getLatency(i){return this._proxy.getLatency(i)}orphanQuestionReply(i){return this._proxy.orphanQuestionReply(i)}installAutoReply(i,o){return this._proxy.installAutoReply(i,o)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(i){return this._proxy.uninstallAutoReply(i)}getDefaultSystemShell(i){return this._proxy.getDefaultSystemShell(i)}async getProfiles(i,o,t,n=!1){const s=await this._shellEnv;return(0,m.detectAvailableProfiles)(o,t,n,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,i))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(i){return this._proxy.getWslPath(i)}getRevivedPtyNewId(i){return this._proxy.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this._proxy.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this._proxy.getTerminalLayoutInfo(i)}async requestDetachInstance(i,o){return this._proxy.requestDetachInstance(i,o)}async acceptDetachInstanceReply(i,o){return this._proxy.acceptDetachInstanceReply(i,o)}async serializeTerminalState(i){return this._proxy.serializeTerminalState(i)}async reviveTerminalProcesses(i,o){return this._proxy.reviveTerminalProcesses(i,o)}async refreshProperty(i,o){return this._proxy.refreshProperty(i,o)}async updateProperty(i,o,t){return this._proxy.updateProperty(i,o,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(i,o){return this._resolveVariablesRequestStore.createRequest({workspaceId:i,originalText:o})}async acceptPtyHostResolvedVariables(i,o){this._resolveVariablesRequestStore.acceptReply(i,o)}};d=pe([K(1,E.IConfigurationService),K(2,b.IEnvironmentService),K(3,p.ILogService)],d),e.PtyHostService=d}),define(ne[72],re([0,1,3,4,5,8]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var T;(function(S){S.Http="http",S.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const C=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!C)return{address:C[1],port:+C[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=w;function p(S,C){return C?C!==1&&S<1024:!r.isWindows&&S<1024}e.isPortPrivileged=p;class v{constructor(C,m,g){this.remoteAddress=C,this.localAddress=m,this._dispose=g,this._onDispose=new D.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=v;let h=class{constructor(C){this.logService=C,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(C){return this._tunnelProvider=C,C?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(C){this._canElevate=C.elevation,this._privacyOptions=C.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const C=[],m=Array.from(this._tunnels.values());for(const g of m){const a=Array.from(g.values());for(const d of a){const c=await d.value;c&&C.push(c)}}return C}async dispose(){for(const C of this._tunnels.values()){for(const{value:m}of C.values())await m.then(g=>g?.dispose());C.clear()}this._tunnels.clear()}openTunnel(C,m,g,a,d=!1,c,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${g} on local port ${a}.`),!C)return;if(m||(m="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(C,m,g,a,d,c,i);return o?o.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(t);return(t.tunnelRemoteHost!==m||t.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(C){return{tunnelRemotePort:C.tunnelRemotePort,tunnelRemoteHost:C.tunnelRemoteHost,tunnelLocalPort:C.tunnelLocalPort,localAddress:C.localAddress,privacy:C.privacy,protocol:C.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${C.tunnelRemoteHost}:${C.tunnelRemotePort} `);const m=this._tunnels.get(C.tunnelRemoteHost);if(m){const g=m.get(C.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(C.tunnelRemoteHost,C.tunnelRemotePort,g))}}}}async tryDisposeTunnel(C,m,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${C}:${m}.`);const a=g.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(C)&&this._tunnels.get(C).delete(m),a}}async closeTunnel(C,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${C}:${m} `);const g=this._tunnels.get(C);if(g&&g.has(m)){const a=g.get(m);a.refcount=0,await this.tryDisposeTunnel(C,m,a)}}addTunnelToMap(C,m,g){this._tunnels.has(C)||this._tunnels.set(C,new Map),this._tunnels.get(C).set(m,{refcount:1,value:g})}async removeEmptyTunnelFromMap(C,m){const g=this._tunnels.get(C);g&&(await g.get(m)||g.delete(m),g.size===0&&this._tunnels.delete(C))}getTunnelFromMap(C,m){const g=[C];I(C)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):w(C)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const a=g.map(d=>this._tunnels.get(d));for(const d of a){const c=d?.get(m);if(c)return c}}canTunnel(C){return!!b(C)}createWithProvider(C,m,g,a,d,c,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${g} on local port ${a}.`);const o=g;this._factoryInProgress.add(o);const n={elevationRequired:d?p(a===void 0?g:a):!1},s={remoteAddress:{host:m,port:g},localAddressPort:a,privacy:c,public:c?c!==P.Private:void 0,protocol:i},u=C.forwardPort(s,n);return u?(this.addTunnelToMap(m,g,u),u.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),u}};h=pe([K(0,L.ILogService)],h),e.AbstractTunnelService=h}),define(ne[232],re([0,1,8,72,2,9,6]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends R.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new T.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let E=class It extends R.Disposable{constructor(I,w){super(),this._tunnelService=I,this._logService=w,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++It._lastId)}}async startTunnel(I,w,p,v,h,S){const C=new P,m=await Promise.resolve(this._tunnelService.openTunnel(I,C,p,v,h,S));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${v} (remote).`),C.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(w))throw this._disposedTunnels.delete(w),C.dispose(),await m.dispose(),(0,L.canceled)();return C.setTunnel(m),this._tunnels.set(w,C),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${m.localAddress} (local) to ${p}:${v} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(I,w){const p=this._tunnels.get(I);!p||p.setAddress(w)}async destroyTunnel(I){const w=this._tunnels.get(I);if(w){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await w.dispose();return}this._disposedTunnels.add(I)}};E._lastId=0,E=pe([K(0,r.ISharedTunnelsService),K(1,D.ILogService)],E),e.SharedProcessTunnelService=E}),define(ne[233],re([0,1,80,119,208,6,2,18,8,25,206,72,103]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(g,a,d,c,i){let o;for(let t=3;t&&(o?.dispose(),o=await new h(g,a,d,c,i).waitForReady(),!(i&&r.BROWSER_RESTRICTED_PORTS[i]||!r.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));t--);return o}class h extends T.Disposable{constructor(a,d,c,i,o){super(),this.defaultTunnelHost=d,this.suggestedLocalPort=o,this.privacy=w.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=a,this._server=D.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=t=>this._onConnection(t),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(d=>{d()})}async waitForReady(){let a=await(0,r.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),d=null;return this._server.listen(a,this.defaultTunnelHost),await this._barrier.wait(),d=this._server.address(),d||(a=0,this._server.listen(a,this.defaultTunnelHost),await this._barrier.wait(),d=this._server.address()),this.tunnelLocalPort=d.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${d.port}`,this}async _onConnection(a){a.pause();const d=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,I.connectRemoteAgentTunnel)(this._options,d,this.tunnelRemotePort),i=c.getSocket().socket,o=c.readEntireBuffer();c.dispose(),o.byteLength>0&&a.write(o.buffer),a.on("end",()=>{a.localAddress&&this._socketsDispose.delete(a.localAddress),i.end()}),a.on("close",()=>i.end()),a.on("error",()=>{a.localAddress&&this._socketsDispose.delete(a.localAddress),i.destroy()}),i.on("end",()=>a.end()),i.on("close",()=>a.end()),i.on("error",()=>{a.destroy()}),a.pipe(i),i.pipe(a),a.localAddress&&this._socketsDispose.set(a.localAddress,()=>{a.end(),i.end()})}}let S=class extends w.AbstractTunnelService{constructor(a,d,c,i,o){super(d),this.socketFactory=a,this.signService=c,this.productService=i,this.configurationService=o}get defaultTunnelHost(){const a=this.configurationService.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(a,d,c,i,o,t,n){const s=this.getTunnelFromMap(d,c);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,d,c,i,o,t,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${c} on local port ${i}.`);const u={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:a,signService:this.signService,logService:this.logService,ipcLogger:null},l=v(u,this.defaultTunnelHost,d,c,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(d,c,l),l}}};S=pe([K(1,E.ILogService),K(2,p.ISignService),K(3,b.IProductService),K(4,P.IConfigurationService)],S),e.BaseTunnelService=S;let C=class extends S{constructor(a,d,c,i){super(R.nodeSocketFactory,a,d,c,i)}};C=pe([K(0,E.ILogService),K(1,p.ISignService),K(2,b.IProductService),K(3,P.IConfigurationService)],C),e.TunnelService=C;let m=class extends T.Disposable{constructor(a,d,c,i){super(),this.logService=a,this.productService=d,this.signService=c,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(a,d,c,i,o,t,n,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${i} on local port ${o}.`),!this._tunnelServices.has(a)){const u=new C(this.logService,this.signService,this.productService,this.configurationService);this._register(u),this._tunnelServices.set(a,u),u.onTunnelClosed(async()=>{(await u.tunnels).length===0&&(u.dispose(),this._tunnelServices.delete(a))})}return this._tunnelServices.get(a).openTunnel(d,c,i,o,t,n,s)}};m=pe([K(0,E.ILogService),K(1,b.IProductService),K(2,p.ISignService),K(3,P.IConfigurationService)],m),e.SharedTunnelsService=m}),define(ne[31],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(ne[234],re([0,1,3,2,7,14,33,13,8,31]),function(Q,e,D,r,R,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let I=class extends r.Disposable{constructor(p,v,h,S,C){super(),this.extensionsManagementService=p,this.logService=S,this.uriIdentityService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(g=>{this.installedExtensions=g.map(a=>a.identifier),this.startTimestamp=Date.now()}),this._register(p.onInstallExtension(g=>this.onInstallExtension(g))),this._register(p.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(p.onDidUninstallExtension(g=>this.onDidUninstallExtension(g)));const m=R.URI.file(h.extensionsPath);this._register(v.watch(m)),this._register(D.Event.filter(v.onDidFilesChange,g=>g.rawChanges.some(a=>this.doesChangeAffects(a,m)))(()=>this.onDidChange()))}doesChangeAffects(p,v){return p.type!==1&&p.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(p.resource),v)?!1:this.uriIdentityService.extUri.isEqual(p.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(p.resource).startsWith(".")}onInstallExtension(p){this.addInstallingExtension(p.identifier)}onDidInstallExtensions(p){for(const v of p)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(p){p.error||this.removeInstalledExtension(p.identifier)}addInstallingExtension(p){this.removeInstallingExtension(p),this.installingExtensions.push(p)}removeInstallingExtension(p){this.installingExtensions=this.installingExtensions.filter(v=>!(0,T.areSameExtensions)(v,p))}addInstalledExtension(p){this.installedExtensions&&(this.removeInstalledExtension(p),this.installedExtensions.push(p))}removeInstalledExtension(p){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,T.areSameExtensions)(v,p)))}async onDidChange(){if(this.installedExtensions){const p=await this.extensionsManagementService.getInstalled(),v=p.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(C=>(0,T.areSameExtensions)(C,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),h=this.installedExtensions.filter(S=>this.installingExtensions.some(C=>(0,T.areSameExtensions)(C,S))?!1:p.every(C=>!(0,T.areSameExtensions)(C.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=p.map(S=>S.identifier),(v.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:h})}}};I=pe([K(1,P.IFileService),K(2,L.INativeEnvironmentService),K(3,E.ILogService),K(4,b.IUriIdentityService)],I),e.ExtensionsWatcher=I}),define(ne[235],re([0,1,31,91,13,17,117,3,2]),function(Q,e,D,r,R,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(p){this.uri=p,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let I=class{constructor(p){this._fileService=p,this._dispooables=new E.DisposableStore,this._limit=2**16;const v=new Map,h=S=>{let C=v.get(S.scheme);return C===void 0&&(C=p.hasProvider(S)&&!this._fileService.hasCapability(S,1024),v.set(S.scheme,C)),C};this._dispooables.add(P.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(S=>{v.delete(S.scheme)})),this.extUri=new L.ExtUri(h),this._canonicalUris=new T.SkipList((S,C)=>this.extUri.compare(S,C,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(p){this._fileService.hasProvider(p)&&(p=(0,L.normalizePath)(p));const v=this._canonicalUris.get(p);return v?v.touch().uri.with({fragment:p.fragment}):(this._canonicalUris.set(p,new b(p)),this._checkTrim(),p)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const p=[...this._canonicalUris.entries()].sort((h,S)=>h[1].touch<S[1].touch?1:h[1].touch>S[1].touch?-1:0);b._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let h=0;h<v;h++)this._canonicalUris.set(p[h][0],p[h][1].touch())}};I=pe([K(0,R.IFileService)],I),e.UriIdentityService=I,(0,r.registerSingleton)(D.IUriIdentityService,I,!0)}),define(ne[236],re([0,1,3,2,13,42,34,16]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class E extends r.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(I,w,p,v){super(),this.fileSystemScheme=I,this.fileSystemProvider=w,this.userDataScheme=p,this.logService=v,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(h=>this.handleFileChanges(h)))}watch(I,w){this.watchResources.set(I,I);const p=this.fileSystemProvider.watch(this.toFileSystemResource(I),w);return(0,r.toDisposable)(()=>{this.watchResources.delete(I),p.dispose()})}stat(I){return this.fileSystemProvider.stat(this.toFileSystemResource(I))}mkdir(I){return this.fileSystemProvider.mkdir(this.toFileSystemResource(I))}rename(I,w,p){return this.fileSystemProvider.rename(this.toFileSystemResource(I),this.toFileSystemResource(w),p)}readFile(I){return this.fileSystemProvider.readFile(this.toFileSystemResource(I),{atomic:!0})}readFileStream(I,w,p){const v=(0,L.newWriteableStream)(h=>P.VSBuffer.concat(h.map(S=>P.VSBuffer.wrap(S))).buffer);return(async()=>{try{const h=await this.readFile(I);v.end(h)}catch(h){v.error(h),v.end()}})(),v}readdir(I){return this.fileSystemProvider.readdir(this.toFileSystemResource(I))}writeFile(I,w,p){return this.fileSystemProvider.writeFile(this.toFileSystemResource(I),w,p)}delete(I,w){return this.fileSystemProvider.delete(this.toFileSystemResource(I),w)}copy(I,w,p){if((0,R.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(I),this.toFileSystemResource(w),p);throw new Error("copy not supported")}handleFileChanges(I){const w=[];for(const p of I){if(p.resource.scheme!==this.fileSystemScheme)continue;const v=this.toUserDataResource(p.resource);this.watchResources.findSubstr(v)&&w.push({resource:v,type:p.type})}w.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(w))}toFileSystemResource(I){return I.with({scheme:this.fileSystemScheme})}toUserDataResource(I){return I.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=E}),define(ne[61],re([0,1,79]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function r(T,P,E,b){const I=(0,D.setProperty)(T,P,E,b)[0];return I&&(T=T.substring(0,I.offset)+I.content+T.substring(I.offset+I.length)),T}e.edit=r;function R(T,P,E){let b=E;for(;b>=0;){if(T.charAt(b)===P.charAt(P.length-1)&&P.length===1)return b+1;if(b--,P.length===2&&b>=0&&T.charAt(b)===P.charAt(0))return b+2}return 0}e.getLineStartOffset=R;function L(T,P,E){let b=E;for(;b>=0;)if(T.charAt(b)===P.charAt(P.length-1)&&P.length===1||(b++,P.length===2&&b>=0&&T.charAt(b)===P.charAt(1)))return b;return T.length-1}e.getLineEndOffset=L}),define(ne[237],re([0,1,32,55,15]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(p,v,h,S,C){const m=[],g=[],a=[];if(!v){const _=p.filter(({identifier:M})=>C.every(k=>k.toLowerCase()!==M.id.toLowerCase()));return{local:{added:m,removed:g,updated:a},remote:_.length>0?{added:_,updated:[],removed:[],all:_}:null}}p=p.map(I),v=v.map(I),h=h?h.map(I):null;const d=new Map,c=_=>{_.uuid&&d.set(_.id.toLowerCase(),_.uuid)};p.forEach(({identifier:_})=>c(_)),v.forEach(({identifier:_})=>c(_)),h?.forEach(({identifier:_})=>c(_));const i=_=>{const M=_.identifier.uuid||d.get(_.identifier.id.toLowerCase());return M?`uuid:${M}`:`id:${_.identifier.id.toLowerCase()}`},o=(_,M)=>(_.set(i(M),M),_),t=p.reduce(o,new Map),n=v.reduce(o,new Map),s=v.reduce((_,M)=>{const k=i(M);M=(0,D.deepClone)(M);const F=t.get(k);return F&&(F.installed&&(M.installed=!0),M.version||(M.version=F.version)),o(_,M)},new Map),u=h?h.reduce(o,new Map):null,l=S.reduce(o,new Map),f=C.reduce((_,M)=>{const k=d.get(M.toLowerCase());return _.add(k?`uuid:${k}`:`id:${M.toLowerCase()}`)},new Set),y=T(t,n,f);if(y.added.size>0||y.removed.size>0||y.updated.size>0){const _=T(u,t,f),M=T(u,n,f),k=(F,$)=>{const x=t.get(F);if(x){const J=n.get(F),H=$?J:x;return{...H,version:J.version&&(!x.installed||r.gt(J.version,x.version))?J.version:x.version,state:P(x,J,u?.get(F)),preRelease:(0,R.isUndefined)(H.preRelease)?x.preRelease:x.installed?H.preRelease:J.preRelease}}};for(const F of M.removed.values()){const $=t.get(F);$&&g.push($.identifier)}for(const F of M.added.values())if(_.added.has(F)){if(y.updated.has(F)){const $=k(F,!0);$&&(a.push(w($,F)),s.set(F,$))}}else{const $=n.get(F);$.installed&&m.push(w($,F))}for(const F of M.updated.values()){const $=k(F,!0);$&&(a.push(w($,F)),s.set(F,$))}for(const F of _.added.values())M.added.has(F)||s.set(F,t.get(F));for(const F of _.updated.values())if(!M.removed.has(F)&&!M.updated.has(F)){const $=k(F,!1);$&&(s.get(F)?.installed&&($.installed=!0),s.set(F,$))}for(const F of _.removed.values())!l.has(F)&&!M.updated.has(F)&&u?.get(F)?.installed&&s.delete(F)}const A=[],O=T(n,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(O.added.size>0||O.updated.size>0||O.removed.size>0)&&s.forEach((_,M)=>A.push(w(_,M))),{local:{added:m,removed:g,updated:a},remote:A.length?{added:[...O.added].map(_=>s.get(_)),updated:[...O.updated].map(_=>s.get(_)),removed:[...O.removed].map(_=>n.get(_)),all:A}:null}}e.merge=L;function T(p,v,h,{checkInstalledProperty:S,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const m=p?[...p.keys()].filter(i=>!h.has(i)):[],g=[...v.keys()].filter(i=>!h.has(i)),a=g.filter(i=>m.indexOf(i)===-1).reduce((i,o)=>(i.add(o),i),new Set),d=m.filter(i=>g.indexOf(i)===-1).reduce((i,o)=>(i.add(o),i),new Set),c=new Set;for(const i of m){if(d.has(i))continue;const o=p.get(i),t=v.get(i);(!t||o.disabled!==t.disabled||o.installed&&t.installed&&o.preRelease!==t.preRelease||!b(o.state,t.state)||C&&o.version!==t.version||S&&o.installed!==t.installed)&&c.add(i)}return{added:a,removed:d,updated:c}}function P(p,v,h){const S=p.state,C=v.state,m=h?.state;if(!v.version||S&&r.gt(p.version,v.version))return S;if(C&&r.gt(v.version,p.version)||!S)return C;if(!C)return S;const g=(0,D.deepClone)(S),a=m?E(m,C):{added:Object.keys(C).reduce((c,i)=>(c.add(i),c),new Set),removed:new Set,updated:new Set},d=m?E(m,S):{added:Object.keys(S).reduce((c,i)=>(c.add(i),c),new Set),removed:new Set,updated:new Set};for(const c of[...a.added.values(),...a.updated.values()])g[c]=C[c];for(const c of a.removed.values())d.updated.has(c)||delete g[c];return g}function E(p,v){const h=Object.keys(p),S=Object.keys(v),C=S.filter(a=>h.indexOf(a)===-1).reduce((a,d)=>(a.add(d),a),new Set),m=h.filter(a=>S.indexOf(a)===-1).reduce((a,d)=>(a.add(d),a),new Set),g=new Set;for(const a of h){if(m.has(a))continue;const d=p[a],c=v[a];(0,D.equals)(d,c)||g.add(a)}return{added:C,removed:m,updated:g}}function b(p={},v={}){const{added:h,removed:S,updated:C}=E(p,v);return h.size===0&&S.size===0&&C.size===0}function I(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function w(p,v){const h={identifier:{id:p.identifier.id,uuid:v.startsWith("uuid:")?v.substring(5):void 0},preRelease:!!p.preRelease};return p.version&&(h.version=p.version),p.disabled&&(h.disabled=!0),p.installed&&(h.installed=!0),p.state&&(h.state=p.state),h}}),define(ne[110],re([0,1,19,18,5]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,E){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==P&&I!==`-${P}`),E&&b.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}updateSynchronizedExtensions(P,E){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==P&&I!==`-${P}`),E&&b.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}getIgnoredExtensions(P){const E=P.filter(p=>p.isMachineScoped).map(p=>p.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(p=>p.toLowerCase()),I=[],w=[];if(Array.isArray(b))for(const p of b)p.startsWith("-")?w.push(p.substring(1)):I.push(p);return(0,D.distinct)([...E,...I].filter(p=>w.indexOf(p)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(E=>E.toLowerCase())}};L=pe([K(0,r.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(ne[238],re([0,1,19,35,32,178,61]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(d){return(0,r.parse)(d)||[]}e.parseKeybindings=P;async function E(d,c,i,o,t){const n=P(d),s=P(c),u=i?P(i):null,l=[...n,...s,...u||[]].map(J=>J.key),f=await t.resolveUserBindings(l),y=I(n,s,u,f);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const A=p(n),O=p(s),_=u?p(u):null,M=h(A,O,f),k=_?h(_,A,f):{added:[...A.keys()].reduce((J,H)=>(J.add(H),J),new Set),removed:new Set,updated:new Set},F=_?h(_,O,f):{added:[...O.keys()].reduce((J,H)=>(J.add(H),J),new Set),removed:new Set,updated:new Set},$=b(M,k,F);let x=d;for(const J of $.removed.values())$.conflicts.has(J)||(x=g(x,J,o));for(const J of $.added.values()){if($.conflicts.has(J))continue;const H=O.get(J);if(H.some(G=>G.command!==`-${J}`&&y.conflicts.has(f[G.key]))){$.conflicts.add(J);continue}x=m(x,H,o)}for(const J of $.updated.values()){if($.conflicts.has(J))continue;const H=O.get(J);if(H.some(G=>G.command!==`-${J}`&&y.conflicts.has(f[G.key]))){$.conflicts.add(J);continue}x=a(x,J,H,o)}return{mergeContent:x,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=E;function b(d,c,i){const o=new Set,t=new Set,n=new Set,s=new Set;for(const u of c.removed.values())i.updated.has(u)&&s.add(u);for(const u of i.removed.values())s.has(u)||(c.updated.has(u)?s.add(u):t.add(u));for(const u of c.added.values())s.has(u)||i.added.has(u)&&d.updated.has(u)&&s.add(u);for(const u of i.added.values())s.has(u)||(c.added.has(u)?d.updated.has(u)&&s.add(u):o.add(u));for(const u of c.updated.values())s.has(u)||i.updated.has(u)&&d.updated.has(u)&&s.add(u);for(const u of i.updated.values())s.has(u)||(c.updated.has(u)?d.updated.has(u)&&s.add(u):n.add(u));return{added:o,removed:t,updated:n,conflicts:s}}function I(d,c,i,o){const t=new Set,n=w(d,o),s=w(c,o),u=i?w(i,o):null,l=v(n,s);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const f=u?v(u,n):{added:[...n.keys()].reduce((k,F)=>(k.add(F),k),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const y=u?v(u,s):{added:[...s.keys()].reduce((k,F)=>(k.add(F),k),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:A,removed:O,updated:_,conflicts:M}=b(l,f,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:O,updated:_,conflicts:M}}function w(d,c){const i=new Map;for(const o of d){const t=c[o.key];let n=i.get(t);n||(n=[],i.set(t,n)),n.push(o)}return i}function p(d){const c=new Map;for(const i of d){const o=i.command[0]==="-"?i.command.substring(1):i.command;let t=c.get(o);t||(t=[],c.set(o,t)),t.push(i)}return c}function v(d,c){const i=[...d.keys()],o=[...c.keys()],t=o.filter(u=>i.indexOf(u)===-1).reduce((u,l)=>(u.add(l),u),new Set),n=i.filter(u=>o.indexOf(u)===-1).reduce((u,l)=>(u.add(l),u),new Set),s=new Set;for(const u of i){if(n.has(u))continue;const l=d.get(u).map(y=>({...y,key:u})),f=c.get(u).map(y=>({...y,key:u}));(0,D.equals)(l,f,(y,A)=>C(y,A))||s.add(u)}return{added:t,removed:n,updated:s}}function h(d,c,i){const o=[...d.keys()],t=[...c.keys()],n=t.filter(l=>o.indexOf(l)===-1).reduce((l,f)=>(l.add(f),l),new Set),s=o.filter(l=>t.indexOf(l)===-1).reduce((l,f)=>(l.add(f),l),new Set),u=new Set;for(const l of o){if(s.has(l))continue;const f=d.get(l).map(A=>({...A,key:i[A.key]})),y=c.get(l).map(A=>({...A,key:i[A.key]}));S(f,y)||u.add(l)}return{added:n,removed:s,updated:u}}function S(d,c){return!(!(0,D.equals)(d.filter(({command:i})=>i[0]!=="-"),c.filter(({command:i})=>i[0]!=="-"),(i,o)=>C(i,o))||!(0,D.equals)(d.filter(({command:i})=>i[0]==="-"),c.filter(({command:i})=>i[0]==="-"),(i,o)=>C(i,o)))}function C(d,c){if(d.command!==c.command||d.key!==c.key)return!1;const i=L.ContextKeyExpr.deserialize(d.when),o=L.ContextKeyExpr.deserialize(c.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!R.equals(d.args,c.args))}function m(d,c,i){for(const o of c)d=T.edit(d,[-1],o,i);return d}function g(d,c,i){const o=P(d);for(let t=o.length-1;t>=0;t--)(o[t].command===c||o[t].command===`-${c}`)&&(d=T.edit(d,[t],void 0,i));return d}function a(d,c,i,o){const t=P(d),n=t.findIndex(s=>s.command===c||s.command===`-${c}`);for(let s=t.length-1;s>=0;s--)(t[s].command===c||t[s].command===`-${c}`)&&(d=T.edit(d,[s],void 0,o));for(let s=i.length-1;s>=0;s--)d=T.edit(d,[n],i[s],o);return d}}),define(ne[239],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(L,T,P){const E={},b={},I=new Set;if(!T)return{local:{added:E,updated:b,removed:[...I.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const w=r(L,T);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:E,updated:b,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const p=r(P,L),v=r(P,T),h={},S={},C=new Set,m=new Set;for(const g of p.removed.values())v.updated.has(g)?E[g]=T[g]:C.add(g);for(const g of v.removed.values())m.has(g)||(p.updated.has(g)?m.add(g):I.add(g));for(const g of p.updated.values())m.has(g)||(v.updated.has(g)?w.updated.has(g)&&m.add(g):S[g]=L[g]);for(const g of v.updated.values())m.has(g)||(p.updated.has(g)?w.updated.has(g)&&m.add(g):L[g]!==void 0&&(b[g]=T[g]));for(const g of p.added.values())m.has(g)||(v.added.has(g)?w.updated.has(g)&&m.add(g):h[g]=L[g]);for(const g of v.added.values())m.has(g)||(p.added.has(g)?w.updated.has(g)&&m.add(g):E[g]=T[g]);return{local:{added:E,removed:[...I.values()],updated:b},remote:{added:h,removed:[...C.values()],updated:S},conflicts:[...m.values()]}}e.merge=D;function r(L,T){const P=L?Object.keys(L):[],E=T?Object.keys(T):[],b=E.filter(p=>P.indexOf(p)===-1).reduce((p,v)=>(p.add(v),p),new Set),I=P.filter(p=>E.indexOf(p)===-1).reduce((p,v)=>(p.add(v),p),new Set),w=new Set;for(const p of P){if(I.has(p))continue;const v=L[p],h=T[p];v!==h&&w.add(p)}return{added:b,removed:I,updated:w}}function R(L,T){const{added:P,removed:E,updated:b}=r(L,T);return P.size===0&&E.size===0&&b.size===0}e.areSame=R}),define(ne[240],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(R,L,T,P){const E={local:{added:[],removed:[],updated:[]},remote:{added:[],removed:[],updated:[]}};if(!L){const I=R.filter(({id:w})=>!P.includes(w));return I.length?E.remote.added=I:E.remote=null,E}const b=r(R,L,P);if(b.added.length>0||b.removed.length>0||b.updated.length>0){const I=r(T,R,P),w=r(T,L,P);for(const p of w.removed){const v=R.find(h=>h.id===p);v&&E.local.removed.push(v)}for(const p of w.added){const v=L.find(h=>h.id===p);I.added.includes(p)?b.updated.includes(p)&&E.local.updated.push(v):E.local.added.push(v)}for(const p of w.updated)E.local.updated.push(L.find(v=>v.id===p));for(const p of I.added)w.added.includes(p)||E.remote.added.push(R.find(v=>v.id===p));for(const p of I.updated)w.removed.includes(p)||w.updated.includes(p)||E.remote.updated.push(R.find(v=>v.id===p));for(const p of I.removed)E.remote.removed.push(L.find(v=>v.id===p))}return E.remote.added.length===0&&E.remote.removed.length===0&&E.remote.updated.length===0&&(E.remote=null),E}e.merge=D;function r(R,L,T){R=R?R.filter(({id:p})=>!T.includes(p)):[],L=L.filter(({id:p})=>!T.includes(p));const P=R.map(({id:p})=>p),E=L.map(({id:p})=>p),b=E.filter(p=>P.indexOf(p)===-1),I=P.filter(p=>E.indexOf(p)===-1),w=[];for(const{id:p,name:v}of R){if(I.includes(p))continue;const h=L.find(S=>S.id===p);(!h||h.name!==v)&&w.push(p)}return{added:b,removed:I,updated:w}}}),define(ne[26],re([0,1,19,15,166,43,29,5,100,40]),function(Q,e,D,r,R,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const s=b.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(u=>!!s[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function w(){const s=b.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(s).filter(y=>!!s[y].ignoreSync),l=Object.keys(s).filter(y=>s[y].scope===2||s[y].scope===6),f=I();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...l,...f])}e.getDefaultIgnoredSettings=w,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const s="vscode://schemas/ignoredSettings",u=b.Registry.as(L.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,R.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,R.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,R.localize)(2,null),items:[{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,R.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,R.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=b.Registry.as(E.Extensions.JSONContribution),f=()=>{const y=I(),A=w().filter(k=>k!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(L.allSettings.properties).filter(k=>A.indexOf(k)===-1),_=A.filter(k=>y.indexOf(k)===-1),M={items:{type:"string",enum:[...O,..._.map(k=>`-${k}`)]}};l.registerSchema(s,M)};return u.onDidUpdateConfiguration(()=>f())}e.registerConfiguration=p;function v(s){return s&&(0,r.isObject)(s)&&(0,r.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=v;var h;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(h=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function S(s,...u){return s?[s,...u]:u}e.getPathSegments=S;function C(s,u,l,f){return f.joinPath(l.userDataSyncHome,...S(s,u,`lastSync${u}.json`))}e.getLastSyncResourceUri=C,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(s){const u={};return u[e.HEADER_EXECUTION_ID]=s,u}e.createSyncHeaders=m;var g;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(g=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class a extends Error{constructor(u,l,f,y){super(u),this.code=l,this.resource=f,this.operationId=y,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=a;class d extends a{constructor(u,l,f,y,A){super(u,f,void 0,A),this.url=l,this.serverCode=y}}e.UserDataSyncStoreError=d;class c extends a{constructor(u,l){super(u,l)}}e.UserDataAutoSyncError=c,function(s){function u(l){if(l instanceof s)return l;const f=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(f&&f[1]){const y=f[2]==="unknown"?void 0:f[2],A=f[3]==="unknown"?void 0:f[3];return new s(l.message,f[1],y,A)}return new s(l.message,"Unknown")}s.toUserDataSyncError=u}(a=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var o;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(o=e.Change||(e.Change={}));var t;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(s){return`sync.enable.${s}`}e.getEnablementKey=n,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(ne[241],re([0,1,32,26]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(P,E,b,I,w){if(!E)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const p=L(P,E);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const v=b?L(b,E):{added:Object.keys(E).reduce((g,a)=>(g.add(a),g),new Set),removed:new Set,updated:new Set},h=b?L(b,P):{added:Object.keys(P).reduce((g,a)=>(g.add(a),g),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},C=D.deepClone(E),m=!b;for(const g of h.added.values())g!==r.SYNC_SERVICE_URL_TYPE&&m&&v.added.has(g)||(C[g]=P[g]);for(const g of h.updated.values())C[g]=P[g];for(const g of h.removed.values())I.unregistered.includes(g)||delete C[g];for(const g of v.added.values()){const a=E[g];if(I.machine.includes(g)){w.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(b&&h.added.has(g))continue;const d=P[g];d&&d.value===a.value||g===r.SYNC_SERVICE_URL_TYPE&&m&&h.added.has(g)||(d?S.updated[g]=a:S.added[g]=a)}for(const g of v.updated.values()){const a=E[g];if(I.machine.includes(g)){w.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(g)||h.removed.has(g))continue;const d=P[g];d&&d.value===a.value||(S.updated[g]=a)}for(const g of v.removed.values()){if(I.machine.includes(g)){w.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}h.updated.has(g)||h.removed.has(g)||S.removed.push(g)}return{local:S,remote:T(C,E)?null:C}}e.merge=R;function L(P,E){const b=Object.keys(P),I=Object.keys(E),w=I.filter(h=>b.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),p=b.filter(h=>I.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),v=new Set;for(const h of b){if(p.has(h))continue;const S=P[h],C=E[h];D.equals(S,C)||v.add(h)}return{added:w,removed:p,updated:v}}function T(P,E){const{added:b,removed:I,updated:w}=L(P,E);return b.size===0&&I.size===0&&w.size===0}}),define(ne[242],re([0,1,19,35,79,46,32,61,26]),function(Q,e,D,r,R,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function b(l,f,y){let A=[];y?A=w(y):A=I(f);const O=[],_=[...(0,E.getDisallowedIgnoredSettings)()];if(Array.isArray(A))for(const M of A)M.startsWith("-")?_.push(M.substring(1)):O.push(M);return(0,D.distinct)([...l,...O].filter(M=>_.indexOf(M)===-1))}e.getIgnoredSettings=b;function I(l){let f=l.inspect("settingsSync.ignoredSettings").userValue;return f!==void 0||(f=l.inspect("sync.ignoredSettings").userValue,f!==void 0)?f:l.getValue("settingsSync.ignoredSettings")||[]}function w(l){const f=(0,r.parse)(l);return f?f["settingsSync.ignoredSettings"]||f["sync.ignoredSettings"]||[]:[]}function p(l,f){const y=(0,r.parse)(l)||{};let A="{}";for(const O of Object.keys(y)){const _=(0,R.setProperty)(A,[O],y[O],f);A=(0,R.applyEdits)(A,_)}return A}e.removeComments=p;function v(l,f,y,A){if(y.length){const O=u(f),_=(0,r.parse)(f)||{},M=(0,r.parse)(l);if(!M)return l;const k=[];for(const F of y){const $=_[F],x=M[F];$===void 0?l=P.edit(l,[F],void 0,A):x!==void 0?l=P.edit(l,[F],$,A):k.push(i(F,O))}k.sort((F,$)=>F.startOffset-$.startOffset),k.forEach(F=>l=g(F.setting.key,f,l,A))}return l}e.updateIgnoredSettings=v;function h(l,f,y,A,O,_){const M=v(l,f,A,_),k=y!==M,F=y!==f;if(!k&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(k&&!F)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(F&&!k)return{conflictsSettings:[],localContent:v(f,l,A,_),remoteContent:null,hasConflicts:!1};if(y===null&&C(l)){const B=S(l,f,A)?null:v(f,l,A,_);return{conflictsSettings:[],localContent:B,remoteContent:null,hasConflicts:!1}}let $=l,x=f;const J=(0,r.parse)(l),H=(0,r.parse)(f),G=y?(0,r.parse)(y):null,z=A.reduce((B,Z)=>(B.add(Z),B),new Set),j=m(J,H,z),Y=m(G,J,z),te=m(G,H,z),ce=new Map,W=new Set,V=B=>{W.add(B);const Z=O.filter(({key:oe})=>oe===B)[0];Z?($=P.edit($,[B],Z.value,_),x=P.edit(x,[B],Z.value,_)):ce.set(B,{key:B,localValue:J[B],remoteValue:H[B]})};for(const B of Y.removed.values())te.updated.has(B)?V(B):x=P.edit(x,[B],void 0,_);for(const B of te.removed.values())W.has(B)||(Y.updated.has(B)?V(B):$=P.edit($,[B],void 0,_));for(const B of Y.updated.values())W.has(B)||(te.updated.has(B)?j.updated.has(B)&&V(B):x=P.edit(x,[B],J[B],_));for(const B of te.updated.values())W.has(B)||(Y.updated.has(B)?j.updated.has(B)&&V(B):$=P.edit($,[B],H[B],_));for(const B of Y.added.values())W.has(B)||(te.added.has(B)?j.updated.has(B)&&V(B):x=g(B,$,x,_));for(const B of te.added.values())W.has(B)||(Y.added.has(B)?j.updated.has(B)&&V(B):$=g(B,x,$,_));const U=ce.size>0||!S($,x,A),N=U||!S($,l,[]),q=U||!S(x,f,[]);return{localContent:N?$:null,remoteContent:q?x:null,conflictsSettings:[...ce.values()],hasConflicts:U}}e.merge=h;function S(l,f,y){if(l===f)return!0;const A=(0,r.parse)(l),O=(0,r.parse)(f),_=y.reduce((F,$)=>(F.add($),F),new Set),M=u(l).filter(F=>!(F.setting&&_.has(F.setting.key))),k=u(f).filter(F=>!(F.setting&&_.has(F.setting.key)));if(M.length!==k.length)return!1;for(let F=0;F<M.length;F++){const $=M[F],x=k[F];if($.setting&&x.setting){if($.setting.key!==x.setting.key||!T.equals(A[$.setting.key],O[$.setting.key]))return!1}else if(!$.setting&&!x.setting){if($.value!==x.value)return!1}else return!1}return!0}e.areSame=S;function C(l){return l?u(l).length===0:!0}e.isEmpty=C;function m(l,f,y){const A=l?Object.keys(l).filter(F=>!y.has(F)):[],O=Object.keys(f).filter(F=>!y.has(F)),_=O.filter(F=>A.indexOf(F)===-1).reduce((F,$)=>(F.add($),F),new Set),M=A.filter(F=>O.indexOf(F)===-1).reduce((F,$)=>(F.add($),F),new Set),k=new Set;if(l)for(const F of A){if(M.has(F))continue;const $=l[F],x=f[F];T.equals($,x)||k.add(F)}return{added:_,removed:M,updated:k}}function g(l,f,y,A){const O=(0,r.parse)(f),_=u(f),M=u(y),k=a(l,_,M);return d(y,l,O[l],k,M,A)}e.addSetting=g;function a(l,f,y){const A=f.findIndex(_=>_.setting?.key===l),O=f[A-1];if(O){if(O.setting){const M=i(O.setting.key,y);if(M)return{index:y.indexOf(M),insertAfter:!0}}else{const M=o(A,f);if(M){const k=i(M.setting.key,y);if(k){const F=t(y.indexOf(k),y),$=n(f,M,f[A]);if(F){const x=n(y,k,F),J=s($,x);return J?{index:y.indexOf(J),insertAfter:!0}:{index:y.indexOf(F),insertAfter:!1}}else{const x=n(y,k,y[y.length-1]),J=s($,x);return J?{index:y.indexOf(J),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const _=f[A+1];if(_)if(_.setting){const M=i(_.setting.key,y);if(M)return{index:y.indexOf(M),insertAfter:!1}}else{const M=t(A,f);if(M){const k=i(M.setting.key,y);if(k){const F=o(y.indexOf(k),y),$=n(f,f[A],M);if(F){const x=n(y,F,k),J=s($.reverse(),x.reverse());return J?{index:y.indexOf(J),insertAfter:!1}:{index:y.indexOf(F),insertAfter:!0}}else{const x=n(y,y[0],k),J=s($.reverse(),x.reverse());return J?{index:y.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function d(l,f,y,A,O,_){let M;return A.index===-1?M=(0,R.setProperty)(l,[f],y,_):M=c(l,f,y,A,O,_).map(k=>(0,R.withFormatting)(l,k,_)[0]),(0,R.applyEdits)(l,M)}function c(l,f,y,A,O,_){const M=`${JSON.stringify(f)}: ${JSON.stringify(y)}`,k=(0,L.getEOL)(_,l),F=O[A.index];if(A.insertAfter){const $=[];if(F.setting)$.push({offset:F.endOffset,length:0,content:","+M});else{const x=t(A.index,O),J=o(A.index,O),H=J?.setting?.commaOffset;J&&H===void 0&&$.push({offset:J.endOffset,length:0,content:","});const G=H!==void 0&&H>F.endOffset;$.push({offset:G?H+1:F.endOffset,length:0,content:x?k+M+",":k+M})}return $}else{if(F.setting)return[{offset:F.startOffset,length:0,content:M+","}];const $=(O[A.index-1]&&!O[A.index-1].setting?k:"")+M+(t(A.index,O)?",":"")+k;return[{offset:F.startOffset,length:0,content:$}]}}function i(l,f){return f.filter(y=>y.setting?.key===l)[0]}function o(l,f){for(let y=l-1;y>=0;y--)if(f[y].setting)return f[y]}function t(l,f){for(let y=l+1;y<f.length;y++)if(f[y].setting)return f[y]}function n(l,f,y){const A=l.indexOf(f),O=l.indexOf(y);return l.filter((_,M)=>A<M&&M<O)}function s(l,f){if(l.length&&f.length){let y=0;for(;y<f.length&&y<l.length;y++)if(l[y].value!==f[y].value)return f[y-1];return f[y-1]}}function u(l){const f=[];let y=-1,A,O;const _={onObjectBegin:M=>{y++},onObjectProperty:(M,k,F)=>{y===0&&(A=k,O=M)},onObjectEnd:(M,k)=>{y--,y===0&&f.push({startOffset:A,endOffset:M+k,value:l.substring(A,M+k),setting:{key:O,commaOffset:void 0}})},onArrayBegin:(M,k)=>{y++},onArrayEnd:(M,k)=>{y--,y===0&&f.push({startOffset:A,endOffset:M+k,value:l.substring(A,M+k),setting:{key:O,commaOffset:void 0}})},onLiteralValue:(M,k,F)=>{y===0&&f.push({startOffset:A,endOffset:k+F,value:l.substring(A,k+F),setting:{key:O,commaOffset:void 0}})},onSeparator:(M,k,F)=>{if(y===0&&M===","){let $=f.length-1;for(;$>=0&&!f[$].setting;$--);const x=f[$];x&&f.splice($,1,{startOffset:x.startOffset,endOffset:x.endOffset,value:x.value,setting:{key:x.setting.key,commaOffset:k}})}},onComment:(M,k)=>{y===0&&f.push({startOffset:M,endOffset:M+k,value:l.substring(M,M+k)})}};return(0,r.visit)(l,_),f}}),define(ne[73],re([0,1,3,2,5,26]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let T=class extends r.Disposable{get account(){return this._account}constructor(E,b){super(),this.userDataSyncStoreService=E,this.logService=b,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(E.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(E.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(E){(E&&this._account?E.token!==this._account.token||E.authenticationProviderId!==this._account.authenticationProviderId:E!==this._account)&&(this._account=E,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(E))}};T=pe([K(0,L.IUserDataSyncStoreService),K(1,L.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(ne[243],re([0,1,2,7]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(p){this.service=p}listen(p,v){switch(v){case"onError":return this.service.onError}throw new Error(`Event not found: ${v}`)}call(p,v,h){switch(v){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class L{constructor(p){this.service=p}listen(p,v){throw new Error(`Event not found: ${v}`)}call(p,v,h){switch(v){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(r.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class T{constructor(p){this.channel=p}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(p){return this.channel.call("resolveUserKeybindings",[p])}async resolveFormattingOptions(p){return this.channel.call("resolveFormattingOptions",[p])}}e.UserDataSyncUtilServiceClient=T;class P{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${v}`)}async call(p,v,h){switch(v){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablements":return this.service.setEnablements(h)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class E{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${v}`)}call(p,v,h){switch(v){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=E;class b{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${v}`)}call(p,v,h){switch(v){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class I extends D.Disposable{constructor(p){super(),this.channel=p,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(p){return this.channel.call("switch",[p])}async getPreviousUserDataSyncStore(){const p=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(p)}revive(p){return{url:r.URI.revive(p.url),type:p.type,defaultUrl:r.URI.revive(p.defaultUrl),insidersUrl:r.URI.revive(p.insidersUrl),stableUrl:r.URI.revive(p.stableUrl),canSwitch:p.canSwitch,authenticationProviders:p.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(ne[244],re([0,1,14,8]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends r.AbstractLogger{constructor(T,P){super(),this.logger=this._register(T.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...P){this.logger.trace(T,...P)}debug(T,...P){this.logger.debug(T,...P)}info(T,...P){this.logger.info(T,...P)}warn(T,...P){this.logger.warn(T,...P)}error(T,...P){this.logger.error(T,...P)}critical(T,...P){this.logger.critical(T,...P)}flush(){this.logger.flush()}};R=pe([K(0,r.ILoggerService),K(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(ne[245],re([0,1,6,3,2]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:E,getActiveWindowId:b}){super(),this.disposables=this._register(new R.DisposableStore),r.Event.latch(r.Event.any(P,E))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>b()),(async()=>{try{const w=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:w}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(ne[111],re([0,1,168,12,34,17,7,5,22]),function(Q,e,D,r,R,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function b(o){const t=o;return typeof t?.id=="string"&&T.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function I(o,t){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,r.basename)(o)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const n=o;if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=I;function w(o){const t=o;return typeof t?.id=="string"&&T.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=w;function p(o){const t=o;if(t?.uri)return{id:t.id,uri:T.URI.revive(t.uri)};const n=o;if(n?.configPath)return{id:n.id,configPath:T.URI.revive(n.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=p;var v;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function h(o){const t=o;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=h;function S(o){const t=o;return!!(t&&typeof t=="object"&&T.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=S;class C{constructor(t,n,s,u,l){this._id=t,this._transient=s,this._configuration=u,this._ignorePathCasing=l,this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=C;class m{constructor(t,n){this.raw=n,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function g(o){return new m({uri:o,index:0,name:(0,L.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(o,t){return L.extUriBiasedIgnorePathCase.isEqualOrParent(o,t.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function d(o){let t;return T.URI.isUri(o)?t=o:t=o.configuration,t?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=d;function c(o,t){return!a(o,t)&&!d(o)}e.isSavedWorkspace=c;function i(o){return(typeof o=="string"?(0,r.extname)(o):(0,L.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ne[20],re([0,1,64,3,2,17,15,7,161,14,13,5,8,111,34,31,6,30,27]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function a(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&P.URI.isUri(n.location)&&P.URI.isUri(n.globalStorageHome)&&P.URI.isUri(n.settingsResource)&&P.URI.isUri(n.keybindingsResource)&&P.URI.isUri(n.tasksResource)&&P.URI.isUri(n.snippetsHome)&&((0,T.isUndefined)(n.extensionsResource)||P.URI.isUri(n.extensionsResource)))}e.isUserDataProfile=a,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,w.createDecorator)("IUserDataProfilesService");function d(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,location:P.URI.revive(t.location).with({scheme:n}),globalStorageHome:P.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:P.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:P.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:P.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:P.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:P.URI.revive(t.extensionsResource)?.with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=d,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function c(t,n,s,u,l){return{id:t,name:n,location:s,isDefault:!1,globalStorageHome:(0,L.joinPath)(s,"globalStorage"),settingsResource:(0,L.joinPath)(s,"settings.json"),keybindingsResource:(0,L.joinPath)(s,"keybindings.json"),tasksResource:(0,L.joinPath)(s,"tasks.json"),snippetsHome:(0,L.joinPath)(s,"snippets"),extensionsResource:(0,L.joinPath)(s,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:u,isTransient:l}}e.toUserDataProfile=c;let i=class extends R.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,s,u,l){super(),this.environmentService=n,this.fileService=s,this.uriIdentityService=u,this.logService=l,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new r.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new r.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new r.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new r.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap},this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(f=>c((0,L.basename)(f.location),f.name,f.location,f.useDefaultFlags)):[];let s;const u=new h.ResourceMap,l=c((0,D.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,E.localize)(0,null),this.environmentService.userRoamingDataHome);if(n.unshift({...l,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0||this.transientProfilesObject.profiles.length>0?l.extensionsResource:void 0}),n.length){const f=this.getStoredProfileAssociations();if(f.workspaces)for(const[y,A]of Object.entries(f.workspaces)){const O=P.URI.parse(y),_=P.URI.parse(A),M=n.find(k=>this.uriIdentityService.extUri.isEqual(k.location,_));M&&u.set(O,M)}if(f.emptyWindow){const y=P.URI.parse(f.emptyWindow);s=n.find(A=>this.uriIdentityService.extUri.isEqual(A.location,y))}}this._profilesObject={profiles:n,workspaces:u,emptyWindow:s}}return this._profilesObject}async createTransientProfile(n){const s="Temp",u=new RegExp(`${(0,g.escapeRegExpCharacters)(s)}\\s(\\d+)`);let l=0;for(const y of this.profiles){const A=u.exec(y.name),O=A?parseInt(A[1]):0;l=O>l?O:l}const f=`${s} ${l+1}`;return this.createProfile((0,D.hash)((0,m.generateUuid)()).toString(16),f,void 0,!0,n)}async createNamedProfile(n,s,u){return this.createProfile((0,D.hash)((0,m.generateUuid)()).toString(16),n,s,!1,u)}async createProfile(n,s,u,l,f){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const y=await this.doCreateProfile(n,s,u,!!l);return f&&await this.setProfileForWorkspace(f,y),y}async doCreateProfile(n,s,u,l){let f=this.profileCreationPromises.get(s);return f||(f=(async()=>{try{const y=this.profiles.find(_=>_.name===s||_.id===n);if(y)return y;const A=c(n,s,(0,L.joinPath)(this.profilesHome,n),u,l);await this.fileService.createFolder(A.location);const O=[];return this._onWillCreateProfile.fire({profile:A,join(_){O.push(_)}}),await C.Promises.settled(O),this.updateProfiles([A],[],[]),A}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,f)),f}async updateProfile(n,s,u,l){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let f=this.profiles.find(y=>y.id===n.id);if(!f)throw new Error(`Profile '${n.name}' does not exist`);return f=c(f.id,s,f.location,u,l??f.isTransient),this.updateProfiles([],[],[f]),f}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(l=>l.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);const u=[];this._onWillRemoveProfile.fire({profile:s,join(l){u.push(l)}}),await C.Promises.settled(u),s.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const l of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(l)?.id&&this.profilesObject.workspaces.delete(l);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(s.location,{recursive:!0})}catch(l){this.logService.error(l)}}getOrSetProfileForWorkspace(n,s=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let u=this.getProfileForWorkspace(n);return u||(u=s,this.profiles.length>1&&this.setProfileForWorkspaceSync(n,u)),u}async setProfileForWorkspace(n,s){this.setProfileForWorkspaceSync(n,s)}setProfileForWorkspaceSync(n,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=this.profiles.find(l=>l.id===s.id);if(!u)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(n,u)}unsetWorkspace(n,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(s=>s.isDirectory&&this.profiles.every(u=>!this.uriIdentityService.extUri.isEqual(u.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(n.map(s=>this.removeProfile(s)))}getProfileForWorkspace(n){const s=this.getWorkspace(n);return P.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(n){return(0,v.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,v.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}isProfileAssociatedToWorkspace(n){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,n.location)||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,n.location)||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location)))}updateProfiles(n,s,u){const l=[...this.profiles,...n],f=[];this.transientProfilesObject.profiles=[];for(let y of l)y.isDefault||s.some(A=>y.id===A.id)||(y=u.find(A=>y.id===A.id)??y,y.isTransient?this.transientProfilesObject.profiles.push(y):f.push({location:y.location,name:y.name,useDefaultFlags:y.useDefaultFlags}));this.saveStoredProfiles(f),this._profilesObject=void 0,this.triggerProfilesChanges(n,s,u)}triggerProfilesChanges(n,s,u){this._onDidChangeProfiles.fire({added:n,removed:s,updated:u,all:this.profiles})}updateWorkspaceAssociation(n,s,u){u=s?.isTransient?!0:u,u||this.updateWorkspaceAssociation(n,void 0,!0);const l=this.getWorkspace(n),f=u?this.transientProfilesObject:this.profilesObject;P.URI.isUri(l)?(f.workspaces.delete(l),s&&f.workspaces.set(l,s)):f.emptyWindow=s,u||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[u,l]of this.profilesObject.workspaces.entries())n[u.toString()]=l.location.toString();const s=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:s}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=pe([K(0,b.IEnvironmentService),K(1,I.IFileService),K(2,S.IUriIdentityService),K(3,p.ILogService)],i),e.UserDataProfilesService=i;class o extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=o}),define(ne[246],re([0,1,6,2,20]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let L=class extends r.Disposable{constructor(P){super(),this._register(new D.RunOnceScheduler(()=>{P.cleanUp()},10*1e3)).schedule()}};L=pe([K(0,R.IUserDataProfilesService)],L),e.UserDataProfilesCleaner=L}),define(ne[247],re([0,1,19,6,23,9,3,2,4,7,143,29,33,44,8,25,24,20]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends P.Disposable{constructor(t,n,s,u,l){super(),this.galleryService=t,this.telemetryService=n,this.logService=s,this.productService=u,this.userDataProfilesService=l,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(({task:f})=>f.cancel()),this.uninstallingExtensions.forEach(f=>f.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const n=await this.getTargetPlatform();return t.allTargetPlatforms.some(s=>(0,w.isTargetPlatformCompatible)(s,t.allTargetPlatforms,n))}async installFromGallery(t,n={}){try{if(!this.galleryService.isEnabled())throw new w.ExtensionManagementError(I.localize(0,null),w.ExtensionManagementErrorCode.Internal);const s=await this.checkAndGetCompatibleVersion(t,!!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.installExtension(s.manifest,s.extension,n)}catch(s){throw c(this.telemetryService,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(t),error:s}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(s),d(s)}}async uninstall(t,n={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,n)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(I.localize(1,null));const n=await this.getTargetPlatform(),[s]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:n,compatible:!0},R.CancellationToken.None);if(!s)throw new Error(I.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(s)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,n,s){const u=_=>`${p.ExtensionKey.create(_).toString()}${s.profileLocation?`-${s.profileLocation.toString()}`:""}`;if(!b.URI.isUri(n)){const _=this.installingExtensions.get(u(n));if(_){this.logService.info("Extensions is already requested to install",n.identifier.id);const{local:M}=await _.task.waitUntilTaskIsFinished();return M}s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const l=[],f=[],y=[],A=this.createInstallExtensionTask(t,n,s);b.URI.isUri(n)||this.installingExtensions.set(u(n),{task:A,waitingTasks:[]}),this._onInstallExtension.fire({identifier:A.identifier,source:n,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",A.identifier.id),l.push({task:A,manifest:t});let O=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",A.identifier.id);else try{const M=await this.getAllDepsAndPackExtensions(A.identifier,t,!!s.installOnlyNewlyAddedFromExtensionPack,!!s.installPreReleaseVersion,s.profileLocation),k=await this.getInstalled(void 0,s.profileLocation);for(const{gallery:F,manifest:$}of M){O=O||!!$.extensionDependencies?.some(H=>(0,p.areSameExtensions)({id:H},A.identifier));const x=u(F),J=this.installingExtensions.get(x);if(J){if(this.canWaitForTask(A,J.task)){this.logService.info("Waiting for already requested installing extension",F.identifier.id,A.identifier.id),J.waitingTasks.push(A);const H=J.task.identifier;f.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,G=>G.some(z=>(0,p.areSameExtensions)(z.identifier,H)))).then(G=>{if(!G.find(j=>(0,p.areSameExtensions)(j.identifier,H))?.local)throw new Error(`Extension ${H.id} is not installed`)}))}}else if(!k.some(({identifier:H})=>(0,p.areSameExtensions)(H,F.identifier))){const H=this.createInstallExtensionTask($,F,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(x,{task:H,waitingTasks:[A]}),this._onInstallExtension.fire({identifier:H.identifier,source:F,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",H.identifier.id,A.identifier.id),l.push({task:H,manifest:$})}}}catch(M){if(b.URI.isUri(A.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",A.identifier.id,M.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",A.identifier.id,M.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",A.identifier.id),M}const _=l.reduce((M,{task:k,manifest:F})=>(M.set(k.identifier.id.toLowerCase(),{task:k,manifest:F}),M),new Map);for(;_.size;){let M;const k=[..._.values()].filter(({manifest:F})=>!F.extensionDependencies?.some($=>_.has($.toLowerCase())));k.length?M=_.size===1?k:k.filter(({task:F})=>!(F===A&&!O)):(this.logService.info("Found extensions with circular dependencies",k.map(({task:F})=>F.identifier.id)),M=[..._.values()]),await this.joinAllSettled(M.map(async({task:F})=>{const $=new Date().getTime();try{const{local:x}=await F.run();if(await this.joinAllSettled(this.participants.map(J=>J.postInstall(x,F.source,s,R.CancellationToken.None))),!b.URI.isUri(F.source)){const J=F.operation===3,H=J?void 0:(new Date().getTime()-F.source.lastUpdated)/1e3;if(c(this.telemetryService,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(F.source),duration:new Date().getTime()-$,durationSinceUpdate:H}),E.isWeb&&F.operation!==3)try{await this.galleryService.reportStatistic(x.manifest.publisher,x.manifest.name,x.manifest.version,"install")}catch{}}y.push({local:x,identifier:F.identifier,operation:F.operation,source:F.source,context:s.context,profileLocation:s.profileLocation,applicationScoped:x.isApplicationScoped})}catch(x){throw b.URI.isUri(F.source)||c(this.telemetryService,F.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(F.source),duration:new Date().getTime()-$,error:x}),this.logService.error("Error while installing the extension:",F.identifier.id),x}finally{_.delete(F.identifier.id.toLowerCase())}}))}return f.length&&await this.joinAllSettled(f),y.forEach(({identifier:M})=>this.logService.info("Extension installed successfully:",M.id)),this._onDidInstallExtensions.fire(y),y.filter(({identifier:M})=>(0,p.areSameExtensions)(M,A.identifier))[0].local}catch(_){if(l.forEach(({task:M})=>M.cancel()),y.length)try{const M=await Promise.allSettled(y.map(({local:k})=>this.createUninstallExtensionTask(k,{versionOnly:!0,profileLocation:s.profileLocation}).run()));for(let k=0;k<M.length;k++){const F=M[k],{identifier:$}=y[k];F.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",$.id):this.logService.warn("Rollback: Error while uninstalling extension",$.id,(0,L.getErrorMessage)(F.reason))}}catch(M){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(M),y.map(({identifier:k})=>k.id))}throw this._onDidInstallExtensions.fire(l.map(({task:M})=>({identifier:M.identifier,operation:2,source:M.source,context:s.context,profileLocation:s.profileLocation}))),_}finally{for(const[_,{task:M,waitingTasks:k}]of this.installingExtensions.entries()){const F=k.indexOf(A);F!==-1&&k.splice(F,1),k.length===0&&(M===A||F!==-1)&&this.installingExtensions.delete(_)}}}canWaitForTask(t,n){for(const[,{task:s,waitingTasks:u}]of this.installingExtensions.entries())if(s===t&&(u.includes(n)||u.some(l=>this.canWaitForTask(l,n)))||s===n&&u[0]&&!this.canWaitForTask(t,u[0]))return!1;return!0}async joinAllSettled(t){const n=[],s=[],u=await Promise.allSettled(t);for(const l of u)l.status==="fulfilled"?n.push(l.value):s.push(l.reason);if(s.length)throw a(s);return n}async getAllDepsAndPackExtensions(t,n,s,u,l){if(!this.galleryService.isEnabled())return[];const f=await this.getInstalled(void 0,l),y=[t],A=[],O=async(_,M)=>{const k=M.extensionDependencies||[],F=[...k];if(M.extensionPack){const $=s?f.find(x=>(0,p.areSameExtensions)(x.identifier,_)):void 0;for(const x of M.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(J=>(0,p.areSameExtensions)({id:J},{id:x}))||F.every(J=>!(0,p.areSameExtensions)({id:J},{id:x}))&&F.push(x)}if(F.length){const $=[...y,...A.map(J=>J.gallery.identifier)],x=F.filter(J=>$.every(H=>!(0,p.areSameExtensions)(H,{id:J})));if(x.length){const J=await this.galleryService.getExtensions(x.map(H=>({id:H,preRelease:u})),R.CancellationToken.None);for(const H of J){if($.find(j=>(0,p.areSameExtensions)(j,H.identifier)))continue;const G=k.some(j=>(0,p.areSameExtensions)({id:j},H.identifier));let z;try{z=await this.checkAndGetCompatibleVersion(H,!1,u)}catch(j){if(j instanceof w.ExtensionManagementError&&j.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!G){this.logService.info("Skipping the packed extension as it cannot be installed",H.identifier.id);continue}else throw j}A.push({gallery:z.extension,manifest:z.manifest}),await O(z.extension.identifier,z.manifest)}}}};return await O(t,n),A}async checkAndGetCompatibleVersion(t,n,s){if((await this.getExtensionsControlManifest()).malicious.some(y=>(0,p.areSameExtensions)(t.identifier,y)))throw new w.ExtensionManagementError(I.localize(3,null,t.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const y=await this.getTargetPlatform();throw new w.ExtensionManagementError(I.localize(4,null,t.identifier.id,this.productService.nameLong,(0,w.TargetPlatformToString)(y)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.getCompatibleVersion(t,n,s);if(l){if(s&&!n&&t.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(I.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],R.CancellationToken.None))[0]?new w.ExtensionManagementError(I.localize(6,null,t.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(I.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",l.identifier.id);const f=await this.galleryService.getManifest(l,R.CancellationToken.None);if(f===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(f.version!==l.version)throw new w.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:f}}async getCompatibleVersion(t,n,s){const u=await this.getTargetPlatform();let l=null;return!n&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==s&&(l=(await this.galleryService.getExtensions([{...t.identifier,preRelease:s}],{targetPlatform:u,compatible:!0},R.CancellationToken.None))[0]||null),!l&&await this.galleryService.isExtensionCompatible(t,s,u)&&(l=t),l||(n?l=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:u,compatible:!0},R.CancellationToken.None))[0]||null:l=await this.galleryService.getCompatibleExtension(t,s,u)),l}async uninstallExtension(t,n){const s=O=>`${O.id.toLowerCase()}${n.versionOnly?`-${t.manifest.version}`:""}${n.profileLocation?`@${n.profileLocation.toString()}`:""}`,u=this.uninstallingExtensions.get(s(t.identifier));if(u)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),u.waitUntilTaskIsFinished();const l=(O,_)=>{const M=this.createUninstallExtensionTask(O,_);return this.uninstallingExtensions.set(s(M.extension.identifier),M),n.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${O.identifier.id}@${O.manifest.version}`,n.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${O.identifier.id}@${O.manifest.version}`),this._onUninstallExtension.fire({identifier:O.identifier,profileLocation:n.profileLocation,applicationScoped:O.isApplicationScoped}),M},f=(O,_)=>{_?n.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${O.identifier.id}@${O.manifest.version}`,n.profileLocation.toString(),_.message):this.logService.error("Failed to uninstall extension:",`${O.identifier.id}@${O.manifest.version}`,_.message):n.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${O.identifier.id}@${O.manifest.version}`,n.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${O.identifier.id}@${O.manifest.version}`),c(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(O),error:_}),this._onDidUninstallExtension.fire({identifier:O.identifier,version:O.manifest.version,error:_?.code,profileLocation:n.profileLocation,applicationScoped:O.isApplicationScoped})},y=[],A=[];try{y.push(l(t,n));const O=await this.getInstalled(1,n.profileLocation);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const _=this.getAllPackExtensionsToUninstall(t,O);for(const M of _)this.uninstallingExtensions.has(s(M.identifier))?this.logService.info("Extensions is already requested to uninstall",M.identifier.id):y.push(l(M,n))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(y.map(_=>_.extension),O,t),await this.joinAllSettled(y.map(async _=>{try{if(await _.run(),await this.joinAllSettled(this.participants.map(M=>M.postUninstall(_.extension,n,R.CancellationToken.None))),_.extension.identifier.uuid)try{await this.galleryService.reportStatistic(_.extension.manifest.publisher,_.extension.manifest.name,_.extension.manifest.version,"uninstall")}catch{}f(_.extension)}catch(M){const k=M instanceof w.ExtensionManagementError?M:new w.ExtensionManagementError((0,L.getErrorMessage)(M),w.ExtensionManagementErrorCode.Internal);throw f(_.extension,k),k}finally{A.push(_)}}))}catch(O){const _=O instanceof w.ExtensionManagementError?O:new w.ExtensionManagementError((0,L.getErrorMessage)(O),w.ExtensionManagementErrorCode.Internal);for(const M of y){try{M.cancel()}catch{}A.includes(M)||f(M.extension,_)}throw _}finally{for(const O of y)this.uninstallingExtensions.delete(s(O.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",O.extension.identifier.id)}}checkForDependents(t,n,s){for(const u of t){const l=this.getDependents(u,n);if(l.length){const f=l.filter(y=>!t.some(A=>(0,p.areSameExtensions)(A.identifier,y.identifier)));if(f.length)throw new Error(this.getDependentsErrorMessage(u,f,s))}}}getDependentsErrorMessage(t,n,s){return s===t?n.length===1?I.localize(8,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?I.localize(9,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):I.localize(10,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?I.localize(11,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?I.localize(12,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):I.localize(13,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(t,n,s=[]){if(s.indexOf(t)!==-1)return[];s.push(t);const u=t.manifest.extensionPack?t.manifest.extensionPack:[];if(u.length){const l=n.filter(y=>!y.isBuiltin&&u.some(A=>(0,p.areSameExtensions)({id:A},y.identifier))),f=[];for(const y of l)f.push(...this.getAllPackExtensionsToUninstall(y,n,s));return[...l,...f]}return[]}getDependents(t,n){return n.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(u=>(0,p.areSameExtensions)({id:u},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,n,s){return s.profileLocation&&(0,v.isApplicationScopedExtension)(t)&&(s={...s,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,n,s)}createUninstallExtensionTask(t,n){return n.profileLocation&&t.isApplicationScoped&&(n={...n,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,n)}};g=pe([K(0,w.IExtensionGalleryService),K(1,C.ITelemetryService),K(2,h.ILogService),K(3,S.IProductService),K(4,m.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function a(o){const t=Array.isArray(o)?o:[o];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((n,s)=>new Error(`${n.message}${n.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=a;function d(o){if(o instanceof w.ExtensionManagementError)return o;const t=new w.ExtensionManagementError(o.message,w.ExtensionManagementErrorCode.Internal);return t.stack=o.stack,t}function c(o,t,{extensionData:n,duration:s,error:u,durationSinceUpdate:l}){const f=u?u instanceof w.ExtensionManagementError?u.code:w.ExtensionManagementErrorCode.Internal:void 0;o.publicLog(t,{...n,success:!u,duration:s,errorcode:f,durationSinceUpdate:l})}e.reportTelemetry=c;class i{constructor(){this.barrier=new r.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,r.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,r.createCancelablePromise)(t=>new Promise((n,s)=>{const u=t.onCancellationRequested(()=>{u.dispose(),s(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=i}),define(ne[74],re([0,1,19,6,32,16,9,35,125,2,22,12,4,17,55,84,15,7,146,14,33,44,68,13,5,8,25,3,65,49,20,31,174]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m,g,a,d,c,i,o,t,n,s,u,l,f,y,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var _;(function(H){function G(z,j){if(z===j)return!0;const Y=Object.keys(z),te=new Set;for(const ce of Object.keys(j))te.add(ce);if(Y.length!==te.size)return!1;for(const ce of Y){if(z[ce]!==j[ce])return!1;te.delete(ce)}return te.size===0}H.equals=G})(_=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let M=class extends b.Disposable{constructor(G,z,j,Y,te,ce,W,V,U,N,q){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=z,this.extensionsControlLocation=j,this.cacheLocation=Y,this.userDataProfilesService=te,this.extensionsProfileScannerService=ce,this.fileService=W,this.logService=V,this.environmentService=U,this.productService=N,this.instantiationService=q,this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance($,(0,v.joinPath)(this.cacheLocation,c.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance($,(0,v.joinPath)(this.cacheLocation,c.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(F,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,d.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(G,z,j){const[Y,te]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(z)]),ce=j?await this.scanExtensionsUnderDevelopment(G,[...Y,...te]):[];return this.dedupExtensions(Y,te,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const z=[];z.push(this.scanDefaultSystemExtensions(!!G.useCache,G.language)),z.push(this.scanDevSystemExtensions(G.language,!!G.checkControlFile));const[j,Y]=await Promise.all(z);return this.applyScanOptions([...j,...Y],0,G,!1)}async scanUserExtensions(G){this.logService.trace("Started scanning user extensions");const z=await this.createExtensionScannerInput(G.profileLocation??this.userExtensionsLocation,!!G.profileLocation,1,!G.includeUninstalled,G.language);let Y=await(G.useCache&&!z.devMode&&z.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return Y=await this.applyScanOptions(Y,1,G,!0),this.logService.trace("Scanned user extensions:",Y.length),Y}async scanExtensionsUnderDevelopment(G,z){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const j=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(Y=>Y.scheme===I.Schemas.file).map(async Y=>{const te=await this.createExtensionScannerInput(Y,!1,1,!0,G.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(te)).map(W=>(W.type=z.find(V=>(0,d.areSameExtensions)(V.identifier,W.identifier))?.type??W.type,this.extensionsScanner.validate(W,te)))}))).flat();return this.applyScanOptions(j,"development",G,!0)}return[]}async scanExistingExtension(G,z,j){const Y=await this.createExtensionScannerInput(G,!1,z,!0,j.language),te=await this.extensionsScanner.scanExtension(Y);return!te||!j.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(G,z,j){const Y=await this.createExtensionScannerInput(G,!1,z,!0,j.language),te=await this.extensionsScanner.scanOneOrMultipleExtensions(Y);return this.applyScanOptions(te,z,j,!0)}async scanMetadata(G){const z=(0,v.joinPath)(G,"package.json"),j=(await this.fileService.readFile(z)).value.toString();return JSON.parse(j).__metadata}async updateMetadata(G,z){const j=(0,v.joinPath)(G,"package.json"),Y=(await this.fileService.readFile(j)).value.toString(),te=JSON.parse(Y);z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.installedTimestamp=z.installedTimestamp||void 0,te.__metadata={...te.__metadata,...z},await this.fileService.writeFile((0,v.joinPath)(G,"package.json"),L.VSBuffer.fromString(JSON.stringify(te,null,"	")))}async applyScanOptions(G,z,j,Y){return j.includeAllVersions||(G=this.dedupExtensions(z===0?G:void 0,z===1?G:void 0,z==="development"?G:void 0,await this.getTargetPlatform(),Y)),j.includeInvalid||(G=G.filter(te=>te.isValid)),G.sort((te,ce)=>{const W=w.basename(te.location.fsPath),V=w.basename(ce.location.fsPath);return W<V?-1:W>V?1:0})}dedupExtensions(G,z,j,Y,te){const ce=(V,U,N)=>{if(V.isValid&&!U.isValid)return!1;if(V.isValid===U.isValid){if(te&&h.gt(V.manifest.version,U.manifest.version))return this.logService.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${V.location.path} with version ${V.manifest.version}`),!1;if(h.eq(V.manifest.version,U.manifest.version)){if(V.type===0)return this.logService.debug(`Skipping extension ${U.location.path} in favour of system extension ${V.location.path} with same version`),!1;if(V.targetPlatform===Y)return this.logService.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return N?this.logService.warn(`Overwriting user extension ${V.location.path} with ${U.location.path}.`):this.logService.debug(`Overwriting user extension ${V.location.path} with ${U.location.path}.`),!0},W=new Map;return G?.forEach(V=>{const U=c.ExtensionIdentifier.toKey(V.identifier.id),N=W.get(U);(!N||ce(N,V,!1))&&W.set(U,V)}),z?.forEach(V=>{const U=c.ExtensionIdentifier.toKey(V.identifier.id),N=W.get(U);if(!N&&G&&V.type===0){this.logService.debug(`Skipping obsolete system extension ${V.location.path}.`);return}(!N||ce(N,V,!1))&&W.set(U,V)}),j?.forEach(V=>{const U=c.ExtensionIdentifier.toKey(V.identifier.id),N=W.get(U);(!N||ce(N,V,!0))&&W.set(U,V),W.set(U,V)}),[...W.values()]}async scanDefaultSystemExtensions(G,z){this.logService.trace("Started scanning system extensions");const j=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,z),te=await(G&&!j.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(j);return this.logService.trace("Scanned system extensions:",te.length),te}async scanDevSystemExtensions(G,z){const j=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!j?.length)return[];this.logService.trace("Started scanning dev system extensions");const Y=z?await this.getBuiltInExtensionControl():{},te=[],ce=m.URI.file(w.normalize(w.join(I.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions")));for(const V of j){const U=Y[V.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":te.push((0,v.joinPath)(ce,V.name));break;default:te.push(m.URI.file(U));break}}const W=await Promise.all(te.map(async V=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(V,!1,0,!0,G))));return this.logService.trace("Scanned dev system extensions:",W.length),(0,D.coalesce)(W)}async getBuiltInExtensionControl(){try{const G=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(G.value.toString())}catch{return{}}}async createExtensionScannerInput(G,z,j,Y,te,ce=!0){const W=await this.getTranslations(te??p.language),V=await this.getMtime(G),U=z?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,N=U?await this.getMtime(U):void 0;return new k(G,V,U,N,z,j,Y,ce,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,te,W)}async getMtime(G){try{const z=await this.fileService.stat(G);if(typeof z.mtime=="number")return z.mtime}catch{}}};M=pe([K(4,y.IUserDataProfilesService),K(5,f.IExtensionsProfileScannerService),K(6,o.IFileService),K(7,n.ILogService),K(8,a.IEnvironmentService),K(9,s.IProductService),K(10,t.IInstantiationService)],M),e.AbstractExtensionsScannerService=M;class k{constructor(G,z,j,Y,te,ce,W,V,U,N,q,B,Z,oe){this.location=G,this.mtime=z,this.applicationExtensionslocation=j,this.applicationExtensionslocationMtime=Y,this.profile=te,this.type=ce,this.excludeObsolete=W,this.validate=V,this.productVersion=U,this.productDate=N,this.productCommit=q,this.devMode=B,this.language=Z,this.translations=oe}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,z){return(0,v.isEqual)(G.location,z.location)&&G.mtime===z.mtime&&(0,v.isEqual)(G.applicationExtensionslocation,z.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===z.applicationExtensionslocationMtime&&G.profile===z.profile&&G.type===z.type&&G.excludeObsolete===z.excludeObsolete&&G.validate===z.validate&&G.productVersion===z.productVersion&&G.productDate===z.productDate&&G.productCommit===z.productCommit&&G.devMode===z.devMode&&G.language===z.language&&_.equals(G.translations,z.translations)}}let F=class extends b.Disposable{constructor(G,z,j,Y,te){super(),this.obsoleteFile=G,this.extensionsProfileScannerService=z,this.uriIdentityService=j,this.fileService=Y,this.logService=te}async scanExtensions(G){const z=G.profile?await this.scanExtensionsFromProfile(G):await this.scanExtensionsFromLocation(G);let j={};if(G.excludeObsolete&&G.type===1)try{const Y=(await this.fileService.readFile(this.obsoleteFile)).value.toString();j=JSON.parse(Y)}catch{}return(0,C.isEmptyObject)(j)?z:z.filter(Y=>!j[d.ExtensionKey.create(Y).toString()])}async scanExtensionsFromLocation(G){const z=await this.fileService.resolve(G.location);if(!z.children?.length)return[];const j=await Promise.all(z.children.map(async Y=>{if(!Y.isDirectory||G.type===1&&(0,v.basename)(Y.resource).indexOf(".")===0)return null;const te=new k(Y.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(te)}));return(0,D.coalesce)(j).sort((Y,te)=>Y.location.path<te.location.path?-1:1)}async scanExtensionsFromProfile(G){let z=await this.scanExtensionsFromProfileResource(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(G.location,G.applicationExtensionslocation)){z=z.filter(Y=>!Y.metadata?.isApplicationScoped);const j=await this.scanExtensionsFromProfileResource(G.applicationExtensionslocation,Y=>!!Y.metadata?.isApplicationScoped,G);z.push(...j)}return z}async scanExtensionsFromProfileResource(G,z,j){const Y=await this.extensionsProfileScannerService.scanProfileExtensions(G);if(!Y.length)return[];const te=await Promise.all(Y.map(async ce=>{if(z(ce)){const W=new k(ce.location,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(W,ce.metadata)}return null}));return(0,D.coalesce)(te)}async scanOneOrMultipleExtensions(G){try{if(await this.fileService.exists((0,v.joinPath)(G.location,"package.json"))){const z=await this.scanExtension(G);return z?[z]:[]}else return await this.scanExtensions(G)}catch(z){return this.logService.error(`Error scanning extensions at ${G.location.path}:`,(0,T.getErrorMessage)(z)),[]}}async scanExtension(G,z){try{let j=await this.scanExtensionManifest(G.location);if(j){j.publisher||(j.publisher=c.UNDEFINED_PUBLISHER),z=z??j.__metadata,delete j.__metadata;const Y=(0,d.getGalleryExtensionId)(j.publisher,j.name),te=z?.id?{id:Y,uuid:z.id}:{id:Y},ce=z?.isSystem?0:G.type,W=ce===0||!!z?.isBuiltin;j=await this.translateManifest(G.location,j,k.createNlsConfiguration(G));const V={type:ce,identifier:te,manifest:j,location:G.location,isBuiltin:W,targetPlatform:z?.targetPlatform??"undefined",metadata:z,isValid:!0,validations:[]};return G.validate?this.validate(V,G):V}}catch(j){G.type!==0&&this.logService.error(j)}return null}validate(G,z){let j=!0;const Y=(0,i.validateExtensionManifest)(z.productVersion,z.productDate,z.location,G.manifest,G.isBuiltin);for(const[te,ce]of Y)te===S.default.Error&&(j=!1,this.logService.error(this.formatMessage(z.location,ce)));return G.isValid=j,G.validations=Y,G}async scanExtensionManifest(G){const z=(0,v.joinPath)(G,"package.json");let j;try{j=(await this.fileService.readFile(z)).value.toString()}catch(te){return(0,o.toFileOperationResult)(te)!==1&&this.logService.error(this.formatMessage(G,(0,g.localize)(0,null,z.path,te.message))),null}let Y;try{Y=JSON.parse(j)}catch{const ce=[];(0,P.parse)(j,ce);for(const W of ce)this.logService.error(this.formatMessage(G,(0,g.localize)(1,null,z.path,W.offset,W.length,(0,E.getParseErrorMessage)(W.error))));return null}return(0,P.getNodeType)(Y)!=="object"?(this.logService.error(this.formatMessage(G,(0,g.localize)(2,null,z.path))),null):Y}async translateManifest(G,z,j){const Y=await this.getLocalizedMessages(G,z,j);if(Y)try{const te=[],ce=await this.resolveOriginalMessageBundle(Y.default,te);if(te.length>0)return te.forEach(V=>{this.logService.error(this.formatMessage(G,(0,g.localize)(3,null,Y.default?.path,(0,E.getParseErrorMessage)(V.error))))}),z;if((0,P.getNodeType)(Y)!=="object")return this.logService.error(this.formatMessage(G,(0,g.localize)(4,null,Y.default?.path))),z;const W=Y.values||Object.create(null);return(0,O.localizeManifest)(z,W,ce)}catch{}return z}async getLocalizedMessages(G,z,j){const Y=(0,v.joinPath)(G,"package.nls.json"),te=(U,N)=>{N.forEach(q=>{this.logService.error(this.formatMessage(G,(0,g.localize)(5,null,U?.path,(0,E.getParseErrorMessage)(q.error))))})},ce=U=>{this.logService.error(this.formatMessage(G,(0,g.localize)(6,null,U?.path)))},W=`${z.publisher}.${z.name}`,V=j.translations[W];if(V)try{const U=m.URI.file(V),N=(await this.fileService.readFile(U)).value.toString(),q=[],B=(0,P.parse)(N,q);return q.length>0?(te(U,q),{values:void 0,default:Y}):(0,P.getNodeType)(B)!=="object"?(ce(U),{values:void 0,default:Y}):{values:B.contents?B.contents.package:void 0,default:Y}}catch{return{values:void 0,default:Y}}else{if(!await this.fileService.exists(Y))return;let N;try{N=await this.findMessageBundles(G,j)}catch{return}if(!N.localized)return{values:void 0,default:N.original};try{const q=(await this.fileService.readFile(N.localized)).value.toString(),B=[],Z=(0,P.parse)(q,B);return B.length>0?(te(N.localized,B),{values:void 0,default:N.original}):(0,P.getNodeType)(Z)!=="object"?(ce(N.localized),{values:void 0,default:N.original}):{values:Z,default:N.original}}catch{return{values:void 0,default:N.original}}}}async resolveOriginalMessageBundle(G,z){if(G)try{const j=(await this.fileService.readFile(G)).value.toString();return(0,P.parse)(j,z)}catch{}}findMessageBundles(G,z){return new Promise((j,Y)=>{const te=ce=>{const W=(0,v.joinPath)(G,`package.nls.${ce}.json`);this.fileService.exists(W).then(V=>{V&&j({localized:W,original:(0,v.joinPath)(G,"package.nls.json")});const U=ce.lastIndexOf("-");U===-1?j({localized:(0,v.joinPath)(G,"package.nls.json"),original:null}):(ce=ce.substring(0,U),te(ce))})};if(z.devMode||z.pseudo||!z.language)return j({localized:(0,v.joinPath)(G,"package.nls.json"),original:null});te(z.language)})}formatMessage(G,z){return`[${G.path}]: ${z}`}};F=pe([K(1,f.IExtensionsProfileScannerService),K(2,A.IUriIdentityService),K(3,o.IFileService),K(4,n.ILogService)],F);let $=class extends F{constructor(G,z,j,Y,te,ce){super(z,j,Y,te,ce),this.cacheFile=G,this.cacheValidatorThrottler=this._register(new r.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(G){const z=await this.readExtensionCache();if(this.input=G,z&&z.input&&k.equals(z.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),z.result.map(Y=>(Y.location=m.URI.revive(Y.location),Y));const j=await super.scanExtensions(G);return await this.writeExtensionCache({input:G,result:j}),j}async readExtensionCache(){try{const G=await this.fileService.readFile(this.cacheFile),z=JSON.parse(G.value.toString());return{result:z.result,input:(0,l.revive)(z.input)}}catch(G){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(G))}return null}async writeExtensionCache(G){try{await this.fileService.writeFile(this.cacheFile,L.VSBuffer.fromString(JSON.stringify(G)))}catch(z){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(z))}}async validateCache(){if(!this.input)return;const G=await this.readExtensionCache();if(!G)return;const z=G.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!R.equals(j,z))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(Y){this.logService.error(Y)}}};$=pe([K(2,f.IExtensionsProfileScannerService),K(3,A.IUriIdentityService),K(4,o.IFileService),K(5,n.ILogService)],$);function x(H,G){const z=(0,d.getExtensionId)(H.manifest.publisher,H.manifest.name);return{id:z,identifier:new c.ExtensionIdentifier(z),isBuiltin:H.type===0,isUserBuiltin:H.type===1&&H.isBuiltin,isUnderDevelopment:G,extensionLocation:H.location,uuid:H.identifier.uuid,targetPlatform:H.targetPlatform,...H.manifest}}e.toExtensionDescription=x;class J extends M{constructor(G,z,j,Y,te,ce,W,V,U,N,q){super(G,z,(0,v.joinPath)(j,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(Y,c.MANIFEST_CACHE_FOLDER),te,ce,W,V,U,N,q),this.translationsPromise=(async()=>{if(p.translationsConfigFile)try{const B=await this.fileService.readFile(m.URI.file(p.translationsConfigFile));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}getTranslations(G){return this.translationsPromise}}e.NativeExtensionsScannerService=J}),define(ne[248],re([0,1,54,6,38,3,2,22,12,28,8,20]),function(Q,e,D,r,R,L,T,P,E,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends T.Disposable{constructor(h,S){super(),this.userDataProfilesService=h,this.logService=S,this.processesLimiter=new r.Limiter(5)}async postUninstall(h){const S=this.parseScript(h,"uninstall");return S&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),C=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${C}`)))),b.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,C=>this.logService.error("Error while removing extension storage path",C))}parseScript(h,S){const C=`vscode:${S}`;if(h.location.scheme===P.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[C]=="string"){const m=h.manifest.scripts[C].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${C} should be a node script`),null):{script:(0,E.join)(h.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(h,S,C,m,g){return new Promise((a,d)=>{const c=this.start(h,S,C,g);let i;const o=t=>{i&&(clearTimeout(i),i=null),t?d(t):a(void 0)};c.on("error",t=>{o((0,R.toErrorMessage)(t)||"Unknown")}),c.on("exit",(t,n)=>{o(t?`post-${S} process exited with code ${t}`:void 0)}),m&&(i=setTimeout(()=>{i=null,c.kill(),d("timed out")},5e3))})}start(h,S,C,m){const g={silent:!0,execArgv:void 0},a=(0,D.fork)(h,[`--type=extension-post-${S}`,...C],g);a.stdout.setEncoding("utf8"),a.stderr.setEncoding("utf8");const d=L.Event.fromNodeEventEmitter(a.stdout,"data"),c=L.Event.fromNodeEventEmitter(a.stderr,"data");d(t=>this.logService.info(m.identifier.id,m.manifest.version,`post-${S}`,t)),c(t=>this.logService.error(m.identifier.id,m.manifest.version,`post-${S}`,t));const i=L.Event.any(L.Event.map(d,t=>({data:`%c${t}`,format:[""]})),L.Event.map(c,t=>({data:`%c${t}`,format:["color: red"]})));return L.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(m.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),a}getExtensionStoragePath(h){return(0,E.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};p=pe([K(0,w.IUserDataProfilesService),K(1,I.ILogService)],p),e.ExtensionsLifecycle=p}),define(ne[249],re([0,1,7,14,49,74,13,5,8,25,20]),function(Q,e,D,r,R,L,T,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let w=class extends L.NativeExtensionsScannerService{constructor(v,h,S,C,m,g,a){super(D.URI.file(m.builtinExtensionsPath),D.URI.file(m.extensionsPath),m.userHome,D.URI.file(m.userDataPath),v,h,S,C,m,g,a)}};w=pe([K(0,I.IUserDataProfilesService),K(1,R.IExtensionsProfileScannerService),K(2,T.IFileService),K(3,E.ILogService),K(4,r.INativeEnvironmentService),K(5,b.IProductService),K(6,P.IInstantiationService)],w),e.ExtensionsScannerService=w}),define(ne[21],re([0,1,6,3,2,192,15,67,5,20]),function(Q,e,D,r,R,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,E.createDecorator)("storageService");var I;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var w;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(w=e.StorageScope||(e.StorageScope={}));var p;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));function v(g){const a=g.get(e.TARGET_KEY);if(a)try{return JSON.parse(a)}catch{}return Object.create(null)}e.loadKeyTargets=v;class h extends R.Disposable{constructor(a={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super(),this.options=a,this._onDidChangeValue=this._register(new r.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new r.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new r.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(a,d){if(d===e.TARGET_KEY){switch(a){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:a})}else this._onDidChangeValue.fire({scope:a,key:d,target:this.getKeyTargets(a)[d]})}emitWillSaveState(a){this._onWillSaveState.fire({reason:a})}get(a,d,c){return this.getStorage(d)?.get(a,c)}getBoolean(a,d,c){return this.getStorage(d)?.getBoolean(a,c)}getNumber(a,d,c){return this.getStorage(d)?.getNumber(a,c)}store(a,d,c,i){if((0,T.isUndefinedOrNull)(d)){this.remove(a,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(a,c,i),this.getStorage(c)?.set(a,d)})}remove(a,d){this.withPausedEmitters(()=>{this.updateKeyTarget(a,d,void 0),this.getStorage(d)?.delete(a)})}withPausedEmitters(a){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{a()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(a,d){const c=[],i=this.getKeyTargets(a);for(const o of Object.keys(i))i[o]===d&&c.push(o);return c}updateKeyTarget(a,d,c){const i=this.getKeyTargets(d);typeof c=="number"?i[a]!==c&&(i[a]=c,this.getStorage(d)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[a]=="number"&&(delete i[a],this.getStorage(d)?.set(e.TARGET_KEY,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(a){switch(a){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(a){const d=this.getStorage(a);return d?v(d):Object.create(null)}isNew(a){return this.getBoolean(e.IS_NEW_KEY,a)===!0}async flush(a=I.NONE){this._onWillSaveState.fire({reason:a});const d=this.getStorage(-1),c=this.getStorage(0),i=this.getStorage(1);switch(a){case I.NONE:await D.Promises.settled([d?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await D.Promises.settled([d?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const a=this.getStorage(-1)?.items??new Map,d=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return m(a,d,c,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(a,d){return this.emitWillSaveState(I.NONE),(0,b.isUserDataProfile)(a)?this.switchToProfile(a,d):this.switchToWorkspace(a,d)}canSwitchProfile(a,d){return!(a.id===d.id||S(d)&&S(a))}switchData(a,d,c,i){this.withPausedEmitters(()=>{if(i)for(const[o,t]of a)d.set(o,t);else{const o=new Set;for(const[t,n]of a)o.add(t),d.get(t)!==n&&this.emitDidChangeValue(c,t);for(const[t]of d.items)o.has(t)||this.emitDidChangeValue(c,t)}})}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;function S(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class C extends h{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(a=>this.emitDidChangeValue(1,a))),this._register(this.profileStorage.onDidChangeStorage(a=>this.emitDidChangeValue(0,a))),this._register(this.applicationStorage.onDidChangeStorage(a=>this.emitDidChangeValue(-1,a)))}getStorage(a){switch(a){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(a){switch(a){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(a){return!1}}e.InMemoryStorageService=C;async function m(g,a,d,c,i,o){const t=_=>{try{return JSON.parse(_)}catch{return _}},n=new Map,s=new Map;g.forEach((_,M)=>{n.set(M,_),s.set(M,t(_))});const u=new Map,l=new Map;a.forEach((_,M)=>{u.set(M,_),l.set(M,t(_))});const f=new Map,y=new Map;d.forEach((_,M)=>{f.set(M,_),y.set(M,t(_))}),console.group(c!==i?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const A=[];if(n.forEach((_,M)=>{A.push({key:M,value:_})}),console.table(A),console.groupEnd(),console.log(s),c!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const _=[];u.forEach((M,k)=>{_.push({key:k,value:M})}),console.table(_),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${o})`);const O=[];f.forEach((_,M)=>{O.push({key:M,value:_})}),console.table(O),console.groupEnd(),console.log(y)}e.logStorage=m}),define(ne[250],re([0,1,3,2,15,29,33,21]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let E=class extends r.Disposable{constructor(w,p){super(),this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(w)),this._register(this.storageManger.onDidChange(v=>this._onDidChangeEnablement.fire({extensions:v,source:"storage"}))),this._register(p.onDidInstallExtensions(v=>v.forEach(({local:h,operation:S})=>{h&&S===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(w,p){return this._removeFromDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:p}),!0):!1}async disableExtension(w,p){return this._addToDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:p}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(w){const p=this.getDisabledExtensions();return p.every(v=>!(0,T.areSameExtensions)(v,w))?(p.push(w),this._setDisabledExtensions(p),!0):!1}_removeFromDisabledExtensions(w){const p=this.getDisabledExtensions();for(let v=0;v<p.length;v++){const h=p[v];if((0,T.areSameExtensions)(h,w))return p.splice(v,1),this._setDisabledExtensions(p),!0}return!1}_setDisabledExtensions(w){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,w)}_getExtensions(w){return this.storageManger.get(w,0)}_setExtensions(w,p){this.storageManger.set(w,p,0)}};E=pe([K(0,P.IStorageService),K(1,L.IExtensionManagementService)],E),e.GlobalExtensionEnablementService=E;class b extends r.Disposable{constructor(w){super(),this.storageService=w,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(w.onDidChangeValue(p=>this.onDidStorageChange(p)))}get(w,p){let v;return p===0?((0,R.isUndefinedOrNull)(this.storage[w])&&(this.storage[w]=this._get(w,p)),v=this.storage[w]):v=this._get(w,p),JSON.parse(v)}set(w,p,v){const h=JSON.stringify(p.map(({id:C,uuid:m})=>({id:C,uuid:m})));this._get(w,v)!==h&&(v===0&&(p.length?this.storage[w]=h:delete this.storage[w]),this._set(w,p.length?h:void 0,v))}onDidStorageChange(w){if(w.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[w.key])&&this._get(w.key,w.scope)!==this.storage[w.key]){const v=this.get(w.key,w.scope);delete this.storage[w.key];const h=this.get(w.key,w.scope),S=v.filter(m=>!h.some(g=>(0,T.areSameExtensions)(m,g))),C=h.filter(m=>!v.some(g=>(0,T.areSameExtensions)(g,m)));(S.length||C.length)&&this._onDidChange.fire([...S,...C])}}_get(w,p){return this.storageService.get(w,p,"[]")}_set(w,p,v){p?this.storageService.store(w,p,v,1):this.storageService.remove(w,v)}}e.StorageManager=b}),define(ne[251],re([0,1,19,23,9,4,36,15,7,18,14,29,33,68,13,8,25,45,220,21,24]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m,g,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const c=L.isWeb?"web":(0,w.getTargetPlatform)(L.platform,T.arch);var i;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function o(...U){return String(U.reduce((N,q)=>N|q,0))}var t;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class f{constructor(N=l){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,q=this.state.pageSize){return new f({...this.state,pageNumber:N,pageSize:q})}withFilter(N,...q){const B=[...this.state.criteria,...q.length?q.map(Z=>({filterType:N,value:Z})):[{filterType:N}]];return new f({...this.state,criteria:B})}withSortBy(N){return new f({...this.state,sortBy:N})}withSortOrder(N){return new f({...this.state,sortOrder:N})}withFlags(...N){return new f({...this.state,flags:N.reduce((q,B)=>q|B,0)})}withAssetTypes(...N){return new f({...this.state,assetTypes:N})}withSource(N){return new f({...this.state,source:N})}get raw(){const{criteria:N,pageNumber:q,pageSize:B,sortBy:Z,sortOrder:oe,flags:X,assetTypes:ie}=this.state;return{filters:[{criteria:N,pageNumber:q,pageSize:B,sortBy:Z,sortOrder:oe}],assetTypes:ie,flags:X}}get searchText(){const N=this.state.criteria.filter(q=>q.filterType===t.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function y(U,N){const q=(U||[]).filter(B=>B.statisticName===N)[0];return q?q.value:0}function A(U){const N="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(B=>B.assetType.indexOf(N)===0).reduce((B,Z)=>{const oe=M(U,Z.assetType);return oe&&B.push([Z.assetType.substring(N.length),oe]),B},[])}function O(U){if(U.properties){const N=U.properties.filter(Z=>Z.key===n.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=N.filter(Z=>q.test(Z.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return M(U,n.Repository)}function _(U){return{uri:`${U.fallbackAssetUri}/${n.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${n.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function M(U,N){return U.files.filter(B=>B.assetType===N)[0]?{uri:`${U.assetUri}/${N}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${N}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function k(U,N){const q=U.properties?U.properties.filter(Z=>Z.key===N):[],B=q.length>0&&q[0].value;return B?B.split(",").map(Z=>(0,p.adoptToGalleryExtensionId)(Z)):[]}function F(U){const N=U.properties?U.properties.filter(q=>q.key===s.Engine):[];return N.length>0&&N[0].value||""}function $(U){const N=U.properties?U.properties.filter(q=>q.key===s.PreRelease):[];return N.length>0&&N[0].value==="true"}function x(U){const N=U.properties?U.properties.filter(B=>B.key===s.LocalizedLanguages):[],q=N.length>0&&N[0].value||"";return q?q.split(","):[]}function J(U){return U.properties?.find(N=>N.key===s.SponsorLink)?.value}function H(U){return U.indexOf("preview")!==-1}function G(U){return U.targetPlatform?(0,w.toTargetPlatform)(U.targetPlatform):"undefined"}function z(U){const N=(0,D.distinct)(U.versions.map(G)),q=!!U.tags?.includes(w.WEB_EXTENSION_TAG),B=N.indexOf("web");return q?B===-1&&N.push("web"):B!==-1&&N.splice(B,1),N}function j(U,N){const q=(0,w.getFallbackTargetPlarforms)(N);for(let B=0;B<U.length;B++){const Z=U[B];if(Z.version===U[B-1]?.version){let oe=B;const X=G(Z);if(X===N)for(;oe>0&&U[oe-1].version===Z.version;)oe--;else if(q.includes(X))for(;oe>0&&U[oe-1].version===Z.version&&G(U[oe-1])!==N;)oe--;oe!==B&&(U.splice(B,1),U.splice(oe,0,Z))}}return U}e.sortExtensionVersions=j;function Y(U,N,q){U.telemetryData={index:N,querySource:q}}function te(U,N,q){const B=U.versions[0],Z={manifest:M(N,n.Manifest),readme:M(N,n.Details),changelog:M(N,n.Changelog),license:M(N,n.License),repository:O(N),download:_(N),icon:M(N,n.Icon),coreTranslations:A(N)};return{identifier:{id:(0,p.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:N.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:J(B),description:U.shortDescription||"",installCount:y(U.statistics,"install"),rating:y(U.statistics,"averagerating"),ratingCount:y(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:q,assets:Z,properties:{dependencies:k(N,s.Dependency),extensionPack:k(N,s.ExtensionPack),engine:F(N),localizedLanguages:x(N),targetPlatform:G(N),isPreReleaseVersion:$(N)},hasPreReleaseVersion:$(B),hasReleaseVersion:!0,preview:H(U.flags)}}let ce=class{constructor(N,q,B,Z,oe,X,ie,se){this.requestService=q,this.logService=B,this.environmentService=Z,this.telemetryService=oe,this.fileService=X,this.productService=ie,this.configurationService=se;const ue=ie.extensionsGallery;this.extensionsGalleryUrl=ue&&ue.serviceUrl,this.extensionsControlUrl=ue&&ue.controlUrl,this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(ie.version,ie,this.environmentService,this.configurationService,this.fileService,N,this.telemetryService)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,q,B){const Z=r.CancellationToken.isCancellationToken(q)?{}:q,oe=r.CancellationToken.isCancellationToken(q)?q:B,X=[],ie=[],se=[],ue=[];let he=!0;for(const Ee of N){Ee.uuid?ie.push(Ee.uuid):X.push(Ee.id);const Pe=!!(Ee.version||Ee.preRelease);se.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Pe}),Ee.version&&ue.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),he=he&&!!Ee.hasPreRelease&&!Pe}if(!ie.length&&!X.length)return[];let ve=new f().withPage(1,N.length);ie.length&&(ve=ve.withFilter(t.ExtensionId,...ie)),X.length&&(ve=ve.withFilter(t.ExtensionName,...X)),(Z.queryAllVersions||he)&&(ve=ve.withFlags(ve.flags,i.IncludeVersions)),Z.source&&(ve=ve.withSource(Z.source));const{extensions:we}=await this.queryGalleryExtensions(ve,{targetPlatform:Z.targetPlatform??c,includePreRelease:se,versions:ue,compatible:!!Z.compatible},oe);return Z.source&&we.forEach((Ee,Pe)=>Y(Ee,Pe,Z.source)),we}async getCompatibleExtension(N,q,B){if((0,w.isNotWebExtensionInWebTargetPlatform)(N.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(N,q,B))return N;const Z=new f().withFlags(i.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,N.identifier.uuid),{extensions:oe}=await this.queryGalleryExtensions(Z,{targetPlatform:B,compatible:!0,includePreRelease:q},r.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(N,q,B){if(!(0,w.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,B)||!q&&N.properties.isPreReleaseVersion)return!1;let Z=N.properties.engine;if(!Z){const oe=await this.getManifest(N,r.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");Z=oe.engines.vscode}return(0,v.isEngineValid)(Z,this.productService.version,this.productService.date)}async isValidVersion(N,q,B,Z,oe){if(!(0,w.isTargetPlatformCompatible)(G(N),Z,oe)||q!=="any"&&$(N)!==(q==="prerelease"))return!1;if(B)try{const X=await this.getEngine(N);if(!(0,v.isEngineValid)(X,this.productService.version,this.productService.date))return!1}catch(X){return this.logService.error(`Error while getting the engine for the version ${N.version}.`,(0,R.getErrorMessage)(X)),!1}return!0}async query(N,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=N.text||"";const Z=N.pageSize??50;let oe=new f().withPage(1,Z);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,ve,we)=>(oe=oe.withFilter(t.Category,we||ve),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,ve,we)=>(oe=oe.withFilter(t.Tag,we||ve),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(t.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),oe=oe.withFilter(t.SearchText,B)),oe=oe.withSortBy(0)):N.ids?oe=oe.withFilter(t.ExtensionId,...N.ids):N.names?oe=oe.withFilter(t.ExtensionName,...N.names):oe=oe.withSortBy(4),typeof N.sortBy=="number"&&(oe=oe.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(oe=oe.withSortOrder(N.sortOrder)),N.source&&(oe=oe.withSource(N.source));const X=async(he,ve)=>{const{extensions:we,total:Ee}=await this.queryGalleryExtensions(he,{targetPlatform:c,compatible:!1,includePreRelease:!!N.includePreRelease},ve);return we.forEach((Pe,Ue)=>Y(Pe,(he.pageNumber-1)*he.pageSize+Ue,N.source)),{extensions:we,total:Ee}},{extensions:ie,total:se}=await X(oe,q),ue=async(he,ve)=>{if(ve.isCancellationRequested)throw new R.CancellationError;const{extensions:we}=await X(oe.withPage(he+1),ve);return we};return{firstPage:ie,total:se,pageSize:oe.pageSize,getPage:ue}}async queryGalleryExtensions(N,q,B){const Z=N.flags;!!(N.flags&i.IncludeLatestVersionOnly)&&!!(N.flags&i.IncludeVersions)&&(N=N.withFlags(N.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(N.flags&i.IncludeLatestVersionOnly)&&!(N.flags&i.IncludeVersions)&&(N=N.withFlags(N.flags,i.IncludeLatestVersionOnly)),q.versions?.length&&(N=N.withFlags(N.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),N=N.withFlags(N.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:oe,total:X}=await this.queryRawGalleryExtensions(N,B);if(!(N.flags&i.IncludeLatestVersionOnly)){const he=[];for(const ve of oe){const we=await this.toGalleryExtensionWithCriteria(ve,q);we&&he.push(we)}return{extensions:he,total:X}}const se=[],ue=new Map;for(let he=0;he<oe.length;he++){const ve=oe[he],we={id:(0,p.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),uuid:ve.extensionId},Ee=(0,P.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(Ue=>(0,p.areSameExtensions)(Ue,we))?.includePreRelease;if(q.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(z(ve),q.targetPlatform))continue;const Pe=await this.toGalleryExtensionWithCriteria(ve,q);!Pe||Pe.properties.isPreReleaseVersion&&(!Ee||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==q.targetPlatform&&Pe.hasPreReleaseVersion?ue.set(ve.extensionId,he):se.push([he,Pe])}if(ue.size){const he=new Date().getTime(),ve=new f().withFlags(Z&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ue.size).withFilter(t.ExtensionId,...ue.keys()),{extensions:we}=await this.queryGalleryExtensions(ve,q,B);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-he,count:ue.size});for(const Ee of we){const Pe=ue.get(Ee.identifier.uuid);se.push([Pe,Ee])}}return{extensions:se.sort((he,ve)=>he[0]-ve[0]).map(([,he])=>he),total:X}}async toGalleryExtensionWithCriteria(N,q){const B={id:(0,p.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},Z=q.versions?.find(se=>(0,p.areSameExtensions)(se,B))?.version,oe=(0,P.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(se=>(0,p.areSameExtensions)(se,B))?.includePreRelease,X=z(N),ie=j(N.versions,q.targetPlatform);if(q.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(X,q.targetPlatform))return null;for(let se=0;se<ie.length;se++){const ue=ie[se];if(!(Z&&ue.version!==Z)){if(await this.isValidVersion(ue,oe?"any":"release",q.compatible,X,q.targetPlatform))return te(N,ue,X);if(Z&&ue.version===Z)return null}}return Z||q.compatible?null:te(N,N.versions[0],X)}async queryRawGalleryExtensions(N,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,i.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,o(i.Unpublished));const B=await this.commonHeadersPromise,Z=JSON.stringify(N.raw),oe={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},X=new Date().getTime();let ie,se,ue=0;try{if(ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Z,headers:oe},q),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:ue};const he=await(0,m.asJson)(ie);if(he){const ve=he.results[0],we=ve.extensions,Ee=ve.resultMetadata&&ve.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return ue=Ee&&Ee.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ue}}return{galleryExtensions:[],total:ue}}catch(he){throw se=he,he}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-X,success:!!ie&&(0,m.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:se?(0,R.isCancellationError)(se)?"canceled":(0,R.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(N,q,B,Z){if(!this.isEnabled())return;const oe=L.isWeb?this.api(`/itemName/${N}.${q}/version/${B}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${q}/${B}/stats?statType=${Z}`),X=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.commonHeadersPromise,Accept:X};try{await this.requestService.request({type:"POST",url:oe,headers:se},r.CancellationToken.None)}catch{}}async download(N,q,B){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const Z=(0,p.getGalleryExtensionTelemetryData)(N),oe=new Date().getTime(),X=he=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Z,duration:he}),ie=B===2?"install":B===3?"update":"",se=ie?{uri:`${N.assets.download.uri}${E.URI.parse(N.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${N.assets.download.fallbackUri}${E.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:N.assets.download,ue=await this.getAsset(se);await this.fileService.writeFile(q,ue.stream),X(new Date().getTime()-oe)}async getReadme(N,q){if(N.assets.readme){const B=await this.getAsset(N.assets.readme,{},q);return await(0,m.asTextOrError)(B)||""}return""}async getManifest(N,q){if(N.assets.manifest){const B=await this.getAsset(N.assets.manifest,{},q),Z=await(0,m.asTextOrError)(B);return Z?JSON.parse(Z):null}return null}async getManifestFromRawExtensionVersion(N,q){const B=M(N,n.Manifest);if(!B)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},oe=await this.getAsset(B,{headers:Z});return await(0,m.asJson)(oe)}async getCoreTranslation(N,q){const B=N.assets.coreTranslations.filter(Z=>Z[0]===q.toUpperCase())[0];if(B){const Z=await this.getAsset(B[1]),oe=await(0,m.asTextOrError)(Z);return oe?JSON.parse(oe):null}return null}async getChangelog(N,q){if(N.assets.changelog){const B=await this.getAsset(N.assets.changelog,{},q);return await(0,m.asTextOrError)(B)||""}return""}async getAllCompatibleVersions(N,q,B){let Z=new f().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?Z=Z.withFilter(t.ExtensionId,N.identifier.uuid):Z=Z.withFilter(t.ExtensionName,N.identifier.id);const{galleryExtensions:oe}=await this.queryRawGalleryExtensions(Z,r.CancellationToken.None);if(!oe.length)return[];const X=z(oe[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(X,B))return[];const ie=[];await Promise.all(oe[0].versions.map(async he=>{try{await this.isValidVersion(he,q?"any":"release",!0,X,B)&&ie.push(he)}catch{}}));const se=[],ue=new Set;for(const he of j(ie,B))ue.has(he.version)||(ue.add(he.version),se.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:$(he)}));return se}async getAsset(N,q={},B=r.CancellationToken.None){const Z=await this.commonHeadersPromise,oe={type:"GET"},X={...Z,...q.headers||{}};q={...q,...oe,headers:X};const ie=N.uri,se=N.fallbackUri,ue={...q,url:ie};try{const he=await this.requestService.request(ue,B);if(he.res.statusCode===200)return he;const ve=await(0,m.asTextOrError)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${ve}`)}catch(he){if((0,R.isCancellationError)(he))throw he;const ve=(0,R.getErrorMessage)(he);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:ve});const we={...q,url:se};return this.requestService.request(we,B)}}async getEngine(N){let q=F(N);if(!q){const B=await this.getManifestFromRawExtensionVersion(N,r.CancellationToken.None);if(!B)throw new Error("Manifest was not found");q=B.engines.vscode}return q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},r.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,m.asJson)(N),B=[],Z={};if(q){for(const oe of q.malicious)B.push({id:oe});if(q.migrateToPreRelease)for(const[oe,X]of Object.entries(q.migrateToPreRelease))(!X.engine||(0,v.isEngineValid)(X.engine,this.productService.version,this.productService.date))&&(Z[oe.toLowerCase()]={disallowInstall:!0,extension:{id:X.id,displayName:X.displayName,autoMigrate:{storage:!!X.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[oe,X]of Object.entries(q.deprecated))X&&(Z[oe.toLowerCase()]=(0,P.isBoolean)(X)?{}:X)}return{malicious:B,deprecated:Z}}};ce=pe([K(1,m.IRequestService),K(2,S.ILogService),K(3,I.IEnvironmentService),K(4,d.ITelemetryService),K(5,h.IFileService),K(6,C.IProductService),K(7,b.IConfigurationService)],ce);let W=class extends ce{constructor(N,q,B,Z,oe,X,ie,se){super(N,q,B,Z,oe,X,ie,se)}};W=pe([K(0,a.IStorageService),K(1,m.IRequestService),K(2,S.ILogService),K(3,I.IEnvironmentService),K(4,d.ITelemetryService),K(5,h.IFileService),K(6,C.IProductService),K(7,b.IConfigurationService)],W),e.ExtensionGalleryService=W;let V=class extends ce{constructor(N,q,B,Z,oe,X,ie){super(void 0,N,q,B,Z,oe,X,ie)}};V=pe([K(0,m.IRequestService),K(1,S.ILogService),K(2,I.IEnvironmentService),K(3,d.ITelemetryService),K(4,h.IFileService),K(5,C.IProductService),K(6,b.IConfigurationService)],V),e.ExtensionGalleryServiceWithNoStorageService=V}),define(ne[75],re([0,1,5,3,2,21,33,25,19,8,15]),function(Q,e,D,r,R,L,T,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class Qe extends R.Disposable{static toKey(h){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static fromKey(h){const S=w.exec(h);if(S&&S[1])return{id:S[1],version:S[2]}}static async removeOutdatedExtensionVersions(h,S){const C=await h.getInstalled(),m=[];for(const[g,a]of Qe.readAllExtensionsWithKeysForSync(S)){const d=C.find(c=>(0,T.areSameExtensions)(c.identifier,{id:g}))?.manifest.version;for(const c of a)d!==c&&m.push(Qe.toKey({id:g,version:c}))}for(const g of m)S.remove(g,0)}static readAllExtensionsWithKeysForSync(h){const S=new Map,C=h.keys(0,1);for(const m of C){const g=Qe.fromKey(m);if(g){let a=S.get(g.id.toLowerCase());a||S.set(g.id.toLowerCase(),a=[]),a.push(g.version)}}return S}constructor(h,S,C){super(),this.storageService=h,this.productService=S,this.logService=C,this._onDidChangeExtensionStorageToSync=this._register(new r.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Qe.readAllExtensionsWithKeysForSync(h),this._register(this.storageService.onDidChangeValue(m=>this.onDidChangeStorageValue(m)))}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const S=Qe.fromKey(h.key);if(S){if(this.storageService.get(h.key,0)===void 0)this.extensionsWithKeysForSync.delete(S.id.toLowerCase());else{let C=this.extensionsWithKeysForSync.get(S.id.toLowerCase());C||this.extensionsWithKeysForSync.set(S.id.toLowerCase(),C=[]),C.push(S.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(h){if((0,I.isString)(h))return h;const S=h.manifest?h.manifest.publisher:h.publisher,C=h.manifest?h.manifest.name:h.name;return(0,T.getExtensionId)(S,C)}getExtensionState(h,S){const C=this.getExtensionId(h),m=this.storageService.get(C,S?0:1);if(m)try{return JSON.parse(m)}catch(g){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${C}, global: ${S}): ${g}`)}}setExtensionState(h,S,C){const m=this.getExtensionId(h);S===void 0?this.storageService.remove(m,C?0:1):this.storageService.store(m,JSON.stringify(S),C?0:1,1)}setKeysForSync(h,S){this.storageService.store(Qe.toKey(h),JSON.stringify(S),0,1)}getKeysForSync(h){const S=this.productService.extensionSyncedKeys?.[h.id.toLowerCase()],C=this.storageService.get(Qe.toKey(h),0),m=C?JSON.parse(C):void 0;return m&&S?(0,E.distinct)([...m,...S]):m||S}addToMigrationList(h,S){if(h!==S){const C=this.migrationList.filter(m=>!m.includes(h)&&!m.includes(S));C.push([h,S]),this.migrationList=C}}getSourceExtensionToMigrate(h){const S=this.migrationList.find(([,C])=>h===C);return S?S[0]:void 0}get migrationList(){const h=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const S=JSON.parse(h);if(Array.isArray(S))return S}catch{}return[]}set migrationList(h){h.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(h),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};p=pe([K(0,L.IStorageService),K(1,P.IProductService),K(2,b.ILogService)],p),e.ExtensionStorageService=p}),define(ne[252],re([0,1,19,6,3,12,4,36,7,147,14,29,33,211,94,13,8,59,25,45,21,24]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m,g,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const i="extensionTips/promptedExecutableTips",o="extensionTips/lastPromptedMediumImpExeTime";let t=class extends v.ExtensionTipsService{constructor(s,u,l,f,y,A,O,_,M,k){super(O,_,M,k),this.environmentService=s,this.telemetryService=u,this.extensionManagementService=l,this.storageService=f,this.nativeHostService=y,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&Object.entries(_.exeBasedExtensionTips).forEach(([F,$])=>{const x=[],J=[],H=[];Object.entries($.recommendations).forEach(([G,z])=>{z.important?$.important?x.push({extensionId:G,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):J.push({extensionId:G,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):H.push({extensionId:G,extensionName:z.name,isExtensionPack:!!z.isExtensionPack})}),x.length&&this.highImportanceExecutableTips.set(F,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:x}),J.length&&this.mediumImportanceExecutableTips.set(F,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:J}),H.length&&this.allOtherExecutableTips.set(F,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:H})}),(0,r.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),u=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...u]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),u=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(u,l)}groupImportantTipsByExe(s,u){const l=new Map;s.forEach(_=>l.set(_.extensionId.toLowerCase(),_));const{installed:f,uninstalled:y}=this.groupByInstalled([...l.keys()],u);for(const _ of f){const M=l.get(_);M&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:M.exeName})}for(const _ of y){const M=l.get(_);M&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:M.exeName})}const A=this.getPromptedExecutableTips(),O=new Map;for(const _ of y){const M=l.get(_);if(M&&(!A[M.exeName]||!A[M.exeName].includes(M.extensionId))){let k=O.get(M.exeName);k||(k=[],O.set(M.exeName,k)),k.push(M)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,u]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(u).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(u[0].exeName,u);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const f=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(f(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const f=this._register((0,r.disposableTimeout)(()=>{f.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),u=Date.now()-s,l=7*24*60*60*1e3;if(u<l){const A=this._register((0,r.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},l-u));return}const[f,y]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(y).then(A=>{switch(A){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(f),this.addToRecommendedExecutables(y[0].exeName,y);const O=this._register((0,r.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},l));break}case"ignored":this.mediumImportanceTipsByExe.delete(f),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const O=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const O=this._register((0,r.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(s){const u=await this.extensionManagementService.getInstalled(1),l=s.filter(y=>!y.whenNotInstalled||y.whenNotInstalled.every(A=>u.every(O=>!(0,p.areSameExtensions)(O.identifier,{id:A})))).map(({extensionId:y})=>y.toLowerCase()),f=(0,b.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,f,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(o,-1);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(o,s,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(i,-1,"{}"))}addToRecommendedExecutables(s,u){const l=this.getPromptedExecutableTips();l[s]=u.map(({extensionId:f})=>f.toLowerCase()),this.storageService.store(i,JSON.stringify(l),-1,0)}groupByInstalled(s,u){const l=[],f=[],y=u.reduce((A,O)=>(A.add(O.identifier.id.toLowerCase()),A),new Set);return s.forEach(A=>{y.has(A.toLowerCase())?l.push(A):f.push(A)}),{installed:l,uninstalled:f}}async getValidExecutableBasedExtensionTips(s){const u=[],l=new Map;for(const f of s.keys()){const y=s.get(f);if(!y||!(0,D.isNonEmptyArray)(y.recommendations))continue;const A=[];T.isWindows?y.windowsPath&&A.push(y.windowsPath.replace("%USERPROFILE%",P.env.USERPROFILE).replace("%ProgramFiles(x86)%",P.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",P.env.ProgramFiles).replace("%APPDATA%",P.env.APPDATA).replace("%WINDIR%",P.env.WINDIR)):(A.push((0,L.join)("/usr/local/bin",f)),A.push((0,L.join)("/usr/bin",f)),A.push((0,L.join)(this.environmentService.userHome.fsPath,f)));for(const O of A){let _=l.get(O);if(_===void 0&&(_=await this.fileService.exists(E.URI.file(O)),l.set(O,_)),_)for(const{extensionId:M,extensionName:k,isExtensionPack:F,whenNotInstalled:$}of y.recommendations)u.push({extensionId:M,extensionName:k,isExtensionPack:F,exeName:f,exeFriendlyName:y.exeFriendlyName,windowsPath:y.windowsPath,whenNotInstalled:$})}}return u}};t=pe([K(0,I.INativeEnvironmentService),K(1,c.ITelemetryService),K(2,w.IExtensionManagementService),K(3,d.IStorageService),K(4,m.INativeHostService),K(5,h.IExtensionRecommendationNotificationService),K(6,S.IFileService),K(7,g.IProductService),K(8,a.IRequestService),K(9,C.ILogService)],t),e.ExtensionTipsService=t}),define(ne[253],re([0,1,6,2,17,67,21,71,20]),function(Q,e,D,r,R,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends T.AbstractStorageService{constructor(w,p,v,h){super(),this.initialWorkspace=w,this.initialProfiles=p,this.mainProcessService=v,this.environmentService=h,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new r.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new r.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const w=this._register(new P.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),p=this._register(new L.Storage(w));return this._register(p.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v))),p}createProfileStorage(w){this.profileStorageDisposables.clear(),this.profileStorageProfile=w;let p;if((0,T.isProfileUsingDefaultStorage)(w))p=this.applicationStorage;else{const v=this.profileStorageDisposables.add(new P.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),w));p=this.profileStorageDisposables.add(new L.Storage(v))}return this.profileStorageDisposables.add(p.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),p}createWorkspaceStorage(w){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=w?.id;let p;if(w){const v=this.workspaceStorageDisposables.add(new P.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),w));p=this.workspaceStorageDisposables.add(new L.Storage(v)),this.workspaceStorageDisposables.add(p.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)))}return p}async doInitialize(){await D.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(w){switch(w){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(w){switch(w){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,R.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(w,p){if(!this.canSwitchProfile(this.profileStorageProfile,w))return;const v=this.profileStorage,h=v.items;v!==this.applicationStorage&&await v.close(),this.profileStorage=this.createProfileStorage(w),await this.profileStorage.init(),this.switchData(h,this.profileStorage,0,p)}async switchToWorkspace(w,p){const v=this.workspaceStorage,h=v?.items??new Map;await v?.close(),this.workspaceStorage=this.createWorkspaceStorage(w),await this.workspaceStorage.init(),this.switchData(h,this.workspaceStorage,1,p)}hasScope(w){return(0,E.isUserDataProfile)(w)?this.profileStorageProfile.id===w.id:this.workspaceStorageId===w.id}}e.NativeStorageService=b}),define(ne[254],re([0,1,3,2,17,14,58,20]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let E=class extends r.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(I,w,p){super(),this._profiles=[],this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.channel=w.getChannel("userDataProfiles"),this.profilesHome=(0,R.joinPath)(p.userRoamingDataHome,"profiles"),this._profiles=I.map(v=>(0,P.reviveProfile)(v,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(v=>{const h=v.added.map(m=>(0,P.reviveProfile)(m,this.profilesHome.scheme)),S=v.removed.map(m=>(0,P.reviveProfile)(m,this.profilesHome.scheme)),C=v.updated.map(m=>(0,P.reviveProfile)(m,this.profilesHome.scheme));this._profiles=v.all.map(m=>(0,P.reviveProfile)(m,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:h,removed:S,updated:C,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}async createNamedProfile(I,w,p){const v=await this.channel.call("createNamedProfile",[I,w,p]);return(0,P.reviveProfile)(v,this.profilesHome.scheme)}async createProfile(I,w,p,v,h){const S=await this.channel.call("createProfile",[I,w,p,v,h]);return(0,P.reviveProfile)(S,this.profilesHome.scheme)}async createTransientProfile(I){const w=await this.channel.call("createTransientProfile",[I]);return(0,P.reviveProfile)(w,this.profilesHome.scheme)}async setProfileForWorkspace(I,w){await this.channel.call("setProfileForWorkspace",[I,w])}removeProfile(I){return this.channel.call("removeProfile",[I])}async updateProfile(I,w,p,v){const h=await this.channel.call("updateProfile",[I,w,p,v]);return(0,P.reviveProfile)(h,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}};E=pe([K(1,T.IMainProcessService),K(2,L.IEnvironmentService)],E),e.UserDataProfilesNativeService=E}),define(ne[41],re([0,1,19,6,16,23,3,35,2,27,15,7,162,18,14,13,8,48,21,24,31,26,20]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m,g,a,d,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function o(l){return!!(l&&l.version!==void 0&&typeof l.version=="number"&&l.content!==void 0&&typeof l.content=="string"&&(Object.keys(l).length===2||Object.keys(l).length===3&&l.machineId!==void 0&&typeof l.machineId=="string"))}e.isSyncData=o;let t=class extends E.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(f,y,A,O,_,M,k,F,$,x,J,H){super(),this.syncResource=f,this.collection=y,this.fileService=A,this.environmentService=O,this.userDataSyncStoreService=M,this.userDataSyncBackupStoreService=k,this.userDataSyncEnablementService=F,this.telemetryService=$,this.logService=x,this.configurationService=J,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new r.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=`${(0,b.uppercaseFirstLetter)(this.resource)}${f.profile.isDefault?"":` (${f.profile.name})`}`,this.extUri=H.extUri,this.syncFolder=this.extUri.joinPath(O.userDataSyncHome,...(0,c.getPathSegments)(f.profile.isDefault?void 0:f.profile.id,f.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,c.PREVIEW_DIR_NAME),this.lastSyncResource=(0,c.getLastSyncResourceUri)(f.profile.isDefault?void 0:f.profile.id,f.syncResource,O,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(O,A,_)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const f=await this.syncPreviewPromise;this.syncPreviewPromise=null;const y=await this.performSync(f.remoteUserData,f.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(y)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const f=await this.getLastSyncUserData();(f?await this.hasRemoteChanged(f):!0)&&this._onDidChangeLocal.fire()}}setStatus(f){this._status!==f&&(this._status=f,this._onDidChangStatus.fire(f))}async sync(f,y={}){await this._sync(f,!0,this.getUserDataSyncConfiguration(),y)}async preview(f,y,A={}){return this._sync(f,!1,y,A)}async apply(f,y={}){try{this.syncHeaders={...y};const A=await this.doApply(f);return this.setStatus(A),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(f,y,A,O){try{if(this.syncHeaders={...O},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const M=await this.getLastSyncUserData(),k=await this.getLatestRemoteUserData(f,M);return _=await this.performSync(k,M,y,A),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(f){const y=await this.resolveContent(f);if(!y)return!1;const A=this.parseSyncData(y);if(!A)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const O=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,O),M=await this.isRemoteDataFromCurrentMachine(_),k=await this.generateSyncPreview({ref:_.ref,syncData:A},O,M,this.getUserDataSyncConfiguration(),L.CancellationToken.None),F=[];for(const $ of k){const x=await this.getAcceptResult($,$.remoteResource,void 0,L.CancellationToken.None),{remoteChange:J}=await this.getAcceptResult($,$.previewResource,$.remoteContent,L.CancellationToken.None);F.push([$,{...x,remoteChange:J!==0?J:2}])}await this.applyResult(_,O,F,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(f){const y=await this.currentMachineIdPromise;return!!f.syncData?.machineId&&f.syncData.machineId===y}async getLatestRemoteUserData(f,y){if(y){const A=f?f[this.resource]:void 0;if(y.ref===A||A===void 0&&y.syncData===null)return y}return this.getRemoteUserData(y)}async performSync(f,y,A,O){if(f.syncData&&f.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new c.UserDataSyncError((0,p.localize)(0,null,this.resource,this.version,f.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(f,y,A,O)}catch(_){if(_ instanceof c.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(f,y,A,O);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),f=await this.getRemoteUserData(null),y=await this.getLastSyncUserData(),this.performSync(f,y,A,O)}throw _}}async doSync(f,y,A,O){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,r.createCancelablePromise)(M=>this.doGenerateSyncResourcePreview(f,y,A,O,M)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:M})=>M==="conflict")?"hasConflicts":A?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(f){return await this.updateSyncResourcePreview(f,async y=>{const A=await this.getMergeResult(y,L.CancellationToken.None);await this.fileService.writeFile(y.previewResource,R.VSBuffer.fromString(A?.content||""));const O=A&&!A.hasConflicts?await this.getAcceptResult(y,y.previewResource,void 0,L.CancellationToken.None):void 0;return y.acceptResult=O,y.mergeState=A.hasConflicts?"conflict":O?"accepted":"preview",y.localChange=O?O.localChange:A.localChange,y.remoteChange=O?O.remoteChange:A.remoteChange,y}),this.syncPreviewPromise}async accept(f,y){return await this.updateSyncResourcePreview(f,async A=>{const O=await this.getAcceptResult(A,f,y,L.CancellationToken.None);return A.acceptResult=O,A.mergeState="accepted",A.localChange=O.localChange,A.remoteChange=O.remoteChange,A}),this.syncPreviewPromise}async discard(f){return await this.updateSyncResourcePreview(f,async y=>{const A=await this.getMergeResult(y,L.CancellationToken.None);return await this.fileService.writeFile(y.previewResource,R.VSBuffer.fromString(A.content||"")),y.acceptResult=void 0,y.mergeState="preview",y.localChange=A.localChange,y.remoteChange=A.remoteChange,y}),this.syncPreviewPromise}async updateSyncResourcePreview(f,y){if(!this.syncPreviewPromise)return;let A=await this.syncPreviewPromise;const O=A.resourcePreviews.findIndex(({localResource:_,remoteResource:M,previewResource:k})=>this.extUri.isEqual(_,f)||this.extUri.isEqual(M,f)||this.extUri.isEqual(k,f));O!==-1&&(this.syncPreviewPromise=(0,r.createCancelablePromise)(async _=>{const M=[...A.resourcePreviews];return M[O]=await y(M[O]),{...A,resourcePreviews:M}}),A=await this.syncPreviewPromise,this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(f){if(!this.syncPreviewPromise)return"idle";const y=await this.syncPreviewPromise;return y.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":y.resourcePreviews.some(({mergeState:A})=>A!=="accepted")?"syncing":(await this.applyResult(y.remoteUserData,y.lastSyncUserData,y.resourcePreviews.map(A=>[A,A.acceptResult]),f),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(f){const y=f.filter(({mergeState:A})=>A==="conflict");(0,D.equals)(this._conflicts,y,(A,O)=>this.extUri.isEqual(A.previewResource,O.previewResource))||(this._conflicts=y,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const f=await this.getLastSyncUserData();return!!f&&f.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllResourceRefs(this.resource,this.collection)).map(({created:y,ref:A})=>({created:y,uri:this.toRemoteBackupResource(A)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.syncResource.profile,this.resource)).map(({created:y,ref:A})=>({created:y,uri:this.toLocalBackupResource(A)}))}toRemoteBackupResource(f){return w.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.syncResource.profile.isDefault?"":`${this.syncResource.profile.id}/`}${this.resource}/${f}`})}toLocalBackupResource(f){return w.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.syncResource.profile.id}/${this.resource}/${f}`})}async getMachineId({uri:f}){const y=this.extUri.basename(f);if(this.extUri.isEqual(f,this.toRemoteBackupResource(y))){const{content:A}=await this.getUserData(y);if(A)return this.parseSyncData(A)?.machineId}}async resolveContent(f){const y=this.extUri.basename(f);if(this.extUri.isEqual(f,this.toRemoteBackupResource(y))){const{content:A}=await this.getUserData(y);return A}return this.extUri.isEqual(f,this.toLocalBackupResource(y))?this.userDataSyncBackupStoreService.resolveContent(this.syncResource.profile,this.resource,y):null}async resolvePreviewContent(f){const y=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(y)for(const A of y.resourcePreviews){if(this.extUri.isEqual(A.acceptedResource,f))return A.acceptResult?A.acceptResult.content:null;if(this.extUri.isEqual(A.remoteResource,f))return A.remoteContent;if(this.extUri.isEqual(A.localResource,f))return A.localContent;if(this.extUri.isEqual(A.baseResource,f))return A.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(f,y,A,O,_){const M=await this.isRemoteDataFromCurrentMachine(f),k=await this.generateSyncPreview(f,y,M,O,_),F=[];for(const $ of k){const x=$.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"});if($.localChange===0&&$.remoteChange===0)F.push({...$,acceptedResource:x,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const J=A?await this.getMergeResult($,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile($.previewResource,R.VSBuffer.fromString(J?.content||""));const H=J&&!J.hasConflicts?await this.getAcceptResult($,$.previewResource,void 0,_):void 0;F.push({...$,acceptResult:H,mergeState:J?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:J?J.localChange:$.localChange,remoteChange:H?H.remoteChange:J?J.remoteChange:$.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:f,lastSyncUserData:y,resourcePreviews:F,isLastSyncFromCurrentMachine:M}}async getLastSyncUserData(){try{const f=await this.fileService.readFile(this.lastSyncResource),y=JSON.parse(f.value.toString()),A=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=y.version&&A&&y.version!==A,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${y.version} is not compatible with current sync state version ${A}.`),await this.resetLocal(),null;const O=y;if(O.content===null)return{ref:y.ref,syncData:null};const _=JSON.parse(O.content);if(o(_))return{...y,syncData:_,content:void 0}}catch(f){f instanceof S.FileOperationError&&f.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Not synced yet. Last sync resource does not exist.`):this.logService.error(f)}return null}async updateLastSyncUserData(f,y={}){if(y.ref||y.content||y.version)throw new Error("Cannot have core properties as additional");const A=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),O={ref:f.ref,content:f.syncData?JSON.stringify(f.syncData):null,version:A,...y};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(O)))}async getRemoteUserData(f){const{ref:y,content:A}=await this.getUserData(f);let O=null;return A!==null&&(O=this.parseSyncData(A)),{ref:y,syncData:O}}parseSyncData(f){try{const y=JSON.parse(f);if(o(y))return y}catch(y){this.logService.error(y)}throw new c.UserDataSyncError((0,p.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(f){if((0,I.isString)(f)){const y=await this.userDataSyncStoreService.resolveResourceContent(this.resource,f,this.collection);return{ref:f,content:y}}else{const y=f?{ref:f.ref,content:f.syncData?JSON.stringify(f.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,y,this.collection,this.syncHeaders)}}async updateRemoteUserData(f,y){const A=await this.currentMachineIdPromise,O={version:this.version,machineId:A,content:f};try{return y=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(O),y,this.collection,this.syncHeaders),{ref:y,syncData:O}}catch(_){throw _ instanceof c.UserDataSyncError&&_.code==="TooLarge"&&(_=new c.UserDataSyncError(_.message,_.code,this.resource)),_}}async backupLocal(f){const y={version:this.version,content:f};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(y))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=pe([K(2,S.IFileService),K(3,h.IEnvironmentService),K(4,g.IStorageService),K(5,c.IUserDataSyncStoreService),K(6,c.IUserDataSyncBackupStoreService),K(7,c.IUserDataSyncEnablementService),K(8,a.ITelemetryService),K(9,c.IUserDataSyncLogService),K(10,v.IConfigurationService),K(11,d.IUriIdentityService)],t),e.AbstractSynchroniser=t;let n=class extends t{constructor(f,y,A,O,_,M,k,F,$,x,J,H,G){super(y,A,O,_,M,k,F,$,x,J,H,G),this.file=f,this._register(this.fileService.watch(this.extUri.dirname(f))),this._register(this.fileService.onDidFilesChange(z=>this.onFileChanges(z)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(f,y,A){try{y?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(f),A?void 0:y):await this.fileService.createFile(this.file,R.VSBuffer.fromString(f),{overwrite:A})}catch(O){throw O instanceof S.FileOperationError&&O.fileOperationResult===1||O instanceof S.FileOperationError&&O.fileOperationResult===3?new c.UserDataSyncError(O.message,"LocalPreconditionFailed"):O}}onFileChanges(f){!f.contains(this.file)||this.triggerLocalChange()}};n=pe([K(3,S.IFileService),K(4,h.IEnvironmentService),K(5,g.IStorageService),K(6,c.IUserDataSyncStoreService),K(7,c.IUserDataSyncBackupStoreService),K(8,c.IUserDataSyncEnablementService),K(9,a.ITelemetryService),K(10,c.IUserDataSyncLogService),K(11,v.IConfigurationService),K(12,d.IUriIdentityService)],n),e.AbstractFileSynchroniser=n;let s=class extends n{constructor(f,y,A,O,_,M,k,F,$,x,J,H,G,z){super(f,y,A,O,_,M,k,F,$,x,J,G,z),this.userDataSyncUtilService=H,this._formattingOptions=void 0}hasErrors(f,y){const A=[],O=(0,P.parse)(f,A,{allowEmptyContent:!0,allowTrailingComma:!0});return A.length>0||!(0,I.isUndefined)(O)&&y!==Array.isArray(O)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};s=pe([K(3,S.IFileService),K(4,h.IEnvironmentService),K(5,g.IStorageService),K(6,c.IUserDataSyncStoreService),K(7,c.IUserDataSyncBackupStoreService),K(8,c.IUserDataSyncEnablementService),K(9,a.ITelemetryService),K(10,c.IUserDataSyncLogService),K(11,c.IUserDataSyncUtilService),K(12,v.IConfigurationService),K(13,d.IUriIdentityService)],s),e.AbstractJsonFileSynchroniser=s;let u=class{constructor(f,y,A,O,_,M){this.resource=f,this.userDataProfilesService=y,this.environmentService=A,this.logService=O,this.fileService=_,this.extUri=M.extUri,this.lastSyncResource=(0,c.getLastSyncResourceUri)(void 0,this.resource,A,this.extUri)}async initialize({ref:f,content:y}){if(!y){this.logService.info("Remote content does not exist.",this.resource);return}const A=this.parseSyncData(y);if(!!A)try{await this.doInitialize({ref:f,syncData:A})}catch(O){this.logService.error(O)}}parseSyncData(f){try{const y=JSON.parse(f);if(o(y))return y}catch(y){this.logService.error(y)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(f,y={}){const A={ref:f.ref,content:f.syncData?JSON.stringify(f.syncData):null,...y};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(A)))}};u=pe([K(1,i.IUserDataProfilesService),K(2,h.IEnvironmentService),K(3,C.ILogService),K(4,S.IFileService),K(5,d.IUriIdentityService)],u),e.AbstractInitializer=u}),define(ne[255],re([0,1,6,23,9,3,46,27,7,18,14,29,33,75,13,8,21,24,31,20,41,237,110,26]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m,g,a,d,c,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function t(u,l){const f=JSON.parse(u.content);if(u.version===1||u.version===2){const y=(await l.getInstalled(0)).filter(A=>A.isBuiltin);for(const A of f)u.version===1&&(A.enabled===!1&&(A.disabled=!0),delete A.enabled),u.version===2&&y.every(O=>!(0,p.areSameExtensions)(O.identifier,A.identifier))&&(A.installed=!0)}return f}let n=class gt extends d.AbstractSynchroniser{constructor(l,f,y,A,O,_,M,k,F,$,x,J,H,G,z,j,Y){super({syncResource:"extensions",profile:l},f,A,y,O,_,M,G,z,x,H,Y),this.extensionManagementService=k,this.extensionEnablementService=F,this.ignoredExtensionsManagementService=$,this.extensionGalleryService=J,this.extensionStorageService=j,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.profileLocation=l.extensionsResource,this._register(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,te=>te.some(({local:ce})=>!!ce)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,te=>!te.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(l,f){const y=l.syncData?await t(l.syncData,this.extensionManagementService):null,A=f?.skippedExtensions||[],O=f?.syncData?await t(f.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),M=this.getLocalExtensions(_),k=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);y?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:F,remote:$}=(0,c.merge)(M,y,O,A,k),x={local:F,remote:$,content:this.getPreviewContent(M,F.added,F.updated,F.removed),localChange:F.added.length>0||F.removed.length>0||F.updated.length>0?2:0,remoteChange:$!==null?2:0},J=this.stringify(M,!1);return[{skippedExtensions:A,baseResource:this.baseResource,baseContent:O?this.stringify(O,!1):J,localResource:this.localResource,localContent:J,localExtensions:M,remoteResource:this.remoteResource,remoteContent:y?this.stringify(y,!1):null,previewResource:this.previewResource,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(l){const f=l.syncData?await t(l.syncData,this.extensionManagementService):null,y=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),A=this.getLocalExtensions(y),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(y),{remote:_}=(0,c.merge)(A,f,f,l.skippedExtensions||[],O);return _!==null}getPreviewContent(l,f,y,A){const O=[...f,...y],_=new Set,M=k=>{_.add(k.id.toLowerCase()),k.uuid&&_.add(k.uuid)};O.forEach(({identifier:k})=>M(k)),A.forEach(M);for(const k of l)_.has(k.identifier.id.toLowerCase())||k.identifier.uuid&&_.has(k.identifier.uuid)||O.push(k);return this.stringify(O,!1)}async getMergeResult(l,f){return{...l.previewResult,hasConflicts:!1}}async getAcceptResult(l,f,y,A){if(this.extUri.isEqual(f,this.localResource))return this.acceptLocal(l);if(this.extUri.isEqual(f,this.remoteResource))return this.acceptRemote(l);if(this.extUri.isEqual(f,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async acceptLocal(l){const f=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),y=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),A=(0,c.merge)(l.localExtensions,null,null,l.skippedExtensions,y),{local:O,remote:_}=A;return{content:l.localContent,local:O,remote:_,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(l){const f=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),y=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),A=l.remoteContent?JSON.parse(l.remoteContent):null;if(A!==null){const O=(0,c.merge)(l.localExtensions,A,l.localExtensions,[],y),{local:_,remote:M}=O;return{content:l.remoteContent,local:_,remote:M,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(l,f,y,A){let{skippedExtensions:O,localExtensions:_}=y[0][0];const{local:M,remote:k,localChange:F,remoteChange:$}=y[0][1];if(F===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),F!==0&&(await this.backupLocal(JSON.stringify(_)),O=await this.updateLocalExtensions(M.added,M.removed,M.updated,O)),k){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const x=JSON.stringify(k.all);l=await this.updateRemoteUserData(x,A?null:l.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${k.added.length?` Added: ${JSON.stringify(k.added.map(J=>J.identifier.id))}.`:""}${k.updated.length?` Updated: ${JSON.stringify(k.updated.map(J=>J.identifier.id))}.`:""}${k.removed.length?` Removed: ${JSON.stringify(k.removed.map(J=>J.identifier.id))}.`:""}`)}f?.ref!==l.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(l,{skippedExtensions:O}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(x=>x.identifier.id))}.`:""}`))}async getAssociatedResources({uri:l}){return[{resource:this.extUri.joinPath(l,"extensions.json"),comparableResource:gt.EXTENSIONS_DATA_URI}]}async resolveContent(l){if(this.extUri.isEqual(l,gt.EXTENSIONS_DATA_URI)){const y=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(y),O=this.getLocalExtensions(y).filter(_=>!A.some(M=>(0,p.areSameExtensions)({id:M},_.identifier)));return this.stringify(O,!0)}if(this.extUri.isEqual(this.remoteResource,l)||this.extUri.isEqual(this.baseResource,l)||this.extUri.isEqual(this.localResource,l)||this.extUri.isEqual(this.acceptedResource,l)){const y=await this.resolvePreviewContent(l);return y&&this.stringify(JSON.parse(y),!0)}let f=await super.resolveContent(l);if(f)return f;if(f=await super.resolveContent(this.extUri.dirname(l)),f){const y=this.parseSyncData(f);if(y)switch(this.extUri.basename(l)){case"extensions.json":return this.stringify(this.parseExtensions(y),!0)}}return null}stringify(l,f){return l.sort((y,A)=>!y.identifier.uuid&&A.identifier.uuid?-1:y.identifier.uuid&&!A.identifier.uuid?1:(0,P.compare)(y.identifier.id,A.identifier.id)),f?(0,T.toFormattedString)(l,{}):JSON.stringify(l)}async hasLocalData(){try{const l=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if(this.getLocalExtensions(l).some(y=>y.installed||y.disabled))return!0}catch{}return!1}async updateLocalExtensions(l,f,y,A){const O=[],_=[],M=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if(f.length){const F=M.filter(({identifier:$,isBuiltin:x})=>!x&&f.some(J=>(0,p.areSameExtensions)($,J)));await D.Promises.settled(F.map(async $=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,$.identifier.id),await this.extensionManagementService.uninstall($,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,$.identifier.id),O.push($.identifier)}))}(l.length||y.length)&&await D.Promises.settled([...l,...y].map(async F=>{const $=M.find(J=>(0,p.areSameExtensions)(J.identifier,F.identifier));if($&&$.isBuiltin){F.state&&$.manifest.version===F.version&&this.updateExtensionState(F.state,$,$.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,F.identifier))!==!!F.disabled&&(F.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,F.identifier.id),await this.extensionEnablementService.disableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,F.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,F.identifier.id),await this.extensionEnablementService.enableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,F.identifier.id))),O.push(F.identifier);return}const x=(await this.extensionGalleryService.getExtensions([{...F.identifier,preRelease:F.preRelease}],r.CancellationToken.None))[0];if(F.state&&($?$.manifest.version===F.version:!!x)&&this.updateExtensionState(F.state,$||x,$?.manifest.version),x)try{this.extensionEnablementService.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,F.identifier))!==!!F.disabled&&(F.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,F.identifier.id,x.version),await this.extensionEnablementService.disableExtension(x.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,F.identifier.id,x.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,F.identifier.id,x.version),await this.extensionEnablementService.enableExtension(x.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,F.identifier.id,x.version))),(!$||$.preRelease!==F.preRelease)&&(await this.extensionManagementService.canInstall(x)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,F.identifier.id,x.version),await this.extensionManagementService.installFromGallery(x,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:F.preRelease,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,F.identifier.id,x.version),O.push(x.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,x.displayName||x.identifier.id),_.push(F)))}catch(J){_.push(F),J instanceof w.ExtensionManagementError&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatiblePreRelease,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(J.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,x.displayName||x.identifier.id):(this.logService.error(J),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,x.displayName||x.identifier.id))}else _.push(F),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,F.identifier.id)}));const k=[];for(const F of A)O.some($=>(0,p.areSameExtensions)($,F.identifier))||k.push(F);for(const F of _)k.some($=>(0,p.areSameExtensions)($.identifier,F.identifier))||k.push(F);return k}updateExtensionState(l,f,y){const A=this.extensionStorageService.getExtensionState(f,!0)||{},O=y?this.extensionStorageService.getKeysForSync({id:f.identifier.id,version:y}):void 0;O?O.forEach(_=>{A[_]=l[_]}):Object.keys(l).forEach(_=>A[_]=l[_]),this.extensionStorageService.setExtensionState(f,A,!0)}parseExtensions(l){return JSON.parse(l.content)}getLocalExtensions(l){const f=this.extensionEnablementService.getDisabledExtensions();return l.map(y=>{const{identifier:A,isBuiltin:O,manifest:_,preRelease:M}=y,k={identifier:A,preRelease:M,version:_.version};f.some(F=>(0,p.areSameExtensions)(F,A))&&(k.disabled=!0),O||(k.installed=!0);try{const F=this.extensionStorageService.getKeysForSync({id:A.id,version:_.version});if(F){const $=this.extensionStorageService.getExtensionState(y,!0)||{};k.state=Object.keys($).reduce((x,J)=>(F.includes(J)&&(x[J]=$[J]),x),{})}}catch(F){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,R.getErrorMessage)(F))}return k})}};n.EXTENSIONS_DATA_URI=E.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),n=pe([K(2,I.IEnvironmentService),K(3,h.IFileService),K(4,C.IStorageService),K(5,o.IUserDataSyncStoreService),K(6,o.IUserDataSyncBackupStoreService),K(7,w.IExtensionManagementService),K(8,w.IGlobalExtensionEnablementService),K(9,i.IIgnoredExtensionsManagementService),K(10,o.IUserDataSyncLogService),K(11,w.IExtensionGalleryService),K(12,b.IConfigurationService),K(13,o.IUserDataSyncEnablementService),K(14,m.ITelemetryService),K(15,v.IExtensionStorageService),K(16,g.IUriIdentityService)],n),e.ExtensionsSynchroniser=n;let s=class extends d.AbstractInitializer{constructor(l,f,y,A,O,_,M){super("extensions",A,O,_,y,M),this.extensionManagementService=l,this.ignoredExtensionsManagementService=f}async parseExtensions(l){return l.syncData?await t(l.syncData,this.extensionManagementService):null}generatePreview(l,f){const y=[],A=[],O=[];for(const _ of l){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const M=f.find(k=>(0,p.areSameExtensions)(k.identifier,_.identifier));M?(y.push(M),_.disabled&&O.push(_.identifier)):_.installed&&(A.push({..._.identifier,preRelease:!!_.preRelease}),_.disabled&&O.push(_.identifier))}return{installedExtensions:y,newExtensions:A,disabledExtensions:O,remoteExtensions:l}}};s=pe([K(0,w.IExtensionManagementService),K(1,i.IIgnoredExtensionsManagementService),K(2,h.IFileService),K(3,a.IUserDataProfilesService),K(4,I.IEnvironmentService),K(5,S.ILogService),K(6,g.IUriIdentityService)],s),e.AbstractExtensionsInitializer=s}),define(ne[256],re([0,1,19,16,3,35,4,15,163,18,14,13,21,24,31,20,41,238,26]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function a(i,o,t){try{const n=JSON.parse(i);if(!o)return(0,P.isUndefined)(n.all)?null:n.all;switch(T.OS){case 2:return(0,P.isUndefined)(n.mac)?null:n.mac;case 3:return(0,P.isUndefined)(n.linux)?null:n.linux;case 1:return(0,P.isUndefined)(n.windows)?null:n.windows}}catch(n){return t.error(n),null}}e.getKeybindingsContentFromSyncContent=a;let d=class extends C.AbstractJsonFileSynchroniser{constructor(o,t,n,s,u,l,f,y,A,O,_,M,k){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},t,y,A,O,n,s,f,M,u,_,l,k),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(l.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,t,n,s){const u=o.syncData?a(o.syncData.content,s.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&n?o:t;const l=t?this.getKeybindingsContentFromLastSyncUserData(t):null,f=await this.getLocalFileContent(),y=await this.getFormattingOptions();let A=null,O=!1,_=!1,M=!1;if(u){let $=f?f.value.toString():"[]";if($=$||"[]",this.hasErrors($,!0))throw new g.UserDataSyncError((0,E.localize)(0,null),"LocalInvalidContent",this.resource);if(!l||l!==$||l!==u){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const x=await(0,m.merge)($,u,l,y,this.userDataSyncUtilService);x.hasChanges&&(A=x.mergeContent,M=x.hasConflicts,O=M||x.mergeContent!==$,_=M||x.mergeContent!==u)}}else f&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),A=f.value.toString(),_=!0);const k={content:M?l:A,localChange:O?f?2:1:0,remoteChange:_?2:0,hasConflicts:M},F=f?f.value.toString():null;return[{fileContent:f,baseResource:this.baseResource,baseContent:l,localResource:this.localResource,localContent:F,localChange:k.localChange,remoteResource:this.remoteResource,remoteContent:u,remoteChange:k.remoteChange,previewResource:this.previewResource,previewResult:k,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const t=this.getKeybindingsContentFromLastSyncUserData(o);if(t===null)return!0;const n=await this.getLocalFileContent(),s=n?n.value.toString():"",u=await this.getFormattingOptions(),l=await(0,m.merge)(s||"[]",t,t,u,this.userDataSyncUtilService);return l.hasConflicts||l.mergeContent!==t}async getMergeResult(o,t){return o.previewResult}async getAcceptResult(o,t,n,s){if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return n===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,n,s){const{fileContent:u}=n[0][0];let{content:l,localChange:f,remoteChange:y}=n[0][1];if(f===0&&y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.hasErrors(l,!0)))throw new g.UserDataSyncError((0,E.localize)(1,null),"LocalInvalidContent",this.resource);if(f!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),u&&await this.backupLocal(this.toSyncContent(u.value.toString())),await this.updateLocalFileContent(l||"[]",u,s),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),y!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const A=this.toSyncContent(l||"[]",o.syncData?.content);o=await this.updateRemoteUserData(A,s?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=(0,L.parse)(o.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:o}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(o,"keybindings.json"),comparableResource:t}]}async resolveContent(o){if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o))return this.resolvePreviewContent(o);let t=await super.resolveContent(o);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(o)),t){const n=this.parseSyncData(t);if(n)switch(this.extUri.basename(o)){case"keybindings.json":return a(n.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:a(o.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(o,t){let n={};try{n=JSON.parse(t||"{}")}catch(s){this.logService.error(s)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=o,T.OS){case 2:n.mac=o;break;case 3:n.linux=o;break;case 1:n.windows=o;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};d=pe([K(2,g.IUserDataSyncStoreService),K(3,g.IUserDataSyncBackupStoreService),K(4,g.IUserDataSyncLogService),K(5,b.IConfigurationService),K(6,g.IUserDataSyncEnablementService),K(7,w.IFileService),K(8,I.IEnvironmentService),K(9,p.IStorageService),K(10,g.IUserDataSyncUtilService),K(11,v.ITelemetryService),K(12,h.IUriIdentityService)],d),e.KeybindingsSynchroniser=d;let c=class extends C.AbstractInitializer{constructor(o,t,n,s,u){super("keybindings",t,n,s,o,u)}async doInitialize(o){const t=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,r.VSBuffer.fromString(t)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,L.parse)(o.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return a(o,!0,this.logService)}catch(t){return this.logService.error(t),null}}};c=pe([K(0,w.IFileService),K(1,S.IUserDataProfilesService),K(2,I.IEnvironmentService),K(3,g.IUserDataSyncLogService),K(4,h.IUriIdentityService)],c),e.KeybindingsInitializer=c}),define(ne[257],re([0,1,16,3,164,18,70,14,29,13,21,24,31,20,41,61,242,26]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function a(i){const o=JSON.parse(i);return g(o)?o:{settings:i}}e.parseSettingsSyncContent=a;let d=class extends h.AbstractJsonFileSynchroniser{constructor(o,t,n,s,u,l,f,y,A,O,_,M,k,F){super(o.settingsResource,{syncResource:"settings",profile:o},t,n,s,u,l,f,_,M,y,A,O,F),this.extensionManagementService=k,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(o){const t=await this.getLastSyncUserData(),n=await this.getLatestRemoteUserData(o,t),s=this.getSettingsSyncContent(n),u=new T.ConfigurationModelParser(m.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&u.parse(s.settings),u.configurationModel.getValue(m.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(o,t,n){const s=await this.getLocalFileContent(),u=await this.getFormattingOptions(),l=this.getSettingsSyncContent(o);t=t===null&&n?o:t;const f=t?this.getSettingsSyncContent(t):null,y=await this.getIgnoredSettings();let A=null,O=!1,_=!1,M=!1;if(l){let x=s?s.value.toString().trim():"{}";x=x||"{}",this.validateContent(x),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const J=(0,C.merge)(x,l.settings,f?f.settings:null,y,[],u);A=J.localContent||J.remoteContent,O=J.localContent!==null,_=J.remoteContent!==null,M=J.hasConflicts}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),A=s.value.toString().trim()||"{}",this.validateContent(A),_=!0);const k=s?s.value.toString():null,F=f?.settings??null,$={content:M?F:A,localChange:O?2:0,remoteChange:_?2:0,hasConflicts:M};return[{fileContent:s,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:k,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const t=this.getSettingsSyncContent(o);if(t===null)return!0;const n=await this.getLocalFileContent(),s=n?n.value.toString().trim():"",u=await this.getIgnoredSettings(),l=await this.getFormattingOptions();return(0,C.merge)(s||"{}",t.settings,t.settings,u,[],l).remoteContent!==null}async getMergeResult(o,t){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...o.previewResult,content:o.previewResult.content?(0,C.updateIgnoredSettings)(o.previewResult.content,"{}",s,n):null}}async getAcceptResult(o,t,n,s){const u=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?(0,C.updateIgnoredSettings)(o.fileContent.value.toString(),"{}",l,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent!==null?(0,C.updateIgnoredSettings)(o.remoteContent,o.fileContent?o.fileContent.value.toString():"{}",l,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return n===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:n!==null?(0,C.updateIgnoredSettings)(n,o.fileContent?o.fileContent.value.toString():"{}",l,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,n,s){const{fileContent:u}=n[0][0];let{content:l,localChange:f,remoteChange:y}=n[0][1];if(f===0&&y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),f!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(l,u,s),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),y!==0){const A=await this.getFormattingOptions(),O=this.getSettingsSyncContent(o),_=await this.getIgnoredSettings(l);l=(0,C.updateIgnoredSettings)(l,O?O.settings:"{}",_,A),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),o=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),s?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(o),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=await this.getFormattingOptions(),n=(0,S.edit)(o.value.toString(),[m.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,C.isEmpty)(n)}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:o}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(o,"settings.json"),comparableResource:t}]}async resolveContent(o){if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)||this.extUri.isEqual(this.baseResource,o))return this.resolvePreviewContent(o);let t=await super.resolveContent(o);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(o)),t){const n=this.parseSyncData(t);if(n){const s=this.parseSettingsSyncContent(n.content);if(s)switch(this.extUri.basename(o)){case"settings.json":return s.settings}}}return null}async resolvePreviewContent(o){let t=await super.resolvePreviewContent(o);if(t){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();t=(0,C.updateIgnoredSettings)(t,"{}",s,n)}return t}getSettingsSyncContent(o){return o.syncData?this.parseSettingsSyncContent(o.syncData.content):null}parseSettingsSyncContent(o){try{return a(o)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(o){return{settings:o}}async getIgnoredSettings(o){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=r.Event.any(r.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:u})=>!!u)),r.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,C.getIgnoredSettings)(t,this.configurationService,o)}validateContent(o){if(this.hasErrors(o,!1))throw new m.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource)}};d=pe([K(2,b.IFileService),K(3,P.IEnvironmentService),K(4,I.IStorageService),K(5,m.IUserDataSyncStoreService),K(6,m.IUserDataSyncBackupStoreService),K(7,m.IUserDataSyncLogService),K(8,m.IUserDataSyncUtilService),K(9,L.IConfigurationService),K(10,m.IUserDataSyncEnablementService),K(11,w.ITelemetryService),K(12,E.IExtensionManagementService),K(13,p.IUriIdentityService)],d),e.SettingsSynchroniser=d;let c=class extends h.AbstractInitializer{constructor(o,t,n,s,u){super("settings",t,n,s,o,u)}async doInitialize(o){const t=o.syncData?this.parseSettingsSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,D.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,C.isEmpty)(o.value.toString().trim())}catch(o){return o.fileOperationResult===1}}parseSettingsSyncContent(o){try{return a(o)}catch(t){this.logService.error(t)}return null}};c=pe([K(0,b.IFileService),K(1,v.IUserDataProfilesService),K(2,P.IEnvironmentService),K(3,m.IUserDataSyncLogService),K(4,p.IUriIdentityService)],c),e.SettingsInitializer=c}),define(ne[258],re([0,1,16,3,32,18,14,13,21,24,31,20,41,239,26]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let S=class extends p.AbstractSynchroniser{constructor(g,a,d,c,i,o,t,n,s,u,l,f){super({syncResource:"snippets",profile:g},a,c,d,i,o,t,u,l,n,s,f),this.version=1,this.snippetsFolder=g.snippetsHome,this._register(this.fileService.watch(d.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(r.Event.filter(this.fileService.onDidFilesChange,y=>y.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,a,d){const c=await this.getSnippetsFileContents(),i=this.toSnippetsContents(c),o=g.syncData?this.parseSnippets(g.syncData):null;a=a===null&&d?g:a;const t=a&&a.syncData?this.parseSnippets(a.syncData):null;o?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,v.merge)(i,o,t);return this.getResourcePreviews(n,c,o||{},t||{})}async hasRemoteChanged(g){const a=g.syncData?this.parseSnippets(g.syncData):null;if(a===null)return!0;const d=await this.getSnippetsFileContents(),c=this.toSnippetsContents(d),i=(0,v.merge)(c,a,a);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async getMergeResult(g,a){return g.previewResult}async getAcceptResult(g,a,d,c){if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder))return d===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:d,localChange:d===null?g.fileContent!==null?3:0:2,remoteChange:d===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(g,a,d,c){const i=d.map(([o,t])=>({...o,acceptResult:t}));i.every(({localChange:o,remoteChange:t})=>o===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),i.some(({localChange:o})=>o!==0)&&(await this.updateLocalBackup(i),await this.updateLocalSnippets(i,c)),i.some(({remoteChange:o})=>o!==0)&&(g=await this.updateRemoteSnippets(i,g,c)),a?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:o}of i)try{await this.fileService.del(o)}catch{}}getResourcePreviews(g,a,d,c){const i=new Map;for(const o of Object.keys(g.local.added)){const t={content:g.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};i.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(g.local.updated)){const t={content:g.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0},n=a[o]?a[o].value.toString():null;i.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[o],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of g.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0},n=a[o]?a[o].value.toString():null;i.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[o],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(g.remote.added)){const t={content:g.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1},n=a[o]?a[o].value.toString():null;i.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[o],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(g.remote.updated)){const t={content:g.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2},n=a[o]?a[o].value.toString():null;i.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[o],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of g.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};i.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of g.conflicts){const t={content:c[o]??null,hasConflicts:!0,localChange:a[o]?2:1,remoteChange:d[o]?2:1},n=a[o]?a[o].value.toString():null;i.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[o]||null,localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(a))if(!i.has(o)){const t={content:a[o]?a[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},n=a[o]?a[o].value.toString():null;i.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[o]||null,localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...i.values()]}async getAssociatedResources({uri:g}){const a=await super.resolveContent(g);if(a){const d=this.parseSyncData(a);if(d){const c=this.parseSnippets(d),i=[];for(const o of Object.keys(c)){const t=this.extUri.joinPath(g,o),n=this.extUri.joinPath(this.snippetsFolder,o),s=await this.fileService.exists(n);i.push({resource:t,comparableResource:s?n:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})})}return i}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let a=await super.resolveContent(g);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(g)),a){const d=this.parseSyncData(a);if(d)return this.parseSnippets(d)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const a={};for(const d of g)d.fileContent&&(a[this.extUri.basename(d.localResource)]=d.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(a)))}async updateLocalSnippets(g,a){for(const{fileContent:d,acceptResult:c,localResource:i,remoteResource:o,localChange:t}of g)if(t!==0){const n=o?this.extUri.basename(o):this.extUri.basename(i),s=this.extUri.joinPath(this.snippetsFolder,n);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(s)),await this.fileService.del(s),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(s))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(s)),await this.fileService.createFile(s,D.VSBuffer.fromString(c.content),{overwrite:a}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(s))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(s)),await this.fileService.writeFile(s,D.VSBuffer.fromString(c.content),a?void 0:d),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(s)))}}async updateRemoteSnippets(g,a,d){const c=a.syncData?this.parseSnippets(a.syncData):{},i=(0,R.deepClone)(c);for(const{acceptResult:o,localResource:t,remoteResource:n,remoteChange:s}of g)if(s!==0){const u=t?this.extUri.basename(t):this.extUri.basename(n);s===3?delete i[u]:i[u]=o.content}return(0,v.areSame)(c,i)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),a=await this.updateRemoteUserData(JSON.stringify(i),d?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),a}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const a={};for(const d of Object.keys(g))a[d]=g[d].value.toString();return a}async getSnippetsFileContents(){const g={};let a;try{a=await this.fileService.resolve(this.snippetsFolder)}catch(d){if(d instanceof P.FileOperationError&&d.fileOperationResult===1)return g;throw d}for(const d of a.children||[]){const c=d.resource,i=this.extUri.extname(c);if(i===".json"||i===".code-snippets"){const o=this.extUri.relativePath(this.snippetsFolder,c),t=await this.fileService.readFile(c);g[o]=t}}return g}};S=pe([K(2,T.IEnvironmentService),K(3,P.IFileService),K(4,E.IStorageService),K(5,h.IUserDataSyncStoreService),K(6,h.IUserDataSyncBackupStoreService),K(7,h.IUserDataSyncLogService),K(8,L.IConfigurationService),K(9,h.IUserDataSyncEnablementService),K(10,b.ITelemetryService),K(11,I.IUriIdentityService)],S),e.SnippetsSynchroniser=S;let C=class extends p.AbstractInitializer{constructor(g,a,d,c,i){super("snippets",a,d,c,g,i)}async doInitialize(g){const a=g.syncData?JSON.parse(g.syncData.content):null;if(!a){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const c of Object.keys(a)){const i=a[c];if(i){const o=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,c);await this.fileService.createFile(o,D.VSBuffer.fromString(i)),this.logService.info("Created snippet",this.extUri.basename(o))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};C=pe([K(0,P.IFileService),K(1,w.IUserDataProfilesService),K(2,T.IEnvironmentService),K(3,h.IUserDataSyncLogService),K(4,I.IUriIdentityService)],C),e.SnippetsInitializer=C}),define(ne[259],re([0,1,16,18,14,13,21,24,31,20,41,26]),function(Q,e,D,r,R,L,T,P,E,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function p(C,m){try{return JSON.parse(C).tasks}catch(g){return m.error(g),null}}e.getTasksContentFromSyncContent=p;let v=class extends I.AbstractFileSynchroniser{constructor(m,g,a,d,c,i,o,t,n,s,u,l){super(m.tasksResource,{syncResource:"tasks",profile:m},g,t,n,s,a,d,o,u,c,i,l),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(m,g,a,d){const c=m.syncData?p(m.syncData.content,this.logService):null;g=g===null&&a?m:g;const i=g?.syncData?p(g.syncData.content,this.logService):null,o=await this.getLocalFileContent();let t=null,n=!1,s=!1,u=!1;if(c){const y=o?o.value.toString():null;if(!i||i!==y||i!==c){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const A=S(y,c,i);t=A.content,u=A.hasConflicts,n=A.hasLocalChanged,s=A.hasRemoteChanged}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=o.value.toString(),s=!0);const l={content:u?i:t,localChange:n?o?2:1:0,remoteChange:s?2:0,hasConflicts:u},f=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:i,localResource:this.localResource,localContent:f,localChange:l.localChange,remoteResource:this.remoteResource,remoteContent:c,remoteChange:l.remoteChange,previewResource:this.previewResource,previewResult:l,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(m){const g=m?.syncData?p(m.syncData.content,this.logService):null;if(g===null)return!0;const a=await this.getLocalFileContent(),d=a?a.value.toString():null,c=S(d,g,g);return c.hasLocalChanged||c.hasRemoteChanged}async getMergeResult(m,g){return m.previewResult}async getAcceptResult(m,g,a,d){if(this.extUri.isEqual(g,this.localResource))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(g,this.remoteResource))return{content:m.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(g,this.previewResource))return a===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:a,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(m,g,a,d){const{fileContent:c}=a[0][0],{content:i,localChange:o,remoteChange:t}=a[0][1];if(o===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),c&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(c.value.toString()))),await this.updateLocalFileContent(i||"{}",c,d),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const n=JSON.stringify(this.toTasksSyncContent(i||"{}"));m=await this.updateRemoteUserData(n,d?null:m.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}g?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:m}){const g=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(m,"tasks.json"),comparableResource:g}]}async resolveContent(m){if(this.extUri.isEqual(this.remoteResource,m)||this.extUri.isEqual(this.baseResource,m)||this.extUri.isEqual(this.localResource,m)||this.extUri.isEqual(this.acceptedResource,m))return this.resolvePreviewContent(m);let g=await super.resolveContent(m);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(m)),g){const a=this.parseSyncData(g);if(a)switch(this.extUri.basename(m)){case"tasks.json":return p(a.content,this.logService)}}return null}toTasksSyncContent(m){return{tasks:m}}};v=pe([K(2,w.IUserDataSyncStoreService),K(3,w.IUserDataSyncBackupStoreService),K(4,w.IUserDataSyncLogService),K(5,r.IConfigurationService),K(6,w.IUserDataSyncEnablementService),K(7,L.IFileService),K(8,R.IEnvironmentService),K(9,T.IStorageService),K(10,P.ITelemetryService),K(11,E.IUriIdentityService)],v),e.TasksSynchroniser=v;let h=class extends I.AbstractInitializer{constructor(m,g,a,d,c){super("tasks",g,a,d,m,c),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(m){const g=m.syncData?p(m.syncData.content,this.logService):null;if(!g){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,D.VSBuffer.fromString(g)),await this.updateLastSyncUserData(m)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};h=pe([K(0,L.IFileService),K(1,b.IUserDataProfilesService),K(2,R.IEnvironmentService),K(3,w.IUserDataSyncLogService),K(4,E.IUriIdentityService)],h),e.TasksInitializer=h;function S(C,m,g){if(C===null&&m===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(C===m)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const a=g!==C,d=g!==m;return!a&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:a&&!d?{content:C,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!a?{content:m,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:C,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ne[260],re([0,1,46,7,18,14,13,21,24,31,20,41,240,26]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesManifestSynchroniser=void 0;let h=class mt extends w.AbstractSynchroniser{constructor(m,g,a,d,c,i,o,t,n,s,u,l,f){super({syncResource:"profiles",profile:m},g,d,c,i,o,t,u,l,n,s,f),this.userDataProfilesService=a,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const m=await this.getLastSyncUserData();return m?.syncData?S(m.syncData):null}async getRemoteSyncedProfiles(m){const g=await this.getLastSyncUserData(),a=await this.getLatestRemoteUserData(m,g);return a?.syncData?S(a.syncData):null}async generateSyncPreview(m,g,a){const d=m.syncData?S(m.syncData):null,c=g?.syncData?S(g.syncData):null,i=this.getLocalUserDataProfiles(),{local:o,remote:t}=(0,p.merge)(i,d,c,[]),n={local:o,remote:t,content:c?this.stringifyRemoteProfiles(c):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:t!==null?2:0},s=this.stringifyLocalProfiles(i,!1);return[{baseResource:this.baseResource,baseContent:c?this.stringifyRemoteProfiles(c):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:d?this.stringifyRemoteProfiles(d):null,remoteProfiles:d,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(m){const g=m?.syncData?S(m.syncData):null,a=this.getLocalUserDataProfiles(),{remote:d}=(0,p.merge)(a,g,g,[]);return!!d?.added.length||!!d?.removed.length||!!d?.updated.length}async getMergeResult(m,g){return{...m.previewResult,hasConflicts:!1}}async getAcceptResult(m,g,a,d){if(this.extUri.isEqual(g,this.localResource))return this.acceptLocal(m);if(this.extUri.isEqual(g,this.remoteResource))return this.acceptRemote(m);if(this.extUri.isEqual(g,this.previewResource))return m.previewResult;throw new Error(`Invalid Resource: ${g.toString()}`)}async acceptLocal(m){const g=this.getLocalUserDataProfiles(),a=(0,p.merge)(g,null,null,[]),{local:d,remote:c}=a;return{content:m.localContent,local:d,remote:c,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:c!==null?2:0}}async acceptRemote(m){const g=m.remoteContent?JSON.parse(m.remoteContent):null,a=[],d=[];for(const c of this.getLocalUserDataProfiles()){const i=g?.find(o=>o.id===c.id);i&&(a.push({id:c.id,name:c.name,collection:i.collection}),d.push(c))}if(g!==null){const c=(0,p.merge)(d,g,a,[]),{local:i,remote:o}=c;return{content:m.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:m.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(m,g,a,d){const{local:c,remote:i,localChange:o,remoteChange:t}=a[0][1];if(o===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`),o!==0){await this.backupLocal(this.stringifyLocalProfiles(this.getLocalUserDataProfiles(),!1));const n=[];for(const s of c.added)n.push(this.userDataProfilesService.createProfile(s.id,s.name));for(const s of c.removed)n.push(this.userDataProfilesService.removeProfile(s));for(const s of c.updated){const u=this.userDataProfilesService.profiles.find(l=>l.id===s.id);u?n.push(this.userDataProfilesService.updateProfile(u,s.name)):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${s.id}' to update.`)}await Promise.all(n)}if(t!==0){const n=a[0][0].remoteProfiles||[];this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);for(const s of i?.added||[]){const u=await this.userDataSyncStoreService.createCollection(this.syncHeaders);n.push({id:s.id,name:s.name,collection:u})}for(const s of i?.removed||[])n.splice(n.findIndex(({id:u})=>s.id===u),1);for(const s of i?.updated||[]){const u=n.find(({id:l})=>s.id===l);u&&n.splice(n.indexOf(u),1,{id:s.id,name:s.name,collection:u.collection})}m=await this.updateRemoteUserData(this.stringifyRemoteProfiles(n),d?null:m.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${i?.added.length?` Added: ${JSON.stringify(i.added.map(s=>s.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(s=>s.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(s=>s.name))}.`:""}`);for(const s of i?.removed||[])await this.userDataSyncStoreService.deleteCollection(s.collection,this.syncHeaders)}g?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async getAssociatedResources({uri:m}){return[{resource:this.extUri.joinPath(m,"profiles.json"),comparableResource:mt.PROFILES_DATA_URI}]}async resolveContent(m){if(this.extUri.isEqual(m,mt.PROFILES_DATA_URI))return this.stringifyLocalProfiles(this.getLocalUserDataProfiles(),!0);if(this.extUri.isEqual(this.remoteResource,m)||this.extUri.isEqual(this.baseResource,m)||this.extUri.isEqual(this.localResource,m)||this.extUri.isEqual(this.acceptedResource,m)){const a=await this.resolvePreviewContent(m);return a&&(0,D.toFormattedString)(JSON.parse(a),{})}let g=await super.resolveContent(m);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(m)),g){const a=this.parseSyncData(g);if(a)switch(this.extUri.basename(m)){case"profiles.json":return(0,D.toFormattedString)(S(a),{})}}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(m=>!m.isDefault&&!m.isTransient)}stringifyRemoteProfiles(m){return JSON.stringify([...m].sort((g,a)=>g.name.localeCompare(a.name)))}stringifyLocalProfiles(m,g){const a=[...m].sort((d,c)=>d.name.localeCompare(c.name)).map(d=>({id:d.id,name:d.name}));return g?(0,D.toFormattedString)(a,{}):JSON.stringify(a)}};h.PROFILES_DATA_URI=r.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"profiles",path:"/profiles.json"}),h=pe([K(2,I.IUserDataProfilesService),K(3,T.IFileService),K(4,L.IEnvironmentService),K(5,P.IStorageService),K(6,v.IUserDataSyncStoreService),K(7,v.IUserDataSyncBackupStoreService),K(8,v.IUserDataSyncLogService),K(9,R.IConfigurationService),K(10,v.IUserDataSyncEnablementService),K(11,E.ITelemetryService),K(12,b.IUriIdentityService)],h),e.UserDataProfilesManifestSynchroniser=h;function S(C){return JSON.parse(C.content)}}),define(ne[261],re([0,1,6,16,63,2,17,18,14,13,20,26]),function(Q,e,D,r,R,L,T,P,E,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let p=class extends L.Disposable{constructor(h,S,C,m,g){super(),this.environmentService=h,this.fileService=S,this.configurationService=C,this.logService=m,this.userDataProfilesService=g;for(const a of this.userDataProfilesService.profiles)for(const d of w.ALL_SYNC_RESOURCES)this.cleanUpBackup(this.getResourceBackupHome(a,d))}async getAllRefs(h,S){const C=this.getResourceBackupHome(h,S),m=await this.fileService.resolve(C);return m.children?m.children.filter(a=>a.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(a.name)).sort().reverse().map(a=>({ref:a.name,created:this.getCreationTime(a)})):[]}async resolveContent(h,S,C){if(!C){const m=await this.getAllRefs(h,S);m.length&&(C=m[m.length-1].ref)}if(C){const m=(0,T.joinPath)(this.environmentService.userDataSyncHome,S,C);return(await this.fileService.readFile(m)).value.toString()}return null}async backup(h,S,C){const m=this.getResourceBackupHome(h,S),g=(0,T.joinPath)(m,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(g,r.VSBuffer.fromString(C))}catch(a){this.logService.error(a)}try{this.cleanUpBackup(m)}catch{}}getResourceBackupHome(h,S){return(0,T.joinPath)(this.environmentService.userDataSyncHome,...h.isDefault?[S]:[h.id,S])}async cleanUpBackup(h){try{try{if(!await this.fileService.exists(h))return}catch{return}const S=await this.fileService.resolve(h);if(S.children){const C=S.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let g=C.filter(d=>Date.now()-this.getCreationTime(d)>m);const a=C.length-g.length;a<10&&(g=g.slice(10-a)),await D.Promises.settled(g.map(async d=>{this.logService.info("Deleting from backup",d.resource.path),await this.fileService.del(d.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(h){return h.ctime||new Date(parseInt(h.name.substring(0,4)),parseInt(h.name.substring(4,6))-1,parseInt(h.name.substring(6,8)),parseInt(h.name.substring(9,11)),parseInt(h.name.substring(11,13)),parseInt(h.name.substring(13,15))).getTime()}};p=pe([K(0,E.IEnvironmentService),K(1,b.IFileService),K(2,P.IConfigurationService),K(3,w.IUserDataSyncLogService),K(4,I.IUserDataProfilesService)],p),e.UserDataSyncBackupStoreService=p}),define(ne[262],re([0,1,3,2,4,14,21,24,26]),function(Q,e,D,r,R,L,T,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const b="sync.enable";let I=class extends r.Disposable{constructor(p,v,h,S){super(),this.storageService=p,this.telemetryService=v,this.environmentService=h,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(p.onDidChangeValue(C=>this.onDidStorageChange(C)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(b,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(p){p&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(b,{enabled:p}),this.storageService.store(b,p,-1,1))}isResourceEnabled(p){return this.storageService.getBoolean((0,E.getEnablementKey)(p),-1,!0)}setResourceEnablement(p,v){if(this.isResourceEnabled(p)!==v){const h=(0,E.getEnablementKey)(p);this.storeResourceEnablement(h,v)}}getResourceSyncStateVersion(p){}storeResourceEnablement(p,v){this.storageService.store(p,v,-1,R.isWeb?0:1)}onDidStorageChange(p){if(p.scope!==-1)return;if(b===p.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const v=E.ALL_SYNC_RESOURCES.filter(h=>(0,E.getEnablementKey)(h)===p.key)[0];if(v){this._onDidChangeResourceEnablement.fire([v,this.isResourceEnabled(v)]);return}}};I=pe([K(0,T.IStorageService),K(1,P.ITelemetryService),K(2,L.IEnvironmentService),K(3,E.IUserDataSyncStoreManagementService)],I),e.UserDataSyncEnablementService=I}),define(ne[76],re([0,1,3,2,4,27,167,14,13,5,25,48,21,26]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName",S="Safari",C="Chrome",m="Edge",g="Firefox",a="Android";function d(o){switch(o){case S:case C:case m:case g:case a:case(0,R.PlatformToString)(0):return!0}return!1}e.isWebPlatform=d;function c(){return R.isSafari?S:R.isChrome?C:R.isEdge?m:R.isFirefox?g:R.isAndroid?a:(0,R.PlatformToString)(R.isWeb?0:R.platform)}let i=class nt extends r.Disposable{constructor(t,n,s,u,l,f){super(),this.storageService=s,this.userDataSyncStoreService=u,this.logService=l,this.productService=f,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,w.getServiceMachineId)(t,n,s)}async getMachines(t){const n=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(u=>({...u,isCurrent:u.id===n}))}async addCurrentMachine(t){const n=await this.currentMachineIdPromise,s=await this.readMachinesData(t);s.machines.some(({id:u})=>u===n)||(s.machines.push({id:n,name:this.computeCurrentMachineName(s.machines),platform:c()}),await this.writeMachinesData(s))}async removeCurrentMachine(t){const n=await this.currentMachineIdPromise,s=await this.readMachinesData(t),u=s.machines.filter(({id:l})=>l!==n);u.length!==s.machines.length&&(s.machines=u,await this.writeMachinesData(s))}async renameMachine(t,n,s){const u=await this.readMachinesData(s),l=u.machines.find(({id:f})=>f===t);if(l){l.name=n,await this.writeMachinesData(u);const f=await this.currentMachineIdPromise;t===f&&this.storageService.store(h,n,-1,1)}}async setEnablements(t){const n=await this.readMachinesData();for(const[s,u]of t){const l=n.machines.find(f=>f.id===s);l&&(l.disabled=u?void 0:!0)}await this.writeMachinesData(n)}computeCurrentMachineName(t){const n=this.storageService.get(h,-1);if(n)return n;const s=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${c()} (${this.productService.nameShort})`,u=new RegExp(`${(0,L.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let l=0;for(const f of t){const y=u.exec(f.name),A=y?parseInt(y[1]):0;l=A>l?A:l}return`${s} #${l+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const n=this.parse(this.userData);if(n.version!==nt.VERSION)throw new Error((0,T.localize)(0,null,this.productService.nameLong));return n}async writeMachinesData(t){const n=JSON.stringify(t),s=await this.userDataSyncStoreService.writeResource(nt.RESOURCE,n,this.userData?.ref||null);this.userData={ref:s,content:n},this._onDidChange.fire()}async readUserData(t){if(this.userData){const n=t&&t.latest?t.latest[nt.RESOURCE]:void 0;if(this.userData.ref===n)return this.userData;if(n===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(nt.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(n){this.logService.error(n)}return{version:nt.VERSION,machines:[]}}};i.VERSION=1,i.RESOURCE="machines",i=pe([K(0,P.IEnvironmentService),K(1,E.IFileService),K(2,p.IStorageService),K(3,v.IUserDataSyncStoreService),K(4,v.IUserDataSyncLogService),K(5,I.IProductService)],i),e.UserDataSyncMachinesService=i}),define(ne[263],re([0,1,6,63,38,9,3,2,4,17,7,165,25,21,24,26,73,76]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const g="sync.disableMachineEventually",a="sync.sessionId",d="sync.storeUrl",c="sync.productQuality";let i=class extends P.Disposable{get syncUrl(){const n=this.storageService.get(d,-1);return n?I.URI.parse(n):void 0}set syncUrl(n){n?this.storageService.store(d,n.toString(),-1,1):this.storageService.remove(d,-1)}get productQuality(){return this.storageService.get(c,-1)}set productQuality(n){n?this.storageService.store(c,n,-1,1):this.storageService.remove(c,-1)}constructor(n,s,u,l,f,y,A,O,_,M){super(),this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=u,this.userDataSyncEnablementService=l,this.userDataSyncService=f,this.logService=y,this.userDataSyncAccountService=A,this.telemetryService=O,this.userDataSyncMachinesService=_,this.storageService=M,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=n.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(A.onDidChangeAccount(()=>this.updateAutoSync())),this._register(u.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(f.onDidChangeLocal(k=>this.triggerSync([k],!1,!1))),this._register(T.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,k])=>k)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:n,message:s}=this.isAutoSyncEnabled();n?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(u=>this.onDidFinishSync(u))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,r.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(n,s,u){try{this.userDataSyncAccountService.account&&!u&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,-1),n?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(l){if(s)this.logService.error(l),this.updateEnablement(!1);else throw l}}updateEnablement(n){this.userDataSyncEnablementService.isEnabled()!==n&&(this.userDataSyncEnablementService.setEnablement(n),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(n){if(!n){this.successiveFailures=0;return}const s=S.UserDataSyncError.toUserDataSyncError(n);s instanceof S.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?E.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(g,!0,-1,1),await(0,D.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(g,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(g,-1)}async triggerSync(n,s,u){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...n),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",u)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};i=pe([K(0,p.IProductService),K(1,S.IUserDataSyncStoreManagementService),K(2,S.IUserDataSyncStoreService),K(3,S.IUserDataSyncEnablementService),K(4,S.IUserDataSyncService),K(5,S.IUserDataSyncLogService),K(6,C.IUserDataSyncAccountService),K(7,h.ITelemetryService),K(8,m.IUserDataSyncMachinesService),K(9,v.IStorageService)],i),e.UserDataAutoSyncService=i;class o extends P.Disposable{constructor(n,s,u,l,f,y,A,O){super(),this.lastSyncUrl=n,this.interval=s,this.userDataSyncStoreManagementService=u,this.userDataSyncStoreService=l,this.userDataSyncService=f,this.userDataSyncMachinesService=y,this.logService=A,this.storageService=O,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(n,s){const u=(0,D.createCancelablePromise)(async l=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(f){if((0,L.isCancellationError)(f))return}return this.doSync(n,s,l)});return this.syncPromise=u,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const n=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!n&&(!(0,b.isEqual)(s.defaultUrl,n.defaultUrl)||!(0,b.isEqual)(s.insidersUrl,n.insidersUrl)||!(0,b.isEqual)(s.stableUrl,n.stableUrl))}async doSync(n,s,u){this.logService.info(`Auto Sync: Triggered by ${n}`),this._onDidStartSync.fire();let l;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),u.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const f=this.storageService.get(a,-1);if(f&&this.manifest&&f!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const y=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(u.isCancellationRequested)return;const A=y.find(O=>O.isCurrent);if(A?.disabled)throw new S.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(O){throw new S.UserDataAutoSyncError((0,R.toErrorMessage)(O),O instanceof S.UserDataSyncError?O.code:"Unknown")}if(this.manifest&&this.manifest.session!==f&&this.storageService.store(a,this.manifest.session,-1,1),u.isCancellationRequested)return;A||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(f){this.logService.error(f),l=f}this._onDidFinishSync.fire(l)}register(n){return super._register(n)}}o.INTERVAL_SYNCING="Interval"}),define(ne[77],re([0,1,2,67,5,21]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataSyncProfilesStorageService=e.IUserDataSyncProfilesStorageService=void 0,e.IUserDataSyncProfilesStorageService=(0,R.createDecorator)("IUserDataSyncProfilesStorageService");let T=class extends D.Disposable{constructor(b){super(),this.storageService=b}async readStorageData(b){if(this.storageService.hasScope(b))return this.getItems(this.storageService);const I=await this.createStorageDatabase(b),w=new P(I);try{return await w.initialize(),this.getItems(w)}finally{w.dispose(),await this.closeAndDispose(I)}}async updateStorageData(b,I,w){if(this.storageService.hasScope(b))return this.writeItems(this.storageService,I,w);const p=await this.createStorageDatabase(b),v=new P(p);try{await v.initialize(),this.writeItems(v,I,w),await v.flush()}finally{v.dispose(),await this.closeAndDispose(p)}}getItems(b){const I=new Map,w=p=>{for(const v of b.keys(0,p))I.set(v,{value:b.get(v,0),target:p})};return w(0),w(1),I}writeItems(b,I,w){for(const[p,v]of I)b.store(p,v,0,w)}async closeAndDispose(b){try{await b.close()}finally{(0,D.isDisposable)(b)&&b.dispose()}}};T=pe([K(0,L.IStorageService)],T),e.AbstractUserDataSyncProfilesStorageService=T;class P extends L.AbstractStorageService{constructor(b){super({flushInterval:100}),this.profileStorage=this._register(new r.Storage(b))}doInitialize(){return this.profileStorage.init()}getStorage(b){return b===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(ne[264],re([0,1,16,9,3,35,46,4,7,30,18,14,13,8,48,21,24,31,41,61,241,26,20,77]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m,g,a,d,c,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const t="globalState.argv.",n=["locale"];function s(A,O){const _=A.storage?Object.keys(A.storage).sort():[],M={};return _.forEach(k=>M[k]=A.storage[k]),A.storage=M,O?(0,T.toFormattedString)(A,{}):JSON.stringify(A)}const u=1;let l=class pt extends g.AbstractSynchroniser{constructor(O,_,M,k,F,$,x,J,H,G,z,j,Y){super({syncResource:"globalState",profile:O},_,k,J,j,F,$,H,G,x,z,Y),this.userDataSyncProfilesStorageService=M,this.version=u,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(R.Event.any(R.Event.filter(k.onDidFilesChange,te=>te.contains(this.environmentService.argvResource)),R.Event.filter(this.userDataSyncProfilesStorageService.onDidChange,te=>!!(te.targetChanges.some(ce=>this.syncResource.profile.id===ce.id)||te.valueChanges.some(({profile:ce,changes:W})=>this.syncResource.profile.id===ce.id&&W.some(V=>V.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(O,_,M){const k=O.syncData?JSON.parse(O.syncData.content):null;_=_===null&&M?O:_;const F=_&&_.syncData?JSON.parse(_.syncData.content):null,$=await this.getLocalGlobalState();k?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const x=await this.getStorageKeys(F),{local:J,remote:H}=(0,d.merge)($.storage,k?k.storage:null,F?F.storage:null,x,this.logService),G={content:null,local:J,remote:H,localChange:Object.keys(J.added).length>0||Object.keys(J.updated).length>0||J.removed.length>0?2:0,remoteChange:H!==null?2:0},z=s($,!1);return[{baseResource:this.baseResource,baseContent:F?s(F,!1):z,localResource:this.localResource,localContent:z,localUserData:$,remoteResource:this.remoteResource,remoteContent:k?s(k,!1):null,previewResource:this.previewResource,previewResult:G,localChange:G.localChange,remoteChange:G.remoteChange,acceptedResource:this.acceptedResource,storageKeys:x}]}async hasRemoteChanged(O){const _=O.syncData?JSON.parse(O.syncData.content):null;if(_===null)return!0;const M=await this.getLocalGlobalState(),k=await this.getStorageKeys(_),{remote:F}=(0,d.merge)(M.storage,_.storage,_.storage,k,this.logService);return F!==null}async getMergeResult(O,_){return{...O.previewResult,hasConflicts:!1}}async getAcceptResult(O,_,M,k){if(this.extUri.isEqual(_,this.localResource))return this.acceptLocal(O);if(this.extUri.isEqual(_,this.remoteResource))return this.acceptRemote(O);if(this.extUri.isEqual(_,this.previewResource))return O.previewResult;throw new Error(`Invalid Resource: ${_.toString()}`)}async acceptLocal(O){return{content:O.localContent,local:{added:{},removed:[],updated:{}},remote:O.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(O){if(O.remoteContent!==null){const _=JSON.parse(O.remoteContent),{local:M,remote:k}=(0,d.merge)(O.localUserData.storage,_.storage,null,O.storageKeys,this.logService);return{content:O.remoteContent,local:M,remote:k,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:k!==null?2:0}}else return{content:O.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(O,_,M,k){const{localUserData:F}=M[0][0],{local:$,remote:x,localChange:J,remoteChange:H}=M[0][1];if(J===0&&H===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),J!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(F)),await this.writeLocalGlobalState($),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),H!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const G=JSON.stringify({storage:x});O=await this.updateRemoteUserData(G,k?null:O.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}_?.ref!==O.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(O),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:O}){return[{resource:this.extUri.joinPath(O,"globalState.json"),comparableResource:pt.GLOBAL_STATE_DATA_URI}]}async resolveContent(O){if(this.extUri.isEqual(O,pt.GLOBAL_STATE_DATA_URI)){const M=await this.getLocalGlobalState();return s(M,!0)}if(this.extUri.isEqual(this.remoteResource,O)||this.extUri.isEqual(this.baseResource,O)||this.extUri.isEqual(this.localResource,O)||this.extUri.isEqual(this.acceptedResource,O)){const M=await this.resolvePreviewContent(O);return M&&s(JSON.parse(M),!0)}let _=await super.resolveContent(O);if(_)return _;if(_=await super.resolveContent(this.extUri.dirname(O)),_){const M=this.parseSyncData(_);if(M)switch(this.extUri.basename(O)){case"globalState.json":return s(JSON.parse(M.content),!0)}}return null}async hasLocalData(){try{const{storage:O}=await this.getLocalGlobalState();if(Object.keys(O).length>1||O[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const O={};if(this.syncResource.profile.isDefault){const M=await this.getLocalArgvContent(),k=(0,L.parse)(M);for(const F of n)k[F]!==void 0&&(O[`${t}${F}`]={version:1,value:k[F]})}const _=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile);for(const[M,k]of _)k.value&&k.target===0&&(O[M]={version:1,value:k.value});return{storage:O}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const O=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),O.value.toString()}catch(O){this.logService.debug((0,r.getErrorMessage)(O))}return"{}"}async writeLocalGlobalState({added:O,removed:_,updated:M}){const k={},F=new Map,$=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile),x=(J,H)=>{for(const G of J){if(G.startsWith(t)){k[G.substring(t.length)]=H?H[G].value:void 0;continue}if(H){const z=H[G];z.value!==$.get(G)?.value&&F.set(G,z.value)}else $.get(G)!==void 0&&F.set(G,void 0)}};x(Object.keys(O),O),x(Object.keys(M),M),x(_),Object.keys(k).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(k),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),F.size&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`),await this.userDataSyncProfilesStorageService.updateStorageData(this.syncResource.profile,F,0),this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,[...F.keys()]))}async updateArgv(O){const _=await this.getLocalArgvContent();let M=_;for(const k of Object.keys(O))M=(0,a.edit)(M,[k],O[k],{});_!==M&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(M)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}async getStorageKeys(O){const _=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile),M=[],k=[];for(const[x,J]of _)J.target===0?M.push(x):J.target===1&&k.push(x);const F=[...M,...k],$=O?.storage?Object.keys(O.storage).filter(x=>!x.startsWith(t)&&!F.includes(x)&&_.get(x)!==void 0):[];if(!P.isWeb){const x=[...c.ALL_SYNC_RESOURCES.map(J=>(0,c.getEnablementKey)(J)),c.SYNC_SERVICE_URL_TYPE];$.push(...x),k.push(...x)}return{user:M,machine:k,unregistered:$}}};l.GLOBAL_STATE_DATA_URI=E.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),l=pe([K(2,o.IUserDataSyncProfilesStorageService),K(3,p.IFileService),K(4,c.IUserDataSyncStoreService),K(5,c.IUserDataSyncBackupStoreService),K(6,c.IUserDataSyncLogService),K(7,w.IEnvironmentService),K(8,c.IUserDataSyncEnablementService),K(9,C.ITelemetryService),K(10,I.IConfigurationService),K(11,S.IStorageService),K(12,m.IUriIdentityService)],l),e.GlobalStateSynchroniser=l;let f=class extends g.AbstractInitializer{constructor(O,_,M,k,F,$){super("globalState",M,k,F,_,$),this.storageService=O}async doInitialize(O){const _=O.syncData?JSON.parse(O.syncData.content):null;if(!_){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const M={},k={};for(const F of Object.keys(_.storage))F.startsWith(t)?M[F.substring(t.length)]=_.storage[F].value:this.storageService.get(F,0)===void 0&&(k[F]=_.storage[F].value);if(Object.keys(M).length){let F="{}";try{F=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const $ of Object.keys(M))F=(0,a.edit)(F,[$],M[$],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(F))}if(Object.keys(k).length)for(const F of Object.keys(k))this.storageService.store(F,k[F],0,0)}};f=pe([K(0,S.IStorageService),K(1,p.IFileService),K(2,i.IUserDataProfilesService),K(3,w.IEnvironmentService),K(4,c.IUserDataSyncLogService),K(5,m.IUriIdentityService)],f),e.GlobalStateInitializer=f;let y=class{constructor(O,_,M,k,F){this.userDataSyncStoreClient=O,this.storageService=_,this.environmentService=M,this.fileService=k,this.logService=F}getSyncStoreType(O){return this.parseGlobalState(O)?.storage[c.SYNC_SERVICE_URL_TYPE]?.value}async sync(O){const _=(0,c.createSyncHeaders)((0,b.generateUuid)());try{return await this.doSync(O,_)}catch(M){if(M instanceof c.UserDataSyncError)switch(M.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(O,_)}throw M}}async doSync(O,_){const M=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,_),k=this.parseGlobalState(M)||{storage:{}};k.storage[c.SYNC_SERVICE_URL_TYPE]={value:O,version:u};const F=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:u,machineId:F,content:s(k,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify($),M.ref,void 0,_)}parseGlobalState({content:O}){if(!O)return null;const _=JSON.parse(O);if((0,g.isSyncData)(_))return _?JSON.parse(_.content):null;throw new Error("Invalid remote data")}};y=pe([K(1,S.IStorageService),K(2,w.IEnvironmentService),K(3,p.IFileService),K(4,v.ILogService)],y),e.UserDataSyncStoreTypeSynchronizer=y}),define(ne[265],re([0,1,19,6,23,38,3,2,17,15,30,18,29,5,25,21,24,20,255,264,256,257,258,259,260,26]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m,g,a,d,c,i,o,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const s="sync.lastSyncTime";let u=class extends P.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(O,_,M,k,F,$,x,J,H){super(),this.userDataSyncStoreService=O,this.userDataSyncStoreManagementService=_,this.instantiationService=M,this.logService=k,this.telemetryService=F,this.storageService=$,this.userDataSyncEnablementService=x,this.userDataProfilesService=J,this.productService=H,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=_.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(s,-1,void 0),this._register((0,P.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(O,_){this.checkEnablement();const M=(0,I.generateUuid)();try{const x=(0,n.createSyncHeaders)(M);_&&(x["Cache-Control"]="no-cache"),O=await this.userDataSyncStoreService.manifest(O,x)}catch(x){const J=n.UserDataSyncError.toUserDataSyncError(x);throw y(J,M,this.userDataSyncStoreManagementService,this.telemetryService),J}const k=!1,F=this;let $;return{manifest:O,async run(){if(k)throw new Error("Can run a task only once");return $=(0,r.createCancelablePromise)(x=>F.sync(O,!1,M,x)),$.finally(()=>$=void 0)},stop(){return $?.cancel(),F.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new n.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const O=(0,I.generateUuid)(),_=(0,n.createSyncHeaders)(O);let M;try{M=await this.userDataSyncStoreService.manifest(null,_)}catch($){const x=n.UserDataSyncError.toUserDataSyncError($);throw y(x,O,this.userDataSyncStoreManagementService,this.telemetryService),x}await this.resetLocal();const k=this,F=new R.CancellationTokenSource;return{id:O,async merge(){return k.sync(M,!0,O,F.token)},async apply(){for(const $ of k.getActiveProfileSynchronizers()){if(F.token.isCancellationRequested)return;await $.apply(O,F.token)}},stop(){return F.cancel(),k.stop()},dispose(){F.cancel(),k.stop()}}}async sync(O,_,M,k){if(k.isCancellationRequested)return;const F=new Date().getTime();this._syncErrors=[];try{this.logService.info("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const $=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile($,O,_,M,k));const x=$.enabled.find(J=>J.resource==="profiles");if(x){const J=await x.getLastSyncedProfiles()||[];if(k.isCancellationRequested)return;for(const H of J){if(k.isCancellationRequested)return;const G=this.userDataProfilesService.profiles.find(j=>j.id===H.id);if(!G){this.logService.error(`Settings Profile with id:${H.id} and name: ${H.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",H.name);const z=this.getOrCreateActiveProfileSynchronizer(G,H);this._syncErrors.push(...await this.syncProfile(z,O,_,M,k))}}this.logService.info(`Sync done. Took ${new Date().getTime()-F}ms`),this.updateLastSyncTime()}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncProfile(O,_,M,k,F){return(await O.sync(_,M,k,F)).map(([x,J])=>({profile:O.profile,syncResource:x,error:J}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(O=>O.stop()))}async resolveContent(O){for(const _ of this.userDataProfilesService.profiles){const M=await this.performAction(_,async k=>{const F=await k.resolveContent(O);if(F)return F});if(!(0,b.isUndefinedOrNull)(M))return M}return null}async replace(O,_){this.checkEnablement(),await this.performAction(O.profile,async M=>{if(O.syncResource===M.resource)return await M.replace(_),!0})}async accept(O,_,M,k){this.checkEnablement(),await this.performAction(O.profile,async F=>{if(O.syncResource===F.resource)return await F.accept(_,M),k&&await F.apply((0,b.isBoolean)(k)?!1:k.force,(0,n.createSyncHeaders)((0,I.generateUuid)())),!0})}async getRemoteSyncResourceHandles(O){return await this.performAction(O.profile,async M=>{if(M.resource===O.syncResource)return M.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(O){return await this.performAction(O.profile,async M=>{if(M.resource===O.syncResource)return M.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(O,_){return await this.performAction(O.profile,async k=>{if(k.resource===O.syncResource)return k.getAssociatedResources(_)})||[]}async getMachineId(O,_){return await this.performAction(O.profile,async k=>{if(k.resource===O.syncResource)return await k.getMachineId(_)||null})||void 0}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async _=>{if(_.resource!=="globalState"&&await _.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async _=>{if(await _.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(O){this.logService.error(O)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(s,-1),this.activeProfileSynchronizers){for(const[O]of this.activeProfileSynchronizers.values())try{await O.resetLocal()}catch(_){this.logService.error(_)}this.clearActiveProfileSynchronizers()}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performAction(O,_){const M=new P.DisposableStore;try{const k=this.activeProfileSynchronizers.get(O.id);if(k){const H=await this.performActionWithProfileSynchronizer(k[0],_,M);return(0,b.isUndefined)(H)?null:H}if(O.isDefault){const H=M.add(this.instantiationService.createInstance(l,O,void 0)),G=await this.performActionWithProfileSynchronizer(H,_,M);return(0,b.isUndefined)(G)?null:G}if(!this.productService.enableSyncingProfiles)return null;const F=M.add(this.instantiationService.createInstance(t.UserDataProfilesManifestSynchroniser,O,void 0)),$=await this.userDataSyncStoreService.manifest(null),J=(await F.getRemoteSyncedProfiles($?.latest??null)||[]).find(H=>H.id===O.id);if(J){const H=M.add(this.instantiationService.createInstance(l,O,J.collection)),G=await this.performActionWithProfileSynchronizer(H,_,M);return(0,b.isUndefined)(G)?null:G}return null}finally{M.dispose()}}async performActionWithProfileSynchronizer(O,_,M){const k=[...O.enabled,...O.disabled.map(F=>M.add(O.createSynchronizer(F)))];for(const F of k){const $=await _(F);if(!(0,b.isUndefined)($))return $}}setStatus(O){const _=this._status;this._status!==O&&(this._status=O,this._onDidChangeStatus.fire(O),_==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const O=this.getActiveProfileSynchronizers().map(_=>_.conflicts).flat();(0,D.equals)(this._conflicts,O,(_,M)=>_.profile.id===M.profile.id&&_.syncResource===M.syncResource&&(0,D.equals)(_.conflicts,M.conflicts,(k,F)=>(0,E.isEqual)(k.previewResource,F.previewResource)))||(this._conflicts=O,this._onDidChangeConflicts.fire(O))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(s,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(O,_){let M=this.activeProfileSynchronizers.get(O.id);if(!M){const k=new P.DisposableStore,F=k.add(this.instantiationService.createInstance(l,O,_?.collection));k.add(F.onDidChangeStatus($=>this.setStatus($))),k.add(F.onDidChangeConflicts($=>this.updateConflicts())),k.add(F.onDidChangeLocal($=>this._onDidChangeLocal.fire($))),this.activeProfileSynchronizers.set(O.id,M=[F,k])}return M[0]}getActiveProfileSynchronizers(){const O=[];for(const[_]of this.activeProfileSynchronizers.values())O.push(_);return O}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,O])=>O.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};u=pe([K(0,n.IUserDataSyncStoreService),K(1,n.IUserDataSyncStoreManagementService),K(2,v.IInstantiationService),K(3,n.IUserDataSyncLogService),K(4,C.ITelemetryService),K(5,S.IStorageService),K(6,n.IUserDataSyncEnablementService),K(7,m.IUserDataProfilesService),K(8,h.IProductService)],u),e.UserDataSyncService=u;let l=class extends P.Disposable{get enabled(){return this._enabled.sort((O,_)=>O[1]-_[1]).map(([O])=>O)}get disabled(){return n.ALL_SYNC_RESOURCES.filter(O=>!this.userDataSyncEnablementService.isResourceEnabled(O))}get status(){return this._status}get conflicts(){return this._conflicts}get profile(){return this._profile}constructor(O,_,M,k,F,$,x,J,H,G,z){super(),this._profile=O,this.collection=_,this.userDataSyncEnablementService=M,this.instantiationService=k,this.extensionGalleryService=F,this.userDataSyncStoreManagementService=$,this.telemetryService=x,this.logService=J,this.productService=H,this.configurationService=z,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._profile.isDefault&&this._register(G.onDidChangeProfiles(()=>{if(G.defaultProfile.extensionsResource&&!this._profile.extensionsResource||!G.defaultProfile.extensionsResource&&this._profile.extensionsResource){this._profile=G.defaultProfile;for(const[j]of this._enabled)j instanceof g.ExtensionsSynchroniser&&(j.profileLocation=this._profile.extensionsResource)}})),this._register(M.onDidChangeResourceEnablement(([j,Y])=>this.onDidChangeResourceEnablement(j,Y))),this._register((0,P.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,j])=>j.dispose())));for(const j of n.ALL_SYNC_RESOURCES)M.isResourceEnabled(j)&&this.registerSynchronizer(j)}onDidChangeResourceEnablement(O,_){_?this.registerSynchronizer(O):this.deRegisterSynchronizer(O)}registerSynchronizer(O){if(this._enabled.some(([F])=>F.resource===O))return;if(O==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(O==="profiles"){if(!this._profile.isDefault)return;if(!this.productService.enableSyncingProfiles){this.logService.debug("Skipping profiles sync");return}}const _=new P.DisposableStore,M=_.add(this.createSynchronizer(O));_.add(M.onDidChangeStatus(()=>this.updateStatus())),_.add(M.onDidChangeConflicts(()=>this.updateConflicts())),_.add(M.onDidChangeLocal(()=>this._onDidChangeLocal.fire(O)));const k=this.getOrder(O);this._enabled.push([M,k,_])}deRegisterSynchronizer(O){const _=this._enabled.findIndex(([M])=>M.resource===O);if(_!==-1){const M=this._enabled.splice(_,1);for(const[k,,F]of M){if(k.status!=="idle"){const $=k.conflicts.conflicts.length>0;k.stop(),$&&this.updateConflicts(),this.updateStatus()}F.dispose()}}}createSynchronizer(O){switch(O){case"settings":return this.instantiationService.createInstance(c.SettingsSynchroniser,this._profile,this.collection);case"keybindings":return this.instantiationService.createInstance(d.KeybindingsSynchroniser,this._profile,this.collection);case"snippets":return this.instantiationService.createInstance(i.SnippetsSynchroniser,this._profile,this.collection);case"tasks":return this.instantiationService.createInstance(o.TasksSynchroniser,this._profile,this.collection);case"globalState":return this.instantiationService.createInstance(a.GlobalStateSynchroniser,this._profile,this.collection);case"extensions":return this.instantiationService.createInstance(g.ExtensionsSynchroniser,this._profile,this.collection);case"profiles":return this.instantiationService.createInstance(t.UserDataProfilesManifestSynchroniser,this._profile,this.collection)}}async sync(O,_,M,k){if(k.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const $=[],x=(0,n.createSyncHeaders)(M),J=(this.collection?O?.collections?.[this.collection]?.latest:O?.latest)??null,H=_?await this.getUserDataSyncConfiguration(J):{};for(const G of F){if(k.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(G.resource))return[];try{if(_){const z=await G.preview(J,H,x);if(z)for(const j of z.resourcePreviews)(j.localChange!==0||j.remoteChange!==0)&&j.mergeState==="preview"&&await G.merge(j.previewResource)}else await G.sync(J,x)}catch(z){const j=n.UserDataSyncError.toUserDataSyncError(z);if(y(j,M,this.userDataSyncStoreManagementService,this.telemetryService),f(z))throw j;this.logService.error(z),this.logService.error(`${G.resource}: ${(0,L.toErrorMessage)(z)}`),$.push([G.resource,j])}}return $}finally{this.updateStatus()}}async apply(O,_){const M=(0,n.createSyncHeaders)(O);for(const k of this.enabled){if(_.isCancellationRequested)return;try{await k.apply(!1,M)}catch(F){const $=n.UserDataSyncError.toUserDataSyncError(F);if(y($,O,this.userDataSyncStoreManagementService,this.telemetryService),f(F))throw $;this.logService.error(F),this.logService.error(`${k.resource}: ${(0,L.toErrorMessage)(F)}`)}}}async stop(){for(const O of this.enabled)try{O.status!=="idle"&&await O.stop()}catch(_){this.logService.error(_)}}async resetLocal(){for(const O of this.enabled)try{await O.resetLocal()}catch(_){this.logService.error(`${O.resource}: ${(0,L.toErrorMessage)(_)}`),this.logService.error(_)}}async getUserDataSyncConfiguration(O){if(!this.profile.isDefault)return{};const _=this.configurationService.getValue(n.USER_DATA_SYNC_CONFIGURATION_SCOPE),M=this.enabled.find(k=>k instanceof c.SettingsSynchroniser);if(M){const k=await M.getRemoteUserDataSyncConfiguration(O);return{..._,...k}}return _}setStatus(O){this._status!==O&&(this._status=O,this._onDidChangeStatus.fire(O))}updateStatus(){return this.updateConflicts(),this.enabled.some(O=>O.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(O=>O.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const O=this.enabled.filter(_=>_.status==="hasConflicts").filter(_=>_.conflicts.conflicts.length>0).map(_=>_.conflicts);(0,D.equals)(this._conflicts,O,(_,M)=>_.syncResource===M.syncResource&&(0,D.equals)(_.conflicts,M.conflicts,(k,F)=>(0,E.isEqual)(k.previewResource,F.previewResource)))||(this._conflicts=O,this._onDidChangeConflicts.fire(O))}getOrder(O){switch(O){case"profiles":return 0;case"settings":return 1;case"keybindings":return 2;case"snippets":return 3;case"tasks":return 4;case"globalState":return 5;case"extensions":return 6}}};l=pe([K(2,n.IUserDataSyncEnablementService),K(3,v.IInstantiationService),K(4,p.IExtensionGalleryService),K(5,n.IUserDataSyncStoreManagementService),K(6,C.ITelemetryService),K(7,n.IUserDataSyncLogService),K(8,h.IProductService),K(9,m.IUserDataProfilesService),K(10,w.IConfigurationService)],l);function f(A){if(A instanceof n.UserDataSyncError)switch(A.code){case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function y(A,O,_,M){M.publicLog2("sync/error",{code:A.code,serverCode:A instanceof n.UserDataSyncStoreError?String(A.serverCode):void 0,url:A instanceof n.UserDataSyncStoreError?A.url:void 0,resource:A.resource,executionId:O,service:_.userDataSyncStore.url.toString()})}}),define(ne[266],re([0,1,3,2,7,20,26]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function P(w,p){return{...w,profie:(0,L.reviveProfile)(w.profile,p.profilesHome.scheme)}}class E{constructor(p,v,h){this.service=p,this.userDataProfilesService=v,this.logService=h,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(p,v){switch(v){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${v}`)}async call(p,v,h){try{return await this._call(p,v,h)}catch(S){throw this.logService.error(S),S}}async _call(p,v,h){switch(v){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(R.URI.revive(h[0]));case"accept":return this.service.accept(P(h[0],this.userDataProfilesService),R.URI.revive(h[1]),h[2],h[3]);case"replace":return this.service.replace(P(h[0],this.userDataProfilesService),R.URI.revive(h[1]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(P(h[0],this.userDataProfilesService));case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(P(h[0],this.userDataProfilesService));case"getAssociatedResources":return this.service.getAssociatedResources(P(h[0],this.userDataProfilesService),{created:h[1].created,uri:R.URI.revive(h[1].uri)});case"getMachineId":return this.service.getMachineId(P(h[0],this.userDataProfilesService),{created:h[1].created,uri:R.URI.revive(h[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(v.startsWith("manualSync/")){const S=v.substring(11),C=h[0],m=this.getManualSyncTask(C);switch(h=h.slice(1),S){case"merge":return m.merge();case"apply":return m.apply();case"stop":return m.stop();case"dispose":return this.disposeManualSyncTask(m)}}throw new Error("Invalid call")}getManualSyncTask(p){const v=this.manualSyncTasks.get(this.createKey(p));if(!v)throw new Error(`Manual sync taks not found: ${p}`);return v.manualSyncTask}async createManualSyncTask(){const p=new r.DisposableStore,v=p.add(await this.service.createManualSyncTask());return this.manualSyncTasks.set(this.createKey(v.id),{manualSyncTask:v,disposables:p}),v.id}disposeManualSyncTask(p){p.dispose();const v=this.createKey(p.id);this.manualSyncTasks.get(v)?.disposables.dispose(),this.manualSyncTasks.delete(v)}createKey(p){return`manualSyncTask-${p}`}}e.UserDataSyncChannel=E;let b=class extends r.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(p,v){super(),this.userDataProfilesService=v,this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(h,S,C){return p.call(h,S,C).then(null,m=>{throw T.UserDataSyncError.toUserDataSyncError(m)})},listen(h,S){return p.listen(h,S)}},this.channel.call("_getInitialData").then(([h,S,C])=>{this.updateStatus(h),this.updateConflicts(S),C&&this.updateLastSyncTime(C),this._register(this.channel.listen("onDidChangeStatus")(m=>this.updateStatus(m))),this._register(this.channel.listen("onDidChangeLastSyncTime")(m=>this.updateLastSyncTime(m)))}),this._register(this.channel.listen("onDidChangeConflicts")(h=>this.updateConflicts(h))),this._register(this.channel.listen("onSyncErrors")(h=>this._onSyncErrors.fire(h.map(S=>({...S,error:T.UserDataSyncError.toUserDataSyncError(S.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const p=await this.channel.call("createManualSyncTask"),v=this;return new I(p,{async call(S,C,m){return v.channel.call(`manualSync/${S}`,[p,...Array.isArray(C)?C:[C]],m)},listen(){throw new Error("not supported")}})}replace(p,v){return this.channel.call("replace",[p,v])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(p,v,h,S){return this.channel.call("accept",[p,v,h,S])}resolveContent(p){return this.channel.call("resolveContent",[p])}async getLocalSyncResourceHandles(p){return(await this.channel.call("getLocalSyncResourceHandles",[p])).map(({created:h,uri:S})=>({created:h,uri:R.URI.revive(S)}))}async getRemoteSyncResourceHandles(p){return(await this.channel.call("getRemoteSyncResourceHandles",[p])).map(({created:h,uri:S})=>({created:h,uri:R.URI.revive(S)}))}async getAssociatedResources(p,v){return(await this.channel.call("getAssociatedResources",[p,v])).map(({resource:S,comparableResource:C})=>({resource:R.URI.revive(S),comparableResource:R.URI.revive(C)}))}async getMachineId(p,v){return this.channel.call("getMachineId",[p,v])}async updateStatus(p){this._status=p,this._onDidChangeStatus.fire(p)}async updateConflicts(p){this._conflicts=p.map(v=>({syncResource:v.syncResource,profile:(0,L.reviveProfile)(v.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:v.conflicts.map(h=>({...h,baseResource:R.URI.revive(h.baseResource),localResource:R.URI.revive(h.localResource),remoteResource:R.URI.revive(h.remoteResource),previewResource:R.URI.revive(h.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(p){this._lastSyncTime!==p&&(this._lastSyncTime=p,this._onDidChangeLastSyncTime.fire(p))}};b=pe([K(1,L.IUserDataProfilesService)],b),e.UserDataSyncChannelClient=b;class I extends r.Disposable{constructor(p,v){super(),this.id=p,this.channel=v}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(ne[267],re([0,1,6,23,9,3,2,127,4,17,15,7,30,18,14,13,25,45,48,21,26]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m,g,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const c="sync.previous.store",i="sync.donot-make-requests-until",o="sync.user-session-id",t="sync.machine-session-id",n=100,s=1e3*60*5;let u=class extends T.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(d.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(_){this.storageService.store(d.SYNC_SERVICE_URL_TYPE,_,-1,E.isWeb?0:1)}constructor(_,M,k){super(),this.productService=_,this.configurationService=M,this.storageService=k,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter(k.onDidChangeValue,F=>F.key===d.SYNC_SERVICE_URL_TYPE&&F.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[d.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(d.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(_,M){_=E.isWeb&&_?.web?{..._,..._.web}:_;const k={..._||{},...M||{}};if(k&&(0,I.isString)(k.url)&&(0,I.isObject)(k.authenticationProviders)&&Object.keys(k.authenticationProviders).every(F=>Array.isArray(k.authenticationProviders[F].scopes))){const F=k,$=!!F.canSwitch&&!M?.url,x=F.url===F.insidersUrl?"insiders":"stable",J=($?this.userDataSyncStoreType:void 0)||x,H=M?.url||(J==="insiders"?F.insidersUrl:J==="stable"?F.stableUrl:F.url);return{url:w.URI.parse(H),type:J,defaultType:x,defaultUrl:w.URI.parse(F.url),stableUrl:w.URI.parse(F.stableUrl),insidersUrl:w.URI.parse(F.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(F.authenticationProviders).reduce((G,z)=>(G.push({id:z,scopes:F.authenticationProviders[z].scopes}),G),[])}}}};u=pe([K(0,C.IProductService),K(1,v.IConfigurationService),K(2,a.IStorageService)],u),e.AbstractUserDataSyncStoreManagementService=u;let l=class extends u{constructor(_,M,k){super(_,M,k);const F=this.storageService.get(c,-1);F&&(this.previousConfigurationSyncStore=JSON.parse(F));const $=this.productService[d.CONFIGURATION_SYNC_STORE_KEY];$?this.storageService.store(c,JSON.stringify($),-1,1):this.storageService.remove(c,-1)}async switch(_){_!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=_,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=pe([K(0,C.IProductService),K(1,v.IConfigurationService),K(2,a.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let f=class extends T.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(_,M,k,F,$,x,J){super(),this.requestService=k,this.logService=F,this.storageService=J,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(_),this.commonHeadersPromise=(0,g.getServiceMachineId)($,x,J).then(H=>{const G={"X-Client-Name":`${M.applicationName}${E.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(G["X-Client-Commit"]=M.commit),G}),this.session=new A(n,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,T.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(_,M){this.authToken={token:_,type:M}}updateUserDataSyncStoreUrl(_){this.userDataSyncStoreUrl=_?(0,b.joinPath)(_,"v1"):void 0}initDonotMakeRequestsUntil(){const _=this.storageService.getNumber(i,-1);_&&Date.now()<_&&this.setDonotMakeRequestsUntil(new Date(_))}setDonotMakeRequestsUntil(_){this._donotMakeRequestsUntil?.getTime()!==_?.getTime()&&(this._donotMakeRequestsUntil=_,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(M=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),M).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,M=>null)):this.storageService.remove(i,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(_={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,b.joinPath)(this.userDataSyncStoreUrl,"collection").toString();_={..._},_["Content-Type"]="application/json";const k=await this.request(M,{type:"GET",headers:_},[],r.CancellationToken.None);return await(0,m.asJson)(k)||[]}async createCollection(_={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,b.joinPath)(this.userDataSyncStoreUrl,"collection").toString();_={..._},_["Content-Type"]=P.Mimes.text;const k=await this.request(M,{type:"POST",headers:_},[],r.CancellationToken.None),F=await(0,m.asTextOrError)(k);if(!F)throw new d.UserDataSyncStoreError("Server did not return the collection id",M,"NoCollection",k.res.statusCode,k.res.headers[d.HEADER_OPERATION_ID]);return F}async deleteCollection(_,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=_?(0,b.joinPath)(this.userDataSyncStoreUrl,"collection",_).toString():(0,b.joinPath)(this.userDataSyncStoreUrl,"collection").toString();M={...M},await this.request(k,{type:"DELETE",headers:M},[],r.CancellationToken.None)}async getAllResourceRefs(_,M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=this.getResourceUrl(this.userDataSyncStoreUrl,M,_),F={},$=await this.request(k.toString(),{type:"GET",headers:F},[],r.CancellationToken.None);return(await(0,m.asJson)($)||[]).map(({url:J,created:H})=>({ref:(0,b.relativePath)(k,k.with({path:J})),created:H*1e3}))}async resolveResourceContent(_,M,k,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,_),M).toString();F={...F},F["Cache-Control"]="no-cache";const x=await this.request($,{type:"GET",headers:F},[],r.CancellationToken.None);return await(0,m.asTextOrError)(x)}async deleteResource(_,M,k){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=M!==null?(0,b.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,_),M).toString():this.getResourceUrl(this.userDataSyncStoreUrl,k,_).toString(),$={};await this.request(F,{type:"DELETE",headers:$},[],r.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),M={"Content-Type":P.Mimes.text};await this.request(_,{type:"DELETE",headers:M},[],r.CancellationToken.None)}async readResource(_,M,k,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,_),"latest").toString();F={...F},F["Cache-Control"]="no-cache",M&&(F["If-None-Match"]=M.ref);const x=await this.request($,{type:"GET",headers:F},[304],r.CancellationToken.None);let J=null;if(x.res.statusCode===304&&(J=M),J===null){const H=x.res.headers.etag;if(!H)throw new d.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",x.res.statusCode,x.res.headers[d.HEADER_OPERATION_ID]);const G=await(0,m.asTextOrError)(x);if(!G&&x.res.statusCode===304)throw new d.UserDataSyncStoreError("Empty response",$,"EmptyResponse",x.res.statusCode,x.res.headers[d.HEADER_OPERATION_ID]);J={ref:H,content:G}}return J}async writeResource(_,M,k,F,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=this.getResourceUrl(this.userDataSyncStoreUrl,F,_).toString();$={...$},$["Content-Type"]=P.Mimes.text,k&&($["If-Match"]=k);const J=await this.request(x,{type:"POST",data:M,headers:$},[],r.CancellationToken.None),H=J.res.headers.etag;if(!H)throw new d.UserDataSyncStoreError("Server did not return the ref",x,"NoRef",J.res.statusCode,J.res.headers[d.HEADER_OPERATION_ID]);return H}async manifest(_,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();M={...M},M["Content-Type"]="application/json",_&&(M["If-None-Match"]=_.ref);const F=await this.request(k,{type:"GET",headers:M},[304],r.CancellationToken.None);let $=null;if(F.res.statusCode===304&&($=_),!$){const J=F.res.headers.etag;if(!J)throw new d.UserDataSyncStoreError("Server did not return the ref",k,"NoRef",F.res.statusCode,F.res.headers[d.HEADER_OPERATION_ID]);const H=await(0,m.asTextOrError)(F);if(!H&&F.res.statusCode===304)throw new d.UserDataSyncStoreError("Empty response",k,"EmptyResponse",F.res.statusCode,F.res.headers[d.HEADER_OPERATION_ID]);H&&($={...JSON.parse(H),ref:J})}const x=this.storageService.get(o,-1);return x&&$&&x!==$.session&&this.clearSession(),$===null&&x&&this.clearSession(),$&&this.storageService.store(o,$.session,-1,1),$}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteResources(),await this.deleteCollection(),this.clearSession()}getResourceUrl(_,M,k){return M?(0,b.joinPath)(_,"collection",M,"resource",k):(0,b.joinPath)(_,"resource",k)}clearSession(){this.storageService.remove(o,-1),this.storageService.remove(t,-1)}async request(_,M,k,F){if(!this.authToken)throw new d.UserDataSyncStoreError("No Auth Token Available",_,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new d.UserDataSyncStoreError(`${M.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const $=await this.commonHeadersPromise;M.headers={...M.headers||{},...$,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(M.headers),this.logService.trace("Sending request to server",{url:_,type:M.type,headers:{...M.headers,authorization:void 0}});let x;try{x=await this.session.request(_,M,F)}catch(z){if(!(z instanceof d.UserDataSyncStoreError)){let j="RequestFailed";const Y=(0,R.getErrorMessage)(z).toLowerCase();Y.includes("xhr timeout")?j="RequestTimeout":Y.includes("protocol")&&Y.includes("not supported")?j="RequestProtocolNotSupported":Y.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":Y.includes("headers must be an object")?j="RequestHeadersNotObject":(0,R.isCancellationError)(z)&&(j="RequestCanceled"),z=new d.UserDataSyncStoreError(`Connection refused for the request '${_}'.`,_,j,void 0,void 0)}throw this.logService.info("Request failed",_),z}const J=x.res.headers[d.HEADER_OPERATION_ID],H={url:_,status:x.res.statusCode,"execution-id":M.headers[d.HEADER_EXECUTION_ID],"operation-id":J},G=(0,m.isSuccess)(x)||x.res.statusCode&&k.indexOf(x.res.statusCode)!==-1;if(G?this.logService.trace("Request succeeded",H):this.logService.info("Request failed",H),x.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new d.UserDataSyncStoreError(`Request '${_}' failed because of Unauthorized (401).`,_,"Unauthorized",x.res.statusCode,J);if(this._onTokenSucceed.fire(),x.res.statusCode===409)throw new d.UserDataSyncStoreError(`${M.type} request '${_}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,_,"Conflict",x.res.statusCode,J);if(x.res.statusCode===410)throw new d.UserDataSyncStoreError(`${M.type} request '${_}' failed because the requested resource is not longer available (410).`,_,"Gone",x.res.statusCode,J);if(x.res.statusCode===412)throw new d.UserDataSyncStoreError(`${M.type} request '${_}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,_,"PreconditionFailed",x.res.statusCode,J);if(x.res.statusCode===413)throw new d.UserDataSyncStoreError(`${M.type} request '${_}' failed because of too large payload (413).`,_,"TooLarge",x.res.statusCode,J);if(x.res.statusCode===426)throw new d.UserDataSyncStoreError(`${M.type} request '${_}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,_,"UpgradeRequired",x.res.statusCode,J);if(x.res.statusCode===429){const z=x.res.headers["retry-after"];throw z?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(z)*1e3)),new d.UserDataSyncStoreError(`${M.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",x.res.statusCode,J)):new d.UserDataSyncStoreError(`${M.type} request '${_}' failed because of too many requests (429).`,_,"RemoteTooManyRequests",x.res.statusCode,J)}if(!G)throw new d.UserDataSyncStoreError("Server returned "+x.res.statusCode,_,"Unknown",x.res.statusCode,J);return x}addSessionHeaders(_){let M=this.storageService.get(t,-1);M===void 0&&(M=(0,p.generateUuid)(),this.storageService.store(t,M,-1,1)),_["X-Machine-Session-Id"]=M;const k=this.storageService.get(o,-1);k!==void 0&&(_["X-User-Session-Id"]=k)}};f=pe([K(1,C.IProductService),K(2,m.IRequestService),K(3,d.IUserDataSyncLogService),K(4,h.IEnvironmentService),K(5,S.IFileService),K(6,a.IStorageService)],f),e.UserDataSyncStoreClient=f;let y=class extends f{constructor(_,M,k,F,$,x,J){super(_.userDataSyncStore?.url,M,k,F,$,x,J),this._register(_.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(_.userDataSyncStore?.url)))}};y=pe([K(0,d.IUserDataSyncStoreManagementService),K(1,C.IProductService),K(2,m.IRequestService),K(3,d.IUserDataSyncLogService),K(4,h.IEnvironmentService),K(5,S.IFileService),K(6,a.IStorageService)],y),e.UserDataSyncStoreService=y;class A{constructor(_,M,k,F){this.limit=_,this.interval=M,this.requestService=k,this.logService=F,this.requests=[],this.startTime=void 0}request(_,M,k){if(this.isExpired()&&this.reset(),M.url=_,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new d.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,_,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(_),this.requestService.request(M,k)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(ne[268],re([0,1,3,59,25,21,24,263,26,73,76]),function(Q,e,D,r,R,L,T,P,E,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends P.UserDataAutoSyncService{constructor(v,h,S,C,m,g,a,d,c,i,o){super(v,h,S,C,m,a,d,c,i,o),this._register(D.Event.debounce(D.Event.any(D.Event.map(g.onDidFocusWindow,()=>"windowFocus"),D.Event.map(g.onDidOpenWindow,()=>"windowOpen")),(t,n)=>t?[...t,n]:[n],1e3)(t=>this.triggerSync(t,!0,!1)))}};w=pe([K(0,R.IProductService),K(1,E.IUserDataSyncStoreManagementService),K(2,E.IUserDataSyncStoreService),K(3,E.IUserDataSyncEnablementService),K(4,E.IUserDataSyncService),K(5,r.INativeHostService),K(6,E.IUserDataSyncLogService),K(7,b.IUserDataSyncAccountService),K(8,T.ITelemetryService),K(9,I.IUserDataSyncMachinesService),K(10,L.IStorageService)],w),e.UserDataAutoSyncService=w}),define(ne[269],re([0,1,3,2,58,8,77,21,71,20]),function(Q,e,D,r,R,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncProfilesStorageService=void 0;let I=class extends T.AbstractUserDataSyncProfilesStorageService{constructor(p,v,h,S){super(h),this.mainProcessService=p;const C=p.getChannel("profileStorageListener"),m=this._register(new r.MutableDisposable);this._onDidChange=this._register(new D.Emitter({onFirstListenerAdd:()=>{m.value=C.listen("onDidChange")(g=>{S.trace("profile storage changes",g),this._onDidChange.fire({targetChanges:g.targetChanges.map(a=>(0,b.reviveProfile)(a,v.profilesHome.scheme)),valueChanges:g.valueChanges.map(a=>({...a,profile:(0,b.reviveProfile)(a.profile,v.profilesHome.scheme)}))})})},onLastListenerRemove:()=>m.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(p){const v=this.mainProcessService.getChannel("storage");return(0,P.isProfileUsingDefaultStorage)(p)?new E.ApplicationStorageDatabaseClient(v):new E.ProfileStorageDatabaseClient(v,p)}};I=pe([K(0,R.IMainProcessService),K(1,b.IUserDataProfilesService),K(2,P.IStorageService),K(3,L.ILogService)],I),e.UserDataSyncProfilesStorageService=I}),define(ne[270],re([0,1,95,22,4,17]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function T(b){function I(){let w=b.scheme===r.Schemas.file?(0,L.originalFSPath)(b):b.toString();return R.isLinux||(w=w.toLowerCase()),(0,D.createHash)("md5").update(w).digest("hex")}return{id:I(),configPath:b}}e.getWorkspaceIdentifier=T;function P(b,I){function w(){if(b.scheme!==r.Schemas.file)return(0,D.createHash)("md5").update(b.toString()).digest("hex");if(!I)return;let v;return R.isLinux?v=I.ino:R.isMacintosh?v=I.birthtime.getTime():R.isWindows&&(typeof I.birthtimeMs=="number"?v=Math.floor(I.birthtimeMs):v=I.birthtime.getTime()),(0,D.createHash)("md5").update(b.fsPath).update(v?String(v):"").digest("hex")}const p=w();if(typeof p=="string")return{id:p,uri:b}}e.getSingleFolderWorkspaceIdentifier=P;function E(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=E}),define(ne[271],re([0,1,6,9,2,12,28,14,58,8,59,71,111,270]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let h=class extends R.Disposable{constructor(C,m,g,a){super(),this.environmentService=C,this.logService=m,this.nativeHostService=g,this.mainProcessService=a,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const C=await T.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),m=new w.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(C.map(async g=>{const a=(0,L.join)(this.environmentService.workspaceStorageHome.fsPath,g);g.length===v.NON_EMPTY_WORKSPACE_ID_LENGTH||g===p.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(i=>i.workspace?.id===g)||await m.isUsed(a)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${g} as it seems to be an unused empty workspace.`),await T.Promises.rm(a))}))}catch(C){(0,r.onUnexpectedError)(C)}}};h=pe([K(0,P.INativeEnvironmentService),K(1,b.ILogService),K(2,I.INativeHostService),K(3,E.IMainProcessService)],h),e.UnusedWorkspaceStorageDataCleaner=h}),define(ne[112],re([0,1,53,6,12,15,28,139,280,281]),function(Q,e,D,r,R,L,T,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(i,o){let t=o.message;switch(i){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=i,this.cause=o}}e.ExtractError=I;function w(c){const i=c.externalFileAttributes>>16||33188;return[448,56,7].map(o=>i&o).reduce((o,t)=>o+t,i&61440)}function p(c){if(c instanceof I)return c;let i;return/end of central directory record signature not found/.test(c.message)&&(i="CorruptZip"),new I(i,c)}function v(c,i,o,t,n,s){const u=R.dirname(i),l=R.join(t,u);if(!l.startsWith(t))return Promise.reject(new Error(P.localize(0,null,i)));const f=R.join(t,i);let y;return s.onCancellationRequested(()=>{y?.destroy()}),Promise.resolve(T.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((A,O)=>{if(!s.isCancellationRequested)try{y=(0,D.createWriteStream)(f,{mode:o}),y.once("close",()=>A()),y.once("error",O),c.once("error",O),c.pipe(y)}catch(_){O(_)}}))}function h(c,i,o,t){let n=(0,r.createCancelablePromise)(()=>Promise.resolve()),s=0;return t.onCancellationRequested(()=>{n.cancel(),c.close()}),new Promise((u,l)=>{const f=new r.Sequencer,y=A=>{A.isCancellationRequested||(s++,c.readEntry())};c.once("error",l),c.once("close",()=>n.then(()=>{t.isCancellationRequested||c.entryCount===s?u():l(new I("Incomplete",new Error(P.localize(1,null,s,c.entryCount))))},l)),c.readEntry(),c.on("entry",A=>{if(t.isCancellationRequested)return;if(!o.sourcePathRegex.test(A.fileName)){y(t);return}const O=A.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(O)){const k=R.join(i,O);n=(0,r.createCancelablePromise)(F=>T.Promises.mkdir(k,{recursive:!0}).then(()=>y(F)).then(void 0,l));return}const _=C(c,A),M=w(A);n=(0,r.createCancelablePromise)(k=>f.queue(()=>_.then(F=>v(F,O,M,i,o,k).then(()=>y(k)))).then(null,l))})})}function S(c,i=!1){return new Promise((o,t)=>{(0,E.open)(c,i?{lazyEntries:!0}:void 0,(n,s)=>{n?t(p(n)):o((0,L.assertIsDefined)(s))})})}function C(c,i){return new Promise((o,t)=>{c.openReadStream(i,(n,s)=>{n?t(p(n)):o((0,L.assertIsDefined)(s))})})}function m(c,i){return new Promise((o,t)=>{const n=new b.ZipFile;i.forEach(u=>{u.contents?n.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&n.addFile(u.localPath,u.path)}),n.end();const s=(0,D.createWriteStream)(c);n.outputStream.pipe(s),n.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>o(c))})}e.zip=m;function g(c,i,o={},t){const n=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let s=S(c,!0);return o.overwrite&&(s=s.then(u=>T.Promises.rm(i).then(()=>u))),s.then(u=>h(u,i,{sourcePathRegex:n},t))}e.extract=g;function a(c,i){return S(c).then(o=>new Promise((t,n)=>{o.on("entry",s=>{s.fileName===i&&C(o,s).then(u=>t(u),u=>n(u))}),o.once("close",()=>n(new Error(P.localize(2,null,i))))}))}function d(c,i){return a(c,i).then(o=>new Promise((t,n)=>{const s=[];o.once("error",n),o.on("data",u=>s.push(u)),o.on("end",()=>t(Buffer.concat(s)))}))}e.buffer=d}),define(ne[272],re([0,1,112,149]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(L){return(0,D.buffer)(L,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,r.localize)(0,null))}})}e.getManifest=R}),define(ne[113],re([0,1,6,38,9,2,22,12,4,17,55,15,7,30,28,112,148,93,14,247,29,33,49,74,203,248,272,204,234,44,68,13,5,8,25,24,31,20]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m,g,a,d,c,i,o,t,n,s,u,l,f,y,A,O,_,M,k,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,O.refineServiceDecorator)(d.IExtensionManagementService);let x=class extends a.AbstractExtensionManagementService{constructor(W,V,U,N,q,B,Z,oe,X,ie,se,ue){super(W,V,U,ie,ue),this.extensionsScannerService=q,this.extensionsProfileScannerService=B,this.downloadService=Z,this.fileService=X,this.installGalleryExtensionsTasks=new Map;const he=this._register(oe.createInstance(n.ExtensionsLifecycle));this.extensionsScanner=this._register(oe.createInstance(J,we=>he.postUninstall(we))),this.manifestCache=this._register(new u.ExtensionsManifestCache(N,this)),this.extensionsDownloader=this._register(oe.createInstance(t.ExtensionsDownloader));const ve=this._register(new l.ExtensionsWatcher(this,X,N,U,se));this._register(ve.onDidChangeExtensionsByAnotherSource(({added:we,removed:Ee})=>{we.length&&this._onDidInstallExtensions.fire(we.map(Pe=>({identifier:Pe.identifier,operation:1,local:Pe}))),Ee.forEach(Pe=>this._onDidUninstallExtension.fire({identifier:Pe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,c.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const V=await this.collectFiles(W),U=await(0,S.zip)((0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,V);return p.URI.file(U)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const{location:V,cleanup:U}=await this.downloadVsix(W),N=P.resolve(V.fsPath);try{return await(0,s.getManifest)(N)}finally{await U()}}getInstalled(W,V){return this.extensionsScanner.scanExtensions(W??null,V)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(W,V={}){this.logService.trace("ExtensionManagementService#install",W.toString());const{location:U,cleanup:N}=await this.downloadVsix(W);try{const q=await(0,s.getManifest)(P.resolve(U.fsPath));if(q.engines&&q.engines.vscode&&!(0,y.isEngineValid)(q.engines.vscode,this.productService.version,this.productService.date))throw new Error(C.localize(0,null,(0,c.getGalleryExtensionId)(q.publisher,q.name),this.productService.version));return await this.installExtension(q,U,V)}finally{await N()}}getMetadata(W){return this.extensionsScannerService.scanMetadata(W.location)}async updateMetadata(W,V){this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id);const U={...V};return V.isPreReleaseVersion&&(U.preRelease=!0),W=await this.extensionsScanner.updateMetadata(W,U),this.manifestCache.invalidate(),W}async updateExtensionScope(W,V){return this.logService.trace("ExtensionManagementService#updateExtensionScope",W.identifier.id),W=await this.extensionsScanner.updateMetadata(W,{isMachineScoped:V}),this.manifestCache.invalidate(),W}removeUninstalledExtensions(W){return this.extensionsScanner.cleanUp(W)}async downloadVsix(W){if(W.scheme===T.Schemas.file)return{location:W,async cleanup(){}};this.logService.trace("Downloading extension from",W.toString());const V=(0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(W,V),this.logService.info("Downloaded extension to",V.toString()),{location:V,cleanup:async()=>{try{await this.fileService.del(V)}catch(N){this.logService.error(N)}}}}doCreateInstallExtensionTask(W,V,U){let N;if(p.URI.isUri(V))N=new z(W,V,U,this.galleryService,this.extensionsScanner,this.logService);else{const q=c.ExtensionKey.create(V).toString();N=this.installGalleryExtensionsTasks.get(q),N||(this.installGalleryExtensionsTasks.set(q,N=new G(W,V,U,this.extensionsDownloader,this.extensionsScanner,this.logService)),N.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(q)))}return U.profileLocation?new j(N,U.profileLocation,this.extensionsProfileScannerService):N}doCreateUninstallExtensionTask(W,V){return V.profileLocation?new te(W,V.profileLocation,this.extensionsProfileScannerService):new Y(W,V,this.extensionsScanner)}async collectFiles(W){const V=async N=>{let q=await h.Promises.readdir(N);q=q.map(oe=>P.join(N,oe));const B=await Promise.all(q.map(oe=>h.Promises.stat(oe)));let Z=Promise.resolve([]);return B.forEach((oe,X)=>{const ie=q[X];oe.isFile()&&(Z=Z.then(se=>[...se,ie])),oe.isDirectory()&&(Z=Z.then(se=>V(ie).then(ue=>[...se,...ue])))}),Z};return(await V(W.location.fsPath)).map(N=>({path:`extension/${P.relative(W.location.fsPath,N)}`,localPath:N}))}};x=pe([K(0,d.IExtensionGalleryService),K(1,k.ITelemetryService),K(2,_.ILogService),K(3,g.INativeEnvironmentService),K(4,o.IExtensionsScannerService),K(5,i.IExtensionsProfileScannerService),K(6,m.IDownloadService),K(7,O.IInstantiationService),K(8,A.IFileService),K(9,M.IProductService),K(10,F.IUriIdentityService),K(11,$.IUserDataProfilesService)],x),e.ExtensionManagementService=x;let J=class extends L.Disposable{constructor(W,V,U,N){super(),this.beforeRemovingExtension=W,this.fileService=V,this.extensionsScannerService=U,this.logService=N,this.uninstalledPath=(0,b.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(W){await this.removeUninstalledExtensions(),W&&await this.removeOutdatedExtensions()}async scanExtensions(W,V){const U={includeInvalid:!0,profileLocation:V};let N=[];return W===null||W===0?N.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},U,!1)):W===1&&N.push(...await this.extensionsScannerService.scanUserExtensions(U)),N=W!==null?N.filter(q=>q.type===W):N,Promise.all(N.map(q=>this.toLocalExtension(q)))}async scanUserExtensions(W){const V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!W,includeInvalid:!0});return Promise.all(V.map(U=>this.toLocalExtension(U)))}async extractUserExtension(W,V,U,N){const q=W.toString(),B=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),Z=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,q);try{await h.Promises.rm(Z)}catch{throw new d.ExtensionManagementError(C.localize(1,null,Z,W.id),d.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(W,V,B,N),U.installedTimestamp=Date.now(),await this.extensionsScannerService.updateMetadata(p.URI.file(B),U);try{await this.rename(W,B,Z,Date.now()+2*60*1e3),this.logService.info("Renamed to",Z)}catch(oe){try{await h.Promises.rm(B)}catch{}if(oe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",W.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(oe)}. Deleted from extracted location`,B),oe}return this.scanLocalExtension(p.URI.file(Z),1)}async updateMetadata(W,V){return await this.extensionsScannerService.updateMetadata(W.location,V),this.scanLocalExtension(W.location,W.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...W){const V=W.map(U=>c.ExtensionKey.create(U));await this.withUninstalledExtensions(U=>{V.forEach(N=>U[N.toString()]=!0)})}async setInstalled(W){await this.withUninstalledExtensions(N=>delete N[W.toString()]);const U=(await this.scanUserExtensions(!0)).find(N=>c.ExtensionKey.create(N).equals(W))||null;return U?this.updateMetadata(U,{installedTimestamp:Date.now()}):null}async removeExtension(W,V){this.logService.trace(`Deleting ${V} extension from disk`,W.identifier.id,W.location.fsPath),await h.Promises.rm(W.location.fsPath),this.logService.info("Deleted from disk",W.identifier.id,W.location.fsPath)}async removeUninstalledExtension(W){await this.removeExtension(W,"uninstalled"),await this.withUninstalledExtensions(V=>delete V[c.ExtensionKey.create(W).toString()])}async withUninstalledExtensions(W){return this.uninstalledFileLimiter.queue(async()=>{let V;try{V=await h.Promises.readFile(this.uninstalledPath,"utf8")}catch(N){if(N.code!=="ENOENT")throw N}let U={};if(V)try{U=JSON.parse(V)}catch{}return W&&(W(U),Object.keys(U).length?await h.Promises.writeFile(this.uninstalledPath,JSON.stringify(U)):await h.Promises.rm(this.uninstalledPath)),U})}async extractAtLocation(W,V,U,N){this.logService.trace(`Started extracting the extension from ${V} to ${U}`);try{await h.Promises.rm(U)}catch(q){throw new d.ExtensionManagementError(this.joinErrors(q).message,d.ExtensionManagementErrorCode.Delete)}try{await(0,S.extract)(V,U,{sourcePath:"extension",overwrite:!0},N),this.logService.info(`Extracted extension to ${U}:`,W.id)}catch(q){try{await h.Promises.rm(U)}catch{}let B=d.ExtensionManagementErrorCode.Extract;throw q instanceof S.ExtractError&&(q.type==="CorruptZip"?B=d.ExtensionManagementErrorCode.CorruptZip:q.type==="Incomplete"&&(B=d.ExtensionManagementErrorCode.IncompleteZip)),new d.ExtensionManagementError(q.message,B)}}async rename(W,V,U,N){try{await h.Promises.rename(V,U)}catch(q){if(E.isWindows&&q&&q.code==="EPERM"&&Date.now()<N)return this.logService.info(`Failed renaming ${V} to ${U} with 'EPERM' error. Trying again...`,W.id),this.rename(W,V,U,N);throw new d.ExtensionManagementError(q.message||C.localize(2,null,V,U),q.code||d.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(W,V){const U=await this.extensionsScannerService.scanExistingExtension(W,V,{includeInvalid:!0});if(U)return this.toLocalExtension(U);throw new Error(C.localize(3,null,W.path))}async toLocalExtension(W){const V=await this.fileService.resolve(W.location);let U,N;return V.children&&(U=V.children.find(({name:q})=>/^readme(\.txt|\.md|)$/i.test(q))?.resource,N=V.children.find(({name:q})=>/^changelog(\.txt|\.md|)$/i.test(q))?.resource),{identifier:W.identifier,type:W.type,isBuiltin:W.isBuiltin||!!W.metadata?.isBuiltin,location:W.location,manifest:W.manifest,targetPlatform:W.targetPlatform,validations:W.validations,isValid:W.isValid,readmeUrl:U,changelogUrl:N,publisherDisplayName:W.metadata?.publisherDisplayName||null,publisherId:W.metadata?.publisherId||null,isApplicationScoped:!!W.metadata?.isApplicationScoped,isMachineScoped:!!W.metadata?.isMachineScoped,isPreReleaseVersion:!!W.metadata?.isPreReleaseVersion,preRelease:!!W.metadata?.preRelease,installedTimestamp:W.metadata?.installedTimestamp,updated:!!W.metadata?.updated}}async removeUninstalledExtensions(){const W=await this.getUninstalledExtensions(),V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),U=new Set;for(const B of V)W[c.ExtensionKey.create(B).toString()]||U.add(B.identifier.id.toLowerCase());const N=(0,c.groupByExtension)(V,B=>B.identifier);await D.Promises.settled(N.map(async B=>{const Z=B.sort((oe,X)=>I.rcompare(oe.manifest.version,X.manifest.version))[0];U.has(Z.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(Z))}));const q=V.filter(B=>W[c.ExtensionKey.create(B).toString()]);await D.Promises.settled(q.map(B=>this.removeUninstalledExtension(B)))}async removeOutdatedExtensions(){const W=await this.extensionsScannerService.scanSystemExtensions({}),V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),U=[],N=await this.extensionsScannerService.getTargetPlatform(),q=(0,c.groupByExtension)(V,B=>B.identifier);for(const B of q)if(B.length>1&&U.push(...B.sort((Z,oe)=>{const X=I.rcompare(Z.manifest.version,oe.manifest.version);return X!==0?X:Z.targetPlatform===N?-1:1}).slice(1)),B[0].type===0){const Z=W.find(oe=>(0,c.areSameExtensions)(oe.identifier,B[0].identifier));(!Z||I.gte(Z.manifest.version,B[0].manifest.version))&&U.push(B[0])}await D.Promises.settled(U.map(B=>this.removeExtension(B,"outdated")))}joinErrors(W){const V=Array.isArray(W)?W:[W];return V.length===1?V[0]instanceof Error?V[0]:new Error(V[0]):V.reduce((U,N)=>new Error(`${U.message}${U.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}};J=pe([K(1,A.IFileService),K(2,o.IExtensionsScannerService),K(3,_.ILogService)],J);class H extends a.AbstractExtensionTask{get operation(){return(0,w.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(W,V,U,N,q){super(),this.identifier=W,this.source=V,this.options=U,this.extensionsScanner=N,this.logService=q,this._operation=2}async installExtension(W,V){try{const U=await this.unsetUninstalledAndGetLocal(W.key);if(U)return this.extensionsScanner.updateMetadata(U,W.metadata)}catch{throw E.isMacintosh?new d.ExtensionManagementError(C.localize(4,null),d.ExtensionManagementErrorCode.Internal):new d.ExtensionManagementError(C.localize(5,null),d.ExtensionManagementErrorCode.Internal)}return this.extract(W,V)}async unsetUninstalledAndGetLocal(W){if(!await this.isUninstalled(W))return null;this.logService.trace("Removing the extension from uninstalled list:",W.id);const U=await this.extensionsScanner.setInstalled(W);return this.logService.info("Removed the extension from uninstalled list:",W.id),U}async isUninstalled(W){return!!(await this.extensionsScanner.getUninstalledExtensions())[W.toString()]}async extract({zipPath:W,key:V,metadata:U},N){const q=await this.extensionsScanner.extractUserExtension(V,W,U,N);return this.logService.info("Extracting completed.",V.id),q}}class G extends H{constructor(W,V,U,N,q,B){super(V.identifier,V,U,q,B),this.manifest=W,this.gallery=V,this.extensionsDownloader=N}async doRun(W){const U=(await this.extensionsScanner.scanExtensions(null,void 0)).find(B=>(0,c.areSameExtensions)(B.identifier,this.gallery.identifier));U&&(this._operation=3);const N={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,f.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||U?.isMachineScoped,isBuiltin:this.options.isBuiltin||U?.isBuiltin,isSystem:U?.type===0?!0:void 0,updated:!!U,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,w.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:U?.preRelease)};if(U?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(U,N),metadata:N};const q=await this.downloadExtension(this.gallery,this._operation);try{const B=await this.installExtension({zipPath:q,key:c.ExtensionKey.create(this.gallery),metadata:N},W);return U&&!this.options.profileLocation&&(U.targetPlatform!==B.targetPlatform||I.neq(U.manifest.version,B.manifest.version))&&await this.extensionsScanner.setUninstalled(U),{local:B,metadata:N}}catch(B){throw await this.deleteDownloadedVSIX(q),B}}async deleteDownloadedVSIX(W){try{await this.extensionsDownloader.delete(p.URI.file(W))}catch(V){this.logService.warn("Error while deleting the downloaded vsix",W.toString(),(0,R.getErrorMessage)(V))}}async downloadExtension(W,V){let U;try{this.logService.trace("Started downloading extension:",W.identifier.id),U=(await this.extensionsDownloader.downloadExtension(W,V)).fsPath,this.logService.info("Downloaded extension:",W.identifier.id,U)}catch(N){throw new d.ExtensionManagementError((0,a.joinErrors)(N).message,d.ExtensionManagementErrorCode.Download)}try{return await(0,s.getManifest)(U),U}catch(N){throw await this.deleteDownloadedVSIX(U),new d.ExtensionManagementError((0,a.joinErrors)(N).message,d.ExtensionManagementErrorCode.Invalid)}}}class z extends H{constructor(W,V,U,N,q,B){super({id:(0,c.getGalleryExtensionId)(W.publisher,W.name)},V,U,q,B),this.manifest=W,this.location=V,this.galleryService=N}async doRun(W){const V=new c.ExtensionKey(this.identifier,this.manifest.version),N=(await this.extensionsScanner.scanExtensions(1,void 0)).find(Z=>(0,c.areSameExtensions)(this.identifier,Z.identifier)),q=await this.getMetadata(this.identifier.id,this.manifest.version,W);if(q.isApplicationScoped=(0,f.isApplicationScopedExtension)(this.manifest),q.isMachineScoped=this.options.isMachineScoped||N?.isMachineScoped,q.isBuiltin=this.options.isBuiltin||N?.isBuiltin,N)if(this._operation=3,V.equals(new c.ExtensionKey(N.identifier,N.manifest.version)))try{await this.extensionsScanner.removeExtension(N,"existing")}catch{throw new Error(C.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&I.gt(N.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(N);else{const Z=await this.unsetUninstalledAndGetLocal(V);if(Z)try{await this.extensionsScanner.removeExtension(Z,"existing")}catch{throw new Error(C.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:P.resolve(this.location.fsPath),key:V,metadata:q},W),metadata:q}}async getMetadata(W,V,U){try{let[N]=await this.galleryService.getExtensions([{id:W,version:V}],U);if(N||([N]=await this.galleryService.getExtensions([{id:W}],U)),N)return{id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId,isPreReleaseVersion:N.properties.isPreReleaseVersion,preRelease:N.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class j{constructor(W,V,U){this.task=W,this.profileLocation=V,this.extensionsProfileScannerService=U,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const W=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[W.local,W.metadata]],this.profileLocation),W}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class Y extends a.AbstractExtensionTask{constructor(W,V,U){super(),this.extension=W,this.options=V,this.extensionsScanner=U}async doRun(W){const V=[],U=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const N=c.ExtensionKey.create(this.extension);V.push(...U.filter(q=>N.equals(c.ExtensionKey.create(q))))}else V.push(...U.filter(N=>(0,c.areSameExtensions)(N.identifier,this.extension.identifier)));if(!V.length)throw new Error(C.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...V),this.options.remove)for(const N of V)try{W.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(N)}catch(q){throw new Error(C.localize(9,null,(0,r.toErrorMessage)(q)))}}}class te extends a.AbstractExtensionTask{constructor(W,V,U){super(),this.extension=W,this.profileLocation=V,this.extensionsProfileScannerService=U}async doRun(W){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(ne[273],re([0,1,2,29,33,49,75,202,113,44,5,8,21,31,20]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const S={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let C=class extends D.Disposable{constructor(a,d,c,i,o,t,n,s){super(),this.userDataProfilesService=d,a.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===1),(0,P.migrateUnsupportedExtensions)(a,c,i,o,s),T.ExtensionStorageService.removeOutdatedExtensionVersions(a,n),this._register(t.createInstance(m))}};C=pe([K(0,E.INativeServerExtensionManagementService),K(1,h.IUserDataProfilesService),K(2,r.IExtensionGalleryService),K(3,T.IExtensionStorageService),K(4,r.IGlobalExtensionEnablementService),K(5,I.IInstantiationService),K(6,p.IStorageService),K(7,w.ILogService)],C),e.ExtensionsCleaner=C;let m=class extends D.Disposable{constructor(a,d,c,i,o){super(),this.extensionManagementService=a,this.userDataProfilesService=d,this.extensionsProfileScannerService=c,this.uriIdentityService=i,this.logService=o,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new D.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:a,removed:d,all:c}){try{await Promise.all(d.map(i=>i.extensionsResource?this.removeExtensionsFromProfile(i.extensionsResource):Promise.resolve()))}catch(i){this.logService.error(i)}if(c.length===1){this.profileModeDisposables.clear();const i=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{i.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{a.length&&(await Promise.all(a.map(i=>i.extensionsResource?this.populateExtensionsFromProfile(i.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new D.DisposableStore,this.profileModeDisposables.value.add((0,D.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(i=>this.onDidChangeProfiles(i))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(i=>this.onDidUninstallExtension(i))),await this.uninstallExtensionsNotInProfiles()))}catch(i){this.logService.error(i)}}async uninstallExtensionsNotInProfiles(){const d=(await this.extensionManagementService.getAllUserInstalled()).filter(c=>!this.profileExtensionsLocations.has(this.getKey(c.identifier,c.manifest.version)));d.length&&await Promise.all(d.map(c=>this.extensionManagementService.uninstall(c,S)))}async onDidInstallExtensions(a){for(const{local:d,profileLocation:c}of a)!d||!c||this.addExtensionWithKey(this.getKey(d.identifier,d.manifest.version),c)}async onDidUninstallExtension(a){!a.profileLocation||!a.version||this.removeExtensionWithKey(this.getKey(a.identifier,a.version),a.profileLocation)&&await this.uninstallExtensions([{identifier:a.identifier,version:a.version}])}async populateExtensionsFromProfile(a){const d=await this.extensionsProfileScannerService.scanProfileExtensions(a);for(const c of d)this.addExtensionWithKey(this.getKey(c.identifier,c.version),a)}async removeExtensionsFromProfile(a){const d=[];for(const c of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(c,a))continue;const i=this.fromKey(c);i&&d.push(i)}d.length&&await this.uninstallExtensions(d)}addExtensionWithKey(a,d){let c=this.profileExtensionsLocations.get(a);c||(c=[],this.profileExtensionsLocations.set(a,c)),c.push(d)}removeExtensionWithKey(a,d){const c=this.profileExtensionsLocations.get(a);if(c){const i=c.findIndex(o=>this.uriIdentityService.extUri.isEqual(o,d));i>-1&&c.splice(i,1)}return c?.length?!1:(this.profileExtensionsLocations.delete(a),!0)}async uninstallExtensions(a){const c=(await this.extensionManagementService.getAllUserInstalled()).filter(i=>a.some(o=>this.getKey(i.identifier,i.manifest.version)===this.getKey(o.identifier,o.version)));c.length&&await Promise.all(c.map(i=>this.extensionManagementService.uninstall(i,S)))}getKey(a,d){return`${b.ExtensionIdentifier.toKey(a.id)}@${d}`}fromKey(a){const[d,c]=(0,R.getIdAndVersion)(a);return c?{identifier:{id:d},version:c}:void 0}};m=pe([K(0,E.INativeServerExtensionManagementService),K(1,h.IUserDataProfilesService),K(2,L.IExtensionsProfileScannerService),K(3,v.IUriIdentityService),K(4,w.ILogService)],m)}),define(ne[282],re([0,1,89,37,38,9,2,22,17,7,39,137,195,273,196,188,189,271,177,180,18,200,92,219,93,210,14,216,250,251,29,179,252,113,94,175,13,191,193,56,5,186,97,187,58,69,205,8,98,59,99,25,45,21,253,104,24,105,106,107,50,223,108,225,231,75,110,26,73,261,243,244,76,262,265,266,267,268,269,77,245,103,218,72,233,207,232,102,215,31,235,4,236,181,198,197,74,249,20,49,194,60,254,213,222,246]),function(Q,e,D,r,R,L,T,P,E,b,I,w,p,v,h,S,C,m,g,a,d,c,i,o,t,n,s,u,l,f,y,A,O,_,M,k,F,$,x,J,H,G,z,j,Y,te,ce,W,V,U,N,q,B,Z,oe,X,ie,se,ue,he,ve,we,Ee,Pe,Ue,We,Ve,ze,ae,de,fe,Ce,Ie,Me,Re,$e,Ae,Fe,_e,ke,ee,le,me,ge,Se,be,De,Te,qe,Le,Ne,xe,Xe,Ze,Dt,vt,Rt,kt,St,yt,Lt,wt,Tt,At,_t,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ut extends T.Disposable{constructor(ye){super(),this.configuration=ye,this.server=this._register(new w.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ye=()=>this.dispose();process.once("exit",ye),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Oe="vscode:electron-main->shared-process=disposeWorker",je=(He,et)=>{this.onDisposeWorker(et)};D.ipcRenderer.on(Oe,je),this._register((0,T.toDisposable)(()=>D.ipcRenderer.removeListener(Oe,je)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,ze.registerConfiguration)(),ye.invokeFunction(Oe=>{const je=Oe.get(W.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(je)}),this._register((0,T.combinedDisposable)(ye.createInstance(p.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(h.LanguagePackCachedDataCleaner),ye.createInstance(m.UnusedWorkspaceStorageDataCleaner),ye.createInstance(C.LogsDataCleaner),ye.createInstance(S.LocalizationsUpdater),ye.createInstance(v.ExtensionsCleaner),ye.createInstance(Ot.UserDataProfilesCleaner)))}async initServices(){const ye=new z.ServiceCollection,Oe={_serviceBrand:void 0,...N.default};ye.set(q.IProductService,Oe);const je=new I.StaticRouter(Ye=>Ye==="main"),He=new j.MessagePortMainProcessService(this.server,je);ye.set(Y.IMainProcessService,He);const et=this.configuration.policiesData?new Lt.PolicyChannelClient(this.configuration.policiesData,He.getChannel("policy")):new wt.NullPolicyService;ye.set(wt.IPolicyService,et);const Be=new u.SharedProcessEnvironmentService(this.configuration.args,Oe);ye.set(s.INativeEnvironmentService,Be);const ot=new V.LogLevelChannelClient(this.server.getChannel("logLevel",je)),tt=new V.LoggerChannelClient(this.configuration.logLevel,ot.onDidChangeLogLevel,He.getChannel("logger"));ye.set(W.ILoggerService,tt);const lt=this._register(new W.MultiplexLogService([this._register(new W.ConsoleLogger(this.configuration.logLevel)),this._register(tt.createLogger((0,E.joinPath)(b.URI.file(Be.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new V.FollowerLogService(ot,lt));ye.set(W.ILogService,Ge),this.sharedProcessWorkerService=new qe.SharedProcessWorkerService(Ge),ye.set(Te.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Je=this._register(new $.FileService(Ge));ye.set(F.IFileService,Je);const ut=this._register(new x.DiskFileSystemProvider(Ge));Je.registerProvider(P.Schemas.file,ut);const ht=this._register(new Xe.FileUserDataProvider(P.Schemas.file,this._register(new Ze.DiskFileSystemProviderClient(He.getChannel(Ze.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:xe.isLinux})),P.Schemas.vscodeUserData,Ge));Je.registerProvider(P.Schemas.vscodeUserData,ht);const it=this._register(new Tt.UserDataProfilesNativeService(this.configuration.profiles,He,Be));ye.set(St.IUserDataProfilesService,it);const Ke=this._register(new c.ConfigurationService(it.defaultProfile.settingsResource,Je,et,Ge));ye.set(d.IConfigurationService,Ke);const rt=new oe.NativeStorageService(void 0,{defaultProfile:it.defaultProfile,currentProfile:it.defaultProfile},He,Be);ye.set(Z.IStorageService,rt),this._register((0,T.toDisposable)(()=>rt.flush())),await Promise.all([Ke.initialize(),rt.initialize()]),ye.set(Le.IUriIdentityService,new Ne.UriIdentityService(Je)),ye.set(B.IRequestService,new At.SharedProcessRequestService(He,Ke,Ge)),ye.set(g.IChecksumService,new J.SyncDescriptor(a.ChecksumService,void 0,!1)),ye.set(vt.IV8InspectProfilingService,new J.SyncDescriptor(Dt.InspectProfilingService,void 0,!1));const at=I.ProxyChannel.toService(He.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(U.INativeHostService,at),ye.set(t.IDownloadService,new J.SyncDescriptor(n.DownloadService,void 0,!0));const dt=this._register(new ee.ActiveWindowManager(at)),Ft=new I.StaticRouter(Ye=>dt.getActiveClientId().then(ft=>Ye===ft));ye.set(M.IExtensionRecommendationNotificationService,new k.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Ft)));let ct;const st=[],bt=(0,ve.isInternalTelemetry)(Oe,Ke);if((0,ve.supportsTelemetry)(Oe,Be)){const Ye=new ue.TelemetryLogAppender(tt,Be);st.push(Ye);const{installSourcePath:ft}=Be;if(Oe.aiConfig?.ariaKey){const Pt=new _t.OneDataSystemAppender(bt,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,T.toDisposable)(()=>Pt.flush())),st.push(Pt)}ct=new he.TelemetryService({appenders:st,commonProperties:(0,X.resolveCommonProperties)(Je,(0,r.release)(),(0,r.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,bt,ft),sendErrorTelemetry:!0,piiPaths:(0,ve.getPiiPathsFromEnvironment)(Be)},Ke,Oe)}else{ct=ve.NullTelemetryService;const Ye=ve.NullAppender;st.push(Ye)}this.server.registerChannel("telemetryAppender",new se.TelemetryAppenderChannel(st)),ye.set(ie.ITelemetryService,ct);const Nt=new we.CustomEndpointTelemetryService(Ke,ct,tt,Be,Oe);ye.set(ie.ICustomEndpointTelemetryService,Nt),ye.set(yt.IExtensionsProfileScannerService,new J.SyncDescriptor(yt.ExtensionsProfileScannerService,void 0,!0)),ye.set(Rt.IExtensionsScannerService,new J.SyncDescriptor(kt.ExtensionsScannerService,void 0,!0)),ye.set(_.INativeServerExtensionManagementService,new J.SyncDescriptor(_.ExtensionManagementService,void 0,!0)),ye.set(y.IExtensionGalleryService,new J.SyncDescriptor(f.ExtensionGalleryService,void 0,!0)),ye.set(y.IExtensionTipsService,new J.SyncDescriptor(O.ExtensionTipsService,void 0,!1)),ye.set(te.ILanguagePackService,new J.SyncDescriptor(ce.NativeLanguagePackService,void 0,!1)),ye.set(i.IDiagnosticsService,new J.SyncDescriptor(o.DiagnosticsService,void 0,!1)),ye.set(ae.IUserDataSyncAccountService,new J.SyncDescriptor(ae.UserDataSyncAccountService,void 0,!0)),ye.set(ze.IUserDataSyncLogService,new J.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),ye.set(ze.IUserDataSyncUtilService,new fe.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ye=>Ye.ctx!=="main"))),ye.set(y.IGlobalExtensionEnablementService,new J.SyncDescriptor(l.GlobalExtensionEnablementService,void 0,!1)),ye.set(Ve.IIgnoredExtensionsManagementService,new J.SyncDescriptor(Ve.IgnoredExtensionsManagementService,void 0,!0)),ye.set(We.IExtensionStorageService,new J.SyncDescriptor(We.ExtensionStorageService)),ye.set(ze.IUserDataSyncStoreManagementService,new J.SyncDescriptor(Ae.UserDataSyncStoreManagementService,void 0,!0)),ye.set(ze.IUserDataSyncStoreService,new J.SyncDescriptor(Ae.UserDataSyncStoreService,void 0,!0)),ye.set(Ie.IUserDataSyncMachinesService,new J.SyncDescriptor(Ie.UserDataSyncMachinesService,void 0,!0)),ye.set(ze.IUserDataSyncBackupStoreService,new J.SyncDescriptor(de.UserDataSyncBackupStoreService,void 0,!1)),ye.set(ze.IUserDataSyncEnablementService,new J.SyncDescriptor(Me.UserDataSyncEnablementService,void 0,!0)),ye.set(ze.IUserDataSyncService,new J.SyncDescriptor(Re.UserDataSyncService,void 0,!1)),ye.set(ke.IUserDataSyncProfilesStorageService,new J.SyncDescriptor(_e.UserDataSyncProfilesStorageService,void 0,!0));const Ct=new Ue.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ke.getValue("terminal.integrated.persistentSessionScrollback")??100},Ke,Be,Ge);return Ct.initialize(),ye.set(Pe.ILocalPtyService,this._register(Ct)),ye.set(le.ISignService,new J.SyncDescriptor(me.SignService,void 0,!1)),ye.set(ge.ISharedTunnelsService,new J.SyncDescriptor(Se.SharedTunnelsService)),ye.set(be.ISharedProcessTunnelService,new J.SyncDescriptor(De.SharedProcessTunnelService)),new G.InstantiationService(ye)}initChannels(ye){const Oe=new A.ExtensionManagementChannel(ye.get(y.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const je=I.ProxyChannel.fromService(ye.get(te.ILanguagePackService));this.server.registerChannel("languagePacks",je);const He=I.ProxyChannel.fromService(ye.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",He);const et=new A.ExtensionTipsChannel(ye.get(y.IExtensionTipsService));this.server.registerChannel("extensionTipsService",et);const Be=I.ProxyChannel.fromService(ye.get(g.IChecksumService));this.server.registerChannel("checksum",Be);const ot=I.ProxyChannel.fromService(ye.get(vt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",ot);const tt=new fe.UserDataSyncMachinesServiceChannel(ye.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",tt);const lt=I.ProxyChannel.fromService(ye.get(ie.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",lt);const Ge=new fe.UserDataSyncAccountServiceChannel(ye.get(ae.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Je=new fe.UserDataSyncStoreManagementServiceChannel(ye.get(ze.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Je);const ut=new $e.UserDataSyncChannel(ye.get(ze.IUserDataSyncService),ye.get(St.IUserDataProfilesService),ye.get(W.ILogService));this.server.registerChannel("userDataSync",ut);const ht=this._register(ye.get(H.IInstantiationService).createInstance(Fe.UserDataAutoSyncService)),it=new fe.UserDataAutoSyncChannel(ht);this.server.registerChannel("userDataAutoSync",it);const Ke=ye.get(Pe.ILocalPtyService),rt=I.ProxyChannel.fromService(Ke);this.server.registerChannel(Ee.TerminalIpcChannels.LocalPty,rt);const at=I.ProxyChannel.fromService(ye.get(be.ISharedProcessTunnelService));this.server.registerChannel(be.ipcSharedProcessTunnelChannelName,at);const dt=I.ProxyChannel.fromService(ye.get(Te.ISharedProcessWorkerService));this.server.registerChannel(Te.ipcSharedProcessWorkerChannelName,dt)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Oe=>{(0,L.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Oe=>{const je=(0,R.toErrorMessage)(Oe,!0);!je||ye.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function Mt(Et){const ye=new Ut(Et);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Mt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a829fbb91cbae44afb6a389341a0763fb3a6ac6f/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
