/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/base/common/codicons","vs/base/common/errors","vs/nls","vs/base/common/arrays","vs/base/browser/browser","vs/base/common/uri","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/keyboardEvent","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/color","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/objects","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/platform/instantiation/common/instantiation","vs/base/common/buffer","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/network","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/range","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/map","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/list/listWidget","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/toggle/toggle","vs/platform/instantiation/common/descriptors","vs/platform/theme/common/themeService","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],be=function(Q){for(var t=[],E=0,i=Q.length;E<i;E++)t[E]=pe[Q[E]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function Ut(Q){if(Array.isArray(Q)){for(var t=0,E=Array(Q.length);t<Q.length;t++)E[t]=Q[t];return E}else return Array.from(Q)}var Vt=Object.hasOwnProperty,Lt=Object.setPrototypeOf,$t=Object.isFrozen,Kt=Object.getPrototypeOf,qt=Object.getOwnPropertyDescriptor,tt=Object.freeze,ot=Object.seal,xt=Object.create,Nt=typeof Reflect<"u"&&Reflect,vt=Nt.apply,Et=Nt.construct;vt||(vt=function(t,E,i){return t.apply(E,i)}),tt||(tt=function(t){return t}),ot||(ot=function(t){return t}),Et||(Et=function(t,E){return new(Function.prototype.bind.apply(t,[null].concat(Ut(E))))});var jt=nt(Array.prototype.forEach),kt=nt(Array.prototype.pop),pt=nt(Array.prototype.push),ut=nt(String.prototype.toLowerCase),Rt=nt(String.prototype.match),lt=nt(String.prototype.replace),Gt=nt(String.prototype.indexOf),Yt=nt(String.prototype.trim),at=nt(RegExp.prototype.test),Pt=Xt(TypeError);function nt(Q){return function(t){for(var E=arguments.length,i=Array(E>1?E-1:0),W=1;W<E;W++)i[W-1]=arguments[W];return vt(Q,t,i)}}function Xt(Q){return function(){for(var t=arguments.length,E=Array(t),i=0;i<t;i++)E[i]=arguments[i];return Et(Q,E)}}function Be(Q,t){Lt&&Lt(Q,null);for(var E=t.length;E--;){var i=t[E];if(typeof i=="string"){var W=ut(i);W!==i&&($t(t)||(t[E]=W),i=W)}Q[i]=!0}return Q}function ct(Q){var t=xt(null),E=void 0;for(E in Q)vt(Vt,Q,[E])&&(t[E]=Q[E]);return t}function Dt(Q,t){for(;Q!==null;){var E=qt(Q,t);if(E){if(E.get)return nt(E.get);if(typeof E.value=="function")return nt(E.value)}Q=Kt(Q)}function i(W){return console.warn("fallback value for",W),null}return i}var Mt=tt(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Ct=tt(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),_t=tt(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Zt=tt(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),St=tt(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),Qt=tt(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ot=tt(["#text"]),Bt=tt(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),At=tt(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Ht=tt(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=tt(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),Jt=ot(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ei=ot(/<%[\s\S]*|[\s\S]*%>/gm),ti=ot(/^data-[\-\w.\u00B7-\uFFFF]/),ii=ot(/^aria-[\-\w]+$/),ni=ot(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),si=ot(/^(?:\w+script|data):/i),ri=ot(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),bt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(Q){return typeof Q}:function(Q){return Q&&typeof Symbol=="function"&&Q.constructor===Symbol&&Q!==Symbol.prototype?"symbol":typeof Q};function rt(Q){if(Array.isArray(Q)){for(var t=0,E=Array(Q.length);t<Q.length;t++)E[t]=Q[t];return E}else return Array.from(Q)}var oi=function(){return typeof window>"u"?null:window},ai=function(t,E){if((typeof t>"u"?"undefined":bt(t))!=="object"||typeof t.createPolicy!="function")return null;var i=null,W="data-tt-policy-suffix";E.currentScript&&E.currentScript.hasAttribute(W)&&(i=E.currentScript.getAttribute(W));var O="dompurify"+(i?"#"+i:"");try{return t.createPolicy(O,{createHTML:function(y){return y}})}catch{return console.warn("TrustedTypes policy "+O+" could not be created."),null}};function Wt(){var Q=arguments.length>0&&arguments[0]!==void 0?arguments[0]:oi(),t=function(ue){return Wt(ue)};if(t.version="2.3.1",t.removed=[],!Q||!Q.document||Q.document.nodeType!==9)return t.isSupported=!1,t;var E=Q.document,i=Q.document,W=Q.DocumentFragment,O=Q.HTMLTemplateElement,C=Q.Node,y=Q.Element,d=Q.NodeFilter,c=Q.NamedNodeMap,g=c===void 0?Q.NamedNodeMap||Q.MozNamedAttrMap:c,L=Q.Text,o=Q.Comment,s=Q.DOMParser,e=Q.trustedTypes,m=y.prototype,v=Dt(m,"cloneNode"),w=Dt(m,"nextSibling"),D=Dt(m,"childNodes"),a=Dt(m,"parentNode");if(typeof O=="function"){var u=i.createElement("template");u.content&&u.content.ownerDocument&&(i=u.content.ownerDocument)}var p=ai(e,E),S=p&&Z?p.createHTML(""):"",T=i,_=T.implementation,r=T.createNodeIterator,n=T.createDocumentFragment,l=T.getElementsByTagName,b=E.importNode,f={};try{f=ct(i).documentMode?i.documentMode:{}}catch{}var z={};t.isSupported=typeof a=="function"&&_&&typeof _.createHTMLDocument<"u"&&f!==9;var $=Jt,X=ei,J=ti,ge=ii,re=si,me=ri,ae=ni,he=null,Se=Be({},[].concat(rt(Mt),rt(Ct),rt(_t),rt(St),rt(Ot))),te=null,De=Be({},[].concat(rt(Bt),rt(At),rt(Ht),rt(yt))),se=null,ie=null,ce=!0,ne=!0,F=!1,V=!1,j=!1,k=!1,h=!1,I=!1,U=!1,K=!0,Z=!1,N=!0,R=!0,H=!1,A={},P=null,M=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),B=null,q=Be({},["audio","video","img","source","image","track"]),ee=null,le=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),de="http://www.w3.org/1998/Math/MathML",ye="http://www.w3.org/2000/svg",Ee="http://www.w3.org/1999/xhtml",Re=Ee,Le=!1,ve=null,Pe=i.createElement("form"),ke=function(ue){ve&&ve===ue||((!ue||(typeof ue>"u"?"undefined":bt(ue))!=="object")&&(ue={}),ue=ct(ue),he="ALLOWED_TAGS"in ue?Be({},ue.ALLOWED_TAGS):Se,te="ALLOWED_ATTR"in ue?Be({},ue.ALLOWED_ATTR):De,ee="ADD_URI_SAFE_ATTR"in ue?Be(ct(le),ue.ADD_URI_SAFE_ATTR):le,B="ADD_DATA_URI_TAGS"in ue?Be(ct(q),ue.ADD_DATA_URI_TAGS):q,P="FORBID_CONTENTS"in ue?Be({},ue.FORBID_CONTENTS):M,se="FORBID_TAGS"in ue?Be({},ue.FORBID_TAGS):{},ie="FORBID_ATTR"in ue?Be({},ue.FORBID_ATTR):{},A="USE_PROFILES"in ue?ue.USE_PROFILES:!1,ce=ue.ALLOW_ARIA_ATTR!==!1,ne=ue.ALLOW_DATA_ATTR!==!1,F=ue.ALLOW_UNKNOWN_PROTOCOLS||!1,V=ue.SAFE_FOR_TEMPLATES||!1,j=ue.WHOLE_DOCUMENT||!1,I=ue.RETURN_DOM||!1,U=ue.RETURN_DOM_FRAGMENT||!1,K=ue.RETURN_DOM_IMPORT!==!1,Z=ue.RETURN_TRUSTED_TYPE||!1,h=ue.FORCE_BODY||!1,N=ue.SANITIZE_DOM!==!1,R=ue.KEEP_CONTENT!==!1,H=ue.IN_PLACE||!1,ae=ue.ALLOWED_URI_REGEXP||ae,Re=ue.NAMESPACE||Ee,V&&(ne=!1),U&&(I=!0),A&&(he=Be({},[].concat(rt(Ot))),te=[],A.html===!0&&(Be(he,Mt),Be(te,Bt)),A.svg===!0&&(Be(he,Ct),Be(te,At),Be(te,yt)),A.svgFilters===!0&&(Be(he,_t),Be(te,At),Be(te,yt)),A.mathMl===!0&&(Be(he,St),Be(te,Ht),Be(te,yt))),ue.ADD_TAGS&&(he===Se&&(he=ct(he)),Be(he,ue.ADD_TAGS)),ue.ADD_ATTR&&(te===De&&(te=ct(te)),Be(te,ue.ADD_ATTR)),ue.ADD_URI_SAFE_ATTR&&Be(ee,ue.ADD_URI_SAFE_ATTR),ue.FORBID_CONTENTS&&(P===M&&(P=ct(P)),Be(P,ue.FORBID_CONTENTS)),R&&(he["#text"]=!0),j&&Be(he,["html","head","body"]),he.table&&(Be(he,["tbody"]),delete se.tbody),tt&&tt(ue),ve=ue)},je=Be({},["mi","mo","mn","ms","mtext"]),He=Be({},["foreignobject","desc","title","annotation-xml"]),Ue=Be({},Ct);Be(Ue,_t),Be(Ue,Zt);var Je=Be({},St);Be(Je,Qt);var it=function(ue){var _e=a(ue);(!_e||!_e.tagName)&&(_e={namespaceURI:Ee,tagName:"template"});var Ne=ut(ue.tagName),We=ut(_e.tagName);if(ue.namespaceURI===ye)return _e.namespaceURI===Ee?Ne==="svg":_e.namespaceURI===de?Ne==="svg"&&(We==="annotation-xml"||je[We]):Boolean(Ue[Ne]);if(ue.namespaceURI===de)return _e.namespaceURI===Ee?Ne==="math":_e.namespaceURI===ye?Ne==="math"&&He[We]:Boolean(Je[Ne]);if(ue.namespaceURI===Ee){if(_e.namespaceURI===ye&&!He[We]||_e.namespaceURI===de&&!je[We])return!1;var Ye=Be({},["title","style","font","a","script"]);return!Je[Ne]&&(Ye[Ne]||!Ue[Ne])}return!1},Me=function(ue){pt(t.removed,{element:ue});try{ue.parentNode.removeChild(ue)}catch{try{ue.outerHTML=S}catch{ue.remove()}}},qe=function(ue,_e){try{pt(t.removed,{attribute:_e.getAttributeNode(ue),from:_e})}catch{pt(t.removed,{attribute:null,from:_e})}if(_e.removeAttribute(ue),ue==="is"&&!te[ue])if(I||U)try{Me(_e)}catch{}else try{_e.setAttribute(ue,"")}catch{}},x=function(ue){var _e=void 0,Ne=void 0;if(h)ue="<remove></remove>"+ue;else{var We=Rt(ue,/^[\r\n\t ]+/);Ne=We&&We[0]}var Ye=p?p.createHTML(ue):ue;if(Re===Ee)try{_e=new s().parseFromString(Ye,"text/html")}catch{}if(!_e||!_e.documentElement){_e=_.createDocument(Re,"template",null);try{_e.documentElement.innerHTML=Le?"":Ye}catch{}}var Xe=_e.body||_e.documentElement;return ue&&Ne&&Xe.insertBefore(i.createTextNode(Ne),Xe.childNodes[0]||null),Re===Ee?l.call(_e,j?"html":"body")[0]:j?_e.documentElement:Xe},oe=function(ue){return r.call(ue.ownerDocument||ue,ue,d.SHOW_ELEMENT|d.SHOW_COMMENT|d.SHOW_TEXT,null,!1)},we=function(ue){return ue instanceof L||ue instanceof o?!1:typeof ue.nodeName!="string"||typeof ue.textContent!="string"||typeof ue.removeChild!="function"||!(ue.attributes instanceof g)||typeof ue.removeAttribute!="function"||typeof ue.setAttribute!="function"||typeof ue.namespaceURI!="string"||typeof ue.insertBefore!="function"},Ce=function(ue){return(typeof C>"u"?"undefined":bt(C))==="object"?ue instanceof C:ue&&(typeof ue>"u"?"undefined":bt(ue))==="object"&&typeof ue.nodeType=="number"&&typeof ue.nodeName=="string"},Ae=function(ue,_e,Ne){!z[ue]||jt(z[ue],function(We){We.call(t,_e,Ne,ve)})},Oe=function(ue){var _e=void 0;if(Ae("beforeSanitizeElements",ue,null),we(ue)||Rt(ue.nodeName,/[\u0080-\uFFFF]/))return Me(ue),!0;var Ne=ut(ue.nodeName);if(Ae("uponSanitizeElement",ue,{tagName:Ne,allowedTags:he}),!Ce(ue.firstElementChild)&&(!Ce(ue.content)||!Ce(ue.content.firstElementChild))&&at(/<[/\w]/g,ue.innerHTML)&&at(/<[/\w]/g,ue.textContent)||Ne==="select"&&at(/<template/i,ue.innerHTML))return Me(ue),!0;if(!he[Ne]||se[Ne]){if(R&&!P[Ne]){var We=a(ue)||ue.parentNode,Ye=D(ue)||ue.childNodes;if(Ye&&We)for(var Xe=Ye.length,Ze=Xe-1;Ze>=0;--Ze)We.insertBefore(v(Ye[Ze],!0),w(ue))}return Me(ue),!0}return ue instanceof y&&!it(ue)||(Ne==="noscript"||Ne==="noembed")&&at(/<\/no(script|embed)/i,ue.innerHTML)?(Me(ue),!0):(V&&ue.nodeType===3&&(_e=ue.textContent,_e=lt(_e,$," "),_e=lt(_e,X," "),ue.textContent!==_e&&(pt(t.removed,{element:ue.cloneNode()}),ue.textContent=_e)),Ae("afterSanitizeElements",ue,null),!1)},$e=function(ue,_e,Ne){if(N&&(_e==="id"||_e==="name")&&(Ne in i||Ne in Pe))return!1;if(!(ne&&!ie[_e]&&at(J,_e))){if(!(ce&&at(ge,_e))){if(!te[_e]||ie[_e])return!1;if(!ee[_e]){if(!at(ae,lt(Ne,me,""))){if(!((_e==="src"||_e==="xlink:href"||_e==="href")&&ue!=="script"&&Gt(Ne,"data:")===0&&B[ue])){if(!(F&&!at(re,lt(Ne,me,"")))){if(Ne)return!1}}}}}}return!0},Ge=function(ue){var _e=void 0,Ne=void 0,We=void 0,Ye=void 0;Ae("beforeSanitizeAttributes",ue,null);var Xe=ue.attributes;if(!!Xe){var Ze={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:te};for(Ye=Xe.length;Ye--;){_e=Xe[Ye];var st=_e,ht=st.name,dt=st.namespaceURI;if(Ne=Yt(_e.value),We=ut(ht),Ze.attrName=We,Ze.attrValue=Ne,Ze.keepAttr=!0,Ze.forceKeepAttr=void 0,Ae("uponSanitizeAttribute",ue,Ze),Ne=Ze.attrValue,!Ze.forceKeepAttr&&(qe(ht,ue),!!Ze.keepAttr)){if(at(/\/>/i,Ne)){qe(ht,ue);continue}V&&(Ne=lt(Ne,$," "),Ne=lt(Ne,X," "));var Tt=ue.nodeName.toLowerCase();if(!!$e(Tt,We,Ne))try{dt?ue.setAttributeNS(dt,ht,Ne):ue.setAttribute(ht,Ne),kt(t.removed)}catch{}}}Ae("afterSanitizeAttributes",ue,null)}},et=function Ie(ue){var _e=void 0,Ne=oe(ue);for(Ae("beforeSanitizeShadowDOM",ue,null);_e=Ne.nextNode();)Ae("uponSanitizeShadowNode",_e,null),!Oe(_e)&&(_e.content instanceof W&&Ie(_e.content),Ge(_e));Ae("afterSanitizeShadowDOM",ue,null)};return t.sanitize=function(Ie,ue){var _e=void 0,Ne=void 0,We=void 0,Ye=void 0,Xe=void 0;if(Le=!Ie,Le&&(Ie="<!-->"),typeof Ie!="string"&&!Ce(Ie)){if(typeof Ie.toString!="function")throw Pt("toString is not a function");if(Ie=Ie.toString(),typeof Ie!="string")throw Pt("dirty is not a string, aborting")}if(!t.isSupported){if(bt(Q.toStaticHTML)==="object"||typeof Q.toStaticHTML=="function"){if(typeof Ie=="string")return Q.toStaticHTML(Ie);if(Ce(Ie))return Q.toStaticHTML(Ie.outerHTML)}return Ie}if(k||ke(ue),t.removed=[],typeof Ie=="string"&&(H=!1),!H)if(Ie instanceof C)_e=x("<!---->"),Ne=_e.ownerDocument.importNode(Ie,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?_e=Ne:_e.appendChild(Ne);else{if(!I&&!V&&!j&&Ie.indexOf("<")===-1)return p&&Z?p.createHTML(Ie):Ie;if(_e=x(Ie),!_e)return I?null:S}_e&&h&&Me(_e.firstChild);for(var Ze=oe(H?Ie:_e);We=Ze.nextNode();)We.nodeType===3&&We===Ye||Oe(We)||(We.content instanceof W&&et(We.content),Ge(We),Ye=We);if(Ye=null,H)return Ie;if(I){if(U)for(Xe=n.call(_e.ownerDocument);_e.firstChild;)Xe.appendChild(_e.firstChild);else Xe=_e;return K&&(Xe=b.call(E,Xe,!0)),Xe}var st=j?_e.outerHTML:_e.innerHTML;return V&&(st=lt(st,$," "),st=lt(st,X," ")),p&&Z?p.createHTML(st):st},t.setConfig=function(Ie){ke(Ie),k=!0},t.clearConfig=function(){ve=null,k=!1},t.isValidAttribute=function(Ie,ue,_e){ve||ke({});var Ne=ut(Ie),We=ut(ue);return $e(Ne,We,_e)},t.addHook=function(Ie,ue){typeof ue=="function"&&(z[Ie]=z[Ie]||[],pt(z[Ie],ue))},t.removeHook=function(Ie){z[Ie]&&kt(z[Ie])},t.removeHooks=function(Ie){z[Ie]&&(z[Ie]=[])},t.removeAllHooks=function(){z={}},t}var li=Wt();define("vs/base/browser/dompurify/dompurify",function(){return li}),define(pe[40],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class E{constructor(C){this.domNode=C,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(C){const y=i(C);this._maxWidth!==y&&(this._maxWidth=y,this.domNode.style.maxWidth=this._maxWidth)}setWidth(C){const y=i(C);this._width!==y&&(this._width=y,this.domNode.style.width=this._width)}setHeight(C){const y=i(C);this._height!==y&&(this._height=y,this.domNode.style.height=this._height)}setTop(C){const y=i(C);this._top!==y&&(this._top=y,this.domNode.style.top=this._top)}setLeft(C){const y=i(C);this._left!==y&&(this._left=y,this.domNode.style.left=this._left)}setBottom(C){const y=i(C);this._bottom!==y&&(this._bottom=y,this.domNode.style.bottom=this._bottom)}setRight(C){const y=i(C);this._right!==y&&(this._right=y,this.domNode.style.right=this._right)}setFontFamily(C){this._fontFamily!==C&&(this._fontFamily=C,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(C){this._fontWeight!==C&&(this._fontWeight=C,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(C){const y=i(C);this._fontSize!==y&&(this._fontSize=y,this.domNode.style.fontSize=this._fontSize)}setFontStyle(C){this._fontStyle!==C&&(this._fontStyle=C,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(C){this._fontFeatureSettings!==C&&(this._fontFeatureSettings=C,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setTextDecoration(C){this._textDecoration!==C&&(this._textDecoration=C,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(C){const y=i(C);this._lineHeight!==y&&(this._lineHeight=y,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(C){const y=i(C);this._letterSpacing!==y&&(this._letterSpacing=y,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(C){this._className!==C&&(this._className=C,this.domNode.className=this._className)}toggleClassName(C,y){this.domNode.classList.toggle(C,y),this._className=this.domNode.className}setDisplay(C){this._display!==C&&(this._display=C,this.domNode.style.display=this._display)}setPosition(C){this._position!==C&&(this._position=C,this.domNode.style.position=this._position)}setVisibility(C){this._visibility!==C&&(this._visibility=C,this.domNode.style.visibility=this._visibility)}setColor(C){this._color!==C&&(this._color=C,this.domNode.style.color=this._color)}setBackgroundColor(C){this._backgroundColor!==C&&(this._backgroundColor=C,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(C){this._layerHint!==C&&(this._layerHint=C,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(C){this._boxShadow!==C&&(this._boxShadow=C,this.domNode.style.boxShadow=C)}setContain(C){this._contain!==C&&(this._contain=C,this.domNode.style.contain=this._contain)}setAttribute(C,y){this.domNode.setAttribute(C,y)}removeAttribute(C){this.domNode.removeAttribute(C)}appendChild(C){this.domNode.appendChild(C.domNode)}removeChild(C){this.domNode.removeChild(C.domNode)}}t.FastDomNode=E;function i(O){return typeof O=="number"?`${O}px`:O}function W(O){return new E(O)}t.createFastDomNode=W}),define(pe[66],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let E=!1,i=null;function W(C){if(!C.parent||C.parent===C)return null;try{const y=C.location,d=C.parent.location;if(y.origin!=="null"&&d.origin!=="null"&&y.origin!==d.origin)return E=!0,null}catch{return E=!0,null}return C.parent}class O{static getSameOriginWindowChain(){if(!i){i=[];let y=window,d;do d=W(y),d?i.push({window:y,iframeElement:y.frameElement||null}):i.push({window:y,iframeElement:null}),y=d;while(y)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),E}static getPositionOfChildWindowRelativeToAncestorWindow(y,d){if(!d||y===d)return{top:0,left:0};let c=0,g=0;const L=this.getSameOriginWindowChain();for(const o of L){if(c+=o.window.scrollY,g+=o.window.scrollX,o.window===d||!o.iframeElement)break;const s=o.iframeElement.getBoundingClientRect();c+=s.top,g+=s.left}return{top:c,left:g}}}t.IframeUtils=O}),define(pe[67],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var E;(function(O){O[O.Copy=0]="Copy",O[O.Move=1]="Move"})(E=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class i extends Error{constructor(C,y){super(`ListError [${C}] ${y}`)}}t.ListError=i;class W{constructor(){this.cache=new WeakMap}getHeight(C){return this.cache.get(C)??this.estimateHeight(C)}setDynamicHeight(C,y){y>0&&this.cache.set(C,y)}}t.CachedListVirtualDelegate=W}),define(pe[68],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class E{constructor(W){this.spliceables=W}splice(W,O,C){this.spliceables.forEach(y=>y.splice(W,O,C))}}t.CombinedSpliceable=E}),define(pe[41],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const E=20;class i{constructor(O,C,y,d,c,g){this._scrollbarSize=Math.round(C),this._oppositeScrollbarSize=Math.round(y),this._arrowSize=Math.round(O),this._visibleSize=d,this._scrollSize=c,this._scrollPosition=g,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new i(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(O){const C=Math.round(O);return this._visibleSize!==C?(this._visibleSize=C,this._refreshComputedValues(),!0):!1}setScrollSize(O){const C=Math.round(O);return this._scrollSize!==C?(this._scrollSize=C,this._refreshComputedValues(),!0):!1}setScrollPosition(O){const C=Math.round(O);return this._scrollPosition!==C?(this._scrollPosition=C,this._refreshComputedValues(),!0):!1}setScrollbarSize(O){this._scrollbarSize=Math.round(O)}setOppositeScrollbarSize(O){this._oppositeScrollbarSize=Math.round(O)}static _computeValues(O,C,y,d,c){const g=Math.max(0,y-O),L=Math.max(0,g-2*C),o=d>0&&d>y;if(!o)return{computedAvailableSize:Math.round(g),computedIsNeeded:o,computedSliderSize:Math.round(L),computedSliderRatio:0,computedSliderPosition:0};const s=Math.round(Math.max(E,Math.floor(y*L/d))),e=(L-s)/(d-y),m=c*e;return{computedAvailableSize:Math.round(g),computedIsNeeded:o,computedSliderSize:Math.round(s),computedSliderRatio:e,computedSliderPosition:Math.round(m)}}_refreshComputedValues(){const O=i._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=O.computedAvailableSize,this._computedIsNeeded=O.computedIsNeeded,this._computedSliderSize=O.computedSliderSize,this._computedSliderRatio=O.computedSliderRatio,this._computedSliderPosition=O.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(O){if(!this._computedIsNeeded)return 0;const C=O-this._arrowSize-this._computedSliderSize/2;return Math.round(C/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(O){if(!this._computedIsNeeded)return 0;const C=O-this._arrowSize;let y=this._scrollPosition;return C<this._computedSliderPosition?y-=this._visibleSize:y+=this._visibleSize,y}getDesiredScrollPositionFromDelta(O){if(!this._computedIsNeeded)return 0;const C=this._computedSliderPosition+O;return Math.round(C/this._computedSliderRatio)}}t.ScrollbarState=i}),define(pe[23],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.TreeVisibility=void 0;var E;(function(y){y[y.Hidden=0]="Hidden",y[y.Visible=1]="Visible",y[y.Recurse=2]="Recurse"})(E=t.TreeVisibility||(t.TreeVisibility={}));var i;(function(y){y[y.Unknown=0]="Unknown",y[y.Twistie=1]="Twistie",y[y.Element=2]="Element",y[y.Filter=3]="Filter"})(i=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var W;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(W=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(y=!1){return{accept:!0,bubble:0,autoExpand:y}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(y=!1){return{accept:!0,bubble:0,effect:0,autoExpand:y}}};class O extends Error{constructor(d,c){super(`TreeError [${d}] ${c}`)}}t.TreeError=O;class C{constructor(d){this.fn=d,this._map=new WeakMap}map(d){let c=this._map.get(d);return c||(c=this.fn(d),this._map.set(d,c)),c}}t.WeakMapper=C}),define(pe[11],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CSSIcon=t.getClassNamesArray=t.Codicon=t.getCodiconAriaLabel=void 0;function E(C){return C?C.replace(/\$\((.*?)\)/g,(y,d)=>` ${d} `).trim():""}t.getCodiconAriaLabel=E;class i{constructor(y,d,c){this.id=y,this.definition=d,this.description=c,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}t.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function W(C,y){const d=["codicon","codicon-"+C];return y&&d.push("codicon-modifier-"+y),d}t.getClassNamesArray=W;var O;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function d(L){if(L instanceof i)return["codicon","codicon-"+L.id];const o=y.exec(L.id);if(!o)return d(i.error);const[,s,e]=o,m=["codicon","codicon-"+s];return e&&m.push("codicon-modifier-"+e.substr(1)),m}C.asClassNameArray=d;function c(L){return d(L).join(" ")}C.asClassName=c;function g(L){return"."+d(L).join(".")}C.asCSSSelector=g})(O=t.CSSIcon||(t.CSSIcon={}))}),define(pe[69],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function E(C,y){const d=Object.create(null);for(const c of C){const g=y(c);let L=d[g];L||(L=d[g]=[]),L.push(c)}return d}t.groupBy=E;function i(C,y){const d=[],c=[];for(const g of C)y.has(g)||d.push(g);for(const g of y)C.has(g)||c.push(g);return{removed:d,added:c}}t.diffSets=i;function W(C,y){const d=[],c=[];for(const[g,L]of C)y.has(g)||d.push(L);for(const[g,L]of y)C.has(g)||c.push(L);return{removed:d,added:c}}t.diffMaps=W;class O{constructor(){this.map=new Map}add(y,d){let c=this.map.get(y);c||(c=new Set,this.map.set(y,c)),c.add(d)}delete(y,d){const c=this.map.get(y);!c||(c.delete(d),c.size===0&&this.map.delete(y))}forEach(y,d){const c=this.map.get(y);!c||c.forEach(d)}}t.SetMap=O}),define(pe[24],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function E(y,d){const c=Math.pow(10,d);return Math.round(y*c)/c}class i{constructor(d,c,g,L=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=E(Math.max(Math.min(1,L),0),3)}static equals(d,c){return d.r===c.r&&d.g===c.g&&d.b===c.b&&d.a===c.a}}t.RGBA=i;class W{constructor(d,c,g,L){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=E(Math.max(Math.min(1,c),0),3),this.l=E(Math.max(Math.min(1,g),0),3),this.a=E(Math.max(Math.min(1,L),0),3)}static equals(d,c){return d.h===c.h&&d.s===c.s&&d.l===c.l&&d.a===c.a}static fromRGBA(d){const c=d.r/255,g=d.g/255,L=d.b/255,o=d.a,s=Math.max(c,g,L),e=Math.min(c,g,L);let m=0,v=0;const w=(e+s)/2,D=s-e;if(D>0){switch(v=Math.min(w<=.5?D/(2*w):D/(2-2*w),1),s){case c:m=(g-L)/D+(g<L?6:0);break;case g:m=(L-c)/D+2;break;case L:m=(c-g)/D+4;break}m*=60,m=Math.round(m)}return new W(m,v,w,o)}static _hue2rgb(d,c,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?d+(c-d)*6*g:g<1/2?c:g<2/3?d+(c-d)*(2/3-g)*6:d}static toRGBA(d){const c=d.h/360,{s:g,l:L,a:o}=d;let s,e,m;if(g===0)s=e=m=L;else{const v=L<.5?L*(1+g):L+g-L*g,w=2*L-v;s=W._hue2rgb(w,v,c+1/3),e=W._hue2rgb(w,v,c),m=W._hue2rgb(w,v,c-1/3)}return new i(Math.round(s*255),Math.round(e*255),Math.round(m*255),o)}}t.HSLA=W;class O{constructor(d,c,g,L){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=E(Math.max(Math.min(1,c),0),3),this.v=E(Math.max(Math.min(1,g),0),3),this.a=E(Math.max(Math.min(1,L),0),3)}static equals(d,c){return d.h===c.h&&d.s===c.s&&d.v===c.v&&d.a===c.a}static fromRGBA(d){const c=d.r/255,g=d.g/255,L=d.b/255,o=Math.max(c,g,L),s=Math.min(c,g,L),e=o-s,m=o===0?0:e/o;let v;return e===0?v=0:o===c?v=((g-L)/e%6+6)%6:o===g?v=(L-c)/e+2:v=(c-g)/e+4,new O(Math.round(v*60),m,o,d.a)}static toRGBA(d){const{h:c,s:g,v:L,a:o}=d,s=L*g,e=s*(1-Math.abs(c/60%2-1)),m=L-s;let[v,w,D]=[0,0,0];return c<60?(v=s,w=e):c<120?(v=e,w=s):c<180?(w=s,D=e):c<240?(w=e,D=s):c<300?(v=e,D=s):c<=360&&(v=s,D=e),v=Math.round((v+m)*255),w=Math.round((w+m)*255),D=Math.round((D+m)*255),new i(v,w,D,o)}}t.HSVA=O;class C{static fromHex(d){return C.Format.CSS.parseHex(d)||C.red}get hsla(){return this._hsla?this._hsla:W.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:O.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof i)this.rgba=d;else if(d instanceof W)this._hsla=d,this.rgba=W.toRGBA(d);else if(d instanceof O)this._hsva=d,this.rgba=O.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&i.equals(this.rgba,d.rgba)&&W.equals(this.hsla,d.hsla)&&O.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=C._relativeLuminanceForComponent(this.rgba.r),c=C._relativeLuminanceForComponent(this.rgba.g),g=C._relativeLuminanceForComponent(this.rgba.b),L=.2126*d+.7152*c+.0722*g;return E(L,4)}static _relativeLuminanceForComponent(d){const c=d/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(d){const c=this.getRelativeLuminance(),g=d.getRelativeLuminance();return c>g?(c+.05)/(g+.05):(g+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const c=this.getRelativeLuminance(),g=d.getRelativeLuminance();return c>g}isDarkerThan(d){const c=this.getRelativeLuminance(),g=d.getRelativeLuminance();return c<g}lighten(d){return new C(new W(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new C(new W(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:c,g,b:L,a:o}=this.rgba;return new C(new i(c,g,L,o*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new i(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const c=d.rgba,g=this.rgba.a,L=c.a,o=g+L*(1-g);if(o<1e-6)return C.transparent;const s=this.rgba.r*g/o+c.r*L*(1-g)/o,e=this.rgba.g*g/o+c.g*L*(1-g)/o,m=this.rgba.b*g/o+c.b*L*(1-g)/o;return new C(new i(s,e,m,o))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:c,g,b:L,a:o}=this.rgba;return new C(new i(d.rgba.r-o*(d.rgba.r-c),d.rgba.g-o*(d.rgba.g-g),d.rgba.b-o*(d.rgba.b-L),1))}flatten(...d){const c=d.reduceRight((g,L)=>C._flatten(L,g));return C._flatten(this,c)}static _flatten(d,c){const g=1-d.rgba.a;return new C(new i(g*c.rgba.r+d.rgba.a*d.rgba.r,g*c.rgba.g+d.rgba.a*d.rgba.g,g*c.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this._toString||(this._toString=C.Format.CSS.format(this)),this._toString}static getLighterColor(d,c,g){if(d.isLighterThan(c))return d;g=g||.5;const L=d.getRelativeLuminance(),o=c.getRelativeLuminance();return g=g*(o-L)/o,d.lighten(g)}static getDarkerColor(d,c,g){if(d.isDarkerThan(c))return d;g=g||.5;const L=d.getRelativeLuminance(),o=c.getRelativeLuminance();return g=g*(L-o)/L,d.darken(g)}}t.Color=C,C.white=new C(new i(255,255,255,1)),C.black=new C(new i(0,0,0,1)),C.red=new C(new i(255,0,0,1)),C.blue=new C(new i(0,0,255,1)),C.green=new C(new i(0,255,0,1)),C.cyan=new C(new i(0,255,255,1)),C.lightgrey=new C(new i(211,211,211,1)),C.transparent=new C(new i(0,0,0,0)),function(y){let d;(function(c){let g;(function(L){function o(S){return S.rgba.a===1?`rgb(${S.rgba.r}, ${S.rgba.g}, ${S.rgba.b})`:y.Format.CSS.formatRGBA(S)}L.formatRGB=o;function s(S){return`rgba(${S.rgba.r}, ${S.rgba.g}, ${S.rgba.b}, ${+S.rgba.a.toFixed(2)})`}L.formatRGBA=s;function e(S){return S.hsla.a===1?`hsl(${S.hsla.h}, ${(S.hsla.s*100).toFixed(2)}%, ${(S.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(S)}L.formatHSL=e;function m(S){return`hsla(${S.hsla.h}, ${(S.hsla.s*100).toFixed(2)}%, ${(S.hsla.l*100).toFixed(2)}%, ${S.hsla.a.toFixed(2)})`}L.formatHSLA=m;function v(S){const T=S.toString(16);return T.length!==2?"0"+T:T}function w(S){return`#${v(S.rgba.r)}${v(S.rgba.g)}${v(S.rgba.b)}`}L.formatHex=w;function D(S,T=!1){return T&&S.rgba.a===1?y.Format.CSS.formatHex(S):`#${v(S.rgba.r)}${v(S.rgba.g)}${v(S.rgba.b)}${v(Math.round(S.rgba.a*255))}`}L.formatHexA=D;function a(S){return S.isOpaque()?y.Format.CSS.formatHex(S):y.Format.CSS.formatRGBA(S)}L.format=a;function u(S){const T=S.length;if(T===0||S.charCodeAt(0)!==35)return null;if(T===7){const _=16*p(S.charCodeAt(1))+p(S.charCodeAt(2)),r=16*p(S.charCodeAt(3))+p(S.charCodeAt(4)),n=16*p(S.charCodeAt(5))+p(S.charCodeAt(6));return new y(new i(_,r,n,1))}if(T===9){const _=16*p(S.charCodeAt(1))+p(S.charCodeAt(2)),r=16*p(S.charCodeAt(3))+p(S.charCodeAt(4)),n=16*p(S.charCodeAt(5))+p(S.charCodeAt(6)),l=16*p(S.charCodeAt(7))+p(S.charCodeAt(8));return new y(new i(_,r,n,l/255))}if(T===4){const _=p(S.charCodeAt(1)),r=p(S.charCodeAt(2)),n=p(S.charCodeAt(3));return new y(new i(16*_+_,16*r+r,16*n+n))}if(T===5){const _=p(S.charCodeAt(1)),r=p(S.charCodeAt(2)),n=p(S.charCodeAt(3)),l=p(S.charCodeAt(4));return new y(new i(16*_+_,16*r+r,16*n+n,(16*l+l)/255))}return null}L.parseHex=u;function p(S){switch(S){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=c.CSS||(c.CSS={}))})(d=y.Format||(y.Format={}))}(C=t.Color||(t.Color={}))}),define(pe[25],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function E(C){return(y,d,c)=>{let g=null,L=null;if(typeof c.value=="function"?(g="value",L=c.value):typeof c.get=="function"&&(g="get",L=c.get),!L)throw new Error("not supported");c[g]=C(L,d)}}t.createDecorator=E;function i(C,y,d){let c=null,g=null;if(typeof d.value=="function"?(c="value",g=d.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(c="get",g=d.get),!g)throw new Error("not supported");const L=`$memoize$${y}`;d[c]=function(...o){return this.hasOwnProperty(L)||Object.defineProperty(this,L,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,o)}),this[L]}}t.memoize=i;function W(C,y,d){return E((c,g)=>{const L=`$debounce$${g}`,o=`$debounce$result$${g}`;return function(...s){this[o]||(this[o]=d?d():void 0),clearTimeout(this[L]),y&&(this[o]=y(this[o],...s),s=[this[o]]),this[L]=setTimeout(()=>{c.apply(this,s),this[o]=d?d():void 0},C)}})}t.debounce=W;function O(C,y,d){return E((c,g)=>{const L=`$throttle$timer$${g}`,o=`$throttle$result$${g}`,s=`$throttle$lastRun$${g}`,e=`$throttle$pending$${g}`;return function(...m){if(this[o]||(this[o]=d?d():void 0),(this[s]===null||this[s]===void 0)&&(this[s]=-Number.MAX_VALUE),y&&(this[o]=y(this[o],...m)),this[e])return;const v=this[s]+C;v<=Date.now()?(this[s]=Date.now(),c.apply(this,[this[o]]),this[o]=d?d():void 0):(this[e]=!0,this[L]=setTimeout(()=>{this[e]=!1,this[s]=Date.now(),c.apply(this,[this[o]]),this[o]=d?d():void 0},v-Date.now()))}})}t.throttle=O}),define(pe[70],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class E{constructor(W,O,C,y){this.originalStart=W,this.originalLength=O,this.modifiedStart=C,this.modifiedLength=y}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=E}),define(pe[12],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(S){setTimeout(()=>{throw S.stack?a.isErrorNoTelemetry(S)?new a(S.message+`

`+S.stack):new Error(S.message+`

`+S.stack):S},0)}}addListener(S){return this.listeners.push(S),()=>{this._removeListener(S)}}emit(S){this.listeners.forEach(T=>{T(S)})}_removeListener(S){this.listeners.splice(this.listeners.indexOf(S),1)}setUnexpectedErrorHandler(S){this.unexpectedErrorHandler=S}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(S){this.unexpectedErrorHandler(S),this.emit(S)}onUnexpectedExternalError(S){this.unexpectedErrorHandler(S)}}t.ErrorHandler=E,t.errorHandler=new E;function i(p){t.errorHandler.setUnexpectedErrorHandler(p)}t.setUnexpectedErrorHandler=i;function W(p){d(p)||t.errorHandler.onUnexpectedError(p)}t.onUnexpectedError=W;function O(p){d(p)||t.errorHandler.onUnexpectedExternalError(p)}t.onUnexpectedExternalError=O;function C(p){if(p instanceof Error){const{name:S,message:T}=p,_=p.stacktrace||p.stack;return{$isError:!0,name:S,message:T,stack:_,noTelemetry:a.isErrorNoTelemetry(p)}}return p}t.transformErrorForSerialization=C;const y="Canceled";function d(p){return p instanceof c?!0:p instanceof Error&&p.name===y&&p.message===y}t.isCancellationError=d;class c extends Error{constructor(){super(y),this.name=this.message}}t.CancellationError=c;function g(){const p=new Error(y);return p.name=p.message,p}t.canceled=g;function L(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}t.illegalArgument=L;function o(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}t.illegalState=o;function s(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=s;function e(p){const S=new Error(`${p} has been disposed`);return S.name="DISPOSED",S}t.disposed=e;function m(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}t.getErrorMessage=m;class v extends Error{constructor(S){super("NotImplemented"),S&&(this.message=S)}}t.NotImplementedError=v;class w extends Error{constructor(S){super("NotSupported"),S&&(this.message=S)}}t.NotSupportedError=w;class D extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=D;class a extends Error{constructor(S){super(S),this.name="CodeExpectedError"}static fromError(S){if(S instanceof a)return S;const T=new a;return T.message=S.message,T.stack=S.stack,T}static isErrorNoTelemetry(S){return S.name==="CodeExpectedError"}}t.ErrorNoTelemetry=a;class u extends Error{constructor(S){super(S||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype);debugger}}t.BugIndicatingError=u}),define(pe[14],be([1,0,12]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function i(N,R=0){return N[N.length-(1+R)]}t.tail=i;function W(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}t.tail2=W;function O(N,R,H=(A,P)=>A===P){if(N===R)return!0;if(!N||!R||N.length!==R.length)return!1;for(let A=0,P=N.length;A<P;A++)if(!H(N[A],R[A]))return!1;return!0}t.equals=O;function C(N,R){const H=N.length-1;R<H&&(N[R]=N[H]),N.pop()}t.removeFastWithoutKeepingOrder=C;function y(N,R,H){return d(N.length,A=>H(N[A],R))}t.binarySearch=y;function d(N,R){let H=0,A=N-1;for(;H<=A;){const P=(H+A)/2|0,M=R(P);if(M<0)H=P+1;else if(M>0)A=P-1;else return P}return-(H+1)}t.binarySearch2=d;function c(N,R){let H=0,A=N.length;if(A===0)return 0;for(;H<A;){const P=Math.floor((H+A)/2);R(N[P])?A=P:H=P+1}return H}t.findFirstInSorted=c;function g(N,R,H){if(N=N|0,N>=R.length)throw new TypeError("invalid index");const A=R[Math.floor(R.length*Math.random())],P=[],M=[],B=[];for(const q of R){const ee=H(q,A);ee<0?P.push(q):ee>0?M.push(q):B.push(q)}return N<P.length?g(N,P,H):N<P.length+B.length?B[0]:g(N-(P.length+B.length),M,H)}t.quickSelect=g;function L(N,R){const H=[];let A;for(const P of N.slice(0).sort(R))!A||R(A[0],P)!==0?(A=[P],H.push(A)):A.push(P);return H}t.groupBy=L;function o(N,R,H){const A=[];function P(q,ee,le){if(ee===0&&le.length===0)return;const de=A[A.length-1];de&&de.start+de.deleteCount===q?(de.deleteCount+=ee,de.toInsert.push(...le)):A.push({start:q,deleteCount:ee,toInsert:le})}let M=0,B=0;for(;;){if(M===N.length){P(M,0,R.slice(B));break}if(B===R.length){P(M,N.length-M,[]);break}const q=N[M],ee=R[B],le=H(q,ee);le===0?(M+=1,B+=1):le<0?(P(M,1,[]),M+=1):le>0&&(P(M,0,[ee]),B+=1)}return A}t.sortedDiff=o;function s(N,R,H){const A=o(N,R,H),P=[],M=[];for(const B of A)P.push(...N.slice(B.start,B.start+B.deleteCount)),M.push(...B.toInsert);return{removed:P,added:M}}t.delta=s;function e(N,R,H){if(H===0)return[];const A=N.slice(0,H).sort(R);return v(N,R,A,H,N.length),A}t.top=e;function m(N,R,H,A,P){return H===0?Promise.resolve([]):new Promise((M,B)=>{(async()=>{const q=N.length,ee=N.slice(0,H).sort(R);for(let le=H,de=Math.min(H+A,q);le<q;le=de,de=Math.min(de+A,q)){if(le>H&&await new Promise(ye=>setTimeout(ye)),P&&P.isCancellationRequested)throw new E.CancellationError;v(N,R,ee,le,de)}return ee})().then(M,B)})}t.topAsync=m;function v(N,R,H,A,P){for(const M=H.length;A<P;A++){const B=N[A];if(R(B,H[M-1])<0){H.pop();const q=c(H,ee=>R(B,ee)<0);H.splice(q,0,B)}}}function w(N){return N.filter(R=>!!R)}t.coalesce=w;function D(N){let R=0;for(let H=0;H<N.length;H++)N[H]&&(N[R]=N[H],R+=1);N.length=R}t.coalesceInPlace=D;function a(N,R,H){N.splice(H,0,N.splice(R,1)[0])}t.move=a;function u(N){return!Array.isArray(N)||N.length===0}t.isFalsyOrEmpty=u;function p(N){return Array.isArray(N)&&N.length>0}t.isNonEmptyArray=p;function S(N,R=H=>H){const H=new Set;return N.filter(A=>{const P=R(A);return H.has(P)?!1:(H.add(P),!0)})}t.distinct=S;function T(N){const R=new Set;return H=>{const A=N(H);return R.has(A)?!1:(R.add(A),!0)}}t.uniqueFilter=T;function _(N,R){const H=r(N,R);if(H!==-1)return N[H]}t.findLast=_;function r(N,R){for(let H=N.length-1;H>=0;H--){const A=N[H];if(R(A))return H}return-1}t.lastIndex=r;function n(N,R){return N.length>0?N[0]:R}t.firstOrDefault=n;function l(N,R){return N.length>0?N[N.length-1]:R}t.lastOrDefault=l;function b(N,R,H=(A,P)=>A===P){let A=0;for(let P=0,M=Math.min(N.length,R.length);P<M&&H(N[P],R[P]);P++)A++;return A}t.commonPrefixLength=b;function f(N){return[].concat(...N)}t.flatten=f;function z(N,R){let H=typeof R=="number"?N:0;typeof R=="number"?H=N:(H=0,R=N);const A=[];if(H<=R)for(let P=H;P<R;P++)A.push(P);else for(let P=H;P>R;P--)A.push(P);return A}t.range=z;function $(N,R,H){return N.reduce((A,P)=>(A[R(P)]=H?H(P):P,A),Object.create(null))}t.index=$;function X(N,R){return N.push(R),()=>J(N,R)}t.insert=X;function J(N,R){const H=N.indexOf(R);if(H>-1)return N.splice(H,1),R}t.remove=J;function ge(N,R,H){const A=N.slice(0,R),P=N.slice(R);return A.concat(H,P)}t.arrayInsert=ge;function re(N,R){let H;if(typeof R=="number"){let A=R;H=()=>{const P=Math.sin(A++)*179426549;return P-Math.floor(P)}}else H=Math.random;for(let A=N.length-1;A>0;A-=1){const P=Math.floor(H()*(A+1)),M=N[A];N[A]=N[P],N[P]=M}}t.shuffle=re;function me(N,R){const H=N.indexOf(R);H>-1&&(N.splice(H,1),N.unshift(R))}t.pushToStart=me;function ae(N,R){const H=N.indexOf(R);H>-1&&(N.splice(H,1),N.push(R))}t.pushToEnd=ae;function he(N,R){for(const H of R)N.push(H)}t.pushMany=he;function Se(N,R){return Array.isArray(N)?N.map(R):R(N)}t.mapArrayOrNot=Se;function te(N){return Array.isArray(N)?N:[N]}t.asArray=te;function De(N){return N[Math.floor(Math.random()*N.length)]}t.getRandomElement=De;function se(N,R){for(const H of N){const A=R(H);if(A!==void 0)return A}}t.mapFind=se;function ie(N,R,H){const A=ne(N,R),P=N.length,M=H.length;N.length=P+M;for(let B=P-1;B>=A;B--)N[B+M]=N[B];for(let B=0;B<M;B++)N[B+A]=H[B]}t.insertInto=ie;function ce(N,R,H,A){const P=ne(N,R),M=N.splice(P,H);return ie(N,P,A),M}t.splice=ce;function ne(N,R){return R<0?Math.max(R+N.length,0):Math.min(R,N.length)}var F;(function(N){function R(P){return P<0}N.isLessThan=R;function H(P){return P>0}N.isGreaterThan=H;function A(P){return P===0}N.isNeitherLessOrGreaterThan=A,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(F=t.CompareResult||(t.CompareResult={}));function V(N,R){return(H,A)=>R(N(H),N(A))}t.compareBy=V;function j(...N){return(R,H)=>{for(const A of N){const P=A(R,H);if(!F.isNeitherLessOrGreaterThan(P))return P}return F.neitherLessOrGreaterThan}}t.tieBreakComparators=j;const k=(N,R)=>N-R;t.numberComparator=k;function h(N,R){if(N.length===0)return;let H=N[0];for(let A=1;A<N.length;A++){const P=N[A];R(P,H)>0&&(H=P)}return H}t.findMaxBy=h;function I(N,R){if(N.length===0)return;let H=N[0];for(let A=1;A<N.length;A++){const P=N[A];R(P,H)>=0&&(H=P)}return H}t.findLastMaxBy=I;function U(N,R){return h(N,(H,A)=>-R(H,A))}t.findMinBy=U;class K{constructor(R){this.items=R,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(R){let H=this.firstIdx;for(;H<this.items.length&&R(this.items[H]);)H++;const A=H===this.firstIdx?null:this.items.slice(this.firstIdx,H);return this.firstIdx=H,A}takeFromEndWhile(R){let H=this.lastIdx;for(;H>=0&&R(this.items[H]);)H--;const A=H===this.lastIdx?null:this.items.slice(H+1,this.lastIdx+1);return this.lastIdx=H,A}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const R=this.items[this.firstIdx];return this.firstIdx++,R}removeLast(){const R=this.items[this.lastIdx];return this.lastIdx--,R}takeCount(R){const H=this.items.slice(this.firstIdx,this.firstIdx+R);return this.firstIdx+=R,H}}t.ArrayQueue=K;class Z{constructor(R){this.iterate=R}forEach(R){this.iterate(H=>(R(H),!0))}toArray(){const R=[];return this.iterate(H=>(R.push(H),!0)),R}filter(R){return new Z(H=>this.iterate(A=>R(A)?H(A):!0))}map(R){return new Z(H=>this.iterate(A=>H(R(A))))}some(R){let H=!1;return this.iterate(A=>(H=R(A),!H)),H}findFirst(R){let H;return this.iterate(A=>R(A)?(H=A,!1):!0),H}findLast(R){let H;return this.iterate(A=>(R(A)&&(H=A),!0)),H}findLastMaxBy(R){let H,A=!0;return this.iterate(P=>((A||F.isGreaterThan(R(P,H)))&&(A=!1,H=P),!0)),H}}t.CallbackIterable=Z,Z.empty=new Z(N=>{})}),define(pe[71],be([1,0,12]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function i(d,c){if(!d)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}t.ok=i;function W(d,c="Unreachable"){throw new Error(c)}t.assertNever=W;function O(d){if(!d)throw new E.BugIndicatingError("Assertion Failed")}t.assert=O;function C(d){if(!d()){debugger;d(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}t.assertFn=C;function y(d,c){let g=0;for(;g<d.length-1;){const L=d[g],o=d[g+1];if(!c(L,o))return!1;g++}return!0}t.checkAdjacentItems=y}),define(pe[42],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function E(i){const W=this;let O=!1,C;return function(){return O||(O=!0,C=i.apply(W,arguments)),C}}t.once=E}),define(pe[72],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class E{constructor(W){this._prefix=W,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=E,t.defaultGenerator=new E("id#")}),define(pe[26],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var E;(function(i){function W(T){return T&&typeof T=="object"&&typeof T[Symbol.iterator]=="function"}i.is=W;const O=Object.freeze([]);function C(){return O}i.empty=C;function*y(T){yield T}i.single=y;function d(T){return T||O}i.from=d;function c(T){return!T||T[Symbol.iterator]().next().done===!0}i.isEmpty=c;function g(T){return T[Symbol.iterator]().next().value}i.first=g;function L(T,_){for(const r of T)if(_(r))return!0;return!1}i.some=L;function o(T,_){for(const r of T)if(_(r))return r}i.find=o;function*s(T,_){for(const r of T)_(r)&&(yield r)}i.filter=s;function*e(T,_){let r=0;for(const n of T)yield _(n,r++)}i.map=e;function*m(...T){for(const _ of T)for(const r of _)yield r}i.concat=m;function*v(T){for(const _ of T)for(const r of _)yield r}i.concatNested=v;function w(T,_,r){let n=r;for(const l of T)n=_(n,l);return n}i.reduce=w;function D(T,_){let r=0;for(const n of T)_(n,r++)}i.forEach=D;function*a(T,_,r=T.length){for(_<0&&(_+=T.length),r<0?r+=T.length:r>T.length&&(r=T.length);_<r;_++)yield T[_]}i.slice=a;function u(T,_=Number.POSITIVE_INFINITY){const r=[];if(_===0)return[r,T];const n=T[Symbol.iterator]();for(let l=0;l<_;l++){const b=n.next();if(b.done)return[r,i.empty()];r.push(b.value)}return[r,{[Symbol.iterator](){return n}}]}i.consume=u;function p(T){return u(T)[0]}i.collect=p;function S(T,_,r=(n,l)=>n===l){const n=T[Symbol.iterator](),l=_[Symbol.iterator]();for(;;){const b=n.next(),f=l.next();if(b.done!==f.done)return!1;if(b.done)return!0;if(!r(b.value,f.value))return!1}}i.equals=S})(E=t.Iterable||(t.Iterable={}))}),define(pe[43],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var E;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(E=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i=t.ScanCode||(t.ScanCode={}));class W{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(m,v){this._keyCodeToStr[m]=v,this._strToKeyCode[v.toLowerCase()]=m}keyCodeToStr(m){return this._keyCodeToStr[m]}strToKeyCode(m){return this._strToKeyCode[m.toLowerCase()]||0}}const O=new W,C=new W,y=new W;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const d=[],c=Object.create(null),g=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>g[e]||0,toEnum:e=>c[e]||0,toString:e=>d[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",m=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],v=[],w=[];for(const D of m){const[a,u,p,S,T,_,r,n,l,b]=D;if(w[p]||(w[p]=!0,d[p]=S,c[S]=p,g[S.toLowerCase()]=p,u&&(t.IMMUTABLE_CODE_TO_KEY_CODE[p]=T,T!==0&&T!==3&&T!==5&&T!==4&&T!==6&&T!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[T]=p))),!v[T]){if(v[T]=!0,!_)throw new Error(`String representation missing for key code ${T} around scan code ${S}`);O.define(T,_),C.define(T,l||_),y.define(T,b||l||_)}r&&(t.EVENT_KEY_CODE_MAP[r]=T),n&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[n]=T)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var L;(function(e){function m(p){return O.keyCodeToStr(p)}e.toString=m;function v(p){return O.strToKeyCode(p)}e.fromString=v;function w(p){return C.keyCodeToStr(p)}e.toUserSettingsUS=w;function D(p){return y.keyCodeToStr(p)}e.toUserSettingsGeneral=D;function a(p){return C.strToKeyCode(p)||y.strToKeyCode(p)}e.fromUserSettings=a;function u(p){if(p>=93&&p<=108)return null;switch(p){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return O.keyCodeToStr(p)}e.toElectronAccelerator=u})(L=t.KeyCodeUtils||(t.KeyCodeUtils={}));var o;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(o=t.KeyMod||(t.KeyMod={}));function s(e,m){const v=(m&65535)<<16>>>0;return(e|v)>>>0}t.KeyChord=s}),define(pe[73],be([1,0,12]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ScanCodeBinding=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=void 0;var i;(function(L){L[L.CtrlCmd=2048]="CtrlCmd",L[L.Shift=1024]="Shift",L[L.Alt=512]="Alt",L[L.WinCtrl=256]="WinCtrl",L[L.KeyCode=255]="KeyCode"})(i||(i={}));function W(L,o){if(L===0)return null;const s=(L&65535)>>>0,e=(L&4294901760)>>>16;return e!==0?new y([O(s,o),O(e,o)]):new y([O(s,o)])}t.createKeybinding=W;function O(L,o){const s=!!(L&2048),e=!!(L&256),m=o===2?e:s,v=!!(L&1024),w=!!(L&512),D=o===2?s:e,a=L&255;return new C(m,v,w,D,a)}t.createSimpleKeybinding=O;class C{constructor(o,s,e,m,v){this.ctrlKey=o,this.shiftKey=s,this.altKey=e,this.metaKey=m,this.keyCode=v}equals(o){return this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.keyCode===o.keyCode}getHashCode(){const o=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",e=this.altKey?"1":"0",m=this.metaKey?"1":"0";return`${o}${s}${e}${m}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new y([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=C;class y{constructor(o){if(o.length===0)throw(0,E.illegalArgument)("parts");this.parts=o}getHashCode(){let o="";for(let s=0,e=this.parts.length;s<e;s++)s!==0&&(o+=";"),o+=this.parts[s].getHashCode();return o}equals(o){if(o===null||this.parts.length!==o.parts.length)return!1;for(let s=0;s<this.parts.length;s++)if(!this.parts[s].equals(o.parts[s]))return!1;return!0}}t.ChordKeybinding=y;class d{constructor(o,s,e,m,v){this.ctrlKey=o,this.shiftKey=s,this.altKey=e,this.metaKey=m,this.scanCode=v}equals(o){return this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.scanCode===o.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeBinding=d;class c{constructor(o,s,e,m,v,w){this.ctrlKey=o,this.shiftKey=s,this.altKey=e,this.metaKey=m,this.keyLabel=v,this.keyAriaLabel=w}}t.ResolvedKeybindingPart=c;class g{}t.ResolvedKeybinding=g}),define(pe[44],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class E{constructor(W){this.executor=W,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(W){this._error=W}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(W){return new E(()=>W(this.getValue()))}}t.Lazy=E}),define(pe[2],be([1,0,42,26]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const W=!1;let O=null;function C(n){O=n}if(t.setDisposableTracker=C,W){const n="__is_disposable_tracked__";C(new class{trackDisposable(l){const b=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[n]||console.log(b)},3e3)}setParent(l,b){if(l&&l!==D.None)try{l[n]=!0}catch{}}markAsDisposed(l){if(l&&l!==D.None)try{l[n]=!0}catch{}}markAsSingleton(l){}})}function y(n){return O?.trackDisposable(n),n}function d(n){O?.markAsDisposed(n)}function c(n,l){O?.setParent(n,l)}function g(n,l){if(!!O)for(const b of n)O.setParent(b,l)}function L(n){return O?.markAsSingleton(n),n}t.markAsSingleton=L;function o(n){return typeof n.dispose=="function"&&n.dispose.length===0}t.isDisposable=o;function s(n){if(i.Iterable.is(n)){const l=[];for(const b of n)if(b)try{b.dispose()}catch(f){l.push(f)}if(l.length===1)throw l[0];if(l.length>1)throw new AggregateError(l,"Encountered errors while disposing of store");return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}t.dispose=s;function e(n){for(const l of n)o(l)&&l.dispose();return[]}t.disposeIfDisposable=e;function m(...n){const l=v(()=>s(n));return g(n,l),l}t.combinedDisposable=m;function v(n){const l=y({dispose:(0,E.once)(()=>{d(l),n()})});return l}t.toDisposable=v;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{s(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return c(l,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}t.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class D{constructor(){this._store=new w,y(this),c(this._store,this)}dispose(){d(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}t.Disposable=D,D.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){this._isDisposed||l===this._value||(this._value?.dispose(),l&&c(l,this),this._value=l)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const l=this._value;return this._value=void 0,l&&c(l,null),l}}t.MutableDisposable=a;class u{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=u;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(l){let b=l;return this.unset=()=>b=void 0,this.isset=()=>b!==void 0,this.dispose=()=>{b&&(b(),b=void 0,d(this))},this}}t.SafeDisposable=p;class S{constructor(){this.references=new Map}acquire(l,...b){let f=this.references.get(l);f||(f={counter:0,object:this.createReferencedObject(l,...b)},this.references.set(l,f));const{object:z}=f,$=(0,E.once)(()=>{--f.counter===0&&(this.destroyReferencedObject(l,f.object),this.references.delete(l))});return f.counter++,{object:z,dispose:$}}}t.ReferenceCollection=S;class T{constructor(l){this.referenceCollection=l}async acquire(l,...b){const f=this.referenceCollection.acquire(l,...b);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(z){throw f.dispose(),z}}}t.AsyncReferenceCollection=T;class _{constructor(l){this.object=l}dispose(){}}t.ImmortalReference=_;function r(n){const l=new w;try{n(l)}finally{l.dispose()}}t.disposeOnReturn=r}),define(pe[74],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class E{constructor(O){this.element=O,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class i{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let O=this._first;for(;O!==E.Undefined;){const C=O.next;O.prev=E.Undefined,O.next=E.Undefined,O=C}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(O){return this._insert(O,!1)}push(O){return this._insert(O,!0)}_insert(O,C){const y=new E(O);if(this._first===E.Undefined)this._first=y,this._last=y;else if(C){const c=this._last;this._last=y,y.prev=c,c.next=y}else{const c=this._first;this._first=y,y.next=c,c.prev=y}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(y))}}shift(){if(this._first!==E.Undefined){const O=this._first.element;return this._remove(this._first),O}}pop(){if(this._last!==E.Undefined){const O=this._last.element;return this._remove(this._last),O}}_remove(O){if(O.prev!==E.Undefined&&O.next!==E.Undefined){const C=O.prev;C.next=O.next,O.next.prev=C}else O.prev===E.Undefined&&O.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):O.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):O.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let O=this._first;for(;O!==E.Undefined;)yield O.element,O=O.next}}t.LinkedList=i}),function(Q,t){typeof exports=="object"&&typeof module<"u"?t(exports):typeof define=="function"&&define.amd?define(pe[75],be([0]),t):(Q=typeof globalThis<"u"?globalThis:Q||self,t(Q.marked={}))}(this,function(Q){"use strict";function t(N,R){for(var H=0;H<R.length;H++){var A=R[H];A.enumerable=A.enumerable||!1,A.configurable=!0,"value"in A&&(A.writable=!0),Object.defineProperty(N,A.key,A)}}function E(N,R,H){return R&&t(N.prototype,R),H&&t(N,H),Object.defineProperty(N,"prototype",{writable:!1}),N}function i(N,R){if(!!N){if(typeof N=="string")return W(N,R);var H=Object.prototype.toString.call(N).slice(8,-1);if(H==="Object"&&N.constructor&&(H=N.constructor.name),H==="Map"||H==="Set")return Array.from(N);if(H==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(H))return W(N,R)}}function W(N,R){(R==null||R>N.length)&&(R=N.length);for(var H=0,A=new Array(R);H<R;H++)A[H]=N[H];return A}function O(N,R){var H=typeof Symbol<"u"&&N[Symbol.iterator]||N["@@iterator"];if(H)return(H=H.call(N)).next.bind(H);if(Array.isArray(N)||(H=i(N))||R&&N&&typeof N.length=="number"){H&&(N=H);var A=0;return function(){return A>=N.length?{done:!0}:{done:!1,value:N[A++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Q.defaults=C();function y(N){Q.defaults=N}var d=/[&<>"']/,c=/[&<>"']/g,g=/[<>"']|&(?!#?\w+;)/,L=/[<>"']|&(?!#?\w+;)/g,o={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},s=function(R){return o[R]};function e(N,R){if(R){if(d.test(N))return N.replace(c,s)}else if(g.test(N))return N.replace(L,s);return N}var m=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(N){return N.replace(m,function(R,H){return H=H.toLowerCase(),H==="colon"?":":H.charAt(0)==="#"?H.charAt(1)==="x"?String.fromCharCode(parseInt(H.substring(2),16)):String.fromCharCode(+H.substring(1)):""})}var w=/(^|[^\[])\^/g;function D(N,R){N=typeof N=="string"?N:N.source,R=R||"";var H={replace:function(P,M){return M=M.source||M,M=M.replace(w,"$1"),N=N.replace(P,M),H},getRegex:function(){return new RegExp(N,R)}};return H}var a=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(N,R,H){if(N){var A;try{A=decodeURIComponent(v(H)).replace(a,"").toLowerCase()}catch{return null}if(A.indexOf("javascript:")===0||A.indexOf("vbscript:")===0||A.indexOf("data:")===0)return null}R&&!u.test(H)&&(H=n(R,H));try{H=encodeURI(H).replace(/%25/g,"%")}catch{return null}return H}var S={},T=/^[^:]+:\/*[^/]*$/,_=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(N,R){S[" "+N]||(T.test(N)?S[" "+N]=N+"/":S[" "+N]=z(N,"/",!0)),N=S[" "+N];var H=N.indexOf(":")===-1;return R.substring(0,2)==="//"?H?R:N.replace(_,"$1")+R:R.charAt(0)==="/"?H?R:N.replace(r,"$1")+R:N+R}var l={exec:function(){}};function b(N){for(var R=1,H,A;R<arguments.length;R++){H=arguments[R];for(A in H)Object.prototype.hasOwnProperty.call(H,A)&&(N[A]=H[A])}return N}function f(N,R){var H=N.replace(/\|/g,function(M,B,q){for(var ee=!1,le=B;--le>=0&&q[le]==="\\";)ee=!ee;return ee?"|":" |"}),A=H.split(/ \|/),P=0;if(A[0].trim()||A.shift(),A.length>0&&!A[A.length-1].trim()&&A.pop(),A.length>R)A.splice(R);else for(;A.length<R;)A.push("");for(;P<A.length;P++)A[P]=A[P].trim().replace(/\\\|/g,"|");return A}function z(N,R,H){var A=N.length;if(A===0)return"";for(var P=0;P<A;){var M=N.charAt(A-P-1);if(M===R&&!H)P++;else if(M!==R&&H)P++;else break}return N.slice(0,A-P)}function $(N,R){if(N.indexOf(R[1])===-1)return-1;for(var H=N.length,A=0,P=0;P<H;P++)if(N[P]==="\\")P++;else if(N[P]===R[0])A++;else if(N[P]===R[1]&&(A--,A<0))return P;return-1}function X(N){N&&N.sanitize&&!N.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function J(N,R){if(R<1)return"";for(var H="";R>1;)R&1&&(H+=N),R>>=1,N+=N;return H+N}function ge(N,R,H,A){var P=R.href,M=R.title?e(R.title):null,B=N[1].replace(/\\([\[\]])/g,"$1");if(N[0].charAt(0)!=="!"){A.state.inLink=!0;var q={type:"link",raw:H,href:P,title:M,text:B,tokens:A.inlineTokens(B)};return A.state.inLink=!1,q}return{type:"image",raw:H,href:P,title:M,text:e(B)}}function re(N,R){var H=N.match(/^(\s+)(?:```)/);if(H===null)return R;var A=H[1];return R.split(`
`).map(function(P){var M=P.match(/^\s+/);if(M===null)return P;var B=M[0];return B.length>=A.length?P.slice(A.length):P}).join(`
`)}var me=function(){function N(H){this.options=H||Q.defaults}var R=N.prototype;return R.space=function(A){var P=this.rules.block.newline.exec(A);if(P&&P[0].length>0)return{type:"space",raw:P[0]}},R.code=function(A){var P=this.rules.block.code.exec(A);if(P){var M=P[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:P[0],codeBlockStyle:"indented",text:this.options.pedantic?M:z(M,`
`)}}},R.fences=function(A){var P=this.rules.block.fences.exec(A);if(P){var M=P[0],B=re(M,P[3]||"");return{type:"code",raw:M,lang:P[2]?P[2].trim():P[2],text:B}}},R.heading=function(A){var P=this.rules.block.heading.exec(A);if(P){var M=P[2].trim();if(/#$/.test(M)){var B=z(M,"#");(this.options.pedantic||!B||/ $/.test(B))&&(M=B.trim())}return{type:"heading",raw:P[0],depth:P[1].length,text:M,tokens:this.lexer.inline(M)}}},R.hr=function(A){var P=this.rules.block.hr.exec(A);if(P)return{type:"hr",raw:P[0]}},R.blockquote=function(A){var P=this.rules.block.blockquote.exec(A);if(P){var M=P[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:P[0],tokens:this.lexer.blockTokens(M,[]),text:M}}},R.list=function(A){var P=this.rules.block.list.exec(A);if(P){var M,B,q,ee,le,de,ye,Ee,Re,Le,ve,Pe,ke=P[1].trim(),je=ke.length>1,He={type:"list",raw:"",ordered:je,start:je?+ke.slice(0,-1):"",loose:!1,items:[]};ke=je?"\\d{1,9}\\"+ke.slice(-1):"\\"+ke,this.options.pedantic&&(ke=je?ke:"[*+-]");for(var Ue=new RegExp("^( {0,3}"+ke+")((?:[	 ][^\\n]*)?(?:\\n|$))");A&&(Pe=!1,!(!(P=Ue.exec(A))||this.rules.block.hr.test(A)));){if(M=P[0],A=A.substring(M.length),Ee=P[2].split(`
`,1)[0],Re=A.split(`
`,1)[0],this.options.pedantic?(ee=2,ve=Ee.trimLeft()):(ee=P[2].search(/[^ ]/),ee=ee>4?1:ee,ve=Ee.slice(ee),ee+=P[1].length),de=!1,!Ee&&/^ *$/.test(Re)&&(M+=Re+`
`,A=A.substring(Re.length+1),Pe=!0),!Pe)for(var Je=new RegExp("^ {0,"+Math.min(3,ee-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,ee-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Me=new RegExp("^ {0,"+Math.min(3,ee-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,ee-1)+"}#");A&&(Le=A.split(`
`,1)[0],Ee=Le,this.options.pedantic&&(Ee=Ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Me.test(Ee)||qe.test(Ee)||Je.test(Ee)||it.test(A)));){if(Ee.search(/[^ ]/)>=ee||!Ee.trim())ve+=`
`+Ee.slice(ee);else if(!de)ve+=`
`+Ee;else break;!de&&!Ee.trim()&&(de=!0),M+=Le+`
`,A=A.substring(Le.length+1)}He.loose||(ye?He.loose=!0:/\n *\n *$/.test(M)&&(ye=!0)),this.options.gfm&&(B=/^\[[ xX]\] /.exec(ve),B&&(q=B[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:M,task:!!B,checked:q,loose:!1,text:ve}),He.raw+=M}He.items[He.items.length-1].raw=M.trimRight(),He.items[He.items.length-1].text=ve.trimRight(),He.raw=He.raw.trimRight();var x=He.items.length;for(le=0;le<x;le++){this.lexer.state.top=!1,He.items[le].tokens=this.lexer.blockTokens(He.items[le].text,[]);var oe=He.items[le].tokens.filter(function(Ce){return Ce.type==="space"}),we=oe.every(function(Ce){for(var Ae=Ce.raw.split(""),Oe=0,$e=O(Ae),Ge;!(Ge=$e()).done;){var et=Ge.value;if(et===`
`&&(Oe+=1),Oe>1)return!0}return!1});!He.loose&&oe.length&&we&&(He.loose=!0,He.items[le].loose=!0)}return He}},R.html=function(A){var P=this.rules.block.html.exec(A);if(P){var M={type:"html",raw:P[0],pre:!this.options.sanitizer&&(P[1]==="pre"||P[1]==="script"||P[1]==="style"),text:P[0]};if(this.options.sanitize){var B=this.options.sanitizer?this.options.sanitizer(P[0]):e(P[0]);M.type="paragraph",M.text=B,M.tokens=this.lexer.inline(B)}return M}},R.def=function(A){var P=this.rules.block.def.exec(A);if(P){P[3]&&(P[3]=P[3].substring(1,P[3].length-1));var M=P[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:M,raw:P[0],href:P[2],title:P[3]}}},R.table=function(A){var P=this.rules.block.table.exec(A);if(P){var M={type:"table",header:f(P[1]).map(function(ye){return{text:ye}}),align:P[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:P[3]&&P[3].trim()?P[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(M.header.length===M.align.length){M.raw=P[0];var B=M.align.length,q,ee,le,de;for(q=0;q<B;q++)/^ *-+: *$/.test(M.align[q])?M.align[q]="right":/^ *:-+: *$/.test(M.align[q])?M.align[q]="center":/^ *:-+ *$/.test(M.align[q])?M.align[q]="left":M.align[q]=null;for(B=M.rows.length,q=0;q<B;q++)M.rows[q]=f(M.rows[q],M.header.length).map(function(ye){return{text:ye}});for(B=M.header.length,ee=0;ee<B;ee++)M.header[ee].tokens=this.lexer.inline(M.header[ee].text);for(B=M.rows.length,ee=0;ee<B;ee++)for(de=M.rows[ee],le=0;le<de.length;le++)de[le].tokens=this.lexer.inline(de[le].text);return M}}},R.lheading=function(A){var P=this.rules.block.lheading.exec(A);if(P)return{type:"heading",raw:P[0],depth:P[2].charAt(0)==="="?1:2,text:P[1],tokens:this.lexer.inline(P[1])}},R.paragraph=function(A){var P=this.rules.block.paragraph.exec(A);if(P){var M=P[1].charAt(P[1].length-1)===`
`?P[1].slice(0,-1):P[1];return{type:"paragraph",raw:P[0],text:M,tokens:this.lexer.inline(M)}}},R.text=function(A){var P=this.rules.block.text.exec(A);if(P)return{type:"text",raw:P[0],text:P[0],tokens:this.lexer.inline(P[0])}},R.escape=function(A){var P=this.rules.inline.escape.exec(A);if(P)return{type:"escape",raw:P[0],text:e(P[1])}},R.tag=function(A){var P=this.rules.inline.tag.exec(A);if(P)return!this.lexer.state.inLink&&/^<a /i.test(P[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(P[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(P[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(P[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:P[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(P[0]):e(P[0]):P[0]}},R.link=function(A){var P=this.rules.inline.link.exec(A);if(P){var M=P[2].trim();if(!this.options.pedantic&&/^</.test(M)){if(!/>$/.test(M))return;var B=z(M.slice(0,-1),"\\");if((M.length-B.length)%2===0)return}else{var q=$(P[2],"()");if(q>-1){var ee=P[0].indexOf("!")===0?5:4,le=ee+P[1].length+q;P[2]=P[2].substring(0,q),P[0]=P[0].substring(0,le).trim(),P[3]=""}}var de=P[2],ye="";if(this.options.pedantic){var Ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);Ee&&(de=Ee[1],ye=Ee[3])}else ye=P[3]?P[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(M)?de=de.slice(1):de=de.slice(1,-1)),ge(P,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:ye&&ye.replace(this.rules.inline._escapes,"$1")},P[0],this.lexer)}},R.reflink=function(A,P){var M;if((M=this.rules.inline.reflink.exec(A))||(M=this.rules.inline.nolink.exec(A))){var B=(M[2]||M[1]).replace(/\s+/g," ");if(B=P[B.toLowerCase()],!B||!B.href){var q=M[0].charAt(0);return{type:"text",raw:q,text:q}}return ge(M,B,M[0],this.lexer)}},R.emStrong=function(A,P,M){M===void 0&&(M="");var B=this.rules.inline.emStrong.lDelim.exec(A);if(!!B&&!(B[3]&&M.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var q=B[1]||B[2]||"";if(!q||q&&(M===""||this.rules.inline.punctuation.exec(M))){var ee=B[0].length-1,le,de,ye=ee,Ee=0,Re=B[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Re.lastIndex=0,P=P.slice(-1*A.length+ee);(B=Re.exec(P))!=null;)if(le=B[1]||B[2]||B[3]||B[4]||B[5]||B[6],!!le){if(de=le.length,B[3]||B[4]){ye+=de;continue}else if((B[5]||B[6])&&ee%3&&!((ee+de)%3)){Ee+=de;continue}if(ye-=de,!(ye>0)){if(de=Math.min(de,de+ye+Ee),Math.min(ee,de)%2){var Le=A.slice(1,ee+B.index+de);return{type:"em",raw:A.slice(0,ee+B.index+de+1),text:Le,tokens:this.lexer.inlineTokens(Le)}}var ve=A.slice(2,ee+B.index+de-1);return{type:"strong",raw:A.slice(0,ee+B.index+de+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},R.codespan=function(A){var P=this.rules.inline.code.exec(A);if(P){var M=P[2].replace(/\n/g," "),B=/[^ ]/.test(M),q=/^ /.test(M)&&/ $/.test(M);return B&&q&&(M=M.substring(1,M.length-1)),M=e(M,!0),{type:"codespan",raw:P[0],text:M}}},R.br=function(A){var P=this.rules.inline.br.exec(A);if(P)return{type:"br",raw:P[0]}},R.del=function(A){var P=this.rules.inline.del.exec(A);if(P)return{type:"del",raw:P[0],text:P[2],tokens:this.lexer.inlineTokens(P[2])}},R.autolink=function(A,P){var M=this.rules.inline.autolink.exec(A);if(M){var B,q;return M[2]==="@"?(B=e(this.options.mangle?P(M[1]):M[1]),q="mailto:"+B):(B=e(M[1]),q=B),{type:"link",raw:M[0],text:B,href:q,tokens:[{type:"text",raw:B,text:B}]}}},R.url=function(A,P){var M;if(M=this.rules.inline.url.exec(A)){var B,q;if(M[2]==="@")B=e(this.options.mangle?P(M[0]):M[0]),q="mailto:"+B;else{var ee;do ee=M[0],M[0]=this.rules.inline._backpedal.exec(M[0])[0];while(ee!==M[0]);B=e(M[0]),M[1]==="www."?q="http://"+B:q=B}return{type:"link",raw:M[0],text:B,href:q,tokens:[{type:"text",raw:B,text:B}]}}},R.inlineText=function(A,P){var M=this.rules.inline.text.exec(A);if(M){var B;return this.lexer.state.inRawBlock?B=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(M[0]):e(M[0]):M[0]:B=e(this.options.smartypants?P(M[0]):M[0]),{type:"text",raw:M[0],text:B}}},N}(),ae={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ae._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ae._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ae.def=D(ae.def).replace("label",ae._label).replace("title",ae._title).getRegex(),ae.bullet=/(?:[*+-]|\d{1,9}[.)])/,ae.listItemStart=D(/^( *)(bull) */).replace("bull",ae.bullet).getRegex(),ae.list=D(ae.list).replace(/bull/g,ae.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ae.def.source+")").getRegex(),ae._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ae._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ae.html=D(ae.html,"i").replace("comment",ae._comment).replace("tag",ae._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ae.paragraph=D(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.blockquote=D(ae.blockquote).replace("paragraph",ae.paragraph).getRegex(),ae.normal=b({},ae),ae.gfm=b({},ae.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ae.gfm.table=D(ae.gfm.table).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.gfm.paragraph=D(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ae.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.pedantic=b({},ae.normal,{html:D(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ae._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:D(ae.normal._paragraph).replace("hr",ae.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ae.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var he={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};he._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",he.punctuation=D(he.punctuation).replace(/punctuation/g,he._punctuation).getRegex(),he.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,he.escapedEmSt=/\\\*|\\_/g,he._comment=D(ae._comment).replace("(?:-->|$)","-->").getRegex(),he.emStrong.lDelim=D(he.emStrong.lDelim).replace(/punct/g,he._punctuation).getRegex(),he.emStrong.rDelimAst=D(he.emStrong.rDelimAst,"g").replace(/punct/g,he._punctuation).getRegex(),he.emStrong.rDelimUnd=D(he.emStrong.rDelimUnd,"g").replace(/punct/g,he._punctuation).getRegex(),he._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,he._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,he._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,he.autolink=D(he.autolink).replace("scheme",he._scheme).replace("email",he._email).getRegex(),he._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,he.tag=D(he.tag).replace("comment",he._comment).replace("attribute",he._attribute).getRegex(),he._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,he._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,he._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,he.link=D(he.link).replace("label",he._label).replace("href",he._href).replace("title",he._title).getRegex(),he.reflink=D(he.reflink).replace("label",he._label).replace("ref",ae._label).getRegex(),he.nolink=D(he.nolink).replace("ref",ae._label).getRegex(),he.reflinkSearch=D(he.reflinkSearch,"g").replace("reflink",he.reflink).replace("nolink",he.nolink).getRegex(),he.normal=b({},he),he.pedantic=b({},he.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:D(/^!?\[(label)\]\((.*?)\)/).replace("label",he._label).getRegex(),reflink:D(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",he._label).getRegex()}),he.gfm=b({},he.normal,{escape:D(he.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),he.gfm.url=D(he.gfm.url,"i").replace("email",he.gfm._extended_email).getRegex(),he.breaks=b({},he.gfm,{br:D(he.br).replace("{2,}","*").getRegex(),text:D(he.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Se(N){return N.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function te(N){var R="",H,A,P=N.length;for(H=0;H<P;H++)A=N.charCodeAt(H),Math.random()>.5&&(A="x"+A.toString(16)),R+="&#"+A+";";return R}var De=function(){function N(H){this.tokens=[],this.tokens.links=Object.create(null),this.options=H||Q.defaults,this.options.tokenizer=this.options.tokenizer||new me,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var A={block:ae.normal,inline:he.normal};this.options.pedantic?(A.block=ae.pedantic,A.inline=he.pedantic):this.options.gfm&&(A.block=ae.gfm,this.options.breaks?A.inline=he.breaks:A.inline=he.gfm),this.tokenizer.rules=A}N.lex=function(A,P){var M=new N(P);return M.lex(A)},N.lexInline=function(A,P){var M=new N(P);return M.inlineTokens(A)};var R=N.prototype;return R.lex=function(A){A=A.replace(/\r\n|\r/g,`
`),this.blockTokens(A,this.tokens);for(var P;P=this.inlineQueue.shift();)this.inlineTokens(P.src,P.tokens);return this.tokens},R.blockTokens=function(A,P){var M=this;P===void 0&&(P=[]),this.options.pedantic?A=A.replace(/\t/g,"    ").replace(/^ +$/gm,""):A=A.replace(/^( *)(\t+)/gm,function(ye,Ee,Re){return Ee+"    ".repeat(Re.length)});for(var B,q,ee,le;A;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ye){return(B=ye.call({lexer:M},A,P))?(A=A.substring(B.raw.length),P.push(B),!0):!1}))){if(B=this.tokenizer.space(A)){A=A.substring(B.raw.length),B.raw.length===1&&P.length>0?P[P.length-1].raw+=`
`:P.push(B);continue}if(B=this.tokenizer.code(A)){A=A.substring(B.raw.length),q=P[P.length-1],q&&(q.type==="paragraph"||q.type==="text")?(q.raw+=`
`+B.raw,q.text+=`
`+B.text,this.inlineQueue[this.inlineQueue.length-1].src=q.text):P.push(B);continue}if(B=this.tokenizer.fences(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.heading(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.hr(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.blockquote(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.list(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.html(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.def(A)){A=A.substring(B.raw.length),q=P[P.length-1],q&&(q.type==="paragraph"||q.type==="text")?(q.raw+=`
`+B.raw,q.text+=`
`+B.raw,this.inlineQueue[this.inlineQueue.length-1].src=q.text):this.tokens.links[B.tag]||(this.tokens.links[B.tag]={href:B.href,title:B.title});continue}if(B=this.tokenizer.table(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.lheading(A)){A=A.substring(B.raw.length),P.push(B);continue}if(ee=A,this.options.extensions&&this.options.extensions.startBlock&&function(){var ye=1/0,Ee=A.slice(1),Re=void 0;M.options.extensions.startBlock.forEach(function(Le){Re=Le.call({lexer:this},Ee),typeof Re=="number"&&Re>=0&&(ye=Math.min(ye,Re))}),ye<1/0&&ye>=0&&(ee=A.substring(0,ye+1))}(),this.state.top&&(B=this.tokenizer.paragraph(ee))){q=P[P.length-1],le&&q.type==="paragraph"?(q.raw+=`
`+B.raw,q.text+=`
`+B.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=q.text):P.push(B),le=ee.length!==A.length,A=A.substring(B.raw.length);continue}if(B=this.tokenizer.text(A)){A=A.substring(B.raw.length),q=P[P.length-1],q&&q.type==="text"?(q.raw+=`
`+B.raw,q.text+=`
`+B.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=q.text):P.push(B);continue}if(A){var de="Infinite loop on byte: "+A.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,P},R.inline=function(A,P){return P===void 0&&(P=[]),this.inlineQueue.push({src:A,tokens:P}),P},R.inlineTokens=function(A,P){var M=this;P===void 0&&(P=[]);var B,q,ee,le=A,de,ye,Ee;if(this.tokens.links){var Re=Object.keys(this.tokens.links);if(Re.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(le))!=null;)Re.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(le=le.slice(0,de.index)+"["+J("a",de[0].length-2)+"]"+le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(le))!=null;)le=le.slice(0,de.index)+"["+J("a",de[0].length-2)+"]"+le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(le))!=null;)le=le.slice(0,de.index)+"++"+le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;A;)if(ye||(Ee=""),ye=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(B=ve.call({lexer:M},A,P))?(A=A.substring(B.raw.length),P.push(B),!0):!1}))){if(B=this.tokenizer.escape(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.tag(A)){A=A.substring(B.raw.length),q=P[P.length-1],q&&B.type==="text"&&q.type==="text"?(q.raw+=B.raw,q.text+=B.text):P.push(B);continue}if(B=this.tokenizer.link(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.reflink(A,this.tokens.links)){A=A.substring(B.raw.length),q=P[P.length-1],q&&B.type==="text"&&q.type==="text"?(q.raw+=B.raw,q.text+=B.text):P.push(B);continue}if(B=this.tokenizer.emStrong(A,le,Ee)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.codespan(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.br(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.del(A)){A=A.substring(B.raw.length),P.push(B);continue}if(B=this.tokenizer.autolink(A,te)){A=A.substring(B.raw.length),P.push(B);continue}if(!this.state.inLink&&(B=this.tokenizer.url(A,te))){A=A.substring(B.raw.length),P.push(B);continue}if(ee=A,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Pe=A.slice(1),ke=void 0;M.options.extensions.startInline.forEach(function(je){ke=je.call({lexer:this},Pe),typeof ke=="number"&&ke>=0&&(ve=Math.min(ve,ke))}),ve<1/0&&ve>=0&&(ee=A.substring(0,ve+1))}(),B=this.tokenizer.inlineText(ee,Se)){A=A.substring(B.raw.length),B.raw.slice(-1)!=="_"&&(Ee=B.raw.slice(-1)),ye=!0,q=P[P.length-1],q&&q.type==="text"?(q.raw+=B.raw,q.text+=B.text):P.push(B);continue}if(A){var Le="Infinite loop on byte: "+A.charCodeAt(0);if(this.options.silent){console.error(Le);break}else throw new Error(Le)}}return P},E(N,null,[{key:"rules",get:function(){return{block:ae,inline:he}}}]),N}(),se=function(){function N(H){this.options=H||Q.defaults}var R=N.prototype;return R.code=function(A,P,M){var B=(P||"").match(/\S*/)[0];if(this.options.highlight){var q=this.options.highlight(A,B);q!=null&&q!==A&&(M=!0,A=q)}return A=A.replace(/\n$/,"")+`
`,B?'<pre><code class="'+this.options.langPrefix+e(B,!0)+'">'+(M?A:e(A,!0))+`</code></pre>
`:"<pre><code>"+(M?A:e(A,!0))+`</code></pre>
`},R.blockquote=function(A){return`<blockquote>
`+A+`</blockquote>
`},R.html=function(A){return A},R.heading=function(A,P,M,B){if(this.options.headerIds){var q=this.options.headerPrefix+B.slug(M);return"<h"+P+' id="'+q+'">'+A+"</h"+P+`>
`}return"<h"+P+">"+A+"</h"+P+`>
`},R.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},R.list=function(A,P,M){var B=P?"ol":"ul",q=P&&M!==1?' start="'+M+'"':"";return"<"+B+q+`>
`+A+"</"+B+`>
`},R.listitem=function(A){return"<li>"+A+`</li>
`},R.checkbox=function(A){return"<input "+(A?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},R.paragraph=function(A){return"<p>"+A+`</p>
`},R.table=function(A,P){return P&&(P="<tbody>"+P+"</tbody>"),`<table>
<thead>
`+A+`</thead>
`+P+`</table>
`},R.tablerow=function(A){return`<tr>
`+A+`</tr>
`},R.tablecell=function(A,P){var M=P.header?"th":"td",B=P.align?"<"+M+' align="'+P.align+'">':"<"+M+">";return B+A+("</"+M+`>
`)},R.strong=function(A){return"<strong>"+A+"</strong>"},R.em=function(A){return"<em>"+A+"</em>"},R.codespan=function(A){return"<code>"+A+"</code>"},R.br=function(){return this.options.xhtml?"<br/>":"<br>"},R.del=function(A){return"<del>"+A+"</del>"},R.link=function(A,P,M){if(A=p(this.options.sanitize,this.options.baseUrl,A),A===null)return M;var B='<a href="'+e(A)+'"';return P&&(B+=' title="'+P+'"'),B+=">"+M+"</a>",B},R.image=function(A,P,M){if(A=p(this.options.sanitize,this.options.baseUrl,A),A===null)return M;var B='<img src="'+A+'" alt="'+M+'"';return P&&(B+=' title="'+P+'"'),B+=this.options.xhtml?"/>":">",B},R.text=function(A){return A},N}(),ie=function(){function N(){}var R=N.prototype;return R.strong=function(A){return A},R.em=function(A){return A},R.codespan=function(A){return A},R.del=function(A){return A},R.html=function(A){return A},R.text=function(A){return A},R.link=function(A,P,M){return""+M},R.image=function(A,P,M){return""+M},R.br=function(){return""},N}(),ce=function(){function N(){this.seen={}}var R=N.prototype;return R.serialize=function(A){return A.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},R.getNextSafeSlug=function(A,P){var M=A,B=0;if(this.seen.hasOwnProperty(M)){B=this.seen[A];do B++,M=A+"-"+B;while(this.seen.hasOwnProperty(M))}return P||(this.seen[A]=B,this.seen[M]=0),M},R.slug=function(A,P){P===void 0&&(P={});var M=this.serialize(A);return this.getNextSafeSlug(M,P.dryrun)},N}(),ne=function(){function N(H){this.options=H||Q.defaults,this.options.renderer=this.options.renderer||new se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ie,this.slugger=new ce}N.parse=function(A,P){var M=new N(P);return M.parse(A)},N.parseInline=function(A,P){var M=new N(P);return M.parseInline(A)};var R=N.prototype;return R.parse=function(A,P){P===void 0&&(P=!0);var M="",B,q,ee,le,de,ye,Ee,Re,Le,ve,Pe,ke,je,He,Ue,Je,it,Me,qe,x=A.length;for(B=0;B<x;B++){if(ve=A[B],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(qe=this.options.extensions.renderers[ve.type].call({parser:this},ve),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){M+=qe||"";continue}switch(ve.type){case"space":continue;case"hr":{M+=this.renderer.hr();continue}case"heading":{M+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,v(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{M+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Re="",Ee="",le=ve.header.length,q=0;q<le;q++)Ee+=this.renderer.tablecell(this.parseInline(ve.header[q].tokens),{header:!0,align:ve.align[q]});for(Re+=this.renderer.tablerow(Ee),Le="",le=ve.rows.length,q=0;q<le;q++){for(ye=ve.rows[q],Ee="",de=ye.length,ee=0;ee<de;ee++)Ee+=this.renderer.tablecell(this.parseInline(ye[ee].tokens),{header:!1,align:ve.align[ee]});Le+=this.renderer.tablerow(Ee)}M+=this.renderer.table(Re,Le);continue}case"blockquote":{Le=this.parse(ve.tokens),M+=this.renderer.blockquote(Le);continue}case"list":{for(Pe=ve.ordered,ke=ve.start,je=ve.loose,le=ve.items.length,Le="",q=0;q<le;q++)Ue=ve.items[q],Je=Ue.checked,it=Ue.task,He="",Ue.task&&(Me=this.renderer.checkbox(Je),je?Ue.tokens.length>0&&Ue.tokens[0].type==="paragraph"?(Ue.tokens[0].text=Me+" "+Ue.tokens[0].text,Ue.tokens[0].tokens&&Ue.tokens[0].tokens.length>0&&Ue.tokens[0].tokens[0].type==="text"&&(Ue.tokens[0].tokens[0].text=Me+" "+Ue.tokens[0].tokens[0].text)):Ue.tokens.unshift({type:"text",text:Me}):He+=Me),He+=this.parse(Ue.tokens,je),Le+=this.renderer.listitem(He,it,Je);M+=this.renderer.list(Le,Pe,ke);continue}case"html":{M+=this.renderer.html(ve.text);continue}case"paragraph":{M+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Le=ve.tokens?this.parseInline(ve.tokens):ve.text;B+1<x&&A[B+1].type==="text";)ve=A[++B],Le+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);M+=P?this.renderer.paragraph(Le):Le;continue}default:{var oe='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(oe);return}else throw new Error(oe)}}}return M},R.parseInline=function(A,P){P=P||this.renderer;var M="",B,q,ee,le=A.length;for(B=0;B<le;B++){if(q=A[B],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[q.type]&&(ee=this.options.extensions.renderers[q.type].call({parser:this},q),ee!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(q.type))){M+=ee||"";continue}switch(q.type){case"escape":{M+=P.text(q.text);break}case"html":{M+=P.html(q.text);break}case"link":{M+=P.link(q.href,q.title,this.parseInline(q.tokens,P));break}case"image":{M+=P.image(q.href,q.title,q.text);break}case"strong":{M+=P.strong(this.parseInline(q.tokens,P));break}case"em":{M+=P.em(this.parseInline(q.tokens,P));break}case"codespan":{M+=P.codespan(q.text);break}case"br":{M+=P.br();break}case"del":{M+=P.del(this.parseInline(q.tokens,P));break}case"text":{M+=P.text(q.text);break}default:{var de='Token with "'+q.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return M},N}();function F(N,R,H){if(typeof N>"u"||N===null)throw new Error("marked(): input parameter is undefined or null");if(typeof N!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(N)+", string expected");if(typeof R=="function"&&(H=R,R=null),R=b({},F.defaults,R||{}),X(R),H){var A=R.highlight,P;try{P=De.lex(N,R)}catch(le){return H(le)}var M=function(de){var ye;if(!de)try{R.walkTokens&&F.walkTokens(P,R.walkTokens),ye=ne.parse(P,R)}catch(Ee){de=Ee}return R.highlight=A,de?H(de):H(null,ye)};if(!A||A.length<3||(delete R.highlight,!P.length))return M();var B=0;F.walkTokens(P,function(le){le.type==="code"&&(B++,setTimeout(function(){A(le.text,le.lang,function(de,ye){if(de)return M(de);ye!=null&&ye!==le.text&&(le.text=ye,le.escaped=!0),B--,B===0&&M()})},0))}),B===0&&M();return}function q(le){if(le.message+=`
Please report this to https://github.com/markedjs/marked.`,R.silent)return"<p>An error occurred:</p><pre>"+e(le.message+"",!0)+"</pre>";throw le}try{var ee=De.lex(N,R);if(R.walkTokens){if(R.async)return Promise.all(F.walkTokens(ee,R.walkTokens)).then(function(){return ne.parse(ee,R)}).catch(q);F.walkTokens(ee,R.walkTokens)}return ne.parse(ee,R)}catch(le){q(le)}}F.options=F.setOptions=function(N){return b(F.defaults,N),y(F.defaults),F},F.getDefaults=C,F.defaults=Q.defaults,F.use=function(){for(var N=arguments.length,R=new Array(N),H=0;H<N;H++)R[H]=arguments[H];var A=b.apply(void 0,[{}].concat(R)),P=F.defaults.extensions||{renderers:{},childTokens:{}},M;R.forEach(function(B){if(B.extensions&&(M=!0,B.extensions.forEach(function(ee){if(!ee.name)throw new Error("extension name required");if(ee.renderer){var le=P.renderers?P.renderers[ee.name]:null;le?P.renderers[ee.name]=function(){for(var de=arguments.length,ye=new Array(de),Ee=0;Ee<de;Ee++)ye[Ee]=arguments[Ee];var Re=ee.renderer.apply(this,ye);return Re===!1&&(Re=le.apply(this,ye)),Re}:P.renderers[ee.name]=ee.renderer}if(ee.tokenizer){if(!ee.level||ee.level!=="block"&&ee.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");P[ee.level]?P[ee.level].unshift(ee.tokenizer):P[ee.level]=[ee.tokenizer],ee.start&&(ee.level==="block"?P.startBlock?P.startBlock.push(ee.start):P.startBlock=[ee.start]:ee.level==="inline"&&(P.startInline?P.startInline.push(ee.start):P.startInline=[ee.start]))}ee.childTokens&&(P.childTokens[ee.name]=ee.childTokens)})),B.renderer&&function(){var ee=F.defaults.renderer||new se,le=function(Ee){var Re=ee[Ee];ee[Ee]=function(){for(var Le=arguments.length,ve=new Array(Le),Pe=0;Pe<Le;Pe++)ve[Pe]=arguments[Pe];var ke=B.renderer[Ee].apply(ee,ve);return ke===!1&&(ke=Re.apply(ee,ve)),ke}};for(var de in B.renderer)le(de);A.renderer=ee}(),B.tokenizer&&function(){var ee=F.defaults.tokenizer||new me,le=function(Ee){var Re=ee[Ee];ee[Ee]=function(){for(var Le=arguments.length,ve=new Array(Le),Pe=0;Pe<Le;Pe++)ve[Pe]=arguments[Pe];var ke=B.tokenizer[Ee].apply(ee,ve);return ke===!1&&(ke=Re.apply(ee,ve)),ke}};for(var de in B.tokenizer)le(de);A.tokenizer=ee}(),B.walkTokens){var q=F.defaults.walkTokens;A.walkTokens=function(ee){var le=[];return le.push(B.walkTokens.call(this,ee)),q&&(le=le.concat(q.call(this,ee))),le}}M&&(A.extensions=P),F.setOptions(A)})},F.walkTokens=function(N,R){for(var H=[],A=function(){var q=M.value;switch(H=H.concat(R.call(F,q)),q.type){case"table":{for(var ee=O(q.header),le;!(le=ee()).done;){var de=le.value;H=H.concat(F.walkTokens(de.tokens,R))}for(var ye=O(q.rows),Ee;!(Ee=ye()).done;)for(var Re=Ee.value,Le=O(Re),ve;!(ve=Le()).done;){var Pe=ve.value;H=H.concat(F.walkTokens(Pe.tokens,R))}break}case"list":{H=H.concat(F.walkTokens(q.items,R));break}default:F.defaults.extensions&&F.defaults.extensions.childTokens&&F.defaults.extensions.childTokens[q.type]?F.defaults.extensions.childTokens[q.type].forEach(function(ke){H=H.concat(F.walkTokens(q[ke],R))}):q.tokens&&(H=H.concat(F.walkTokens(q.tokens,R)))}},P=O(N),M;!(M=P()).done;)A();return H},F.parseInline=function(N,R){if(typeof N>"u"||N===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof N!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(N)+", string expected");R=b({},F.defaults,R||{}),X(R);try{var H=De.lexInline(N,R);return R.walkTokens&&F.walkTokens(H,R.walkTokens),ne.parseInline(H,R)}catch(A){if(A.message+=`
Please report this to https://github.com/markedjs/marked.`,R.silent)return"<p>An error occurred:</p><pre>"+e(A.message+"",!0)+"</pre>";throw A}},F.Parser=ne,F.parser=ne.parse,F.Renderer=se,F.TextRenderer=ie,F.Lexer=De,F.lexer=De.lex,F.Tokenizer=me,F.Slugger=ce,F.parse=F;var V=F.options,j=F.setOptions,k=F.use,h=F.walkTokens,I=F.parseInline,U=F,K=ne.parse,Z=De.lex;Q.Lexer=De,Q.Parser=ne,Q.Renderer=se,Q.Slugger=ce,Q.TextRenderer=ie,Q.Tokenizer=me,Q.getDefaults=C,Q.lexer=Z,Q.marked=F,Q.options=V,Q.parse=U,Q.parseInline=I,Q.parser=K,Q.setOptions=j,Q.use=k,Q.walkTokens=h,Object.defineProperty(Q,"__esModule",{value:!0})}),define(pe[76],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class E{constructor(W,O=0,C=W.length,y=O-1){this.items=W,this.start=O,this.end=C,this.index=y}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=E}),define(pe[77],be([1,0,76]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class i{constructor(C=[],y=10){this._initialize(C),this._limit=y,this._onChange()}getHistory(){return this._elements}add(C){this._history.delete(C),this._history.add(C),this._onChange()}next(){return this._currentPosition()!==this._elements.length-1?this._navigator.next():null}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}has(C){return this._history.has(C)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const C=this._elements;this._navigator=new E.ArrayNavigator(C,0,C.length,C.length)}_reduceToLimit(){const C=this._elements;C.length>this._limit&&this._initialize(C.slice(C.length-this._limit))}_currentPosition(){const C=this._navigator.current();return C?this._elements.indexOf(C):-1}_initialize(C){this._history=new Set;for(const y of C)this._history.add(y)}get _elements(){const C=[];return this._history.forEach(y=>C.push(y)),C}}t.HistoryNavigator=i;class W{constructor(C,y=10){if(this.capacity=y,C.length<1)throw new Error("not supported");this.size=1,this.head=this.tail=this.cursor={value:C[0],previous:void 0,next:void 0};for(let d=1;d<C.length;d++)this.add(C[d])}add(C){const y={value:C,previous:this.tail,next:void 0};for(this.tail.next=y,this.tail=y,this.cursor=this.tail,this.size++;this.size>this.capacity;)this.head=this.head.next,this.head.previous=void 0,this.size--}replaceLast(C){const y=this.tail.value;return this.tail.value=C,y}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(C){let y=this.head;for(;y;){if(y.value===C)return!0;y=y.next}return!1}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let C=this.head;for(;C;)yield C.value,C=C.next}}t.HistoryNavigator2=W}),define(pe[45],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function E(y,d,c){return Math.min(Math.max(y,d),c)}t.clamp=E;function i(y,d){return(d+y%d)%d}t.rot=i;class W{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=W;class O{constructor(){this._n=1,this._val=0}update(d){return this._val=this._val+(d-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=O;class C{constructor(d){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(d),this._values.fill(0,0,d)}update(d){const c=this._values[this._index];return this._values[this._index]=d,this._index=(this._index+1)%this._values.length,this._sum-=c,this._sum+=d,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=C}),define(pe[46],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var E;(function(i){function W(d,c){if(d.start>=c.end||c.start>=d.end)return{start:0,end:0};const g=Math.max(d.start,c.start),L=Math.min(d.end,c.end);return L-g<=0?{start:0,end:0}:{start:g,end:L}}i.intersect=W;function O(d){return d.end-d.start<=0}i.isEmpty=O;function C(d,c){return!O(W(d,c))}i.intersects=C;function y(d,c){const g=[],L={start:d.start,end:Math.min(c.start,d.end)},o={start:Math.max(c.end,d.start),end:d.end};return O(L)||g.push(L),O(o)||g.push(o),g}i.relativeComplement=y})(E=t.Range||(t.Range={}))}),define(pe[78],be([1,0,46]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function i(d,c){const g=[];for(const L of c){if(d.start>=L.range.end)continue;if(d.end<L.range.start)break;const o=E.Range.intersect(d,L.range);E.Range.isEmpty(o)||g.push({range:o,size:L.size})}return g}t.groupIntersect=i;function W({start:d,end:c},g){return{start:d+g,end:c+g}}t.shift=W;function O(d){const c=[];let g=null;for(const L of d){const o=L.range.start,s=L.range.end,e=L.size;if(g&&e===g.size){g.range.end=s;continue}g={range:{start:o,end:s},size:e},c.push(g)}return c}t.consolidate=O;function C(...d){return O(d.reduce((c,g)=>c.concat(g),[]))}class y{constructor(){this.groups=[],this._size=0}splice(c,g,L=[]){const o=L.length-g,s=i({start:0,end:c},this.groups),e=i({start:c+g,end:Number.POSITIVE_INFINITY},this.groups).map(v=>({range:W(v.range,o),size:v.size})),m=L.map((v,w)=>({range:{start:c+w,end:c+w+1},size:v.size}));this.groups=C(s,m,e),this._size=this.groups.reduce((v,w)=>v+w.size*(w.range.end-w.range.start),0)}get count(){const c=this.groups.length;return c?this.groups[c-1].range.end:0}get size(){return this._size}indexAt(c){if(c<0)return-1;let g=0,L=0;for(const o of this.groups){const s=o.range.end-o.range.start,e=L+s*o.size;if(c<e)return g+Math.floor((c-L)/o.size);g+=s,L=e}return g}indexAfter(c){return Math.min(this.indexAt(c)+1,this.count)}positionAt(c){if(c<0)return-1;let g=0,L=0;for(const o of this.groups){const s=o.range.end-o.range.start,e=L+s;if(c<e)return g+(c-L)*o.size;g+=s*o.size,L=e}return-1}}t.RangeMap=y}),define(pe[79],be([1,0,12,2]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function W(u){const p=u;return p?typeof p.read=="function":!1}t.isReadable=W;function O(u){const p=u;return p?[p.on,p.pause,p.resume,p.destroy].every(S=>typeof S=="function"):!1}t.isReadableStream=O;function C(u){const p=u;return p?O(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}t.isReadableBufferedStream=C;function y(u,p){return new d(u,p)}t.newWriteableStream=y;class d{constructor(p,S){this.reducer=p,this.options=S,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(S=>this.pendingWritePromises.push(S))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p<"u"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(S=>S(p))}emitError(p){this.listeners.error.length===0?(0,E.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(S=>S(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,S){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(S),this.resume();break;case"end":this.listeners.end.push(S),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(S),this.state.flowing&&this.flowErrors();break}}removeListener(p,S){if(this.state.destroyed)return;let T;switch(p){case"data":T=this.listeners.data;break;case"end":T=this.listeners.end;break;case"error":T=this.listeners.error;break}if(T){const _=T.indexOf(S);_>=0&&T.splice(_,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const S=[...this.pendingWritePromises];this.pendingWritePromises.length=0,S.forEach(T=>T())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(u,p){const S=[];let T;for(;(T=u.read())!==null;)S.push(T);return p(S)}t.consumeReadable=c;function g(u,p,S){const T=[];let _;for(;(_=u.read())!==null&&T.length<S;)T.push(_);return _===null&&T.length>0?p(T):{read:()=>{if(T.length>0)return T.shift();if(typeof _<"u"){const r=_;return _=void 0,r}return u.read()}}}t.peekReadable=g;function L(u,p){return new Promise((S,T)=>{const _=[];o(u,{onData:r=>{p&&_.push(r)},onError:r=>{p?T(r):S(void 0)},onEnd:()=>{S(p?p(_):void 0)}})})}t.consumeStream=L;function o(u,p){let S=!1;return u.on("error",T=>{S||p.onError(T)}),u.on("end",()=>{S||p.onEnd()}),u.on("data",T=>{S||p.onData(T)}),(0,i.toDisposable)(()=>S=!0)}t.listenStream=o;function s(u,p){return new Promise((S,T)=>{const _=new i.DisposableStore,r=[],n=f=>{if(r.push(f),r.length>p)return _.dispose(),u.pause(),S({stream:u,buffer:r,ended:!1})},l=f=>T(f),b=()=>S({stream:u,buffer:r,ended:!0});_.add((0,i.toDisposable)(()=>u.removeListener("error",l))),u.on("error",l),_.add((0,i.toDisposable)(()=>u.removeListener("end",b))),u.on("end",b),_.add((0,i.toDisposable)(()=>u.removeListener("data",n))),u.on("data",n)})}t.peekStream=s;function e(u,p){const S=y(p);return S.end(u),S}t.toStream=e;function m(){const u=y(()=>{throw new Error("not supported")});return u.end(),u}t.emptyStream=m;function v(u){let p=!1;return{read:()=>p?null:(p=!0,u)}}t.toReadable=v;function w(u,p,S){const T=y(S);return o(u,{onData:_=>T.write(p.data(_)),onError:_=>T.error(p.error?p.error(_):_),onEnd:()=>T.end()}),T}t.transform=w;function D(u,p,S){let T=!1;return{read:()=>{const _=p.read();return T?_:(T=!0,_!==null?S([u,_]):u)}}}t.prefixedReadable=D;function a(u,p,S){let T=!1;const _=y(S);return o(p,{onData:r=>T?_.write(r):(T=!0,_.write(S([u,r]))),onError:r=>_.error(r),onEnd:()=>{T||(T=!0,_.write(u)),_.end()}}),_}t.prefixedStream=a}),define(pe[31],be([1,0,79]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer<"u";let W,O;class C{static alloc(f){return i?new C(Buffer.allocUnsafe(f)):new C(new Uint8Array(f))}static wrap(f){return i&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new C(f)}static fromString(f,z){return!(z?.dontUseNodeBuffer||!1)&&i?new C(Buffer.from(f)):(W||(W=new TextEncoder),new C(W.encode(f)))}static fromByteArray(f){const z=C.alloc(f.length);for(let $=0,X=f.length;$<X;$++)z.buffer[$]=f[$];return z}static concat(f,z){if(typeof z>"u"){z=0;for(let J=0,ge=f.length;J<ge;J++)z+=f[J].byteLength}const $=C.alloc(z);let X=0;for(let J=0,ge=f.length;J<ge;J++){const re=f[J];$.set(re,X),X+=re.byteLength}return $}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=C.alloc(this.byteLength);return f.set(this),f}toString(){return i?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(f,z){return new C(this.buffer.subarray(f,z))}set(f,z){if(f instanceof C)this.buffer.set(f.buffer,z);else if(f instanceof Uint8Array)this.buffer.set(f,z);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),z);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),z);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return c(this.buffer,f)}writeUInt32BE(f,z){g(this.buffer,f,z)}readUInt32LE(f){return L(this.buffer,f)}writeUInt32LE(f,z){o(this.buffer,f,z)}readUInt8(f){return s(this.buffer,f)}writeUInt8(f,z){e(this.buffer,f,z)}}t.VSBuffer=C;function y(b,f){return b[f+0]<<0>>>0|b[f+1]<<8>>>0}t.readUInt16LE=y;function d(b,f,z){b[z+0]=f&255,f=f>>>8,b[z+1]=f&255}t.writeUInt16LE=d;function c(b,f){return b[f]*2**24+b[f+1]*2**16+b[f+2]*2**8+b[f+3]}t.readUInt32BE=c;function g(b,f,z){b[z+3]=f,f=f>>>8,b[z+2]=f,f=f>>>8,b[z+1]=f,f=f>>>8,b[z]=f}t.writeUInt32BE=g;function L(b,f){return b[f+0]<<0>>>0|b[f+1]<<8>>>0|b[f+2]<<16>>>0|b[f+3]<<24>>>0}t.readUInt32LE=L;function o(b,f,z){b[z+0]=f&255,f=f>>>8,b[z+1]=f&255,f=f>>>8,b[z+2]=f&255,f=f>>>8,b[z+3]=f&255}t.writeUInt32LE=o;function s(b,f){return b[f]}t.readUInt8=s;function e(b,f,z){b[z]=f}t.writeUInt8=e;function m(b){return E.consumeReadable(b,f=>C.concat(f))}t.readableToBuffer=m;function v(b){return E.toReadable(b)}t.bufferToReadable=v;function w(b){return E.consumeStream(b,f=>C.concat(f))}t.streamToBuffer=w;async function D(b){return b.ended?C.concat(b.buffer):C.concat([...b.buffer,await w(b.stream)])}t.bufferedStreamToBuffer=D;function a(b){return E.toStream(b,f=>C.concat(f))}t.bufferToStream=a;function u(b){return E.transform(b,{data:f=>typeof f=="string"?C.fromString(f):C.wrap(f)},f=>C.concat(f))}t.streamToBufferReadableStream=u;function p(b){return E.newWriteableStream(f=>C.concat(f),b)}t.newWriteableBufferStream=p;function S(b,f){return E.prefixedReadable(b,f,z=>C.concat(z))}t.prefixedBufferReadable=S;function T(b,f){return E.prefixedStream(b,f,z=>C.concat(z))}t.prefixedBufferStream=T;function _(b){let f=0,z=0,$=0;const X=new Uint8Array(Math.floor(b.length/4*3)),J=re=>{switch(z){case 3:X[$++]=f|re,z=0;break;case 2:X[$++]=f|re>>>2,f=re<<6,z=3;break;case 1:X[$++]=f|re>>>4,f=re<<4,z=2;break;default:f=re<<2,z=1}};for(let re=0;re<b.length;re++){const me=b.charCodeAt(re);if(me>=65&&me<=90)J(me-65);else if(me>=97&&me<=122)J(me-97+26);else if(me>=48&&me<=57)J(me-48+52);else if(me===43||me===45)J(62);else if(me===47||me===95)J(63);else{if(me===61)break;throw new SyntaxError(`Unexpected base64 character ${b[re]}`)}}const ge=$;for(;z>0;)J(0);return C.wrap(X).slice(0,ge)}t.decodeBase64=_;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:b},f=!0,z=!1){const $=z?n:r;let X="";const J=b.byteLength%3;let ge=0;for(;ge<b.byteLength-J;ge+=3){const re=b[ge+0],me=b[ge+1],ae=b[ge+2];X+=$[re>>>2],X+=$[(re<<4|me>>>4)&63],X+=$[(me<<2|ae>>>6)&63],X+=$[ae&63]}if(J===1){const re=b[ge+0];X+=$[re>>>2],X+=$[re<<4&63],f&&(X+="==")}else if(J===2){const re=b[ge+0],me=b[ge+1];X+=$[re>>>2],X+=$[(re<<4|me>>>4)&63],X+=$[me<<2&63],f&&(X+="=")}return X}t.encodeBase64=l}),define(pe[6],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function E(T){return typeof T=="string"}t.isString=E;function i(T){return Array.isArray(T)&&T.every(_=>E(_))}t.isStringArray=i;function W(T){return typeof T=="object"&&T!==null&&!Array.isArray(T)&&!(T instanceof RegExp)&&!(T instanceof Date)}t.isObject=W;function O(T){const _=Object.getPrototypeOf(Uint8Array);return typeof T=="object"&&T instanceof _}t.isTypedArray=O;function C(T){return typeof T=="number"&&!isNaN(T)}t.isNumber=C;function y(T){return!!T&&typeof T[Symbol.iterator]=="function"}t.isIterable=y;function d(T){return T===!0||T===!1}t.isBoolean=d;function c(T){return typeof T>"u"}t.isUndefined=c;function g(T){return!L(T)}t.isDefined=g;function L(T){return c(T)||T===null}t.isUndefinedOrNull=L;function o(T,_){if(!T)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}t.assertType=o;function s(T){if(L(T))throw new Error("Assertion Failed: argument is undefined or null");return T}t.assertIsDefined=s;function e(...T){const _=[];for(let r=0;r<T.length;r++){const n=T[r];if(L(n))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);_.push(n)}return _}t.assertAllDefined=e;const m=Object.prototype.hasOwnProperty;function v(T){if(!W(T))return!1;for(const _ in T)if(m.call(T,_))return!1;return!0}t.isEmptyObject=v;function w(T){return typeof T=="function"}t.isFunction=w;function D(...T){return T.length>0&&T.every(w)}t.areFunctions=D;function a(T,_){const r=Math.min(T.length,_.length);for(let n=0;n<r;n++)u(T[n],_[n])}t.validateConstraints=a;function u(T,_){if(E(_)){if(typeof T!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(w(_)){try{if(T instanceof _)return}catch{}if(!L(T)&&T.constructor===_||_.length===1&&_.call(void 0,T)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=u;function p(T){return T===null?void 0:T}t.withNullAsUndefined=p;function S(T){return typeof T>"u"?null:T}t.withUndefinedAsNull=S}),define(pe[27],be([1,0,6]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function i(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const D=Array.isArray(w)?[]:{};return Object.keys(w).forEach(a=>{w[a]&&typeof w[a]=="object"?D[a]=i(w[a]):D[a]=w[a]}),D}t.deepClone=i;function W(w){if(!w||typeof w!="object")return w;const D=[w];for(;D.length>0;){const a=D.shift();Object.freeze(a);for(const u in a)if(O.call(a,u)){const p=a[u];typeof p=="object"&&!Object.isFrozen(p)&&!(0,E.isTypedArray)(p)&&D.push(p)}}return w}t.deepFreeze=W;const O=Object.prototype.hasOwnProperty;function C(w,D){return y(w,D,new Set)}t.cloneAndChange=C;function y(w,D,a){if((0,E.isUndefinedOrNull)(w))return w;const u=D(w);if(typeof u<"u")return u;if(Array.isArray(w)){const p=[];for(const S of w)p.push(y(S,D,a));return p}if((0,E.isObject)(w)){if(a.has(w))throw new Error("Cannot clone recursive data-structure");a.add(w);const p={};for(const S in w)O.call(w,S)&&(p[S]=y(w[S],D,a));return a.delete(w),p}return w}function d(w,D,a=!0){return(0,E.isObject)(w)?((0,E.isObject)(D)&&Object.keys(D).forEach(u=>{u in w?a&&((0,E.isObject)(w[u])&&(0,E.isObject)(D[u])?d(w[u],D[u],a):w[u]=D[u]):w[u]=D[u]}),w):D}t.mixin=d;function c(w,D){if(w===D)return!0;if(w==null||D===null||D===void 0||typeof w!=typeof D||typeof w!="object"||Array.isArray(w)!==Array.isArray(D))return!1;let a,u;if(Array.isArray(w)){if(w.length!==D.length)return!1;for(a=0;a<w.length;a++)if(!c(w[a],D[a]))return!1}else{const p=[];for(u in w)p.push(u);p.sort();const S=[];for(u in D)S.push(u);if(S.sort(),!c(p,S))return!1;for(a=0;a<p.length;a++)if(!c(w[p[a]],D[p[a]]))return!1}return!0}t.equals=c;function g(w){const D=new Set;return JSON.stringify(w,(a,u)=>{if((0,E.isObject)(u)||Array.isArray(u)){if(D.has(u))return"[Circular]";D.add(u)}return u})}t.safeStringify=g;function L(w,D){const a=Object.create(null);return!w||!D||Object.keys(D).forEach(p=>{const S=w[p],T=D[p];c(S,T)||(a[p]=T)}),a}t.distinct=L;function o(w,D){const a=D.toLowerCase(),u=Object.keys(w).find(p=>p.toLowerCase()===a);return u?w[u]:w[D]}t.getCaseInsensitive=o;function s(w,D){const a=Object.create(null);for(const[u,p]of Object.entries(w))D(u,p)&&(a[u]=p);return a}t.filter=s;function e(w){let D=[],a=Object.getPrototypeOf(w);for(;Object.prototype!==a;)D=D.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return D}t.getAllPropertyNames=e;function m(w){const D=[];for(const a of e(w))typeof w[a]=="function"&&D.push(a);return D}t.getAllMethodNames=m;function v(w,D){const a=p=>function(){const S=Array.prototype.slice.call(arguments,0);return D(p,S)},u={};for(const p of w)u[p]=a(p);return u}t.createProxyObject=v}),define(pe[80],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(pe[81],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class E{constructor(W,O){this.sender=W,this.onMessage=O}send(W){try{this.sender.send("vscode:message",W.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=E}),define(pe[47],be([7]),{}),define(pe[82],be([7]),{}),define(pe[83],be([7]),{}),define(pe[84],be([7]),{}),define(pe[85],be([1,0,11,83,84]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.formatRule=void 0;function i(W){let O=W.definition;for(;O instanceof E.Codicon;)O=O.definition;return`.codicon-${W.id}:before { content: '${O.fontCharacter}'; }`}t.formatRule=i}),define(pe[86],be([7]),{}),define(pe[87],be([7]),{}),define(pe[88],be([7]),{}),define(pe[89],be([7]),{}),define(pe[90],be([7]),{}),define(pe[91],be([7]),{}),define(pe[92],be([7]),{}),define(pe[93],be([7]),{}),define(pe[94],be([7]),{}),define(pe[95],be([13,9]),function(Q,t){return Q.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(pe[96],be([13,9]),function(Q,t){return Q.create("vs/base/browser/ui/findinput/findInput",t)}),define(pe[97],be([13,9]),function(Q,t){return Q.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(pe[98],be([13,9]),function(Q,t){return Q.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(pe[99],be([13,9]),function(Q,t){return Q.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(pe[100],be([13,9]),function(Q,t){return Q.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(pe[101],be([13,9]),function(Q,t){return Q.create("vs/base/browser/ui/tree/abstractTree",t)}),define(pe[102],be([13,9]),function(Q,t){return Q.create("vs/base/common/actions",t)}),define(pe[103],be([13,9]),function(Q,t){return Q.create("vs/base/common/platform",t)}),define(pe[5],be([1,0,103]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=void 0;const i="en";let W=!1,O=!1,C=!1,y=!1,d=!1,c=!1,g=!1,L=!1,o=!1,s=!1,e,m=i,v,w;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let D;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?D=t.globals.vscode.process:typeof process<"u"&&(D=process);const a=typeof D?.versions?.electron=="string",u=a&&D?.type==="renderer";if(typeof navigator=="object"&&!u)w=navigator.userAgent,W=w.indexOf("Windows")>=0,O=w.indexOf("Macintosh")>=0,L=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=w.indexOf("Linux")>=0,s=w?.indexOf("Mobi")>=0,c=!0,e=E.getConfiguredDefaultLocale(E.localize(0,null))||i,m=e;else if(typeof D=="object"){W=D.platform==="win32",O=D.platform==="darwin",C=D.platform==="linux",y=C&&!!D.env.SNAP&&!!D.env.SNAP_REVISION,g=a,o=!!D.env.CI||!!D.env.BUILD_ARTIFACTSTAGINGDIRECTORY,e=i,m=i;const f=D.env.VSCODE_NLS_CONFIG;if(f)try{const z=JSON.parse(f),$=z.availableLanguages["*"];e=z.locale,m=$||i,v=z._translationsConfigFile}catch{}d=!0}else console.error("Unable to resolve platform.");var p;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(p=t.Platform||(t.Platform={}));function S(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=S;let T=0;O?T=1:W?T=3:C&&(T=2),t.isWindows=W,t.isMacintosh=O,t.isLinux=C,t.isLinuxSnap=y,t.isNative=d,t.isElectron=g,t.isWeb=c,t.isWebWorker=c&&typeof t.globals.importScripts=="function",t.isIOS=L,t.isMobile=s,t.isCI=o,t.platform=T,t.userAgent=w,t.language=m;var _;(function(f){function z(){return t.language}f.value=z;function $(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}f.isDefaultVariant=$;function X(){return t.language==="en"}f.isDefault=X})(_=t.Language||(t.Language={})),t.locale=e,t.translationsConfigFile=v,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const f=[];t.globals.addEventListener("message",$=>{if($.data&&$.data.vscodeScheduleAsyncWork)for(let X=0,J=f.length;X<J;X++){const ge=f[X];if(ge.id===$.data.vscodeScheduleAsyncWork){f.splice(X,1),ge.callback();return}}});let z=0;return $=>{const X=++z;f.push({id:X,callback:$}),t.globals.postMessage({vscodeScheduleAsyncWork:X},"*")}}return f=>setTimeout(f)})();var r;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(r=t.OperatingSystem||(t.OperatingSystem={})),t.OS=O||L?2:W?1:3;let n=!0,l=!1;function b(){if(!l){l=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,n=new Uint16Array(f.buffer)[0]===(2<<8)+1}return n}t.isLittleEndian=b,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(pe[104],be([1,0,5]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let i;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const W=E.globals.vscode.process;i={get platform(){return W.platform},get arch(){return W.arch},get env(){return W.env},cwd(){return W.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.platform=i.platform,t.arch=i.arch}),define(pe[21],be([1,0,104]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const i=65,W=97,O=90,C=122,y=46,d=47,c=92,g=58,L=63;class o extends Error{constructor(u,p,S){let T;typeof p=="string"&&p.indexOf("not ")===0?(T="must not be",p=p.replace(/^not /,"")):T="must be";const _=u.indexOf(".")!==-1?"property":"argument";let r=`The "${u}" ${_} ${T} of type ${p}`;r+=`. Received type ${typeof S}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function s(a,u){if(typeof a!="string")throw new o(u,"string",a)}function e(a){return a===d||a===c}function m(a){return a===d}function v(a){return a>=i&&a<=O||a>=W&&a<=C}function w(a,u,p,S){let T="",_=0,r=-1,n=0,l=0;for(let b=0;b<=a.length;++b){if(b<a.length)l=a.charCodeAt(b);else{if(S(l))break;l=d}if(S(l)){if(!(r===b-1||n===1))if(n===2){if(T.length<2||_!==2||T.charCodeAt(T.length-1)!==y||T.charCodeAt(T.length-2)!==y){if(T.length>2){const f=T.lastIndexOf(p);f===-1?(T="",_=0):(T=T.slice(0,f),_=T.length-1-T.lastIndexOf(p)),r=b,n=0;continue}else if(T.length!==0){T="",_=0,r=b,n=0;continue}}u&&(T+=T.length>0?`${p}..`:"..",_=2)}else T.length>0?T+=`${p}${a.slice(r+1,b)}`:T=a.slice(r+1,b),_=b-r-1;r=b,n=0}else l===y&&n!==-1?++n:n=-1}return T}function D(a,u){if(u===null||typeof u!="object")throw new o("pathObject","Object",u);const p=u.dir||u.root,S=u.base||`${u.name||""}${u.ext||""}`;return p?p===u.root?`${p}${S}`:`${p}${a}${S}`:S}t.win32={resolve(...a){let u="",p="",S=!1;for(let T=a.length-1;T>=-1;T--){let _;if(T>=0){if(_=a[T],s(_,"path"),_.length===0)continue}else u.length===0?_=E.cwd():(_=E.env[`=${u}`]||E.cwd(),(_===void 0||_.slice(0,2).toLowerCase()!==u.toLowerCase()&&_.charCodeAt(2)===c)&&(_=`${u}\\`));const r=_.length;let n=0,l="",b=!1;const f=_.charCodeAt(0);if(r===1)e(f)&&(n=1,b=!0);else if(e(f))if(b=!0,e(_.charCodeAt(1))){let z=2,$=z;for(;z<r&&!e(_.charCodeAt(z));)z++;if(z<r&&z!==$){const X=_.slice($,z);for($=z;z<r&&e(_.charCodeAt(z));)z++;if(z<r&&z!==$){for($=z;z<r&&!e(_.charCodeAt(z));)z++;(z===r||z!==$)&&(l=`\\\\${X}\\${_.slice($,z)}`,n=z)}}}else n=1;else v(f)&&_.charCodeAt(1)===g&&(l=_.slice(0,2),n=2,r>2&&e(_.charCodeAt(2))&&(b=!0,n=3));if(l.length>0)if(u.length>0){if(l.toLowerCase()!==u.toLowerCase())continue}else u=l;if(S){if(u.length>0)break}else if(p=`${_.slice(n)}\\${p}`,S=b,b&&u.length>0)break}return p=w(p,!S,"\\",e),S?`${u}\\${p}`:`${u}${p}`||"."},normalize(a){s(a,"path");const u=a.length;if(u===0)return".";let p=0,S,T=!1;const _=a.charCodeAt(0);if(u===1)return m(_)?"\\":a;if(e(_))if(T=!0,e(a.charCodeAt(1))){let n=2,l=n;for(;n<u&&!e(a.charCodeAt(n));)n++;if(n<u&&n!==l){const b=a.slice(l,n);for(l=n;n<u&&e(a.charCodeAt(n));)n++;if(n<u&&n!==l){for(l=n;n<u&&!e(a.charCodeAt(n));)n++;if(n===u)return`\\\\${b}\\${a.slice(l)}\\`;n!==l&&(S=`\\\\${b}\\${a.slice(l,n)}`,p=n)}}}else p=1;else v(_)&&a.charCodeAt(1)===g&&(S=a.slice(0,2),p=2,u>2&&e(a.charCodeAt(2))&&(T=!0,p=3));let r=p<u?w(a.slice(p),!T,"\\",e):"";return r.length===0&&!T&&(r="."),r.length>0&&e(a.charCodeAt(u-1))&&(r+="\\"),S===void 0?T?`\\${r}`:r:T?`${S}\\${r}`:`${S}${r}`},isAbsolute(a){s(a,"path");const u=a.length;if(u===0)return!1;const p=a.charCodeAt(0);return e(p)||u>2&&v(p)&&a.charCodeAt(1)===g&&e(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let u,p;for(let _=0;_<a.length;++_){const r=a[_];s(r,"path"),r.length>0&&(u===void 0?u=p=r:u+=`\\${r}`)}if(u===void 0)return".";let S=!0,T=0;if(typeof p=="string"&&e(p.charCodeAt(0))){++T;const _=p.length;_>1&&e(p.charCodeAt(1))&&(++T,_>2&&(e(p.charCodeAt(2))?++T:S=!1))}if(S){for(;T<u.length&&e(u.charCodeAt(T));)T++;T>=2&&(u=`\\${u.slice(T)}`)}return t.win32.normalize(u)},relative(a,u){if(s(a,"from"),s(u,"to"),a===u)return"";const p=t.win32.resolve(a),S=t.win32.resolve(u);if(p===S||(a=p.toLowerCase(),u=S.toLowerCase(),a===u))return"";let T=0;for(;T<a.length&&a.charCodeAt(T)===c;)T++;let _=a.length;for(;_-1>T&&a.charCodeAt(_-1)===c;)_--;const r=_-T;let n=0;for(;n<u.length&&u.charCodeAt(n)===c;)n++;let l=u.length;for(;l-1>n&&u.charCodeAt(l-1)===c;)l--;const b=l-n,f=r<b?r:b;let z=-1,$=0;for(;$<f;$++){const J=a.charCodeAt(T+$);if(J!==u.charCodeAt(n+$))break;J===c&&(z=$)}if($!==f){if(z===-1)return S}else{if(b>f){if(u.charCodeAt(n+$)===c)return S.slice(n+$+1);if($===2)return S.slice(n+$)}r>f&&(a.charCodeAt(T+$)===c?z=$:$===2&&(z=3)),z===-1&&(z=0)}let X="";for($=T+z+1;$<=_;++$)($===_||a.charCodeAt($)===c)&&(X+=X.length===0?"..":"\\..");return n+=z,X.length>0?`${X}${S.slice(n,l)}`:(S.charCodeAt(n)===c&&++n,S.slice(n,l))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const u=t.win32.resolve(a);if(u.length<=2)return a;if(u.charCodeAt(0)===c){if(u.charCodeAt(1)===c){const p=u.charCodeAt(2);if(p!==L&&p!==y)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(v(u.charCodeAt(0))&&u.charCodeAt(1)===g&&u.charCodeAt(2)===c)return`\\\\?\\${u}`;return a},dirname(a){s(a,"path");const u=a.length;if(u===0)return".";let p=-1,S=0;const T=a.charCodeAt(0);if(u===1)return e(T)?a:".";if(e(T)){if(p=S=1,e(a.charCodeAt(1))){let n=2,l=n;for(;n<u&&!e(a.charCodeAt(n));)n++;if(n<u&&n!==l){for(l=n;n<u&&e(a.charCodeAt(n));)n++;if(n<u&&n!==l){for(l=n;n<u&&!e(a.charCodeAt(n));)n++;if(n===u)return a;n!==l&&(p=S=n+1)}}}}else v(T)&&a.charCodeAt(1)===g&&(p=u>2&&e(a.charCodeAt(2))?3:2,S=p);let _=-1,r=!0;for(let n=u-1;n>=S;--n)if(e(a.charCodeAt(n))){if(!r){_=n;break}}else r=!1;if(_===-1){if(p===-1)return".";_=p}return a.slice(0,_)},basename(a,u){u!==void 0&&s(u,"ext"),s(a,"path");let p=0,S=-1,T=!0,_;if(a.length>=2&&v(a.charCodeAt(0))&&a.charCodeAt(1)===g&&(p=2),u!==void 0&&u.length>0&&u.length<=a.length){if(u===a)return"";let r=u.length-1,n=-1;for(_=a.length-1;_>=p;--_){const l=a.charCodeAt(_);if(e(l)){if(!T){p=_+1;break}}else n===-1&&(T=!1,n=_+1),r>=0&&(l===u.charCodeAt(r)?--r===-1&&(S=_):(r=-1,S=n))}return p===S?S=n:S===-1&&(S=a.length),a.slice(p,S)}for(_=a.length-1;_>=p;--_)if(e(a.charCodeAt(_))){if(!T){p=_+1;break}}else S===-1&&(T=!1,S=_+1);return S===-1?"":a.slice(p,S)},extname(a){s(a,"path");let u=0,p=-1,S=0,T=-1,_=!0,r=0;a.length>=2&&a.charCodeAt(1)===g&&v(a.charCodeAt(0))&&(u=S=2);for(let n=a.length-1;n>=u;--n){const l=a.charCodeAt(n);if(e(l)){if(!_){S=n+1;break}continue}T===-1&&(_=!1,T=n+1),l===y?p===-1?p=n:r!==1&&(r=1):p!==-1&&(r=-1)}return p===-1||T===-1||r===0||r===1&&p===T-1&&p===S+1?"":a.slice(p,T)},format:D.bind(null,"\\"),parse(a){s(a,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return u;const p=a.length;let S=0,T=a.charCodeAt(0);if(p===1)return e(T)?(u.root=u.dir=a,u):(u.base=u.name=a,u);if(e(T)){if(S=1,e(a.charCodeAt(1))){let z=2,$=z;for(;z<p&&!e(a.charCodeAt(z));)z++;if(z<p&&z!==$){for($=z;z<p&&e(a.charCodeAt(z));)z++;if(z<p&&z!==$){for($=z;z<p&&!e(a.charCodeAt(z));)z++;z===p?S=z:z!==$&&(S=z+1)}}}}else if(v(T)&&a.charCodeAt(1)===g){if(p<=2)return u.root=u.dir=a,u;if(S=2,e(a.charCodeAt(2))){if(p===3)return u.root=u.dir=a,u;S=3}}S>0&&(u.root=a.slice(0,S));let _=-1,r=S,n=-1,l=!0,b=a.length-1,f=0;for(;b>=S;--b){if(T=a.charCodeAt(b),e(T)){if(!l){r=b+1;break}continue}n===-1&&(l=!1,n=b+1),T===y?_===-1?_=b:f!==1&&(f=1):_!==-1&&(f=-1)}return n!==-1&&(_===-1||f===0||f===1&&_===n-1&&_===r+1?u.base=u.name=a.slice(r,n):(u.name=a.slice(r,_),u.base=a.slice(r,n),u.ext=a.slice(_,n))),r>0&&r!==S?u.dir=a.slice(0,r-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...a){let u="",p=!1;for(let S=a.length-1;S>=-1&&!p;S--){const T=S>=0?a[S]:E.cwd();s(T,"path"),T.length!==0&&(u=`${T}/${u}`,p=T.charCodeAt(0)===d)}return u=w(u,!p,"/",m),p?`/${u}`:u.length>0?u:"."},normalize(a){if(s(a,"path"),a.length===0)return".";const u=a.charCodeAt(0)===d,p=a.charCodeAt(a.length-1)===d;return a=w(a,!u,"/",m),a.length===0?u?"/":p?"./":".":(p&&(a+="/"),u?`/${a}`:a)},isAbsolute(a){return s(a,"path"),a.length>0&&a.charCodeAt(0)===d},join(...a){if(a.length===0)return".";let u;for(let p=0;p<a.length;++p){const S=a[p];s(S,"path"),S.length>0&&(u===void 0?u=S:u+=`/${S}`)}return u===void 0?".":t.posix.normalize(u)},relative(a,u){if(s(a,"from"),s(u,"to"),a===u||(a=t.posix.resolve(a),u=t.posix.resolve(u),a===u))return"";const p=1,S=a.length,T=S-p,_=1,r=u.length-_,n=T<r?T:r;let l=-1,b=0;for(;b<n;b++){const z=a.charCodeAt(p+b);if(z!==u.charCodeAt(_+b))break;z===d&&(l=b)}if(b===n)if(r>n){if(u.charCodeAt(_+b)===d)return u.slice(_+b+1);if(b===0)return u.slice(_+b)}else T>n&&(a.charCodeAt(p+b)===d?l=b:b===0&&(l=0));let f="";for(b=p+l+1;b<=S;++b)(b===S||a.charCodeAt(b)===d)&&(f+=f.length===0?"..":"/..");return`${f}${u.slice(_+l)}`},toNamespacedPath(a){return a},dirname(a){if(s(a,"path"),a.length===0)return".";const u=a.charCodeAt(0)===d;let p=-1,S=!0;for(let T=a.length-1;T>=1;--T)if(a.charCodeAt(T)===d){if(!S){p=T;break}}else S=!1;return p===-1?u?"/":".":u&&p===1?"//":a.slice(0,p)},basename(a,u){u!==void 0&&s(u,"ext"),s(a,"path");let p=0,S=-1,T=!0,_;if(u!==void 0&&u.length>0&&u.length<=a.length){if(u===a)return"";let r=u.length-1,n=-1;for(_=a.length-1;_>=0;--_){const l=a.charCodeAt(_);if(l===d){if(!T){p=_+1;break}}else n===-1&&(T=!1,n=_+1),r>=0&&(l===u.charCodeAt(r)?--r===-1&&(S=_):(r=-1,S=n))}return p===S?S=n:S===-1&&(S=a.length),a.slice(p,S)}for(_=a.length-1;_>=0;--_)if(a.charCodeAt(_)===d){if(!T){p=_+1;break}}else S===-1&&(T=!1,S=_+1);return S===-1?"":a.slice(p,S)},extname(a){s(a,"path");let u=-1,p=0,S=-1,T=!0,_=0;for(let r=a.length-1;r>=0;--r){const n=a.charCodeAt(r);if(n===d){if(!T){p=r+1;break}continue}S===-1&&(T=!1,S=r+1),n===y?u===-1?u=r:_!==1&&(_=1):u!==-1&&(_=-1)}return u===-1||S===-1||_===0||_===1&&u===S-1&&u===p+1?"":a.slice(u,S)},format:D.bind(null,"/"),parse(a){s(a,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return u;const p=a.charCodeAt(0)===d;let S;p?(u.root="/",S=1):S=0;let T=-1,_=0,r=-1,n=!0,l=a.length-1,b=0;for(;l>=S;--l){const f=a.charCodeAt(l);if(f===d){if(!n){_=l+1;break}continue}r===-1&&(n=!1,r=l+1),f===y?T===-1?T=l:b!==1&&(b=1):T!==-1&&(b=-1)}if(r!==-1){const f=_===0&&p?1:_;T===-1||b===0||b===1&&T===r-1&&T===_+1?u.base=u.name=a.slice(f,r):(u.name=a.slice(f,T),u.base=a.slice(f,r),u.ext=a.slice(T,r))}return _>0?u.dir=a.slice(0,_-1):p&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=E.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=E.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=E.platform==="win32"?t.win32.join:t.posix.join,t.resolve=E.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=E.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=E.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=E.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=E.platform==="win32"?t.win32.extname:t.posix.extname,t.format=E.platform==="win32"?t.win32.format:t.posix.format,t.parse=E.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=E.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=E.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=E.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),define(pe[105],be([1,0,21]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},W={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(g){const L=(0,E.extname)(g),o=i[L.toLowerCase()];return o!==void 0?o:C(g)}t.getMediaOrTextMime=O;function C(g){const L=(0,E.extname)(g);return W[L.toLowerCase()]}t.getMediaMime=C;function y(g){for(const L in W)if(W[L]===g)return L}t.getExtensionForMimeType=y;const d=/^(.+)\/(.+?)(;.+)?$/;function c(g,L){const o=d.exec(g);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:L?void 0:g}t.normalizeMimeType=c}),define(pe[106],be([1,0,5]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=E.globals.performance&&typeof E.globals.performance.now=="function";class W{static create(C=!0){return new W(C)}constructor(C){this._highResolution=i&&C,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}t.StopWatch=W}),define(pe[3],be([1,0,12,42,2,74,106]),function(Q,t,E,i,W,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const y=!1,d=!1;var c;(function(l){l.None=()=>W.Disposable.None;function b(h){if(d){const{onListenerDidAdd:I}=h,U=e.create();let K=0;h.onListenerDidAdd=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),I?.()}}}function f(h){return(I,U=null,K)=>{let Z=!1,N;return N=h(R=>{if(!Z)return N?N.dispose():Z=!0,I.call(U,R)},null,K),Z&&N.dispose(),N}}l.once=f;function z(h,I,U){return me((K,Z=null,N)=>h(R=>K.call(Z,I(R)),null,N),U)}l.map=z;function $(h,I,U){return me((K,Z=null,N)=>h(R=>{I(R),K.call(Z,R)},null,N),U)}l.forEach=$;function X(h,I,U){return me((K,Z=null,N)=>h(R=>I(R)&&K.call(Z,R),null,N),U)}l.filter=X;function J(h){return h}l.signal=J;function ge(...h){return(I,U=null,K)=>(0,W.combinedDisposable)(...h.map(Z=>Z(N=>I.call(U,N),null,K)))}l.any=ge;function re(h,I,U,K){let Z=U;return z(h,N=>(Z=I(Z,N),Z),K)}l.reduce=re;function me(h,I){let U;const K={onFirstListenerAdd(){U=h(Z.fire,Z)},onLastListenerRemove(){U?.dispose()}};I||b(K);const Z=new v(K);return I?.add(Z),Z.event}function ae(h,I,U=100,K=!1,Z,N){let R,H,A,P=0;const M={leakWarningThreshold:Z,onFirstListenerAdd(){R=h(q=>{P++,H=I(H,q),K&&!A&&(B.fire(H),H=void 0),clearTimeout(A),A=setTimeout(()=>{const ee=H;H=void 0,A=void 0,(!K||P>1)&&B.fire(ee),P=0},U)})},onLastListenerRemove(){R.dispose()}};N||b(M);const B=new v(M);return N?.add(B),B.event}l.debounce=ae;function he(h,I=(K,Z)=>K===Z,U){let K=!0,Z;return X(h,N=>{const R=K||!I(N,Z);return K=!1,Z=N,R},U)}l.latch=he;function Se(h,I,U){return[l.filter(h,I,U),l.filter(h,K=>!I(K),U)]}l.split=Se;function te(h,I=!1,U=[]){let K=U.slice(),Z=h(H=>{K?K.push(H):R.fire(H)});const N=()=>{K?.forEach(H=>R.fire(H)),K=null},R=new v({onFirstListenerAdd(){Z||(Z=h(H=>R.fire(H)))},onFirstListenerDidAdd(){K&&(I?setTimeout(N):N())},onLastListenerRemove(){Z&&Z.dispose(),Z=null}});return R.event}l.buffer=te;class De{constructor(I){this.event=I,this.disposables=new W.DisposableStore}map(I){return new De(z(this.event,I,this.disposables))}forEach(I){return new De($(this.event,I,this.disposables))}filter(I){return new De(X(this.event,I,this.disposables))}reduce(I,U){return new De(re(this.event,I,U,this.disposables))}latch(){return new De(he(this.event,void 0,this.disposables))}debounce(I,U=100,K=!1,Z){return new De(ae(this.event,I,U,K,Z,this.disposables))}on(I,U,K){return this.event(I,U,K)}once(I,U,K){return f(this.event)(I,U,K)}dispose(){this.disposables.dispose()}}function se(h){return new De(h)}l.chain=se;function ie(h,I,U=K=>K){const K=(...H)=>R.fire(U(...H)),Z=()=>h.on(I,K),N=()=>h.removeListener(I,K),R=new v({onFirstListenerAdd:Z,onLastListenerRemove:N});return R.event}l.fromNodeEventEmitter=ie;function ce(h,I,U=K=>K){const K=(...H)=>R.fire(U(...H)),Z=()=>h.addEventListener(I,K),N=()=>h.removeEventListener(I,K),R=new v({onFirstListenerAdd:Z,onLastListenerRemove:N});return R.event}l.fromDOMEventEmitter=ce;function ne(h){return new Promise(I=>f(h)(I))}l.toPromise=ne;function F(h,I){return I(void 0),h(U=>I(U))}l.runAndSubscribe=F;function V(h,I){let U=null;function K(N){U?.dispose(),U=new W.DisposableStore,I(N,U)}K(void 0);const Z=h(N=>K(N));return(0,W.toDisposable)(()=>{Z.dispose(),U?.dispose()})}l.runAndSubscribeWithStore=V;class j{constructor(I,U){this.obs=I,this._counter=0,this._hasChanged=!1;const K={onFirstListenerAdd:()=>{I.addObserver(this)},onLastListenerRemove:()=>{I.removeObserver(this)}};U||b(K),this.emitter=new v(K),U&&U.add(this.emitter)}beginUpdate(I){this._counter++}handleChange(I,U){this._hasChanged=!0}endUpdate(I){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function k(h,I){return new j(h,I).emitter.event}l.fromObservable=k})(c=t.Event||(t.Event={}));class g{constructor(b){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${b}_${g._idPool++}`,g.all.add(this)}start(b){this._stopWatch=new C.StopWatch(!0),this.listenerCount=b}stop(){if(this._stopWatch){const b=this._stopWatch.elapsed();this.durations.push(b),this.elapsedOverall+=b,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=g,g.all=new Set,g._idPool=0;let L=-1;function o(l){const b=L;return L=l,{dispose(){L=b}}}t.setGlobalLeakWarningThreshold=o;class s{constructor(b,f=Math.random().toString(18).slice(2,5)){this.customThreshold=b,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(b,f){let z=L;if(typeof this.customThreshold=="number"&&(z=this.customThreshold),z<=0||f<z)return;this._stacks||(this._stacks=new Map);const $=this._stacks.get(b.value)||0;if(this._stacks.set(b.value,$+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=z*.5;let X,J=0;for(const[ge,re]of this._stacks)(!X||J<re)&&(X=ge,J=re);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${J}):`),console.warn(X)}return()=>{const X=this._stacks.get(b.value)||0;this._stacks.set(b.value,X-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(b){this.value=b}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m{constructor(b,f,z){this.callback=b,this.callbackThis=f,this.stack=z,this.subscription=new W.SafeDisposable}invoke(b){this.callback.call(this.callbackThis,b)}}class v{constructor(b){this._disposed=!1,this._options=b,this._leakageMon=L>0?new s(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new g(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(y){const b=Array.from(this._listeners);queueMicrotask(()=>{for(const f of b)f.subscription.isset()&&(f.subscription.unset(),f.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(b,f,z)=>{this._listeners||(this._listeners=new O.LinkedList);const $=this._listeners.isEmpty();$&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let X,J;this._leakageMon&&this._listeners.size>=30&&(J=e.create(),X=this._leakageMon.check(J,this._listeners.size+1)),y&&(J=J??e.create());const ge=new m(b,f,J),re=this._listeners.push(ge);$&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,b,f);const me=ge.subscription.set(()=>{X?.(),this._disposed||(re(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return z instanceof W.DisposableStore?z.add(me):Array.isArray(z)&&z.push(me),me}),this._event}fire(b){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new D);for(const f of this._listeners)this._deliveryQueue.push(this,f,b);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}t.Emitter=v;class w{constructor(){this._queue=new O.LinkedList}get size(){return this._queue.size}push(b,f,z){this._queue.push(new a(b,f,z))}clear(b){const f=new O.LinkedList;for(const z of this._queue)z.emitter!==b&&f.push(z);this._queue=f}deliver(){for(;this._queue.size>0;){const b=this._queue.shift();try{b.listener.invoke(b.event)}catch(f){(0,E.onUnexpectedError)(f)}}}}t.EventDeliveryQueue=w;class D extends w{clear(b){this._queue.clear()}}class a{constructor(b,f,z){this.emitter=b,this.listener=f,this.event=z}}class u extends v{async fireAsync(b,f,z){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new O.LinkedList);for(const $ of this._listeners)this._asyncDeliveryQueue.push([$,b]);for(;this._asyncDeliveryQueue.size>0&&!f.isCancellationRequested;){const[$,X]=this._asyncDeliveryQueue.shift(),J=[],ge={...X,token:f,waitUntil:re=>{if(Object.isFrozen(J))throw new Error("waitUntil can NOT be called asynchronous");z&&(re=z(re,$.callback)),J.push(re)}};try{$.invoke(ge)}catch(re){(0,E.onUnexpectedError)(re);continue}Object.freeze(J),await Promise.allSettled(J).then(re=>{for(const me of re)me.status==="rejected"&&(0,E.onUnexpectedError)(me.reason)})}}}}t.AsyncEmitter=u;class p extends v{constructor(b){super(b),this._isPaused=0,this._eventQueue=new O.LinkedList,this._mergeFn=b?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const b=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(b))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(b){this._listeners&&(this._isPaused!==0?this._eventQueue.push(b):super.fire(b))}}t.PauseableEmitter=p;class S extends p{constructor(b){super(b),this._delay=b.delay??100}fire(b){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(b)}}t.DebounceEmitter=S;class T extends v{constructor(b){super(b),this._queuedEvents=[],this._mergeFn=b?.merge}fire(b){!this.hasListeners()||(this._queuedEvents.push(b),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(f=>super.fire(f)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=T;class _{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(b){const f={event:b,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const z=()=>{this.hasListeners&&this.unhook(f);const $=this.events.indexOf(f);this.events.splice($,1)};return(0,W.toDisposable)((0,i.once)(z))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(b=>this.hook(b))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(b=>this.unhook(b))}hook(b){b.listener=b.event(f=>this.emitter.fire(f))}unhook(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=_;class r{constructor(){this.buffers=[]}wrapEvent(b){return(f,z,$)=>b(X=>{const J=this.buffers[this.buffers.length-1];J?J.push(()=>f.call(z,X)):f.call(z,X)},void 0,$)}bufferEvents(b){const f=[];this.buffers.push(f);const z=b();return this.buffers.pop(),f.forEach($=>$()),z}}t.EventBufferer=r;class n{constructor(){this.listening=!1,this.inputEvent=c.None,this.inputEventListener=W.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(b){this.inputEvent=b,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=b(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=n}),define(pe[15],be([1,0,3,2]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class W{constructor(){this._zoomLevel=0,this._zoomFactor=1,this._fullscreen=!1,this._onDidChangeFullscreen=new E.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event}getZoomLevel(){return this._zoomLevel}setZoomLevel(a,u){this._zoomLevel!==a&&(this._zoomLevel=a)}getZoomFactor(){return this._zoomFactor}setZoomFactor(a){this._zoomFactor=a}setFullscreen(a){this._fullscreen!==a&&(this._fullscreen=a,this._onDidChangeFullscreen.fire())}isFullscreen(){return this._fullscreen}}W.INSTANCE=new W;class O extends i.Disposable{constructor(){super(),this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this._listener=()=>this._handleChange(!0),this._mediaQueryList=null,this._handleChange(!1)}_handleChange(a){this._mediaQueryList?.removeEventListener("change",this._listener),this._mediaQueryList=matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this._mediaQueryList.addEventListener("change",this._listener),a&&this._onDidChange.fire()}}class C extends i.Disposable{get value(){return this._value}constructor(){super(),this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this._value=this._getPixelRatio();const a=this._register(new O);this._register(a.onDidChange(()=>{this._value=this._getPixelRatio(),this._onDidChange.fire(this._value)}))}_getPixelRatio(){const a=document.createElement("canvas").getContext("2d"),u=window.devicePixelRatio||1,p=a.webkitBackingStorePixelRatio||a.mozBackingStorePixelRatio||a.msBackingStorePixelRatio||a.oBackingStorePixelRatio||a.backingStorePixelRatio||1;return u/p}}class y{constructor(){this._pixelRatioMonitor=null}_getOrCreatePixelRatioMonitor(){return this._pixelRatioMonitor||(this._pixelRatioMonitor=(0,i.markAsSingleton)(new C)),this._pixelRatioMonitor}get value(){return this._getOrCreatePixelRatioMonitor().value}get onDidChange(){return this._getOrCreatePixelRatioMonitor().onDidChange}}function d(D,a){typeof D=="string"&&(D=window.matchMedia(D)),D.addEventListener("change",a)}t.addMatchMediaChangeListener=d,t.PixelRatio=new y;function c(D,a){W.INSTANCE.setZoomLevel(D,a)}t.setZoomLevel=c;function g(){return W.INSTANCE.getZoomLevel()}t.getZoomLevel=g;function L(){return W.INSTANCE.getZoomFactor()}t.getZoomFactor=L;function o(D){W.INSTANCE.setZoomFactor(D)}t.setZoomFactor=o;function s(D){W.INSTANCE.setFullscreen(D)}t.setFullscreen=s;function e(){return W.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=W.INSTANCE.onDidChangeFullscreen;const m=navigator.userAgent;t.isFirefox=m.indexOf("Firefox")>=0,t.isWebKit=m.indexOf("AppleWebKit")>=0,t.isChrome=m.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&m.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=m.indexOf("Electron/")>=0,t.isAndroid=m.indexOf("Android")>=0;let v=!1;if(window.matchMedia){const D=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),a=window.matchMedia("(display-mode: fullscreen)");v=D.matches,d(D,({matches:u})=>{v&&a.matches||(v=u)})}function w(){return v}t.isStandalone=w}),define(pe[107],be([1,0,15,5]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var W;(function(O){O[O.Always=0]="Always",O[O.FullScreen=1]="FullScreen",O[O.None=2]="None"})(W=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:i.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.isNative||E.isStandalone()?0:navigator.keyboard||E.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(pe[18],be([1,0,3]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class i{get event(){return this.emitter.event}constructor(O,C,y){const d=c=>this.emitter.fire(c);this.emitter=new E.Emitter({onFirstListenerAdd:()=>O.addEventListener(C,d,y),onLastListenerRemove:()=>O.removeEventListener(C,d,y)})}dispose(){this.emitter.dispose()}}t.DomEmitter=i}),define(pe[19],be([1,0,15,43,73,5]),function(Q,t,E,i,W,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function C(e){if(e.charCode){const v=String.fromCharCode(e.charCode).toUpperCase();return i.KeyCodeUtils.fromString(v)}const m=e.keyCode;if(m===3)return 7;if(E.isFirefox){if(m===59)return 80;if(m===107)return 81;if(m===109)return 83;if(O.isMacintosh&&m===224)return 57}else if(E.isWebKit){if(m===91)return 57;if(O.isMacintosh&&m===93)return 57;if(!O.isMacintosh&&m===92)return 57}return i.EVENT_KEY_CODE_MAP[m]||0}const y=O.isMacintosh?256:2048,d=512,c=1024,g=O.isMacintosh?2048:256;function L(e){const m=[];return e.ctrlKey&&m.push("ctrl"),e.shiftKey&&m.push("shift"),e.altKey&&m.push("alt"),e.metaKey&&m.push("meta"),`modifiers: [${m.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=L;function o(e){const m=[];return e.ctrlKey&&m.push("ctrl"),e.shiftKey&&m.push("shift"),e.altKey&&m.push("alt"),e.metaKey&&m.push("meta"),`modifiers: [${m.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${i.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=o;class s{constructor(m){this._standardKeyboardEventBrand=!0;const v=m;this.browserEvent=v,this.target=v.target,this.ctrlKey=v.ctrlKey,this.shiftKey=v.shiftKey,this.altKey=v.altKey,this.metaKey=v.metaKey,this.keyCode=C(v),this.code=v.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this._asKeybinding=this._computeKeybinding(),this._asRuntimeKeybinding=this._computeRuntimeKeybinding()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeybinding(){return this._asRuntimeKeybinding}equals(m){return this._asKeybinding===m}_computeKeybinding(){let m=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(m=this.keyCode);let v=0;return this.ctrlKey&&(v|=y),this.altKey&&(v|=d),this.shiftKey&&(v|=c),this.metaKey&&(v|=g),v|=m,v}_computeRuntimeKeybinding(){let m=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(m=this.keyCode),new W.SimpleKeybinding(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,m)}}t.StandardKeyboardEvent=s}),define(pe[20],be([1,0,15,66,5]),function(Q,t,E,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class O{constructor(c){this.timestamp=Date.now(),this.browserEvent=c,this.leftButton=c.button===0,this.middleButton=c.button===1,this.rightButton=c.button===2,this.buttons=c.buttons,this.target=c.target,this.detail=c.detail||1,c.type==="dblclick"&&(this.detail=2),this.ctrlKey=c.ctrlKey,this.shiftKey=c.shiftKey,this.altKey=c.altKey,this.metaKey=c.metaKey,typeof c.pageX=="number"?(this.posx=c.pageX,this.posy=c.pageY):(this.posx=c.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=c.clientY+document.body.scrollTop+document.documentElement.scrollTop);const g=i.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,c.view);this.posx-=g.left,this.posy-=g.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=O;class C extends O{constructor(c){super(c),this.dataTransfer=c.dataTransfer}}t.DragMouseEvent=C;class y{constructor(c,g=0,L=0){if(this.browserEvent=c||null,this.target=c?c.target||c.targetNode||c.srcElement:null,this.deltaY=L,this.deltaX=g,c){const o=c,s=c;if(typeof o.wheelDeltaY<"u")this.deltaY=o.wheelDeltaY/120;else if(typeof s.VERTICAL_AXIS<"u"&&s.axis===s.VERTICAL_AXIS)this.deltaY=-s.detail/3;else if(c.type==="wheel"){const e=c;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!W.isMacintosh?this.deltaY=-c.deltaY/3:this.deltaY=-c.deltaY:this.deltaY=-c.deltaY/40}if(typeof o.wheelDeltaX<"u")E.isSafari&&W.isWindows?this.deltaX=-(o.wheelDeltaX/120):this.deltaX=o.wheelDeltaX/120;else if(typeof s.HORIZONTAL_AXIS<"u"&&s.axis===s.HORIZONTAL_AXIS)this.deltaX=-c.detail/3;else if(c.type==="wheel"){const e=c;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!W.isMacintosh?this.deltaX=-c.deltaX/3:this.deltaX=-c.deltaX:this.deltaX=-c.deltaX/40}this.deltaY===0&&this.deltaX===0&&c.wheelDelta&&(this.deltaY=c.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=y}),define(pe[32],be([1,0,3,2,102]),function(Q,t,E,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class O extends i.Disposable{constructor(o,s="",e="",m=!0,v){super(),this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=o,this._label=s,this._cssClass=e,this._enabled=m,this._actionCallback=v}get id(){return this._id}get label(){return this._label}set label(o){this._setLabel(o)}_setLabel(o){this._label!==o&&(this._label=o,this._onDidChange.fire({label:o}))}get tooltip(){return this._tooltip||""}set tooltip(o){this._setTooltip(o)}_setTooltip(o){this._tooltip!==o&&(this._tooltip=o,this._onDidChange.fire({tooltip:o}))}get class(){return this._cssClass}set class(o){this._setClass(o)}_setClass(o){this._cssClass!==o&&(this._cssClass=o,this._onDidChange.fire({class:o}))}get enabled(){return this._enabled}set enabled(o){this._setEnabled(o)}_setEnabled(o){this._enabled!==o&&(this._enabled=o,this._onDidChange.fire({enabled:o}))}get checked(){return this._checked}set checked(o){this._setChecked(o)}_setChecked(o){this._checked!==o&&(this._checked=o,this._onDidChange.fire({checked:o}))}async run(o,s){this._actionCallback&&await this._actionCallback(o)}}t.Action=O;class C extends i.Disposable{constructor(){super(...arguments),this._onWillRun=this._register(new E.Emitter),this.onWillRun=this._onWillRun.event,this._onDidRun=this._register(new E.Emitter),this.onDidRun=this._onDidRun.event}async run(o,s){if(!o.enabled)return;this._onWillRun.fire({action:o});let e;try{await this.runAction(o,s)}catch(m){e=m}this._onDidRun.fire({action:o,error:e})}async runAction(o,s){await o.run(s)}}t.ActionRunner=C;class y extends O{static join(...o){let s=[];for(const e of o)e.length&&(s.length?s=[...s,new y,...e]:s=e);return s}constructor(o){super(y.ID,o,o?"separator text":"separator"),this.checked=!1,this.enabled=!1}}t.Separator=y,y.ID="vs.actions.separator";class d{get actions(){return this._actions}constructor(o,s,e,m){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=o,this.label=s,this.class=m,this._actions=e}async run(){}}t.SubmenuAction=d;class c extends O{constructor(){super(c.ID,W.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=c,c.ID="vs.actions.empty";function g(L){return{id:L.id,label:L.label,class:void 0,enabled:L.enabled??!0,checked:L.checked??!1,run:async()=>L.run(),tooltip:L.label}}t.toAction=g}),define(pe[28],be([1,0,3]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const i=Object.freeze(function(y,d){const c=setTimeout(y.bind(d),0);return{dispose(){clearTimeout(c)}}});var W;(function(y){function d(c){return c===y.None||c===y.Cancelled||c instanceof O?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}y.isCancellationToken=d,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(W=t.CancellationToken||(t.CancellationToken={}));class O{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new O),this._token}cancel(){this._token?this._token instanceof O&&this._token.cancel():this._token=W.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof O&&this._token.dispose():this._token=W.None}}t.CancellationTokenSource=C}),define(pe[108],be([1,0,28]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class i{constructor(y){this.task=y,this.result=null}get(){if(this.result)return this.result;const y=new E.CancellationTokenSource,d=this.task(y.token);return this.result={promise:d,dispose:()=>{this.result=null,y.cancel(),y.dispose()}},this.result}}t.Cache=i;class W{constructor(y){this.fn=y,this.lastCache=void 0,this.lastArgKey=void 0}get(y){const d=JSON.stringify(y);return this.lastArgKey!==d&&(this.lastArgKey=d,this.lastCache=this.fn(y)),this.lastCache}}t.LRUCachedFunction=W;class O{get cachedValues(){return this._map}constructor(y){this.fn=y,this._map=new Map}get(y){if(this._map.has(y))return this._map.get(y);const d=this.fn(y);return this._map.set(y,d),d}}t.CachedFunction=O}),define(pe[48],be([1,0,3,2]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var W;(function(s){s[s.Auto=1]="Auto",s[s.Hidden=2]="Hidden",s[s.Visible=3]="Visible"})(W=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class O{constructor(e,m,v,w,D,a,u){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(m=m|0,v=v|0,w=w|0,D=D|0,a=a|0,u=u|0),this.rawScrollLeft=w,this.rawScrollTop=u,m<0&&(m=0),w+m>v&&(w=v-m),w<0&&(w=0),D<0&&(D=0),u+D>a&&(u=a-D),u<0&&(u=0),this.width=m,this.scrollWidth=v,this.scrollLeft=w,this.height=D,this.scrollHeight=a,this.scrollTop=u}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,m){return new O(this._forceIntegerValues,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,m?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,m?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new O(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,m){const v=this.width!==e.width,w=this.scrollWidth!==e.scrollWidth,D=this.scrollLeft!==e.scrollLeft,a=this.height!==e.height,u=this.scrollHeight!==e.scrollHeight,p=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:m,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:v,scrollWidthChanged:w,scrollLeftChanged:D,heightChanged:a,scrollHeightChanged:u,scrollTopChanged:p}}}t.ScrollState=O;class C extends i.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this._onScroll=this._register(new E.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new O(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,m){const v=this._state.withScrollDimensions(e,m);this._setState(v,Boolean(this._smoothScrolling)),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const m=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(m,!1)}setScrollPositionSmooth(e,m){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft>"u"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this._smoothScrolling.to.scrollTop:e.scrollTop};const v=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===v.scrollLeft&&this._smoothScrolling.to.scrollTop===v.scrollTop)return;let w;m?w=new g(this._smoothScrolling.from,v,this._smoothScrolling.startTime,this._smoothScrolling.duration):w=this._smoothScrolling.combine(this._state,v,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=w}else{const v=this._state.withScrollPosition(e);this._smoothScrolling=g.start(this._state,v,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),m=this._state.withScrollPosition(e);if(this._setState(m,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,m){const v=this._state;v.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(v,m)))}}t.Scrollable=C;class y{constructor(e,m,v){this.scrollLeft=e,this.scrollTop=m,this.isDone=v}}t.SmoothScrollingUpdate=y;function d(s,e){const m=e-s;return function(v){return s+m*o(v)}}function c(s,e,m){return function(v){return v<m?s(v/m):e((v-m)/(1-m))}}class g{constructor(e,m,v,w){this.from=e,this.to=m,this.duration=w,this.startTime=v,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,m,v){if(Math.abs(e-m)>2.5*v){let D,a;return e<m?(D=e+.75*v,a=m-.75*v):(D=e-.75*v,a=m+.75*v),c(d(e,D),d(a,m),.33)}return d(e,m)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const m=(e-this.startTime)/this.duration;if(m<1){const v=this.scrollLeft(m),w=this.scrollTop(m);return new y(v,w,!1)}return new y(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,m,v){return g.start(e,m,v)}static start(e,m,v){v=v+10;const w=Date.now()-10;return new g(e,m,w,v)}}t.SmoothScrollingOperation=g;function L(s){return Math.pow(s,3)}function o(s){return 1-L(1-s)}}),define(pe[10],be([1,0,108,44]),function(Q,t,E,i){"use strict";var W;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function O(x){return!x||typeof x!="string"?!0:x.trim().length===0}t.isFalsyOrWhitespace=O;const C=/{(\d+)}/g;function y(x,...oe){return oe.length===0?x:x.replace(C,function(we,Ce){const Ae=parseInt(Ce,10);return isNaN(Ae)||Ae<0||Ae>=oe.length?we:oe[Ae]})}t.format=y;const d=/{([^}]+)}/g;function c(x,oe){return x.replace(d,(we,Ce)=>oe[Ce]??we)}t.format2=c;function g(x){return x.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}t.escape=g;function L(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=L;function o(x,oe){let we=0;const Ce=oe.charCodeAt(0);for(let Ae=x.length-1;Ae>=0;Ae--)x.charCodeAt(Ae)===Ce&&we++;return we}t.count=o;function s(x,oe,we="\u2026"){return x.length<=oe?x:`${x.substr(0,oe)}${we}`}t.truncate=s;function e(x,oe=" "){const we=m(x,oe);return v(we,oe)}t.trim=e;function m(x,oe){if(!x||!oe)return x;const we=oe.length;if(we===0||x.length===0)return x;let Ce=0;for(;x.indexOf(oe,Ce)===Ce;)Ce=Ce+we;return x.substring(Ce)}t.ltrim=m;function v(x,oe){if(!x||!oe)return x;const we=oe.length,Ce=x.length;if(we===0||Ce===0)return x;let Ae=Ce,Oe=-1;for(;Oe=x.lastIndexOf(oe,Ae-1),!(Oe===-1||Oe+we!==Ae);){if(Oe===0)return"";Ae=Oe}return x.substring(0,Ae)}t.rtrim=v;function w(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=w;function D(x){return x.replace(/\*/g,"")}t.stripWildcards=D;function a(x,oe,we={}){if(!x)throw new Error("Cannot create regex from empty string");oe||(x=L(x)),we.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Ce="";return we.global&&(Ce+="g"),we.matchCase||(Ce+="i"),we.multiline&&(Ce+="m"),we.unicode&&(Ce+="u"),new RegExp(x,Ce)}t.createRegExp=a;function u(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}t.regExpLeadsToEndlessLoop=u;function p(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=p;function S(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}t.regExpFlags=S;function T(x){return x.split(/\r\n|\r|\n/)}t.splitLines=T;function _(x){for(let oe=0,we=x.length;oe<we;oe++){const Ce=x.charCodeAt(oe);if(Ce!==32&&Ce!==9)return oe}return-1}t.firstNonWhitespaceIndex=_;function r(x,oe=0,we=x.length){for(let Ce=oe;Ce<we;Ce++){const Ae=x.charCodeAt(Ce);if(Ae!==32&&Ae!==9)return x.substring(oe,Ce)}return x.substring(oe,we)}t.getLeadingWhitespace=r;function n(x,oe=x.length-1){for(let we=oe;we>=0;we--){const Ce=x.charCodeAt(we);if(Ce!==32&&Ce!==9)return we}return-1}t.lastNonWhitespaceIndex=n;function l(x,oe,we){const Ce=[];let Ae=0;for(const Oe of x.matchAll(oe)){if(Ce.push(x.slice(Ae,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Ae=Oe.index+Oe[0].length,Ce.push(we(Oe[0],...Oe.slice(1),Oe.index,x,Oe.groups))}return Ce.push(x.slice(Ae)),Promise.all(Ce).then(Oe=>Oe.join(""))}t.replaceAsync=l;function b(x,oe){return x<oe?-1:x>oe?1:0}t.compare=b;function f(x,oe,we=0,Ce=x.length,Ae=0,Oe=oe.length){for(;we<Ce&&Ae<Oe;we++,Ae++){const et=x.charCodeAt(we),Ie=oe.charCodeAt(Ae);if(et<Ie)return-1;if(et>Ie)return 1}const $e=Ce-we,Ge=Oe-Ae;return $e<Ge?-1:$e>Ge?1:0}t.compareSubstring=f;function z(x,oe){return $(x,oe,0,x.length,0,oe.length)}t.compareIgnoreCase=z;function $(x,oe,we=0,Ce=x.length,Ae=0,Oe=oe.length){for(;we<Ce&&Ae<Oe;we++,Ae++){let et=x.charCodeAt(we),Ie=oe.charCodeAt(Ae);if(et===Ie)continue;if(et>=128||Ie>=128)return f(x.toLowerCase(),oe.toLowerCase(),we,Ce,Ae,Oe);J(et)&&(et-=32),J(Ie)&&(Ie-=32);const ue=et-Ie;if(ue!==0)return ue}const $e=Ce-we,Ge=Oe-Ae;return $e<Ge?-1:$e>Ge?1:0}t.compareSubstringIgnoreCase=$;function X(x){return x>=48&&x<=57}t.isAsciiDigit=X;function J(x){return x>=97&&x<=122}t.isLowerAsciiLetter=J;function ge(x){return x>=65&&x<=90}t.isUpperAsciiLetter=ge;function re(x,oe){return x.length===oe.length&&$(x,oe)===0}t.equalsIgnoreCase=re;function me(x,oe){const we=oe.length;return oe.length>x.length?!1:$(x,oe,0,we)===0}t.startsWithIgnoreCase=me;function ae(x,oe){const we=Math.min(x.length,oe.length);let Ce;for(Ce=0;Ce<we;Ce++)if(x.charCodeAt(Ce)!==oe.charCodeAt(Ce))return Ce;return we}t.commonPrefixLength=ae;function he(x,oe){const we=Math.min(x.length,oe.length);let Ce;const Ae=x.length-1,Oe=oe.length-1;for(Ce=0;Ce<we;Ce++)if(x.charCodeAt(Ae-Ce)!==oe.charCodeAt(Oe-Ce))return Ce;return we}t.commonSuffixLength=he;function Se(x){return 55296<=x&&x<=56319}t.isHighSurrogate=Se;function te(x){return 56320<=x&&x<=57343}t.isLowSurrogate=te;function De(x,oe){return(x-55296<<10)+(oe-56320)+65536}t.computeCodePoint=De;function se(x,oe,we){const Ce=x.charCodeAt(we);if(Se(Ce)&&we+1<oe){const Ae=x.charCodeAt(we+1);if(te(Ae))return De(Ce,Ae)}return Ce}t.getNextCodePoint=se;function ie(x,oe){const we=x.charCodeAt(oe-1);if(te(we)&&oe>1){const Ce=x.charCodeAt(oe-2);if(Se(Ce))return De(Ce,we)}return we}class ce{get offset(){return this._offset}constructor(oe,we=0){this._str=oe,this._len=oe.length,this._offset=we}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=ie(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=se(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}t.CodePointIterator=ce;class ne{get offset(){return this._iterator.offset}constructor(oe,we=0){this._iterator=new ce(oe,we)}nextGraphemeLength(){const oe=ke.getInstance(),we=this._iterator,Ce=we.offset;let Ae=oe.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Oe=we.offset,$e=oe.getGraphemeBreakType(we.nextCodePoint());if(ve(Ae,$e)){we.setOffset(Oe);break}Ae=$e}return we.offset-Ce}prevGraphemeLength(){const oe=ke.getInstance(),we=this._iterator,Ce=we.offset;let Ae=oe.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Oe=we.offset,$e=oe.getGraphemeBreakType(we.prevCodePoint());if(ve($e,Ae)){we.setOffset(Oe);break}Ae=$e}return Ce-we.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=ne;function F(x,oe){return new ne(x,oe).nextGraphemeLength()}t.nextCharLength=F;function V(x,oe){return new ne(x,oe).prevGraphemeLength()}t.prevCharLength=V;function j(x,oe){oe>0&&te(x.charCodeAt(oe))&&oe--;const we=oe+F(x,oe);return[we-V(x,we),we]}t.getCharContainingOffset=j;let k;function h(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function I(x){return k||(k=h()),k.test(x)}t.containsRTL=I;const U=/^[\t\n\r\x20-\x7E]*$/;function K(x){return U.test(x)}t.isBasicASCII=K,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(x){return t.UNUSUAL_LINE_TERMINATORS.test(x)}t.containsUnusualLineTerminators=Z;function N(x){return x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}t.isFullWidthCharacter=N;function R(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129008||x>=129280&&x<=129535||x>=129648&&x<=129782}t.isEmojiImprecise=R;function H(x,oe){if(x.length<oe)return x;const we=/\b/g;let Ce=0;for(;we.test(x)&&!(x.length-we.lastIndex<oe);)Ce=we.lastIndex,we.lastIndex+=1;return x.substring(Ce).replace(/^\s/,"")}t.lcut=H;const A=/\x1B\x5B[12]?K/g,P=/\x1b\[\d+m/g,M=/\x1b\[0?m/g;function B(x){return x&&(x=x.replace(A,""),x=x.replace(P,""),x=x.replace(M,"")),x}t.removeAnsiEscapeCodes=B,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function q(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}t.startsWithUTF8BOM=q;function ee(x){return q(x)?x.substr(1):x}t.stripUTF8BOM=ee;function le(x,oe){if(!x||!oe||x.length<oe.length)return!1;const we=oe.length,Ce=x.toLowerCase();let Ae=0,Oe=-1;for(;Ae<we;){const $e=Ce.indexOf(oe[Ae],Oe+1);if($e<0)return!1;Oe=$e,Ae++}return!0}t.fuzzyContains=le;function de(x,oe=!1){return x?(oe&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}t.containsUppercaseCharacter=de;function ye(x){return x.charAt(0).toUpperCase()+x.slice(1)}t.uppercaseFirstLetter=ye;function Ee(x,oe=1){if(oe===0)return"";let we=-1;do we=x.indexOf(`
`,we+1),oe--;while(oe>0&&we>=0);return we===-1?x:(x[we-1]==="\r"&&we--,x.substr(0,we))}t.getNLines=Ee;function Re(x){return x=x%(2*26),x<26?String.fromCharCode(97+x):String.fromCharCode(65+x-26)}t.singleLetterHash=Re;function Le(x){return ke.getInstance().getGraphemeBreakType(x)}t.getGraphemeBreakType=Le;function ve(x,oe){return x===0?oe!==5&&oe!==7:x===2&&oe===3?!1:x===4||x===2||x===3||oe===4||oe===2||oe===3?!0:!(x===8&&(oe===8||oe===9||oe===11||oe===12)||(x===11||x===9)&&(oe===9||oe===10)||(x===12||x===10)&&oe===10||oe===5||oe===13||oe===7||x===1||x===13&&oe===14||x===6&&oe===6)}var Pe;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=t.GraphemeBreakType||(t.GraphemeBreakType={}));class ke{static getInstance(){return ke._INSTANCE||(ke._INSTANCE=new ke),ke._INSTANCE}constructor(){this._data=je()}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const we=this._data,Ce=we.length/3;let Ae=1;for(;Ae<=Ce;)if(oe<we[3*Ae])Ae=2*Ae;else if(oe>we[3*Ae+1])Ae=2*Ae+1;else return we[3*Ae+2];return 0}}ke._INSTANCE=null;function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(x,oe){if(x===0)return 0;const we=Ue(x,oe);if(we!==void 0)return we;const Ce=new ce(oe,x);return Ce.prevCodePoint(),Ce.offset}t.getLeftDeleteOffset=He;function Ue(x,oe){const we=new ce(oe,x);let Ce=we.prevCodePoint();for(;Je(Ce)||Ce===65039||Ce===8419;){if(we.offset===0)return;Ce=we.prevCodePoint()}if(!R(Ce))return;let Ae=we.offset;return Ae>0&&we.prevCodePoint()===8205&&(Ae=we.offset),Ae}function Je(x){return 127995<=x&&x<=127999}var it;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),t.noBreakWhitespace="\xA0";class Me{static getInstance(oe){return Me.cache.get(Array.from(oe))}static getLocales(){return Me._locales.getValue()}constructor(oe){this.confusableDictionary=oe}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=Me,W=Me,Me.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Me.cache=new E.LRUCachedFunction(x=>{function oe(Ie){const ue=new Map;for(let _e=0;_e<Ie.length;_e+=2)ue.set(Ie[_e],Ie[_e+1]);return ue}function we(Ie,ue){const _e=new Map(Ie);for(const[Ne,We]of ue)_e.set(Ne,We);return _e}function Ce(Ie,ue){if(!Ie)return ue;const _e=new Map;for(const[Ne,We]of Ie)ue.has(Ne)&&_e.set(Ne,We);return _e}const Ae=W.ambiguousCharacterData.getValue();let Oe=x.filter(Ie=>!Ie.startsWith("_")&&Ie in Ae);Oe.length===0&&(Oe=["_default"]);let $e;for(const Ie of Oe){const ue=oe(Ae[Ie]);$e=Ce($e,ue)}const Ge=oe(Ae._common),et=we(Ge,$e);return new Me(et)}),Me._locales=new i.Lazy(()=>Object.keys(Me.ambiguousCharacterData.getValue()).filter(x=>!x.startsWith("_")));class qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(qe.getRawData())),this._data}static isInvisibleCharacter(oe){return qe.getData().has(oe)}static get codePoints(){return qe.getData()}}t.InvisibleCharacters=qe,qe._data=void 0}),define(pe[109],be([1,0,21,5,10,6]),function(Q,t,E,i,W,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function C(n){return n===47||n===92}t.isPathSeparator=C;function y(n){return n.replace(/[\\/]/g,E.posix.sep)}t.toSlashes=y;function d(n){return n.indexOf("/")===-1&&(n=y(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}t.toPosixPath=d;function c(n,l=E.posix.sep){if(!n)return"";const b=n.length,f=n.charCodeAt(0);if(C(f)){if(C(n.charCodeAt(1))&&!C(n.charCodeAt(2))){let $=3;const X=$;for(;$<b&&!C(n.charCodeAt($));$++);if(X!==$&&!C(n.charCodeAt($+1))){for($+=1;$<b;$++)if(C(n.charCodeAt($)))return n.slice(0,$+1).replace(/[\\/]/g,l)}}return l}else if(w(f)&&n.charCodeAt(1)===58)return C(n.charCodeAt(2))?n.slice(0,2)+l:n.slice(0,2);let z=n.indexOf("://");if(z!==-1){for(z+=3;z<b;z++)if(C(n.charCodeAt(z)))return n.slice(0,z+1)}return""}t.getRoot=c;function g(n){if(!i.isWindows||!n||n.length<5)return!1;let l=n.charCodeAt(0);if(l!==92||(l=n.charCodeAt(1),l!==92))return!1;let b=2;const f=b;for(;b<n.length&&(l=n.charCodeAt(b),l!==92);b++);return!(f===b||(l=n.charCodeAt(b+1),isNaN(l)||l===92))}t.isUNC=g;const L=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,s=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(n,l=i.isWindows){const b=l?L:o;return!(!n||n.length===0||/^\s+$/.test(n)||(b.lastIndex=0,b.test(n))||l&&s.test(n)||n==="."||n===".."||l&&n[n.length-1]==="."||l&&n.length!==n.trim().length||n.length>255)}t.isValidBasename=e;function m(n,l,b){const f=n===l;return!b||f?f:!n||!l?!1:(0,W.equalsIgnoreCase)(n,l)}t.isEqual=m;function v(n,l,b,f=E.sep){if(n===l)return!0;if(!n||!l||l.length>n.length)return!1;if(b){if(!(0,W.startsWithIgnoreCase)(n,l))return!1;if(l.length===n.length)return!0;let $=l.length;return l.charAt(l.length-1)===f&&$--,n.charAt($)===f}return l.charAt(l.length-1)!==f&&(l+=f),n.indexOf(l)===0}t.isEqualOrParent=v;function w(n){return n>=65&&n<=90||n>=97&&n<=122}t.isWindowsDriveLetter=w;function D(n,l){return i.isWindows&&n.endsWith(":")&&(n+=E.sep),(0,E.isAbsolute)(n)||(n=(0,E.join)(l,n)),n=(0,E.normalize)(n),i.isWindows?(n=(0,W.rtrim)(n,E.sep),n.endsWith(":")&&(n+=E.sep)):(n=(0,W.rtrim)(n,E.sep),n||(n=E.sep)),n}t.sanitizeFilePath=D;function a(n){const l=(0,E.normalize)(n);return i.isWindows?n.length>3?!1:u(l)&&(n.length===2||l.charCodeAt(2)===92):l===E.posix.sep}t.isRootOrDriveLetter=a;function u(n,l=i.isWindows){return l?w(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}t.hasDriveLetter=u;function p(n){return u(n)?n[0]:void 0}t.getDriveLetter=p;function S(n,l,b){return l.length>n.length?-1:n===l?0:(b&&(n=n.toLowerCase(),l=l.toLowerCase()),n.indexOf(l))}t.indexOfPath=S;function T(n){const l=n.split(":");let b,f,z;for(const $ of l){const X=Number($);(0,O.isNumber)(X)?f===void 0?f=X:z===void 0&&(z=X):b=b?[b,$].join(":"):$}if(!b)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:b,line:f!==void 0?f:void 0,column:z!==void 0?z:f!==void 0?1:void 0}}t.parseLineAndColumnAware=T;const _="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(n,l,b=8){let f="";for(let $=0;$<b;$++)f+=_.charAt(Math.floor(Math.random()*_.length));let z;return l?z=`${l}-${f}`:z=f,n?(0,E.join)(n,z):z}t.randomPath=r}),define(pe[110],be([1,0,10]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function i(w){return W(w,0)}t.hash=i;function W(w,D){switch(typeof w){case"object":return w===null?O(349,D):Array.isArray(w)?d(w,D):c(w,D);case"string":return y(w,D);case"boolean":return C(w,D);case"number":return O(w,D);case"undefined":return O(937,D);default:return O(617,D)}}t.doHash=W;function O(w,D){return(D<<5)-D+w|0}t.numberHash=O;function C(w,D){return O(w?433:863,D)}function y(w,D){D=O(149417,D);for(let a=0,u=w.length;a<u;a++)D=O(w.charCodeAt(a),D);return D}t.stringHash=y;function d(w,D){return D=O(104579,D),w.reduce((a,u)=>W(u,a),D)}function c(w,D){return D=O(181387,D),Object.keys(w).sort().reduce((a,u)=>(a=y(u,a),W(w[u],a)),D)}class g{constructor(){this._value=0}get value(){return this._value}hash(D){return this._value=W(D,this._value),this._value}}t.Hasher=g;var L;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(L||(L={}));function o(w,D,a=32){const u=a-D,p=~((1<<u)-1);return(w<<D|(p&w)>>>u)>>>0}function s(w,D=0,a=w.byteLength,u=0){for(let p=0;p<a;p++)w[D+p]=u}function e(w,D,a="0"){for(;w.length<D;)w=a+w;return w}function m(w,D=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(a=>a.toString(16).padStart(2,"0")).join(""):e((w>>>0).toString(16),D/4)}t.toHexString=m;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(D){const a=D.length;if(a===0)return;const u=this._buff;let p=this._buffLen,S=this._leftoverHighSurrogate,T,_;for(S!==0?(T=S,_=-1,S=0):(T=D.charCodeAt(0),_=0);;){let r=T;if(E.isHighSurrogate(T))if(_+1<a){const n=D.charCodeAt(_+1);E.isLowSurrogate(n)?(_++,r=E.computeCodePoint(T,n)):r=65533}else{S=T;break}else E.isLowSurrogate(T)&&(r=65533);if(p=this._push(u,p,r),_++,_<a)T=D.charCodeAt(_);else break}this._buffLen=p,this._leftoverHighSurrogate=S}_push(D,a,u){return u<128?D[a++]=u:u<2048?(D[a++]=192|(u&1984)>>>6,D[a++]=128|(u&63)>>>0):u<65536?(D[a++]=224|(u&61440)>>>12,D[a++]=128|(u&4032)>>>6,D[a++]=128|(u&63)>>>0):(D[a++]=240|(u&1835008)>>>18,D[a++]=128|(u&258048)>>>12,D[a++]=128|(u&4032)>>>6,D[a++]=128|(u&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,D[0]=D[64+0],D[1]=D[64+1],D[2]=D[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,s(this._buff,this._buffLen),this._buffLen>56&&(this._step(),s(this._buff));const D=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(D/4294967296),!1),this._buffDV.setUint32(60,D%4294967296,!1),this._step()}_step(){const D=v._bigBlock32,a=this._buffDV;for(let b=0;b<64;b+=4)D.setUint32(b,a.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)D.setUint32(b,o(D.getUint32(b-12,!1)^D.getUint32(b-32,!1)^D.getUint32(b-56,!1)^D.getUint32(b-64,!1),1),!1);let u=this._h0,p=this._h1,S=this._h2,T=this._h3,_=this._h4,r,n,l;for(let b=0;b<80;b++)b<20?(r=p&S|~p&T,n=1518500249):b<40?(r=p^S^T,n=1859775393):b<60?(r=p&S|p&T|S&T,n=2400959708):(r=p^S^T,n=3395469782),l=o(u,5)+r+_+n+D.getUint32(b*4,!1)&4294967295,_=T,T=S,S=o(p,30),p=u,u=l;this._h0=this._h0+u&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+S&4294967295,this._h3=this._h3+T&4294967295,this._h4=this._h4+_&4294967295}}t.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))}),define(pe[111],be([1,0,70,110]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class W{constructor(o){this.source=o}getElements(){const o=this.source,s=new Int32Array(o.length);for(let e=0,m=o.length;e<m;e++)s[e]=o.charCodeAt(e);return s}}t.StringDiffSequence=W;function O(L,o,s){return new g(new W(L),new W(o)).ComputeDiff(s).changes}t.stringDiff=O;class C{static Assert(o,s){if(!o)throw new Error(s)}}t.Debug=C;class y{static Copy(o,s,e,m,v){for(let w=0;w<v;w++)e[m+w]=o[s+w]}static Copy2(o,s,e,m,v){for(let w=0;w<v;w++)e[m+w]=o[s+w]}}t.MyArray=y;var d;(function(L){L[L.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(d||(d={}));class c{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new E.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(o,s){this.m_originalStart=Math.min(this.m_originalStart,o),this.m_modifiedStart=Math.min(this.m_modifiedStart,s),this.m_originalCount++}AddModifiedElement(o,s){this.m_originalStart=Math.min(this.m_originalStart,o),this.m_modifiedStart=Math.min(this.m_modifiedStart,s),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class g{constructor(o,s,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=o,this._modifiedSequence=s;const[m,v,w]=g._getElements(o),[D,a,u]=g._getElements(s);this._hasStrings=w&&u,this._originalStringElements=m,this._originalElementsOrHash=v,this._modifiedStringElements=D,this._modifiedElementsOrHash=a,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(o){return o.length>0&&typeof o[0]=="string"}static _getElements(o){const s=o.getElements();if(g._isStringArray(s)){const e=new Int32Array(s.length);for(let m=0,v=s.length;m<v;m++)e[m]=(0,i.stringHash)(s[m],0);return[s,e,!0]}return s instanceof Int32Array?[[],s,!1]:[[],new Int32Array(s),!1]}ElementsAreEqual(o,s){return this._originalElementsOrHash[o]!==this._modifiedElementsOrHash[s]?!1:this._hasStrings?this._originalStringElements[o]===this._modifiedStringElements[s]:!0}ElementsAreStrictEqual(o,s){if(!this.ElementsAreEqual(o,s))return!1;const e=g._getStrictElement(this._originalSequence,o),m=g._getStrictElement(this._modifiedSequence,s);return e===m}static _getStrictElement(o,s){return typeof o.getStrictElement=="function"?o.getStrictElement(s):null}OriginalElementsAreEqual(o,s){return this._originalElementsOrHash[o]!==this._originalElementsOrHash[s]?!1:this._hasStrings?this._originalStringElements[o]===this._originalStringElements[s]:!0}ModifiedElementsAreEqual(o,s){return this._modifiedElementsOrHash[o]!==this._modifiedElementsOrHash[s]?!1:this._hasStrings?this._modifiedStringElements[o]===this._modifiedStringElements[s]:!0}ComputeDiff(o){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,o)}_ComputeDiff(o,s,e,m,v){const w=[!1];let D=this.ComputeDiffRecursive(o,s,e,m,w);return v&&(D=this.PrettifyChanges(D)),{quitEarly:w[0],changes:D}}ComputeDiffRecursive(o,s,e,m,v){for(v[0]=!1;o<=s&&e<=m&&this.ElementsAreEqual(o,e);)o++,e++;for(;s>=o&&m>=e&&this.ElementsAreEqual(s,m);)s--,m--;if(o>s||e>m){let S;return e<=m?(C.Assert(o===s+1,"originalStart should only be one more than originalEnd"),S=[new E.DiffChange(o,0,e,m-e+1)]):o<=s?(C.Assert(e===m+1,"modifiedStart should only be one more than modifiedEnd"),S=[new E.DiffChange(o,s-o+1,e,0)]):(C.Assert(o===s+1,"originalStart should only be one more than originalEnd"),C.Assert(e===m+1,"modifiedStart should only be one more than modifiedEnd"),S=[]),S}const w=[0],D=[0],a=this.ComputeRecursionPoint(o,s,e,m,w,D,v),u=w[0],p=D[0];if(a!==null)return a;if(!v[0]){const S=this.ComputeDiffRecursive(o,u,e,p,v);let T=[];return v[0]?T=[new E.DiffChange(u+1,s-(u+1)+1,p+1,m-(p+1)+1)]:T=this.ComputeDiffRecursive(u+1,s,p+1,m,v),this.ConcatenateChanges(S,T)}return[new E.DiffChange(o,s-o+1,e,m-e+1)]}WALKTRACE(o,s,e,m,v,w,D,a,u,p,S,T,_,r,n,l,b,f){let z=null,$=null,X=new c,J=s,ge=e,re=_[0]-l[0]-m,me=-1073741824,ae=this.m_forwardHistory.length-1;do{const he=re+o;he===J||he<ge&&u[he-1]<u[he+1]?(S=u[he+1],r=S-re-m,S<me&&X.MarkNextChange(),me=S,X.AddModifiedElement(S+1,r),re=he+1-o):(S=u[he-1]+1,r=S-re-m,S<me&&X.MarkNextChange(),me=S-1,X.AddOriginalElement(S,r+1),re=he-1-o),ae>=0&&(u=this.m_forwardHistory[ae],o=u[0],J=1,ge=u.length-1)}while(--ae>=-1);if(z=X.getReverseChanges(),f[0]){let he=_[0]+1,Se=l[0]+1;if(z!==null&&z.length>0){const te=z[z.length-1];he=Math.max(he,te.getOriginalEnd()),Se=Math.max(Se,te.getModifiedEnd())}$=[new E.DiffChange(he,T-he+1,Se,n-Se+1)]}else{X=new c,J=w,ge=D,re=_[0]-l[0]-a,me=1073741824,ae=b?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const he=re+v;he===J||he<ge&&p[he-1]>=p[he+1]?(S=p[he+1]-1,r=S-re-a,S>me&&X.MarkNextChange(),me=S+1,X.AddOriginalElement(S+1,r+1),re=he+1-v):(S=p[he-1],r=S-re-a,S>me&&X.MarkNextChange(),me=S,X.AddModifiedElement(S+1,r+1),re=he-1-v),ae>=0&&(p=this.m_reverseHistory[ae],v=p[0],J=1,ge=p.length-1)}while(--ae>=-1);$=X.getChanges()}return this.ConcatenateChanges(z,$)}ComputeRecursionPoint(o,s,e,m,v,w,D){let a=0,u=0,p=0,S=0,T=0,_=0;o--,e--,v[0]=0,w[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const r=s-o+(m-e),n=r+1,l=new Int32Array(n),b=new Int32Array(n),f=m-e,z=s-o,$=o-e,X=s-m,ge=(z-f)%2===0;l[f]=o,b[z]=s,D[0]=!1;for(let re=1;re<=r/2+1;re++){let me=0,ae=0;p=this.ClipDiagonalBound(f-re,re,f,n),S=this.ClipDiagonalBound(f+re,re,f,n);for(let Se=p;Se<=S;Se+=2){Se===p||Se<S&&l[Se-1]<l[Se+1]?a=l[Se+1]:a=l[Se-1]+1,u=a-(Se-f)-$;const te=a;for(;a<s&&u<m&&this.ElementsAreEqual(a+1,u+1);)a++,u++;if(l[Se]=a,a+u>me+ae&&(me=a,ae=u),!ge&&Math.abs(Se-z)<=re-1&&a>=b[Se])return v[0]=a,w[0]=u,te<=b[Se]&&1447>0&&re<=1447+1?this.WALKTRACE(f,p,S,$,z,T,_,X,l,b,a,s,v,u,m,w,ge,D):null}const he=(me-o+(ae-e)-re)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(me,he))return D[0]=!0,v[0]=me,w[0]=ae,he>0&&1447>0&&re<=1447+1?this.WALKTRACE(f,p,S,$,z,T,_,X,l,b,a,s,v,u,m,w,ge,D):(o++,e++,[new E.DiffChange(o,s-o+1,e,m-e+1)]);T=this.ClipDiagonalBound(z-re,re,z,n),_=this.ClipDiagonalBound(z+re,re,z,n);for(let Se=T;Se<=_;Se+=2){Se===T||Se<_&&b[Se-1]>=b[Se+1]?a=b[Se+1]-1:a=b[Se-1],u=a-(Se-z)-X;const te=a;for(;a>o&&u>e&&this.ElementsAreEqual(a,u);)a--,u--;if(b[Se]=a,ge&&Math.abs(Se-f)<=re&&a<=l[Se])return v[0]=a,w[0]=u,te>=l[Se]&&1447>0&&re<=1447+1?this.WALKTRACE(f,p,S,$,z,T,_,X,l,b,a,s,v,u,m,w,ge,D):null}if(re<=1447){let Se=new Int32Array(S-p+2);Se[0]=f-p+1,y.Copy2(l,p,Se,1,S-p+1),this.m_forwardHistory.push(Se),Se=new Int32Array(_-T+2),Se[0]=z-T+1,y.Copy2(b,T,Se,1,_-T+1),this.m_reverseHistory.push(Se)}}return this.WALKTRACE(f,p,S,$,z,T,_,X,l,b,a,s,v,u,m,w,ge,D)}PrettifyChanges(o){for(let s=0;s<o.length;s++){const e=o[s],m=s<o.length-1?o[s+1].originalStart:this._originalElementsOrHash.length,v=s<o.length-1?o[s+1].modifiedStart:this._modifiedElementsOrHash.length,w=e.originalLength>0,D=e.modifiedLength>0;for(;e.originalStart+e.originalLength<m&&e.modifiedStart+e.modifiedLength<v&&(!w||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!D||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const u=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!u)break;e.originalStart++,e.modifiedStart++}const a=[null];if(s<o.length-1&&this.ChangesOverlap(o[s],o[s+1],a)){o[s]=a[0],o.splice(s+1,1),s--;continue}}for(let s=o.length-1;s>=0;s--){const e=o[s];let m=0,v=0;if(s>0){const S=o[s-1];m=S.originalStart+S.originalLength,v=S.modifiedStart+S.modifiedLength}const w=e.originalLength>0,D=e.modifiedLength>0;let a=0,u=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let S=1;;S++){const T=e.originalStart-S,_=e.modifiedStart-S;if(T<m||_<v||w&&!this.OriginalElementsAreEqual(T,T+e.originalLength)||D&&!this.ModifiedElementsAreEqual(_,_+e.modifiedLength))break;const n=(T===m&&_===v?5:0)+this._boundaryScore(T,e.originalLength,_,e.modifiedLength);n>u&&(u=n,a=S)}e.originalStart-=a,e.modifiedStart-=a;const p=[null];if(s>0&&this.ChangesOverlap(o[s-1],o[s],p)){o[s-1]=p[0],o.splice(s,1),s++;continue}}if(this._hasStrings)for(let s=1,e=o.length;s<e;s++){const m=o[s-1],v=o[s],w=v.originalStart-m.originalStart-m.originalLength,D=m.originalStart,a=v.originalStart+v.originalLength,u=a-D,p=m.modifiedStart,S=v.modifiedStart+v.modifiedLength,T=S-p;if(w<5&&u<20&&T<20){const _=this._findBetterContiguousSequence(D,u,p,T,w);if(_){const[r,n]=_;(r!==m.originalStart+m.originalLength||n!==m.modifiedStart+m.modifiedLength)&&(m.originalLength=r-m.originalStart,m.modifiedLength=n-m.modifiedStart,v.originalStart=r+w,v.modifiedStart=n+w,v.originalLength=a-v.originalStart,v.modifiedLength=S-v.modifiedStart)}}}return o}_findBetterContiguousSequence(o,s,e,m,v){if(s<v||m<v)return null;const w=o+s-v+1,D=e+m-v+1;let a=0,u=0,p=0;for(let S=o;S<w;S++)for(let T=e;T<D;T++){const _=this._contiguousSequenceScore(S,T,v);_>0&&_>a&&(a=_,u=S,p=T)}return a>0?[u,p]:null}_contiguousSequenceScore(o,s,e){let m=0;for(let v=0;v<e;v++){if(!this.ElementsAreEqual(o+v,s+v))return 0;m+=this._originalStringElements[o+v].length}return m}_OriginalIsBoundary(o){return o<=0||o>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[o])}_OriginalRegionIsBoundary(o,s){if(this._OriginalIsBoundary(o)||this._OriginalIsBoundary(o-1))return!0;if(s>0){const e=o+s;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(o){return o<=0||o>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[o])}_ModifiedRegionIsBoundary(o,s){if(this._ModifiedIsBoundary(o)||this._ModifiedIsBoundary(o-1))return!0;if(s>0){const e=o+s;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(o,s,e,m){const v=this._OriginalRegionIsBoundary(o,s)?1:0,w=this._ModifiedRegionIsBoundary(e,m)?1:0;return v+w}ConcatenateChanges(o,s){const e=[];if(o.length===0||s.length===0)return s.length>0?s:o;if(this.ChangesOverlap(o[o.length-1],s[0],e)){const m=new Array(o.length+s.length-1);return y.Copy(o,0,m,0,o.length-1),m[o.length-1]=e[0],y.Copy(s,1,m,o.length,s.length-1),m}else{const m=new Array(o.length+s.length);return y.Copy(o,0,m,0,o.length),y.Copy(s,0,m,o.length,s.length),m}}ChangesOverlap(o,s,e){if(C.Assert(o.originalStart<=s.originalStart,"Left change is not less than or equal to right change"),C.Assert(o.modifiedStart<=s.modifiedStart,"Left change is not less than or equal to right change"),o.originalStart+o.originalLength>=s.originalStart||o.modifiedStart+o.modifiedLength>=s.modifiedStart){const m=o.originalStart;let v=o.originalLength;const w=o.modifiedStart;let D=o.modifiedLength;return o.originalStart+o.originalLength>=s.originalStart&&(v=s.originalStart+s.originalLength-o.originalStart),o.modifiedStart+o.modifiedLength>=s.modifiedStart&&(D=s.modifiedStart+s.modifiedLength-o.modifiedStart),e[0]=new E.DiffChange(m,v,w,D),!0}else return e[0]=null,!1}ClipDiagonalBound(o,s,e,m){if(o>=0&&o<m)return o;const v=e,w=m-e-1,D=s%2===0;if(o<0){const a=v%2===0;return D===a?0:1}else{const a=w%2===0;return D===a?m-1:m-2}}}t.LcsDiff=g}),define(pe[49],be([1,0,14,10]),function(Q,t,E,i){"use strict";var W,O,C;Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=t.setToString=t.mapToString=t.getOrSet=void 0;function y(_,r,n){let l=_.get(r);return l===void 0&&(l=n,_.set(r,l)),l}t.getOrSet=y;function d(_){const r=[];return _.forEach((n,l)=>{r.push(`${l} => ${n}`)}),`Map(${_.size}) {${r.join(", ")}}`}t.mapToString=d;function c(_){const r=[];return _.forEach(n=>{r.push(n)}),`Set(${_.size}) {${r.join(", ")}}`}t.setToString=c;class g{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const n=r.charCodeAt(0),l=this._value.charCodeAt(this._pos);return n-l}value(){return this._value[this._pos]}}t.StringIterator=g;class L{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,i.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=L;class o{constructor(r=!0,n=!0){this._splitOnBackslash=r,this._caseSensitive=n}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let n=r.length-1;n>=0;n--,this._valueLen--){const l=this._value.charCodeAt(n);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,i.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=o;var s;(function(_){_[_.Scheme=1]="Scheme",_[_.Authority=2]="Authority",_[_.Path=3]="Path",_[_.Query=4]="Query",_[_.Fragment=5]="Fragment"})(s||(s={}));class e{constructor(r,n){this._ignorePathCasing=r,this._ignoreQueryAndFragment=n,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new o(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,i.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}t.UriIterator=e;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(_){_[_.Left=-1]="Left",_[_.Mid=0]="Mid",_[_.Right=1]="Right"})(v||(v={}));class w{static forUris(r=()=>!1,n=()=>!1){return new w(new e(r,n))}static forPaths(r=!1){return new w(new o(void 0,!r))}static forStrings(){return new w(new g)}static forConfigKeys(){return new w(new L)}constructor(r){this._iter=r}clear(){this._root=void 0}fill(r,n){if(n){const l=n.slice(0);(0,E.shuffle)(l);for(const b of l)this.set(b,r)}else{const l=r.slice(0);(0,E.shuffle)(l);for(const b of l)this.set(b[0],b[1])}}set(r,n){const l=this._iter.reset(r);let b;this._root||(this._root=new m,this._root.segment=l.value());const f=[];for(b=this._root;;){const $=l.cmp(b.segment);if($>0)b.left||(b.left=new m,b.left.segment=l.value()),f.push([-1,b]),b=b.left;else if($<0)b.right||(b.right=new m,b.right.segment=l.value()),f.push([1,b]),b=b.right;else if(l.hasNext())l.next(),b.mid||(b.mid=new m,b.mid.segment=l.value()),f.push([0,b]),b=b.mid;else break}const z=b.value;b.value=n,b.key=r;for(let $=f.length-1;$>=0;$--){const X=f[$][1];X.updateHeight();const J=X.balanceFactor();if(J<-1||J>1){const ge=f[$][0],re=f[$+1][0];if(ge===1&&re===1)f[$][1]=X.rotateLeft();else if(ge===-1&&re===-1)f[$][1]=X.rotateRight();else if(ge===1&&re===-1)X.right=f[$+1][1]=f[$+1][1].rotateRight(),f[$][1]=X.rotateLeft();else if(ge===-1&&re===1)X.left=f[$+1][1]=f[$+1][1].rotateLeft(),f[$][1]=X.rotateRight();else throw new Error;if($>0)switch(f[$-1][0]){case-1:f[$-1][1].left=f[$][1];break;case 1:f[$-1][1].right=f[$][1];break;case 0:f[$-1][1].mid=f[$][1];break}else this._root=f[0][1]}}return z}get(r){return this._getNode(r)?.value}_getNode(r){const n=this._iter.reset(r);let l=this._root;for(;l;){const b=n.cmp(l.segment);if(b>0)l=l.left;else if(b<0)l=l.right;else if(n.hasNext())n.next(),l=l.mid;else break}return l}has(r){const n=this._getNode(r);return!(n?.value===void 0&&n?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,n){const l=this._iter.reset(r),b=[];let f=this._root;for(;f;){const z=l.cmp(f.segment);if(z>0)b.push([-1,f]),f=f.left;else if(z<0)b.push([1,f]),f=f.right;else if(l.hasNext())l.next(),b.push([0,f]),f=f.mid;else break}if(!!f){if(n?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const z=this._min(f.right),{key:$,value:X,segment:J}=z;this._delete(z.key,!1),f.key=$,f.value=X,f.segment=J}else{const z=f.left??f.right;if(b.length>0){const[$,X]=b[b.length-1];switch($){case-1:X.left=z;break;case 0:X.mid=z;break;case 1:X.right=z;break}}else this._root=z}for(let z=b.length-1;z>=0;z--){const $=b[z][1];$.updateHeight();const X=$.balanceFactor();if(X>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),b[z][1]=$.rotateLeft()):X<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),b[z][1]=$.rotateRight()),z>0)switch(b[z-1][0]){case-1:b[z-1][1].left=b[z][1];break;case 1:b[z-1][1].right=b[z][1];break;case 0:b[z-1][1].mid=b[z][1];break}else this._root=b[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const n=this._iter.reset(r);let l=this._root,b;for(;l;){const f=n.cmp(l.segment);if(f>0)l=l.left;else if(f<0)l=l.right;else if(n.hasNext())n.next(),b=l.value||b,l=l.mid;else break}return l&&l.value||b}findSuperstr(r){const n=this._iter.reset(r);let l=this._root;for(;l;){const b=n.cmp(l.segment);if(b>0)l=l.left;else if(b<0)l=l.right;else if(n.hasNext())n.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(r){for(const[n,l]of this)r(l,n)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const n=[];return this._dfsEntries(r,n),n[Symbol.iterator]()}_dfsEntries(r,n){!r||(r.left&&this._dfsEntries(r.left,n),r.value&&n.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,n),r.right&&this._dfsEntries(r.right,n))}_isBalanced(){const r=n=>{if(!n)return!0;const l=n.balanceFactor();return l<-1||l>1?!1:r(n.left)&&r(n.right)};return r(this._root)}}t.TernarySearchTree=w;class D{constructor(r,n){this.uri=r,this.value=n}}class a{constructor(r,n){this[W]="ResourceMap",r instanceof a?(this.map=new Map(r.map),this.toKey=n??a.defaultToKey):(this.map=new Map,this.toKey=r??a.defaultToKey)}set(r,n){return this.map.set(this.toKey(r),new D(r,n)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,n){typeof n<"u"&&(r=r.bind(n));for(const[l,b]of this.map)r(b.value,b.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(W=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}t.ResourceMap=a,a.defaultToKey=_=>_.toString();class u{constructor(r,n){this[O]="ResourceSet",!r||typeof r=="function"?this._map=new a(r):(this._map=new a(n),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,n){this._map.forEach((l,b)=>r.call(n,b,b,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=u;var p;(function(_){_[_.None=0]="None",_[_.AsOld=1]="AsOld",_[_.AsNew=2]="AsNew"})(p=t.Touch||(t.Touch={}));class S{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,n=0){const l=this._map.get(r);if(!!l)return n!==0&&this.touch(l,n),l.value}set(r,n,l=0){let b=this._map.get(r);if(b)b.value=n,l!==0&&this.touch(b,l);else{switch(b={key:r,value:n,next:void 0,previous:void 0},l){case 0:this.addItemLast(b);break;case 1:this.addItemFirst(b);break;case 2:this.addItemLast(b);break;default:this.addItemLast(b);break}this._map.set(r,b),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const n=this._map.get(r);if(!!n)return this._map.delete(r),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,n){const l=this._state;let b=this._head;for(;b;){if(n?r.bind(n)(b.value,b.key,this):r(b.value,b.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const r=this,n=this._state;let l=this._head;const b={[Symbol.iterator](){return b},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(l){const f={value:l.key,done:!1};return l=l.next,f}else return{value:void 0,done:!0}}};return b}values(){const r=this,n=this._state;let l=this._head;const b={[Symbol.iterator](){return b},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(l){const f={value:l.value,done:!1};return l=l.next,f}else return{value:void 0,done:!0}}};return b}entries(){const r=this,n=this._state;let l=this._head;const b={[Symbol.iterator](){return b},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(l){const f={value:[l.key,l.value],done:!1};return l=l.next,f}else return{value:void 0,done:!0}}};return b}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let n=this._head,l=this.size;for(;n&&l>r;)this._map.delete(n.key),n=n.next,l--;this._head=n,this._size=l,n&&(n.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const n=r.next,l=r.previous;if(!n||!l)throw new Error("Invalid list");n.previous=l,l.next=n}r.next=void 0,r.previous=void 0,this._state++}touch(r,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(r===this._head)return;const l=r.next,b=r.previous;r===this._tail?(b.next=void 0,this._tail=b):(l.previous=b,b.next=l),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(n===2){if(r===this._tail)return;const l=r.next,b=r.previous;r===this._head?(l.previous=void 0,this._head=l):(l.previous=b,b.next=l),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((n,l)=>{r.push([l,n])}),r}fromJSON(r){this.clear();for(const[n,l]of r)this.set(n,l)}}t.LinkedMap=S;class T extends S{constructor(r,n=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,n=2){return super.get(r,n)}peek(r){return super.get(r,0)}set(r,n){return super.set(r,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=T}),define(pe[33],be([1,0,49,10]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function W(...M){return function(B,q){for(let ee=0,le=M.length;ee<le;ee++){const de=M[ee](B,q);if(de)return de}return null}}t.or=W,t.matchesStrictPrefix=O.bind(void 0,!1),t.matchesPrefix=O.bind(void 0,!0);function O(M,B,q){if(!q||q.length<B.length)return null;let ee;return M?ee=i.startsWithIgnoreCase(q,B):ee=q.indexOf(B)===0,ee?B.length>0?[{start:0,end:B.length}]:[]:null}function C(M,B){const q=B.toLowerCase().indexOf(M.toLowerCase());return q===-1?null:[{start:q,end:q+M.length}]}t.matchesContiguousSubString=C;function y(M,B){return d(M.toLowerCase(),B.toLowerCase(),0,0)}t.matchesSubString=y;function d(M,B,q,ee){if(q===M.length)return[];if(ee===B.length)return null;if(M[q]===B[ee]){let le=null;return(le=d(M,B,q+1,ee+1))?w({start:ee,end:ee+1},le):null}return d(M,B,q,ee+1)}function c(M){return 97<=M&&M<=122}function g(M){return 65<=M&&M<=90}t.isUpper=g;function L(M){return 48<=M&&M<=57}function o(M){return M===32||M===9||M===10||M===13}const s=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(M=>s.add(M.charCodeAt(0)));function e(M){return o(M)||s.has(M)}function m(M,B){return M===B||e(M)&&e(B)}function v(M){return c(M)||g(M)||L(M)}function w(M,B){return B.length===0?B=[M]:M.end===B[0].start?B[0].start=M.start:B.unshift(M),B}function D(M,B){for(let q=B;q<M.length;q++){const ee=M.charCodeAt(q);if(g(ee)||L(ee)||q>0&&!v(M.charCodeAt(q-1)))return q}return M.length}function a(M,B,q,ee){if(q===M.length)return[];if(ee===B.length)return null;if(M[q]!==B[ee].toLowerCase())return null;{let le=null,de=ee+1;for(le=a(M,B,q+1,ee+1);!le&&(de=D(B,de))<B.length;)le=a(M,B,q+1,de),de++;return le===null?null:w({start:ee,end:ee+1},le)}}function u(M){let B=0,q=0,ee=0,le=0,de=0;for(let ve=0;ve<M.length;ve++)de=M.charCodeAt(ve),g(de)&&B++,c(de)&&q++,v(de)&&ee++,L(de)&&le++;const ye=B/M.length,Ee=q/M.length,Re=ee/M.length,Le=le/M.length;return{upperPercent:ye,lowerPercent:Ee,alphaPercent:Re,numericPercent:Le}}function p(M){const{upperPercent:B,lowerPercent:q}=M;return q===0&&B>.6}function S(M){const{upperPercent:B,lowerPercent:q,alphaPercent:ee,numericPercent:le}=M;return q>.2&&B<.8&&ee>.6&&le<.2}function T(M){let B=0,q=0,ee=0,le=0;for(let de=0;de<M.length;de++)ee=M.charCodeAt(de),g(ee)&&B++,c(ee)&&q++,o(ee)&&le++;return(B===0||q===0)&&le===0?M.length<=30:B<=5}function _(M,B){if(!B||(B=B.trim(),B.length===0)||!T(M)||B.length>60)return null;const q=u(B);if(!S(q)){if(!p(q))return null;B=B.toLowerCase()}let ee=null,le=0;for(M=M.toLowerCase();le<B.length&&(ee=a(M,B,0,le))===null;)le=D(B,le+1);return ee}t.matchesCamelCase=_;function r(M,B,q=!1){if(!B||B.length===0)return null;let ee=null,le=0;for(M=M.toLowerCase(),B=B.toLowerCase();le<B.length&&(ee=n(M,B,0,le,q))===null;)le=l(B,le+1);return ee}t.matchesWords=r;function n(M,B,q,ee,le){if(q===M.length)return[];if(ee===B.length)return null;if(m(M.charCodeAt(q),B.charCodeAt(ee))){let de=null,ye=ee+1;if(de=n(M,B,q+1,ee+1,le),!le)for(;!de&&(ye=l(B,ye))<B.length;)de=n(M,B,q+1,ye,le),ye++;return de?M.charCodeAt(q)!==B.charCodeAt(ee)?de:w({start:ee,end:ee+1},de):null}else return null}function l(M,B){for(let q=B;q<M.length;q++)if(e(M.charCodeAt(q))||q>0&&e(M.charCodeAt(q-1)))return q;return M.length}const b=W(t.matchesPrefix,_,C),f=W(t.matchesPrefix,_,y),z=new E.LRUCache(1e4);function $(M,B,q=!1){if(typeof M!="string"||typeof B!="string")return null;let ee=z.get(M);ee||(ee=new RegExp(i.convertSimple2RegExpPattern(M),"i"),z.set(M,ee));const le=ee.exec(B);return le?[{start:le.index,end:le.index+le[0].length}]:q?f(M,B):b(M,B)}t.matchesFuzzy=$;function X(M,B){const q=K(M,M.toLowerCase(),0,B,B.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?ge(q):null}t.matchesFuzzy2=X;function J(M,B,q,ee,le,de){const ye=Math.min(13,M.length);for(;q<ye;q++){const Ee=K(M,B,q,ee,le,de,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(Ee)return Ee}return[0,de]}t.anyScore=J;function ge(M){if(typeof M>"u")return[];const B=[],q=M[1];for(let ee=M.length-1;ee>1;ee--){const le=M[ee]+q,de=B[B.length-1];de&&de.end===le?de.end=le+1:B.push({start:le,end:le+1})}return B}t.createMatches=ge;const re=128;function me(){const M=[],B=[];for(let q=0;q<=re;q++)B[q]=0;for(let q=0;q<=re;q++)M.push(B.slice(0));return M}function ae(M){const B=[];for(let q=0;q<=M;q++)B[q]=0;return B}const he=ae(2*re),Se=ae(2*re),te=me(),De=me(),se=me(),ie=!1;function ce(M,B,q,ee,le){function de(Ee,Re,Le=" "){for(;Ee.length<Re;)Ee=Le+Ee;return Ee}let ye=` |   |${ee.split("").map(Ee=>de(Ee,3)).join("|")}
`;for(let Ee=0;Ee<=q;Ee++)Ee===0?ye+=" |":ye+=`${B[Ee-1]}|`,ye+=M[Ee].slice(0,le+1).map(Re=>de(Re.toString(),3)).join("|")+`
`;return ye}function ne(M,B,q,ee){M=M.substr(B),q=q.substr(ee),console.log(ce(De,M,M.length,q,q.length)),console.log(ce(se,M,M.length,q,q.length)),console.log(ce(te,M,M.length,q,q.length))}function F(M,B){if(B<0||B>=M.length)return!1;const q=M.codePointAt(B);switch(q){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(q)}}function V(M,B){if(B<0||B>=M.length)return!1;switch(M.charCodeAt(B)){case 32:case 9:return!0;default:return!1}}function j(M,B,q){return B[M]!==q[M]}function k(M,B,q,ee,le,de,ye=!1){for(;B<q&&le<de;)M[B]===ee[le]&&(ye&&(he[B]=le),B+=1),le+=1;return B===q}t.isPatternInWord=k;var h;(function(M){M[M.Diag=1]="Diag",M[M.Left=2]="Left",M[M.LeftLeft=3]="LeftLeft"})(h||(h={}));var I;(function(M){M.Default=[-100,0];function B(q){return!q||q.length===2&&q[0]===-100&&q[1]===0}M.isDefault=B})(I=t.FuzzyScore||(t.FuzzyScore={}));class U{constructor(B,q){this.firstMatchCanBeWeak=B,this.boostFullMatch=q}}t.FuzzyScoreOptions=U,U.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function K(M,B,q,ee,le,de,ye=U.default){const Ee=M.length>re?re:M.length,Re=ee.length>re?re:ee.length;if(q>=Ee||de>=Re||Ee-q>Re-de||!k(B,q,Ee,le,de,Re,!0))return;Z(Ee,Re,q,de,B,le);let Le=1,ve=1,Pe=q,ke=de;const je=[!1];for(Le=1,Pe=q;Pe<Ee;Le++,Pe++){const Me=he[Pe],qe=Se[Pe],x=Pe+1<Ee?Se[Pe+1]:Re;for(ve=Me-de+1,ke=Me;ke<x;ve++,ke++){let oe=Number.MIN_SAFE_INTEGER,we=!1;ke<=qe&&(oe=N(M,B,Pe,q,ee,le,ke,Re,de,te[Le-1][ve-1]===0,je));let Ce=0;oe!==Number.MAX_SAFE_INTEGER&&(we=!0,Ce=oe+De[Le-1][ve-1]);const Ae=ke>Me,Oe=Ae?De[Le][ve-1]+(te[Le][ve-1]>0?-5:0):0,$e=ke>Me+1&&te[Le][ve-1]>0,Ge=$e?De[Le][ve-2]+(te[Le][ve-2]>0?-5:0):0;if($e&&(!Ae||Ge>=Oe)&&(!we||Ge>=Ce))De[Le][ve]=Ge,se[Le][ve]=3,te[Le][ve]=0;else if(Ae&&(!we||Oe>=Ce))De[Le][ve]=Oe,se[Le][ve]=2,te[Le][ve]=0;else if(we)De[Le][ve]=Ce,se[Le][ve]=1,te[Le][ve]=te[Le-1][ve-1]+1;else throw new Error("not possible")}}if(ie&&ne(M,q,ee,de),!je[0]&&!ye.firstMatchCanBeWeak)return;Le--,ve--;const He=[De[Le][ve],de];let Ue=0,Je=0;for(;Le>=1;){let Me=ve;do{const qe=se[Le][Me];if(qe===3)Me=Me-2;else if(qe===2)Me=Me-1;else break}while(Me>=1);Ue>1&&B[q+Le-1]===le[de+ve-1]&&!j(Me+de-1,ee,le)&&Ue+1>te[Le][Me]&&(Me=ve),Me===ve?Ue++:Ue=1,Je||(Je=Me),Le--,ve=Me-1,He.push(ve)}Re===Ee&&ye.boostFullMatch&&(He[0]+=2);const it=Je-Ee;return He[0]-=it,He}t.fuzzyScore=K;function Z(M,B,q,ee,le,de){let ye=M-1,Ee=B-1;for(;ye>=q&&Ee>=ee;)le[ye]===de[Ee]&&(Se[ye]=Ee,ye--),Ee--}function N(M,B,q,ee,le,de,ye,Ee,Re,Le,ve){if(B[q]!==de[ye])return Number.MIN_SAFE_INTEGER;let Pe=1,ke=!1;return ye===q-ee?Pe=M[q]===le[ye]?7:5:j(ye,le,de)&&(ye===0||!j(ye-1,le,de))?(Pe=M[q]===le[ye]?7:5,ke=!0):F(de,ye)&&(ye===0||!F(de,ye-1))?Pe=5:(F(de,ye-1)||V(de,ye-1))&&(Pe=5,ke=!0),Pe>1&&q===ee&&(ve[0]=!0),ke||(ke=j(ye,le,de)||F(de,ye-1)||V(de,ye-1)),q===ee?ye>Re&&(Pe-=ke?3:5):Le?Pe+=ke?2:0:Pe+=ke?0:1,ye+1===Ee&&(Pe-=ke?3:5),Pe}function R(M,B,q,ee,le,de,ye){return A(M,B,q,ee,le,de,!0,ye)}t.fuzzyScoreGracefulAggressive=R;function H(M,B,q,ee,le,de,ye){return A(M,B,q,ee,le,de,!1,ye)}t.fuzzyScoreGraceful=H;function A(M,B,q,ee,le,de,ye,Ee){let Re=K(M,B,q,ee,le,de,Ee);if(Re&&!ye)return Re;if(M.length>=3){const Le=Math.min(7,M.length-1);for(let ve=q+1;ve<Le;ve++){const Pe=P(M,ve);if(Pe){const ke=K(Pe,Pe.toLowerCase(),q,ee,le,de,Ee);ke&&(ke[0]-=3,(!Re||ke[0]>Re[0])&&(Re=ke))}}}return Re}function P(M,B){if(B+1>=M.length)return;const q=M[B],ee=M[B+1];if(q!==ee)return M.slice(0,B)+ee+q+M.slice(B+2)}}),define(pe[34],be([1,0,11,33,10]),function(Q,t,E,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=t.iconStartMarker=void 0,t.iconStartMarker="$(";const O=new RegExp(`\\$\\(${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(E.CSSIcon.iconNameCharacter),y=new RegExp(`(\\\\)?${O.source}`,"g");function d(v){return v.replace(y,(w,D)=>D?w:`\\${w}`)}t.escapeIcons=d;const c=new RegExp(`\\\\${O.source}`,"g");function g(v){return v.replace(c,w=>`\\${w}`)}t.markdownEscapeEscapedIcons=g;const L=new RegExp(`(\\s)?(\\\\)?${O.source}(\\s)?`,"g");function o(v){return v.indexOf(t.iconStartMarker)===-1?v:v.replace(L,(w,D,a,u)=>a?w:D||u||"")}t.stripIcons=o;function s(v){const w=v.indexOf(t.iconStartMarker);return w===-1?{text:v}:e(v,w)}t.parseLabelWithIcons=s;function e(v,w){const D=[];let a="";function u(b){if(b){a+=b;for(const f of b)D.push(T)}}let p=-1,S="",T=0,_,r,n=w;const l=v.length;for(u(v.substr(0,w));n<l;)_=v[n],r=v[n+1],_===t.iconStartMarker[0]&&r===t.iconStartMarker[1]?(p=n,u(S),S=t.iconStartMarker,n++):_===")"&&p!==-1?(T+=n-p+1,p=-1,S=""):p!==-1?C.test(_)?S+=_:(u(S),p=-1,S=""):u(_),n++;return u(S),{text:a,iconOffsets:D}}function m(v,w,D=!1){const{text:a,iconOffsets:u}=w;if(!u||u.length===0)return(0,i.matchesFuzzy)(v,a,D);const p=(0,W.ltrim)(a," "),S=a.length-p.length,T=(0,i.matchesFuzzy)(v,p,D);if(T)for(const _ of T){const r=u[_.start+S]+S;_.start+=r,_.end+=r}return T}t.matchesFuzzyIconAware=m}),define(pe[16],be([1,0,21,5]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const W=/^\w[\w\d+.-]*$/,O=/^\//,C=/^\/\//;function y(_,r){if(!_.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${_.authority}", path: "${_.path}", query: "${_.query}", fragment: "${_.fragment}"}`);if(_.scheme&&!W.test(_.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(_.path){if(_.authority){if(!O.test(_.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(_.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(_,r){return!_&&!r?"file":_}function c(_,r){switch(_){case"https":case"http":case"file":r?r[0]!==L&&(r=L+r):r=L;break}return r}const g="",L="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(r){return r instanceof s?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,n,l,b,f,z=!1){typeof r=="object"?(this.scheme=r.scheme||g,this.authority=r.authority||g,this.path=r.path||g,this.query=r.query||g,this.fragment=r.fragment||g):(this.scheme=d(r,z),this.authority=n||g,this.path=c(this.scheme,l||g),this.query=b||g,this.fragment=f||g,y(this,z))}get fsPath(){return a(this,!1)}with(r){if(!r)return this;let{scheme:n,authority:l,path:b,query:f,fragment:z}=r;return n===void 0?n=this.scheme:n===null&&(n=g),l===void 0?l=this.authority:l===null&&(l=g),b===void 0?b=this.path:b===null&&(b=g),f===void 0?f=this.query:f===null&&(f=g),z===void 0?z=this.fragment:z===null&&(z=g),n===this.scheme&&l===this.authority&&b===this.path&&f===this.query&&z===this.fragment?this:new m(n,l,b,f,z)}static parse(r,n=!1){const l=o.exec(r);return l?new m(l[2]||g,T(l[4]||g),T(l[5]||g),T(l[7]||g),T(l[9]||g),n):new m(g,g,g,g,g)}static file(r){let n=g;if(i.isWindows&&(r=r.replace(/\\/g,L)),r[0]===L&&r[1]===L){const l=r.indexOf(L,2);l===-1?(n=r.substring(2),r=L):(n=r.substring(2,l),r=r.substring(l)||L)}return new m("file",n,r,g,g)}static from(r){const n=new m(r.scheme,r.authority,r.path,r.query,r.fragment);return y(n,!0),n}static joinPath(r,...n){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return i.isWindows&&r.scheme==="file"?l=s.file(E.win32.join(a(r,!0),...n)).path:l=E.posix.join(r.path,...n),r.with({path:l})}toString(r=!1){return u(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof s)return r;{const n=new m(r);return n._formatted=r.external,n._fsPath=r._sep===e?r.fsPath:null,n}}else return r}}t.URI=s;const e=i.isWindows?1:void 0;class m extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(r=!1){return r?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=e),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(_,r){let n,l=-1;for(let b=0;b<_.length;b++){const f=_.charCodeAt(b);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||r&&f===47)l!==-1&&(n+=encodeURIComponent(_.substring(l,b)),l=-1),n!==void 0&&(n+=_.charAt(b));else{n===void 0&&(n=_.substr(0,b));const z=v[f];z!==void 0?(l!==-1&&(n+=encodeURIComponent(_.substring(l,b)),l=-1),n+=z):l===-1&&(l=b)}}return l!==-1&&(n+=encodeURIComponent(_.substring(l))),n!==void 0?n:_}function D(_){let r;for(let n=0;n<_.length;n++){const l=_.charCodeAt(n);l===35||l===63?(r===void 0&&(r=_.substr(0,n)),r+=v[l]):r!==void 0&&(r+=_[n])}return r!==void 0?r:_}function a(_,r){let n;return _.authority&&_.path.length>1&&_.scheme==="file"?n=`//${_.authority}${_.path}`:_.path.charCodeAt(0)===47&&(_.path.charCodeAt(1)>=65&&_.path.charCodeAt(1)<=90||_.path.charCodeAt(1)>=97&&_.path.charCodeAt(1)<=122)&&_.path.charCodeAt(2)===58?r?n=_.path.substr(1):n=_.path[1].toLowerCase()+_.path.substr(2):n=_.path,i.isWindows&&(n=n.replace(/\//g,"\\")),n}t.uriToFsPath=a;function u(_,r){const n=r?D:w;let l="",{scheme:b,authority:f,path:z,query:$,fragment:X}=_;if(b&&(l+=b,l+=":"),(f||b==="file")&&(l+=L,l+=L),f){let J=f.indexOf("@");if(J!==-1){const ge=f.substr(0,J);f=f.substr(J+1),J=ge.indexOf(":"),J===-1?l+=n(ge,!1):(l+=n(ge.substr(0,J),!1),l+=":",l+=n(ge.substr(J+1),!1)),l+="@"}f=f.toLowerCase(),J=f.indexOf(":"),J===-1?l+=n(f,!1):(l+=n(f.substr(0,J),!1),l+=f.substr(J))}if(z){if(z.length>=3&&z.charCodeAt(0)===47&&z.charCodeAt(2)===58){const J=z.charCodeAt(1);J>=65&&J<=90&&(z=`/${String.fromCharCode(J+32)}:${z.substr(3)}`)}else if(z.length>=2&&z.charCodeAt(1)===58){const J=z.charCodeAt(0);J>=65&&J<=90&&(z=`${String.fromCharCode(J+32)}:${z.substr(2)}`)}l+=n(z,!0)}return $&&(l+="?",l+=n($,!1)),X&&(l+="#",l+=r?X:w(X,!1)),l}function p(_){try{return decodeURIComponent(_)}catch{return _.length>3?_.substr(0,3)+p(_.substr(3)):_}}const S=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function T(_){return _.match(S)?_.replace(S,r=>p(r)):_}}),define(pe[50],be([1,0,31,10,16]),function(Q,t,E,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function O(c){return JSON.stringify(c,y)}t.stringify=O;function C(c){let g=JSON.parse(c);return g=d(g),g}t.parse=C;function y(c,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:(0,i.regExpFlags)(g)}:g}function d(c,g=0){if(!c||g>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return W.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 14:return new Date(c.source)}if(c instanceof E.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let L=0;L<c.length;++L)c[L]=d(c[L],g+1);else for(const L in c)Object.hasOwnProperty.call(c,L)&&(c[L]=d(c[L],g+1))}return c}t.revive=d}),define(pe[35],be([1,0,5,16]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var W;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebook="vscode-notebook",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractive="vscode-interactive",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(W=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class O{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${W.vscodeRemoteResource}`}setPreferredWebSchema(c){this._preferredWebSchema=c}setDelegate(c){this._delegate=c}setServerRootPath(c){this._remoteResourcesPath=`${c}/${W.vscodeRemoteResource}`}set(c,g,L){this._hosts[c]=g,this._ports[c]=L}setConnectionToken(c,g){this._connectionTokens[c]=g}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(c){if(this._delegate)return this._delegate(c);const g=c.authority;let L=this._hosts[g];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const o=this._ports[g],s=this._connectionTokens[g];let e=`path=${encodeURIComponent(c.path)}`;return typeof s=="string"&&(e+=`&${t.connectionTokenQueryName}=${encodeURIComponent(s)}`),i.URI.from({scheme:E.isWeb?this._preferredWebSchema:W.vscodeRemoteResource,authority:`${L}:${o}`,path:this._remoteResourcesPath,query:e})}}t.RemoteAuthorities=new O;class C{asBrowserUri(c,g){const L=this.toUri(c,g);return L.scheme===W.vscodeRemote?t.RemoteAuthorities.rewrite(L):L.scheme===W.file&&(E.isNative||E.isWebWorker&&E.globals.origin===`${W.vscodeFileResource}://${C.FALLBACK_AUTHORITY}`)?L.with({scheme:W.vscodeFileResource,authority:L.authority||C.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(c,g){const L=this.toUri(c,g);return L.scheme===W.vscodeFileResource?L.with({scheme:W.file,authority:L.authority!==C.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(c,g){return i.URI.isUri(c)?c:i.URI.parse(g.toUrl(c))}}C.FALLBACK_AUTHORITY="vscode-app",t.FileAccess=new C;var y;(function(d){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(c.get("3"));const g="vscode-coi";function L(s){let e;typeof s=="string"?e=new URL(s).searchParams:s instanceof URL?e=s.searchParams:i.URI.isUri(s)&&(e=new URL(s.toString(!0)).searchParams);const m=e?.get(g);if(!!m)return c.get(m)}d.getHeadersFromQuery=L;function o(s,e,m){if(!globalThis.crossOriginIsolated)return;const v=e&&m?"3":m?"2":"1";s instanceof URLSearchParams?s.set(g,v):s[g]=v}d.addSearchParam=o})(y=t.COI||(t.COI={}))}),define(pe[36],be([1,0,109,35,21,5,10,16]),function(Q,t,E,i,W,O,C,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function d(s){return(0,y.uriToFsPath)(s,!0)}t.originalFSPath=d;class c{constructor(e){this._ignorePathCasing=e}compare(e,m,v=!1){return e===m?0:(0,C.compare)(this.getComparisonKey(e,v),this.getComparisonKey(m,v))}isEqual(e,m,v=!1){return e===m?!0:!e||!m?!1:this.getComparisonKey(e,v)===this.getComparisonKey(m,v)}getComparisonKey(e,m=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(e){return this._ignorePathCasing(e)}isEqualOrParent(e,m,v=!1){if(e.scheme===m.scheme){if(e.scheme===i.Schemas.file)return E.isEqualOrParent(d(e),d(m),this._ignorePathCasing(e))&&e.query===m.query&&(v||e.fragment===m.fragment);if((0,t.isEqualAuthority)(e.authority,m.authority))return E.isEqualOrParent(e.path,m.path,this._ignorePathCasing(e),"/")&&e.query===m.query&&(v||e.fragment===m.fragment)}return!1}joinPath(e,...m){return y.URI.joinPath(e,...m)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return W.posix.basename(e.path)}extname(e){return W.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let m;return e.scheme===i.Schemas.file?m=y.URI.file(W.dirname(d(e))).path:(m=W.posix.dirname(e.path),e.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),m="/")),e.with({path:m})}normalizePath(e){if(!e.path.length)return e;let m;return e.scheme===i.Schemas.file?m=y.URI.file(W.normalize(d(e))).path:m=W.posix.normalize(e.path),e.with({path:m})}relativePath(e,m){if(e.scheme!==m.scheme||!(0,t.isEqualAuthority)(e.authority,m.authority))return;if(e.scheme===i.Schemas.file){const D=W.relative(d(e),d(m));return O.isWindows?E.toSlashes(D):D}let v=e.path||"/";const w=m.path||"/";if(this._ignorePathCasing(e)){let D=0;for(const a=Math.min(v.length,w.length);D<a&&!(v.charCodeAt(D)!==w.charCodeAt(D)&&v.charAt(D).toLowerCase()!==w.charAt(D).toLowerCase());D++);v=w.substr(0,D)+v.substr(D)}return W.posix.relative(v,w)}resolvePath(e,m){if(e.scheme===i.Schemas.file){const v=y.URI.file(W.resolve(d(e),m));return e.with({authority:v.authority,path:v.path})}return m=E.toPosixPath(m),e.with({path:W.posix.resolve(e.path,m)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,m){return e===m||e!==void 0&&m!==void 0&&(0,C.equalsIgnoreCase)(e,m)}hasTrailingPathSeparator(e,m=W.sep){if(e.scheme===i.Schemas.file){const v=d(e);return v.length>E.getRoot(v).length&&v[v.length-1]===m}else{const v=e.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,m=W.sep){return(0,t.hasTrailingPathSeparator)(e,m)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,m=W.sep){let v=!1;if(e.scheme===i.Schemas.file){const w=d(e);v=w!==void 0&&w.length===E.getRoot(w).length&&w[w.length-1]===m}else{m="/";const w=e.path;v=w.length===1&&w.charCodeAt(w.length-1)===47}return!v&&!(0,t.hasTrailingPathSeparator)(e,m)?e.with({path:e.path+"/"}):e}}t.ExtUri=c,t.extUri=new c(()=>!1),t.extUriBiasedIgnorePathCase=new c(s=>s.scheme===i.Schemas.file?!O.isLinux:!0),t.extUriIgnorePathCase=new c(s=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function g(s,e){const m=[];for(let v=0;v<s.length;v++){const w=e(s[v]);s.some((D,a)=>a===v?!1:(0,t.isEqualOrParent)(w,e(D)))||m.push(s[v])}return m}t.distinctParents=g;var L;(function(s){s.META_DATA_LABEL="label",s.META_DATA_DESCRIPTION="description",s.META_DATA_SIZE="size",s.META_DATA_MIME="mime";function e(m){const v=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(a=>{const[u,p]=a.split(":");u&&p&&v.set(u,p)});const D=m.path.substring(0,m.path.indexOf(";"));return D&&v.set(s.META_DATA_MIME,D),v}s.parseMetaData=e})(L=t.DataUri||(t.DataUri={}));function o(s,e,m){if(e){let v=s.path;return v&&v[0]!==W.posix.sep&&(v=W.posix.sep+v),s.with({scheme:m,authority:e,path:v})}return s.with({scheme:m})}t.toLocalResource=o}),define(pe[8],be([1,0,28,12,3,2,36,5]),function(Q,t,E,i,W,O,C,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.MicrotaskDelay=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function d(j){return!!j&&typeof j.then=="function"}t.isThenable=d;function c(j){const k=new E.CancellationTokenSource,h=j(k.token),I=new Promise((U,K)=>{const Z=k.token.onCancellationRequested(()=>{Z.dispose(),k.dispose(),K(new i.CancellationError)});Promise.resolve(h).then(N=>{Z.dispose(),k.dispose(),U(N)},N=>{Z.dispose(),k.dispose(),K(N)})});return new class{cancel(){k.cancel()}then(U,K){return I.then(U,K)}catch(U){return this.then(void 0,U)}finally(U){return I.finally(U)}}}t.createCancelablePromise=c;function g(j,k,h){return new Promise((I,U)=>{const K=k.onCancellationRequested(()=>{K.dispose(),I(h)});j.then(I,U).finally(()=>K.dispose())})}t.raceCancellation=g;function L(j,k){return new Promise((h,I)=>{const U=k.onCancellationRequested(()=>{U.dispose(),I(new i.CancellationError)});j.then(h,I).finally(()=>U.dispose())})}t.raceCancellationError=L;async function o(j){let k=-1;const h=j.map((U,K)=>U.then(Z=>(k=K,Z))),I=await Promise.race(h);return j.forEach((U,K)=>{K!==k&&U.cancel()}),I}t.raceCancellablePromises=o;function s(j,k,h){let I;const U=setTimeout(()=>{I?.(void 0),h?.()},k);return Promise.race([j.finally(()=>clearTimeout(U)),new Promise(K=>I=K)])}t.raceTimeout=s;function e(j){return new Promise((k,h)=>{const I=j();d(I)?I.then(k,h):k(I)})}t.asPromise=e;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(k){if(this.activePromise){if(this.queuedPromiseFactory=k,!this.queuedPromise){const h=()=>{this.queuedPromise=null;const I=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,I};this.queuedPromise=new Promise(I=>{this.activePromise.then(h,h).then(I)})}return new Promise((h,I)=>{this.queuedPromise.then(h,I)})}return this.activePromise=k(),new Promise((h,I)=>{this.activePromise.then(U=>{this.activePromise=null,h(U)},U=>{this.activePromise=null,I(U)})})}}t.Throttler=m;class v{constructor(){this.current=Promise.resolve(null)}queue(k){return this.current=this.current.then(()=>k(),()=>k())}}t.Sequencer=v;class w{constructor(){this.promiseMap=new Map}queue(k,h){const U=(this.promiseMap.get(k)??Promise.resolve()).catch(()=>{}).then(h).finally(()=>{this.promiseMap.get(k)===U&&this.promiseMap.delete(k)});return this.promiseMap.set(k,U),U}}t.SequencerByKey=w;const D=(j,k)=>{let h=!0;const I=setTimeout(()=>{h=!1,k()},j);return{isTriggered:()=>h,dispose:()=>{clearTimeout(I),h=!1}}},a=j=>{let k=!0;return queueMicrotask(()=>{k&&(k=!1,j())}),{isTriggered:()=>k,dispose:()=>{k=!1}}};t.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(k){this.defaultDelay=k,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(k,h=this.defaultDelay){this.task=k,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,K)=>{this.doResolve=U,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}}));const I=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=h===t.MicrotaskDelay?a(I):D(h,I),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=u;class p{constructor(k){this.delayer=new u(k),this.throttler=new m}trigger(k,h){return this.delayer.trigger(()=>this.throttler.queue(k),h)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}t.ThrottledDelayer=p;class S{constructor(){this._isOpen=!1,this._promise=new Promise((k,h)=>{this._completePromise=k})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=S;class T extends S{constructor(k){super(),this._timeout=setTimeout(()=>this.open(),k)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=T;function _(j,k){return k?new Promise((h,I)=>{const U=setTimeout(()=>{K.dispose(),h()},j),K=k.onCancellationRequested(()=>{clearTimeout(U),K.dispose(),I(new i.CancellationError)})}):c(h=>_(j,h))}t.timeout=_;function r(j,k=0){const h=setTimeout(j,k);return(0,O.toDisposable)(()=>clearTimeout(h))}t.disposableTimeout=r;function n(j){const k=[];let h=0;const I=j.length;function U(){return h<I?j[h++]():null}function K(Z){Z!=null&&k.push(Z);const N=U();return N?N.then(K):Promise.resolve(k)}return Promise.resolve(null).then(K)}t.sequence=n;function l(j,k=I=>!!I,h=null){let I=0;const U=j.length,K=()=>{if(I>=U)return Promise.resolve(h);const Z=j[I++];return Promise.resolve(Z()).then(R=>k(R)?Promise.resolve(R):K())};return K()}t.first=l;function b(j,k=I=>!!I,h=null){if(j.length===0)return Promise.resolve(h);let I=j.length;const U=()=>{I=-1;for(const K of j)K.cancel?.()};return new Promise((K,Z)=>{for(const N of j)N.then(R=>{--I>=0&&k(R)?(U(),K(R)):I===0&&K(h)}).catch(R=>{--I>=0&&(U(),Z(R))})})}t.firstParallel=b;class f{constructor(k){this._size=0,this.maxDegreeOfParalellism=k,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new W.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(k){return this._size++,new Promise((h,I)=>{this.outstandingPromises.push({factory:k,c:h,e:I}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const k=this.outstandingPromises.shift();this.runningPromises++;const h=k.factory();h.then(k.c,k.e),h.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}t.Limiter=f;class z extends f{constructor(){super(1)}}t.Queue=z;class ${constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const k=new se;return this.drainers.add(k),k.p}isDrained(){for(const[,k]of this.queues)if(k.size>0)return!1;return!0}queueFor(k,h=C.extUri){const I=h.getComparisonKey(k);let U=this.queues.get(I);return U||(U=new z,W.Event.once(U.onDrained)(()=>{U?.dispose(),this.queues.delete(I),this.onDidQueueDrain()}),this.queues.set(I,U)),U}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const k of this.drainers)k.complete();this.drainers.clear()}dispose(){for(const[,k]of this.queues)k.dispose();this.queues.clear(),this.releaseDrainers()}}t.ResourceQueue=$;class X{constructor(k,h){this._token=-1,typeof k=="function"&&typeof h=="number"&&this.setIfNotSet(k,h)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(k,h){this.cancel(),this._token=setTimeout(()=>{this._token=-1,k()},h)}setIfNotSet(k,h){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,k()},h))}}t.TimeoutTimer=X;class J{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(k,h){this.cancel(),this._token=setInterval(()=>{k()},h)}}t.IntervalTimer=J;class ge{constructor(k,h){this.timeoutToken=-1,this.runner=k,this.timeout=h,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(k=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,k)}get delay(){return this.timeout}set delay(k){this.timeout=k}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=ge;class re{constructor(k,h){h%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${h}ms is not a multiple of 1000ms.`),this.runner=k,this.timeout=h,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(k=this.timeout){k%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${k}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(k/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=re;class me extends ge{constructor(k,h){super(k,h),this.units=[]}work(k){this.units.push(k),this.isScheduled()||this.schedule()}doRun(){const k=this.units;this.units=[],this.runner?.(k)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=me;class ae extends O.Disposable{constructor(k,h){super(),this.options=k,this.handler=h,this.pendingWork=[],this.throttler=this._register(new O.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(k){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+k.length>this.options.maxBufferedWork)return!1}else if(this.pending+k.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...k),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new ge(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=ae,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=j=>{(0,y.setTimeout0)(()=>{if(k)return;const h=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,h-Date.now())}}))});let k=!1;return{dispose(){k||(k=!0)}}}:t.runWhenIdle=(j,k)=>{const h=requestIdleCallback(j,typeof k=="number"?{timeout:k}:void 0);let I=!1;return{dispose(){I||(I=!0,cancelIdleCallback(h))}}}}();class he{constructor(k){this._didRun=!1,this._executor=()=>{try{this._value=k()}catch(h){this._error=h}finally{this._didRun=!0}},this._handle=(0,t.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.IdleValue=he;async function Se(j,k,h){let I;for(let U=0;U<h;U++)try{return await j()}catch(K){I=K,await _(k)}throw I}t.retry=Se;class te{hasPending(k){return this._pending?typeof k=="number"?this._pending.taskId===k:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(k,h,I){return this._pending={taskId:k,cancel:()=>I?.(),promise:h},h.then(()=>this.donePending(k),()=>this.donePending(k)),h}donePending(k){this._pending&&k===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const k=this._next;this._next=void 0,k.run().then(k.promiseResolve,k.promiseReject)}}setNext(k){if(this._next)this._next.run=k;else{let h,I;const U=new Promise((K,Z)=>{h=K,I=Z});this._next={run:k,promise:U,promiseResolve:h,promiseReject:I}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}t.TaskSequentializer=te;class De{constructor(k,h=()=>Date.now()){this.interval=k,this.nowFn=h,this.lastIncrementTime=0,this.value=0}increment(){const k=this.nowFn();return k-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=k,this.value=0),this.value++,this.value}}t.IntervalCounter=De;class se{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((k,h)=>{this.completeCallback=k,this.errorCallback=h})}complete(k){return new Promise(h=>{this.completeCallback(k),this.resolved=!0,h()})}error(k){return new Promise(h=>{this.errorCallback(k),this.rejected=!0,h()})}cancel(){new Promise(k=>{this.errorCallback(new i.CancellationError),this.rejected=!0,k()})}}t.DeferredPromise=se;var ie;(function(j){async function k(I){let U;const K=await Promise.all(I.map(Z=>Z.then(N=>N,N=>{U||(U=N)})));if(typeof U<"u")throw U;return K}j.settled=k;function h(I){return new Promise(async(U,K)=>{try{await I(U,K)}catch(Z){K(Z)}})}j.withAsyncBody=h})(ie=t.Promises||(t.Promises={}));var ce;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(ce||(ce={}));class ne{static fromArray(k){return new ne(h=>{h.emitMany(k)})}static fromPromise(k){return new ne(async h=>{h.emitMany(await k)})}static fromPromises(k){return new ne(async h=>{await Promise.all(k.map(async I=>h.emitOne(await I)))})}static merge(k){return new ne(async h=>{await Promise.all(k.map(async I=>{for await(const U of I)h.emitOne(U)}))})}constructor(k){this._state=0,this._results=[],this._error=null,this._onStateChanged=new W.Emitter,queueMicrotask(async()=>{const h={emitOne:I=>this.emitOne(I),emitMany:I=>this.emitMany(I),reject:I=>this.reject(I)};try{await Promise.resolve(k(h)),this.resolve()}catch(I){this.reject(I)}finally{h.emitOne=void 0,h.emitMany=void 0,h.reject=void 0}})}[Symbol.asyncIterator](){let k=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(k<this._results.length)return{done:!1,value:this._results[k++]};if(this._state===1)return{done:!0,value:void 0};await W.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(k,h){return new ne(async I=>{for await(const U of k)I.emitOne(h(U))})}map(k){return ne.map(this,k)}static filter(k,h){return new ne(async I=>{for await(const U of k)h(U)&&I.emitOne(U)})}filter(k){return ne.filter(this,k)}static coalesce(k){return ne.filter(k,h=>!!h)}coalesce(){return ne.coalesce(this)}static async toPromise(k){const h=[];for await(const I of k)h.push(I);return h}toPromise(){return ne.toPromise(this)}emitOne(k){this._state===0&&(this._results.push(k),this._onStateChanged.fire())}emitMany(k){this._state===0&&(this._results=this._results.concat(k),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(k){this._state===0&&(this._state=2,this._error=k,this._onStateChanged.fire())}}t.AsyncIterableObject=ne,ne.EMPTY=ne.fromArray([]);class F extends ne{constructor(k,h){super(h),this._source=k}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=F;function V(j){const k=new E.CancellationTokenSource,h=j(k.token);return new F(k,async I=>{const U=k.token.onCancellationRequested(()=>{U.dispose(),k.dispose(),I.reject(new i.CancellationError)});try{for await(const K of h){if(k.token.isCancellationRequested)return;I.emitOne(K)}U.dispose(),k.dispose()}catch(K){U.dispose(),k.dispose(),I.reject(K)}})}t.createCancelableAsyncIterable=V}),define(pe[4],be([1,0,15,107,19,20,8,12,3,112,2,35,5,6,16]),function(Q,t,E,i,W,O,C,y,d,c,g,L,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.computeClippingRect=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function m(Y){for(;Y.firstChild;)Y.firstChild.remove()}t.clearNode=m;function v(Y){return Y?.isConnected??!1}t.isInDOM=v;class w{constructor(G,fe,Te,Fe){this._node=G,this._type=fe,this._handler=Te,this._options=Fe||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){!this._handler||(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function D(Y,G,fe,Te){return new w(Y,G,fe,Te)}t.addDisposableListener=D;function a(Y){return function(G){return Y(new O.StandardMouseEvent(G))}}function u(Y){return function(G){return Y(new W.StandardKeyboardEvent(G))}}const p=function(G,fe,Te,Fe){let Ve=Te;return fe==="click"||fe==="mousedown"?Ve=a(Te):(fe==="keydown"||fe==="keypress"||fe==="keyup")&&(Ve=u(Te)),D(G,fe,Ve,Fe)};t.addStandardDisposableListener=p;const S=function(G,fe,Te){const Fe=a(fe);return _(G,Fe,Te)};t.addStandardDisposableGenericMouseDownListener=S;const T=function(G,fe,Te){const Fe=a(fe);return n(G,Fe,Te)};t.addStandardDisposableGenericMouseUpListener=T;function _(Y,G,fe){return D(Y,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,G,fe)}t.addDisposableGenericMouseDownListener=_;function r(Y,G,fe){return D(Y,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,G,fe)}t.addDisposableGenericMouseMoveListener=r;function n(Y,G,fe){return D(Y,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,G,fe)}t.addDisposableGenericMouseUpListener=n;class l{constructor(G,fe=0){this._runner=G,this.priority=fe,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(G){(0,y.onUnexpectedError)(G)}}static sort(G,fe){return fe.priority-G.priority}}(function(){let Y=[],G=null,fe=!1,Te=!1;const Fe=()=>{for(fe=!1,G=Y,Y=[],Te=!0;G.length>0;)G.sort(l.sort),G.shift().execute();Te=!1};t.scheduleAtNextAnimationFrame=(Ve,ze=0)=>{const xe=new l(Ve,ze);return Y.push(xe),fe||(fe=!0,requestAnimationFrame(Fe)),xe},t.runAtThisOrScheduleAtNextAnimationFrame=(Ve,ze)=>{if(Te){const xe=new l(Ve,ze);return G.push(xe),xe}else return(0,t.scheduleAtNextAnimationFrame)(Ve,ze)}})();function b(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,1e4)}t.measure=b;function f(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,-1e4)}t.modify=f;const z=8,$=function(Y,G){return G};class X extends g.Disposable{constructor(G,fe,Te,Fe=$,Ve=z){super();let ze=null,xe=0;const Qe=this._register(new C.TimeoutTimer),gt=()=>{xe=new Date().getTime(),Te(ze),ze=null};this._register(D(G,fe,It=>{ze=Fe(ze,It);const mt=new Date().getTime()-xe;mt>=Ve?(Qe.cancel(),gt()):Qe.setIfNotSet(gt,Ve-mt)}))}}function J(Y,G,fe,Te,Fe){return new X(Y,G,fe,Te,Fe)}t.addDisposableThrottledListener=J;function ge(Y){return document.defaultView.getComputedStyle(Y,null)}t.getComputedStyle=ge;function re(Y){if(Y!==document.body)return new ae(Y.clientWidth,Y.clientHeight);if(o.isIOS&&window.visualViewport)return new ae(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new ae(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new ae(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new ae(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=re;class me{static convertToPixels(G,fe){return parseFloat(fe)||0}static getDimension(G,fe,Te){const Fe=ge(G),Ve=Fe?Fe.getPropertyValue(fe):"0";return me.convertToPixels(G,Ve)}static getBorderLeftWidth(G){return me.getDimension(G,"border-left-width","borderLeftWidth")}static getBorderRightWidth(G){return me.getDimension(G,"border-right-width","borderRightWidth")}static getBorderTopWidth(G){return me.getDimension(G,"border-top-width","borderTopWidth")}static getBorderBottomWidth(G){return me.getDimension(G,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(G){return me.getDimension(G,"padding-left","paddingLeft")}static getPaddingRight(G){return me.getDimension(G,"padding-right","paddingRight")}static getPaddingTop(G){return me.getDimension(G,"padding-top","paddingTop")}static getPaddingBottom(G){return me.getDimension(G,"padding-bottom","paddingBottom")}static getMarginLeft(G){return me.getDimension(G,"margin-left","marginLeft")}static getMarginTop(G){return me.getDimension(G,"margin-top","marginTop")}static getMarginRight(G){return me.getDimension(G,"margin-right","marginRight")}static getMarginBottom(G){return me.getDimension(G,"margin-bottom","marginBottom")}}class ae{constructor(G,fe){this.width=G,this.height=fe}with(G=this.width,fe=this.height){return G!==this.width||fe!==this.height?new ae(G,fe):this}static is(G){return typeof G=="object"&&typeof G.height=="number"&&typeof G.width=="number"}static lift(G){return G instanceof ae?G:new ae(G.width,G.height)}static equals(G,fe){return G===fe?!0:!G||!fe?!1:G.width===fe.width&&G.height===fe.height}}t.Dimension=ae,ae.None=new ae(0,0);function he(Y){let G=Y.offsetParent,fe=Y.offsetTop,Te=Y.offsetLeft;for(;(Y=Y.parentNode)!==null&&Y!==document.body&&Y!==document.documentElement;){fe-=Y.scrollTop;const Fe=H(Y)?null:ge(Y);Fe&&(Te-=Fe.direction!=="rtl"?Y.scrollLeft:-Y.scrollLeft),Y===G&&(Te+=me.getBorderLeftWidth(Y),fe+=me.getBorderTopWidth(Y),fe+=Y.offsetTop,Te+=Y.offsetLeft,G=Y.offsetParent)}return{left:Te,top:fe}}t.getTopLeftOffset=he;function Se(Y,G,fe){typeof G=="number"&&(Y.style.width=`${G}px`),typeof fe=="number"&&(Y.style.height=`${fe}px`)}t.size=Se;function te(Y,G,fe,Te,Fe,Ve="absolute"){typeof G=="number"&&(Y.style.top=`${G}px`),typeof fe=="number"&&(Y.style.right=`${fe}px`),typeof Te=="number"&&(Y.style.bottom=`${Te}px`),typeof Fe=="number"&&(Y.style.left=`${Fe}px`),Y.style.position=Ve}t.position=te;function De(Y){const G=Y.getBoundingClientRect();return{left:G.left+window.scrollX,top:G.top+window.scrollY,width:G.width,height:G.height}}t.getDomNodePagePosition=De;function se(Y){let G=Y,fe=1;do{const Te=ge(G).zoom;Te!=null&&Te!=="1"&&(fe*=Te),G=G.parentElement}while(G!==null&&G!==document.documentElement);return fe}t.getDomNodeZoomLevel=se;function ie(Y){const G=me.getMarginLeft(Y)+me.getMarginRight(Y);return Y.offsetWidth+G}t.getTotalWidth=ie;function ce(Y){const G=me.getBorderLeftWidth(Y)+me.getBorderRightWidth(Y),fe=me.getPaddingLeft(Y)+me.getPaddingRight(Y);return Y.offsetWidth-G-fe}t.getContentWidth=ce;function ne(Y){const G=me.getMarginLeft(Y)+me.getMarginRight(Y);return Y.scrollWidth+G}t.getTotalScrollWidth=ne;function F(Y){const G=me.getBorderTopWidth(Y)+me.getBorderBottomWidth(Y),fe=me.getPaddingTop(Y)+me.getPaddingBottom(Y);return Y.offsetHeight-G-fe}t.getContentHeight=F;function V(Y){const G=me.getMarginTop(Y)+me.getMarginBottom(Y);return Y.offsetHeight+G}t.getTotalHeight=V;function j(Y,G){if(Y===null)return 0;const fe=he(Y),Te=he(G);return fe.left-Te.left}function k(Y,G){const fe=G.map(Fe=>Math.max(ne(Fe),ie(Fe))+j(Fe,Y)||0);return Math.max(...fe)}t.getLargestChildWidth=k;function h(Y,G){for(;Y;){if(Y===G)return!0;Y=Y.parentNode}return!1}t.isAncestor=h;const I="parentFlowToElementId";function U(Y,G){Y.dataset[I]=G.id}t.setParentFlowTo=U;function K(Y){const G=Y.dataset[I];return typeof G=="string"?document.getElementById(G):null}function Z(Y,G){let fe=Y;for(;fe;){if(fe===G)return!0;if(fe instanceof HTMLElement){const Te=K(fe);if(Te){fe=Te;continue}}fe=fe.parentNode}return!1}t.isAncestorUsingFlowTo=Z;function N(Y,G,fe){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y.classList.contains(G))return Y;if(fe){if(typeof fe=="string"){if(Y.classList.contains(fe))return null}else if(Y===fe)return null}Y=Y.parentNode}return null}t.findParentWithClass=N;function R(Y,G,fe){return!!N(Y,G,fe)}t.hasParentWithClass=R;function H(Y){return Y&&!!Y.host&&!!Y.mode}t.isShadowRoot=H;function A(Y){return!!P(Y)}t.isInShadowDOM=A;function P(Y){for(;Y.parentNode;){if(Y===document.body)return null;Y=Y.parentNode}return H(Y)?Y:null}t.getShadowRoot=P;function M(){let Y=document.activeElement;for(;Y?.shadowRoot;)Y=Y.shadowRoot.activeElement;return Y}t.getActiveElement=M;function B(Y=document.getElementsByTagName("head")[0]){const G=document.createElement("style");return G.type="text/css",G.media="screen",Y.appendChild(G),G}t.createStyleSheet=B;function q(Y=document.getElementsByTagName("head")[0]){const G=document.createElement("meta");return Y.appendChild(G),G}t.createMetaElement=q;let ee=null;function le(){return ee||(ee=B()),ee}function de(Y){return Y?.sheet?.rules?Y.sheet.rules:Y?.sheet?.cssRules?Y.sheet.cssRules:[]}function ye(Y,G,fe=le()){!fe||!G||fe.sheet.insertRule(Y+"{"+G+"}",0)}t.createCSSRule=ye;function Ee(Y,G=le()){if(!G)return;const fe=de(G),Te=[];for(let Fe=0;Fe<fe.length;Fe++)fe[Fe].selectorText.indexOf(Y)!==-1&&Te.push(Fe);for(let Fe=Te.length-1;Fe>=0;Fe--)G.sheet.deleteRule(Te[Fe])}t.removeCSSRulesContainingSelector=Ee;function Re(Y){return typeof HTMLElement=="object"?Y instanceof HTMLElement:Y&&typeof Y=="object"&&Y.nodeType===1&&typeof Y.nodeName=="string"}t.isHTMLElement=Re,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:E.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:E.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:E.isWebKit?"webkitAnimationIteration":"animationiteration"},t.EventHelper={stop:(Y,G)=>(Y.preventDefault(),G&&Y.stopPropagation(),Y)};function Le(Y){const G=[];for(let fe=0;Y&&Y.nodeType===Y.ELEMENT_NODE;fe++)G[fe]=Y.scrollTop,Y=Y.parentNode;return G}t.saveParentsScrollTop=Le;function ve(Y,G){for(let fe=0;Y&&Y.nodeType===Y.ELEMENT_NODE;fe++)Y.scrollTop!==G[fe]&&(Y.scrollTop=G[fe]),Y=Y.parentNode}t.restoreParentsScrollTop=ve;class Pe extends g.Disposable{static hasFocusWithin(G){const fe=P(G),Te=fe?fe.activeElement:document.activeElement;return h(Te,G)}constructor(G){super(),this._onDidFocus=this._register(new d.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new d.Emitter),this.onDidBlur=this._onDidBlur.event;let fe=Pe.hasFocusWithin(G),Te=!1;const Fe=()=>{Te=!1,fe||(fe=!0,this._onDidFocus.fire())},Ve=()=>{fe&&(Te=!0,window.setTimeout(()=>{Te&&(Te=!1,fe=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{Pe.hasFocusWithin(G)!==fe&&(fe?Ve():Fe())},this._register(D(G,t.EventType.FOCUS,Fe,!0)),this._register(D(G,t.EventType.BLUR,Ve,!0)),this._register(D(G,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(D(G,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler()))}refreshState(){this._refreshStateHandler()}}function ke(Y){return new Pe(Y)}t.trackFocus=ke;function je(Y,G){return Y.after(G),G}t.after=je;function He(Y,...G){if(Y.append(...G),G.length===1&&typeof G[0]!="string")return G[0]}t.append=He;function Ue(Y,G){return Y.insertBefore(G,Y.firstChild),G}t.prepend=Ue;function Je(Y,...G){Y.innerText="",He(Y,...G)}t.reset=Je;const it=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Me;(function(Y){Y.HTML="http://www.w3.org/1999/xhtml",Y.SVG="http://www.w3.org/2000/svg"})(Me=t.Namespace||(t.Namespace={}));function qe(Y,G,fe,...Te){const Fe=it.exec(G);if(!Fe)throw new Error("Bad use of emmet");fe={...fe||{}};const Ve=Fe[1]||"div";let ze;return Y!==Me.HTML?ze=document.createElementNS(Y,Ve):ze=document.createElement(Ve),Fe[3]&&(ze.id=Fe[3]),Fe[4]&&(ze.className=Fe[4].replace(/\./g," ").trim()),Object.keys(fe).forEach(xe=>{const Qe=fe[xe];typeof Qe>"u"||(/^on\w+$/.test(xe)?ze[xe]=Qe:xe==="selected"?Qe&&ze.setAttribute(xe,"true"):ze.setAttribute(xe,Qe))}),ze.append(...Te),ze}function x(Y,G,...fe){return qe(Me.HTML,Y,G,...fe)}t.$=x,x.SVG=function(Y,G,...fe){return qe(Me.SVG,Y,G,...fe)};function oe(Y,G){const fe=[];return Y.forEach((Te,Fe)=>{Fe>0&&(G instanceof Node?fe.push(G.cloneNode()):fe.push(document.createTextNode(G))),fe.push(Te)}),fe}t.join=oe;function we(...Y){for(const G of Y)G.style.display="",G.removeAttribute("aria-hidden")}t.show=we;function Ce(...Y){for(const G of Y)G.style.display="none",G.setAttribute("aria-hidden","true")}t.hide=Ce;function Ae(Y,G){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y instanceof HTMLElement&&Y.hasAttribute(G))return Y;Y=Y.parentNode}return null}function Oe(Y){!Y||!Y.hasAttribute("tabIndex")||(document.activeElement===Y&&Ae(Y.parentElement,"tabIndex")?.focus(),Y.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=Oe;function $e(Y){return G=>{G.preventDefault(),G.stopPropagation(),Y(G)}}t.finalHandler=$e;function Ge(){return new Promise(Y=>{document.readyState==="complete"||document&&document.body!==null?Y(void 0):window.addEventListener("DOMContentLoaded",Y,!1)})}t.domContentLoaded=Ge;function et(Y){const G=window.devicePixelRatio*Y;return Math.max(1,Math.floor(G))/window.devicePixelRatio}t.computeScreenAwareSize=et;function Ie(Y){window.open(Y,"_blank","noopener")}t.windowOpenNoOpener=Ie;const ue=780,_e=640;function Ne(Y){const G=Math.floor(window.screenLeft+window.innerWidth/2-ue/2),fe=Math.floor(window.screenTop+window.innerHeight/2-_e/2);window.open(Y,"_blank",`width=${ue},height=${_e},top=${fe},left=${G}`)}t.windowOpenPopup=Ne;function We(Y,G=!0){const fe=window.open();return fe?(G&&(fe.opener=null),fe.location.href=Y,!0):!1}t.windowOpenWithSuccess=We;function Ye(Y){const G=()=>{Y(),fe=(0,t.scheduleAtNextAnimationFrame)(G)};let fe=(0,t.scheduleAtNextAnimationFrame)(G);return(0,g.toDisposable)(()=>fe.dispose())}t.animate=Ye,L.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Xe(Y){return Y?`url('${L.FileAccess.asBrowserUri(Y).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=Xe;function Ze(Y){return`'${Y.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=Ze;function st(Y,G){let fe;if(e.URI.isUri(Y))fe=Y.toString(!0);else{const Fe=new Blob([Y]);fe=URL.createObjectURL(Fe),setTimeout(()=>URL.revokeObjectURL(fe))}const Te=document.createElement("a");document.body.appendChild(Te),Te.download=G,Te.href=fe,Te.click(),setTimeout(()=>document.body.removeChild(Te))}t.triggerDownload=st;function ht(){return new Promise(Y=>{const G=document.createElement("input");document.body.appendChild(G),G.type="file",G.multiple=!0,d.Event.once(d.Event.fromDOMEventEmitter(G,"input"))(()=>{Y((0,s.withNullAsUndefined)(G.files))}),G.click(),setTimeout(()=>document.body.removeChild(G))})}t.triggerUpload=ht;var dt;(function(Y){Y[Y.DOCUMENT=1]="DOCUMENT",Y[Y.BROWSER=2]="BROWSER"})(dt=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function Tt(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:dt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:dt.BROWSER,guess:!1}:(o.isMacintosh||o.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:dt.BROWSER,guess:!0}:null}t.detectFullscreen=Tt;function Ft(Y,G=!1){const fe=document.createElement("a");return c.addHook("afterSanitizeAttributes",Te=>{for(const Fe of["href","src"])if(Te.hasAttribute(Fe)){const Ve=Te.getAttribute(Fe);if(Fe==="href"&&Ve.startsWith("#"))continue;if(fe.href=Ve,!Y.includes(fe.protocol.replace(/:$/,""))){if(G&&Fe==="src"&&fe.href.startsWith("data:"))continue;Te.removeAttribute(Fe)}}}),(0,g.toDisposable)(()=>{c.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=Ft;const ui=[L.Schemas.http,L.Schemas.https,L.Schemas.command];function ci(Y,G){const fe={ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1},Te=Ft(ui);try{const Fe=c.sanitize(G,{...fe,RETURN_TRUSTED_TYPE:!0});Y.innerHTML=Fe}finally{Te.dispose()}}t.safeInnerHtml=ci;function hi(Y){const G=new Uint16Array(Y.length);for(let Fe=0;Fe<G.length;Fe++)G[Fe]=Y.charCodeAt(Fe);let fe="";const Te=new Uint8Array(G.buffer);for(let Fe=0;Fe<Te.length;Fe++)fe+=String.fromCharCode(Te[Fe]);return fe}function di(Y){return btoa(hi(Y))}t.multibyteAwareBtoa=di;class ft extends d.Emitter{constructor(){super(),this._subscriptions=new g.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(D(window,"keydown",G=>{if(G.defaultPrevented)return;const fe=new W.StandardKeyboardEvent(G);if(!(fe.keyCode===6&&G.repeat)){if(G.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(G.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(G.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(G.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(fe.keyCode!==6)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=G.altKey,this._keyStatus.ctrlKey=G.ctrlKey,this._keyStatus.metaKey=G.metaKey,this._keyStatus.shiftKey=G.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=G,this.fire(this._keyStatus))}},!0)),this._subscriptions.add(D(window,"keyup",G=>{G.defaultPrevented||(!G.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!G.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!G.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!G.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=G.altKey,this._keyStatus.ctrlKey=G.ctrlKey,this._keyStatus.metaKey=G.metaKey,this._keyStatus.shiftKey=G.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=G,this.fire(this._keyStatus)))},!0)),this._subscriptions.add(D(document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(D(document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(D(document.body,"mousemove",G=>{G.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),this._subscriptions.add(D(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return ft.instance||(ft.instance=new ft),ft.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=ft;function fi(Y){const G=document.cookie.match("(^|[^;]+)\\s*"+Y+"\\s*=\\s*([^;]+)");return G?G.pop():void 0}t.getCookieValue=fi;class gi extends g.Disposable{constructor(G,fe){super(),this.element=G,this.callbacks=fe,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this._register(D(this.element,t.EventType.DRAG_ENTER,G=>{this.counter++,this.dragStartTime=G.timeStamp,this.callbacks.onDragEnter(G)})),this._register(D(this.element,t.EventType.DRAG_OVER,G=>{G.preventDefault(),this.callbacks.onDragOver?.(G,G.timeStamp-this.dragStartTime)})),this._register(D(this.element,t.EventType.DRAG_LEAVE,G=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave(G))})),this._register(D(this.element,t.EventType.DRAG_END,G=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd(G)})),this._register(D(this.element,t.EventType.DROP,G=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop(G)}))}}t.DragAndDropObserver=gi;function mi(Y,G){const fe=Y instanceof HTMLElement?Y.getBoundingClientRect():Y,Te=G.getBoundingClientRect(),Fe=Math.max(Te.top-fe.top,0),Ve=Math.max(fe.width-(fe.right-Te.right),0),ze=Math.max(fe.height-(fe.bottom-Te.bottom),0),xe=Math.max(Te.left-fe.left,0);return{top:Fe,right:Ve,bottom:ze,left:xe}}t.computeClippingRect=mi;const pi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function bi(Y,...G){let fe,Te;Array.isArray(G[0])?(fe={},Te=G[0]):(fe=G[0]||{},Te=G[1]);const Fe=pi.exec(Y);if(!Fe||!Fe.groups)throw new Error("Bad use of h");const Ve=Fe.groups.tag||"div",ze=document.createElement(Ve);Fe.groups.id&&(ze.id=Fe.groups.id),Fe.groups.class&&(ze.className=Fe.groups.class.replace(/\./g," ").trim());const xe={};if(Fe.groups.name&&(xe[Fe.groups.name]=ze),Te)for(const Qe of Te)Qe instanceof HTMLElement?ze.appendChild(Qe):typeof Qe=="string"?ze.append(Qe):(Object.assign(xe,Qe),ze.appendChild(Qe.root));for(const[Qe,gt]of Object.entries(fe))if(Qe==="style")for(const[It,mt]of Object.entries(gt))ze.style.setProperty(zt(It),typeof mt=="number"?mt+"px":""+mt);else Qe==="tabIndex"?ze.tabIndex=gt:ze.setAttribute(zt(Qe),gt.toString());return xe.root=ze,xe}t.h=bi;function zt(Y){return Y.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(pe[51],be([1,0,4,2,105]),function(Q,t,E,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class O extends i.Disposable{constructor(d,c){super(),this._register((0,E.addDisposableListener)(d,"dragover",g=>{g.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{c(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(g=>{this._register((0,E.addDisposableListener)(d,g,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=O,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:W.Mimes.text};function C(y,d,c){const g=document.createElement("div");g.className=c,g.textContent=d,y.dataTransfer&&(document.body.appendChild(g),y.dataTransfer.setDragImage(g,-10,-10),setTimeout(()=>document.body.removeChild(g),0))}t.applyDragImage=C}),define(pe[52],be([1,0,4]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function i(o,s={}){const e=O(s);return e.textContent=o,e}t.renderText=i;function W(o,s={}){const e=O(s);return d(e,c(o,!!s.renderCodeSegments),s.actionHandler,s.renderCodeSegments),e}t.renderFormattedText=W;function O(o){const s=o.inline?"span":"div",e=document.createElement(s);return o.className&&(e.className=o.className),e}t.createElement=O;class C{constructor(s){this.source=s,this.index=0}eos(){return this.index>=this.source.length}next(){const s=this.peek();return this.advance(),s}peek(){return this.source[this.index]}advance(){this.index++}}var y;(function(o){o[o.Invalid=0]="Invalid",o[o.Root=1]="Root",o[o.Text=2]="Text",o[o.Bold=3]="Bold",o[o.Italics=4]="Italics",o[o.Action=5]="Action",o[o.ActionClose=6]="ActionClose",o[o.Code=7]="Code",o[o.NewLine=8]="NewLine"})(y||(y={}));function d(o,s,e,m){let v;if(s.type===2)v=document.createTextNode(s.content||"");else if(s.type===3)v=document.createElement("b");else if(s.type===4)v=document.createElement("i");else if(s.type===7&&m)v=document.createElement("code");else if(s.type===5&&e){const w=document.createElement("a");e.disposables.add(E.addStandardDisposableListener(w,"click",D=>{e.callback(String(s.index),D)})),v=w}else s.type===8?v=document.createElement("br"):s.type===1&&(v=o);v&&o!==v&&o.appendChild(v),v&&Array.isArray(s.children)&&s.children.forEach(w=>{d(v,w,e,m)})}function c(o,s){const e={type:1,children:[]};let m=0,v=e;const w=[],D=new C(o);for(;!D.eos();){let a=D.next();const u=a==="\\"&&L(D.peek(),s)!==0;if(u&&(a=D.next()),!u&&g(a,s)&&a===D.peek()){D.advance(),v.type===2&&(v=w.pop());const p=L(a,s);if(v.type===p||v.type===5&&p===6)v=w.pop();else{const S={type:p,children:[]};p===5&&(S.index=m,m++),v.children.push(S),w.push(v),v=S}}else if(a===`
`)v.type===2&&(v=w.pop()),v.children.push({type:8});else if(v.type!==2){const p={type:2,content:a};v.children.push(p),w.push(v),v=p}else v.content+=a}return v.type===2&&(v=w.pop()),w.length,e}function g(o,s){return L(o,s)!==0}function L(o,s){switch(o){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return s?7:0;default:return 0}}}),define(pe[53],be([1,0,4,2]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class W{constructor(){this._hooks=new i.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(C,y){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const d=this._onStopCallback;this._onStopCallback=null,C&&d&&d(y)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(C,y,d,c,g){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=c,this._onStopCallback=g;let L=C;try{C.setPointerCapture(y),this._hooks.add((0,i.toDisposable)(()=>{C.releasePointerCapture(y)}))}catch{L=window}this._hooks.add(E.addDisposableListener(L,E.EventType.POINTER_MOVE,o=>{if(o.buttons!==d){this.stopMonitoring(!0);return}o.preventDefault(),this._pointerMoveCallback(o)})),this._hooks.add(E.addDisposableListener(L,E.EventType.POINTER_UP,o=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=W});var Ke=this&&this.__decorate||function(Q,t,E,i){var W=arguments.length,O=W<3?t:i===null?i=Object.getOwnPropertyDescriptor(t,E):i,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(Q,t,E,i);else for(var y=Q.length-1;y>=0;y--)(C=Q[y])&&(O=(W<3?C(O):W>3?C(t,E,O):C(t,E))||O);return W>3&&O&&Object.defineProperty(t,E,O),O};define(pe[22],be([1,0,4,14,25,2]),function(Q,t,E,i,W,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var C;(function(d){d.Tap="-monaco-gesturetap",d.Change="-monaco-gesturechange",d.Start="-monaco-gesturestart",d.End="-monaco-gesturesend",d.Contextmenu="-monaco-gesturecontextmenu"})(C=t.EventType||(t.EventType={}));class y extends O.Disposable{constructor(){super(),this.dispatched=!1,this.activeTouches={},this.handle=null,this.targets=[],this.ignoreTargets=[],this._lastSetTapCountTime=0,this._register(E.addDisposableListener(document,"touchstart",c=>this.onTouchStart(c),{passive:!1})),this._register(E.addDisposableListener(document,"touchend",c=>this.onTouchEnd(c))),this._register(E.addDisposableListener(document,"touchmove",c=>this.onTouchMove(c),{passive:!1}))}static addTarget(c){return y.isTouchDevice()?(y.INSTANCE||(y.INSTANCE=new y),y.INSTANCE.targets.push(c),{dispose:()=>{y.INSTANCE.targets=y.INSTANCE.targets.filter(g=>g!==c)}}):O.Disposable.None}static ignoreTarget(c){return y.isTouchDevice()?(y.INSTANCE||(y.INSTANCE=new y),y.INSTANCE.ignoreTargets.push(c),{dispose:()=>{y.INSTANCE.ignoreTargets=y.INSTANCE.ignoreTargets.filter(g=>g!==c)}}):O.Disposable.None}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(c){const g=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let L=0,o=c.targetTouches.length;L<o;L++){const s=c.targetTouches.item(L);this.activeTouches[s.identifier]={id:s.identifier,initialTarget:s.target,initialTimeStamp:g,initialPageX:s.pageX,initialPageY:s.pageY,rollingTimestamps:[g],rollingPageX:[s.pageX],rollingPageY:[s.pageY]};const e=this.newGestureEvent(C.Start,s.target);e.pageX=s.pageX,e.pageY=s.pageY,this.dispatchEvent(e)}this.dispatched&&(c.preventDefault(),c.stopPropagation(),this.dispatched=!1)}onTouchEnd(c){const g=Date.now(),L=Object.keys(this.activeTouches).length;for(let o=0,s=c.changedTouches.length;o<s;o++){const e=c.changedTouches.item(o);if(!this.activeTouches.hasOwnProperty(String(e.identifier))){console.warn("move of an UNKNOWN touch",e);continue}const m=this.activeTouches[e.identifier],v=Date.now()-m.initialTimeStamp;if(v<y.HOLD_DELAY&&Math.abs(m.initialPageX-i.tail(m.rollingPageX))<30&&Math.abs(m.initialPageY-i.tail(m.rollingPageY))<30){const w=this.newGestureEvent(C.Tap,m.initialTarget);w.pageX=i.tail(m.rollingPageX),w.pageY=i.tail(m.rollingPageY),this.dispatchEvent(w)}else if(v>=y.HOLD_DELAY&&Math.abs(m.initialPageX-i.tail(m.rollingPageX))<30&&Math.abs(m.initialPageY-i.tail(m.rollingPageY))<30){const w=this.newGestureEvent(C.Contextmenu,m.initialTarget);w.pageX=i.tail(m.rollingPageX),w.pageY=i.tail(m.rollingPageY),this.dispatchEvent(w)}else if(L===1){const w=i.tail(m.rollingPageX),D=i.tail(m.rollingPageY),a=i.tail(m.rollingTimestamps)-m.rollingTimestamps[0],u=w-m.rollingPageX[0],p=D-m.rollingPageY[0],S=this.targets.filter(T=>m.initialTarget instanceof Node&&T.contains(m.initialTarget));this.inertia(S,g,Math.abs(u)/a,u>0?1:-1,w,Math.abs(p)/a,p>0?1:-1,D)}this.dispatchEvent(this.newGestureEvent(C.End,m.initialTarget)),delete this.activeTouches[e.identifier]}this.dispatched&&(c.preventDefault(),c.stopPropagation(),this.dispatched=!1)}newGestureEvent(c,g){const L=document.createEvent("CustomEvent");return L.initEvent(c,!1,!0),L.initialTarget=g,L.tapCount=0,L}dispatchEvent(c){if(c.type===C.Tap){const g=new Date().getTime();let L=0;g-this._lastSetTapCountTime>y.CLEAR_TAP_COUNT_TIME?L=1:L=2,this._lastSetTapCountTime=g,c.tapCount=L}else(c.type===C.Change||c.type===C.Contextmenu)&&(this._lastSetTapCountTime=0);for(let g=0;g<this.ignoreTargets.length;g++)if(c.initialTarget instanceof Node&&this.ignoreTargets[g].contains(c.initialTarget))return;this.targets.forEach(g=>{c.initialTarget instanceof Node&&g.contains(c.initialTarget)&&(g.dispatchEvent(c),this.dispatched=!0)})}inertia(c,g,L,o,s,e,m,v){this.handle=E.scheduleAtNextAnimationFrame(()=>{const w=Date.now(),D=w-g;let a=0,u=0,p=!0;L+=y.SCROLL_FRICTION*D,e+=y.SCROLL_FRICTION*D,L>0&&(p=!1,a=o*L*D),e>0&&(p=!1,u=m*e*D);const S=this.newGestureEvent(C.Change);S.translationX=a,S.translationY=u,c.forEach(T=>T.dispatchEvent(S)),p||this.inertia(c,w,L,o,s+a,e,m,v+u)})}onTouchMove(c){const g=Date.now();for(let L=0,o=c.changedTouches.length;L<o;L++){const s=c.changedTouches.item(L);if(!this.activeTouches.hasOwnProperty(String(s.identifier))){console.warn("end of an UNKNOWN touch",s);continue}const e=this.activeTouches[s.identifier],m=this.newGestureEvent(C.Change,e.initialTarget);m.translationX=s.pageX-i.tail(e.rollingPageX),m.translationY=s.pageY-i.tail(e.rollingPageY),m.pageX=s.pageX,m.pageY=s.pageY,this.dispatchEvent(m),e.rollingPageX.length>3&&(e.rollingPageX.shift(),e.rollingPageY.shift(),e.rollingTimestamps.shift()),e.rollingPageX.push(s.pageX),e.rollingPageY.push(s.pageY),e.rollingTimestamps.push(g)}this.dispatched&&(c.preventDefault(),c.stopPropagation(),this.dispatched=!1)}}y.SCROLL_FRICTION=-.005,y.HOLD_DELAY=700,y.CLEAR_TAP_COUNT_TIME=400,Ke([W.memoize],y,"isTouchDevice",null),t.Gesture=y}),define(pe[54],be([1,0,4,5,82]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const W=2e4;let O,C,y,d,c;function g(e){O=document.createElement("div"),O.className="monaco-aria-container";const m=()=>{const w=document.createElement("div");return w.className="monaco-alert",w.setAttribute("role","alert"),w.setAttribute("aria-atomic","true"),O.appendChild(w),w};C=m(),y=m();const v=()=>{const w=document.createElement("div");return w.className="monaco-status",w.setAttribute("role","complementary"),w.setAttribute("aria-live","polite"),w.setAttribute("aria-atomic","true"),O.appendChild(w),w};d=v(),c=v(),e.appendChild(O)}t.setARIAContainer=g;function L(e){!O||(C.textContent!==e?(E.clearNode(y),s(C,e)):(E.clearNode(C),s(y,e)))}t.alert=L;function o(e){!O||(i.isMacintosh?L(e):d.textContent!==e?(E.clearNode(c),s(d,e)):(E.clearNode(d),s(c,e)))}t.status=o;function s(e,m){E.clearNode(e),m.length>W&&(m=m.substr(0,W)),e.textContent=m,e.style.visibility="hidden",e.style.visibility="visible"}}),define(pe[113],be([1,0,4,11]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const W=new RegExp(`(\\\\)?\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)`,"g");function O(y){const d=new Array;let c,g=0,L=0;for(;(c=W.exec(y))!==null;){L=c.index||0,g<L&&d.push(y.substring(g,L)),g=(c.index||0)+c[0].length;const[,o,s]=c;d.push(o?`$(${s})`:C({id:s}))}return g<y.length&&d.push(y.substring(g)),d}t.renderLabelWithIcons=O;function C(y){const d=E.$("span");return d.classList.add(...i.CSSIcon.asClassNameArray(y)),d}t.renderIcon=C}),define(pe[114],be([1,0,4]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function i(O){try{O.parentElement?.removeChild(O)}catch{}}class W{constructor(C){this.renderers=C,this.cache=new Map}alloc(C){let y=this.getTemplateCache(C).pop();if(!y){const d=(0,E.$)(".monaco-list-row"),g=this.getRenderer(C).renderTemplate(d);y={domNode:d,templateId:C,templateData:g}}return y}release(C){!C||this.releaseRow(C)}releaseRow(C){const{domNode:y,templateId:d}=C;y&&(y.classList.remove("scrolling"),i(y)),this.getTemplateCache(d).push(C)}getTemplateCache(C){let y=this.cache.get(C);return y||(y=[],this.cache.set(C,y)),y}dispose(){this.cache.forEach((C,y)=>{for(const d of C)this.getRenderer(y).disposeTemplate(d.templateData),d.templateData=null}),this.cache.clear()}getRenderer(C){const y=this.renderers.get(C);if(!y)throw new Error(`No renderer found for ${C}`);return y}}t.RowCache=W}),define(pe[115],be([1,0,8,2]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class W extends i.Disposable{constructor(C,y,d){super(),this._visibility=C,this._visibleClassName=y,this._invisibleClassName=d,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new E.TimeoutTimer)}setVisibility(C){this._visibility!==C&&(this._visibility=C,this._updateShouldBeVisible())}setShouldBeVisible(C){this._rawShouldBeVisible=C,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===2?!1:this._visibility===3?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const C=this._applyVisibilitySetting();this._shouldBeVisible!==C&&(this._shouldBeVisible=C,this.ensureVisibility())}setIsNeeded(C){this._isNeeded!==C&&(this._isNeeded=C,this.ensureVisibility())}setDomNode(C){this._domNode=C,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(C){this._revealTimer.cancel(),this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(C?" fade":"")))}}t.ScrollbarVisibilityController=W}),define(pe[116],be([1,0,4,22,14,3,2,5]),function(Q,t,E,i,W,O,C,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class d extends C.Disposable{constructor(g,L,o,s){super(),this.selected=0,this.selectBoxOptions=s||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new O.Emitter),this.styles=o,this.registerListeners(),this.setOptions(g,L)}registerListeners(){this._register(i.Gesture.addTarget(this.selectElement)),[i.EventType.Tap].forEach(g=>{this._register(E.addDisposableListener(this.selectElement,g,L=>{this.selectElement.focus()}))}),this._register(E.addStandardDisposableListener(this.selectElement,"click",g=>{E.EventHelper.stop(g,!0)})),this._register(E.addStandardDisposableListener(this.selectElement,"change",g=>{this.selectElement.title=g.target.value,this._onDidSelect.fire({index:g.target.selectedIndex,selected:g.target.value})})),this._register(E.addStandardDisposableListener(this.selectElement,"keydown",g=>{let L=!1;y.isMacintosh?(g.keyCode===18||g.keyCode===16||g.keyCode===10)&&(L=!0):(g.keyCode===18&&g.altKey||g.keyCode===10||g.keyCode===3)&&(L=!0),L&&g.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(g,L){(!this.options||!W.equals(this.options,g))&&(this.options=g,this.selectElement.options.length=0,this.options.forEach((o,s)=>{this.selectElement.add(this.createOption(o.text,s,o.isDisabled))})),L!==void 0&&this.select(L)}select(g){this.options.length===0?this.selected=0:g>=0&&g<this.options.length?this.selected=g:g>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(g){this.selectBoxOptions.ariaLabel=g,this.selectElement.setAttribute("aria-label",g)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(g){this.selectElement.tabIndex=g?0:-1}render(g){g.classList.add("select-container"),g.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(g){this.styles=g,this.applyStyles()}applyStyles(){if(this.selectElement){const g=this.styles.selectBackground?this.styles.selectBackground.toString():"",L=this.styles.selectForeground?this.styles.selectForeground.toString():"",o=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=g,this.selectElement.style.color=L,this.selectElement.style.borderColor=o}}createOption(g,L,o){const s=document.createElement("option");return s.value=g,s.text=g,s.disabled=!!o,s}}t.SelectBoxNative=d}),define(pe[55],be([1,0,23,14,8,111,3,26]),function(Q,t,E,i,W,O,C,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function d(o){return typeof o=="object"&&"visibility"in o&&"data"in o}t.isFilterResult=d;function c(o){switch(o){case!0:return 1;case!1:return 0;default:return o}}t.getVisibleState=c;function g(o){return typeof o.collapsible=="boolean"}class L{constructor(s,e,m,v={}){this.user=s,this.list=e,this.rootRef=[],this.eventBufferer=new C.EventBufferer,this._onDidChangeCollapseState=new C.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new C.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new C.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new W.Delayer(W.MicrotaskDelay),this.collapseByDefault=typeof v.collapseByDefault>"u"?!1:v.collapseByDefault,this.filter=v.filter,this.autoExpandSingleChildren=typeof v.autoExpandSingleChildren>"u"?!1:v.autoExpandSingleChildren,this.root={parent:void 0,element:m,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(s,e,m=y.Iterable.empty(),v={}){if(s.length===0)throw new E.TreeError(this.user,"Invalid tree location");v.diffIdentityProvider?this.spliceSmart(v.diffIdentityProvider,s,e,m,v):this.spliceSimple(s,e,m,v)}spliceSmart(s,e,m,v=y.Iterable.empty(),w,D=w.diffDepth??0){const{parentNode:a}=this.getParentNodeWithListIndex(e);if(!a.lastDiffIds)return this.spliceSimple(e,m,v,w);const u=[...v],p=e[e.length-1],S=new O.LcsDiff({getElements:()=>a.lastDiffIds},{getElements:()=>[...a.children.slice(0,p),...u,...a.children.slice(p+m)].map(l=>s.getId(l.element).toString())}).ComputeDiff(!1);if(S.quitEarly)return a.lastDiffIds=void 0,this.spliceSimple(e,m,u,w);const T=e.slice(0,-1),_=(l,b,f)=>{if(D>0)for(let z=0;z<f;z++)l--,b--,this.spliceSmart(s,[...T,l,0],Number.MAX_SAFE_INTEGER,u[b].children,w,D-1)};let r=Math.min(a.children.length,p+m),n=u.length;for(const l of S.changes.sort((b,f)=>f.originalStart-b.originalStart))_(r,n,r-(l.originalStart+l.originalLength)),r=l.originalStart,n=l.modifiedStart-p,this.spliceSimple([...T,r],l.originalLength,y.Iterable.slice(u,n,n+l.modifiedLength),w);_(r,n,r)}spliceSimple(s,e,m=y.Iterable.empty(),{onDidCreateNode:v,onDidDeleteNode:w,diffIdentityProvider:D}){const{parentNode:a,listIndex:u,revealed:p,visible:S}=this.getParentNodeWithListIndex(s),T=[],_=y.Iterable.map(m,re=>this.createTreeNode(re,a,a.visible?1:0,p,T,v)),r=s[s.length-1],n=a.children.length>0;let l=0;for(let re=r;re>=0&&re<a.children.length;re--){const me=a.children[re];if(me.visible){l=me.visibleChildIndex;break}}const b=[];let f=0,z=0;for(const re of _)b.push(re),z+=re.renderNodeCount,re.visible&&(re.visibleChildIndex=l+f++);const $=(0,i.splice)(a.children,r,e,b);D?a.lastDiffIds?(0,i.splice)(a.lastDiffIds,r,e,b.map(re=>D.getId(re.element).toString())):a.lastDiffIds=a.children.map(re=>D.getId(re.element).toString()):a.lastDiffIds=void 0;let X=0;for(const re of $)re.visible&&X++;if(X!==0)for(let re=r+b.length;re<a.children.length;re++){const me=a.children[re];me.visible&&(me.visibleChildIndex-=X)}if(a.visibleChildrenCount+=f-X,p&&S){const re=$.reduce((me,ae)=>me+(ae.visible?ae.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(a,z-re),this.list.splice(u,re,T)}if($.length>0&&w){const re=me=>{w(me),me.children.forEach(re)};$.forEach(re)}this._onDidSplice.fire({insertedNodes:b,deletedNodes:$});const J=a.children.length>0;n!==J&&this.setCollapsible(s.slice(0,-1),J);let ge=a;for(;ge;){if(ge.visibility===2){this.refilterDelayer.trigger(()=>this.refilter());break}ge=ge.parent}}rerender(s){if(s.length===0)throw new E.TreeError(this.user,"Invalid tree location");const{node:e,listIndex:m,revealed:v}=this.getTreeNodeWithListIndex(s);e.visible&&v&&this.list.splice(m,1,[e])}updateElementHeight(s,e){if(s.length===0)throw new E.TreeError(this.user,"Invalid tree location");const{listIndex:m}=this.getTreeNodeWithListIndex(s);this.list.updateElementHeight(m,e)}has(s){return this.hasTreeNode(s)}getListIndex(s){const{listIndex:e,visible:m,revealed:v}=this.getTreeNodeWithListIndex(s);return m&&v?e:-1}getListRenderCount(s){return this.getTreeNode(s).renderNodeCount}isCollapsible(s){return this.getTreeNode(s).collapsible}setCollapsible(s,e){const m=this.getTreeNode(s);typeof e>"u"&&(e=!m.collapsible);const v={collapsible:e};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(s,v))}isCollapsed(s){return this.getTreeNode(s).collapsed}setCollapsed(s,e,m){const v=this.getTreeNode(s);typeof e>"u"&&(e=!v.collapsed);const w={collapsed:e,recursive:m||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(s,w))}_setCollapseState(s,e){const{node:m,listIndex:v,revealed:w}=this.getTreeNodeWithListIndex(s),D=this._setListNodeCollapseState(m,v,w,e);if(m!==this.root&&this.autoExpandSingleChildren&&D&&!g(e)&&m.collapsible&&!m.collapsed&&!e.recursive){let a=-1;for(let u=0;u<m.children.length;u++)if(m.children[u].visible)if(a>-1){a=-1;break}else a=u;a>-1&&this._setCollapseState([...s,a],e)}return D}_setListNodeCollapseState(s,e,m,v){const w=this._setNodeCollapseState(s,v,!1);if(!m||!s.visible||!w)return w;const D=s.renderNodeCount,a=this.updateNodeAfterCollapseChange(s),u=D-(e===-1?0:1);return this.list.splice(e+1,u,a.slice(1)),w}_setNodeCollapseState(s,e,m){let v;if(s===this.root?v=!1:(g(e)?(v=s.collapsible!==e.collapsible,s.collapsible=e.collapsible):s.collapsible?(v=s.collapsed!==e.collapsed,s.collapsed=e.collapsed):v=!1,v&&this._onDidChangeCollapseState.fire({node:s,deep:m})),!g(e)&&e.recursive)for(const w of s.children)v=this._setNodeCollapseState(w,e,!0)||v;return v}expandTo(s){this.eventBufferer.bufferEvents(()=>{let e=this.getTreeNode(s);for(;e.parent;)e=e.parent,s=s.slice(0,s.length-1),e.collapsed&&this._setCollapseState(s,{collapsed:!1,recursive:!1})})}refilter(){const s=this.root.renderNodeCount,e=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,s,e),this.refilterDelayer.cancel()}createTreeNode(s,e,m,v,w,D){const a={parent:e,element:s.element,children:[],depth:e.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof s.collapsible=="boolean"?s.collapsible:typeof s.collapsed<"u",collapsed:typeof s.collapsed>"u"?this.collapseByDefault:s.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},u=this._filterNode(a,m);a.visibility=u,v&&w.push(a);const p=s.children||y.Iterable.empty(),S=v&&u!==0&&!a.collapsed,T=y.Iterable.map(p,n=>this.createTreeNode(n,a,u,S,w,D));let _=0,r=1;for(const n of T)a.children.push(n),r+=n.renderNodeCount,n.visible&&(n.visibleChildIndex=_++);return a.collapsible=a.collapsible||a.children.length>0,a.visibleChildrenCount=_,a.visible=u===2?_>0:u===1,a.visible?a.collapsed||(a.renderNodeCount=r):(a.renderNodeCount=0,v&&w.pop()),D?.(a),a}updateNodeAfterCollapseChange(s){const e=s.renderNodeCount,m=[];return this._updateNodeAfterCollapseChange(s,m),this._updateAncestorsRenderNodeCount(s.parent,m.length-e),m}_updateNodeAfterCollapseChange(s,e){if(s.visible===!1)return 0;if(e.push(s),s.renderNodeCount=1,!s.collapsed)for(const m of s.children)s.renderNodeCount+=this._updateNodeAfterCollapseChange(m,e);return this._onDidChangeRenderNodeCount.fire(s),s.renderNodeCount}updateNodeAfterFilterChange(s){const e=s.renderNodeCount,m=[];return this._updateNodeAfterFilterChange(s,s.visible?1:0,m),this._updateAncestorsRenderNodeCount(s.parent,m.length-e),m}_updateNodeAfterFilterChange(s,e,m,v=!0){let w;if(s!==this.root){if(w=this._filterNode(s,e),w===0)return s.visible=!1,s.renderNodeCount=0,!1;v&&m.push(s)}const D=m.length;s.renderNodeCount=s===this.root?0:1;let a=!1;if(!s.collapsed||w!==0){let u=0;for(const p of s.children)a=this._updateNodeAfterFilterChange(p,w,m,v&&!s.collapsed)||a,p.visible&&(p.visibleChildIndex=u++);s.visibleChildrenCount=u}else s.visibleChildrenCount=0;return s!==this.root&&(s.visible=w===2?a:w===1,s.visibility=w),s.visible?s.collapsed||(s.renderNodeCount+=m.length-D):(s.renderNodeCount=0,v&&m.pop()),this._onDidChangeRenderNodeCount.fire(s),s.visible}_updateAncestorsRenderNodeCount(s,e){if(e!==0)for(;s;)s.renderNodeCount+=e,this._onDidChangeRenderNodeCount.fire(s),s=s.parent}_filterNode(s,e){const m=this.filter?this.filter.filter(s.element,e):1;return typeof m=="boolean"?(s.filterData=void 0,m?1:0):d(m)?(s.filterData=m.data,c(m.visibility)):(s.filterData=void 0,c(m))}hasTreeNode(s,e=this.root){if(!s||s.length===0)return!0;const[m,...v]=s;return m<0||m>e.children.length?!1:this.hasTreeNode(v,e.children[m])}getTreeNode(s,e=this.root){if(!s||s.length===0)return e;const[m,...v]=s;if(m<0||m>e.children.length)throw new E.TreeError(this.user,"Invalid tree location");return this.getTreeNode(v,e.children[m])}getTreeNodeWithListIndex(s){if(s.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:e,listIndex:m,revealed:v,visible:w}=this.getParentNodeWithListIndex(s),D=s[s.length-1];if(D<0||D>e.children.length)throw new E.TreeError(this.user,"Invalid tree location");const a=e.children[D];return{node:a,listIndex:m,revealed:v,visible:w&&a.visible}}getParentNodeWithListIndex(s,e=this.root,m=0,v=!0,w=!0){const[D,...a]=s;if(D<0||D>e.children.length)throw new E.TreeError(this.user,"Invalid tree location");for(let u=0;u<D;u++)m+=e.children[u].renderNodeCount;return v=v&&!e.collapsed,w=w&&e.visible,a.length===0?{parentNode:e,listIndex:m,revealed:v,visible:w}:this.getParentNodeWithListIndex(a,e.children[D],m+1,v,w)}getNode(s=[]){return this.getTreeNode(s)}getNodeLocation(s){const e=[];let m=s;for(;m.parent;)e.push(m.parent.children.indexOf(m)),m=m.parent;return e.reverse()}getParentNodeLocation(s){if(s.length!==0)return s.length===1?[]:(0,i.tail2)(s)[0]}getFirstElementChild(s){const e=this.getTreeNode(s);if(e.children.length!==0)return e.children[0].element}getLastElementAncestor(s=[]){const e=this.getTreeNode(s);if(e.children.length!==0)return this._getLastElementAncestor(e)}_getLastElementAncestor(s){return s.children.length===0?s.element:this._getLastElementAncestor(s.children[s.children.length-1])}}t.IndexTreeModel=L}),define(pe[117],be([1,0,55,23,26]),function(Q,t,E,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class O{get size(){return this.nodes.size}constructor(y,d,c={}){this.user=y,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new E.IndexTreeModel(y,d,null,c),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,c.sorter&&(this.sorter={compare(g,L){return c.sorter.compare(g.element,L.element)}}),this.identityProvider=c.identityProvider}setChildren(y,d=W.Iterable.empty(),c={}){const g=this.getElementLocation(y);this._setChildren(g,this.preserveCollapseState(d),c)}_setChildren(y,d=W.Iterable.empty(),c){const g=new Set,L=new Set,o=e=>{if(e.element===null)return;const m=e;if(g.add(m.element),this.nodes.set(m.element,m),this.identityProvider){const v=this.identityProvider.getId(m.element).toString();L.add(v),this.nodesByIdentity.set(v,m)}c.onDidCreateNode?.(m)},s=e=>{if(e.element===null)return;const m=e;if(g.has(m.element)||this.nodes.delete(m.element),this.identityProvider){const v=this.identityProvider.getId(m.element).toString();L.has(v)||this.nodesByIdentity.delete(v)}c.onDidDeleteNode?.(m)};this.model.splice([...y,0],Number.MAX_VALUE,d,{...c,onDidCreateNode:o,onDidDeleteNode:s})}preserveCollapseState(y=W.Iterable.empty()){return this.sorter&&(y=[...y].sort(this.sorter.compare.bind(this.sorter))),W.Iterable.map(y,d=>{let c=this.nodes.get(d.element);if(!c&&this.identityProvider){const o=this.identityProvider.getId(d.element).toString();c=this.nodesByIdentity.get(o)}if(!c)return{...d,children:this.preserveCollapseState(d.children)};const g=typeof d.collapsible=="boolean"?d.collapsible:c.collapsible,L=typeof d.collapsed<"u"?d.collapsed:c.collapsed;return{...d,collapsible:g,collapsed:L,children:this.preserveCollapseState(d.children)}})}rerender(y){const d=this.getElementLocation(y);this.model.rerender(d)}updateElementHeight(y,d){const c=this.getElementLocation(y);this.model.updateElementHeight(c,d)}resort(y=null,d=!0){if(!this.sorter)return;const c=this.getElementLocation(y),g=this.model.getNode(c);this._setChildren(c,this.resortChildren(g,d),{})}resortChildren(y,d,c=!0){let g=[...y.children];return(d||c)&&(g=g.sort(this.sorter.compare.bind(this.sorter))),W.Iterable.map(g,L=>({element:L.element,collapsible:L.collapsible,collapsed:L.collapsed,children:this.resortChildren(L,d,!1)}))}getFirstElementChild(y=null){const d=this.getElementLocation(y);return this.model.getFirstElementChild(d)}getLastElementAncestor(y=null){const d=this.getElementLocation(y);return this.model.getLastElementAncestor(d)}has(y){return this.nodes.has(y)}getListIndex(y){const d=this.getElementLocation(y);return this.model.getListIndex(d)}getListRenderCount(y){const d=this.getElementLocation(y);return this.model.getListRenderCount(d)}isCollapsible(y){const d=this.getElementLocation(y);return this.model.isCollapsible(d)}setCollapsible(y,d){const c=this.getElementLocation(y);return this.model.setCollapsible(c,d)}isCollapsed(y){const d=this.getElementLocation(y);return this.model.isCollapsed(d)}setCollapsed(y,d,c){const g=this.getElementLocation(y);return this.model.setCollapsed(g,d,c)}expandTo(y){const d=this.getElementLocation(y);this.model.expandTo(d)}refilter(){this.model.refilter()}getNode(y=null){if(y===null)return this.model.getNode(this.model.rootRef);const d=this.nodes.get(y);if(!d)throw new i.TreeError(this.user,`Tree element not found: ${y}`);return d}getNodeLocation(y){return y.element}getParentNodeLocation(y){if(y===null)throw new i.TreeError(this.user,"Invalid getParentNodeLocation call");const d=this.nodes.get(y);if(!d)throw new i.TreeError(this.user,`Tree element not found: ${y}`);const c=this.model.getNodeLocation(d),g=this.model.getParentNodeLocation(c);return this.model.getNode(g).element}getElementLocation(y){if(y===null)return[];const d=this.nodes.get(y);if(!d)throw new i.TreeError(this.user,`Tree element not found: ${y}`);return this.model.getNodeLocation(d)}}t.ObjectTreeModel=O}),define(pe[17],be([1,0,4,19,20,22,2]),function(Q,t,E,i,W,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class y extends C.Disposable{onclick(c,g){this._register(E.addDisposableListener(c,E.EventType.CLICK,L=>g(new W.StandardMouseEvent(L))))}onmousedown(c,g){this._register(E.addDisposableListener(c,E.EventType.MOUSE_DOWN,L=>g(new W.StandardMouseEvent(L))))}onmouseover(c,g){this._register(E.addDisposableListener(c,E.EventType.MOUSE_OVER,L=>g(new W.StandardMouseEvent(L))))}onmouseleave(c,g){this._register(E.addDisposableListener(c,E.EventType.MOUSE_LEAVE,L=>g(new W.StandardMouseEvent(L))))}onkeydown(c,g){this._register(E.addDisposableListener(c,E.EventType.KEY_DOWN,L=>g(new i.StandardKeyboardEvent(L))))}onkeyup(c,g){this._register(E.addDisposableListener(c,E.EventType.KEY_UP,L=>g(new i.StandardKeyboardEvent(L))))}oninput(c,g){this._register(E.addDisposableListener(c,E.EventType.INPUT,g))}onblur(c,g){this._register(E.addDisposableListener(c,E.EventType.BLUR,g))}onfocus(c,g){this._register(E.addDisposableListener(c,E.EventType.FOCUS,g))}onchange(c,g){this._register(E.addDisposableListener(c,E.EventType.CHANGE,g))}ignoreGesture(c){O.Gesture.ignoreTarget(c)}}t.Widget=y}),define(pe[37],be([1,0,53,17,8,4]),function(Q,t,E,i,W,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class C extends i.Widget{constructor(d){super(),this._onActivate=d.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=d.bgWidth+"px",this.bgDomNode.style.height=d.bgHeight+"px",typeof d.top<"u"&&(this.bgDomNode.style.top="0px"),typeof d.left<"u"&&(this.bgDomNode.style.left="0px"),typeof d.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof d.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=d.className,this.domNode.classList.add(...d.icon.classNamesArray),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof d.top<"u"&&(this.domNode.style.top=d.top+"px"),typeof d.left<"u"&&(this.domNode.style.left=d.left+"px"),typeof d.bottom<"u"&&(this.domNode.style.bottom=d.bottom+"px"),typeof d.right<"u"&&(this.domNode.style.right=d.right+"px"),this._pointerMoveMonitor=this._register(new E.GlobalPointerMoveMonitor),this._register(O.addStandardDisposableListener(this.bgDomNode,O.EventType.POINTER_DOWN,c=>this._arrowPointerDown(c))),this._register(O.addStandardDisposableListener(this.domNode,O.EventType.POINTER_DOWN,c=>this._arrowPointerDown(c))),this._pointerdownRepeatTimer=this._register(new W.IntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new W.TimeoutTimer)}_arrowPointerDown(d){if(!d.target||!(d.target instanceof Element))return;const c=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24)};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(c,200),this._pointerMoveMonitor.startMonitoring(d.target,d.pointerId,d.buttons,g=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),d.preventDefault()}}t.ScrollbarArrow=C}),define(pe[56],be([1,0,4,40,53,37,115,17,5]),function(Q,t,E,i,W,O,C,y,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const c=140;class g extends y.Widget{constructor(o){super(),this._lazyRender=o.lazyRender,this._host=o.host,this._scrollable=o.scrollable,this._scrollByPage=o.scrollByPage,this._scrollbarState=o.scrollbarState,this._visibilityController=this._register(new C.ScrollbarVisibilityController(o.visibility,"visible scrollbar "+o.extraScrollbarClassName,"invisible scrollbar "+o.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new W.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,i.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(E.addDisposableListener(this.domNode.domNode,E.EventType.POINTER_DOWN,s=>this._domNodePointerDown(s)))}_createArrow(o){const s=this._register(new O.ScrollbarArrow(o));this.domNode.domNode.appendChild(s.bgDomNode),this.domNode.domNode.appendChild(s.domNode)}_createSlider(o,s,e,m){this.slider=(0,i.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(o),this.slider.setLeft(s),typeof e=="number"&&this.slider.setWidth(e),typeof m=="number"&&this.slider.setHeight(m),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(E.addDisposableListener(this.slider.domNode,E.EventType.POINTER_DOWN,v=>{v.button===0&&(v.preventDefault(),this._sliderPointerDown(v))})),this.onclick(this.slider.domNode,v=>{v.leftButton&&v.stopPropagation()})}_onElementSize(o){return this._scrollbarState.setVisibleSize(o)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(o){return this._scrollbarState.setScrollSize(o)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(o){return this._scrollbarState.setScrollPosition(o)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){!this._shouldRender||(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(o){o.target===this.domNode.domNode&&this._onPointerDown(o)}delegatePointerDown(o){const s=this.domNode.domNode.getClientRects()[0].top,e=s+this._scrollbarState.getSliderPosition(),m=s+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),v=this._sliderPointerPosition(o);e<=v&&v<=m?o.button===0&&(o.preventDefault(),this._sliderPointerDown(o)):this._onPointerDown(o)}_onPointerDown(o){let s,e;if(o.target===this.domNode.domNode&&typeof o.offsetX=="number"&&typeof o.offsetY=="number")s=o.offsetX,e=o.offsetY;else{const v=E.getDomNodePagePosition(this.domNode.domNode);s=o.pageX-v.left,e=o.pageY-v.top}const m=this._pointerDownRelativePosition(s,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(m):this._scrollbarState.getDesiredScrollPositionFromOffset(m)),o.button===0&&(o.preventDefault(),this._sliderPointerDown(o))}_sliderPointerDown(o){if(!o.target||!(o.target instanceof Element))return;const s=this._sliderPointerPosition(o),e=this._sliderOrthogonalPointerPosition(o),m=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(o.target,o.pointerId,o.buttons,v=>{const w=this._sliderOrthogonalPointerPosition(v),D=Math.abs(w-e);if(d.isWindows&&D>c){this._setDesiredScrollPositionNow(m.getScrollPosition());return}const u=this._sliderPointerPosition(v)-s;this._setDesiredScrollPositionNow(m.getDesiredScrollPositionFromDelta(u))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(o){const s={};this.writeScrollPosition(s,o),this._scrollable.setScrollPositionNow(s)}updateScrollbarSize(o){this._updateScrollbarSize(o),this._scrollbarState.setScrollbarSize(o),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=g}),define(pe[118],be([1,0,20,56,37,41,11]),function(Q,t,E,i,W,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class y extends i.AbstractScrollbar{constructor(c,g,L){const o=c.getScrollDimensions(),s=c.getCurrentScrollPosition();if(super({lazyRender:g.lazyRender,host:L,scrollbarState:new O.ScrollbarState(g.horizontalHasArrows?g.arrowSize:0,g.horizontal===2?0:g.horizontalScrollbarSize,g.vertical===2?0:g.verticalScrollbarSize,o.width,o.scrollWidth,s.scrollLeft),visibility:g.horizontal,extraScrollbarClassName:"horizontal",scrollable:c,scrollByPage:g.scrollByPage}),g.horizontalHasArrows){const e=(g.arrowSize-W.ARROW_IMG_SIZE)/2,m=(g.horizontalScrollbarSize-W.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:C.Codicon.scrollbarButtonLeft,top:m,left:e,bottom:void 0,right:void 0,bgWidth:g.arrowSize,bgHeight:g.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:C.Codicon.scrollbarButtonRight,top:m,left:void 0,bottom:void 0,right:e,bgWidth:g.arrowSize,bgHeight:g.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((g.horizontalScrollbarSize-g.horizontalSliderSize)/2),0,void 0,g.horizontalSliderSize)}_updateSlider(c,g){this.slider.setWidth(c),this.slider.setLeft(g)}_renderDomNode(c,g){this.domNode.setWidth(c),this.domNode.setHeight(g),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(c){return this._shouldRender=this._onElementScrollSize(c.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(c.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(c.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(c,g){return c}_sliderPointerPosition(c){return c.pageX}_sliderOrthogonalPointerPosition(c){return c.pageY}_updateScrollbarSize(c){this.slider.setHeight(c)}writeScrollPosition(c,g){c.scrollLeft=g}updateOptions(c){this.updateScrollbarSize(c.horizontal===2?0:c.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(c.vertical===2?0:c.verticalScrollbarSize),this._visibilityController.setVisibility(c.horizontal),this._scrollByPage=c.scrollByPage}}t.HorizontalScrollbar=y}),define(pe[119],be([1,0,20,56,37,41,11]),function(Q,t,E,i,W,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class y extends i.AbstractScrollbar{constructor(c,g,L){const o=c.getScrollDimensions(),s=c.getCurrentScrollPosition();if(super({lazyRender:g.lazyRender,host:L,scrollbarState:new O.ScrollbarState(g.verticalHasArrows?g.arrowSize:0,g.vertical===2?0:g.verticalScrollbarSize,0,o.height,o.scrollHeight,s.scrollTop),visibility:g.vertical,extraScrollbarClassName:"vertical",scrollable:c,scrollByPage:g.scrollByPage}),g.verticalHasArrows){const e=(g.arrowSize-W.ARROW_IMG_SIZE)/2,m=(g.verticalScrollbarSize-W.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:C.Codicon.scrollbarButtonUp,top:e,left:m,bottom:void 0,right:void 0,bgWidth:g.verticalScrollbarSize,bgHeight:g.arrowSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:C.Codicon.scrollbarButtonDown,top:void 0,left:m,bottom:e,right:void 0,bgWidth:g.verticalScrollbarSize,bgHeight:g.arrowSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((g.verticalScrollbarSize-g.verticalSliderSize)/2),g.verticalSliderSize,void 0)}_updateSlider(c,g){this.slider.setHeight(c),this.slider.setTop(g)}_renderDomNode(c,g){this.domNode.setWidth(g),this.domNode.setHeight(c),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(c){return this._shouldRender=this._onElementScrollSize(c.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(c.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(c.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(c,g){return g}_sliderPointerPosition(c){return c.pageY}_sliderOrthogonalPointerPosition(c){return c.pageX}_updateScrollbarSize(c){this.slider.setWidth(c)}writeScrollPosition(c,g){c.scrollTop=g}updateOptions(c){this.updateScrollbarSize(c.vertical===2?0:c.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(c.vertical),this._scrollByPage=c.scrollByPage}}t.VerticalScrollbar=y}),define(pe[57],be([1,0,15,4,40,20,118,119,17,8,3,2,5,48,89]),function(Q,t,E,i,W,O,C,y,d,c,g,L,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,m=50,v=!0;class w{constructor(r,n,l){this.timestamp=r,this.deltaX=n,this.deltaY=l,this.score=0}}class D{constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let r=1,n=0,l=1,b=this._rear;do{const f=b===this._front?r:Math.pow(2,-l);if(r-=f,n+=this._memory[b].score*f,b===this._front)break;b=(this._capacity+b-1)%this._capacity,l++}while(!0);return n<=.5}accept(r,n,l){const b=new w(r,n,l);b.score=this._computeScore(b),this._front===-1&&this._rear===-1?(this._memory[0]=b,this._front=0,this._rear=0):(this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=b)}_computeScore(r){if(Math.abs(r.deltaX)>0&&Math.abs(r.deltaY)>0)return 1;let n=.5;const l=this._front===-1&&this._rear===-1?null:this._memory[this._rear];return(!this._isAlmostInt(r.deltaX)||!this._isAlmostInt(r.deltaY))&&(n+=.25),Math.min(Math.max(n,0),1)}_isAlmostInt(r){return Math.abs(Math.round(r)-r)<.01}}t.MouseWheelClassifier=D,D.INSTANCE=new D;class a extends d.Widget{get options(){return this._options}constructor(r,n,l){super(),this._onScroll=this._register(new g.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new g.Emitter),this.onWillScroll=this._onWillScroll.event,r.style.overflow="hidden",this._options=T(n),this._scrollable=l,this._register(this._scrollable.onScroll(f=>{this._onWillScroll.fire(f),this._onDidScroll(f),this._onScroll.fire(f)}));const b={onMouseWheel:f=>this._onMouseWheel(f),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new y.VerticalScrollbar(this._scrollable,this._options,b)),this._horizontalScrollbar=this._register(new C.HorizontalScrollbar(this._scrollable,this._options,b)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(r),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,W.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,W.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,W.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,f=>this._onMouseOver(f)),this.onmouseleave(this._listenOnDomNode,f=>this._onMouseLeave(f)),this._hideTimeout=this._register(new c.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}dispose(){this._mouseWheelToDispose=(0,L.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(r){this._verticalScrollbar.delegatePointerDown(r)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(r){this._scrollable.setScrollDimensions(r,!1)}updateClassName(r){this._options.className=r,o.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(r){typeof r.handleMouseWheel<"u"&&(this._options.handleMouseWheel=r.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof r.mouseWheelScrollSensitivity<"u"&&(this._options.mouseWheelScrollSensitivity=r.mouseWheelScrollSensitivity),typeof r.fastScrollSensitivity<"u"&&(this._options.fastScrollSensitivity=r.fastScrollSensitivity),typeof r.scrollPredominantAxis<"u"&&(this._options.scrollPredominantAxis=r.scrollPredominantAxis),typeof r.horizontal<"u"&&(this._options.horizontal=r.horizontal),typeof r.vertical<"u"&&(this._options.vertical=r.vertical),typeof r.horizontalScrollbarSize<"u"&&(this._options.horizontalScrollbarSize=r.horizontalScrollbarSize),typeof r.verticalScrollbarSize<"u"&&(this._options.verticalScrollbarSize=r.verticalScrollbarSize),typeof r.scrollByPage<"u"&&(this._options.scrollByPage=r.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(r){this._revealOnScroll=r}triggerScrollFromMouseWheelEvent(r){this._onMouseWheel(new O.StandardWheelEvent(r))}_setListeningToMouseWheel(r){if(this._mouseWheelToDispose.length>0!==r&&(this._mouseWheelToDispose=(0,L.dispose)(this._mouseWheelToDispose),r)){const l=b=>{this._onMouseWheel(new O.StandardWheelEvent(b))};this._mouseWheelToDispose.push(i.addDisposableListener(this._listenOnDomNode,i.EventType.MOUSE_WHEEL,l,{passive:!1}))}}_onMouseWheel(r){const n=D.INSTANCE;if(v){const f=window.devicePixelRatio/(0,E.getZoomFactor)();o.isWindows||o.isLinux?n.accept(Date.now(),r.deltaX/f,r.deltaY/f):n.accept(Date.now(),r.deltaX,r.deltaY)}let l=!1;if(r.deltaY||r.deltaX){let f=r.deltaY*this._options.mouseWheelScrollSensitivity,z=r.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(Math.abs(f)>=Math.abs(z)?z=0:f=0),this._options.flipAxes&&([f,z]=[z,f]);const $=!o.isMacintosh&&r.browserEvent&&r.browserEvent.shiftKey;(this._options.scrollYToX||$)&&!z&&(z=f,f=0),r.browserEvent&&r.browserEvent.altKey&&(z=z*this._options.fastScrollSensitivity,f=f*this._options.fastScrollSensitivity);const X=this._scrollable.getFutureScrollPosition();let J={};if(f){const ge=m*f,re=X.scrollTop-(ge<0?Math.floor(ge):Math.ceil(ge));this._verticalScrollbar.writeScrollPosition(J,re)}if(z){const ge=m*z,re=X.scrollLeft-(ge<0?Math.floor(ge):Math.ceil(ge));this._horizontalScrollbar.writeScrollPosition(J,re)}J=this._scrollable.validateScrollPosition(J),(X.scrollLeft!==J.scrollLeft||X.scrollTop!==J.scrollTop)&&(v&&this._options.mouseWheelSmoothScroll&&n.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(J):this._scrollable.setScrollPositionNow(J),l=!0)}let b=l;!b&&this._options.alwaysConsumeMouseWheel&&(b=!0),!b&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(b=!0),b&&(r.preventDefault(),r.stopPropagation())}_onDidScroll(r){this._shouldRender=this._horizontalScrollbar.onDidScroll(r)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(r)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(!!this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const r=this._scrollable.getCurrentScrollPosition(),n=r.scrollTop>0,l=r.scrollLeft>0,b=l?" left":"",f=n?" top":"",z=l||n?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${b}`),this._topShadowDomNode.setClassName(`shadow${f}`),this._topLeftShadowDomNode.setClassName(`shadow${z}${f}${b}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(r){this._mouseIsOver=!1,this._hide()}_onMouseOver(r){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=a;class u extends a{constructor(r,n){n=n||{},n.mouseWheelSmoothScroll=!1;const l=new s.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:b=>i.scheduleAtNextAnimationFrame(b)});super(r,n,l),this._register(l)}setScrollPosition(r){this._scrollable.setScrollPositionNow(r)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=u;class p extends a{constructor(r,n,l){super(r,n,l)}setScrollPosition(r){r.reuseAnimation?this._scrollable.setScrollPositionSmooth(r,r.reuseAnimation):this._scrollable.setScrollPositionNow(r)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=p;class S extends a{constructor(r,n){n=n||{},n.mouseWheelSmoothScroll=!1;const l=new s.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:b=>i.scheduleAtNextAnimationFrame(b)});super(r,n,l),this._register(l),this._element=r,this.onScroll(b=>{b.scrollTopChanged&&(this._element.scrollTop=b.scrollTop),b.scrollLeftChanged&&(this._element.scrollLeft=b.scrollLeft)}),this.scanDomNode()}setScrollPosition(r){this._scrollable.setScrollPositionNow(r)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=S;function T(_){const r={lazyRender:typeof _.lazyRender<"u"?_.lazyRender:!1,className:typeof _.className<"u"?_.className:"",useShadows:typeof _.useShadows<"u"?_.useShadows:!0,handleMouseWheel:typeof _.handleMouseWheel<"u"?_.handleMouseWheel:!0,flipAxes:typeof _.flipAxes<"u"?_.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof _.consumeMouseWheelIfScrollbarIsNeeded<"u"?_.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof _.alwaysConsumeMouseWheel<"u"?_.alwaysConsumeMouseWheel:!1,scrollYToX:typeof _.scrollYToX<"u"?_.scrollYToX:!1,mouseWheelScrollSensitivity:typeof _.mouseWheelScrollSensitivity<"u"?_.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof _.fastScrollSensitivity<"u"?_.fastScrollSensitivity:5,scrollPredominantAxis:typeof _.scrollPredominantAxis<"u"?_.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof _.mouseWheelSmoothScroll<"u"?_.mouseWheelSmoothScroll:!0,arrowSize:typeof _.arrowSize<"u"?_.arrowSize:11,listenOnDomNode:typeof _.listenOnDomNode<"u"?_.listenOnDomNode:null,horizontal:typeof _.horizontal<"u"?_.horizontal:1,horizontalScrollbarSize:typeof _.horizontalScrollbarSize<"u"?_.horizontalScrollbarSize:10,horizontalSliderSize:typeof _.horizontalSliderSize<"u"?_.horizontalSliderSize:0,horizontalHasArrows:typeof _.horizontalHasArrows<"u"?_.horizontalHasArrows:!1,vertical:typeof _.vertical<"u"?_.vertical:1,verticalScrollbarSize:typeof _.verticalScrollbarSize<"u"?_.verticalScrollbarSize:10,verticalHasArrows:typeof _.verticalHasArrows<"u"?_.verticalHasArrows:!1,verticalSliderSize:typeof _.verticalSliderSize<"u"?_.verticalSliderSize:0,scrollByPage:typeof _.scrollByPage<"u"?_.scrollByPage:!1};return r.horizontalSliderSize=typeof _.horizontalSliderSize<"u"?_.horizontalSliderSize:r.horizontalScrollbarSize,r.verticalSliderSize=typeof _.verticalSliderSize<"u"?_.verticalSliderSize:r.verticalScrollbarSize,o.isMacintosh&&(r.className+=" mac"),r}}),define(pe[58],be([1,0,15,51,4,18,22,57,14,8,25,3,2,46,48,78,114]),function(Q,t,E,i,W,O,C,y,d,c,g,L,o,s,e,m,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const w={CurrentDragAndDropData:void 0},D={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(r){return[r]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class a{get context(){return this._context}set context(n){this._context=n}constructor(n){this.elements=n}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=a;class u{constructor(n){this.elements=n}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=u;class p{constructor(){this.types=[],this.files=[]}update(n){if(n.types&&this.types.splice(0,this.types.length,...n.types),n.files){this.files.splice(0,this.files.length);for(let l=0;l<n.files.length;l++){const b=n.files.item(l);b&&(b.size||b.type)&&this.files.push(b)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=p;function S(r,n){return Array.isArray(r)&&Array.isArray(n)?(0,d.equals)(r,n):r===n}class T{constructor(n){n?.getSetSize?this.getSetSize=n.getSetSize.bind(n):this.getSetSize=(l,b,f)=>f,n?.getPosInSet?this.getPosInSet=n.getPosInSet.bind(n):this.getPosInSet=(l,b)=>b+1,n?.getRole?this.getRole=n.getRole.bind(n):this.getRole=l=>"listitem",n?.isChecked?this.isChecked=n.isChecked.bind(n):this.isChecked=l=>{}}}class _{get contentHeight(){return this.rangeMap.size}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(n){if(n!==this._horizontalScrolling){if(n&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=n,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const l of this.items)this.measureItemWidth(l);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,W.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}constructor(n,l,b,f=D){if(this.virtualDelegate=l,this.domId=`list_id_${++_.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new c.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=o.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=o.Disposable.None,this.onDragLeaveTimeout=o.Disposable.None,this.disposables=new o.DisposableStore,this._onDidChangeContentHeight=new L.Emitter,this.onDidChangeContentHeight=L.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this._horizontalScrolling=!1,f.horizontalScrolling&&f.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=new m.RangeMap;for(const $ of b)this.renderers.set($.templateId,$);this.cache=this.disposables.add(new v.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof f.mouseSupport=="boolean"?f.mouseSupport:!0),this._horizontalScrolling=f.horizontalScrolling??D.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.additionalScrollHeight=typeof f.additionalScrollHeight>"u"?0:f.additionalScrollHeight,this.accessibilityProvider=new T(f.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(f.transformOptimization??D.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)"),this.disposables.add(C.Gesture.addTarget(this.rowsContainer)),this.scrollable=new e.Scrollable({forceIntegerValues:!0,smoothScrollDuration:f.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:$=>(0,W.scheduleAtNextAnimationFrame)($)}),this.scrollableElement=this.disposables.add(new y.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:f.alwaysConsumeMouseWheel??D.alwaysConsumeMouseWheel,horizontal:1,vertical:f.verticalScrollMode??D.verticalScrollMode,useShadows:f.useShadows??D.useShadows,mouseWheelScrollSensitivity:f.mouseWheelScrollSensitivity,fastScrollSensitivity:f.fastScrollSensitivity},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),n.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,W.addDisposableListener)(this.rowsContainer,C.EventType.Change,$=>this.onTouchChange($))),this.disposables.add((0,W.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",$=>$.target.scrollTop=0)),this.disposables.add((0,W.addDisposableListener)(this.domNode,"dragover",$=>this.onDragOver(this.toDragEvent($)))),this.disposables.add((0,W.addDisposableListener)(this.domNode,"drop",$=>this.onDrop(this.toDragEvent($)))),this.disposables.add((0,W.addDisposableListener)(this.domNode,"dragleave",$=>this.onDragLeave(this.toDragEvent($)))),this.disposables.add((0,W.addDisposableListener)(this.domNode,"dragend",$=>this.onDragEnd($))),this.setRowLineHeight=f.setRowLineHeight??D.setRowLineHeight,this.setRowHeight=f.setRowHeight??D.setRowHeight,this.supportDynamicHeights=f.supportDynamicHeights??D.supportDynamicHeights,this.dnd=f.dnd??D.dnd,this.layout()}updateOptions(n){n.additionalScrollHeight!==void 0&&(this.additionalScrollHeight=n.additionalScrollHeight,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),n.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(n.smoothScrolling?125:0),n.horizontalScrolling!==void 0&&(this.horizontalScrolling=n.horizontalScrolling),n.mouseWheelScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({mouseWheelScrollSensitivity:n.mouseWheelScrollSensitivity}),n.fastScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({fastScrollSensitivity:n.fastScrollSensitivity})}triggerScrollFromMouseWheelEvent(n){this.scrollableElement.triggerScrollFromMouseWheelEvent(n)}updateElementHeight(n,l,b){if(n<0||n>=this.items.length)return;const f=this.items[n].size;if(typeof l>"u"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[n].lastDynamicHeightWidth=void 0,l=f+this.probeDynamicHeight(n)}if(f===l)return;const z=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let $=0;n<z.start||b!==null&&b>n&&b<=z.end?$=l-f:$=0,this.rangeMap.splice(n,1,[{size:l}]),this.items[n].size=l,this.render(z,Math.max(0,this.lastRenderTop+$),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}splice(n,l,b=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(n,l,b)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(n,l,b=[]){const f=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),z={start:n,end:n+l},$=s.Range.intersect(f,z),X=new Map;for(let V=$.end-1;V>=$.start;V--){const j=this.items[V];if(j.dragStartDisposable.dispose(),j.checkedDisposable.dispose(),j.row){let k=X.get(j.templateId);k||(k=[],X.set(j.templateId,k));const h=this.renderers.get(j.templateId);h&&h.disposeElement&&h.disposeElement(j.element,V,j.row.templateData,j.size),k.push(j.row)}j.row=null}const J={start:n+l,end:this.items.length},ge=s.Range.intersect(J,f),re=s.Range.relativeComplement(J,f),me=b.map(V=>({id:String(this.itemId++),element:V,templateId:this.virtualDelegate.getTemplateId(V),size:this.virtualDelegate.getHeight(V),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(V),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:o.Disposable.None,checkedDisposable:o.Disposable.None}));let ae;n===0&&l>=this.items.length?(this.rangeMap=new m.RangeMap,this.rangeMap.splice(0,0,me),ae=this.items,this.items=me):(this.rangeMap.splice(n,l,me),ae=this.items.splice(n,l,...me));const he=b.length-l,Se=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),te=(0,m.shift)(ge,he),De=s.Range.intersect(Se,te);for(let V=De.start;V<De.end;V++)this.updateItemInDOM(this.items[V],V);const se=s.Range.relativeComplement(te,Se);for(const V of se)for(let j=V.start;j<V.end;j++)this.removeItemFromDOM(j);const ie=re.map(V=>(0,m.shift)(V,he)),ne=[{start:n,end:n+b.length},...ie].map(V=>s.Range.intersect(Se,V)),F=this.getNextToLastElement(ne);for(const V of ne)for(let j=V.start;j<V.end;j++){const k=this.items[j],I=X.get(k.templateId)?.pop();this.insertItemInDOM(j,F,I)}for(const V of X.values())for(const j of V)this.cache.release(j);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),ae.map(V=>V.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,W.scheduleAtNextAnimationFrame)(()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let n=0;for(const l of this.items)typeof l.width<"u"&&(n=Math.max(n,l.width));this.scrollWidth=n,this.scrollableElement.setScrollDimensions({scrollWidth:n===0?0:n+10})}updateWidth(n){if(!this.horizontalScrolling||typeof this.scrollWidth>"u")return;const l=this.items[n];this.measureItemWidth(l),typeof l.width<"u"&&l.width>this.scrollWidth&&(this.scrollWidth=l.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}))}rerender(){if(!!this.supportDynamicHeights){for(const n of this.items)n.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){const n=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),l=this.rangeMap.positionAt(n.start),b=this.rangeMap.positionAt(n.start+1);return b!==-1&&(b-l)/2+l<this.scrollTop?n.start+1:n.start}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(n){return this.items[n].element}indexOf(n){return this.items.findIndex(l=>l.element===n)}domElement(n){const l=this.items[n].row;return l&&l.domNode}elementHeight(n){return this.items[n].size}elementTop(n){return this.rangeMap.positionAt(n)}indexAt(n){return this.rangeMap.indexAt(n)}indexAfter(n){return this.rangeMap.indexAfter(n)}layout(n,l){const b={height:typeof n=="number"?n:(0,W.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,b.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(b),typeof l<"u"&&(this.renderWidth=l,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof l=="number"?l:(0,W.getContentWidth)(this.domNode)})}render(n,l,b,f,z,$=!1){const X=this.getRenderRange(l,b),J=s.Range.relativeComplement(X,n),ge=s.Range.relativeComplement(n,X),re=this.getNextToLastElement(J);if($){const me=s.Range.intersect(n,X);for(let ae=me.start;ae<me.end;ae++)this.updateItemInDOM(this.items[ae],ae)}for(const me of J)for(let ae=me.start;ae<me.end;ae++)this.insertItemInDOM(ae,re);for(const me of ge)for(let ae=me.start;ae<me.end;ae++)this.removeItemFromDOM(ae);f!==void 0&&(this.rowsContainer.style.left=`-${f}px`),this.rowsContainer.style.top=`-${l}px`,this.horizontalScrolling&&z!==void 0&&(this.rowsContainer.style.width=`${Math.max(z,this.renderWidth)}px`),this.lastRenderTop=l,this.lastRenderHeight=b}insertItemInDOM(n,l,b){const f=this.items[n];f.row||(f.row=b??this.cache.alloc(f.templateId));const z=this.accessibilityProvider.getRole(f.element)||"listitem";f.row.domNode.setAttribute("role",z);const $=this.accessibilityProvider.isChecked(f.element);if(typeof $=="boolean")f.row.domNode.setAttribute("aria-checked",String(!!$));else if($){const ge=re=>f.row.domNode.setAttribute("aria-checked",String(!!re));ge($.value),f.checkedDisposable=$.onDidChange(ge)}f.row.domNode.parentElement||(l?this.rowsContainer.insertBefore(f.row.domNode,l):this.rowsContainer.appendChild(f.row.domNode)),this.updateItemInDOM(f,n);const X=this.renderers.get(f.templateId);if(!X)throw new Error(`No renderer found for template id ${f.templateId}`);X?.renderElement(f.element,n,f.row.templateData,f.size);const J=this.dnd.getDragURI(f.element);f.dragStartDisposable.dispose(),f.row.domNode.draggable=!!J,J&&(f.dragStartDisposable=(0,W.addDisposableListener)(f.row.domNode,"dragstart",ge=>this.onDragStart(f.element,J,ge))),this.horizontalScrolling&&(this.measureItemWidth(f),this.eventuallyUpdateScrollWidth())}measureItemWidth(n){if(!n.row||!n.row.domNode)return;n.row.domNode.style.width=E.isFirefox?"-moz-fit-content":"fit-content",n.width=(0,W.getContentWidth)(n.row.domNode);const l=window.getComputedStyle(n.row.domNode);l.paddingLeft&&(n.width+=parseFloat(l.paddingLeft)),l.paddingRight&&(n.width+=parseFloat(l.paddingRight)),n.row.domNode.style.width=""}updateItemInDOM(n,l){n.row.domNode.style.top=`${this.elementTop(l)}px`,this.setRowHeight&&(n.row.domNode.style.height=`${n.size}px`),this.setRowLineHeight&&(n.row.domNode.style.lineHeight=`${n.size}px`),n.row.domNode.setAttribute("data-index",`${l}`),n.row.domNode.setAttribute("data-last-element",l===this.length-1?"true":"false"),n.row.domNode.setAttribute("data-parity",l%2===0?"even":"odd"),n.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(n.element,l,this.length))),n.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(n.element,l))),n.row.domNode.setAttribute("id",this.getElementDomId(l)),n.row.domNode.classList.toggle("drop-target",n.dropTarget)}removeItemFromDOM(n){const l=this.items[n];if(l.dragStartDisposable.dispose(),l.checkedDisposable.dispose(),l.row){const b=this.renderers.get(l.templateId);b&&b.disposeElement&&b.disposeElement(l.element,n,l.row.templateData,l.size),this.cache.release(l.row),l.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(n,l){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:n,reuseAnimation:l})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(n){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:n})}get scrollTop(){return this.getScrollTop()}set scrollTop(n){this.setScrollTop(n)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.additionalScrollHeight}get onMouseClick(){return L.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"click")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseDblClick(){return L.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"dblclick")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseMiddleClick(){return L.Event.filter(L.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"auxclick")).event,n=>this.toMouseEvent(n),this.disposables),n=>n.browserEvent.button===1,this.disposables)}get onMouseUp(){return L.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mouseup")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseDown(){return L.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mousedown")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseOver(){return L.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mouseover")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseMove(){return L.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mousemove")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseOut(){return L.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mouseout")).event,n=>this.toMouseEvent(n),this.disposables)}get onContextMenu(){return L.Event.any(L.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"contextmenu")).event,n=>this.toMouseEvent(n),this.disposables),L.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,C.EventType.Contextmenu)).event,n=>this.toGestureEvent(n),this.disposables))}get onTouchStart(){return L.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"touchstart")).event,n=>this.toTouchEvent(n),this.disposables)}get onTap(){return L.Event.map(this.disposables.add(new O.DomEmitter(this.rowsContainer,C.EventType.Tap)).event,n=>this.toGestureEvent(n),this.disposables)}toMouseEvent(n){const l=this.getItemIndexFromEventTarget(n.target||null),b=typeof l>"u"?void 0:this.items[l],f=b&&b.element;return{browserEvent:n,index:l,element:f}}toTouchEvent(n){const l=this.getItemIndexFromEventTarget(n.target||null),b=typeof l>"u"?void 0:this.items[l],f=b&&b.element;return{browserEvent:n,index:l,element:f}}toGestureEvent(n){const l=this.getItemIndexFromEventTarget(n.initialTarget||null),b=typeof l>"u"?void 0:this.items[l],f=b&&b.element;return{browserEvent:n,index:l,element:f}}toDragEvent(n){const l=this.getItemIndexFromEventTarget(n.target||null),b=typeof l>"u"?void 0:this.items[l],f=b&&b.element;return{browserEvent:n,index:l,element:f}}onScroll(n){try{const l=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(l,n.scrollTop,n.height,n.scrollLeft,n.scrollWidth),this.supportDynamicHeights&&this._rerender(n.scrollTop,n.height,n.inSmoothScrolling)}catch(l){throw console.error("Got bad scroll event:",n),l}}onTouchChange(n){n.preventDefault(),n.stopPropagation(),this.scrollTop-=n.translationY}onDragStart(n,l,b){if(!b.dataTransfer)return;const f=this.dnd.getDragElements(n);if(b.dataTransfer.effectAllowed="copyMove",b.dataTransfer.setData(i.DataTransfers.TEXT,l),b.dataTransfer.setDragImage){let z;this.dnd.getDragLabel&&(z=this.dnd.getDragLabel(f,b)),typeof z>"u"&&(z=String(f.length));const $=(0,W.$)(".monaco-drag-image");$.textContent=z,document.body.appendChild($),b.dataTransfer.setDragImage($,-10,-10),setTimeout(()=>document.body.removeChild($),0)}this.currentDragData=new a(f),w.CurrentDragAndDropData=new u(f),this.dnd.onDragStart?.(this.currentDragData,b)}onDragOver(n){if(n.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),w.CurrentDragAndDropData&&w.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(n.browserEvent),!n.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(w.CurrentDragAndDropData)this.currentDragData=w.CurrentDragAndDropData;else{if(!n.browserEvent.dataTransfer.types)return!1;this.currentDragData=new p}const l=this.dnd.onDragOver(this.currentDragData,n.element,n.index,n.browserEvent);if(this.canDrop=typeof l=="boolean"?l:l.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;n.browserEvent.dataTransfer.dropEffect=typeof l!="boolean"&&l.effect===0?"copy":"move";let b;if(typeof l!="boolean"&&l.feedback?b=l.feedback:typeof n.index>"u"?b=[-1]:b=[n.index],b=(0,d.distinct)(b).filter(f=>f>=-1&&f<this.length).sort((f,z)=>f-z),b=b[0]===-1?[-1]:b,S(this.currentDragFeedback,b))return!0;if(this.currentDragFeedback=b,this.currentDragFeedbackDisposable.dispose(),b[0]===-1)this.domNode.classList.add("drop-target"),this.rowsContainer.classList.add("drop-target"),this.currentDragFeedbackDisposable=(0,o.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.rowsContainer.classList.remove("drop-target")});else{for(const f of b){const z=this.items[f];z.dropTarget=!0,z.row?.domNode.classList.add("drop-target")}this.currentDragFeedbackDisposable=(0,o.toDisposable)(()=>{for(const f of b){const z=this.items[f];z.dropTarget=!1,z.row?.domNode.classList.remove("drop-target")}})}return!0}onDragLeave(n){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,c.disposableTimeout)(()=>this.clearDragOverFeedback(),100),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,n.element,n.index,n.browserEvent)}onDrop(n){if(!this.canDrop)return;const l=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.currentDragData=void 0,w.CurrentDragAndDropData=void 0,!(!l||!n.browserEvent.dataTransfer)&&(n.browserEvent.preventDefault(),l.update(n.browserEvent.dataTransfer),this.dnd.drop(l,n.element,n.index,n.browserEvent))}onDragEnd(n){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.currentDragData=void 0,w.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(n)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=o.Disposable.None}setupDragAndDropScrollTopAnimation(n){if(!this.dragOverAnimationDisposable){const l=(0,W.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,W.animate)(this.animateDragAndDropScrollTop.bind(this,l))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,c.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3),this.dragOverMouseY=n.pageY}animateDragAndDropScrollTop(n){if(this.dragOverMouseY===void 0)return;const l=this.dragOverMouseY-n,b=this.renderHeight-35;l<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(l-35))):l>b&&(this.scrollTop+=Math.min(14,Math.floor(.3*(l-b))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getItemIndexFromEventTarget(n){const l=this.scrollableElement.getDomNode();let b=n;for(;b instanceof HTMLElement&&b!==this.rowsContainer&&l.contains(b);){const f=b.getAttribute("data-index");if(f){const z=Number(f);if(!isNaN(z))return z}b=b.parentElement}}getRenderRange(n,l){return{start:this.rangeMap.indexAt(n),end:this.rangeMap.indexAfter(n+l-1)}}_rerender(n,l,b){const f=this.getRenderRange(n,l);let z,$;n===this.elementTop(f.start)?(z=f.start,$=0):f.end-f.start>1&&(z=f.start+1,$=this.elementTop(z)-n);let X=0;for(;;){const J=this.getRenderRange(n,l);let ge=!1;for(let re=J.start;re<J.end;re++){const me=this.probeDynamicHeight(re);me!==0&&this.rangeMap.splice(re,1,[this.items[re]]),X+=me,ge=ge||me!==0}if(!ge){X!==0&&this.eventuallyUpdateScrollDimensions();const re=s.Range.relativeComplement(f,J);for(const ae of re)for(let he=ae.start;he<ae.end;he++)this.items[he].row&&this.removeItemFromDOM(he);const me=s.Range.relativeComplement(J,f);for(const ae of me)for(let he=ae.start;he<ae.end;he++){const Se=he+1,te=Se<this.items.length?this.items[Se].row:null,De=te?te.domNode:null;this.insertItemInDOM(he,De)}for(let ae=J.start;ae<J.end;ae++)this.items[ae].row&&this.updateItemInDOM(this.items[ae],ae);if(typeof z=="number"){const ae=this.scrollable.getFutureScrollPosition().scrollTop-n,he=this.elementTop(z)-$+ae;this.setScrollTop(he,b)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(n){const l=this.items[n];if(this.virtualDelegate.getDynamicHeight){const $=this.virtualDelegate.getDynamicHeight(l.element);if($!==null){const X=l.size;return l.size=$,l.lastDynamicHeightWidth=this.renderWidth,$-X}}if(!l.hasDynamicHeight||l.lastDynamicHeightWidth===this.renderWidth||!!this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(l.element))return 0;const b=l.size;if(!this.setRowHeight&&l.row){const $=l.row.domNode.offsetHeight;return l.size=$,l.lastDynamicHeightWidth=this.renderWidth,$-b}const f=this.cache.alloc(l.templateId);f.domNode.style.height="",this.rowsContainer.appendChild(f.domNode);const z=this.renderers.get(l.templateId);return z&&(z.renderElement(l.element,n,f.templateData,void 0),z.disposeElement?.(l.element,n,f.templateData,void 0)),l.size=f.domNode.offsetHeight,this.virtualDelegate.setDynamicHeight?.(l.element,l.size),l.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(f.domNode),this.cache.release(f),l.size-b}getNextToLastElement(n){const l=n[n.length-1];if(!l)return null;const b=this.items[l.end];return!b||!b.row?null:b.row.domNode}getElementDomId(n){return`${this.domId}_${n}`}dispose(){if(this.items){for(const n of this.items)if(n.row){const l=this.renderers.get(n.row.templateId);l&&(l.disposeElement?.(n.element,-1,n.row.templateData,void 0),l.disposeTemplate(n.row.templateData))}this.items=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,o.dispose)(this.disposables)}}_.InstanceCount=0,Ke([g.memoize],_.prototype,"onMouseClick",null),Ke([g.memoize],_.prototype,"onMouseDblClick",null),Ke([g.memoize],_.prototype,"onMouseMiddleClick",null),Ke([g.memoize],_.prototype,"onMouseUp",null),Ke([g.memoize],_.prototype,"onMouseDown",null),Ke([g.memoize],_.prototype,"onMouseOver",null),Ke([g.memoize],_.prototype,"onMouseMove",null),Ke([g.memoize],_.prototype,"onMouseOut",null),Ke([g.memoize],_.prototype,"onContextMenu",null),Ke([g.memoize],_.prototype,"onTouchStart",null),Ke([g.memoize],_.prototype,"onTap",null),t.ListView=_}),define(pe[59],be([1,0,4,18,19,22,54,68,14,8,24,25,3,33,2,45,27,5,6,67,58,88]),function(Q,t,E,i,W,O,C,y,d,c,g,L,o,s,e,m,v,w,D,a,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class p{constructor(h){this.trait=h,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(h){return h}renderElement(h,I,U){const K=this.renderedElements.findIndex(Z=>Z.templateData===U);if(K>=0){const Z=this.renderedElements[K];this.trait.unrender(U),Z.index=I}else{const Z={index:I,templateData:U};this.renderedElements.push(Z)}this.trait.renderIndex(I,U)}splice(h,I,U){const K=[];for(const Z of this.renderedElements)Z.index<h?K.push(Z):Z.index>=h+I&&K.push({index:Z.index+U-I,templateData:Z.templateData});this.renderedElements=K}renderIndexes(h){for(const{index:I,templateData:U}of this.renderedElements)h.indexOf(I)>-1&&this.trait.renderIndex(I,U)}disposeTemplate(h){const I=this.renderedElements.findIndex(U=>U.templateData===h);I<0||this.renderedElements.splice(I,1)}}class S{get name(){return this._trait}get renderer(){return new p(this)}constructor(h){this._trait=h,this.length=0,this.indexes=[],this.sortedIndexes=[],this._onChange=new o.Emitter,this.onChange=this._onChange.event}splice(h,I,U){I=Math.max(0,Math.min(I,this.length-h));const K=U.length-I,Z=h+I,N=[...this.sortedIndexes.filter(H=>H<h),...U.map((H,A)=>H?A+h:-1).filter(H=>H!==-1),...this.sortedIndexes.filter(H=>H>=Z).map(H=>H+K)],R=this.length+K;if(this.sortedIndexes.length>0&&N.length===0&&R>0){const H=this.sortedIndexes.find(A=>A>=h)??R-1;N.push(Math.min(H,R-1))}this.renderer.splice(h,I,U.length),this._set(N,N),this.length=R}renderIndex(h,I){I.classList.toggle(this._trait,this.contains(h))}unrender(h){h.classList.remove(this._trait)}set(h,I){return this._set(h,[...h].sort(ce),I)}_set(h,I,U){const K=this.indexes,Z=this.sortedIndexes;this.indexes=h,this.sortedIndexes=I;const N=se(Z,h);return this.renderer.renderIndexes(N),this._onChange.fire({indexes:h,browserEvent:U}),K}get(){return this.indexes}contains(h){return(0,d.binarySearch)(this.sortedIndexes,h,ce)>=0}dispose(){(0,e.dispose)(this._onChange)}}Ke([L.memoize],S.prototype,"renderer",null);class T extends S{constructor(h){super("selected"),this.setAriaSelected=h}renderIndex(h,I){super.renderIndex(h,I),this.setAriaSelected&&(this.contains(h)?I.setAttribute("aria-selected","true"):I.setAttribute("aria-selected","false"))}}class _{constructor(h,I,U){this.trait=h,this.view=I,this.identityProvider=U}splice(h,I,U){if(!this.identityProvider)return this.trait.splice(h,I,U.map(()=>!1));const K=this.trait.get().map(N=>this.identityProvider.getId(this.view.element(N)).toString()),Z=U.map(N=>K.indexOf(this.identityProvider.getId(N).toString())>-1);this.trait.splice(h,I,Z)}}function r(k){return k.tagName==="INPUT"||k.tagName==="TEXTAREA"}t.isInputElement=r;function n(k){return k.classList.contains("monaco-editor")?!0:k.classList.contains("monaco-list")||!k.parentElement?!1:n(k.parentElement)}t.isMonacoEditor=n;function l(k){return k.tagName==="A"&&k.classList.contains("monaco-button")||k.tagName==="DIV"&&k.classList.contains("monaco-button-dropdown")?!0:k.classList.contains("monaco-list")||!k.parentElement?!1:l(k.parentElement)}t.isButton=l;class b{get onKeyDown(){return this.disposables.add(o.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event).filter(h=>!r(h.target)).map(h=>new W.StandardKeyboardEvent(h)))}constructor(h,I,U){this.list=h,this.view=I,this.disposables=new e.DisposableStore,this.multipleSelectionDisposables=new e.DisposableStore,this.onKeyDown.filter(K=>K.keyCode===3).on(this.onEnter,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===16).on(this.onUpArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===18).on(this.onDownArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===11).on(this.onPageUpArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===12).on(this.onPageDownArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===9).on(this.onEscape,this,this.disposables),U.multipleSelectionSupport!==!1&&this.onKeyDown.filter(K=>(w.isMacintosh?K.metaKey:K.ctrlKey)&&K.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables)}updateOptions(h){h.multipleSelectionSupport!==void 0&&(this.multipleSelectionDisposables.clear(),h.multipleSelectionSupport&&this.onKeyDown.filter(I=>(w.isMacintosh?I.metaKey:I.ctrlKey)&&I.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables))}onEnter(h){h.preventDefault(),h.stopPropagation(),this.list.setSelection(this.list.getFocus(),h.browserEvent)}onUpArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusPrevious(1,!1,h.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onDownArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusNext(1,!1,h.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onPageUpArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusPreviousPage(h.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onPageDownArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusNextPage(h.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onCtrlA(h){h.preventDefault(),h.stopPropagation(),this.list.setSelection((0,d.range)(this.list.length),h.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(h){this.list.getSelection().length&&(h.preventDefault(),h.stopPropagation(),this.list.setSelection([],h.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}Ke([L.memoize],b.prototype,"onKeyDown",null);var f;(function(k){k[k.Automatic=0]="Automatic",k[k.Trigger=1]="Trigger"})(f=t.TypeNavigationMode||(t.TypeNavigationMode={}));var z;(function(k){k[k.Idle=0]="Idle",k[k.Typing=1]="Typing"})(z||(z={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(k){return k.ctrlKey||k.metaKey||k.altKey?!1:k.keyCode>=31&&k.keyCode<=56||k.keyCode>=21&&k.keyCode<=30||k.keyCode>=93&&k.keyCode<=102||k.keyCode>=80&&k.keyCode<=90}};class ${constructor(h,I,U,K,Z){this.list=h,this.view=I,this.keyboardNavigationLabelProvider=U,this.keyboardNavigationEventFilter=K,this.delegate=Z,this.enabled=!1,this.state=z.Idle,this.mode=f.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new e.DisposableStore,this.disposables=new e.DisposableStore,this.updateOptions(h.options)}updateOptions(h){h.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=h.typeNavigationMode??f.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let h=!1;const I=this.enabledDisposables.add(o.Event.chain(this.enabledDisposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).filter(Z=>!r(Z.target)).filter(()=>this.mode===f.Automatic||this.triggered).map(Z=>new W.StandardKeyboardEvent(Z)).filter(Z=>h||this.keyboardNavigationEventFilter(Z)).filter(Z=>this.delegate.mightProducePrintableCharacter(Z)).forEach(Z=>E.EventHelper.stop(Z,!0)).map(Z=>Z.browserEvent.key).event,U=o.Event.debounce(I,()=>null,800,void 0,void 0,this.enabledDisposables);o.Event.reduce(o.Event.any(I,U),(Z,N)=>N===null?null:(Z||"")+N,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),U(this.onClear,this,this.enabledDisposables),I(()=>h=!0,void 0,this.enabledDisposables),U(()=>h=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){!this.enabled||(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const h=this.list.getFocus();if(h.length>0&&h[0]===this.previouslyFocused){const I=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(h[0]));I&&(0,C.alert)(I)}this.previouslyFocused=-1}onInput(h){if(!h){this.state=z.Idle,this.triggered=!1;return}const I=this.list.getFocus(),U=I.length>0?I[0]:0,K=this.state===z.Idle?1:0;this.state=z.Typing;for(let Z=0;Z<this.list.length;Z++){const N=(U+Z+K)%this.list.length,R=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(N)),H=R&&R.toString();if(typeof H>"u"||(0,s.matchesPrefix)(h,H)){this.previouslyFocused=U,this.list.setFocus([N]),this.list.reveal(N);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class X{constructor(h,I){this.list=h,this.view=I,this.disposables=new e.DisposableStore,this.disposables.add(o.Event.chain(this.disposables.add(new i.DomEmitter(I.domNode,"keydown")).event)).filter(K=>!r(K.target)).map(K=>new W.StandardKeyboardEvent(K)).filter(K=>K.keyCode===2&&!K.ctrlKey&&!K.metaKey&&!K.shiftKey&&!K.altKey).on(this.onTab,this,this.disposables)}onTab(h){if(h.target!==this.view.domNode)return;const I=this.list.getFocus();if(I.length===0)return;const U=this.view.domElement(I[0]);if(!U)return;const K=U.querySelector("[tabIndex]");if(!K||!(K instanceof HTMLElement)||K.tabIndex===-1)return;const Z=window.getComputedStyle(K);Z.visibility==="hidden"||Z.display==="none"||(h.preventDefault(),h.stopPropagation(),K.focus())}dispose(){this.disposables.dispose()}}function J(k){return w.isMacintosh?k.browserEvent.metaKey:k.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=J;function ge(k){return k.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=ge;function re(k){return k instanceof MouseEvent&&k.button===2}const me={isSelectionSingleChangeEvent:J,isSelectionRangeChangeEvent:ge};class ae{constructor(h){this.list=h,this.disposables=new e.DisposableStore,this._onPointer=new o.Emitter,this.onPointer=this._onPointer.event,h.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||me),this.mouseSupport=typeof h.options.mouseSupport>"u"||!!h.options.mouseSupport,this.mouseSupport&&(h.onMouseDown(this.onMouseDown,this,this.disposables),h.onContextMenu(this.onContextMenu,this,this.disposables),h.onMouseDblClick(this.onDoubleClick,this,this.disposables),h.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(O.Gesture.addTarget(h.getHTMLElement()))),o.Event.any(h.onMouseClick,h.onMouseMiddleClick,h.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(h){h.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,h.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||me))}isSelectionSingleChangeEvent(h){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(h):!1}isSelectionRangeChangeEvent(h){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(h):!1}isSelectionChangeEvent(h){return this.isSelectionSingleChangeEvent(h)||this.isSelectionRangeChangeEvent(h)}onMouseDown(h){n(h.browserEvent.target)||document.activeElement!==h.browserEvent.target&&this.list.domFocus()}onContextMenu(h){if(n(h.browserEvent.target))return;const I=typeof h.index>"u"?[]:[h.index];this.list.setFocus(I,h.browserEvent)}onViewPointer(h){if(!this.mouseSupport||r(h.browserEvent.target)||n(h.browserEvent.target))return;const I=h.index;if(typeof I>"u"){this.list.setFocus([],h.browserEvent),this.list.setSelection([],h.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionRangeChangeEvent(h))return this.changeSelection(h);if(this.isSelectionChangeEvent(h))return this.changeSelection(h);this.list.setFocus([I],h.browserEvent),this.list.setAnchor(I),re(h.browserEvent)||this.list.setSelection([I],h.browserEvent),this._onPointer.fire(h)}onDoubleClick(h){if(r(h.browserEvent.target)||n(h.browserEvent.target)||this.isSelectionChangeEvent(h))return;const I=this.list.getFocus();this.list.setSelection(I,h.browserEvent)}changeSelection(h){const I=h.index;let U=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(h)){typeof U>"u"&&(U=this.list.getFocus()[0]??I,this.list.setAnchor(U));const K=Math.min(U,I),Z=Math.max(U,I),N=(0,d.range)(K,Z+1),R=this.list.getSelection(),H=De(se(R,[U]),U);if(H.length===0)return;const A=se(N,ie(R,H));this.list.setSelection(A,h.browserEvent),this.list.setFocus([I],h.browserEvent)}else if(this.isSelectionSingleChangeEvent(h)){const K=this.list.getSelection(),Z=K.filter(N=>N!==I);this.list.setFocus([I]),this.list.setAnchor(I),K.length===Z.length?this.list.setSelection([...Z,I],h.browserEvent):this.list.setSelection(Z,h.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=ae;class he{constructor(h,I){this.styleElement=h,this.selectorSuffix=I}style(h){const I=this.selectorSuffix&&`.${this.selectorSuffix}`,U=[];h.listBackground&&(h.listBackground.isOpaque()?U.push(`.monaco-list${I} .monaco-list-rows { background: ${h.listBackground}; }`):w.isMacintosh||console.warn(`List with id '${this.selectorSuffix}' was styled with a non-opaque background color. This will break sub-pixel antialiasing.`)),h.listFocusBackground&&(U.push(`.monaco-list${I}:focus .monaco-list-row.focused { background-color: ${h.listFocusBackground}; }`),U.push(`.monaco-list${I}:focus .monaco-list-row.focused:hover { background-color: ${h.listFocusBackground}; }`)),h.listFocusForeground&&U.push(`.monaco-list${I}:focus .monaco-list-row.focused { color: ${h.listFocusForeground}; }`),h.listActiveSelectionBackground&&(U.push(`.monaco-list${I}:focus .monaco-list-row.selected { background-color: ${h.listActiveSelectionBackground}; }`),U.push(`.monaco-list${I}:focus .monaco-list-row.selected:hover { background-color: ${h.listActiveSelectionBackground}; }`)),h.listActiveSelectionForeground&&U.push(`.monaco-list${I}:focus .monaco-list-row.selected { color: ${h.listActiveSelectionForeground}; }`),h.listActiveSelectionIconForeground&&U.push(`.monaco-list${I}:focus .monaco-list-row.selected .codicon { color: ${h.listActiveSelectionIconForeground}; }`),h.listFocusAndSelectionOutline&&U.push(`.monaco-list${I}:focus .monaco-list-row.selected { outline-color: ${h.listFocusAndSelectionOutline} !important; }`),h.listFocusAndSelectionBackground&&U.push(`
				.monaco-drag-image,
				.monaco-list${I}:focus .monaco-list-row.selected.focused { background-color: ${h.listFocusAndSelectionBackground}; }
			`),h.listFocusAndSelectionForeground&&U.push(`
				.monaco-drag-image,
				.monaco-list${I}:focus .monaco-list-row.selected.focused { color: ${h.listFocusAndSelectionForeground}; }
			`),h.listInactiveFocusForeground&&(U.push(`.monaco-list${I} .monaco-list-row.focused { color:  ${h.listInactiveFocusForeground}; }`),U.push(`.monaco-list${I} .monaco-list-row.focused:hover { color:  ${h.listInactiveFocusForeground}; }`)),h.listInactiveSelectionIconForeground&&U.push(`.monaco-list${I} .monaco-list-row.focused .codicon { color:  ${h.listInactiveSelectionIconForeground}; }`),h.listInactiveFocusBackground&&(U.push(`.monaco-list${I} .monaco-list-row.focused { background-color:  ${h.listInactiveFocusBackground}; }`),U.push(`.monaco-list${I} .monaco-list-row.focused:hover { background-color:  ${h.listInactiveFocusBackground}; }`)),h.listInactiveSelectionBackground&&(U.push(`.monaco-list${I} .monaco-list-row.selected { background-color:  ${h.listInactiveSelectionBackground}; }`),U.push(`.monaco-list${I} .monaco-list-row.selected:hover { background-color:  ${h.listInactiveSelectionBackground}; }`)),h.listInactiveSelectionForeground&&U.push(`.monaco-list${I} .monaco-list-row.selected { color: ${h.listInactiveSelectionForeground}; }`),h.listHoverBackground&&U.push(`.monaco-list${I}:not(.drop-target) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${h.listHoverBackground}; }`),h.listHoverForeground&&U.push(`.monaco-list${I} .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${h.listHoverForeground}; }`),h.listSelectionOutline&&U.push(`.monaco-list${I} .monaco-list-row.selected { outline: 1px dotted ${h.listSelectionOutline}; outline-offset: -1px; }`),h.listFocusOutline&&U.push(`
				.monaco-drag-image,
				.monaco-list${I}:focus .monaco-list-row.focused { outline: 1px solid ${h.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${I}.last-focused .monaco-list-row.focused { outline: 1px solid ${h.listFocusOutline}; outline-offset: -1px; }
			`),h.listInactiveFocusOutline&&U.push(`.monaco-list${I} .monaco-list-row.focused { outline: 1px dotted ${h.listInactiveFocusOutline}; outline-offset: -1px; }`),h.listHoverOutline&&U.push(`.monaco-list${I} .monaco-list-row:hover { outline: 1px dashed ${h.listHoverOutline}; outline-offset: -1px; }`),h.listDropBackground&&U.push(`
				.monaco-list${I}.drop-target,
				.monaco-list${I} .monaco-list-rows.drop-target,
				.monaco-list${I} .monaco-list-row.drop-target { background-color: ${h.listDropBackground} !important; color: inherit !important; }
			`),h.tableColumnsBorder&&U.push(`
				.monaco-table:hover > .monaco-split-view2,
				.monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${h.tableColumnsBorder};
			}`),h.tableOddRowsBackgroundColor&&U.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${h.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=U.join(`
`)}}t.DefaultStyleController=he;const Se={listFocusBackground:g.Color.fromHex("#7FB0D0"),listActiveSelectionBackground:g.Color.fromHex("#0E639C"),listActiveSelectionForeground:g.Color.fromHex("#FFFFFF"),listActiveSelectionIconForeground:g.Color.fromHex("#FFFFFF"),listFocusAndSelectionOutline:g.Color.fromHex("#90C2F9"),listFocusAndSelectionBackground:g.Color.fromHex("#094771"),listFocusAndSelectionForeground:g.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:g.Color.fromHex("#3F3F46"),listInactiveSelectionIconForeground:g.Color.fromHex("#FFFFFF"),listHoverBackground:g.Color.fromHex("#2A2D2E"),listDropBackground:g.Color.fromHex("#383B3D"),treeIndentGuidesStroke:g.Color.fromHex("#a9a9a9"),tableColumnsBorder:g.Color.fromHex("#cccccc").transparent(.2),tableOddRowsBackgroundColor:g.Color.fromHex("#cccccc").transparent(.04)},te={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function De(k,h){const I=k.indexOf(h);if(I===-1)return[];const U=[];let K=I-1;for(;K>=0&&k[K]===h-(I-K);)U.push(k[K--]);for(U.reverse(),K=I;K<k.length&&k[K]===h+(K-I);)U.push(k[K++]);return U}function se(k,h){const I=[];let U=0,K=0;for(;U<k.length||K<h.length;)if(U>=k.length)I.push(h[K++]);else if(K>=h.length)I.push(k[U++]);else if(k[U]===h[K]){I.push(k[U]),U++,K++;continue}else k[U]<h[K]?I.push(k[U++]):I.push(h[K++]);return I}function ie(k,h){const I=[];let U=0,K=0;for(;U<k.length||K<h.length;)if(U>=k.length)I.push(h[K++]);else if(K>=h.length)I.push(k[U++]);else if(k[U]===h[K]){U++,K++;continue}else k[U]<h[K]?I.push(k[U++]):K++;return I}const ce=(k,h)=>k-h;class ne{constructor(h,I){this._templateId=h,this.renderers=I}get templateId(){return this._templateId}renderTemplate(h){return this.renderers.map(I=>I.renderTemplate(h))}renderElement(h,I,U,K){let Z=0;for(const N of this.renderers)N.renderElement(h,I,U[Z++],K)}disposeElement(h,I,U,K){let Z=0;for(const N of this.renderers)N.disposeElement?.(h,I,U[Z],K),Z+=1}disposeTemplate(h){let I=0;for(const U of this.renderers)U.disposeTemplate(h[I++])}}class F{constructor(h){this.accessibilityProvider=h,this.templateId="a18n"}renderTemplate(h){return h}renderElement(h,I,U){const K=this.accessibilityProvider.getAriaLabel(h);K?U.setAttribute("aria-label",K):U.removeAttribute("aria-label");const Z=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(h);typeof Z=="number"?U.setAttribute("aria-level",`${Z}`):U.removeAttribute("aria-level")}disposeTemplate(h){}}class V{constructor(h,I){this.list=h,this.dnd=I}getDragElements(h){const I=this.list.getSelectedElements();return I.indexOf(h)>-1?I:[h]}getDragURI(h){return this.dnd.getDragURI(h)}getDragLabel(h,I){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(h,I)}onDragStart(h,I){this.dnd.onDragStart?.(h,I)}onDragOver(h,I,U,K){return this.dnd.onDragOver(h,I,U,K)}onDragLeave(h,I,U,K){this.dnd.onDragLeave?.(h,I,U,K)}onDragEnd(h){this.dnd.onDragEnd?.(h)}drop(h,I,U,K){this.dnd.drop(h,I,U,K)}}class j{get onDidChangeFocus(){return o.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),h=>this.toListEvent(h),this.disposables)}get onDidChangeSelection(){return o.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),h=>this.toListEvent(h),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let h=!1;const I=this.disposables.add(o.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).map(Z=>new W.StandardKeyboardEvent(Z)).filter(Z=>h=Z.keyCode===58||Z.shiftKey&&Z.keyCode===68).map(Z=>E.EventHelper.stop(Z,!0)).filter(()=>!1).event,U=this.disposables.add(o.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event)).forEach(()=>h=!1).map(Z=>new W.StandardKeyboardEvent(Z)).filter(Z=>Z.keyCode===58||Z.shiftKey&&Z.keyCode===68).map(Z=>E.EventHelper.stop(Z,!0)).map(({browserEvent:Z})=>{const N=this.getFocus(),R=N.length?N[0]:void 0,H=typeof R<"u"?this.view.element(R):void 0,A=typeof R<"u"?this.view.domElement(R):this.view.domNode;return{index:R,element:H,anchor:A,browserEvent:Z}}).event,K=this.disposables.add(o.Event.chain(this.view.onContextMenu)).filter(Z=>!h).map(({element:Z,index:N,browserEvent:R})=>({element:Z,index:N,anchor:{x:R.pageX+1,y:R.pageY},browserEvent:R})).event;return o.Event.any(I,U,K)}get onKeyDown(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return o.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return o.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"blur",!0)).event)}constructor(h,I,U,K,Z=te){this.user=h,this._options=Z,this.focus=new S("focused"),this.anchor=new S("anchor"),this.eventBufferer=new o.EventBufferer,this._ariaLabel="",this.disposables=new e.DisposableStore,this._onDidDispose=new o.Emitter,this.onDidDispose=this._onDidDispose.event;const N=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new T(N!=="listbox"),(0,v.mixin)(Z,Se,!1);const R=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=Z.accessibilityProvider,this.accessibilityProvider&&(R.push(new F(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),K=K.map(A=>new ne(A.templateId,[...R,A]));const H={...Z,dnd:Z.dnd&&new V(this,Z.dnd)};if(this.view=new u.ListView(I,U,K,H),this.view.domNode.setAttribute("role",N),Z.styleController)this.styleController=Z.styleController(this.view.domId);else{const A=(0,E.createStyleSheet)(this.view.domNode);this.styleController=new he(A,this.view.domId)}if(this.spliceable=new y.CombinedSpliceable([new _(this.focus,this.view,Z.identityProvider),new _(this.selection,this.view,Z.identityProvider),new _(this.anchor,this.view,Z.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new X(this,this.view)),(typeof Z.keyboardSupport!="boolean"||Z.keyboardSupport)&&(this.keyboardController=new b(this,this.view,Z),this.disposables.add(this.keyboardController)),Z.keyboardNavigationLabelProvider){const A=Z.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new $(this,this.view,Z.keyboardNavigationLabelProvider,Z.keyboardNavigationEventFilter??(()=>!0),A),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(Z),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}createMouseController(h){return new ae(this)}updateOptions(h={}){this._options={...this._options,...h},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(h),this.keyboardController?.updateOptions(h),this.view.updateOptions(h)}get options(){return this._options}splice(h,I,U=[]){if(h<0||h>this.view.length)throw new a.ListError(this.user,`Invalid start index: ${h}`);if(I<0)throw new a.ListError(this.user,`Invalid delete count: ${I}`);I===0&&U.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(h,I,U))}updateWidth(h){this.view.updateWidth(h)}updateElementHeight(h,I){this.view.updateElementHeight(h,I,null)}rerender(){this.view.rerender()}element(h){return this.view.element(h)}indexOf(h){return this.view.indexOf(h)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.getScrollTop()}set scrollTop(h){this.view.setScrollTop(h)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(h){this.view.setScrollLeft(h)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(h){this._ariaLabel=h,this.view.domNode.setAttribute("aria-label",h)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(h,I){this.view.layout(h,I)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(h,I){for(const U of h)if(U<0||U>=this.length)throw new a.ListError(this.user,`Invalid index ${U}`);this.selection.set(h,I)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(h=>this.view.element(h))}setAnchor(h){if(typeof h>"u"){this.anchor.set([]);return}if(h<0||h>=this.length)throw new a.ListError(this.user,`Invalid index ${h}`);this.anchor.set([h])}getAnchor(){return(0,d.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const h=this.getAnchor();return typeof h>"u"?void 0:this.element(h)}setFocus(h,I){for(const U of h)if(U<0||U>=this.length)throw new a.ListError(this.user,`Invalid index ${U}`);this.focus.set(h,I)}focusNext(h=1,I=!1,U,K){if(this.length===0)return;const Z=this.focus.get(),N=this.findNextIndex(Z.length>0?Z[0]+h:0,I,K);N>-1&&this.setFocus([N],U)}focusPrevious(h=1,I=!1,U,K){if(this.length===0)return;const Z=this.focus.get(),N=this.findPreviousIndex(Z.length>0?Z[0]-h:0,I,K);N>-1&&this.setFocus([N],U)}async focusNextPage(h,I){let U=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);U=U===0?0:U-1;const K=this.getFocus()[0];if(K!==U&&(K===void 0||U>K)){const Z=this.findPreviousIndex(U,!1,I);Z>-1&&K!==Z?this.setFocus([Z],h):this.setFocus([U],h)}else{const Z=this.view.getScrollTop();let N=Z+this.view.renderHeight;U>K&&(N-=this.view.elementHeight(U)),this.view.setScrollTop(N),this.view.getScrollTop()!==Z&&(this.setFocus([]),await(0,c.timeout)(0),await this.focusNextPage(h,I))}}async focusPreviousPage(h,I){let U;const K=this.view.getScrollTop();K===0?U=this.view.indexAt(K):U=this.view.indexAfter(K-1);const Z=this.getFocus()[0];if(Z!==U&&(Z===void 0||Z>=U)){const N=this.findNextIndex(U,!1,I);N>-1&&Z!==N?this.setFocus([N],h):this.setFocus([U],h)}else{const N=K;this.view.setScrollTop(K-this.view.renderHeight),this.view.getScrollTop()!==N&&(this.setFocus([]),await(0,c.timeout)(0),await this.focusPreviousPage(h,I))}}focusLast(h,I){if(this.length===0)return;const U=this.findPreviousIndex(this.length-1,!1,I);U>-1&&this.setFocus([U],h)}focusFirst(h,I){this.focusNth(0,h,I)}focusNth(h,I,U){if(this.length===0)return;const K=this.findNextIndex(h,!1,U);K>-1&&this.setFocus([K],I)}findNextIndex(h,I=!1,U){for(let K=0;K<this.length;K++){if(h>=this.length&&!I)return-1;if(h=h%this.length,!U||U(this.element(h)))return h;h++}return-1}findPreviousIndex(h,I=!1,U){for(let K=0;K<this.length;K++){if(h<0&&!I)return-1;if(h=(this.length+h%this.length)%this.length,!U||U(this.element(h)))return h;h--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(h=>this.view.element(h))}reveal(h,I){if(h<0||h>=this.length)throw new a.ListError(this.user,`Invalid index ${h}`);const U=this.view.getScrollTop(),K=this.view.elementTop(h),Z=this.view.elementHeight(h);if((0,D.isNumber)(I)){const N=Z-this.view.renderHeight;this.view.setScrollTop(N*(0,m.clamp)(I,0,1)+K)}else{const N=K+Z,R=U+this.view.renderHeight;K<U&&N>=R||(K<U||N>=R&&Z>=this.view.renderHeight?this.view.setScrollTop(K):N>=R&&this.view.setScrollTop(N-this.view.renderHeight))}}getRelativeTop(h){if(h<0||h>=this.length)throw new a.ListError(this.user,`Invalid index ${h}`);const I=this.view.getScrollTop(),U=this.view.elementTop(h),K=this.view.elementHeight(h);if(U<I||U+K>I+this.view.renderHeight)return null;const Z=K-this.view.renderHeight;return Math.abs((I-U)/Z)}isDOMFocused(){return this.view.domNode===document.activeElement}getHTMLElement(){return this.view.domNode}getElementID(h){return this.view.getElementDomId(h)}style(h){this.styleController.style(h)}toListEvent({indexes:h,browserEvent:I}){return{indexes:h,elements:h.map(U=>this.view.element(U)),browserEvent:I}}_onFocusChange(){const h=this.focus.get();this.view.domNode.classList.toggle("element-focused",h.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const h=this.focus.get();if(h.length>0){let I;this.accessibilityProvider?.getActiveDescendantId&&(I=this.accessibilityProvider.getActiveDescendantId(this.view.element(h[0]))),this.view.domNode.setAttribute("aria-activedescendant",I||this.view.getElementDomId(h[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const h=this.selection.get();this.view.domNode.classList.toggle("selection-none",h.length===0),this.view.domNode.classList.toggle("selection-single",h.length===1),this.view.domNode.classList.toggle("selection-multiple",h.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}Ke([L.memoize],j.prototype,"onDidChangeFocus",null),Ke([L.memoize],j.prototype,"onDidChangeSelection",null),Ke([L.memoize],j.prototype,"onContextMenu",null),Ke([L.memoize],j.prototype,"onKeyDown",null),Ke([L.memoize],j.prototype,"onKeyUp",null),Ke([L.memoize],j.prototype,"onKeyPress",null),Ke([L.memoize],j.prototype,"onDidFocus",null),Ke([L.memoize],j.prototype,"onDidBlur",null),t.List=j}),define(pe[60],be([1,0,12,34,36,10,16]),function(Q,t,E,i,W,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var y;(function(v){v[v.Paragraph=0]="Paragraph",v[v.Break=1]="Break"})(y=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class d{constructor(w="",D=!1){if(this.value=w,typeof this.value!="string")throw(0,E.illegalArgument)("value");typeof D=="boolean"?(this.isTrusted=D,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=D.isTrusted??void 0,this.supportThemeIcons=D.supportThemeIcons??!1,this.supportHtml=D.supportHtml??!1)}appendText(w,D=0){return this.value+=o(this.supportThemeIcons?(0,i.escapeIcons)(w):w).replace(/([ \t]+)/g,(a,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,D===1?`\\
`:`

`),this}appendMarkdown(w){return this.value+=w,this}appendCodeblock(w,D){return this.value+="\n```",this.value+=w,this.value+=`
`,this.value+=D,this.value+="\n```\n",this}appendLink(w,D,a){return this.value+="[",this.value+=this._escape(D,"]"),this.value+="](",this.value+=this._escape(String(w),")"),a&&(this.value+=` "${this._escape(this._escape(a,'"'),")")}"`),this.value+=")",this}_escape(w,D){const a=new RegExp((0,O.escapeRegExpCharacters)(D),"g");return w.replace(a,(u,p)=>w.charAt(p-1)!=="\\"?`\\${u}`:u)}}t.MarkdownString=d;function c(v){return g(v)?!v.value:Array.isArray(v)?v.every(c):!0}t.isEmptyMarkdownString=c;function g(v){return v instanceof d?!0:v&&typeof v=="object"?typeof v.value=="string"&&(typeof v.isTrusted=="boolean"||v.isTrusted===void 0)&&(typeof v.supportThemeIcons=="boolean"||v.supportThemeIcons===void 0):!1}t.isMarkdownString=g;function L(v,w){return v===w?!0:!v||!w?!1:v.value===w.value&&v.isTrusted===w.isTrusted&&v.supportThemeIcons===w.supportThemeIcons&&v.supportHtml===w.supportHtml&&(v.baseUri===w.baseUri||!!v.baseUri&&!!w.baseUri&&(0,W.isEqual)(C.URI.from(v.baseUri),C.URI.from(w.baseUri)))}t.markdownStringEqual=L;function o(v){return v.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=o;function s(v){return v.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=s;function e(v){return v&&v.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}t.removeMarkdownEscapes=e;function m(v){const w=[],D=v.split("|").map(u=>u.trim());v=D[0];const a=D[1];if(a){const u=/height=(\d+)/.exec(a),p=/width=(\d+)/.exec(a),S=u?u[1]:"",T=p?p[1]:"",_=isFinite(parseInt(T)),r=isFinite(parseInt(S));_&&w.push(`width="${T}"`),r&&w.push(`height="${S}"`)}return{href:v,dimensions:w}}t.parseHrefAndDimensions=m}),define(pe[120],be([1,0,4,112,18,52,20,113,12,3,60,34,72,44,2,75,50,35,27,36,10,16]),function(Q,t,E,i,W,O,C,y,d,c,g,L,o,s,e,m,v,w,D,a,u,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.renderMarkdown=void 0;const S=Object.freeze({image:(X,J,ge)=>{let re=[],me=[];return X&&({href:X,dimensions:re}=(0,g.parseHrefAndDimensions)(X),me.push(`src="${(0,g.escapeDoubleQuotes)(X)}"`)),ge&&me.push(`alt="${(0,g.escapeDoubleQuotes)(ge)}"`),J&&me.push(`title="${(0,g.escapeDoubleQuotes)(J)}"`),re.length&&(me=me.concat(re)),"<img "+me.join(" ")+">"},paragraph:X=>`<p>${X}</p>`,link:(X,J,ge)=>typeof X!="string"?"":(X===ge&&(ge=(0,g.removeMarkdownEscapes)(ge)),J=typeof J=="string"?(0,g.escapeDoubleQuotes)((0,g.removeMarkdownEscapes)(J)):"",X=(0,g.removeMarkdownEscapes)(X),X=X.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${X}" title="${J||X}">${ge}</a>`)});function T(X,J={},ge={}){const re=new e.DisposableStore;let me=!1;const ae=(0,O.createElement)(J),he=function(F){let V;try{V=(0,v.parse)(decodeURIComponent(F))}catch{}return V?(V=(0,D.cloneAndChange)(V,j=>{if(X.uris&&X.uris[j])return p.URI.revive(X.uris[j])}),encodeURIComponent(JSON.stringify(V))):F},Se=function(F,V){const j=X.uris&&X.uris[F];let k=p.URI.revive(j);return V?F.startsWith(w.Schemas.data+":")?F:(k||(k=p.URI.parse(F)),w.FileAccess.asBrowserUri(k).toString(!0)):!k||p.URI.parse(F).toString()===k.toString()?F:(k.query&&(k=k.with({query:he(k.query)})),k.toString())},te=new m.marked.Renderer;te.image=S.image,te.link=S.link,te.paragraph=S.paragraph;const De=[];if(J.codeBlockRenderer&&(te.code=(F,V)=>{const j=o.defaultGenerator.nextId(),k=J.codeBlockRenderer(_(V),F);return De.push(k.then(h=>[j,h])),`<div class="code" data-code="${j}">${(0,u.escape)(F)}</div>`}),J.actionHandler){const F=J.actionHandler.disposables.add(new W.DomEmitter(ae,"click")),V=J.actionHandler.disposables.add(new W.DomEmitter(ae,"auxclick"));J.actionHandler.disposables.add(c.Event.any(F.event,V.event)(j=>{const k=new C.StandardMouseEvent(j);if(!k.leftButton&&!k.middleButton)return;let h=k.target;if(!(h.tagName!=="A"&&(h=h.parentElement,!h||h.tagName!=="A")))try{let I=h.dataset.href;I&&(X.baseUri&&(I=r(p.URI.from(X.baseUri),I)),J.actionHandler.callback(I,k))}catch(I){(0,d.onUnexpectedError)(I)}finally{k.preventDefault()}}))}X.supportHtml||(ge.sanitizer=F=>(X.isTrusted?F.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?F:"",ge.sanitize=!0,ge.silent=!0),ge.renderer=te;let se=X.value??"";se.length>1e5&&(se=`${se.substr(0,1e5)}\u2026`),X.supportThemeIcons&&(se=(0,L.markdownEscapeEscapedIcons)(se));let ie=m.marked.parse(se,ge);X.supportThemeIcons&&(ie=(0,y.renderLabelWithIcons)(ie).map(V=>typeof V=="string"?V:V.outerHTML).join(""));const ne=new DOMParser().parseFromString(n(X,ie),"text/html");if(ne.body.querySelectorAll("img").forEach(F=>{const V=F.getAttribute("src");if(V){let j=V;try{X.baseUri&&(j=r(p.URI.from(X.baseUri),j))}catch{}F.src=Se(j,!0)}}),ne.body.querySelectorAll("a").forEach(F=>{const V=F.getAttribute("href");if(F.setAttribute("href",""),!V||/^data:|javascript:/i.test(V)||/^command:/i.test(V)&&!X.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(V))F.replaceWith(...F.childNodes);else{let j=Se(V,!1);X.baseUri&&(j=r(p.URI.from(X.baseUri),V)),F.dataset.href=j}}),ae.innerHTML=n(X,ne.body.innerHTML),De.length>0&&Promise.all(De).then(F=>{if(me)return;const V=new Map(F),j=ae.querySelectorAll("div[data-code]");for(const k of j){const h=V.get(k.dataset.code??"");h&&E.reset(k,h)}J.asyncRenderCallback?.()}),J.asyncRenderCallback)for(const F of ae.getElementsByTagName("img")){const V=re.add(E.addDisposableListener(F,"load",()=>{V.dispose(),J.asyncRenderCallback()}))}return{element:ae,dispose:()=>{me=!0,re.dispose()}}}t.renderMarkdown=T;function _(X){if(!X)return"";const J=X.split(/[\s+|:|,|\{|\?]/,1);return J.length?J[0]:X}function r(X,J){return/^\w[\w\d+.-]*:/.test(J)?J:X.path.endsWith("/")?(0,a.resolvePath)(X,J).toString():(0,a.resolvePath)((0,a.dirname)(X),J).toString()}function n(X,J){const{config:ge,allowedSchemes:re}=l(X);i.addHook("uponSanitizeAttribute",(ae,he)=>{if(he.attrName==="style"||he.attrName==="class"){if(ae.tagName==="SPAN"){if(he.attrName==="style"){he.keepAttr=/^(color\:#[0-9a-fA-F]+;)?(background-color\:#[0-9a-fA-F]+;)?$/.test(he.attrValue);return}else if(he.attrName==="class"){he.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(he.attrValue);return}}he.keepAttr=!1;return}});const me=E.hookDomPurifyHrefAndSrcSanitizer(re);try{return i.sanitize(J,{...ge,RETURN_TRUSTED_TYPE:!0})}finally{i.removeHook("uponSanitizeAttribute"),me.dispose()}}function l(X){const J=[w.Schemas.http,w.Schemas.https,w.Schemas.mailto,w.Schemas.data,w.Schemas.file,w.Schemas.vscodeFileResource,w.Schemas.vscodeRemote,w.Schemas.vscodeRemoteResource];return X.isTrusted&&J.push(w.Schemas.command),{config:{ALLOWED_TAGS:["ul","li","p","b","i","code","blockquote","ol","h1","h2","h3","h4","h5","h6","hr","em","pre","table","thead","tbody","tr","th","td","div","del","a","strong","br","img","span"],ALLOWED_ATTR:["href","data-href","target","title","src","alt","class","style","data-code","width","height","align"],ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:J}}function b(X){return typeof X=="string"?X:f(X)}t.renderStringAsPlaintext=b;function f(X){let J=X.value??"";J.length>1e5&&(J=`${J.substr(0,1e5)}\u2026`);const ge=m.marked.parse(J,{renderer:$.getValue()}).replace(/&(#\d+|[a-zA-Z]+);/g,re=>z.get(re)??re);return n({isTrusted:!1},ge).toString()}t.renderMarkdownAsPlaintext=f;const z=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),$=new s.Lazy(()=>{const X=new m.marked.Renderer;return X.code=J=>J,X.blockquote=J=>J,X.html=J=>"",X.heading=(J,ge,re)=>J+`
`,X.hr=()=>"",X.list=(J,ge)=>J,X.listitem=J=>J+`
`,X.paragraph=J=>J+`
`,X.table=(J,ge)=>J+ge+`
`,X.tablerow=J=>J,X.tablecell=(J,ge)=>J+" ",X.strong=J=>J,X.em=J=>J,X.codespan=J=>J,X.br=()=>`
`,X.del=J=>J,X.image=(J,ge,re)=>"",X.text=J=>J,X.link=(J,ge,re)=>re,X})}),define(pe[121],be([1,0,4,8,28,60,34,2,6,98]),function(Q,t,E,i,W,O,C,y,d,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function g(s,e){(0,d.isString)(e)?s.title=(0,C.stripIcons)(e):e?.markdownNotSupportedFallback?s.title=e.markdownNotSupportedFallback:s.removeAttribute("title")}t.setupNativeHover=g;class L{constructor(e,m,v){this.hoverDelegate=e,this.target=m,this.fadeInAnimation=v}async update(e,m,v){if(this._cancellationTokenSource&&(this._cancellationTokenSource.dispose(!0),this._cancellationTokenSource=void 0),this.isDisposed)return;let w;if(e===void 0||(0,d.isString)(e)||e instanceof HTMLElement)w=e;else if(!(0,d.isFunction)(e.markdown))w=e.markdown??e.markdownNotSupportedFallback;else{this._hoverWidget||this.show((0,c.localize)(0,null),m),this._cancellationTokenSource=new W.CancellationTokenSource;const D=this._cancellationTokenSource.token;if(w=await e.markdown(D),w===void 0&&(w=e.markdownNotSupportedFallback),this.isDisposed||D.isCancellationRequested)return}this.show(w,m,v)}show(e,m,v){const w=this._hoverWidget;if(this.hasContent(e)){const D={content:e,target:this.target,showPointer:this.hoverDelegate.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.fadeInAnimation||!!w,...v};this._hoverWidget=this.hoverDelegate.showHover(D,m)}w?.dispose()}hasContent(e){return e?(0,O.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this._hoverWidget?.isDisposed}dispose(){this._hoverWidget?.dispose(),this._cancellationTokenSource?.dispose(!0),this._cancellationTokenSource=void 0}}function o(s,e,m,v){let w,D;const a=(_,r)=>{_&&(D?.dispose(),D=void 0),r&&(w?.dispose(),w=void 0),s.onDidHideHover?.()},u=(_,r,n)=>new i.TimeoutTimer(async()=>{(!D||D.isDisposed)&&(D=new L(s,n||e,_>0),await D.update(m,r,v))},_),p=()=>{if(w)return;const _=new y.DisposableStore,r=b=>a(!1,b.fromElement===e);_.add(E.addDisposableListener(e,E.EventType.MOUSE_LEAVE,r,!0));const n=()=>a(!0,!0);_.add(E.addDisposableListener(e,E.EventType.MOUSE_DOWN,n,!0));const l={targetElements:[e],dispose:()=>{}};if(s.placement===void 0||s.placement==="mouse"){const b=f=>{l.x=f.x+10,f.target instanceof HTMLElement&&f.target.classList.contains("action-label")&&a(!0,!0)};_.add(E.addDisposableListener(e,E.EventType.MOUSE_MOVE,b,!0))}_.add(u(s.delay,!1,l)),w=_},S=E.addDisposableListener(e,E.EventType.MOUSE_OVER,p,!0);return{show:_=>{a(!1,!0),u(0,_)},hide:()=>{a(!0,!0)},update:async(_,r)=>{m=_,await D?.update(m,void 0,r)},dispose:()=>{S.dispose(),a(!0,!0)}}}t.setupCustomHover=o}),define(pe[122],be([1,0,4,18,19,120,59,14,3,43,2,5,100,91]),function(Q,t,E,i,W,O,C,y,d,c,g,L,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const s=E.$,e="selectOption.entry.template";class m{get templateId(){return e}renderTemplate(D){const a=Object.create(null);return a.disposables=[],a.root=D,a.text=E.append(D,s(".option-text")),a.detail=E.append(D,s(".option-detail")),a.decoratorRight=E.append(D,s(".option-decorator-right")),a}renderElement(D,a,u){const p=u,S=D.text,T=D.detail,_=D.decoratorRight,r=D.isDisabled;p.text.textContent=S,p.detail.textContent=T||"",p.decoratorRight.innerText=_||"",r?p.root.classList.add("option-disabled"):p.root.classList.remove("option-disabled")}disposeTemplate(D){D.disposables=(0,g.dispose)(D.disposables)}}class v extends g.Disposable{constructor(D,a,u,p,S){super(),this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.selectBoxOptions=S||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=v.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new d.Emitter,this._register(this._onDidSelect),this.styles=p,this.registerListeners(),this.constructSelectDropDown(u),this.selected=a||0,D&&this.setOptions(D,a)}getHeight(){return 18}getTemplateId(){return e}constructSelectDropDown(D){this.contextViewProvider=D,this.selectDropDownContainer=E.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=E.append(this.selectDropDownContainer,s(".select-box-details-pane"));const a=E.append(this.selectDropDownContainer,s(".select-box-dropdown-container-width-control")),u=E.append(a,s(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",E.append(u,this.widthControlElement),this._dropDownPosition=0,this.styleElement=E.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(E.addDisposableListener(this.selectDropDownContainer,E.EventType.DRAG_START,p=>{E.EventHelper.stop(p,!0)}))}registerListeners(){this._register(E.addStandardDisposableListener(this.selectElement,"change",a=>{this.selected=a.target.selectedIndex,this._onDidSelect.fire({index:a.target.selectedIndex,selected:a.target.value}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)})),this._register(E.addDisposableListener(this.selectElement,E.EventType.CLICK,a=>{E.EventHelper.stop(a),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(E.addDisposableListener(this.selectElement,E.EventType.MOUSE_DOWN,a=>{E.EventHelper.stop(a)}));let D;this._register(E.addDisposableListener(this.selectElement,"touchstart",a=>{D=this._isVisible})),this._register(E.addDisposableListener(this.selectElement,"touchend",a=>{E.EventHelper.stop(a),D?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(E.addDisposableListener(this.selectElement,E.EventType.KEY_DOWN,a=>{const u=new W.StandardKeyboardEvent(a);let p=!1;L.isMacintosh?(u.keyCode===18||u.keyCode===16||u.keyCode===10||u.keyCode===3)&&(p=!0):(u.keyCode===18&&u.altKey||u.keyCode===16&&u.altKey||u.keyCode===10||u.keyCode===3)&&(p=!0),p&&(this.showSelectDropDown(),E.EventHelper.stop(a,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(D,a){y.equals(this.options,D)||(this.options=D,this.selectElement.options.length=0,this._hasDetails=!1,this.options.forEach((u,p)=>{this.selectElement.add(this.createOption(u.text,p,u.isDisabled)),typeof u.description=="string"&&(this._hasDetails=!0)})),a!==void 0&&(this.select(a),this._currentSelection=this.selected)}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(D){D>=0&&D<this.options.length?this.selected=D:D>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)}setAriaLabel(D){this.selectBoxOptions.ariaLabel=D,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(D){this.selectElement.tabIndex=D?0:-1}render(D){this.container=D,D.classList.add("select-container"),D.appendChild(this.selectElement),this.applyStyles()}style(D){const a=[];this.styles=D,this.styles.listFocusBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&!this.styles.selectBorder.equals(this.styles.selectBackground)?(a.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=a.join(`
`),this.applyStyles()}applyStyles(){if(this.selectElement){const D=this.styles.selectBackground?this.styles.selectBackground.toString():"",a=this.styles.selectForeground?this.styles.selectForeground.toString():"",u=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=D,this.selectElement.style.color=a,this.selectElement.style.borderColor=u}this.selectList&&this.styleList()}styleList(){if(this.selectList){const D=this.styles.selectBackground?this.styles.selectBackground.toString():"";this.selectList.style({});const a=this.styles.selectListBackground?this.styles.selectListBackground.toString():D;this.selectDropDownListContainer.style.backgroundColor=a,this.selectionDetailsPane.style.backgroundColor=a;const u=this.styles.focusBorder?this.styles.focusBorder.toString():"";this.selectDropDownContainer.style.outlineColor=u,this.selectDropDownContainer.style.outlineOffset="-1px"}}createOption(D,a,u){const p=document.createElement("option");return p.value=D,p.text=D,p.disabled=!!u,p}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:D=>this.renderSelectDropDown(D,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:D=>this.renderSelectDropDown(D),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(D){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),D&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(D,a){return D.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(a),{dispose:()=>{try{D.removeChild(this.selectDropDownContainer)}catch{}}}}measureMaxDetailsHeight(){let D=0;return this.options.forEach((a,u)=>{this.updateDetail(u),this.selectionDetailsPane.offsetHeight>D&&(D=this.selectionDetailsPane.offsetHeight)}),D}layoutSelectDropDown(D){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const a=E.getDomNodePagePosition(this.selectElement),u=getComputedStyle(this.selectElement),p=parseFloat(u.getPropertyValue("--dropdown-padding-top"))+parseFloat(u.getPropertyValue("--dropdown-padding-bottom")),S=window.innerHeight-a.top-a.height-(this.selectBoxOptions.minBottomMargin||0),T=a.top-v.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,_=this.selectElement.offsetWidth,r=this.setWidthControlElement(this.widthControlElement),n=Math.max(r,Math.round(_)).toString()+"px";this.selectDropDownContainer.style.width=n,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let l=this.selectList.contentHeight;const b=this._hasDetails?this.measureMaxDetailsHeight():0,f=l+p+b,z=Math.floor((S-p-b)/this.getHeight()),$=Math.floor((T-p-b)/this.getHeight());if(D)return a.top+a.height>window.innerHeight-22||a.top<v.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||z<1&&$<1?!1:(z<v.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&$>z&&this.options.length>z?(this._dropDownPosition=1,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=0,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(a.top+a.height>window.innerHeight-22||a.top<v.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===0&&z<1||this._dropDownPosition===1&&$<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===0){if(this._isVisible&&z+$<1)return this.hideSelectDropDown(!0),!1;f>S&&(l=z*this.getHeight())}else f>T&&(l=$*this.getHeight());return this.selectList.layout(l),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=l+p+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=l+p+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=n,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(D){let a=0;if(D){let u=0,p=0;this.options.forEach((S,T)=>{const _=S.detail?S.detail.length:0,r=S.decoratorRight?S.decoratorRight.length:0,n=S.text.length+_+r;n>p&&(u=T,p=n)}),D.textContent=this.options[u].text+(this.options[u].decoratorRight?this.options[u].decoratorRight+" ":""),a=E.getTotalWidth(D)}return a}createSelectList(D){if(this.selectList)return;this.selectDropDownListContainer=E.append(D,s(".select-box-dropdown-list-container")),this.listRenderer=new m,this.selectList=new C.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:p=>{let S=p.text;return p.detail&&(S+=`. ${p.detail}`),p.decoratorRight&&(S+=`. ${p.decoratorRight}`),p.description&&(S+=`. ${p.description}`),S},getWidgetAriaLabel:()=>(0,o.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const a=this._register(new i.DomEmitter(this.selectDropDownListContainer,"keydown")),u=d.Event.chain(a.event).filter(()=>this.selectList.length>0).map(p=>new W.StandardKeyboardEvent(p));this._register(u.filter(p=>p.keyCode===3).on(p=>this.onEnter(p),this)),this._register(u.filter(p=>p.keyCode===2).on(p=>this.onEnter(p),this)),this._register(u.filter(p=>p.keyCode===9).on(p=>this.onEscape(p),this)),this._register(u.filter(p=>p.keyCode===16).on(p=>this.onUpArrow(p),this)),this._register(u.filter(p=>p.keyCode===18).on(p=>this.onDownArrow(p),this)),this._register(u.filter(p=>p.keyCode===12).on(this.onPageDown,this)),this._register(u.filter(p=>p.keyCode===11).on(this.onPageUp,this)),this._register(u.filter(p=>p.keyCode===14).on(this.onHome,this)),this._register(u.filter(p=>p.keyCode===13).on(this.onEnd,this)),this._register(u.filter(p=>p.keyCode>=21&&p.keyCode<=56||p.keyCode>=80&&p.keyCode<=108).on(this.onCharacter,this)),this._register(E.addDisposableListener(this.selectList.getHTMLElement(),E.EventType.POINTER_UP,p=>this.onPointerUp(p))),this._register(this.selectList.onMouseOver(p=>typeof p.index<"u"&&this.selectList.setFocus([p.index]))),this._register(this.selectList.onDidChangeFocus(p=>this.onListFocus(p))),this._register(E.addDisposableListener(this.selectDropDownContainer,E.EventType.FOCUS_OUT,p=>{!this._isVisible||E.isAncestor(p.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(D){if(!this.selectList.length)return;E.EventHelper.stop(D);const a=D.target;if(!a||a.classList.contains("slider"))return;const u=a.closest(".monaco-list-row");if(!u)return;const p=Number(u.getAttribute("data-index")),S=u.classList.contains("option-disabled");p>=0&&p<this.options.length&&!S&&(this.selected=p,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(D,a){const u=S=>{for(let T=0;T<S.childNodes.length;T++){const _=S.childNodes.item(T);(_.tagName&&_.tagName.toLowerCase())==="img"?S.removeChild(_):u(_)}},p=(0,O.renderMarkdown)({value:D,supportThemeIcons:!0},{actionHandler:a});return p.element.classList.add("select-box-description-markdown"),u(p.element),p.element}onListFocus(D){!this._isVisible||!this._hasDetails||this.updateDetail(D.indexes[0])}updateDetail(D){this.selectionDetailsPane.innerText="";const a=this.options[D],u=a?.description??"",p=a?.descriptionIsMarkdown??!1;if(u){if(p){const S=a.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(u,S))}else this.selectionDetailsPane.innerText=u;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(D){E.EventHelper.stop(D),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(D){E.EventHelper.stop(D),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(D){if(this.selected<this.options.length-1){E.EventHelper.stop(D,!0);const a=this.options[this.selected+1].isDisabled;if(a&&this.options.length>this.selected+2)this.selected+=2;else{if(a)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(D){this.selected>0&&(E.EventHelper.stop(D,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(D){E.EventHelper.stop(D),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(D){E.EventHelper.stop(D),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(D){E.EventHelper.stop(D),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(D){E.EventHelper.stop(D),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(D){const a=c.KeyCodeUtils.toString(D.keyCode);let u=-1;for(let p=0;p<this.options.length-1;p++)if(u=(p+this.selected+1)%this.options.length,this.options[u].text.charAt(0).toUpperCase()===a&&!this.options[u].isDisabled){this.select(u),this.selectList.setFocus([u]),this.selectList.reveal(this.selectList.getFocus()[0]),E.EventHelper.stop(D);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=v,v.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32,v.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2,v.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}),define(pe[123],be([1,0,122,116,17,24,27,5,90]),function(Q,t,E,i,W,O,C,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.defaultStyles=void 0,t.defaultStyles={selectBackground:O.Color.fromHex("#3C3C3C"),selectForeground:O.Color.fromHex("#F0F0F0"),selectBorder:O.Color.fromHex("#3C3C3C")};class d extends W.Widget{constructor(g,L,o,s=(0,C.deepClone)(t.defaultStyles),e){super(),y.isMacintosh&&!e?.useCustomDrawn?this.selectBoxDelegate=new i.SelectBoxNative(g,L,s,e):this.selectBoxDelegate=new E.SelectBoxList(g,L,o,s,e),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(g,L){this.selectBoxDelegate.setOptions(g,L)}select(g){this.selectBoxDelegate.select(g)}setAriaLabel(g){this.selectBoxDelegate.setAriaLabel(g)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(g){this.selectBoxDelegate.setFocusable(g)}render(g){this.selectBoxDelegate.render(g)}style(g){this.selectBoxDelegate.style(g)}applyStyles(){this.selectBoxDelegate.applyStyles()}}t.SelectBox=d}),define(pe[61],be([1,0,15,51,4,22,121,123,32,2,5,6,95,47]),function(Q,t,E,i,W,O,C,y,d,c,g,L,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class s extends c.Disposable{get action(){return this._action}constructor(w,D,a={}){super(),this.options=a,this._context=w||this,this._action=D,D instanceof d.Action&&this._register(D.onDidChange(u=>{!this.element||this.handleActionChangeEvent(u)}))}handleActionChangeEvent(w){w.enabled!==void 0&&this.updateEnabled(),w.checked!==void 0&&this.updateChecked(),w.class!==void 0&&this.updateClass(),w.label!==void 0&&(this.updateLabel(),this.updateTooltip()),w.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new d.ActionRunner)),this._actionRunner}set actionRunner(w){this._actionRunner=w}isEnabled(){return this._action.enabled}setActionContext(w){this._context=w}render(w){const D=this.element=w;this._register(O.Gesture.addTarget(w));const a=this.options&&this.options.draggable;a&&(w.draggable=!0,E.isFirefox&&this._register((0,W.addDisposableListener)(w,W.EventType.DRAG_START,u=>u.dataTransfer?.setData(i.DataTransfers.TEXT,this._action.label)))),this._register((0,W.addDisposableListener)(D,O.EventType.Tap,u=>this.onClick(u,!0))),this._register((0,W.addDisposableListener)(D,W.EventType.MOUSE_DOWN,u=>{a||W.EventHelper.stop(u,!0),this._action.enabled&&u.button===0&&D.classList.add("active")})),g.isMacintosh&&this._register((0,W.addDisposableListener)(D,W.EventType.CONTEXT_MENU,u=>{u.button===0&&u.ctrlKey===!0&&this.onClick(u)})),this._register((0,W.addDisposableListener)(D,W.EventType.CLICK,u=>{W.EventHelper.stop(u,!0),this.options&&this.options.isMenu||this.onClick(u)})),this._register((0,W.addDisposableListener)(D,W.EventType.DBLCLICK,u=>{W.EventHelper.stop(u,!0)})),[W.EventType.MOUSE_UP,W.EventType.MOUSE_OUT].forEach(u=>{this._register((0,W.addDisposableListener)(D,u,p=>{W.EventHelper.stop(p),D.classList.remove("active")}))})}onClick(w,D=!1){W.EventHelper.stop(w,!0);const a=L.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?w:{preserveFocus:D}:this._context;this.actionRunner.run(this._action,a)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(w){this.element&&(this.element.tabIndex=w?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getTooltip(){return this.action.tooltip}updateTooltip(){if(!this.element)return;const w=this.getTooltip()??"";this.updateAriaLabel(),this.options.hoverDelegate?(this.element.title="",this.customHover?this.customHover.update(w):(this.customHover=(0,C.setupCustomHover)(this.options.hoverDelegate,this.element,w),this._store.add(this.customHover))):this.element.title=w}updateAriaLabel(){if(this.element){const w=this.getTooltip()??"";this.element.setAttribute("aria-label",w)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),super.dispose()}}t.BaseActionViewItem=s;class e extends s{constructor(w,D,a={}){super(w,D,a),this.options=a,this.options.icon=a.icon!==void 0?a.icon:!1,this.options.label=a.label!==void 0?a.label:!0,this.cssClass=""}render(w){super.render(w),this.element&&(this.label=(0,W.append)(this.element,(0,W.$)("a.action-label"))),this.label&&(this._action.id===d.Separator.ID?this.label.setAttribute("role","presentation"):this.options.isMenu?this.label.setAttribute("role","menuitem"):this.label.setAttribute("role","button")),this.options.label&&this.options.keybinding&&this.element&&((0,W.append)(this.element,(0,W.$)("span.keybinding")).textContent=this.options.keybinding),this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(w){this.label&&(this.label.tabIndex=w?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.action.label)}getTooltip(){let w=null;return this.action.tooltip?w=this.action.tooltip:!this.options.label&&this.action.label&&this.options.icon&&(w=this.action.label,this.options.keybinding&&(w=o.localize(0,null,w,this.options.keybinding))),w??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.action.class,this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.action.enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateAriaLabel(){if(this.label){const w=this.getTooltip()??"";this.label.setAttribute("aria-label",w)}}updateChecked(){this.label&&(this.action.checked?this.label.classList.add("checked"):this.label.classList.remove("checked"))}}t.ActionViewItem=e;class m extends s{constructor(w,D,a,u,p,S){super(w,D),this.selectBox=new y.SelectBox(a,u,p,void 0,S),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(w,D){this.selectBox.setOptions(w,D)}select(w){this.selectBox.select(w)}registerListeners(){this._register(this.selectBox.onDidSelect(w=>{this.actionRunner.run(this._action,this.getActionContext(w.selected,w.index))}))}getActionContext(w,D){return w}setFocusable(w){this.selectBox.setFocusable(w)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(w){this.selectBox.render(w)}}t.SelectActionViewItem=m}),define(pe[62],be([1,0,4,19,61,32,3,2,6,47]),function(Q,t,E,i,W,O,C,y,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var c;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(c=t.ActionsOrientation||(t.ActionsOrientation={}));class g extends y.Disposable{constructor(s,e={}){super(),this._actionRunnerDisposables=this._register(new y.DisposableStore),this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new C.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new C.Emitter({onFirstListenerAdd:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new C.Emitter),this.onDidRun=this._onDidRun.event,this._onWillRun=this._register(new C.Emitter),this.onWillRun=this._onWillRun.event,this.options=e,this._context=e.context??null,this._orientation=this.options.orientation??0,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[3,10]},this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new O.ActionRunner,this._actionRunnerDisposables.add(this._actionRunner)),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(w=>this._onDidRun.fire(w))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(w=>this._onWillRun.fire(w))),this.viewItems=[],this.viewItemDisposables=new Map,this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let m,v;switch(this._orientation){case 0:m=[15],v=[17];break;case 1:m=[16],v=[18],this.domNode.className+=" vertical";break}this._register(E.addDisposableListener(this.domNode,E.EventType.KEY_DOWN,w=>{const D=new i.StandardKeyboardEvent(w);let a=!0;const u=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;m&&(D.equals(m[0])||D.equals(m[1]))?a=this.focusPrevious():v&&(D.equals(v[0])||D.equals(v[1]))?a=this.focusNext():D.equals(9)&&this.cancelHasListener?this._onDidCancel.fire():D.equals(14)?a=this.focusFirst():D.equals(13)?a=this.focusLast():D.equals(2)&&u instanceof W.BaseActionViewItem&&u.trapsArrowNavigation?a=this.focusNext():this.isTriggerKeyEvent(D)?this._triggerKeys.keyDown?this.doTrigger(D):this.triggerKeyDown=!0:a=!1,a&&(D.preventDefault(),D.stopPropagation())})),this._register(E.addDisposableListener(this.domNode,E.EventType.KEY_UP,w=>{const D=new i.StandardKeyboardEvent(w);this.isTriggerKeyEvent(D)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(D)),D.preventDefault(),D.stopPropagation()):(D.equals(2)||D.equals(1026))&&this.updateFocusedItem()})),this.focusTracker=this._register(E.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(E.getActiveElement()===this.domNode||!E.isAncestor(E.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.focusedItem=void 0,this.previouslyFocusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),s.appendChild(this.domNode)}refreshRole(){this.length()>=2?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(s){s?this.actionsList.setAttribute("aria-label",s):this.actionsList.removeAttribute("aria-label")}setFocusable(s){if(this.focusable=s,this.focusable){const e=this.viewItems.find(m=>m instanceof W.BaseActionViewItem&&m.isEnabled());e instanceof W.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof W.BaseActionViewItem&&e.setFocusable(!1)})}isTriggerKeyEvent(s){let e=!1;return this._triggerKeys.keys.forEach(m=>{e=e||s.equals(m)}),e}updateFocusedItem(){for(let s=0;s<this.actionsList.children.length;s++){const e=this.actionsList.children[s];if(E.isAncestor(E.getActiveElement(),e)){this.focusedItem=s;break}}}get context(){return this._context}set context(s){this._context=s,this.viewItems.forEach(e=>e.setActionContext(s))}get actionRunner(){return this._actionRunner}set actionRunner(s){this._actionRunner=s,this._actionRunnerDisposables.clear(),this._actionRunnerDisposables.add(this._actionRunner.onDidRun(e=>this._onDidRun.fire(e))),this._actionRunnerDisposables.add(this._actionRunner.onWillRun(e=>this._onWillRun.fire(e))),this.viewItems.forEach(e=>e.actionRunner=s)}getContainer(){return this.domNode}hasAction(s){return this.viewItems.findIndex(e=>e.action.id===s.id)!==-1}getAction(s){if(typeof s=="number")return this.viewItems[s]?.action;if(s instanceof HTMLElement){for(;s.parentElement!==this.actionsList;){if(!s.parentElement)return;s=s.parentElement}for(let e=0;e<this.actionsList.childNodes.length;e++)if(this.actionsList.childNodes[e]===s)return this.viewItems[e].action}}push(s,e={}){const m=Array.isArray(s)?s:[s];let v=d.isNumber(e.index)?e.index:null;m.forEach(w=>{const D=document.createElement("li");D.className="action-item",D.setAttribute("role","presentation");let a;this.options.actionViewItemProvider&&(a=this.options.actionViewItemProvider(w)),a||(a=new W.ActionViewItem(this.context,w,{hoverDelegate:this.options.hoverDelegate,...e})),this.options.allowContextMenu||this.viewItemDisposables.set(a,E.addDisposableListener(D,E.EventType.CONTEXT_MENU,u=>{E.EventHelper.stop(u,!0)})),a.actionRunner=this._actionRunner,a.setActionContext(this.context),a.render(D),this.focusable&&a instanceof W.BaseActionViewItem&&this.viewItems.length===0&&a.setFocusable(!0),v===null||v<0||v>=this.actionsList.children.length?(this.actionsList.appendChild(D),this.viewItems.push(a)):(this.actionsList.insertBefore(D,this.actionsList.children[v]),this.viewItems.splice(v,0,a),v++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(s){if(s>=0&&s<this.actionsList.children.length){const e=this.actionsList.children.item(s);if(e)return e.clientWidth}return 0}getHeight(s){if(s>=0&&s<this.actionsList.children.length){const e=this.actionsList.children.item(s);if(e)return e.clientHeight}return 0}pull(s){s>=0&&s<this.viewItems.length&&(this.actionsList.removeChild(this.actionsList.childNodes[s]),this.viewItemDisposables.get(this.viewItems[s])?.dispose(),this.viewItemDisposables.delete(this.viewItems[s]),(0,y.dispose)(this.viewItems.splice(s,1)),this.refreshRole())}clear(){(0,y.dispose)(this.viewItems),(0,y.dispose)(this.viewItemDisposables.values()),this.viewItemDisposables.clear(),this.viewItems=[],E.clearNode(this.actionsList),this.refreshRole()}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(s){let e=!1,m;if(s===void 0?e=!0:typeof s=="number"?m=s:typeof s=="boolean"&&(e=s),e&&typeof this.focusedItem>"u"){const v=this.viewItems.findIndex(w=>w.isEnabled());this.focusedItem=v===-1?void 0:v,this.updateFocus(void 0,void 0,!0)}else m!==void 0&&(this.focusedItem=m),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(s){if(typeof this.focusedItem>"u")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let m;do{if(!s&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=e,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,m=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!m.isEnabled()||m.action.id===O.Separator.ID));return this.updateFocus(),!0}focusPrevious(s){if(typeof this.focusedItem>"u")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let m;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!s&&this.options.preventLoopNavigation)return this.focusedItem=e,!1;this.focusedItem=this.viewItems.length-1}m=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!m.isEnabled()||m.action.id===O.Separator.ID));return this.updateFocus(!0),!0}updateFocus(s,e,m=!1){typeof this.focusedItem>"u"&&this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const v=this.focusedItem!==void 0&&this.viewItems[this.focusedItem];if(v){let w=!0;d.isFunction(v.focus)||(w=!1),this.options.focusOnlyEnabledItems&&d.isFunction(v.isEnabled)&&!v.isEnabled()&&(w=!1),v.action.id===O.Separator.ID&&(w=!1),w?(m||this.previouslyFocusedItem!==this.focusedItem)&&(v.focus(s),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem=void 0)}}doTrigger(s){if(typeof this.focusedItem>"u")return;const e=this.viewItems[this.focusedItem];if(e instanceof W.BaseActionViewItem){const m=e._context===null||e._context===void 0?s:e._context;this.run(e._action,m)}}async run(s,e){await this._actionRunner.run(s,e)}dispose(){(0,y.dispose)(this.viewItems),this.viewItems=[],this.getContainer().remove(),super.dispose()}}t.ActionBar=g;function L(o){if(!o.length)return o;let s=-1;for(let m=0;m<o.length;m++)if(o[m].id!==O.Separator.ID){s=m;break}if(s===-1)return[];o=o.slice(s);for(let m=o.length-1;m>=0&&o[m].id===O.Separator.ID;m--)o.splice(m,1);let e=!1;for(let m=o.length-1;m>=0;m--){const v=o[m].id===O.Separator.ID;v&&!e?o.splice(m,1):v?v&&(e=!1):e=!0}return o}t.prepareActions=L}),define(pe[124],be([1,0,4,18,52,62,54,57,17,24,3,77,27,99,87]),function(Q,t,E,i,W,O,C,y,d,c,g,L,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.MessageType=void 0;const e=E.$;var m;(function(a){a[a.INFO=1]="INFO",a[a.WARNING=2]="WARNING",a[a.ERROR=3]="ERROR"})(m=t.MessageType||(t.MessageType={}));const v={inputBackground:c.Color.fromHex("#3C3C3C"),inputForeground:c.Color.fromHex("#CCCCCC"),inputValidationInfoBorder:c.Color.fromHex("#55AAFF"),inputValidationInfoBackground:c.Color.fromHex("#063B49"),inputValidationWarningBorder:c.Color.fromHex("#B89500"),inputValidationWarningBackground:c.Color.fromHex("#352A05"),inputValidationErrorBorder:c.Color.fromHex("#BE1100"),inputValidationErrorBackground:c.Color.fromHex("#5A1D1D")};class w extends d.Widget{constructor(u,p,S){super(),this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new g.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new g.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=p,this.options=S||Object.create(null),(0,o.mixin)(this.options,v,!1),this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.inputBackground=this.options.inputBackground,this.inputForeground=this.options.inputForeground,this.inputBorder=this.options.inputBorder,this.inputValidationInfoBorder=this.options.inputValidationInfoBorder,this.inputValidationInfoBackground=this.options.inputValidationInfoBackground,this.inputValidationInfoForeground=this.options.inputValidationInfoForeground,this.inputValidationWarningBorder=this.options.inputValidationWarningBorder,this.inputValidationWarningBackground=this.options.inputValidationWarningBackground,this.inputValidationWarningForeground=this.options.inputValidationWarningForeground,this.inputValidationErrorBorder=this.options.inputValidationErrorBorder,this.inputValidationErrorBackground=this.options.inputValidationErrorBackground,this.inputValidationErrorForeground=this.options.inputValidationErrorForeground,this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=E.append(u,e(".monaco-inputbox.idle"));const T=this.options.flexibleHeight?"textarea":"input",_=E.append(this.element,e(".ibwrapper"));if(this.input=E.append(_,e(T+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=E.append(_,e("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new y.ScrollableElement(this.element,{vertical:1}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),E.append(u,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(l=>this.input.scrollTop=l.scrollTop));const r=this._register(new i.DomEmitter(document,"selectionchange")),n=g.Event.filter(r.event,()=>document.getSelection()?.anchorNode===_);this._register(n(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this.ignoreGesture(this.input),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new O.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(u){this.placeholder=u,this.input.setAttribute("placeholder",u)}setTooltip(u){this.tooltip=u,this.input.title=u}setAriaLabel(u){this.ariaLabel=u,u?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(u){this.input.value!==u&&(this.input.value=u,this.onValueChange())}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:E.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return document.activeElement===this.input}select(u=null){this.input.select(),u&&(this.input.setSelectionRange(u.start,u.end),u.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(u){u?this.enable():this.disable()}get width(){return E.getTotalWidth(this.input)}set width(u){if(this.options.flexibleHeight&&this.options.flexibleWidth){let p=0;if(this.mirror){const S=parseFloat(this.mirror.style.paddingLeft||"")||0,T=parseFloat(this.mirror.style.paddingRight||"")||0;p=S+T}this.input.style.width=u-p+"px"}else this.input.style.width=u+"px";this.mirror&&(this.mirror.style.width=u+"px")}set paddingRight(u){this.input.style.width=`calc(100% - ${u}px)`,this.mirror&&(this.mirror.style.paddingRight=u+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const u=this.cachedContentHeight,p=this.cachedHeight,S=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:u,height:p}),this.scrollableElement.setScrollPosition({scrollTop:S})}showMessage(u,p){this.message=u,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(u.type));const S=this.stylesForType(this.message.type);this.element.style.border=S.border?`1px solid ${S.border}`:"",(this.hasFocus()||p)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let u=null;return this.validation&&(u=this.validation(this.value),u?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(u)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),u?.type}stylesForType(u){switch(u){case 1:return{border:this.inputValidationInfoBorder,background:this.inputValidationInfoBackground,foreground:this.inputValidationInfoForeground};case 2:return{border:this.inputValidationWarningBorder,background:this.inputValidationWarningBackground,foreground:this.inputValidationWarningForeground};default:return{border:this.inputValidationErrorBorder,background:this.inputValidationErrorBackground,foreground:this.inputValidationErrorForeground}}}classForType(u){switch(u){case 1:return"info";case 2:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let u;const p=()=>u.style.width=E.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:T=>{if(!this.message)return null;u=E.append(T,e(".monaco-inputbox-container")),p();const _={inline:!0,className:"monaco-inputbox-message"},r=this.message.formatContent?(0,W.renderFormattedText)(this.message.content,_):(0,W.renderText)(this.message.content,_);r.classList.add(this.classForType(this.message.type));const n=this.stylesForType(this.message.type);return r.style.backgroundColor=n.background?n.background.toString():"",r.style.color=n.foreground?n.foreground.toString():"",r.style.border=n.border?`1px solid ${n.border}`:"",E.append(u,r),null},onHide:()=>{this.state="closed"},layout:p});let S;this.message.type===3?S=s.localize(0,null,this.message.content):this.message.type===2?S=s.localize(1,null,this.message.content):S=s.localize(2,null,this.message.content),C.alert(S),this.state="open"}_hideMessage(){!this.contextViewProvider||(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const u=this.value,S=u.charCodeAt(u.length-1)===10?" ":"";(u+S).replace(/\u000c/g,"")?this.mirror.textContent=u+S:this.mirror.innerText="\xA0",this.layout()}style(u){this.inputBackground=u.inputBackground,this.inputForeground=u.inputForeground,this.inputBorder=u.inputBorder,this.inputValidationInfoBackground=u.inputValidationInfoBackground,this.inputValidationInfoForeground=u.inputValidationInfoForeground,this.inputValidationInfoBorder=u.inputValidationInfoBorder,this.inputValidationWarningBackground=u.inputValidationWarningBackground,this.inputValidationWarningForeground=u.inputValidationWarningForeground,this.inputValidationWarningBorder=u.inputValidationWarningBorder,this.inputValidationErrorBackground=u.inputValidationErrorBackground,this.inputValidationErrorForeground=u.inputValidationErrorForeground,this.inputValidationErrorBorder=u.inputValidationErrorBorder,this.applyStyles()}applyStyles(){const u=this.inputBackground?this.inputBackground.toString():"",p=this.inputForeground?this.inputForeground.toString():"",S=this.inputBorder?this.inputBorder.toString():"";this.element.style.backgroundColor=u,this.element.style.color=p,this.input.style.backgroundColor="inherit",this.input.style.color=p,this.element.style.borderWidth=S?"1px":"",this.element.style.borderStyle=S?"solid":"",this.element.style.borderColor=S}layout(){if(!this.mirror)return;const u=this.cachedContentHeight;this.cachedContentHeight=E.getTotalHeight(this.mirror),u!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(u){const p=this.inputElement,S=p.selectionStart,T=p.selectionEnd,_=p.value;S!==null&&T!==null&&(this.value=_.substr(0,S)+u+_.substr(T),p.setSelectionRange(S+1,S+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}t.InputBox=w;class D extends w{constructor(u,p,S){const T=s.localize(3,null),_=` or \u21C5 ${T}`,r=` (\u21C5 ${T})`;super(u,p,S),this._onDidFocus=this._register(new g.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new g.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new L.HistoryNavigator(S.history,100);const n=()=>{if(S.showHistoryHint&&S.showHistoryHint()&&!this.placeholder.endsWith(_)&&!this.placeholder.endsWith(r)&&this.history.getHistory().length){const l=this.placeholder.endsWith(")")?_:r,b=this.placeholder+l;S.showPlaceholderOnFocus&&document.activeElement!==this.input?this.placeholder=b:this.setPlaceHolder(b)}};this.observer=new MutationObserver((l,b)=>{l.forEach(f=>{f.target.textContent||n()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>n()),this.onblur(this.input,()=>{const l=b=>{if(this.placeholder.endsWith(b)){const f=this.placeholder.slice(0,this.placeholder.length-b.length);return S.showPlaceholderOnFocus?this.placeholder=f:this.setPlaceHolder(f),!0}else return!1};l(r)||l(_)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(){this.value&&this.value!==this.getCurrentValue()&&this.history.add(this.value)}getHistory(){return this.history.getHistory()}showNextValue(){this.history.has(this.value)||this.addToHistory();let u=this.getNextValue();u&&(u=u===this.value?this.getNextValue():u),u&&(this.value=u,C.status(this.value))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let u=this.getPreviousValue();u&&(u=u===this.value?this.getPreviousValue():u),u&&(this.value=u,C.status(this.value))}clearHistory(){this.history.clear()}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let u=this.history.current();return u||(u=this.history.last(),this.history.next()),u}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()||this.history.last()}}t.HistoryInputBox=D}),define(pe[63],be([1,0,61,17,11,24,3,92]),function(Q,t,E,i,W,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=void 0;const y={inputActiveOptionBorder:O.Color.fromHex("#007ACC00"),inputActiveOptionForeground:O.Color.fromHex("#FFFFFF"),inputActiveOptionBackground:O.Color.fromHex("#0E639C50")};class d extends E.BaseActionViewItem{constructor(o,s,e){super(o,s,e),this.toggle=this._register(new c({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(o){this.element=o,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(o){this.toggle.domNode.tabIndex=o?0:-1}}t.ToggleActionViewItem=d;class c extends i.Widget{constructor(o){super(),this._onChange=this._register(new C.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new C.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts={...y,...o},this._checked=this._opts.isChecked;const s=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,s.push(...W.CSSIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&s.push(...this._opts.actionClassName.split(" ")),this._checked&&s.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this._opts.title,this.domNode.classList.add(...s),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,e=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),e.preventDefault())}),this.ignoreGesture(this.domNode),this.onkeydown(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this._checked,this._onChange.fire(!0),e.preventDefault(),e.stopPropagation();return}this._onKeyDown.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(o){this._checked=o,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(o){this._icon&&this.domNode.classList.remove(...W.CSSIcon.asClassNameArray(this._icon)),this._icon=o,this._icon&&this.domNode.classList.add(...W.CSSIcon.asClassNameArray(this._icon))}width(){return 2+2+2+16}style(o){o.inputActiveOptionBorder&&(this._opts.inputActiveOptionBorder=o.inputActiveOptionBorder),o.inputActiveOptionForeground&&(this._opts.inputActiveOptionForeground=o.inputActiveOptionForeground),o.inputActiveOptionBackground&&(this._opts.inputActiveOptionBackground=o.inputActiveOptionBackground),this.applyStyles()}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder?this._opts.inputActiveOptionBorder.toString():"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground?this._opts.inputActiveOptionForeground.toString():"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground?this._opts.inputActiveOptionBackground.toString():"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(o){this.domNode.title=o,this.domNode.setAttribute("aria-label",o)}}t.Toggle=c;class g extends i.Widget{constructor(o,s){super(),this.title=o,this.isChecked=s,this.checkbox=new c({title:this.title,isChecked:this.isChecked,icon:W.Codicon.check,actionClassName:"monaco-checkbox"}),this.domNode=this.checkbox.domNode,this.styles={},this.checkbox.onChange(()=>{this.applyStyles()})}get checked(){return this.checkbox.checked}set checked(o){this.checkbox.checked=o,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}style(o){this.styles=o,this.applyStyles()}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground?this.styles.checkboxForeground.toString():"",this.domNode.style.backgroundColor=this.styles.checkboxBackground?this.styles.checkboxBackground.toString():"",this.domNode.style.borderColor=this.styles.checkboxBorder?this.styles.checkboxBorder.toString():""}}t.Checkbox=g}),define(pe[125],be([1,0,63,11,97]),function(Q,t,E,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const O=W.localize(0,null),C=W.localize(1,null),y=W.localize(2,null);class d extends E.Toggle{constructor(o){super({icon:i.Codicon.caseSensitive,title:O+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.CaseSensitiveToggle=d;class c extends E.Toggle{constructor(o){super({icon:i.Codicon.wholeWord,title:C+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.WholeWordsToggle=c;class g extends E.Toggle{constructor(o){super({icon:i.Codicon.regex,title:y+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.RegexToggle=g}),define(pe[126],be([1,0,4,125,124,17,3,96,2,86]),function(Q,t,E,i,W,O,C,y,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const c=y.localize(0,null);class g extends O.Widget{constructor(o,s,e){super(),this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalTogglesDisposables=new d.DisposableStore,this.additionalToggles=[],this._onDidOptionChange=this._register(new C.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new C.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new C.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new C.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new C.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new C.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new C.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.placeholder=e.placeholder||"",this.validation=e.validation,this.label=e.label||c,this.showCommonFindToggles=!!e.showCommonFindToggles,this.inputActiveOptionBorder=e.inputActiveOptionBorder,this.inputActiveOptionForeground=e.inputActiveOptionForeground,this.inputActiveOptionBackground=e.inputActiveOptionBackground,this.inputBackground=e.inputBackground,this.inputForeground=e.inputForeground,this.inputBorder=e.inputBorder,this.inputValidationInfoBorder=e.inputValidationInfoBorder,this.inputValidationInfoBackground=e.inputValidationInfoBackground,this.inputValidationInfoForeground=e.inputValidationInfoForeground,this.inputValidationWarningBorder=e.inputValidationWarningBorder,this.inputValidationWarningBackground=e.inputValidationWarningBackground,this.inputValidationWarningForeground=e.inputValidationWarningForeground,this.inputValidationErrorBorder=e.inputValidationErrorBorder,this.inputValidationErrorBackground=e.inputValidationErrorBackground,this.inputValidationErrorForeground=e.inputValidationErrorForeground;const m=e.appendCaseSensitiveLabel||"",v=e.appendWholeWordsLabel||"",w=e.appendRegexLabel||"",D=e.history||[],a=!!e.flexibleHeight,u=!!e.flexibleWidth,p=e.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new W.HistoryInputBox(this.domNode,s,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder,history:D,showHistoryHint:e.showHistoryHint,flexibleHeight:a,flexibleWidth:u,flexibleMaxHeight:p})),this.regex=this._register(new i.RegexToggle({appendTitle:w,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.regex.onChange(T=>{this._onDidOptionChange.fire(T),!T&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(T=>{this._onRegexKeyDown.fire(T)})),this.wholeWords=this._register(new i.WholeWordsToggle({appendTitle:v,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.wholeWords.onChange(T=>{this._onDidOptionChange.fire(T),!T&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new i.CaseSensitiveToggle({appendTitle:m,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.caseSensitive.onChange(T=>{this._onDidOptionChange.fire(T),!T&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(T=>{this._onCaseSensitiveKeyDown.fire(T)}));const S=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,T=>{if(T.equals(15)||T.equals(17)||T.equals(9)){const _=S.indexOf(document.activeElement);if(_>=0){let r=-1;T.equals(17)?r=(_+1)%S.length:T.equals(15)&&(_===0?r=S.length-1:r=_-1),T.equals(9)?(S[_].blur(),this.inputBox.focus()):r>=0&&S[r].focus(),E.EventHelper.stop(T,!0)}}}),this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this.showCommonFindToggles?"block":"none",this.controls.appendChild(this.caseSensitive.domNode),this.controls.appendChild(this.wholeWords.domNode),this.controls.appendChild(this.regex.domNode),this.showCommonFindToggles||(this.caseSensitive.domNode.style.display="none",this.wholeWords.domNode.style.display="none",this.regex.domNode.style.display="none"),this.setAdditionalToggles(e?.additionalToggles),this.domNode.appendChild(this.controls),o?.appendChild(this.domNode),this._register(E.addDisposableListener(this.inputBox.inputElement,"compositionstart",T=>{this.imeSessionInProgress=!0})),this._register(E.addDisposableListener(this.inputBox.inputElement,"compositionend",T=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,T=>this._onKeyDown.fire(T)),this.onkeyup(this.inputBox.inputElement,T=>this._onKeyUp.fire(T)),this.oninput(this.inputBox.inputElement,T=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,T=>this._onMouseDown.fire(T))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex.enable(),this.wholeWords.enable(),this.caseSensitive.enable();for(const o of this.additionalToggles)o.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex.disable(),this.wholeWords.disable(),this.caseSensitive.disable();for(const o of this.additionalToggles)o.disable()}setFocusInputOnOptionClick(o){this.fixFocusOnOptionClickEnabled=o}setEnabled(o){o?this.enable():this.disable()}setAdditionalToggles(o){for(const s of this.additionalToggles)s.domNode.remove();this.additionalToggles=[],this.additionalTogglesDisposables.dispose(),this.additionalTogglesDisposables=new d.DisposableStore;for(const s of o??[])this.additionalTogglesDisposables.add(s),this.controls.appendChild(s.domNode),this.additionalTogglesDisposables.add(s.onChange(e=>{this._onDidOptionChange.fire(e),!e&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(s);this.additionalToggles.length>0&&(this.controls.style.display="block"),this.inputBox.paddingRight=(this.showCommonFindToggles?this.caseSensitive.width()+this.wholeWords.width()+this.regex.width():0)+this.additionalToggles.reduce((s,e)=>s+e.width(),0)}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(o){this.inputBox.value!==o&&(this.inputBox.value=o)}onSearchSubmit(){this.inputBox.addToHistory()}style(o){this.inputActiveOptionBorder=o.inputActiveOptionBorder,this.inputActiveOptionForeground=o.inputActiveOptionForeground,this.inputActiveOptionBackground=o.inputActiveOptionBackground,this.inputBackground=o.inputBackground,this.inputForeground=o.inputForeground,this.inputBorder=o.inputBorder,this.inputValidationInfoBackground=o.inputValidationInfoBackground,this.inputValidationInfoForeground=o.inputValidationInfoForeground,this.inputValidationInfoBorder=o.inputValidationInfoBorder,this.inputValidationWarningBackground=o.inputValidationWarningBackground,this.inputValidationWarningForeground=o.inputValidationWarningForeground,this.inputValidationWarningBorder=o.inputValidationWarningBorder,this.inputValidationErrorBackground=o.inputValidationErrorBackground,this.inputValidationErrorForeground=o.inputValidationErrorForeground,this.inputValidationErrorBorder=o.inputValidationErrorBorder,this.applyStyles()}applyStyles(){if(this.domNode){const o={inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground};this.regex.style(o),this.wholeWords.style(o),this.caseSensitive.style(o);for(const e of this.additionalToggles)e.style(o);const s={inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder};this.inputBox.style(s)}}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive.checked}setCaseSensitive(o){this.caseSensitive.checked=o}getWholeWords(){return this.wholeWords.checked}setWholeWords(o){this.wholeWords.checked=o}getRegex(){return this.regex.checked}setRegex(o){this.regex.checked=o,this.validate()}focusOnCaseSensitive(){this.caseSensitive.focus()}focusOnRegex(){this.regex.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(o){this.inputBox.showMessage(o)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=g,g.OPTION_CHANGE="optionChange"}),define(pe[127],be([1,0,4,18,19,62,126,58,59,63,55,23,32,14,8,11,69,3,33,2,45,6,101,93]),function(Q,t,E,i,W,O,C,y,d,c,g,L,o,s,e,m,v,w,D,a,u,p,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMode=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class T extends y.ElementsDragAndDropData{set context(F){this.data.context=F}get context(){return this.data.context}constructor(F){super(F.elements.map(V=>V.element)),this.data=F}}function _(ne){return ne instanceof y.ElementsDragAndDropData?new T(ne):ne}class r{constructor(F,V){this.modelProvider=F,this.dnd=V,this.autoExpandDisposable=a.Disposable.None}getDragURI(F){return this.dnd.getDragURI(F.element)}getDragLabel(F,V){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(F.map(j=>j.element),V)}onDragStart(F,V){this.dnd.onDragStart?.(_(F),V)}onDragOver(F,V,j,k,h=!0){const I=this.dnd.onDragOver(_(F),V&&V.element,j,k),U=this.autoExpandNode!==V;if(U&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=V),typeof V>"u")return I;if(U&&typeof I!="boolean"&&I.autoExpand&&(this.autoExpandDisposable=(0,e.disposableTimeout)(()=>{const H=this.modelProvider(),A=H.getNodeLocation(V);H.isCollapsed(A)&&H.setCollapsed(A,!1),this.autoExpandNode=void 0},500)),typeof I=="boolean"||!I.accept||typeof I.bubble>"u"||I.feedback){if(!h){const H=typeof I=="boolean"?I:I.accept,A=typeof I=="boolean"?void 0:I.effect;return{accept:H,effect:A,feedback:[j]}}return I}if(I.bubble===1){const H=this.modelProvider(),A=H.getNodeLocation(V),P=H.getParentNodeLocation(A),M=H.getNode(P),B=P&&H.getListIndex(P);return this.onDragOver(F,M,B,k,!1)}const K=this.modelProvider(),Z=K.getNodeLocation(V),N=K.getListIndex(Z),R=K.getListRenderCount(Z);return{...I,feedback:(0,s.range)(N,N+R)}}drop(F,V,j,k){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(_(F),V&&V.element,j,k)}onDragEnd(F){this.dnd.onDragEnd?.(F)}}function n(ne,F){return F&&{...F,identityProvider:F.identityProvider&&{getId(V){return F.identityProvider.getId(V.element)}},dnd:F.dnd&&new r(ne,F.dnd),multipleSelectionController:F.multipleSelectionController&&{isSelectionSingleChangeEvent(V){return F.multipleSelectionController.isSelectionSingleChangeEvent({...V,element:V.element})},isSelectionRangeChangeEvent(V){return F.multipleSelectionController.isSelectionRangeChangeEvent({...V,element:V.element})}},accessibilityProvider:F.accessibilityProvider&&{...F.accessibilityProvider,getSetSize(V){const j=ne(),k=j.getNodeLocation(V),h=j.getParentNodeLocation(k);return j.getNode(h).visibleChildrenCount},getPosInSet(V){return V.visibleChildIndex+1},isChecked:F.accessibilityProvider&&F.accessibilityProvider.isChecked?V=>F.accessibilityProvider.isChecked(V.element):void 0,getRole:F.accessibilityProvider&&F.accessibilityProvider.getRole?V=>F.accessibilityProvider.getRole(V.element):()=>"treeitem",getAriaLabel(V){return F.accessibilityProvider.getAriaLabel(V.element)},getWidgetAriaLabel(){return F.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:F.accessibilityProvider&&F.accessibilityProvider.getWidgetRole?()=>F.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:F.accessibilityProvider&&F.accessibilityProvider.getAriaLevel?V=>F.accessibilityProvider.getAriaLevel(V.element):V=>V.depth,getActiveDescendantId:F.accessibilityProvider.getActiveDescendantId&&(V=>F.accessibilityProvider.getActiveDescendantId(V.element))},keyboardNavigationLabelProvider:F.keyboardNavigationLabelProvider&&{...F.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(V){return F.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(V.element)}}}}class l{constructor(F){this.delegate=F}getHeight(F){return this.delegate.getHeight(F.element)}getTemplateId(F){return this.delegate.getTemplateId(F.element)}hasDynamicHeight(F){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(F.element)}setDynamicHeight(F,V){this.delegate.setDynamicHeight?.(F.element,V)}}t.ComposedTreeDelegate=l;class b{static lift(F){return F instanceof b?F:new b(F)}static empty(F=0){return new b({focus:[],selection:[],expanded:Object.create(null),scrollTop:F})}constructor(F){if(this.focus=new Set(F.focus),this.selection=new Set(F.selection),F.expanded instanceof Array){this.expanded=Object.create(null);for(const V of F.expanded)this.expanded[V]=1}else this.expanded=F.expanded;this.expanded=F.expanded,this.scrollTop=F.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=b;var f;(function(ne){ne.None="none",ne.OnHover="onHover",ne.Always="always"})(f=t.RenderIndentGuides||(t.RenderIndentGuides={}));class z{get elements(){return this._elements}constructor(F,V=[]){this._elements=V,this.disposables=new a.DisposableStore,this.onDidChange=w.Event.forEach(F,j=>this._elements=j,this.disposables)}dispose(){this.disposables.dispose()}}class ${constructor(F,V,j,k,h={}){this.renderer=F,this.modelProvider=V,this.activeNodes=k,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=$.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.renderedIndentGuides=new v.SetMap,this.activeIndentNodes=new Set,this.indentGuidesDisposable=a.Disposable.None,this.disposables=new a.DisposableStore,this.templateId=F.templateId,this.updateOptions(h),w.Event.map(j,I=>I.node)(this.onDidChangeNodeTwistieState,this,this.disposables),F.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(F={}){if(typeof F.indent<"u"&&(this.indent=(0,u.clamp)(F.indent,0,40)),typeof F.renderIndentGuides<"u"){const V=F.renderIndentGuides!==f.None;if(V!==this.shouldRenderIndentGuides&&(this.shouldRenderIndentGuides=V,this.indentGuidesDisposable.dispose(),V)){const j=new a.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,j),this.indentGuidesDisposable=j,this._onDidChangeActiveNodes(this.activeNodes.elements)}}typeof F.hideTwistiesOfChildlessElements<"u"&&(this.hideTwistiesOfChildlessElements=F.hideTwistiesOfChildlessElements)}renderTemplate(F){const V=(0,E.append)(F,(0,E.$)(".monaco-tl-row")),j=(0,E.append)(V,(0,E.$)(".monaco-tl-indent")),k=(0,E.append)(V,(0,E.$)(".monaco-tl-twistie")),h=(0,E.append)(V,(0,E.$)(".monaco-tl-contents")),I=this.renderer.renderTemplate(h);return{container:F,indent:j,twistie:k,indentGuidesDisposable:a.Disposable.None,templateData:I}}renderElement(F,V,j,k){typeof k=="number"&&(this.renderedNodes.set(F,{templateData:j,height:k}),this.renderedElements.set(F.element,F));const h=$.DefaultIndent+(F.depth-1)*this.indent;j.twistie.style.paddingLeft=`${h}px`,j.indent.style.width=`${h+this.indent-16}px`,this.renderTwistie(F,j),typeof k=="number"&&this.renderIndentGuides(F,j),this.renderer.renderElement(F,V,j.templateData,k)}disposeElement(F,V,j,k){j.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(F,V,j.templateData,k),typeof k=="number"&&(this.renderedNodes.delete(F),this.renderedElements.delete(F.element))}disposeTemplate(F){this.renderer.disposeTemplate(F.templateData)}onDidChangeTwistieState(F){const V=this.renderedElements.get(F);!V||this.onDidChangeNodeTwistieState(V)}onDidChangeNodeTwistieState(F){const V=this.renderedNodes.get(F);!V||(this.renderTwistie(F,V.templateData),this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderIndentGuides(F,V.templateData))}renderTwistie(F,V){V.twistie.classList.remove(...m.Codicon.treeItemExpanded.classNamesArray);let j=!1;this.renderer.renderTwistie&&(j=this.renderer.renderTwistie(F.element,V.twistie)),F.collapsible&&(!this.hideTwistiesOfChildlessElements||F.visibleChildrenCount>0)?(j||V.twistie.classList.add(...m.Codicon.treeItemExpanded.classNamesArray),V.twistie.classList.add("collapsible"),V.twistie.classList.toggle("collapsed",F.collapsed)):V.twistie.classList.remove("collapsible","collapsed"),F.collapsible?V.container.setAttribute("aria-expanded",String(!F.collapsed)):V.container.removeAttribute("aria-expanded")}renderIndentGuides(F,V){if((0,E.clearNode)(V.indent),V.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const j=new a.DisposableStore,k=this.modelProvider();let h=F;for(;;){const I=k.getNodeLocation(h),U=k.getParentNodeLocation(I);if(!U)break;const K=k.getNode(U),Z=(0,E.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(K)&&Z.classList.add("active"),V.indent.childElementCount===0?V.indent.appendChild(Z):V.indent.insertBefore(Z,V.indent.firstElementChild),this.renderedIndentGuides.add(K,Z),j.add((0,a.toDisposable)(()=>this.renderedIndentGuides.delete(K,Z))),h=K}V.indentGuidesDisposable=j}_onDidChangeActiveNodes(F){if(!this.shouldRenderIndentGuides)return;const V=new Set,j=this.modelProvider();F.forEach(k=>{const h=j.getNodeLocation(k);try{const I=j.getParentNodeLocation(h);k.collapsible&&k.children.length>0&&!k.collapsed?V.add(k):I&&V.add(j.getNode(I))}catch{}}),this.activeIndentNodes.forEach(k=>{V.has(k)||this.renderedIndentGuides.forEach(k,h=>h.classList.remove("active"))}),V.forEach(k=>{this.activeIndentNodes.has(k)||this.renderedIndentGuides.forEach(k,h=>h.classList.add("active"))}),this.activeIndentNodes=V}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,a.dispose)(this.disposables)}}$.DefaultIndent=8;class X{get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(F){this._pattern=F,this._lowercasePattern=F.toLowerCase()}constructor(F,V,j){this.tree=F,this.keyboardNavigationLabelProvider=V,this._filter=j,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new a.DisposableStore,F.onWillRefilter(this.reset,this,this.disposables)}filter(F,V){let j=1;if(this._filter){const I=this._filter.filter(F,V);if(typeof I=="boolean"?j=I?1:0:(0,g.isFilterResult)(I)?j=(0,g.getVisibleState)(I.visibility):j=I,j===0)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:D.FuzzyScore.Default,visibility:j};const k=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(F),h=Array.isArray(k)?k:[k];for(const I of h){const U=I&&I.toString();if(typeof U>"u")return{data:D.FuzzyScore.Default,visibility:j};const K=(0,D.fuzzyScore)(this._pattern,this._lowercasePattern,0,U,U.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(K)return this._matchCount++,h.length===1?{data:K,visibility:j}:{data:{label:U,score:K},visibility:j}}return this.tree.findMode===ge.Filter?2:{data:D.FuzzyScore.Default,visibility:j}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,a.dispose)(this.disposables)}}class J extends c.Toggle{constructor(F){super({icon:m.Codicon.listFilter,title:(0,S.localize)(0,null),isChecked:F?.isChecked??!1,inputActiveOptionBorder:F?.inputActiveOptionBorder,inputActiveOptionForeground:F?.inputActiveOptionForeground,inputActiveOptionBackground:F?.inputActiveOptionBackground})}}t.ModeToggle=J;var ge;(function(ne){ne[ne.Highlight=0]="Highlight",ne[ne.Filter=1]="Filter"})(ge=t.TreeFindMode||(t.TreeFindMode={}));class re extends a.Disposable{set mode(F){this.modeToggle.checked=F===ge.Filter,this.findInput.inputBox.setPlaceHolder(F===ge.Filter?(0,S.localize)(1,null):(0,S.localize)(2,null))}constructor(F,V,j,k,h){super(),this.tree=V,this.elements=(0,E.h)(".monaco-tree-type-filter",[(0,E.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,E.h)(".monaco-tree-type-filter-input@findInput"),(0,E.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this._onDidDisable=new w.Emitter,this.onDidDisable=this._onDidDisable.event,F.appendChild(this.elements.root),this._register((0,a.toDisposable)(()=>F.removeChild(this.elements.root))),this.modeToggle=this._register(new J({...h,isChecked:k===ge.Filter})),this.onDidChangeMode=w.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?ge.Filter:ge.Highlight,this._store),this.findInput=this._register(new C.FindInput(this.elements.findInput,j,{label:(0,S.localize)(3,null),additionalToggles:[this.modeToggle],showCommonFindToggles:!1})),this.actionbar=this._register(new O.ActionBar(this.elements.actionbar)),this.mode=k;const I=this._register(new i.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),U=this._register(w.Event.chain(I.event)).map(R=>new W.StandardKeyboardEvent(R)).event;this._register(U(R=>{switch(R.keyCode){case 18:R.preventDefault(),R.stopPropagation(),this.tree.domFocus();return}}));const K=this._register(new o.Action("close",(0,S.localize)(4,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(K,{icon:!0,label:!1});const Z=this._register(new i.DomEmitter(this.elements.grab,"mousedown"));this._register(Z.event(R=>{const H=new a.DisposableStore,A=H.add(new i.DomEmitter(window,"mousemove")),P=H.add(new i.DomEmitter(window,"mouseup")),M=this.right,B=R.pageX;this.elements.grab.classList.add("grabbing");const q=ee=>{const le=ee.pageX-B;this.right=M-le,this.layout()};H.add(A.event(q)),H.add(P.event(ee=>{q(ee),this.elements.grab.classList.remove("grabbing"),H.dispose()}))}));const N=this._register(w.Event.chain(this._register(new i.DomEmitter(this.elements.grab,"keydown")).event)).map(R=>new W.StandardKeyboardEvent(R)).event;this._register(N(R=>{let H;R.keyCode===15?H=Number.POSITIVE_INFINITY:R.keyCode===17?H=0:R.keyCode===10&&(H=this.right===0?Number.POSITIVE_INFINITY:0),H!==void 0&&(R.preventDefault(),R.stopPropagation(),this.right=H,this.layout())})),this.onDidChangeValue=this.findInput.onDidChange,this.style(h??{})}style(F){this.findInput.style(F),F.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=F.listFilterWidgetBackground.toString()),F.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${F.listFilterWidgetShadow}`)}focus(){this.findInput.focus()}select(){this.findInput.select()}layout(F=this.width){this.width=F,this.right=(0,u.clamp)(this.right,0,Math.max(0,F-212)),this.elements.root.style.right=`${this.right}px`}showMessage(F){this.findInput.showMessage(F)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,e.timeout)(300),super.dispose()}}class me{get pattern(){return this._pattern}get mode(){return this._mode}set mode(F){F!==this._mode&&(this._mode=F,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(F))}constructor(F,V,j,k,h){this.tree=F,this.view=j,this.filter=k,this.contextViewProvider=h,this._pattern="",this.width=0,this._onDidChangeMode=new w.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangePattern=new w.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new w.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new a.DisposableStore,this.disposables=new a.DisposableStore,this._mode=F.options.defaultFindMode??ge.Highlight,V.onDidSplice(this.onDidSpliceModel,this,this.disposables)}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.mode=this.tree.options.defaultFindMode??ge.Highlight,this.widget=new re(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.styles),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(F=>this.mode=F,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this._onDidChangeOpenState.fire(!0)}close(){!this.widget||(this.widget=void 0,this.enabledDisposables.dispose(),this.enabledDisposables=new a.DisposableStore,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(F){this._pattern=F,this._onDidChangePattern.fire(F),this.filter.pattern=F,this.tree.refilter(),F&&this.tree.focusNext(0,!0,void 0,j=>!D.FuzzyScore.isDefault(j.filterData));const V=this.tree.getFocus();if(V.length>0){const j=V[0];this.tree.getRelativeTop(j)===null&&this.tree.reveal(j,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const F=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&F?this.widget?.showMessage({type:2,content:(0,S.localize)(5,null)}):this.widget?.clearMessage()}shouldAllowFocus(F){return!this.widget||!this.pattern||this._mode===ge.Filter||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!D.FuzzyScore.isDefault(F.filterData)}style(F){this.styles=F,this.widget?.style(F)}layout(F){this.width=F,this.widget?.layout(F)}dispose(){this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function ae(ne){let F=L.TreeMouseEventTarget.Unknown;return(0,E.hasParentWithClass)(ne.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?F=L.TreeMouseEventTarget.Twistie:(0,E.hasParentWithClass)(ne.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?F=L.TreeMouseEventTarget.Element:(0,E.hasParentWithClass)(ne.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(F=L.TreeMouseEventTarget.Filter),{browserEvent:ne.browserEvent,element:ne.element?ne.element.element:null,target:F}}function he(ne){return{element:ne.element?ne.element.element:null,browserEvent:ne.browserEvent,anchor:ne.anchor}}function Se(ne,F){F(ne),ne.children.forEach(V=>Se(V,F))}class te{get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}constructor(F,V){this.getFirstViewElementWithTrait=F,this.identityProvider=V,this.nodes=[],this._onDidChange=new w.Emitter,this.onDidChange=this._onDidChange.event}set(F,V){!V?.__forceEvent&&(0,s.equals)(this.nodes,F)||this._set(F,!1,V)}_set(F,V,j){if(this.nodes=[...F],this.elements=void 0,this._nodeSet=void 0,!V){const k=this;this._onDidChange.fire({get elements(){return k.get()},browserEvent:j})}}get(){return this.elements||(this.elements=this.nodes.map(F=>F.element)),[...this.elements]}getNodes(){return this.nodes}has(F){return this.nodeSet.has(F)}onDidModelSplice({insertedNodes:F,deletedNodes:V}){if(!this.identityProvider){const K=this.createNodeSet(),Z=N=>K.delete(N);V.forEach(N=>Se(N,Z)),this.set([...K.values()]);return}const j=new Set,k=K=>j.add(this.identityProvider.getId(K.element).toString());V.forEach(K=>Se(K,k));const h=new Map,I=K=>h.set(this.identityProvider.getId(K.element).toString(),K);F.forEach(K=>Se(K,I));const U=[];for(const K of this.nodes){const Z=this.identityProvider.getId(K.element).toString();if(!j.has(Z))U.push(K);else{const R=h.get(Z);R&&U.push(R)}}if(this.nodes.length>0&&U.length===0){const K=this.getFirstViewElementWithTrait();K&&U.push(K)}this._set(U,!0)}createNodeSet(){const F=new Set;for(const V of this.nodes)F.add(V);return F}}class De extends d.MouseController{constructor(F,V){super(F),this.tree=V}onViewPointer(F){if((0,d.isButton)(F.browserEvent.target)||(0,d.isInputElement)(F.browserEvent.target)||(0,d.isMonacoEditor)(F.browserEvent.target))return;const V=F.element;if(!V)return super.onViewPointer(F);if(this.isSelectionRangeChangeEvent(F)||this.isSelectionSingleChangeEvent(F))return super.onViewPointer(F);const j=F.browserEvent.target,k=j.classList.contains("monaco-tl-twistie")||j.classList.contains("monaco-icon-label")&&j.classList.contains("folder-icon")&&F.browserEvent.offsetX<16;let h=!1;if(typeof this.tree.expandOnlyOnTwistieClick=="function"?h=this.tree.expandOnlyOnTwistieClick(V.element):h=!!this.tree.expandOnlyOnTwistieClick,h&&!k&&F.browserEvent.detail!==2)return super.onViewPointer(F);if(!this.tree.expandOnDoubleClick&&F.browserEvent.detail===2)return super.onViewPointer(F);if(V.collapsible){const I=this.tree.model,U=I.getNodeLocation(V),K=F.browserEvent.altKey;if(this.tree.setFocus([U]),I.setCollapsed(U,void 0,K),h&&k)return}super.onViewPointer(F)}onDoubleClick(F){F.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||super.onDoubleClick(F)}}class se extends d.List{constructor(F,V,j,k,h,I,U,K){super(F,V,j,k,K),this.focusTrait=h,this.selectionTrait=I,this.anchorTrait=U}createMouseController(F){return new De(this,F.tree)}splice(F,V,j=[]){if(super.splice(F,V,j),j.length===0)return;const k=[],h=[];let I;j.forEach((U,K)=>{this.focusTrait.has(U)&&k.push(F+K),this.selectionTrait.has(U)&&h.push(F+K),this.anchorTrait.has(U)&&(I=F+K)}),k.length>0&&super.setFocus((0,s.distinct)([...super.getFocus(),...k])),h.length>0&&super.setSelection((0,s.distinct)([...super.getSelection(),...h])),typeof I=="number"&&super.setAnchor(I)}setFocus(F,V,j=!1){super.setFocus(F,V),j||this.focusTrait.set(F.map(k=>this.element(k)),V)}setSelection(F,V,j=!1){super.setSelection(F,V),j||this.selectionTrait.set(F.map(k=>this.element(k)),V)}setAnchor(F,V=!1){super.setAnchor(F),V||(typeof F>"u"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(F)]))}}class ie{get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return w.Event.map(this.view.onMouseClick,ae)}get onMouseDblClick(){return w.Event.filter(w.Event.map(this.view.onMouseDblClick,ae),F=>F.target!==L.TreeMouseEventTarget.Filter)}get onContextMenu(){return w.Event.map(this.view.onContextMenu,he)}get onTap(){return w.Event.map(this.view.onTap,ae)}get onPointer(){return w.Event.map(this.view.onPointer,ae)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return w.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??ge.Highlight}set findMode(F){this.findController&&(this.findController.mode=F)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:w.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick>"u"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick>"u"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}constructor(F,V,j,k,h={}){this._user=F,this._options=h,this.eventBufferer=new w.EventBufferer,this.onDidChangeFindOpenState=w.Event.None,this.disposables=new a.DisposableStore,this._onWillRefilter=new w.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new w.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event;const I=new l(j),U=new w.Relay,K=new w.Relay,Z=this.disposables.add(new z(K.event));this.renderers=k.map(H=>new $(H,()=>this.model,U.event,Z,h));for(const H of this.renderers)this.disposables.add(H);let N;h.keyboardNavigationLabelProvider&&(N=new X(this,h.keyboardNavigationLabelProvider,h.filter),h={...h,filter:N},this.disposables.add(N)),this.focus=new te(()=>this.view.getFocusedElements()[0],h.identityProvider),this.selection=new te(()=>this.view.getSelectedElements()[0],h.identityProvider),this.anchor=new te(()=>this.view.getAnchorElement(),h.identityProvider),this.view=new se(F,V,I,this.renderers,this.focus,this.selection,this.anchor,{...n(()=>this.model,h),tree:this}),this.model=this.createModel(F,this.view,h),U.input=this.model.onDidChangeCollapseState;const R=w.Event.forEach(this.model.onDidSplice,H=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(H),this.selection.onDidModelSplice(H)})},this.disposables);if(R(()=>null,null,this.disposables),K.input=w.Event.chain(w.Event.any(R,this.focus.onDidChange,this.selection.onDidChange)).debounce(()=>null,0).map(()=>{const H=new Set;for(const A of this.focus.getNodes())H.add(A);for(const A of this.selection.getNodes())H.add(A);return[...H.values()]}).event,h.keyboardSupport!==!1){const H=w.Event.chain(this.view.onKeyDown).filter(A=>!(0,d.isInputElement)(A.target)).map(A=>new W.StandardKeyboardEvent(A));H.filter(A=>A.keyCode===15).on(this.onLeftArrow,this,this.disposables),H.filter(A=>A.keyCode===17).on(this.onRightArrow,this,this.disposables),H.filter(A=>A.keyCode===10).on(this.onSpace,this,this.disposables)}(h.findWidgetEnabled??!0)&&h.keyboardNavigationLabelProvider&&h.contextViewProvider?(this.findController=new me(this,this.model,this.view,N,h.contextViewProvider),this.focusNavigationFilter=H=>this.findController.shouldAllowFocus(H),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode):this.onDidChangeFindMode=w.Event.None,this.styleElement=(0,E.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===f.Always)}updateOptions(F={}){this._options={...this._options,...F};for(const V of this.renderers)V.updateOptions(F);this.view.updateOptions(this._options),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===f.Always)}get options(){return this._options}updateWidth(F){const V=this.model.getListIndex(F);V!==-1&&this.view.updateWidth(V)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.scrollTop}set scrollTop(F){this.view.scrollTop=F}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(F){this.view.scrollLeft=F}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){const F=this.view.firstVisibleIndex;return F<0||F>=this.view.length?void 0:this.view.element(F).element}get lastVisibleElement(){const F=this.view.lastVisibleIndex;return this.view.element(F).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(F){this.view.ariaLabel=F}domFocus(){this.view.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(F,V){this.view.layout(F,V),(0,p.isNumber)(V)&&this.findController?.layout(V)}style(F){const V=`.${this.view.domId}`,j=[];F.treeIndentGuidesStroke&&(j.push(`.monaco-list${V}:hover .monaco-tl-indent > .indent-guide, .monaco-list${V}.always .monaco-tl-indent > .indent-guide  { border-color: ${F.treeIndentGuidesStroke.transparent(.4)}; }`),j.push(`.monaco-list${V} .monaco-tl-indent > .indent-guide.active { border-color: ${F.treeIndentGuidesStroke}; }`)),this.styleElement.textContent=j.join(`
`),this.findController?.style(F),this.view.style(F)}getParentElement(F){const V=this.model.getParentNodeLocation(F);return this.model.getNode(V).element}getFirstElementChild(F){return this.model.getFirstElementChild(F)}getNode(F){return this.model.getNode(F)}collapse(F,V=!1){return this.model.setCollapsed(F,!0,V)}expand(F,V=!1){return this.model.setCollapsed(F,!1,V)}toggleCollapsed(F,V=!1){return this.model.setCollapsed(F,void 0,V)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(F){return this.model.isCollapsible(F)}setCollapsible(F,V){return this.model.setCollapsible(F,V)}isCollapsed(F){return this.model.isCollapsed(F)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(F){if(typeof F>"u")return this.view.setAnchor(void 0);const V=this.model.getNode(F);this.anchor.set([V]);const j=this.model.getListIndex(F);j>-1&&this.view.setAnchor(j,!0)}getAnchor(){return(0,s.firstOrDefault)(this.anchor.get(),void 0)}setSelection(F,V){const j=F.map(h=>this.model.getNode(h));this.selection.set(j,V);const k=F.map(h=>this.model.getListIndex(h)).filter(h=>h>-1);this.view.setSelection(k,V,!0)}getSelection(){return this.selection.get()}setFocus(F,V){const j=F.map(h=>this.model.getNode(h));this.focus.set(j,V);const k=F.map(h=>this.model.getListIndex(h)).filter(h=>h>-1);this.view.setFocus(k,V,!0)}focusNext(F=1,V=!1,j,k=this.focusNavigationFilter){this.view.focusNext(F,V,j,k)}focusPrevious(F=1,V=!1,j,k=this.focusNavigationFilter){this.view.focusPrevious(F,V,j,k)}focusNextPage(F,V=this.focusNavigationFilter){return this.view.focusNextPage(F,V)}focusPreviousPage(F,V=this.focusNavigationFilter){return this.view.focusPreviousPage(F,V)}focusLast(F,V=this.focusNavigationFilter){this.view.focusLast(F,V)}focusFirst(F,V=this.focusNavigationFilter){this.view.focusFirst(F,V)}getFocus(){return this.focus.get()}reveal(F,V){this.model.expandTo(F);const j=this.model.getListIndex(F);j!==-1&&this.view.reveal(j,V)}getRelativeTop(F){const V=this.model.getListIndex(F);return V===-1?null:this.view.getRelativeTop(V)}getViewState(F=this.options.identityProvider){if(!F)throw new L.TreeError(this._user,"Can't get tree view state without an identity provider");const V=I=>F.getId(I).toString(),j=b.empty(this.scrollTop);for(const I of this.getFocus())j.focus.add(V(I));for(const I of this.getSelection())j.selection.add(V(I));const k=this.model.getNode(),h=[k];for(;h.length>0;){const I=h.shift();I!==k&&I.collapsible&&(j.expanded[V(I.element)]=I.collapsed?0:1),h.push(...I.children)}return j}onLeftArrow(F){F.preventDefault(),F.stopPropagation();const V=this.view.getFocusedElements();if(V.length===0)return;const j=V[0],k=this.model.getNodeLocation(j);if(!this.model.setCollapsed(k,!0)){const I=this.model.getParentNodeLocation(k);if(!I)return;const U=this.model.getListIndex(I);this.view.reveal(U),this.view.setFocus([U])}}onRightArrow(F){F.preventDefault(),F.stopPropagation();const V=this.view.getFocusedElements();if(V.length===0)return;const j=V[0],k=this.model.getNodeLocation(j);if(!this.model.setCollapsed(k,!1)){if(!j.children.some(K=>K.visible))return;const[I]=this.view.getFocus(),U=I+1;this.view.reveal(U),this.view.setFocus([U])}}onSpace(F){F.preventDefault(),F.stopPropagation();const V=this.view.getFocusedElements();if(V.length===0)return;const j=V[0],k=this.model.getNodeLocation(j),h=F.browserEvent.altKey;this.model.setCollapsed(k,void 0,h)}navigate(F){return new ce(this.view,this.model,F)}dispose(){(0,a.dispose)(this.disposables),this.view.dispose()}}t.AbstractTree=ie;class ce{constructor(F,V,j){this.view=F,this.model=V,j?this.index=this.model.getListIndex(j):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(pe[128],be([1,0,127,117,23,26]),function(Q,t,E,i,W,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class C extends E.AbstractTree{constructor(d,c,g,L,o,s={}){super(d,c,g,L,s),this.user=d,this.dataSource=o,this.nodesByIdentity=new Map,this.identityProvider=s.identityProvider}getInput(){return this.input}setInput(d,c){if(c&&!this.identityProvider)throw new W.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=d,!d){this.nodesByIdentity.clear(),this.model.setChildren(null,O.Iterable.empty());return}if(!c){this._refresh(d);return}const g=[],L=[],o=e=>{const m=this.identityProvider.getId(e).toString();return!c.expanded[m]},s=e=>{const m=this.identityProvider.getId(e.element).toString();c.focus.has(m)&&g.push(e.element),c.selection.has(m)&&L.push(e.element)};this._refresh(d,o,s),this.setFocus(g),this.setSelection(L),c&&typeof c.scrollTop=="number"&&(this.scrollTop=c.scrollTop)}updateChildren(d=this.input){if(typeof this.input>"u")throw new W.TreeError(this.user,"Tree input not set");let c;this.identityProvider&&(c=g=>{const L=this.identityProvider.getId(g).toString(),o=this.nodesByIdentity.get(L);if(!!o)return o.collapsed}),this._refresh(d,c)}resort(d=this.input,c=!0){this.model.resort(d===this.input?null:d,c)}refresh(d){if(d===void 0){this.view.rerender();return}this.model.rerender(d)}_refresh(d,c,g){let L;if(this.identityProvider){const o=new Set,s=g;g=e=>{const m=this.identityProvider.getId(e.element).toString();o.add(m),this.nodesByIdentity.set(m,e),s?.(e)},L=e=>{const m=this.identityProvider.getId(e.element).toString();o.has(m)||this.nodesByIdentity.delete(m)}}this.model.setChildren(d===this.input?null:d,this.iterate(d,c).elements,{onDidCreateNode:g,onDidDeleteNode:L})}iterate(d,c){const g=[...this.dataSource.getChildren(d)];return{elements:O.Iterable.map(g,o=>{const{elements:s,size:e}=this.iterate(o,c),m=this.dataSource.hasChildren?this.dataSource.hasChildren(o):void 0,v=e===0?void 0:c&&c(o);return{element:o,children:s,collapsible:m,collapsed:v}}),size:g.length}}createModel(d,c,g){return new i.ObjectTreeModel(d,c,g)}}t.DataTree=C}),define(pe[38],be([1,0,14,8,31,28,25,12,3,2,50,10,6]),function(Q,t,E,i,W,O,C,y,d,c,g,L,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var s;(function(se){se[se.Promise=100]="Promise",se[se.PromiseCancel=101]="PromiseCancel",se[se.EventListen=102]="EventListen",se[se.EventDispose=103]="EventDispose"})(s=t.RequestType||(t.RequestType={}));function e(se){switch(se){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(se){se[se.Initialize=200]="Initialize",se[se.PromiseSuccess=201]="PromiseSuccess",se[se.PromiseError=202]="PromiseError",se[se.PromiseErrorObj=203]="PromiseErrorObj",se[se.EventFire=204]="EventFire"})(m=t.ResponseType||(t.ResponseType={}));function v(se){switch(se){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(se){se[se.Uninitialized=0]="Uninitialized",se[se.Idle=1]="Idle"})(w||(w={}));class D{constructor(ie){this.buffer=ie,this.pos=0}read(ie){const ce=this.buffer.slice(this.pos,this.pos+ie);return this.pos+=ce.byteLength,ce}}class a{constructor(){this.buffers=[]}get buffer(){return W.VSBuffer.concat(this.buffers)}write(ie){this.buffers.push(ie)}}var u;(function(se){se[se.Undefined=0]="Undefined",se[se.String=1]="String",se[se.Buffer=2]="Buffer",se[se.VSBuffer=3]="VSBuffer",se[se.Array=4]="Array",se[se.Object=5]="Object"})(u||(u={}));function p(se){const ie=W.VSBuffer.alloc(4);return ie.writeUInt32BE(se,0),ie}function S(se){return se.read(4).readUInt32BE(0)}function T(se){const ie=W.VSBuffer.alloc(1);return ie.writeUInt8(se,0),ie}const _={Undefined:T(u.Undefined),String:T(u.String),Buffer:T(u.Buffer),VSBuffer:T(u.VSBuffer),Array:T(u.Array),Object:T(u.Object)},r=typeof Buffer<"u";function n(se,ie){if(typeof ie>"u")se.write(_.Undefined);else if(typeof ie=="string"){const ce=W.VSBuffer.fromString(ie);se.write(_.String),se.write(p(ce.byteLength)),se.write(ce)}else if(r&&Buffer.isBuffer(ie)){const ce=W.VSBuffer.wrap(ie);se.write(_.Buffer),se.write(p(ce.byteLength)),se.write(ce)}else if(ie instanceof W.VSBuffer)se.write(_.VSBuffer),se.write(p(ie.byteLength)),se.write(ie);else if(Array.isArray(ie)){se.write(_.Array),se.write(p(ie.length));for(const ce of ie)n(se,ce)}else{const ce=W.VSBuffer.fromString(JSON.stringify(ie));se.write(_.Object),se.write(p(ce.byteLength)),se.write(ce)}}function l(se){switch(se.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return se.read(S(se)).toString();case u.Buffer:return se.read(S(se)).buffer;case u.VSBuffer:return se.read(S(se));case u.Array:{const ce=S(se),ne=[];for(let F=0;F<ce;F++)ne.push(l(se));return ne}case u.Object:return JSON.parse(se.read(S(se)).toString())}}class b{constructor(ie,ce,ne=null,F=1e3){this.protocol=ie,this.ctx=ce,this.logger=ne,this.timeoutDelay=F,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel(ie,ce){this.channels.set(ie,ce),setTimeout(()=>this.flushPendingRequests(ie),0)}sendResponse(ie){switch(ie.type){case 200:{const ce=this.send([ie.type]);this.logger?.logOutgoing(ce,0,1,v(ie.type));return}case 201:case 202:case 204:case 203:{const ce=this.send([ie.type,ie.id],ie.data);this.logger?.logOutgoing(ce,ie.id,1,v(ie.type),ie.data);return}}}send(ie,ce=void 0){const ne=new a;return n(ne,ie),n(ne,ce),this.sendBuffer(ne.buffer)}sendBuffer(ie){try{return this.protocol.send(ie),ie.byteLength}catch{return 0}}onRawMessage(ie){const ce=new D(ie),ne=l(ce),F=l(ce),V=ne[0];switch(V){case 100:return this.logger?.logIncoming(ie.byteLength,ne[1],1,`${e(V)}: ${ne[2]}.${ne[3]}`,F),this.onPromise({type:V,id:ne[1],channelName:ne[2],name:ne[3],arg:F});case 102:return this.logger?.logIncoming(ie.byteLength,ne[1],1,`${e(V)}: ${ne[2]}.${ne[3]}`,F),this.onEventListen({type:V,id:ne[1],channelName:ne[2],name:ne[3],arg:F});case 101:return this.logger?.logIncoming(ie.byteLength,ne[1],1,`${e(V)}`),this.disposeActiveRequest({type:V,id:ne[1]});case 103:return this.logger?.logIncoming(ie.byteLength,ne[1],1,`${e(V)}`),this.disposeActiveRequest({type:V,id:ne[1]})}}onPromise(ie){const ce=this.channels.get(ie.channelName);if(!ce){this.collectPendingRequest(ie);return}const ne=new O.CancellationTokenSource;let F;try{F=ce.call(this.ctx,ie.name,ie.arg,ne.token)}catch(k){F=Promise.reject(k)}const V=ie.id;F.then(k=>{this.sendResponse({id:V,data:k,type:201}),this.activeRequests.delete(ie.id)},k=>{k instanceof Error?this.sendResponse({id:V,data:{message:k.message,name:k.name,stack:k.stack?k.stack.split?k.stack.split(`
`):k.stack:void 0},type:202}):this.sendResponse({id:V,data:k,type:203}),this.activeRequests.delete(ie.id)});const j=(0,c.toDisposable)(()=>ne.cancel());this.activeRequests.set(ie.id,j)}onEventListen(ie){const ce=this.channels.get(ie.channelName);if(!ce){this.collectPendingRequest(ie);return}const ne=ie.id,V=ce.listen(this.ctx,ie.name,ie.arg)(j=>this.sendResponse({id:ne,data:j,type:204}));this.activeRequests.set(ie.id,V)}disposeActiveRequest(ie){const ce=this.activeRequests.get(ie.id);ce&&(ce.dispose(),this.activeRequests.delete(ie.id))}collectPendingRequest(ie){let ce=this.pendingRequests.get(ie.channelName);ce||(ce=[],this.pendingRequests.set(ie.channelName,ce));const ne=setTimeout(()=>{console.error(`Unknown channel: ${ie.channelName}`),ie.type===100&&this.sendResponse({id:ie.id,data:{name:"Unknown channel",message:`Channel name '${ie.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ce.push({request:ie,timeoutTimer:ne})}flushPendingRequests(ie){const ce=this.pendingRequests.get(ie);if(ce){for(const ne of ce)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.onPromise(ne.request);break;case 102:this.onEventListen(ne.request);break}this.pendingRequests.delete(ie)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=b;var f;(function(se){se[se.LocalSide=0]="LocalSide",se[se.OtherSide=1]="OtherSide"})(f=t.RequestInitiator||(t.RequestInitiator={}));class z{constructor(ie,ce=null){this.protocol=ie,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ne=>this.onBuffer(ne)),this.logger=ce}getChannel(ie){const ce=this;return{call(ne,F,V){return ce.isDisposed?Promise.reject(new y.CancellationError):ce.requestPromise(ie,ne,F,V)},listen(ne,F){return ce.isDisposed?d.Event.None:ce.requestEvent(ie,ne,F)}}}requestPromise(ie,ce,ne,F=O.CancellationToken.None){const V=this.lastRequestId++,k={id:V,type:100,channelName:ie,name:ce,arg:ne};if(F.isCancellationRequested)return Promise.reject(new y.CancellationError);let h;return new Promise((U,K)=>{if(F.isCancellationRequested)return K(new y.CancellationError);const Z=()=>{const A=P=>{switch(P.type){case 201:this.handlers.delete(V),U(P.data);break;case 202:{this.handlers.delete(V);const M=new Error(P.data.message);M.stack=P.data.stack,M.name=P.data.name,K(M);break}case 203:this.handlers.delete(V),K(P.data);break}};this.handlers.set(V,A),this.sendRequest(k)};let N=null;this.state===w.Idle?Z():(N=(0,i.createCancelablePromise)(A=>this.whenInitialized()),N.then(()=>{N=null,Z()}));const R=()=>{N?(N.cancel(),N=null):this.sendRequest({id:V,type:101}),K(new y.CancellationError)},H=F.onCancellationRequested(R);h=(0,c.combinedDisposable)((0,c.toDisposable)(R),H),this.activeRequests.add(h)}).finally(()=>{this.activeRequests.delete(h)})}requestEvent(ie,ce,ne){const F=this.lastRequestId++,j={id:F,type:102,channelName:ie,name:ce,arg:ne};let k=null;const h=new d.Emitter({onFirstListenerAdd:()=>{k=(0,i.createCancelablePromise)(U=>this.whenInitialized()),k.then(()=>{k=null,this.activeRequests.add(h),this.sendRequest(j)})},onLastListenerRemove:()=>{k?(k.cancel(),k=null):(this.activeRequests.delete(h),this.sendRequest({id:F,type:103}))}}),I=U=>h.fire(U.data);return this.handlers.set(F,I),h.event}sendRequest(ie){switch(ie.type){case 100:case 102:{const ce=this.send([ie.type,ie.id,ie.channelName,ie.name],ie.arg);this.logger?.logOutgoing(ce,ie.id,0,`${e(ie.type)}: ${ie.channelName}.${ie.name}`,ie.arg);return}case 101:case 103:{const ce=this.send([ie.type,ie.id]);this.logger?.logOutgoing(ce,ie.id,0,e(ie.type));return}}}send(ie,ce=void 0){const ne=new a;return n(ne,ie),n(ne,ce),this.sendBuffer(ne.buffer)}sendBuffer(ie){try{return this.protocol.send(ie),ie.byteLength}catch{return 0}}onBuffer(ie){const ce=new D(ie),ne=l(ce),F=l(ce),V=ne[0];switch(V){case 200:return this.logger?.logIncoming(ie.byteLength,0,0,v(V)),this.onResponse({type:ne[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(ie.byteLength,ne[1],0,v(V),F),this.onResponse({type:ne[0],id:ne[1],data:F})}}onResponse(ie){if(ie.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}this.handlers.get(ie.id)?.(ie)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,c.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ke([C.memoize],z.prototype,"onDidInitializePromise",null),t.ChannelClient=z;class ${get connections(){const ie=[];return this._connections.forEach(ce=>ie.push(ce)),ie}constructor(ie){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,ie(({protocol:ce,onDidClientDisconnect:ne})=>{d.Event.once(ce.onMessage)(V=>{const j=new D(V),k=l(j),h=new b(ce,k),I=new z(ce);this.channels.forEach((K,Z)=>h.registerChannel(Z,K));const U={channelServer:h,channelClient:I,ctx:k};this._connections.add(U),this._onDidAddConnection.fire(U),ne(()=>{h.dispose(),I.dispose(),this._connections.delete(U),this._onDidRemoveConnection.fire(U)})})})}getChannel(ie,ce){const ne=this;return{call(F,V,j){let k;if((0,o.isFunction)(ce)){const I=(0,E.getRandomElement)(ne.connections.filter(ce));k=I?Promise.resolve(I):d.Event.toPromise(d.Event.filter(ne.onDidAddConnection,ce))}else k=ce.routeCall(ne,F,V);const h=k.then(I=>I.channelClient.getChannel(ie));return J(h).call(F,V,j)},listen(F,V){if((0,o.isFunction)(ce))return ne.getMulticastEvent(ie,ce,F,V);const j=ce.routeEvent(ne,F,V).then(k=>k.channelClient.getChannel(ie));return J(j).listen(F,V)}}}getMulticastEvent(ie,ce,ne,F){const V=this;let j=new c.DisposableStore;const k=new d.Emitter({onFirstListenerAdd:()=>{j=new c.DisposableStore;const h=new d.EventMultiplexer,I=new Map,U=Z=>{const R=Z.channelClient.getChannel(ie).listen(ne,F),H=h.add(R);I.set(Z,H)},K=Z=>{const N=I.get(Z);!N||(N.dispose(),I.delete(Z))};V.connections.filter(ce).forEach(U),d.Event.filter(V.onDidAddConnection,ce)(U,void 0,j),V.onDidRemoveConnection(K,void 0,j),h.event(k.fire,k,j),j.add(h)},onLastListenerRemove:()=>{j.dispose()}});return k.event}registerChannel(ie,ce){this.channels.set(ie,ce),this._connections.forEach(ne=>{ne.channelServer.registerChannel(ie,ce)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=$;class X{constructor(ie,ce,ne=null){const F=new a;n(F,ce),ie.send(F.buffer),this.channelClient=new z(ie,ne),this.channelServer=new b(ie,ce,ne)}getChannel(ie){return this.channelClient.getChannel(ie)}registerChannel(ie,ce){this.channelServer.registerChannel(ie,ce)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=X;function J(se){return{call(ie,ce,ne){return se.then(F=>F.call(ie,ce,ne))},listen(ie,ce){const ne=new d.Relay;return se.then(F=>ne.input=F.listen(ie,ce)),ne.event}}}t.getDelayedChannel=J;function ge(se){let ie=!1;return{call(ce,ne,F){return ie?se.call(ce,ne,F):(0,i.timeout)(0).then(()=>ie=!0).then(()=>se.call(ce,ne,F))},listen(ce,ne){if(ie)return se.listen(ce,ne);const F=new d.Relay;return(0,i.timeout)(0).then(()=>ie=!0).then(()=>F.input=se.listen(ce,ne)),F.event}}}t.getNextTickChannel=ge;class re{constructor(ie){this.fn=ie}routeCall(ie){return this.route(ie)}routeEvent(ie){return this.route(ie)}async route(ie){for(const ce of ie.connections)if(await Promise.resolve(this.fn(ce.ctx)))return Promise.resolve(ce);return await d.Event.toPromise(ie.onDidAddConnection),await this.route(ie)}}t.StaticRouter=re;var me;(function(se){function ie(V,j){const k=V,h=j&&j.disableMarshalling,I=new Map;for(const U in k)ne(U)&&I.set(U,d.Event.buffer(k[U],!0));return new class{listen(U,K,Z){const N=I.get(K);if(N)return N;if(F(K)){const R=k[K];if(typeof R=="function")return R.call(k,Z)}throw new Error(`Event not found: ${K}`)}call(U,K,Z){const N=k[K];if(typeof N=="function"){if(!h&&Array.isArray(Z))for(let R=0;R<Z.length;R++)Z[R]=(0,g.revive)(Z[R]);return N.apply(k,Z)}throw new Error(`Method not found: ${K}`)}}}se.fromService=ie;function ce(V,j){const k=j&&j.disableMarshalling;return new Proxy({},{get(h,I){if(typeof I=="string")return j?.properties?.has(I)?j.properties.get(I):F(I)?function(U){return V.listen(I,U)}:ne(I)?V.listen(I):async function(...U){let K;j&&!(0,o.isUndefinedOrNull)(j.context)?K=[j.context,...U]:K=U;const Z=await V.call(I,K);return k?Z:(0,g.revive)(Z)};throw new Error(`Property not found: ${String(I)}`)}})}se.toService=ce;function ne(V){return V[0]==="o"&&V[1]==="n"&&L.isUpperAsciiLetter(V.charCodeAt(2))}function F(V){return/^onDynamic/.test(V)&&L.isUpperAsciiLetter(V.charCodeAt(9))}})(me=t.ProxyChannel||(t.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(se){if(Array.isArray(se))return se;if(se&&typeof se=="object"&&typeof se.toString=="function"){const ie=se.toString();if(ie!=="[object Object]")return ie}return se}function Se(se){return Array.isArray(se)?se.map(he):he(se)}function te(se,ie,ce,ne,F,V,j){j=Se(j);const k=ae[F],h=k[ne%k.length];let I=[`%c[${se}]%c[${String(ie).padStart(7," ")}]%c[len: ${String(ce).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${h}`];/\($/.test(V)?(I=I.concat(j),I.push(")")):I.push(j),console.log.apply(console,I)}t.logWithColors=te;class De{constructor(ie,ce){this._outgoingPrefix=ie,this._incomingPrefix=ce,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(ie,ce,ne,F,V){this._totalOutgoing+=ie,te(this._outgoingPrefix,this._totalOutgoing,ie,ce,ne,F,V)}logIncoming(ie,ce,ne,F,V){this._totalIncoming+=ie,te(this._incomingPrefix,this._totalIncoming,ie,ce,ne,F,V)}}t.IPCLogger=De}),define(pe[29],be([1,0,5]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=E.globals.vscode.ipcRenderer,t.ipcMessagePort=E.globals.vscode.ipcMessagePort,t.webFrame=E.globals.vscode.webFrame,t.process=E.globals.vscode.process,t.context=E.globals.vscode.context}),define(pe[129],be([1,0,80,29]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let W=0;function O(y,d,c){const g=[],L=W++,o=`vscode:onContextMenu${L}`,s=(e,m,v)=>{g[m].click?.(v)};i.ipcRenderer.once(o,s),i.ipcRenderer.once(E.CONTEXT_MENU_CLOSE_CHANNEL,(e,m)=>{m===L&&(i.ipcRenderer.removeListener(o,s),c?.())}),i.ipcRenderer.send(E.CONTEXT_MENU_CHANNEL,L,y.map(e=>C(e,g)),o,d)}t.popup=O;function C(y,d){const c={id:d.length,label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:typeof y.enabled=="boolean"?y.enabled:!0,visible:typeof y.visible=="boolean"?y.visible:!0};return d.push(y),Array.isArray(y.submenu)&&(c.submenu=y.submenu.map(g=>C(g,d))),c}}),define(pe[130],be([1,0,31,3,38,81,29]),function(Q,t,E,i,W,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class y extends W.IPCClient{static createProtocol(){const c=i.Event.fromNodeEventEmitter(C.ipcRenderer,"vscode:message",(g,L)=>E.VSBuffer.wrap(L));return C.ipcRenderer.send("vscode:hello"),new O.Protocol(C.ipcRenderer,c)}constructor(c){const g=y.createProtocol();super(g,c),this.protocol=g}dispose(){this.protocol.disconnect()}}t.Client=y}),define(pe[131],be([13,9]),function(Q,t){return Q.create("vs/platform/files/common/files",t)}),define(pe[132],be([13,9]),function(Q,t){return Q.create("vs/platform/theme/common/iconRegistry",t)}),define(pe[64],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class E{constructor(W,O=[],C=!1){this.ctor=W,this.staticArguments=O,this.supportsDelayedInstantiation=C}}t.SyncDescriptor=E}),define(pe[133],be([1,0,64]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=t.InstantiationType=void 0;const i=[];var W;(function(y){y[y.Eager=0]="Eager",y[y.Delayed=1]="Delayed"})(W=t.InstantiationType||(t.InstantiationType={}));function O(y,d,c){d instanceof E.SyncDescriptor||(d=new E.SyncDescriptor(d,[],Boolean(c))),i.push([y,d])}t.registerSingleton=O;function C(){return i}t.getSingletonServiceDescriptors=C}),define(pe[30],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var E;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function y(d){return d[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=y})(E=t._util||(t._util={})),t.IInstantiationService=W("instantiationService");function i(C,y,d){y[E.DI_TARGET]===y?y[E.DI_DEPENDENCIES].push({id:C,index:d}):(y[E.DI_DEPENDENCIES]=[{id:C,index:d}],y[E.DI_TARGET]=y)}function W(C){if(E.serviceIds.has(C))return E.serviceIds.get(C);const y=function(d,c,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(y,d,g)};return y.toString=()=>C,E.serviceIds.set(C,y),y}t.createDecorator=W;function O(C){return C}t.refineServiceDecorator=O}),define(pe[134],be([1,0,30]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,E.createDecorator)(t.ID);function i(O){return!!O.hostName&&!!O.errorMessage}t.isRemoteDiagnosticError=i;class W{async getPerformanceInfo(C,y){return{}}async getSystemInfo(C,y){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,y){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}t.NullDiagnosticsService=W}),define(pe[135],be([1,0,49,21,10,6,16,131,30]),function(Q,t,E,i,W,O,C,y,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPlatformLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,d.createDecorator)("fileService");function c(te){return te.create===!0}t.isFileOpenForWriteOptions=c;var g;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(g=t.FileType||(t.FileType={}));var L;(function(te){te[te.Readonly=1]="Readonly"})(L=t.FilePermission||(t.FilePermission={}));var o;(function(te){te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileClone=32768]="FileClone"})(o=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function s(te){return!!(te.capabilities&2)}t.hasReadWriteCapability=s;function e(te){return!!(te.capabilities&8)}t.hasFileFolderCopyCapability=e;function m(te){return!!(te.capabilities&32768)}t.hasFileCloneCapability=m;function v(te){return!!(te.capabilities&4)}t.hasOpenReadWriteCloseCapability=v;function w(te){return!!(te.capabilities&16)}t.hasFileReadStreamCapability=w;function D(te){return s(te)?!!(te.capabilities&16384):!1}t.hasFileAtomicReadCapability=D;var a;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(a=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class u extends Error{constructor(De,se){super(De),this.code=se}}t.FileSystemProviderError=u;function p(te,De){const se=new u(te.toString(),De);return T(se,De),se}t.createFileSystemProviderError=p;function S(te){return te||p((0,y.localize)(0,null),a.Unknown)}t.ensureFileSystemProviderError=S;function T(te,De){return te.name=De?`${De} (FileSystemError)`:"FileSystemError",te}t.markAsFileSystemProviderError=T;function _(te){if(!te)return a.Unknown;if(te instanceof u)return te.code;const De=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!De)return a.Unknown;switch(De[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileExceedsMemoryLimit:return a.FileExceedsMemoryLimit;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}t.toFileSystemProviderErrorCode=_;function r(te){if(te instanceof $)return te.fileOperationResult;switch(_(te)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 10;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileExceedsMemoryLimit:return 9;case a.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=r;var n;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(n=t.FileOperation||(t.FileOperation={}));class l{constructor(De,se,ie){this.resource=De,this.operation=se,this.target=ie}isOperation(De){return this.operation===De}}t.FileOperationEvent=l;var b;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(b=t.FileChangeType||(t.FileChangeType={}));class f{constructor(De,se){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=De;const ie=new Map;for(const ce of De){const ne=ie.get(ce.type);switch(ne?ne.push([ce.resource,ce]):ie.set(ce.type,[[ce.resource,ce]]),ce.type){case 1:this.rawAdded.push(ce.resource);break;case 0:this.rawUpdated.push(ce.resource);break;case 2:this.rawDeleted.push(ce.resource);break}}for(const[ce,ne]of ie)switch(ce){case 1:this.added=E.TernarySearchTree.forUris(()=>se),this.added.fill(ne);break;case 0:this.updated=E.TernarySearchTree.forUris(()=>se),this.updated.fill(ne);break;case 2:this.deleted=E.TernarySearchTree.forUris(()=>se),this.deleted.fill(ne);break}}contains(De,...se){return this.doContains(De,{includeChildren:!1},...se)}affects(De,...se){return this.doContains(De,{includeChildren:!0},...se)}doContains(De,se,...ie){if(!De)return!1;const ce=ie.length>0;return!!((!ce||ie.includes(1))&&(this.added?.get(De)||se.includeChildren&&this.added?.findSuperstr(De))||(!ce||ie.includes(0))&&(this.updated?.get(De)||se.includeChildren&&this.updated?.findSuperstr(De))||(!ce||ie.includes(2))&&(this.deleted?.findSubstr(De)||se.includeChildren&&this.deleted?.findSuperstr(De)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}t.FileChangesEvent=f;function z(te,De,se){return!te||!De||te===De||De.length>te.length?!1:(De.charAt(De.length-1)!==i.sep&&(De+=i.sep),se?(0,W.startsWithIgnoreCase)(te,De):te.indexOf(De)===0)}t.isParent=z;class $ extends Error{constructor(De,se,ie){super(De),this.fileOperationResult=se,this.options=ie}}t.FileOperationError=$;class X extends ${constructor(De,se,ie){super(De,2,ie),this.stat=se}}t.NotModifiedSinceFileOperationError=X;var J;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",te[te.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(J=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var ge;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(ge=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function re(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}t.etag=re;async function me(te,De){if(!De.hasProvider(C.URI.from({scheme:te.scheme})))return new Promise(se=>{const ie=De.onDidChangeFileSystemProviderRegistrations(ce=>{ce.scheme===te.scheme&&ce.added&&(ie.dispose(),se())})})}t.whenProviderRegistered=me,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ae{static formatSize(De){return(0,O.isNumber)(De)||(De=0),De<ae.KB?(0,y.localize)(1,null,De.toFixed(0)):De<ae.MB?(0,y.localize)(2,null,(De/ae.KB).toFixed(2)):De<ae.GB?(0,y.localize)(3,null,(De/ae.MB).toFixed(2)):De<ae.TB?(0,y.localize)(4,null,(De/ae.GB).toFixed(2)):(0,y.localize)(5,null,(De/ae.TB).toFixed(2))}}t.ByteSize=ae,ae.KB=1024,ae.MB=ae.KB*ae.KB,ae.GB=ae.MB*ae.KB,ae.TB=ae.GB*ae.KB;var he;(function(te){te[te.IA32=0]="IA32",te[te.OTHER=1]="OTHER"})(he=t.Arch||(t.Arch={}));function Se(te){return{maxFileSize:te===0?300*ae.MB:16*ae.GB,maxHeapSize:te===0?700*ae.MB:2*700*ae.MB}}t.getPlatformLimits=Se}),define(pe[136],be([1,0,2,130]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class W extends E.Disposable{constructor(C){super(),this.mainProcessConnection=this._register(new i.Client(`window:${C}`))}getChannel(C){return this.mainProcessConnection.getChannel(C)}registerChannel(C,y){this.mainProcessConnection.registerChannel(C,y)}}t.ElectronIPCMainProcessService=W});var wt=this&&this.__param||function(Q,t){return function(E,i){t(E,i,Q)}};define(pe[137],be([1,0,38,64,133,30]),function(Q,t,E,i,W,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerSharedProcessRemoteService=t.ISharedProcessService=t.registerMainProcessRemoteService=t.IMainProcessService=void 0;class C{constructor(s,e,m,v){const w=m.getChannel(s);return y(e)?v.createInstance(new i.SyncDescriptor(e.channelClientCtor,[w])):E.ProxyChannel.toService(w,e?.proxyOptions)}}function y(o){return!!o?.channelClientCtor}t.IMainProcessService=(0,O.createDecorator)("mainProcessService");let d=class extends C{constructor(s,e,m,v){super(s,e,m,v)}};d=Ke([wt(2,t.IMainProcessService),wt(3,O.IInstantiationService)],d);function c(o,s,e){(0,W.registerSingleton)(o,new i.SyncDescriptor(d,[s,e],!0))}t.registerMainProcessRemoteService=c,t.ISharedProcessService=(0,O.createDecorator)("sharedProcessService");let g=class extends C{constructor(s,e,m,v){super(s,e,m,v)}};g=Ke([wt(2,t.ISharedProcessService),wt(3,O.IInstantiationService)],g);function L(o,s,e){(0,W.registerSingleton)(o,new i.SyncDescriptor(g,[s,e],!0))}t.registerSharedProcessRemoteService=L}),define(pe[138],be([1,0,38,137]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let W=class{constructor(C,y){return this.windowId=C,E.ProxyChannel.toService(y.getChannel("nativeHost"),{context:C,properties:(()=>{const d=new Map;return d.set("windowId",C),d})()})}};W=Ke([wt(1,i.IMainProcessService)],W),t.NativeHostService=W}),define(pe[39],be([1,0,71,6]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class W{constructor(){this.data=new Map}add(C,y){E.ok(i.isString(C)),E.ok(i.isObject(y)),E.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,y)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}t.Registry=new W}),define(pe[139],be([1,0,3,39]),function(Q,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function W(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class O{constructor(){this._onDidChangeSchema=new E.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,c){this.schemasById[W(d)]=c,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new O;i.Registry.add(t.Extensions.JSONContribution,C)}),define(pe[140],be([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isDark=t.isHighContrast=t.ColorScheme=void 0;var E;(function(O){O.DARK="dark",O.LIGHT="light",O.HIGH_CONTRAST_DARK="hcDark",O.HIGH_CONTRAST_LIGHT="hcLight"})(E=t.ColorScheme||(t.ColorScheme={}));function i(O){return O===E.HIGH_CONTRAST_DARK||O===E.HIGH_CONTRAST_LIGHT}t.isHighContrast=i;function W(O){return O===E.DARK||O===E.HIGH_CONTRAST_DARK}t.isDark=W}),define(pe[65],be([1,0,11,3,2,30,39,140]),function(Q,t,E,i,W,O,C,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Themable=t.registerThemingParticipant=t.Extensions=t.getThemeTypeSelector=t.FolderThemeIcon=t.FileThemeIcon=t.ThemeIcon=t.themeColorFromId=t.ThemeColor=t.IThemeService=void 0,t.IThemeService=(0,O.createDecorator)("themeService");var d;(function(v){function w(D){return D&&typeof D=="object"&&typeof D.id=="string"}v.isThemeColor=w})(d=t.ThemeColor||(t.ThemeColor={}));function c(v){return{id:v}}t.themeColorFromId=c;var g;(function(v){function w(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||d.isThemeColor(r.color))}v.isThemeIcon=w;const D=new RegExp(`^\\$\\((${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?)\\)$`);function a(r){const n=D.exec(r);if(!n)return;const[,l]=n;return{id:l}}v.fromString=a;function u(r){return{id:r}}v.fromId=u;function p(r,n){let l=r.id;const b=l.lastIndexOf("~");return b!==-1&&(l=l.substring(0,b)),n&&(l=`${l}~${n}`),{id:l}}v.modify=p;function S(r){const n=r.id.lastIndexOf("~");if(n!==-1)return r.id.substring(n+1)}v.getModifier=S;function T(r,n){return r.id===n.id&&r.color?.id===n.color?.id}v.isEqual=T;function _(r,n){return{id:r.id,color:n?c(n):void 0}}v.asThemeIcon=_,v.asClassNameArray=E.CSSIcon.asClassNameArray,v.asClassName=E.CSSIcon.asClassName,v.asCSSSelector=E.CSSIcon.asCSSSelector})(g=t.ThemeIcon||(t.ThemeIcon={})),t.FileThemeIcon=E.Codicon.file,t.FolderThemeIcon=E.Codicon.folder;function L(v){switch(v){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case y.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}t.getThemeTypeSelector=L,t.Extensions={ThemingContribution:"base.contributions.theming"};class o{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,W.toDisposable)(()=>{const D=this.themingParticipants.indexOf(w);this.themingParticipants.splice(D,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const s=new o;C.Registry.add(t.Extensions.ThemingContribution,s);function e(v){return s.onColorThemeChange(v)}t.registerThemingParticipant=e;class m extends W.Disposable{constructor(w){super(),this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(D=>this.onThemeChange(D)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,D){let a=this.theme.getColor(w);return a&&D&&(a=D(a,this.theme)),a?a.toString():null}}t.Themable=m}),define(pe[141],be([1,0,8,11,3,6,16,132,139,39,65]),function(Q,t,E,i,W,O,C,y,d,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var L;(function(u){function p(S,T){let _=S.defaults;for(;g.ThemeIcon.isThemeIcon(_);){const r=e.getIcon(_.id);if(!r)return;_=r.defaults}return _}u.getDefinition=p})(L=t.IconContribution||(t.IconContribution={}));var o;(function(u){function p(T){return{weight:T.weight,style:T.style,src:T.src.map(_=>({format:_.format,location:_.location.toString()}))}}u.toJSONObject=p;function S(T){const _=r=>(0,O.isString)(r)?r:void 0;if(T&&Array.isArray(T.src)&&T.src.every(r=>(0,O.isString)(r.format)&&(0,O.isString)(r.location)))return{weight:_(T.weight),style:_(T.style),src:T.src.map(r=>({format:r.format,location:C.URI.parse(r.location)}))}}u.fromJSONObject=S})(o=t.IconFontDefinition||(t.IconFontDefinition={}));class s{constructor(){this._onDidChange=new W.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${i.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(p,S,T,_){const r=this.iconsById[p];if(r){if(T&&!r.description){r.description=T,this.iconSchema.properties[p].markdownDescription=`${T} $(${p})`;const b=this.iconReferenceSchema.enum.indexOf(p);b!==-1&&(this.iconReferenceSchema.enumDescriptions[b]=T),this._onDidChange.fire()}return r}const n={id:p,description:T,defaults:S,deprecationMessage:_};this.iconsById[p]=n;const l={$ref:"#/definitions/icons"};return _&&(l.deprecationMessage=_),T&&(l.markdownDescription=`${T}: $(${p})`),this.iconSchema.properties[p]=l,this.iconReferenceSchema.enum.push(p),this.iconReferenceSchema.enumDescriptions.push(T||""),this._onDidChange.fire(),{id:p}}deregisterIcon(p){delete this.iconsById[p],delete this.iconSchema.properties[p];const S=this.iconReferenceSchema.enum.indexOf(p);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(p=>this.iconsById[p])}getIcon(p){return this.iconsById[p]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(p,S){const T=this.iconFontsById[p];return T||(this.iconFontsById[p]=S,this._onDidChange.fire(),S)}deregisterIconFont(p){delete this.iconFontsById[p]}getIconFont(p){return this.iconFontsById[p]}toString(){const p=(r,n)=>r.id.localeCompare(n.id),S=r=>{for(;g.ThemeIcon.isThemeIcon(r.defaults);)r=this.iconsById[r.defaults.id];return`codicon codicon-${r?r.id:""}`},T=[];T.push("| preview     | identifier                        | default codicon ID                | description"),T.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const _=Object.keys(this.iconsById).map(r=>this.iconsById[r]);for(const r of _.filter(n=>!!n.description).sort(p))T.push(`|<i class="${S(r)}"></i>|${r.id}|${g.ThemeIcon.isThemeIcon(r.defaults)?r.defaults.id:r.id}|${r.description||""}|`);T.push("| preview     | identifier                        "),T.push("| ----------- | --------------------------------- |");for(const r of _.filter(n=>!g.ThemeIcon.isThemeIcon(n.defaults)).sort(p))T.push(`|<i class="${S(r)}"></i>|${r.id}|`);return T.join(`
`)}}const e=new s;c.Registry.add(t.Extensions.IconContribution,e);function m(u,p,S,T){return e.registerIcon(u,p,S,T)}t.registerIcon=m;function v(){return e}t.getIconRegistry=v;function w(){for(const u of i.Codicon.getAll())e.registerIcon(u.id,u.definition,u.description)}w(),t.iconsSchemaId="vscode://schemas/icons";const D=c.Registry.as(d.Extensions.JSONContribution);D.registerSchema(t.iconsSchemaId,e.getIconSchema());const a=new E.RunOnceScheduler(()=>D.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{a.isScheduled()||a.schedule()}),t.widgetClose=m("widget-close",i.Codicon.close,(0,y.localize)(2,null)),t.gotoPreviousLocation=m("goto-previous-location",i.Codicon.arrowUp,(0,y.localize)(3,null)),t.gotoNextLocation=m("goto-next-location",i.Codicon.arrowDown,(0,y.localize)(4,null)),t.syncing=g.ThemeIcon.modify(i.Codicon.sync,"spin"),t.spinningLoading=g.ThemeIcon.modify(i.Codicon.loading,"spin")}),define(pe[142],be([1,0,4,3,141,65]),function(Q,t,E,i,W,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function C(d){const c=new i.Emitter,g=(0,W.getIconRegistry)();return g.onDidChange(()=>c.fire()),d?.onDidProductIconThemeChange(()=>c.fire()),{onDidChange:c.event,getCSS(){const L=d?d.getProductIconTheme():new y,o={},s=m=>{const v=L.getIcon(m);if(!v)return;const w=v.font;return w?(o[w.id]=w.definition,`.codicon-${m.id}:before { content: '${v.fontCharacter}'; font-family: ${(0,E.asCSSPropertyValue)(w.id)}; }`):`.codicon-${m.id}:before { content: '${v.fontCharacter}'; }`},e=[];for(const m of g.getIcons()){const v=s(m);v&&e.push(v)}for(const m in o){const v=o[m],w=v.weight?`font-weight: ${v.weight};`:"",D=v.style?`font-style: ${v.style};`:"",a=v.src.map(u=>`${(0,E.asCSSUrl)(u.location)} format('${u.format}')`).join(", ");e.push(`@font-face { src: ${a}; font-family: ${(0,E.asCSSPropertyValue)(m)};${w}${D} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=C;class y{getIcon(c){const g=(0,W.getIconRegistry)();let L=c.defaults;for(;O.ThemeIcon.isThemeIcon(L);){const o=g.getIcon(L.id);if(!o)return;L=o.defaults}return L}}t.UnthemedProductIconTheme=y}),define(pe[143],be([1,0,5]),function(Q,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function i(g){return!!g.workspaceUri}t.isWorkspaceToOpen=i;function W(g){return!!g.folderUri}t.isFolderToOpen=W;function O(g){return!!g.fileUri}t.isFileToOpen=O;function C(g){const L=y(g),o=g.getValue("window.menuBarVisibility");return o==="default"||L==="native"&&o==="compact"||E.isMacintosh&&E.isNative?"classic":o}t.getMenuBarVisibility=C;function y(g){if(E.isWeb)return"custom";const L=g.getValue("window");if(L){if(E.isMacintosh&&L.nativeTabs===!0||E.isMacintosh&&L.nativeFullScreen===!1)return"native";const e=L.titleBarStyle;if(e==="native"||e==="custom")return e}return E.isLinux?"native":"custom"}t.getTitleBarStyle=y;function d(g){if(!E.isWindows||E.isWeb||y(g)==="native")return!1;const L=g.getValue("window.experimental.windowControlsOverlay.enabled");return typeof L=="boolean"?L:!1}t.useWindowControlsOverlay=d;function c(g=0){return Math.pow(1.2,g)}t.zoomLevelToZoomFactor=c}),define(pe[144],be([1,0,15,29,143]),function(Q,t,E,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function O(d){i.webFrame.setZoomLevel(d),(0,E.setZoomFactor)((0,W.zoomLevelToZoomFactor)(d)),(0,E.setZoomLevel)(d,!1)}t.applyZoom=O;function C(){O((0,E.getZoomLevel)()+1)}t.zoomIn=C;function y(){O((0,E.getZoomLevel)()-1)}t.zoomOut=y}),define(pe[145],be([1,0,9,4,128,8,129,29,134,135,136,138,142,144,94,85]),function(Q,t,E,i,W,O,C,y,d,c,g,L,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const e=/\s--(inspect|debug)(-brk|port)?=(\d+)?/,m=/\s--(inspect|debug)-port=(\d+)/;class v{getHeight(f){return 22}getTemplateId(f){return _(f)?"process":S(f)?"machine":(0,d.isRemoteDiagnosticError)(f)?"error":T(f)?"header":""}}class w{hasChildren(f){return(0,d.isRemoteDiagnosticError)(f)?!1:_(f)?!!f.children?.length:!0}getChildren(f){return _(f)?f.children?f.children:[]:(0,d.isRemoteDiagnosticError)(f)?[]:T(f)?f.processRoots.length>1?f.processRoots:[f.processRoots[0].rootProcess]:S(f)?[f.rootProcess]:[f.processes]}}class D{constructor(){this.templateId="header"}renderTemplate(f){const z=Object.create(null),$=(0,i.append)(f,(0,i.$)(".row"));return z.name=(0,i.append)($,(0,i.$)(".nameLabel")),z.CPU=(0,i.append)($,(0,i.$)(".cpu")),z.memory=(0,i.append)($,(0,i.$)(".memory")),z.PID=(0,i.append)($,(0,i.$)(".pid")),z}renderElement(f,z,$,X){$.name.textContent=(0,E.localize)(0,null),$.CPU.textContent=(0,E.localize)(1,null),$.PID.textContent=(0,E.localize)(2,null),$.memory.textContent=(0,E.localize)(3,null)}disposeTemplate(f){}}class a{constructor(){this.templateId="machine"}renderTemplate(f){const z=Object.create(null),$=(0,i.append)(f,(0,i.$)(".row"));return z.name=(0,i.append)($,(0,i.$)(".nameLabel")),z}renderElement(f,z,$,X){$.name.textContent=f.element.name}disposeTemplate(f){}}class u{constructor(){this.templateId="error"}renderTemplate(f){const z=Object.create(null),$=(0,i.append)(f,(0,i.$)(".row"));return z.name=(0,i.append)($,(0,i.$)(".nameLabel")),z}renderElement(f,z,$,X){$.name.textContent=f.element.errorMessage}disposeTemplate(f){}}class p{constructor(f,z,$){this.platform=f,this.totalMem=z,this.mapPidToWindowTitle=$,this.templateId="process"}renderTemplate(f){const z=Object.create(null),$=(0,i.append)(f,(0,i.$)(".row"));return z.name=(0,i.append)($,(0,i.$)(".nameLabel")),z.CPU=(0,i.append)($,(0,i.$)(".cpu")),z.memory=(0,i.append)($,(0,i.$)(".memory")),z.PID=(0,i.append)($,(0,i.$)(".pid")),z}renderElement(f,z,$,X){const{element:J}=f;let ge=J.name;ge==="window"&&(ge=this.mapPidToWindowTitle.get(J.pid)!==void 0?`${ge} (${this.mapPidToWindowTitle.get(J.pid)})`:ge);const re=J.pid.toFixed(0);$.name.textContent=ge,$.name.title=J.cmd,$.CPU.textContent=J.load.toFixed(0),$.PID.textContent=re,$.PID.parentElement.id=`pid-${re}`;const me=this.platform==="win32"?J.mem:this.totalMem*(J.mem/100);$.memory.textContent=(me/c.ByteSize.MB).toFixed(0)}disposeTemplate(f){}}function S(b){return!!b.name&&!!b.rootProcess}function T(b){return!!b.processRoots}function _(b){return!!b.pid}class r{constructor(f,z){this.data=z,this.mapPidToWindowTitle=new Map;const $=new g.ElectronIPCMainProcessService(f);this.nativeHostService=new L.NativeHostService(f,$),this.applyStyles(z.styles),this.setEventHandlers(z),y.ipcRenderer.on("vscode:windowsInfoResponse",(X,J)=>{this.mapPidToWindowTitle=new Map,J.forEach(ge=>this.mapPidToWindowTitle.set(ge.pid,ge.title))}),y.ipcRenderer.on("vscode:listProcessesResponse",async(X,J)=>{J.forEach((ge,re)=>{_(ge.rootProcess)&&(ge.rootProcess.name=re===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?(this.tree.setInput({processes:{processRoots:J}}),this.tree.layout(window.innerHeight,window.innerWidth)):await this.createProcessTree(J),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),y.ipcRenderer.send("vscode:windowsInfoRequest"),y.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(f){document.onkeydown=z=>{const $=f.platform==="darwin"?z.metaKey:z.ctrlKey;$&&z.keyCode===87&&(z.stopPropagation(),z.preventDefault(),y.ipcRenderer.send("vscode:closeProcessExplorer")),$&&z.keyCode===187&&(0,s.zoomIn)(),$&&z.keyCode===189&&(0,s.zoomOut)()}}async createProcessTree(f){const z=document.getElementById("process-list");if(!z)return;const{totalmem:$}=await this.nativeHostService.getOSStatistics(),X=[new p(this.data.platform,$,this.mapPidToWindowTitle),new D,new a,new u];this.tree=new W.DataTree("processExplorer",z,new v,X,new w,{identityProvider:{getId:J=>_(J)?J.pid.toString():(0,d.isRemoteDiagnosticError)(J)?J.hostName:T(J)?"processes":S(J)?J.name:"header"}}),this.tree.setInput({processes:{processRoots:f}}),this.tree.layout(window.innerHeight,window.innerWidth),this.tree.onContextMenu(J=>{_(J.element)&&this.showContextMenu(J.element,!0)}),z.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{z.style.height=`${window.innerHeight}px`,this.tree?.layout(window.innerHeight,window.innerWidth)})}isDebuggable(f){const z=e.exec(f);return z&&z.length>=2||f.indexOf("node ")>=0||f.indexOf("node.exe")>=0}attachTo(f){const z={type:"node",request:"attach",name:`process ${f.pid}`};let $=e.exec(f.cmd);$&&$.length>=2?($.length===4&&$[3]&&(z.port=parseInt($[3])),z.protocol=$[1]==="debug"?"legacy":"inspector"):z.processId=String(f.pid),$=m.exec(f.cmd),$&&$.length===3&&(z.port=parseInt($[2])),y.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[z]})}applyStyles(f){const z=(0,i.createStyleSheet)(),$=[];f.listFocusBackground&&($.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${f.listFocusBackground}; }`),$.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${f.listFocusBackground}; }`)),f.listFocusForeground&&$.push(`.monaco-list:focus .monaco-list-row.focused { color: ${f.listFocusForeground}; }`),f.listActiveSelectionBackground&&($.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${f.listActiveSelectionBackground}; }`),$.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${f.listActiveSelectionBackground}; }`)),f.listActiveSelectionForeground&&$.push(`.monaco-list:focus .monaco-list-row.selected { color: ${f.listActiveSelectionForeground}; }`),f.listHoverBackground&&$.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${f.listHoverBackground}; }`),f.listHoverForeground&&$.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${f.listHoverForeground}; }`),f.listFocusOutline&&$.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${f.listFocusOutline}; outline-offset: -1px; }`),f.listHoverOutline&&$.push(`.monaco-list-row:hover { outline: 1px dashed ${f.listHoverOutline}; outline-offset: -1px; }`),f.scrollbarShadowColor&&$.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${f.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${f.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${f.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),f.scrollbarSliderBackgroundColor&&$.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${f.scrollbarSliderBackgroundColor};
				}
			`),f.scrollbarSliderHoverBackgroundColor&&$.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${f.scrollbarSliderHoverBackgroundColor};
				}
			`),f.scrollbarSliderActiveBackgroundColor&&$.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${f.scrollbarSliderActiveBackgroundColor};
				}
			`),z.textContent=$.join(`
`),f.color&&(document.body.style.color=f.color)}showContextMenu(f,z){const $=[],X=Number(f.pid);z&&($.push({label:(0,E.localize)(4,null),click:()=>{this.nativeHostService.killProcess(X,"SIGTERM")}}),$.push({label:(0,E.localize)(5,null),click:()=>{this.nativeHostService.killProcess(X,"SIGKILL")}}),$.push({type:"separator"})),$.push({label:(0,E.localize)(6,null),click:()=>{const J=this.tree?.getSelection()?.map(re=>{if(!(!re||!("pid"in re)))return re.pid}).filter(re=>!!re);J?.includes(X)||(J.length=0,J.push(X));const ge=J?.map(re=>document.getElementById(`pid-${re}`)).filter(re=>!!re);if(ge){const re=ge.map(me=>me.innerText).filter(me=>!!me);this.nativeHostService.writeClipboardText(re.join(`
`))}}}),$.push({label:(0,E.localize)(7,null),click:()=>{const J=document.getElementById("process-list");J&&this.nativeHostService.writeClipboardText(J.innerText)}}),f&&z&&this.isDebuggable(f.cmd)&&($.push({type:"separator"}),$.push({label:(0,E.localize)(8,null),click:()=>{this.attachTo(f)}})),(0,C.popup)($)}requestProcessList(f){setTimeout(()=>{const z=Date.now(),$=f+z-this.lastRequestTime;this.lastRequestTime=z,$>1e3?(y.ipcRenderer.send("vscode:windowsInfoRequest"),y.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList($)},200)}}function n(){const b=(0,i.createStyleSheet)();b.id="codiconStyles";const f=(0,o.getIconsStyleSheet)(void 0);function z(){b.textContent=f.getCSS()}const $=new O.RunOnceScheduler(z,0);f.onDidChange(()=>$.schedule()),$.schedule()}function l(b){const f=b.data.platform==="win32"?"windows":b.data.platform==="linux"?"linux":"mac";document.body.classList.add(f),n(),(0,s.applyZoom)(b.data.zoomLevel),new r(b.windowId,b.data)}t.startup=l})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a829fbb91cbae44afb6a389341a0763fb3a6ac6f/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
